var appaboutController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
};
appaboutController.prototype.Init = function(viewDom){
	this.dom = viewDom;
	this.dom.addClass('refreshMe');
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	this.LoadVersion();
	this.LoadData();
	this.BindEvents();
	urlMgmt.removeLoader();
};
appaboutController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'About Us', false, true, false);
};
appaboutController.prototype.LoadVersion = function()
{
	var versionInfo = "Version: "+TRHelper._version; 
	this.dom.find("#debug_info").html(versionInfo);
};
appaboutController.prototype.LoadData = function()
{
	this.dom.find('.about-us-content').html(aboutUs);
	
	this.dom.find('.website-link').html(website);
	this.dom.find('.social-icons').html(socialLinks);
	this.dom.find('.about-image').attr('alt', Application_name);
};
appaboutController.prototype.BindEvents = function(){
	this.dom.find(".js-check-update").unbind().bind("click",this,function(e){
		e.data.GetLatestVersion();
	});
	this.dom.find('.js-social-link').unbind().bind('click',function(){
		var url = $(this).data('url');
		window.open(url, '_system');
	});
	if(typeof videoSecurity != 'undefined' && videoSecurity == true){
		try {
			var deviceManufacturer = device.manufacturer;
		    deviceManufacturer = deviceManufacturer.toLowerCase();
  			console.log("Able to get the device manufacturer : "+deviceManufacturer );
		}
		catch(err) {
		  console.log("Unable to get the device manufacturer : "+err );
		}
			
		$(".social-icons").append("<span class='deviceManufacturer'>"+(typeof deviceManufacturer != "undefined" ? 'Device: '+deviceManufacturer:'Unable to Identify')+"</span>");
	}
};
appaboutController.prototype.GetLatestVersion =function()
{
	var urlMgmt = UrlMgmt.getObj();
	if (!urlMgmt.App.isOnline)
	{
		tr$.alert("Connect to internet");
	}
	else
	{
		urlMgmt.showLoader();
		$.ajax({
			type: "POST",
			url: remoteServer + "/?route=common/ajax",
			xhrFields: {
			   withCredentials: true
			},
			crossDomain: true,
		    context:this,
		    timeout: 30000,
			data:
			{
				mod: "tr2app",
				ack: "versioncheckb2b",
			},
			success: function(reply)
			{
				try
				{
					if(reply.result.state == "ok")
					{
						versionData = reply.data;
						tr$.AppUpdate(versionData,true);
					}
				}
				catch(e)
				{
					tr$.alert("<p class='errorMsg'>Update Failed</p>");
				}
				urlMgmt.removeLoader();
			}
		});	
	}
};