var QuestionType =
{
    MCQ    : 0,
	Upload : 1,
	COMP   : 2,
	CBQ    : 3,
	BLANK  : 4,
	NIQ    : 5,
    Str : [
        'Multiple Choice Question',
		'.otd file',
		'COMP',
		'Competency Based Question',
		'Fill in the blanks',
		'Numeric input quesion'
    ],
    Seq : {
    	0:'MCQ',
		1:'.otd file',
		2:'COMP',
		3:'Competency Based Question',
		4:'Fill in the blanks',
		5:'Numeric input quesion'
    }   
};

var appssctestController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	
	this.meta = [];
	this.sessionID = -1;
	this.userActivity = [];
	this.ansOrder = [];
	this.sectionName=[];
	this.ShowingQuestionNo = -1;
	this.startedAt = "";
	this.totalTime = "";
	this.startNewQuestionAt = "";
	this.totalMarks = 0;
	this.submited = false;
	this.paused = false;
	this.testId = null;
	this.tr2TestId = null;
	this.testState = null;
	this.parent = null;
	this.passedTime = 0;
	this.testAttribute = {};
	this.pausedtimdetl = {};
	this.pausedQue = -1;
	this.pauseLeft = -1;
	this.lastpausedId = -1;
	this.lastresumetim = {};
	this.lastRes = -1;
	this.pausehistorystored = [];
};
appssctestController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	//TODO: Header change
	urlMgmt.headerAction.view.hide();
};
appssctestController.prototype.LoadTest = function()
{	
	this.testAttribute = JSON.parse(this.parent["tests"][this.testId].meta);
	
	if(this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"]==1)
	{
		var saveLimit = this.testAttribute.hasOwnProperty("SaveLimit")?this.testAttribute["SaveLimit"]:-1;
		this.pauseLeft = saveLimit;
	}
	loadExistingData({entity: "downloadtestdata", recordId: this.testId}, function(data){
		$('#testData').html($(data));
		//Load meta
		loadExistingData({entity: "testmeta", recordId: this.testId, fileErrorHandling: false}, function(data){
			this.meta = data;
	 		loadExistingData({entity: "passedTime", recordId: this.testId}, function(result){
		 	if(result.passedTime > -1){
		 		//means the test is resumed
		 		this.passedTime = result.passedTime;
 				this.lastRes = this.passedTime;
		 		this.meta["startedAt"] = new Date(Date.now() - this.passedTime*1000);
		 	}
		 	 
			if(this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"]==1)
			{			
				if(this.testState == testState.Paused || this.testState == testState.Started)
				{
					if(this.meta["pausedetail"] != undefined)
					{
						this.lastpausedId = this.meta["pausedetail"]["id"];
						this.pauseLeft = this.meta["pausedetail"]["pauseLeft"];
						if(this.testState == testState.Started)
						{
							var tim = Math.floor(Date.now() / 1000) - this.meta["pausedetail"]["pauseBreakedAt"];
					 		this.passedTime = tim + parseInt(this.meta["pausedetail"]["usedTime"]);
					 		this.lastRes = tim + parseInt(this.meta["pausedetail"]["usedTime"]);
					 	} 
					 	else
					 	{
					 		this.passedTime = this.meta["pausedetail"]["usedTime"];
					 		this.parent.SetState(this.testId ,testState.Started);
					 		this.UpdateTestHistry(this.lastpausedId,testState.Paused,this.meta.sessionId);
					 	}		
					}
			 	}
			 	if(this.testState == testState.Started && this.meta["userLastactivetime"] != undefined && this.meta["userLastactivetime"] != -1)
			 	{
			 		var duration = Math.floor(Date.now() / 1000) - this.meta["userLastactivetime"]["lastactive"];
			 		var tt = $("#_totalTime_").text() * 60;
			 		var remaintim = tt - this.meta["userLastactivetime"]["usedTime"];

			 			if(duration > 120 && remaintim > 120)
				 		{
				 			this.passedTime = this.meta ["userLastactivetime"]["usedTime"];
				 			this.UpdateTestPause(this.passedTime,this.meta.sessionId);
				 		}
			 	}
			 		
			}					  	
	 		if(this.testState == testState.Loaded)
		 	{
		 		this.meta["startedAt"] = new Date();
		 		this.meta["endAt"] = null;
				this.testState = testState.Started;
		 		this.parent.SetState(this.testId ,this.testState);
		 		this.SaveQuestion();
		 	}
		 	if(this.meta["endAt"] != null)
		 	{
		 		alert("This test has been already taken");
		 		this.submited = true;
		 		this.testState = testState.Submitted;
				this.parent.SetState(this.testId ,this.testState);
		 		$('.btn-back.BackFromTest').click();
		 	}
		 	this.paused = false;
		 	this.sessionID = this.meta.sessionId;
			loadExistingData({entity: "testpauseque", recordId: this.meta.sessionId}, function(data){
		 		this.pausedQue = data;
				this.PopulateTestUI();
		 	}.bind(this)); 
			 		 	
	    }.bind(this));
    }.bind(this));
    }.bind(this));
};
appssctestController.prototype.PopulateTestUI = function()
{
	this.PopulateHeader();
	
	if(this.testState == testState.Started && this.meta["userLastactivetime"] != undefined && this.meta["userLastactivetime"] != -1)
	{
		var duration = Math.floor(Date.now() / 1000) - this.meta["userLastactivetime"]["lastactive"];
	
		if(duration > 300)
		{
			this.pausedtimdetl["id"] = this.lastpausedId;
			this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now()/ 1000);
			this.pausedtimdetl["pauseLeft"] = -1;
			this.pausedtimdetl["usedTime"] = this.meta["userLastactivetime"]["usedTime"];
			if(this.pauseLeft != -1)
			{
				this.pausedtimdetl["pauseLeft"] = this.pauseLeft;
			}
			this.meta["pausedetail"] = this.pausedtimdetl; 
			writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, this.meta, function(){});
		}
	}
	this.PopulateQuestionPalette();
	this.lastSavedQues();
	this.BindEvents();
	UrlMgmt.getObj().removeLoader();
	$("#SSCTest").show();
	this.ResizeTestScreen();
	setTimeout(function(){ $(".QPalleteBtn").click(); }, 1000);
};
appssctestController.prototype.lastSavedQues = function()
{
	$.ajax({
		type: "POST",
		data:{
				mod: "test",
				ack: "lastsavedques",
				session:this.meta.sessionId,
				testId:this.testId,
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
		complete: function( event){
			var reply = event.responseJSON;
		   	try
		   	{
		   		var qno = reply.data;
		   		this.ShowQuestion(qno);
		   	}
		   catch(e)
		   {
		   	  this.ShowQuestion(1);
		   }		   
		}.bind(this),
		url: remoteServer+"/ajax"
	});
};
appssctestController.prototype.PopulateHeader = function() 
{
	this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	this.timeNotedAt = new Date().getTime();
	
	if(this.meta["startedAt"] == undefined || typeof this.meta["startedAt"] == "string")
	{
		this.startedAt = new Date().getTime() - this.passedTime * 1000;
	}
	else
	    this.startedAt = this.meta["startedAt"].getTime();	
	
	this.remainingTime = this.totalTime - this.passedTime * 1000;
	this.StartTimer();
};
appssctestController.prototype.StartTimer = function() {
	if(this.submited==true || this.paused==true)
		return;

	var milisecond = this.remainingTime - new Date().getTime() + this.timeNotedAt ;
	
	this.SetTime(milisecond);
	if(milisecond >= 0)
	{
	    var t = setTimeout(function(){this.StartTimer();}.bind(this),500);
	}
	else
	{
		this.SubmitTest(true);
	}
};
appssctestController.prototype.SetTime = function(millisecond)
{
	if(millisecond <= 300000){
		if(!$(".timeAlert").hasClass("verticalTranslate"))
		{
			$(".timeAlert").addClass("verticalTranslate");
			var h = $(".controller-appssctestController").height() - 0 - 120;
			$(".timeAlert").animate({
				top : h
			},3000);
		}
	}
	millisecond /= 1000;
	var s = parseInt(millisecond % 60);
	var m = parseInt((millisecond / 60 ) % 60);
	var h = parseInt((millisecond / (60 * 60) ) % 60);
	if(s < 0 || m < 0 || h < 0)
	{ 
	  h = 0;
	  m = 0;
	  s = 0; 
	}
	$("#TimeLeft").text(this.TimeStr(h) + ":" + this.TimeStr(m) + ":" + this.TimeStr(s));
};
appssctestController.prototype.TimeStr = function(i) {
    if (i<10) {i = "0" + i;}  // add zero in front of numbers < 10
    return i;
};
appssctestController.prototype.BindEvents = function()
{
	self = this;
	document.addEventListener('pause', function() {		
			if(self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"]==1)			
	   	    {
	   	    	var usedTime = (new Date().getTime() - self.startedAt)/1000;
	   	 		self.lastresumetim["usedTime"] = Math.round(usedTime);
	   			self.lastresumetim["lastactive"] = Math.floor(Date.now()/ 1000);
	   	  		self.meta["userLastactivetime"] = self.lastresumetim;
	   			writeData("testmeta_"+self.testId+".json", 'testmeta', self.testId, self.meta, function(){});
	   	   	}		
	}, false);
	
	$("#saveForLater").unbind().click(function(){
		self.SaveQuestion();
		var saveLimit = self.pauseLeft - 1;
		if(self.pausedtimdetl["pauseLeft"] != undefined && self.pausedtimdetl["pauseLeft"] > 0)
		{
			saveLimit = self.pausedtimdetl["pauseLeft"]- 1;
		}
		if(saveLimit > 0)
			{$("#saveForLaterModal p.saveLimitInfo").html("You can save this test "+saveLimit+" more time");}	
		else if(saveLimit == 0)
			{$("#saveForLaterModal p.saveLimitInfo").html("You will not be able to save this test again.This is the last chance!!");}	
		$("#saveForLaterModal").modal('show');
		
	});
	
	$("#confirmSave").unbind().click(function(){
		var saveLimit = self.pauseLeft;
		if(saveLimit > 0 || saveLimit == -1)
		{
			UrlMgmt.getObj().showLoader(false);
			self.PauseTest();
			$("#saveForLaterModal").modal('hide');
		}
		else
		{
			alert("You can not Save PAUSE this test.Click OK to continue Test!!");
			$("#saveForLaterModal").modal('hide');
		}
	}.bind(this));
	
	$(".QPalleteBtn").click(function(){
		if($(this).hasClass("showedPallete"))
		{
			$("#QuestionPalette").hide();
			$(this).removeClass("showedPallete");
			$(this).find(".open").removeClass("shownIcon");
			$(this).find(".closed").addClass("shownIcon");
			var top = parseInt($(".middleDiv").height() / 2);
			$(".QPalleteBtn").css("top",top+"px");
		}
		else
		{
			$("#QuestionPalette").show();
			$(this).addClass("showedPallete");
			$(this).find(".closed").removeClass("shownIcon");
			$(this).find(".open").addClass("shownIcon");
		}
		self.ResizeTestScreen();
	});
	$(".qIndicator").unbind().click(function(){
		self.SaveQuestion();
		self.ShowQuestion($(this).attr("qNo"));
	});
	$("#CleanResponseBtn").unbind().click(function(){
		if($("#Question").attr("qType") == QuestionType.NIQ){
			$("#Question").find(".keyboardwrite").val("");
		}
		else{
			$('.Answer input').prop('checked', false);
		}
		$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").removeClass("skippedIcon review_answeredIcon attemptedIcon reviewIcon review_answeredIcon");
		if(self.userActivity[self.ShowingQuestionNo-1].flaged){
			$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("reviewIcon");
		}
		else{
			$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("skippedIcon");
		}
		self.UpdateIndicators();
	});
	$("#MarkForReviewBtn").unbind().click(function(){
		$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").removeClass("skippedIcon review_answeredIcon attemptedIcon reviewIcon review_answeredIcon");
		if(self.userActivity[self.ShowingQuestionNo-1].flaged){
			self.userActivity[self.ShowingQuestionNo - 1].flaged = false;
			$(this).html("Tag");
			if(self.userActivity[self.ShowingQuestionNo-1].state == AnswerStatus.ANSWERED){
				$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("attemptedIcon");	
			}
			else{
				$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("skippedIcon");
			}
		}
		else{
			self.userActivity[self.ShowingQuestionNo - 1].flaged = true;
			$(this).html("De-Tag");
			if(self.userActivity[self.ShowingQuestionNo-1].state == AnswerStatus.ANSWERED){
				$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("review_answeredIcon");	
			}
			else{
				$(".qIndicator[qno='"+self.ShowingQuestionNo+"']").addClass("reviewIcon");
			}
		}
		self.UpdateIndicators();
	});
	$("#previewSubmit").unbind().click(function(){
		this.SaveQuestion();
		this.PopulatePreSubmissionInfo();
		$("#ssctestSummary-modal").modal('show');
	}.bind(this));
	$("#Next").unbind().click(function(){
		this.SaveQuestion();
		var qNo = (this.ShowingQuestionNo%this.userActivity.length) + 1;
		self.ShowQuestion(qNo);
	}.bind(this));
	$("#Prev").unbind().click(function(){
		if(self.ShowingQuestionNo == 1)
			return;
		self.SaveQuestion();
		var qNo = (self.ShowingQuestionNo%self.userActivity.length) - 1;
		if(qNo <= 0)
			qNo = self.ShowingQuestionNo - 1;
		self.ShowQuestion(qNo);
	});
	$(".CancelBtn").click(function(){
		$("#ssctestSummary-modal").modal('hide');
	});
	$("#TS-submitSSCTest").unbind().click(function(){
		$("#ssctestSummary-modal").modal("hide");
		self.SubmitTest();
	}.bind(this));
	$(".closeAlert").click(function(){
		$(this).parents(".timeAlert").hide();
		$(this).parents(".timeAlert").removeClass("verticalTranslate");
	});
	$("#saveForLaterModal .CancelBtn").click(function(){
		$("#saveForLaterModal").modal('hide');
	});
	
	$("#testbackbtnwarningModal .CancelBtn").unbind().click(function(){
		if(self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"]==1)			
   	    {
   	    	var usedTime = (new Date().getTime() - self.startedAt)/1000;
   	    	self.meta["userLastactivetime"] = -1;
   	    	writeData("testmeta_"+self.testId+".json", 'testmeta', self.testId, self.meta, function(){if(typeof cb != 'undefined')cb();});
	    }
		$("#testbackbtnwarningModal").modal('hide');
		self.paused= true;
		UrlMgmt.getObj().PopView();
	}.bind(this));
	
	$("#confirmclosetest").unbind().click(function(){
		$("#testbackbtnwarningModal").modal('hide');
		self.BindEvents();
	}.bind(this));
	
	$('.btn-back.BackFromTest').unbind().click(this,function(e){
		if(self.paused == false && self.submited == false)
	   	{
	   		if(self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"]==1)			
   	    	{
   	    		$("#testbackbtnwarningModal").modal('show');	
   	    	}
   	    	else{
   	    	}
	   		self.pausedQue = self.ShowingQuestionNo;
	   		writeData("testpauseque_"+self.sessionID+".json", "testpauseque", self.sessionID, self.pausedQue, function(){if(typeof cb != 'undefined')cb();});
			self.SaveQuestion();
			self.testState = testState.Started;
		 	self.parent.SetState(self.testId ,self.testState);
		 }
		 if(self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"]==1)			
   	     {
   	     	if(self.submited == true && !($("#ssctestSummary-modal").hasClass('in')))
			 {
			 	UrlMgmt.getObj().PopView();
			 	self.paused= true; 
			 }	
   	     }
   	     else
   	     {
   	     	 if(!($("#ssctestSummary-modal").hasClass('in')))
			 { 
			  	UrlMgmt.getObj().PopView();
			 } 
			  self.paused= true; 
   	     }		
	});
};
appssctestController.prototype.UpdateTestHistry  = function(lpauseId, currentState, sessionId)
{
	$.ajax({
		 url: remoteServer+"/ajax",
		type: 'POST',
	 	data:{
	 		mod: "testapi",
			ack: "updatetesthistory",
			lastpauseId : lpauseId,
			testId:this.testId,
			tempUserId:tempUserId,
			testState:currentState,
			session:sessionId
		},
	 	xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	 	success: function(reply){
	 		if(reply.result.state == "ok")
			{
				if(reply.data["id"] > 0)
				{
					this.meta["pausedetail"] = reply.data;
					writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
				}	
			}
	 		else
	 		{
	 			alert(reply.result.meta);
	 		}
	 		UrlMgmt.getObj().removeLoader();
	 	}.bind(this),
		error: function(jqXHR, exception) {
				UrlMgmt.getObj().removeLoader();
			    if (jqXHR.status === 0) {	
			    	this.pausedtimdetl["id"] = -1;
					this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now()/ 1000);
					this.pausedtimdetl["pauseLeft"] = -1;
					this.pausedtimdetl["usedTime"] = this.passedTime;
					if(this.pauseLeft != -1)
					{
						this.pausedtimdetl["pauseLeft"] = this.pauseLeft;
					}
					this.meta["pausedetail"] = this.pausedtimdetl;
					if(this.meta["pausehistorystored"] == undefined)
					{
						this.meta["pausehistorystored"] = [];	
					}
					this.meta["pausehistorystored"].push({"UT":this.passedTime,"pausebrk":Math.floor(Date.now()/ 1000)});
					writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
					     
			    } else if (jqXHR.status == 404) {
			        alert('Requested page not found. [404]');
			    } else if (jqXHR.status == 500) {
			        alert('Internal Server Error [500].');
			    } else if (exception === 'parsererror') {
			        alert('Requested JSON parse failed.');
			    } else if (exception === 'timeout') {
			        alert('Time out error.');
			    } else if (exception === 'abort') {
			        alert('Ajax request aborted.');
			    } else {
			        alert('Uncaught Error.\n' + jqXHR.responseText);
			    }
			},
	  });
};
appssctestController.prototype.UpdateTestUpdateH  = function(lpauseId, currentState, sessionId)
{
	$.ajax({
		 url: remoteServer+"/ajax",
		type: 'POST',
	 	data:{
	 		mod: "testapi",
			ack: "updatetesthistory",
			lastpauseId : lpauseId,
			testId:this.testId,
			tempUserId:tempUserId,
			testState:currentState,
			session:sessionId
		},
	 	xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	 	success: function(reply){
	 		if(reply.result.state == "ok")
			{
				console.log("update",reply.data);	
			}
	 		else
	 		{
	 			alert(reply.result.meta);
	 		}
	 		UrlMgmt.getObj().removeLoader();
	 	}.bind(this),
		error: function(jqXHR, exception) {
			},
	  });
};
appssctestController.prototype.UpdateTestPause = function(usedTime,sessionId)
{
	$.ajax({
		type:"POST",
		url: remoteServer+"/ajax",
		data:{ 
				mod:"testapi",
				ack:"insertPauseHistory",
				testId:this.testId,
				session:sessionId,
				usedTime:usedTime,
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	    success: function(reply){
			if(reply.result.state == "ok")
			{
				if(reply.data["state"] == 1)
				{
					this.UpdateTestUpdateH(reply.data["id"],testState.Paused,sessionId);			
				}
			}	   
			else
			{
				alert(reply.result.meta);
			}
			UrlMgmt.getObj().removeLoader();
		}.bind(this),
		error: function(jqXHR, exception) {
				if (jqXHR.status === 0) {
					if(this.meta["pausehistorystored"] == undefined)
					{
						this.meta["pausehistorystored"] = [];	
					}
					this.meta["pausehistorystored"].push({"UT":usedTime,"pausebrk":Math.floor(Date.now()/ 1000)});
					writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
				}
			},
	});
};
appssctestController.prototype.PauseTest = function()
{
	var usedTime = (new Date().getTime() - this.startedAt)/1000;
	usedTime = Math.round(usedTime);
	$.ajax({
		type:"POST",
		url: remoteServer+"/ajax",
		data:{ 
				mod:"testapi",
				ack:"insertPauseHistory",
				testId:this.testId,
				session:this.sessionID,
				usedTime:usedTime,
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	    success: function(reply){
			if(reply.result.state == "ok")
			{
				if(reply.data["state"] == 1)
				{
					this.paused = true;
					this.meta["pausedetail"] = reply.data;
					writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
					this.meta["pausehistorystored"] = [];	
					this.testState = testState.Paused;
					this.pausedQue = this.ShowingQuestionNo;
					writeData("testpauseque_"+this.sessionID+".json", "testpauseque", this.sessionID, this.pausedQue, function(){if(typeof cb != 'undefined')cb();});
					this.parent.SetState(this.testId ,this.testState);
					UrlMgmt.getObj().PopView();
				}
				else{
					alert("You can not pause this Test!!");
					UrlMgmt.getObj().removeLoader();
				}
			}	   
			else
			{
				alert(reply.result.meta);
			}
		}.bind(this),
		error: function(jqXHR, exception) {
				if (jqXHR.status === 0) {
					this.paused = true;
			    	this.pausedtimdetl["id"] = -1;
					this.pausedtimdetl["usedTime"] = usedTime;
					this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now()/ 1000);
					this.pausedtimdetl["pauseLeft"] = -1;
					if(this.testAttribute["SaveLimit"] != undefined)
					{
						this.pausedtimdetl["pauseLeft"] = this.pauseLeft - 1;
					}
					/*if(this.meta["pausehistorystored"] == undefined)
					{
						this.meta["pausehistorystored"] = [];	
					}
					this.meta["pausehistorystored"].push({"UT":usedTime,"pausebrk":Math.floor(Date.now()/ 1000)});*/
					this.meta["pausedetail"] = this.pausedtimdetl;
					writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
				
					this.testState = testState.Paused;
					this.pausedQue = this.ShowingQuestionNo;
					writeData("testpauseque_"+this.sessionID+".json", "testpauseque", this.sessionID, this.pausedQue, function(){if(typeof cb != 'undefined')cb();});
					this.parent.SetState(this.testId ,this.testState);
					UrlMgmt.getObj().PopView();
					UrlMgmt.getObj().removeLoader();
			    } else if (jqXHR.status == 404) {
			        alert('Requested page not found. [404]');
			    } else if (jqXHR.status == 500) {
			        alert('Internal Server Error [500].');
			    } else if (exception === 'parsererror') {
			        alert('Requested JSON parse failed.');
			    } else if (exception === 'timeout') {
			        alert('Time out error.');
			    } else if (exception === 'abort') {
			        alert('Ajax request aborted.');
			    } else {
			        alert('Uncaught Error.\n' + jqXHR.responseText);
			    }
			},
	});
};
appssctestController.prototype.PopulateQuestionPalette = function()
{
	if(this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"]==1)
	{
		$('.bottomDiv').find(".SavL").append('<div class="Saved"><button id="saveForLater" class="saveL" '+
											  'savelimit='+this.pauseLeft+' canpause="false">Save For Later</button></div>');		
	}
	
	var palleteBtn = $('.QPalleteBtn');
	palleteBtn.append('<x-icon class="leftHideShowBtn open shownIcon">'+arrowEIcon+'</x-icon><x-icon class="leftHideShowBtn closed">'+arrowWIcon+'</x-icon>');
	this.questionOrder = JSON.parse($("#_questionOrder_").text());
	for(s in this.questionOrder)
	{
		this.sectionName[s] = this.questionOrder[s].name;
		var sBtn = $('<span class="sectionNav" sectionId="'+s+'">'+this.questionOrder[s].name+'</span>').appendTo($("#sectionPanel"));
	}
	var qNoInSection = 1;
	var currentSectionId = 0;
	for(var qNo in this.meta.questions)
	{
		var q = this.meta.questions[qNo];
		var qId = q.questionId;
		var sQId = q.subQuestionId;
		var sectionId = q.sectionId;
		if(sectionId != currentSectionId)
		{
			currentSectionId = sectionId;
			qNoInSection = 1;
		}
		var className= "Icon qIndicator";
		
		if(this.sessionID > 0)
		{	
			this.userActivity[qNo-1] = {ans:[], state: AnswerStatus.MISSED, questionNo:qId, sQId:sQId, 
							timeSpent:-1, flaged:false};
			if(q.hasOwnProperty("answer") && q.answer.hasOwnProperty("ans"))
			{
				this.userActivity[qNo-1] = {ans:q.answer.ans, state: q.answer.state, questionNo:qId, 
											sQId:sQId, timeSpent:-1, flaged:(q.flag==1)};
											
				if(q.flag==1 && q.answer.state == AnswerStatus.ANSWERED)
					className += " review_answeredIcon";
				else if(q.flag==1 && q.answer.state == AnswerStatus.SKIPED)
					className += " reviewIcon";
				else if(q.answer.state == AnswerStatus.ANSWERED)
					className += " attemptedIcon";
				else	
					className += " skippedIcon";
			}
			else
			{
				className += " missedIcon";
			}
			this.ansOrder[qNo-1] = q.meta;
		}
		var icon = '<div class="'+className+'" qNo="'+ qNo +'" qId="'+qId+'" sQId="'+sQId+'" '+
					'sectionId="'+sectionId+'" qNoInSection="'+qNoInSection+'">Q'+qNo+'</div>';
		$("#QuestionPalette .QNavigator").append(icon);
		qNoInSection ++;
	}
	$(".sectionNav").removeClass("Selected");
	$(".sectionNav[sectionId='0']").addClass("Selected");
};
appssctestController.prototype.ShowQuestion = function(qNo)
{
	writeData("testpauseque_"+this.sessionID+".json", "testpauseque", this.sessionID, qNo, function(){if(typeof cb != 'undefined')cb();});
	
	//Clean Floating right box 
	$('.floated-answerBox').html('');	
	
	qNo = parseInt(qNo);
	this.UpdateTotalTimeSpent();
	this.ShowingQuestionNo = qNo;
	var q = $('.qIndicator[qNo="'+qNo+'"]');
	var state = AnswerStatus.MISSED;
	if(this.userActivity[qNo - 1] != null)
	{
		state = this.userActivity[qNo - 1].state;
	}
	if(state == AnswerStatus.MISSED)
	{
		q.removeClass("missedIcon");
		q.addClass("skippedIcon");
		this.userActivity[qNo - 1].state = AnswerStatus.SKIPED;
	}

	var sectionId = q.attr("sectionId");
	if(sectionId != $(".sectionNav.Selected").attr("sectionId"))
	{
		$(".qIndicator").css("display", "inline-block");
		$(".sectionNav").removeClass("Selected");
		$(".sectionNav[sectionId='"+sectionId+"']").addClass("Selected");
	}
		
	var qNoInSection = q.attr("qNoInSection");
	$("#QuestionNo").text(qNo);
	var qId = q.attr("qId");
	var sQId = q.attr("sQId");
	var qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"']:eq(0)");
	var qDivEnglish = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[0]+"']");
	var qDivHindi = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[1]+"']");
	$("#Question").attr("qNo", qNo);
	$("#Question").attr("qId", qId);
	$("#Question").attr("sQId", sQId);

	var qtype = qDiv.attr("qType");
	var qMark = qDiv.attr("marks");
	var negativeMark = $("#_negativeMark_").html();
	if(negativeMark > 0)
	{
		negativeMark = (qMark*negativeMark)/100;
	}
	$(".infoPanel .questionMark").html(qMark);
	$(".infoPanel .negative").html(negativeMark);
	$(".questionTypePanel #QuestionType").text(QuestionType.Str[qtype]);
	$("#QPart > .Question").attr("qactualtype", qtype);
	loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data){
		if(typeof qtype != undefined && parseInt(qtype) == QuestionType.BLANK)
	    {
	    	this.ShowFillInTheBankQuestion(qDiv, qNo, data);
	    }
	    else if(typeof qtype != undefined && parseInt(qtype) == QuestionType.NIQ)
	    {
	    	this.ShowNIQQuestion(qDiv, qNo, data);
	    }
	    else
	    {
	    	this.ShowMCQQuestion(qDiv, qNo, qId, sQId, parseInt(qtype), qDivEnglish, qDivHindi, data);
	    }
		MathJax.Hub.Queue(["Typeset",MathJax.Hub, $("#SSCTest #Question").get(0)],
			function ()
			{
				var cWidth = $('#SSCTest #Question').width();
				var wWidth = $(window).width();
				if(cWidth < (wWidth/2) || cWidth > (wWidth - 40))
				{
					cWidth = wWidth - 40;
				}
		        $("#SSCTest #Question span.MathJax_CHTML").each(function(){
			        if($(this).width() > cWidth)
			        {
			            $(this).css({'max-width' : cWidth+'px'});
			            $(this).addClass("scroll-x");
			        }
		        });
				$("#SSCTest #Question .questionText,  #SSCTest #Question .AnswerText ").html(function(i,h){
					return h.replace(/&nbsp;/g,' ');
				});
			}
		);
		this.ResizeTestScreen();
		var scrollPos = q.position().top - $('.qIndicator[qno="1"]').position().top - 
							$(".QNavigator").height()/2.0;
		$(".QNavigator").scrollTop(scrollPos);
		this.UpdateIndicators();
		this.ValidateNavigation();
	}.bind(this));
};
appssctestController.prototype.ValidateNavigation = function ()
{
	var questionCount = $(".QNavigator").find(".qIndicator").length;
	(this.ShowingQuestionNo == 1)? $("#Prev").addClass("Disable"):$("#Prev").removeClass("Disable");
	(this.ShowingQuestionNo == questionCount)?$("#Next").addClass("Disable"):$("#Next").removeClass("Disable");
	if(this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"]==1)			
	{
		var usedTime = (new Date().getTime() - this.startedAt)/1000;
 		this.lastresumetim["usedTime"] = Math.round(usedTime);
		this.lastresumetim["lastactive"] = Math.floor(Date.now()/ 1000);
  		this.meta["userLastactivetime"] = this.lastresumetim;
		writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
	}
};
appssctestController.prototype.ShowMCQQuestion = function(qDiv, qNo, qNumber, sQId, qtype, qDivEnglish, qDivHindi, data)
{
	var serveransweredDate = 0;
	var localansweredDate = 0; 
		var answerData = data;

		$("#Question").attr("qType", QuestionType.MCQ);
		var answer = "<div class=\"Answers\" choiceMode=\"" + qDiv.attr("choicemode") + "\" >";
		
		var qText = "";
		var ans = qDiv.find("._answer_");
		var ansEnglish =  qTextEnglish = "";
		if(qDivEnglish.length > 0)
		{
			ansEnglish = qDivEnglish.find("._answer_");
			qTextEnglish = qDivEnglish.find("._text_").html();
			qText += '<div class="questionEng">' + qTextEnglish + '</div>';
		}
		var ansHindi = qTextHindi = "";
		if(qDivHindi.length > 0)
		{
			ansHindi = qDivHindi.find("._answer_"); 
			qTextHindi = qDivHindi.find("._text_").html();
			qText += '<div class="questionHindi">' + qTextHindi + '</div>';
		}
			
		var inputType = "radio";
		if(qDiv.attr("choicemode") > 0)
		{
			inputType = "checkbox";
		}
		var choice = 0;
		for (var i = 0; i < this.ansOrder[qNo-1].length; i++) 
		{	
			var option = "";
			if(ansEnglish != "" && ansHindi != ""){
				option += '<div class="ansEng">'+$(ansEnglish[this.ansOrder[qNo-1][i]]).html()+'</div>';
				if($(ansEnglish[this.ansOrder[qNo-1][i]]).text().trim() != $(ansHindi[this.ansOrder[qNo-1][i]]).text().trim())
					option += '<div class="ansHindi">'+$(ansHindi[this.ansOrder[qNo-1][i]]).html()+'</div>';
			}
			else if(ansEnglish != "")
			{
				option += '<div class="ansEng">'+$(ansEnglish[this.ansOrder[qNo-1][i]]).html()+'</div>';
			}
			else
			{
				option += '<div class="ansHindi">'+$(ansHindi[this.ansOrder[qNo-1][i]]).html()+'</div>';
			}
			var ansClass = 	"Answer";
			var checked ="";
			//Check which activity is latest (server or file)
			serveransweredDate = (answerData && answerData[qNo-1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
			localansweredDate = (this.userActivity && this.userActivity[qNo-1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;
			
			if(serveransweredDate > localansweredDate && answerData[qNo-1] != null && answerData[qNo-1].ans != undefined && answerData[qNo-1].ans[choice]){
				checked = 'checked="checked"';
			}
			else if(serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice])
			{
				checked = 'checked="checked"';
			}
			answer += 	"<div class=\"tableRow\"><div class=\""+ansClass+"\">"+
					"<span class=\"tableCol\">"+'<input type="'+inputType+'" name="ansOption" '+ checked +'>'+"</span>"+
					"<span class=\"tableCol\">"+String.fromCharCode(choice + 65)+")</span>"+
					"<span class=\"AnswerText tableCol\">" + option + "</span>"+ 
					"</div></div>";
			choice++;				
		}
		answer += "</div>";
		
		$("#Question").html('<div class="questionText">'+qText+'</div>' + answer);	
		$('.Answer').unbind().bind("click",this, function(e){
			if(e.target.tagName.toUpperCase()!= "INPUT")
				$(this).find("input").click();
			e.data.AnswerClicked(this);
		});
		
		if(this.userActivity[qNo - 1].flaged == true)
			$("#MarkForReviewBtn").html("De-Tag");
		else
			$("#MarkForReviewBtn").html("Tag");
};
appssctestController.prototype.ShowNIQQuestion = function (qDiv, qNo, data)
{
		var answerData = data;
		
		$("#Question").attr("qType", QuestionType.NIQ);
		var answer = "<div class=\"Answers\">";
		var ans = qDiv.find("._answer_");
		answer += this.KeyBoardHtml();
		answer += "</div>";
		var upToDecimalHtml='';
		if(qDiv.attr("upToDecimal") != undefined)
		{
			if(parseInt(qDiv.attr("upToDecimal"))!=0){
				upToDecimalHtml = '<div class="upToDecimal"><b>up to '+qDiv.attr("upToDecimal")+' decimal place</b></div>';
			}
		}  
		var qText = qDiv.find("._text_").html();
		$("#Question").html('<div class="questionText">' + qText + upToDecimalHtml + '</div>' + answer);
		$("#Question").find(".keyboardwrite").prop( "disabled", true );
		$("#Question").find(".keyboard li").bind("click", this.CreateAnsKeyBoardHtml.bind(this));
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo-1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(answerData[qNo - 1].ans[0]);
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(this.userActivity[qNo - 1].ans[0]);
		}
};
appssctestController.prototype.ShowFillInTheBankQuestion = function(qDiv, qNo, data)
{
		var answerData = data;
	
		$("#Question").attr("qType", QuestionType.BLANK);
		
		var parts = qDiv.find("._text_").html().split("{BLANK}");
		var qText = "";
		for(var i=0; i < parts.length; i++)
		{
			qText += parts[i];
			if(i < parts.length - 1)
			{
				qText += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
			}
		}
		var answer = "<div class=\"Answers\">";
		var ans = qDiv.find("._answer_");
	    for (var i = 0; i < ans.length; i++) 
		{	
			ansClass = 	"AnswerSelect";
			answer += 	"<div class=\""+ansClass+"\">"+
						'<div class="BlankNumber">blank-'+(i+1)+'</div>'+
						$(ans[i]).html() +  
					"</div>";
		}
		answer += "</div>";
		
		$("#Question").html('<div class="questionText">' + qText + '</div>' + answer);
		
		var ques = $("#Question .Answers select");
		ques.val("-1");
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null) {
			for (var i = 0; i < answerData[qNo - 1].ans.length; i++) {
				$(ques[i]).val(answerData[qNo - 1].ans[i]);
			}
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null) {
			for (var i = 0; i < this.userActivity[qNo - 1].ans.length; i++) {
				$(ques[i]).val(this.userActivity[qNo - 1].ans[i]);
			}
		}
};
appssctestController.prototype.KeyBoardHtml = function()
{
	keyBoardHtmlDis = '<div class="containerkeyboard">'+
		'<textarea class="keyboardwrite" rows="1"></textarea>'+
		'<ul class="keyboard">'+
			'<li class="symbol"><span class="off">1</span></li>'+
			'<li class="symbol"><span class="off">2</span></li>'+
			'<li class="symbol"><span class="off">3</span></li>'+
			'<li class="symbol"><span class="off">4</span></li>'+
			'<li class="symbol"><span class="off">5</span></li>'+
			'<li class="symbol"><span class="off">6</span></li>'+
			'<li class="symbol"><span class="off">7</span></li>'+
			'<li class="symbol"><span class="off">8</span></li>'+
			'<li class="symbol"><span class="off">9</span></li>'+
			'<li class="symbol"><span class="off">0</span></li>'+
			'<li class="symbol"><span class="off">.</span></li>'+
			'<li class="symbol"><span class="off">-</span></li>'+
			'<li class="delete lastitem">delete</li>'+
		'</ul>'+
	'</div>';
	return keyBoardHtmlDis;
};
appssctestController.prototype.CreateAnsKeyBoardHtml = function(event)
{	
	var Data=event.currentTarget;
	var character = $(Data).html();
	qNumber = $("#test_Question_Number").text();
	if(this.userActivity[this.ShowingQuestionNo - 1].state != AnswerStatus.FLAGED)
		this.userActivity[this.ShowingQuestionNo - 1].state = AnswerStatus.ANSWERED;
	if ($(Data).hasClass('delete')) {
		var html = $("#Question").find(".keyboardwrite").val();
		$("#Question").find(".keyboardwrite").val(html.substr(0, html.length - 1));
		if($("#Question").find(".keyboardwrite").val().length===0){
			this.userActivity[this.ShowingQuestionNo - 1].state = AnswerStatus.SKIPED;
		}
		return false;
	}
	if ($(Data).hasClass('symbol')) character = $('span:visible', $(Data)).html();
	$("#Question").find(".keyboardwrite").val($("#Question").find(".keyboardwrite").val() + character);
	if($("#Question").find(".keyboardwrite").val().length>1){
		if(!$.isNumeric($("#Question").find(".keyboardwrite").val())){
			alert("Notice:- answer should be numeric");			
		}
	}
};
appssctestController.prototype.UpdateTotalTimeSpent = function()
{
	if(this.startNewQuestionAt != "" && this.ShowingQuestionNo != -1)
	{
		if(this.userActivity[this.ShowingQuestionNo - 1].timeSpent == -1)
			this.userActivity[this.ShowingQuestionNo - 1].timeSpent++;
		this.userActivity[this.ShowingQuestionNo - 1].timeSpent += (parseInt((new Date().getTime() - 
																	this.startNewQuestionAt)/1000));																
	}
	this.startNewQuestionAt = new Date().getTime();
};
appssctestController.prototype.ResizeTestScreen = function()
{
	var height = $(".headerNav").outerHeight() + $(".sscHeader").outerHeight() +  $(".bottomDiv").outerHeight() - 3;
	$(".middleDiv").outerHeight($(window).height() - height);
	$(".Question").outerHeight($(".middleDiv").height() - $(".infoPanel").height());
	$("#QuestionPalette").outerHeight($("#SSCTest").height() - $(".sscHeader").outerHeight() - $(".header-seperator").outerHeight() -5);
	$(".QNavigator").outerHeight($("#QuestionPalette").outerHeight() - $(".Legend").outerHeight() - $(".palleteHeading").outerHeight() - 20);
	$(".QPalleteBtn").css("right","0px");
	if($(".QPalleteBtn").hasClass("showedPallete"))
		$(".QPalleteBtn").css("right",$("#QuestionPalette").width());
};
appssctestController.prototype.SaveQuestion = function()
{
	if(this.submited == false)
	{
		if(this.ShowingQuestionNo > 0)
		{
			if(!this.userActivity[this.ShowingQuestionNo - 1].hasOwnProperty("ans"))
			{
				this.userActivity[this.ShowingQuestionNo - 1].ans = [];
			}
			this.UpdateTotalTimeSpent();
			var state = AnswerStatus.SKIPED;
			var answered = false;
			var counter = 0;
			
			var self = this;
			if($('#Question').attr("qType") == QuestionType.BLANK)
			{
				$("#Question .Answers select").each(function(){
					var selectVal = $(this).val(); 
					self.userActivity[self.ShowingQuestionNo - 1].ans[counter] = selectVal;
					if(selectVal > -1)
					{
						answered = true;
					}
					counter++;
				});
			}
			else if($("#Question").attr("qType") == QuestionType.NIQ){
				self.userActivity[self.ShowingQuestionNo - 1].ans[0]=$("#Question").find(".keyboardwrite").val();
				if($("#Question").find(".keyboardwrite").val()){
					answered=true;
				}
			}
			else
			{	
				$(".Answers input").each(function(){
					var hasSelectedAns =  $(this).prop("checked");
					self.userActivity[self.ShowingQuestionNo - 1].ans[counter] = hasSelectedAns;
					answered |= hasSelectedAns;
					counter++;
				});
			}
			
			this.userActivity[this.ShowingQuestionNo - 1].state = answered?AnswerStatus.ANSWERED:AnswerStatus.SKIPED;
			this.userActivity[this.ShowingQuestionNo-1]["answeredDate"] = new Date();
		
			var q = $('.qIndicator[qNo="'+this.ShowingQuestionNo +'"]');
			var classForIcon =  "skippedIcon";
			
			if(this.userActivity[this.ShowingQuestionNo-1]["flaged"] && answered)
				classForIcon = "review_answeredIcon";
			else if(this.userActivity[this.ShowingQuestionNo-1]["flaged"])
				classForIcon = "reviewIcon";
			else if(answered)
				classForIcon = "attemptedIcon";
				
			q.attr("class", "Icon qIndicator " + classForIcon);
			
				
			if(!this.meta["questions"][this.ShowingQuestionNo].hasOwnProperty("answer"))
			{
				this.meta["questions"][this.ShowingQuestionNo]["answer"] = {};
			}
			this.meta["questions"][this.ShowingQuestionNo]["answer"]["ans"] = this.userActivity[this.ShowingQuestionNo-1]["ans"];
			this.meta["questions"][this.ShowingQuestionNo]["answer"]["state"] = this.userActivity[this.ShowingQuestionNo-1]["state"];
			this.meta["questions"][this.ShowingQuestionNo].flaged = this.userActivity[this.ShowingQuestionNo-1]["flaged"]?"true":"false";
			this.meta["questions"][this.ShowingQuestionNo]["timeSpent"] = this.userActivity[this.ShowingQuestionNo-1]["timeSpent"];
			if(!UrlMgmt.getObj().App.isOnline){
				if(!this.meta.hasOwnProperty('questionsSubmit'))
					this.meta["questionsSubmit"] = false;
			}
			else{
				$.ajax({
					url: remoteServer+"/ajax",
					type: 'POST',
				 	data:{
				 		mod: "test",
						ack: "save",
						answer: JSON.stringify(this.meta["questions"][this.ShowingQuestionNo]["answer"]),
						flaged: this.meta["questions"][this.ShowingQuestionNo]["flaged"],
						qid: this.meta["questions"][this.ShowingQuestionNo]["questionId"],
						sqid: this.meta["questions"][this.ShowingQuestionNo]["subQuestionId"],
						session: this.meta["sessionId"],
						tempUserId: this.meta["tempUserId"],
						timespent: this.meta["questions"][this.ShowingQuestionNo]["timeSpent"],
			
					},
				 	xhrFields: {
				       withCredentials: true
				    },
				    crossDomain: true,
				    context:this, 
				 	success: function(reply){
				 		if(reply.result.state == "ok")
						{
						}
					}.bind(this),
					error: function(jqXHR, exception) {
						if (jqXHR.status === 0) {
						  	//alert("Data will be saved temporarily as you are not connected to Internet");
						} else if (jqXHR.status == 404) {
						    alert('Requested page not found. [404]');
						} else if (jqXHR.status == 500) {
						    alert('Internal Server Error [500].');
						} else if (exception === 'parsererror') {
						    alert('Requested JSON parse failed.');
						} else if (exception === 'timeout') {
						    alert('Time out error.');
						} else if (exception === 'abort') {
						    alert('Ajax request aborted.');
						} else {
						    alert('Uncaught Error.\n' + jqXHR.responseText);
						}
					}
				});
				
				//last question number save in redis
				$.ajax({
					url: remoteServer+"/ajax",
					type: 'POST',
				 	data:{
				 		mod: "test",
						ack: "lastquestionsave",
						session: this.meta["sessionId"],
						qno: this.ShowingQuestionNo,
						testId: this.testId
					},
				 	xhrFields: {
				       withCredentials: true
				    },
				    crossDomain: true,
				    context:this, 
				 	success: function(reply){
				 		if(reply.result.state == "ok")
						{
							
						}
					}.bind(this),
					error: function(jqXHR, exception) {
						if (jqXHR.status === 0) {
							 var alerted = localStorage.getItem('alerted') || '';
	   		 				 if (alerted != 'yes') {
	     						alert("Data will be saved temporarily as you are not connected to Internet");
	     						localStorage.setItem('alerted','yes');
	    					 }
						} else if (jqXHR.status == 404) {
						    alert('Requested page not found. [404]');
						} else if (jqXHR.status == 500) {
						    alert('Internal Server Error [500].');
						} else if (exception === 'parsererror') {
						    alert('Requested JSON parse failed.');
						} else if (exception === 'timeout') {
						    alert('Time out error.');
						} else if (exception === 'abort') {
						    alert('Ajax request aborted.');
						} else {
						    alert('Uncaught Error.\n' + jqXHR.responseText);
						}
					}
				});
			}
		}
		writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
	}
};
appssctestController.prototype.AnswerClicked = function(ans)
{
	if($(ans).hasClass("selectedAns"))
	{
		$(ans).removeClass("selectedAns");
	}
	else
	{
		var parent = $(ans).parents(".Answers");
		if(parent.attr("choiceMode") == 0)
		{
			parent.find(".Answer").removeClass("selectedAns");
		}
		$(ans).addClass("selectedAns");	
	}
};
appssctestController.prototype.UpdateIndicators = function ()
{
	var stats = [0,0,0,0,0,0,0];
	var currentSection = -1;
	for(var qNo in this.meta.questions)
	{
		if(this.userActivity[qNo-1].flaged && this.userActivity[qNo-1].state == AnswerStatus.ANSWERED)
		{
			stats[AnswerStatus.ANSWEREDFLAGED]++;
		}
		else if(this.userActivity[qNo-1].flaged)
		{
			stats[AnswerStatus.FLAGED]++;
		}
		stats[this.userActivity[qNo-1].state]++;
	}
	$("#SSCTest .Legend").find(".reviewIcon").html(stats[AnswerStatus.FLAGED]);
	$("#SSCTest .Legend").find(".missedIcon").html(stats[AnswerStatus.MISSED]+stats[AnswerStatus.SKIPED]);
	$("#SSCTest .Legend").find(".review_answeredIcon").html(stats[AnswerStatus.ANSWEREDFLAGED]);
	$("#SSCTest .Legend").find(".attemptedIcon").html(stats[AnswerStatus.ANSWERED]);
};
appssctestController.prototype.SubmitTest = function(timeFinished)
{
	if(this.submited == false)
	{
		this.meta["endAt"] = new Date();
		if(!UrlMgmt.getObj().App.isOnline){
			this.meta["submitted"] = false;
		}
		writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, this.meta, function(){
			this.submited = true;
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().PopView();
				alert("Test will be auto saved whenever you connect to internet");
			}
			else{
				this.testState = testState.Submitted;
				this.parent.SetState(this.testId ,this.testState);
				this.parent.UploadTest(this.testId , this.tr2TestId, this.testState);
				this.testState = testState.Loaded;
				
				if(timeFinished){
					alert("Your test time is finished. So saving the test.");
				}
				else{
					alert("Your test has been submitted");
				}
			}
		}.bind(this));	
	}
};
appssctestController.prototype.PopulatePreSubmissionInfo = function()
{
	var stats = [0,0,0,0,0,0,0];
	for(var qNo in this.meta.questions)
	{
		if(this.userActivity[qNo-1].flaged && this.userActivity[qNo-1].state == AnswerStatus.ANSWERED)
		{
			stats[AnswerStatus.ANSWEREDFLAGED]++;
		}
		else if(this.userActivity[qNo-1].flaged)
		{
			stats[AnswerStatus.FLAGED]++;
		}
		stats[this.userActivity[qNo-1].state]++;
	}
	$("#ssctestSummary-modal .remainingTime").html($("#TimeLeft").html());
	$("#ssctestSummary-modal .unanswered").html(stats[AnswerStatus.MISSED]+stats[AnswerStatus.SKIPED]);
	$("#ssctestSummary-modal .tagged").html(stats[AnswerStatus.FLAGED]);
	$("#ssctestSummary-modal .taggedAttempted").html(stats[AnswerStatus.ANSWEREDFLAGED]);
};