var testInstance = null;

$(document).ready(function(e) {	
	//testInstance = new Test();
});

function test()
{
	
}
test.prototype.Init = function(testId, tr2TestId, state,lang, parent,languageOptions)
{
	this.meta = [];
	this.sessionID = -1;
	this.userActivity = [];
	this.ansOrder = [];
	this.startedAt = "";
	this.totalTime = "";
	this.startNewQuestionAt = "";
	this.totalMarks = 0;
	this.submited = false;
	this.paused = false;
	this.testId = testId;
	this.tr2TestId = tr2TestId;
	this.testState = state;
	this.parent = parent;
	this.testLanguage = lang;
	this.languageOptions = languageOptions;
	$('<div class="Loader"><img src="img/loader.svg"></div>').appendTo(".TestLayout");
	console.log("test");
	setTimeout(function(){this.LoadTest();}.bind(this),300);
};
test.prototype.LoadTest = function()
{
	loadExistingData({entity: "downloadtestdata", recordId: this.testId}, function(data){
		$('#testData').html($(data));
		//Load meta
		loadExistingData({entity: "testmeta", recordId: this.testId, fileErrorHandling: false}, function(data){
	 		this.meta = data;
		 	if(this.testState == testState.Loaded)
		 	{
		 		this.meta["startedAt"] = new Date();
		 		this.meta["endAt"] = null;
				this.meta["language"] = this.testLanguage; 
				this.testState = testState.Started;
		 		this.parent.SetState(this.testId ,this.testState);
		 		this.SaveQuestion(-1);
		 	}
		 	if(this.meta["endAt"] != null)
		 	{
		 		alert("This test has been already taken");
		 		this.submited = true;
		 		this.testState = testState.Submitted;
				this.parent.SetState(this.testId ,this.testState);
		 		$('.btn-back.BackFromTest').click();
		 	}
		 	this.paused = false;
		 	this.sessionID = this.meta.sessionId;
			this.PopulateTestUI();
	    }.bind(this),function (fileName, e){
	    	$(".TestLayout .Loader").remove();
	    	switch (e.code) {
		        case FileError.QUOTA_EXCEEDED_ERR:
		            alert('Storage quota exceeded');
		            break;
		        case FileError.SECURITY_ERR:
		            alert('Security error');
		            break;
		        case FileError.NOT_FOUND_ERR:
		        case FileError.INVALID_MODIFICATION_ERR:
		        case FileError.INVALID_STATE_ERR:
		           $('<div class="Loader"><h4>Could not load the test...</h4></div>').appendTo(".TestLayout");
		           break;
		        default:
		            alert('Unknown error');
		            break;
		    }
	    }.bind(this));
    }.bind(this),function (fileName, e){
    	$(".TestLayout .Loader").remove();
    	switch (e.code) {
	        case FileError.QUOTA_EXCEEDED_ERR:
	            alert('Storage quota exceeded');
	            break;
	        case FileError.SECURITY_ERR:
	            alert('Security error');
	            break;
	        case FileError.NOT_FOUND_ERR:
	        case FileError.INVALID_MODIFICATION_ERR:
	        case FileError.INVALID_STATE_ERR:
	           $('<div class="Loader"><h4>Could not load the test...</h4></div>').appendTo(".TestLayout");
	           break;
	        default:
	            alert('Unknown error');
	            break;
	    }
    }.bind(this));
};
test.prototype.PopulateTestUI = function()
{
	$('.TestLayout').empty();
	this.PopulateHeader();
	this.PopulateLeftPannel();
	this.PopulateMiddlePannel();
	this.PopulateFooterPannel();
	this.Events();
	this.ShowQuestion(1,this.testLanguage);
	this.ResizeTestScreen();
	setTimeout('$(".leftHideShowBtnDiv").trigger("click");',600);
};
test.prototype.PopulateHeader = function()
{
	if(typeof this.meta["startedAt"] == "string")
	{
		this.startedAt = Date.parse(this.meta["startedAt"]);
	}
	else
	{
		this.startedAt = this.meta["startedAt"].getTime();	
	}
	this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	this.StartTimer();
	var elem = $('<div class="switchLanguageDiv">Take Test In : <select id="switchLanguage"></select></div>');
	elem.appendTo(".TestLayout");
	for(key in this.languageOptions)
	{
		var option = $('<option value="' + this.languageOptions[key] + '">' + TestLanguageType.Str[this.languageOptions[key]] + '</option>');
		if(option.val() == this.testLanguage)
			option.attr("selected","selected");
		$("#switchLanguage").append(option);
	}
	$('#switchLanguage').change(function(e){
		this.obj.testLanguage = e.target.value;
		selectedQuestion = parseInt($("#test_Question_Number").text());
		this.obj.SwitchLeftPannel();
		this.obj.ShowQuestion(selectedQuestion, this.obj.testLanguage);
	}.bind({obj:this}));
};
test.prototype.SwitchLeftPannel = function()
{
	this.questionOrder = JSON.parse($("#_questionOrder_").text());
	for(var qNo in this.meta.questions)
	{
		var qId = this.meta.questions[qNo].questionId;
		var sQId = this.meta.questions[qNo].subQuestionId;		
		var q = this.meta.questions[qNo];
		var qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[this.testLanguage]+"']");
		if(!qDiv.length){
			qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"']:eq(0)");
		}
		$(".qTitle[qId='"+qId+"'][sQId='"+sQId+"']").find('.qTitleText').text(qDiv.find("._title_").text());
	}
};
test.prototype.PopulateLeftPannel = function()
{
	var hideLeft = $('<div class="leftHideShowBtnDiv"></div>').appendTo(".TestLayout");
	hideLeft.append('<x-icon class="leftHideShowBtn open ShowedIcon">'+arrowWIcon+'</x-icon><x-icon class="leftHideShowBtn closed">'+arrowEIcon+'</x-icon>');
	
	var div = $('<div id="QuestionPanel"></div>').appendTo(".TestLayout");
	div = $("<div class='all-sections'></div>").appendTo(div);
	
	
	
	var commonElement = '<x-icon class="qState '+ 
						AnswerStatus.Str[AnswerStatus.MISSED]+ ' ShowedIcon" state="'+AnswerStatus.MISSED+'">'+MissedIcon+'</x-icon>' + 
					'<x-icon  class="qState '+
						AnswerStatus.Str[AnswerStatus.ANSWERED] + '" state="'+AnswerStatus.ANSWERED+'">'+AnsweredIcon+'</x-icon>' + 
					'<x-icon class="qState '+
						AnswerStatus.Str[AnswerStatus.SKIPED]+'" state="'+AnswerStatus.SKIPED+'">'+SkipedIcon+'</x-icon>' +
					'<x-icon class="qState '+
						AnswerStatus.Str[AnswerStatus.FLAGED]+'" state="'+ AnswerStatus.FLAGED +'">'+FlagedIcon+'</x-icon>' ;
	
	var counter = 1;
	this.questionOrder = JSON.parse($("#_questionOrder_").text());
	className = "\"qTitle selected\"";
	
	//Populate Sections
	var sectionId = 0; 
	var qCountInSection = [];
	var marksInSection = [];
	for(s in this.questionOrder)
	{
		var section = this.questionOrder[s];
		var sDiv = $('<div class="section" sId="'+sectionId+'">'+
						'<label for="Radio_'+sectionId+'"><div class="sectionName"><span>'+section.name+
						'</span><x-icon class="toggleSectionBtn">'+toggleSectionBtn+'</x-icon></div></label>'+
						'<div class="sectionQuestions" sId="'+sectionId+'"></div>'
					+'</div>'); 
		
		var checked	= (sectionId==0)?"checked":"";	
		var radio = '<input type="radio" name="radio" '+ checked +' id="Radio_'+sectionId+'"/>';				
		div.append(radio).append(sDiv);
		qCountInSection[sectionId] = 0;
		marksInSection[sectionId] = 0;
		sectionId ++;
	}
	//Populate Questions
	for(var qNo in this.meta.questions)
	{
		var qId = this.meta.questions[qNo].questionId;
		var sQId = this.meta.questions[qNo].subQuestionId;		
		var sectionId = this.meta.questions[qNo].sectionId;
		
		var q = this.meta.questions[qNo];
		var qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[this.testLanguage]+"']");
		if(!qDiv.length){
			qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"']:eq(0)");
		}
		qCountInSection[sectionId] ++;
		var marks = parseFloat(qDiv.attr("marks"));
		this.totalMarks += marks;
		marksInSection[sectionId] += marks;
	
		var qtitle = '<div class='+className+' qNo="'+qNo+'" qId="'+qId+'" sQId="'+sQId+'">' + 
				'<span class="qIndecator">' +
				'<span class="qNo">'+qNo+'</span>' + commonElement +
				'</span><span class="qTitleText">'+qDiv.find("._title_").text() + 
				'</span>';
		if(marks)		
		  qtitle += '<span class="qMarks">'+marks+'</span>';		
				
		qtitle +='<div class="clear"></div></div>';

		className = "\"qTitle\"";
		var sDiv = $('.sectionQuestions[sId="'+sectionId+'"]');
		$(sDiv).append(qtitle);
		if(this.sessionID > 0)
		{	
			this.userActivity[qNo-1] = {ans:[], state: AnswerStatus.MISSED, questionNo:0, sQId:0, 
							timeSpent:-1, flaged:false};
			if(q.hasOwnProperty("answer") && q.answer.hasOwnProperty("ans"))
			{
				this.userActivity[qNo-1] = {ans:q.answer.ans, state: q.answer.state, questionNo:qId, 
											sQId:sQId, timeSpent:q.timeSpent, flaged:(q.flag==1)};
			}
			this.ansOrder[qNo-1] = q.meta;
		}
		else
		{
			this.userActivity[qNo-1] = null;			
			ans = $("#"+qId+"._question_ ._answer_");
			this.ansOrder[qNo-1] = [];
			ansCounter = 0;

			self = this;
			ans.each(function (){
				self.ansOrder[qNo-1][ansCounter] = $(this).attr('id');
				ansCounter ++;
			});
		}
	}
	for(s in qCountInSection)
	{
		var sNameSpan = $('.section[sId="'+s+'"] .sectionName>span');
		
		var marksInfo = qCountInSection[s]+' Questions';
		if(marksInSection[s])
		{
		      marksInfo = marksInSection[s] + ' Marks for ' +  marksInfo;
		}
		sNameSpan.append('<div class="sectionInfo">'+ marksInfo + '</div>');
	}
	
	if(this.sessionID > 0) //Updatte States
	{
		for(i = 0; i < this.userActivity.length; i++)
		{
			if(this.userActivity[i] != null)
			{
				this.ChangeQuestionState(i+1, this.userActivity[i].flaged?AnswerStatus.FLAGED:this.userActivity[i].state);
			}
		}
	}	
	MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
};
test.prototype.PopulateMiddlePannel = function()
{
	var div = $('<div id="QuestionBody"></div>').appendTo(".TestLayout");	
};
test.prototype.PopulateFooterPannel=function()
{
	var div = $('<div class="navbar navbar-default FootrNav"></div>').appendTo(".TestLayout");
	div = $('<table class="container"></table>').appendTo(div);
	div = $('<tr></tr>').appendTo(div);
	$('<td><button id="Prev" class="btn btns-common btn-sm" type="button"><div>Previous</div><div><img src="img/prev.png"></div></button></td>').appendTo(div);
	$('<td class="Flag"><button id="Flag" class="btn btn-sm" type="button"><x-icon>'+FlagedIcon+'</x-icon><div>MARK FOR REVIEW</div></button></td>').appendTo(div);
	$('<td><button id="Next" class="btn btns-common btn-sm" type="button"><div>Next</div><div><img src="img/next.png"></div></button></td>').appendTo(div);
};

test.prototype.Events=function()
{
	$(".all-sections .qTitle").unbind("click").bind("click", this, function(e){
		e.data.ShowQuestion(parseInt($(this).attr("qNo")),e.data.testLanguage);
	});
	
	$(".leftHideShowBtnDiv").unbind("click").bind("click", this, function(event){
		var left = $("#QuestionPanel").css("width");
		var speed = 300;
		if($(".leftHideShowBtn.open").hasClass("ShowedIcon"))
		{
			var left= '-'+left;
			$(".leftHideShowBtn.open").removeClass("ShowedIcon");
			$(".leftHideShowBtn.closed").addClass("ShowedIcon");
			$(".leftHideShowBtnDiv").animate({"left": '0px'}, speed);
			$("#QuestionPanel").animate({"left" : left}, speed);
		}
		else if($(".leftHideShowBtn.closed").hasClass("ShowedIcon"))
		{
			$(".leftHideShowBtn.closed").removeClass("ShowedIcon");
			$(".leftHideShowBtn.open").addClass("ShowedIcon");
			$(".leftHideShowBtnDiv").animate({"left":left}, speed);
			$("#QuestionPanel").animate({"left":0}, speed);
		}
	});
	$("#Flag").unbind("click").bind("click", this, function(e){
		var qNo = parseInt($("#test_Question_Number").text());
		if(e.data.GetCurrentState(qNo) != AnswerStatus.FLAGED)
		{
			e.data.ChangeQuestionState(qNo, AnswerStatus.FLAGED);
			$("#Flag").addClass(AnswerStatus.Str[AnswerStatus.FLAGED]);
		}
		else
		{
			$("#Flag").removeClass(AnswerStatus.Str[AnswerStatus.FLAGED]);
			e.data.ChangeQuestionState(qNo, ($("#QuestionBody .Question .Answer.selectedAns").length == 0)?
										AnswerStatus.SKIPED : AnswerStatus.ANSWERED);
		}
	});
	
	$("#Prev").unbind("click").bind("click", this, function(e){
		var qNo = parseInt($("#test_Question_Number").text()) - 1;
		var toBeDispalyed = $('#QuestionPanel .qTitle[qNo="'+qNo+'"]');
		if(toBeDispalyed.length == 1)
		{
			toBeDispalyed.click();
		}
		$(toBeDispalyed)[0].scrollIntoView();
	});
	$("#Next").unbind("click").bind("click", this, function(e){
		var qNo = parseInt($("#test_Question_Number").text()) + 1;
		var toBeDispalyed = $('#QuestionPanel .qTitle[qNo="'+qNo+'"]');
		if(toBeDispalyed.length == 1)
		{
			toBeDispalyed.click();
		}
		$(toBeDispalyed)[0].scrollIntoView();
	});
	$('#SubmitTests').unbind("click").bind("click", this, function(e){
		e.data.SavePrevQuestion(false);
		e.data.SaveQuestion(parseInt($("#test_Question_Number").text()), function(){
				state = {};
				state[AnswerStatus.SKIPED] = 0;
				state[AnswerStatus.ANSWERED] = 0;
				state[AnswerStatus.MISSED] = 0;
				state[AnswerStatus.FLAGED] = 0;
				this.userActivity.forEach(function(e){
					if(e == null)
					{
						state[AnswerStatus.MISSED]++;
					}
					else
					{
						state[e.state] ++;
					}
					if(e.flaged)
						state[AnswerStatus.FLAGED]++;
			    });
			    $("#testSummary-modal").modal("show");
				$("#testSummary-modal").find(".TS_sum .TS_sum_uans").html(state[AnswerStatus.MISSED]);
				$("#testSummary-modal").find(".TS_sum .TS_sum_ans").html(state[AnswerStatus.ANSWERED]);
				$("#testSummary-modal").find(".TS_sum .TS_sum_skp").html(state[AnswerStatus.SKIPED]);
				$("#testSummary-modal").find(".TS_sum .TS_sum_flg").html(state[AnswerStatus.FLAGED]);
		}.bind(e.data));
	});
	//resume test
	$('#testSummary-modal #TS-resumeTest').unbind("click").bind("click", this, function(e){
		 $("#testSummary-modal").modal("hide");
	});
	//submit test after confirmation
	$('#testSummary-modal #TS-submitTest').unbind("click").bind("click", this, function(e){
		$("#testSummary-modal").modal("hide");
		e.data.SubmitTest();
	});
	$('.btn-back.BackFromTest').unbind("click").bind("click", this, function(e){
		 if(!($("#testSummary-modal").hasClass('in')))
		 {
		  	app.popView();
		 } 
		 e.data.paused= true;
		 e.data.parent.RefreshTestList();		
	});
};
test.prototype.ShowQuestion = function (qNo,language)
{		
	this.SavePrevQuestion(true);
	
	this.startNewQuestionAt = new Date().getTime();

	$(".all-sections").find(".selected").removeClass("selected") ;
	$('.all-sections .qTitle[qNo="'+ qNo+'"]').addClass("selected");
	
	if(this.userActivity[qNo - 1].flaged)
	{
		$("#Flag").addClass(AnswerStatus.Str[AnswerStatus.FLAGED]);
	}else
	{
		$("#Flag").removeClass(AnswerStatus.Str[AnswerStatus.FLAGED]);
	}
	var titleDiv = $('.qTitle[qNo="'+qNo+'"]'); 	
	var qNumber = titleDiv.attr("qId");
	var sQId = titleDiv.attr("sQId");
	var qDiv = $("._question_[qId='"+qNumber+"'][sQId='"+sQId+"'][language='"+ TestLanguageType.Str[language]+"']");
	if(!qDiv.length){
		qDiv = $("._question_[qId='"+qNumber+"'][sQId='"+sQId+"']:eq(0)");
	}
	
	var qtype = qDiv.attr("qtype");
	if(typeof qtype != undefined && parseInt(qtype) == QuestionType.BLANK)
    {
    	this.ShowFillInTheBankQuestion(qDiv,qNo, qNumber, sQId);
    }
    else if(typeof qtype != undefined && parseInt(qtype) == QuestionType.NIQ){
    	this.ShowNIQQuestion(qDiv,qNo, qNumber, sQId);
    }
    else
    {
    	this.ShowMCQQuestion(qDiv, qNo, qNumber, sQId);
    }	
	this.ValidateNavigation();
	this.ShowSubQuestion();
};
test.prototype.ShowFillInTheBankQuestion = function (qDiv, sNumber, qNumber, sQId)
{
	var ques = '<div class="Question" id="'+sNumber+'" qId="'+qNumber +'" sQId="'+sQId+'">' +
			'<div class="QuestionText">'+
			'<div id="test_Question_Number" qType="'+QuestionType.BLANK+'">'+sNumber+'</div>';
	if(qDiv.attr("marks") != undefined)
	{		
		ques += '<div id="question_Marks"> Marks: '+ qDiv.attr("marks") + '</div>';
    }
    
    var parts = qDiv.find("._text_").html().split("{BLANK}");
	var entry = "";
	for(var i=0; i < parts.length; i++)
	{
		entry += parts[i];
		if(i < parts.length - 1)
		{
			entry += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
		}
	}

	var answer = "<div class=\"Answers\">";
	var ans = qDiv.find("._answer_");
    for (var i = 0; i < ans.length; i++) 
	{	
		ansClass = 	"AnswerSelect";
		answer += 	"<div class=\""+ansClass+"\">"+
					'<div class="BlankNumber">blank-'+(i+1)+'</div>'+
					$(ans[i]).html() +  
				"</div>";
	}
	answer += "</div>";
	
	ques += '<div class="text">' + entry + '</div></div>' + answer + '</div>';
	
	$("#QuestionBody").html(ques);
	
	ques = $("#QuestionBody .Answers select");
	ques.val("-1");
	if(this.userActivity[sNumber - 1] != null)
	{
		for(var i = 0; i < this.userActivity[sNumber - 1].ans.length; i++)
		{
			if(this.userActivity[sNumber - 1].ans[i] != null)
				$(ques[i]).val(this.userActivity[sNumber - 1].ans[i]);
		}
	}
	$(".AnswerSelect > select").bind( "change", this.FillInTheBalnkAnswerChanged.bind(this));		
};
test.prototype.ShowNIQQuestion = function(qDiv, sNumber, qNumber, sQId)
{
	var choiceMode = 0;
    if(qDiv.attr("choicemode") != undefined)
    {
        choiceMode = qDiv.attr("choicemode");
    }   
	answer = "<div class=\"Answers\" choiceMode=\"" + choiceMode + "\">";
	choice = 0;
	ans = qDiv.find("._answer_");
	answer += this.KeyBoardHtml();	
	answer += "</div>";
	
	var upToDecimalHtml='';
	if(qDiv.attr("upToDecimal") != undefined)
	{
		if(parseInt(qDiv.attr("upToDecimal"))!=0){
			upToDecimalHtml = '<div class="upToDecimal"><b>up to '+qDiv.attr("upToDecimal")+' decimal place</b></div>';
		}
	}  
	var ques = '<div class="Question" id="'+sNumber+'" qId="'+qNumber +'" sQId="'+sQId+'">' +
			'<div class="QuestionText">'+
			'<div id="test_Question_Number" qType="'+QuestionType.NIQ+'">'+sNumber+'</div>';
	if(qDiv.attr("marks") != undefined)
	{		
		ques += '<div id="question_Marks"> Marks: '+ qDiv.attr("marks") + '</div>';
    }
	ques += '<div class="text">' +
		 qDiv.find("._text_").html() + upToDecimalHtml +
		'</div></div>' + 
		answer + '</div>';
	$("#QuestionBody").html(ques);
	$("#QuestionBody").find(".keyboardwrite").prop( "disabled", true );
	$("#QuestionBody").find(".keyboard li").bind("click", this.CreateAnsKeyBoardHtml.bind(this));		
	$("#QuestionBody").find(".keyboardwrite").val(this.userActivity[sNumber - 1].ans[0]);
	
};
test.prototype.ShowMCQQuestion = function(qDiv, sNumber, qNumber, sQId)
{
	var choiceMode = 0;
    if(qDiv.attr("choicemode") != undefined)
    {
        choiceMode = qDiv.attr("choicemode");
    }   
	answer = "<div class=\"Answers\" choiceMode=\"" + choiceMode + "\">";
	choice = 0;
	ans = qDiv.find("._answer_");
	
	for (var i = 0; i < this.ansOrder[sNumber-1].length; i++) 
	{	
		ansClass = 	"Answer";
		if(this.userActivity[sNumber - 1] != null && this.userActivity[sNumber - 1].ans[choice])
		{
			ansClass = 	"Answer selectedAns";
		}
		answer += 	"<div class=\""+ansClass+"\">"+
				"<span class=\"AnswerText\">" + $(ans[this.ansOrder[sNumber-1][i]]).html() + "</span>"+ 
				"<span class=\"ChoiceBig\">" + String.fromCharCode(choice + 65) + "</span></div>";
				choice++;
	}
	answer += "</div>";
	
	var subQuestionIndicator = "";
	var noSQ = $(".all-sections .qTitle[qId='"+qNumber+"']").length;
	if(noSQ > 1)
	{
		var subQuestionNumber = parseInt(sQId) + 1;
		subQuestionIndicator = '<span class="subQuestionIndicator">Part ' + subQuestionNumber + " of " + noSQ + '</span>';
	}

	var ques = '<div class="Question" qNo="'+sNumber+'" qId="'+qNumber +'" sQId="'+sQId+'">' +
			'<div class="QuestionText">'+
			'<div id="test_Question_Number">'+sNumber+'</div>'+ subQuestionIndicator;
	if(qDiv.attr("marks") != undefined)
	{		
		ques += '<div id="question_Marks"> Marks: '+ qDiv.attr("marks") + '</div>';
    }
	ques += '<div class="text">' +
			 qDiv.find("._text_").html() + 
			'</div></div>' + 
			answer + '</div>';
								
	$("#QuestionBody").html(ques);
	$(".Answer").unbind( "click" ).bind( "click", this, function(e){e.data.AnswerClicked(this);});
};
test.prototype.ChangeQuestionState = function(qNo, toState)
{
	$('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState').removeClass("ShowedIcon");
	var ans = $('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState.' + AnswerStatus.Str[AnswerStatus.MISSED]);
	switch(toState)
	{
		case AnswerStatus.ANSWERED:
			ans = $('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState.' + AnswerStatus.Str[AnswerStatus.ANSWERED]);
		break;
		case AnswerStatus.SKIPED:
			ans = $('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState.' + AnswerStatus.Str[AnswerStatus.SKIPED]);
		break;
		case AnswerStatus.FLAGED:
			ans = $('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState.' + AnswerStatus.Str[AnswerStatus.FLAGED]);
		break;
	}
	ans.addClass("ShowedIcon");
};
test.prototype.GetCurrentState = function(qNo)
{
	return $('#QuestionPanel .qTitle[qNo="'+qNo+'"] .qState.ShowedIcon').attr("state");
};
test.prototype.AnswerClicked = function(ans)
{
	var qNumber = $("#test_Question_Number").text();
	if($(ans).hasClass("selectedAns"))
	{
		$(ans).removeClass("selectedAns");
		if(this.GetCurrentState(qNumber) != AnswerStatus.FLAGED
			&& $(ans).siblings(".selectedAns").length == 0)
		{
			this.ChangeQuestionState(qNumber, AnswerStatus.SKIPED);
		}
	}else
	{
		if($(ans).parent().attr("choiceMode") == 0)
		{
			$(ans).siblings().removeClass("selectedAns");
		}
		
		$(ans).addClass("selectedAns");	
		if(this.GetCurrentState(qNumber) != AnswerStatus.FLAGED)
		{
			this.ChangeQuestionState(qNumber, AnswerStatus.ANSWERED);
		}
	}
};
test.prototype.SavePrevQuestion = function(saveToDB)
{
	var prevQuestion = parseInt($("#test_Question_Number").text());
	if(prevQuestion > 0)
	{
		if( this.userActivity[prevQuestion - 1].questionNo == 0)
		{
			this.userActivity[prevQuestion - 1].questionNo = $("#QuestionBody .Question").attr("qId");
			this.userActivity[prevQuestion - 1].sQId = $("#QuestionBody .Question").attr("sQId");
		}
		
		var prevState = this.userActivity[prevQuestion - 1].state;
		var prevAns = JSON.stringify(this.userActivity[prevQuestion - 1].ans);
		var prevFlag = this.userActivity[prevQuestion - 1].flaged;
		var state = AnswerStatus.SKIPED;
		
		this.userActivity[prevQuestion - 1].flaged = $("#Flag").hasClass(AnswerStatus.Str[AnswerStatus.FLAGED]);
		
		var answered = false;
		var self = this;
		var counter = 0;	
		if($('#test_Question_Number').attr("qType") == QuestionType.BLANK)
		{
			$(".Answers select").each(function(){
				var selectVal = $(this).val(); 
				self.userActivity[prevQuestion - 1].ans[counter] = selectVal;
				if(selectVal > -1)
				{
					answered = true;
				}
				counter++;
			});
		}
		else if($("#test_Question_Number").attr("qType")==QuestionType.NIQ){
			this.userActivity[prevQuestion - 1].ans[0]=$("#QuestionBody").find(".keyboardwrite").val();
			if($("#QuestionBody").find(".keyboardwrite").val()){
				answered=true;
			}
		}		
		else
		{	
			$(".Answers .Answer").each(function(){
				hasSelectedAns =  $(this).hasClass("selectedAns");
				self.userActivity[prevQuestion - 1].ans[counter] = hasSelectedAns;
				answered |= hasSelectedAns;
				counter++;
			});
		}
		state = answered?AnswerStatus.ANSWERED:AnswerStatus.SKIPED;
		this.ChangeQuestionState(prevQuestion, this.userActivity[prevQuestion - 1].flaged?AnswerStatus.FLAGED:state);
		
		this.userActivity[prevQuestion - 1].state = state;	
		if(this.userActivity[prevQuestion - 1].timeSpent == -1)
			this.userActivity[prevQuestion - 1].timeSpent++; 
		this.userActivity[prevQuestion - 1].timeSpent += parseInt((new Date().getTime() - this.startNewQuestionAt)/1000);
		if(saveToDB && !(prevAns == JSON.stringify(this.userActivity[prevQuestion - 1].ans) 
				&& prevState == this.userActivity[prevQuestion - 1].state 
				&& prevFlag == this.userActivity[prevQuestion - 1].flaged))
		{
			this.SaveQuestion(prevQuestion);
		}	
	}
};
test.prototype.ShowSubQuestion = function ()
{
	var subQuetion = $('#QuestionBody ._subQText_').detach();
	if(subQuetion.length == 1)
	{
		subQuetion.prepend("<span><b>Q: </b></span>");
		$('#QuestionBody .QuestionText').append(subQuetion);	
		
		$('<input type="checkbox" id="ShowCommonText">'+
			'<label class="ShowCommonText" for="ShowCommonText"><x-icon class="ShowCommonTextBtn">'+toggleSectionBtn+'</x-icon></label>').insertBefore('#QuestionBody .QuestionText .text');	
	}
	
};
test.prototype.ValidateNavigation = function()
{
	var selectedQuestion = $("#QuestionPanel .selected");
	var sectionId = selectedQuestion.parent().attr("sId");
	if(!$("#Radio_"+sectionId).prop("checked"))
	{
		$("#Radio_"+sectionId).prop("checked", true);
	}
		
	var selectedQuestion = parseInt(selectedQuestion.attr("qNo"));
	var questionCount = $("#QuestionPanel .qTitle").length;
	(selectedQuestion == 1)? $("#Prev").attr("disabled", "true"):$("#Prev").removeAttr("disabled");
	(selectedQuestion == questionCount)?$("#Next").attr("disabled", "true"):$("#Next").removeAttr("disabled");
};
test.prototype.StartTimer = function() {
	if(this.paused == true || this.submited==true)
		return;
	
	var milisecond = this.totalTime - new Date().getTime() + this.startedAt;
	if(milisecond >= 0)
	{
		this.SetTime(milisecond);
	    var t = setTimeout(function(){this.StartTimer();}.bind(this),500);
	}
	else
	{
		this.SubmitTest();
	}
};
test.prototype.SetTime = function(millisecond)
{
	millisecond /= 1000;
	s = parseInt(millisecond%60);
	m = parseInt((millisecond / 60 )%60);
	h = parseInt((millisecond / (60 * 60) ) % 60);
	if(s < 0 || m < 0 || h < 0)
	{ 
	  h = 0;
	  m = 0;
	  s = 0; 
	}
	$("#test_Time").text(this.TimeStr(h) + ":" + this.TimeStr(m) + ":" + this.TimeStr(s));
	
	if($("#submitTestFrame").css('display') != 'none')
	{
		$("#timeLeftSummary").text(	$("#test_Time").text());
	}
};
test.prototype.TimeStr = function(i) {
    if (i<10) {i = "0" + i;};  // add zero in front of numbers < 10
    return i;
};

test.prototype.SaveQuestion = function(qNumber, cb)
{
	if(this.submited == false)
	{
		if(qNumber > 0)
		{
			if(!this.meta["questions"][qNumber].hasOwnProperty(answer))
			{
				this.meta["questions"][qNumber]["answer"] = {};
			}
			this.meta["questions"][qNumber]["answer"]["ans"] = this.userActivity[qNumber-1]["ans"];
			this.meta["questions"][qNumber]["answer"]["state"] = this.userActivity[qNumber-1]["state"];
			this.meta["questions"][qNumber].flag = this.userActivity[qNumber-1]["flaged"]?"1":"0";
			this.meta["questions"][qNumber]["timeSpent"] = this.userActivity[qNumber-1]["timeSpent"];
		}
		writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, this.meta, function(){if(typeof cb != 'undefined')cb();});
	}
};
test.prototype.SubmitTest = function()
{
	if(this.submited == false)
	{
		this.meta["endAt"] = new Date();
		console.log(this.meta);
		writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, this.meta, function(){
			this.submited = true;
			this.testState = testState.Submitted;
			this.parent.SetState(this.testId ,this.testState);
			this.parent.UploadTest(this.testId, this.tr2TestId, this.testState);
			this.testState = testState.Loaded;
			console.log("Your test has been submitted");
		}.bind(this));	
	}
	$('.btn-back.BackFromTest').click();
};
test.prototype.ResizeTestScreen = function()
{
	var tHeight = $('#QuestionPanel').height();
	var cHeight = 0;
	var sCount = 0;
	$('#QuestionPanel .section').each(function(){
		cHeight += $(this).height();
		sCount++;
	});
	
	var visibleSQHeight = $('#QuestionPanel .all-sections > input[type="radio"]:checked + div.section .sectionQuestions').height();
	var heightOfSectionDivs = cHeight - visibleSQHeight;  
	$('#QuestionPanel .sectionQuestions').height(tHeight - heightOfSectionDivs); 
};
test.prototype.KeyBoardHtml = function()
{
	keyBoardHtmlDis = '<div class="containerkeyboard">'+
		'<textarea class="keyboardwrite" rows="1"></textarea>'+
		'<ul class="keyboard">'+
			'<li class="symbol"><span class="off">1</span></li>'+
			'<li class="symbol"><span class="off">2</span></li>'+
			'<li class="symbol"><span class="off">3</span></li>'+
			'<li class="symbol"><span class="off">4</span></li>'+
			'<li class="symbol"><span class="off">5</span></li>'+
			'<li class="symbol"><span class="off">6</span></li>'+
			'<li class="symbol"><span class="off">7</span></li>'+
			'<li class="symbol"><span class="off">8</span></li>'+
			'<li class="symbol"><span class="off">9</span></li>'+
			'<li class="symbol"><span class="off">0</span></li>'+
			'<li class="symbol"><span class="off">.</span></li>'+
			'<li class="symbol"><span class="off">-</span></li>'+
			'<li class="delete lastitem">delete</li>'+
		'</ul>'+
	'</div>';
	return keyBoardHtmlDis;
};
test.prototype.CreateAnsKeyBoardHtml = function(event)
{	
	var Data=event.currentTarget;
	var character = $(Data).html();
	qNumber = $("#test_Question_Number").text();
	if(this.GetCurrentState(qNumber) != AnswerStatus.FLAGED)
	{
		this.ChangeQuestionState(qNumber, AnswerStatus.ANSWERED);
	}
	if ($(Data).hasClass('delete')) {
		var html = $("#QuestionBody").find(".keyboardwrite").val();
		$("#QuestionBody").find(".keyboardwrite").val(html.substr(0, html.length - 1));
		if($("#QuestionBody").find(".keyboardwrite").val().length===0){
			this.ChangeQuestionState(qNumber, AnswerStatus.SKIPED);
		}
		return false;
	}
	if ($(Data).hasClass('symbol')) character = $('span:visible', $(Data)).html();
	$("#QuestionBody").find(".keyboardwrite").val($("#QuestionBody").find(".keyboardwrite").val() + character);
	if($("#QuestionBody").find(".keyboardwrite").val().length>1){
		if(!$.isNumeric($("#QuestionBody").find(".keyboardwrite").val())){
			alert("Notice:- answer should be numeric");			
		}
	}
};
test.prototype.FillInTheBalnkAnswerChanged = function(event)
{
	var qNumber = $("#test_Question_Number").text();
	if(this.GetCurrentState(qNumber) != AnswerStatus.FLAGED)
	{
		var ans = $(".Answers select");
		var isAnswered = false;
		$(".Answers select").each(function(){
			if($(this).val() > -1)
			{
				isAnswered = true;
			}
		});
		this.ChangeQuestionState(qNumber, isAnswered?AnswerStatus.ANSWERED:AnswerStatus.SKIPED);
	}
};
