/******* AppBrowser *******/
var _appBrowser = null;
function AppBrowser()
{
	this.url = null;
	this.urlInfo = null;
	this.data = null;
	this.stack = [];
};

AppBrowser.getObj = function()
{
	if(_appBrowser === null)
	{
		_appBrowser = new AppBrowser();
	}
	return _appBrowser;
};
AppBrowser.prototype.Open = function(url)
{
	var ref = cordova.InAppBrowser.open(encodeURI(url), "_blank", "location=no");
	this.stack.push(ref);
};
AppBrowser.prototype.Close = function()
{
	this.stack[this.stack.length-1].close();
};
AppBrowser.prototype.OpenWPBlog = function(url)
{
	this.url = url;
	
	//check for relative url
	var regX = new RegExp('^(?:[a-z]+:)?//', 'i');
	if(!regX.test(this.url))
	{
		this.url =(this.url[0] == "/")? remoteServer+this.url:remoteServer+'/'+this.url;
	}
	
	if(this.url.indexOf('www.toprankers.com/exams/') > -1 && this.url.indexOf('/amp') == -1)
	{
		//open amp
		(this.url[this.url.length-1] != '/') ? this.url=this.url+'/amp/': this.url=this.url+'amp/';
	}
	
	var ref = cordova.InAppBrowser.open(encodeURI(this.url), "_blank", "location=no");
	this.stack.push(ref);
	ref.addEventListener('loadstart', function(e){
		this.url = e.url;
		if(this.url.indexOf('close-in-app-browser') > -1)
		{
			this.Close();
			return;
		}
		this.urlInfo = document.createElement('a');
		this.urlInfo.href = this.url;
		
		//tr url
		if(this.urlInfo.hostname == 'www.toprankers.com')
		{
			//blog Url
			if(this.url.indexOf('www.toprankers.com/exams/') > -1)
			{
				//open amp
				if(this.url.indexOf('/amp') == -1)
				{
					(this.url[this.url.length-1] != '/') ? this.url=this.url+'/amp/': this.url=this.url+'amp/';
					ref.executeScript({code: "window.location = '"+this.url+"';"},function(){
						console.log('redirected');
					});
				}
			}
			else
			{	//TR WEB URL
				var pathSegments = this.urlInfo.pathname.split('/');
				console.log(pathSegments);
				var urlKey = getUrlKeyFromPathSegments(pathSegments);
				if(urlKey)
				{
					console.log('urlKey',urlKey);
					tr$.ajax({
						mod: "tr2app",
						ack: "geturlaction",
						additionalParams:{
							urls: [urlKey]
						},
						successClb: function(response){
							var data = response.data;
							console.log(data);
							if(Object.keys(data).length > 0)
							{	//TR2 URL
								for(var i in data)
								{
									var action = data[i]["action"];
								}
								console.log(action);
								if(action.indexOf('common/exam') > -1)
								{
									var examId = action.split('=')[1];
									var testListId = AppBrowser.getObj().data.exams[examId]["testListId"][0];
									action = 'lists/test&id='+ testListId;
								}
								AppBrowser.getObj().Close();
								try
								{
									//TODO
									UrlMgmt.getObj().Route({route: action, needData: true, offlineAllowed: true});
									AppBrowser.getObj().Close();
								}
								catch(e)
								{
									console.error(e);
								}
								if (!(typeof window.sqlitePlugin == 'undefined' || SQLiteOps.getObj().databaseOpen == false)) {
									SQLiteOps.getObj().WriteTable("urlaction",data[i].urlKey, data[i]["action"]);
								}
							}
							else
							{	//TR1 URL
								window.open(AppBrowser.getObj().url,"_system");
								AppBrowser.getObj().Close();
							}
						},
						errorClb: function(){
							console.log("errorcallback------->");
						}
					});
				}
	
			}
		}
		else
		{	//3rd party url
			window.open(this.url,"_system");
			AppBrowser.getObj().Close();
		}
	}.bind(this));
	
	
	//inject script and  style
	ref.addEventListener('loadstop', function(e){
		var script =
			"var bckBtn = document.createElement('div');"+
			"bckBtn.innerHTML = '<a href=\"/close-in-app-browser\">X</a>';"+
			"document.body.appendChild(bckBtn);"+
			"bckBtn.className = 'bck-btn';";
			
		ref.executeScript({code: script});
		
		var style =
			".nav_container{display: none;}"+
			".bck-btn{position: fixed; top: 10px; left: 10px; background-color:rgba(0,0,0,0.3); border-radius:50%; width:23px; text-align:center;}"+
			".bck-btn a {color: #fff;}";

		ref.insertCSS({code: style});
	}.bind(this));
	
	
	function getUrlKeyFromPathSegments(pathSegments)
	{
		if(pathSegments.length > 0)
		{
			var urlKey = pathSegments.pop();
			if(urlKey != '') return urlKey;
			return getUrlKeyFromPathSegments(pathSegments);
		}
		return false;
	}
};
