var commonbookmarkController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.userInfo = null;
	this.refresh = true;
	this.dataLoadmoreflag = false;
};
 
commonbookmarkController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if (this.data != undefined && this.data.offline != undefined && this.data.offline == true) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
		//this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
	

commonbookmarkController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Bookmark', false, true, false);
	var Roptions = '<td><span class="js-bookmarkfilter" ><img src="img/filter.png"></span></td>';
	UrlMgmt.getObj().headerAction.controler.AddHeaderOptions(Roptions);
};

commonbookmarkController.prototype.OfflineInit = function() {
	Factory.getObj().LoadViewForOffline(this);
};

commonbookmarkController.prototype.OnlineInit = function() {
	if(typeof this.data.tag != "undefined" ){
		this.PopulateBookmarkQuestions();
		this.BindEvents();
	}
	
};
commonbookmarkController.prototype.BindEvents = function()
{

	var TotalPages= Math.ceil(this.data.tag.questioncount / this.data.questionPerPage);
	
	if(TotalPages > 0 && this.data.currentPage >= TotalPages)
	{

		$(this.dom).unbind().bind('scroll',this,function(e){

		});
	}
	else{

		$(this.dom).unbind().bind('scroll',this,function(e){
			if(e.data.dataLoadmoreflag == false)
			{
	            if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight) {
	             e.data.dataLoadmoreflag = true;	
	             e.data.appendData		 = true;
	             e.data.LoadMoreData();
	        	}
	        	
        	}
		});

	}
	
	$(this.dom).find(".questionData").hide();
	$(this.dom).find('.bookmark-container').find('.bookmarkDiv').unbind().bind("click",this,function(e)
	{
		if(e.isDefaultPrevented())
		{
			return;
		};
		$(".questionData").not($(this).children('.bookmark-title').next()).slideUp('fast');
		$(this).children('.bookmark-title').next().slideToggle('fast');
		var closing = $(this).children('.bookmark-title').find('span.glyphicon.glyphicon-chevron-down').length == 0;
		$(this).find('span.glyphicon.glyphicon-chevron-up').each(function(){
			$(this).parents(".bookmarkDiv").removeClass('bookmarkselected');
			$(this).removeClass('glyphicon-chevron-up');
			$(this).addClass('glyphicon-chevron-down');
			
		}); 
       
       if ($('.questionData').find('.UserActions').find(" .showSolution:contains(Show Solution) "))
       {
       		var questionDiv = $(this).find('.showSolution').closest('.questionData').find('.questiondiv');
       		$('.showSolution').html("Show Solution");
       		$('.solText').css('display', 'none');    
            $('.solution').css('display' , ' none');
            $('.showSolution').closest('.optionsdiv').find('.correctOp').removeClass('correctOption');
            $('.questiondiv').find('_columnOption_ Questionboard-body').attr('hideanswer', 'true');
            if(questionDiv.attr('qType') == QuestionType.MMQ){
	            questionDiv.find('._columnOption_.Questionboard-body').attr('hideanswer', 'true');
	            	
	         }
	         else if(questionDiv.attr('qType') == QuestionType.BLANK){
	           questionDiv.closest('.questionData').find('.QuestionOptions').attr('hideanswer', 'true');
	         }
       	}
		var questionType = $(this).find(".questiondiv").attr("qtype");
		if(questionType == QuestionType.BLANK)
			{
				var text = $(this).find(".qText").html();
				var parts = text.split("{BLANK}");
				text = "";
				var i =0 ;
				for(i=0; i < parts.length; i++)
				{
					if(i < parts.length - 1)
						{
							text += parts[i] +'<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
						}
				}
				if(text.length > 0)
				{
					$(this).find(".qText").html(text);
				}																	
			}   
		
		if(!closing)
		{
			$("#commonbookmarkController .bookmarkselected").find('span.glyphicon').removeClass('glyphicon-chevron-up');
			$("#commonbookmarkController .bookmarkselected").find('span.glyphicon').addClass('glyphicon-chevron-down');
			$("#commonbookmarkController .bookmarkselected").removeClass('bookmarkselected');
			$(this).addClass("bookmarkselected");
			$(this).children('.bookmark-title').find('span.glyphicon').removeClass('glyphicon-chevron-down');
			$(this).children('.bookmark-title').find('span.glyphicon').addClass('glyphicon-chevron-up'); 
		}
    });
    $(this.dom).find('.showSolution').unbind().bind("click",this,function(e) {
    	e.preventDefault();
        var solution = $(this).closest('.optionsdiv').find('.solution');
        var questionDiv = $(this).closest('.questionData').find('.questiondiv');
        if ($(solution).is(":hidden")) {
            $(this).html("Hide Solution");
            $('.solText').css('display', 'block');
            $(this).closest('.optionsdiv').find('.correctOp').addClass('correctOption');
            $(solution).find("span.MathJax,span.MathJax_SVG").each(function() {
                $(this).css({
                    'max-width': wPanelGroup - 50 + 'px',
                    display: 'inline-block'
                });
            });
	            if(questionDiv.attr('qType') == QuestionType.MMQ){
	            	questionDiv.find('._columnOption_.Questionboard-body').attr('hideanswer', 'false');
	            	
	            }
	            else if(questionDiv.attr('qType') == QuestionType.BLANK){
	            	questionDiv.closest('.questionData').find('.QuestionOptions').attr('hideanswer', 'false');
	          	  }
          }  
          else if ($(solution).is(":visible")){
            $(this).html("Show Solution");
            $(this).closest('.optionsdiv').find('.correctOp').removeClass('correctOption');
            if(questionDiv.attr('qType') == QuestionType.MMQ){
	            questionDiv.find('._columnOption_.Questionboard-body').attr('hideanswer', 'true');
	            	
	         }
	         else if(questionDiv.attr('qType') == QuestionType.BLANK){
	           questionDiv.closest('.questionData').find('.QuestionOptions').attr('hideanswer', 'true');
	         }
          }   
        $(solution).slideToggle();
    });    
    $('.js-bookmarkfilter').unbind().bind('click',this,function(e){
    	var filterhtml = '';
    	var filter_is_empty = true;
    	filterhtml += '<div class="bookmarkfilter">';
    	for (var bookmarkid in e.data.data.tag.bookmarks) 
		{
			filter_is_empty = false;
			filterhtml +=   '<div class="js-filtername_div">'+
								'<span class="filtername"><span>'+e.data.data.tag.bookmarks[bookmarkid]+'</span></span>'+
								'<label class="switch">'+
									'<input type="checkbox" value="'+bookmarkid+'" class="bookmarkfilterCheckbox ">'+
								'</label>'+
								'<img class="selectedfiltername" src="img/batchlist_filter_tick.png">'+
							'</div>';	
		}
		filterhtml += '</div>';
		if(filter_is_empty){
		 	alert("There is no Bookmark Filter");
		 	return;
		 }	
		$('#bookmarkFilter').find('.Filteroption').html(filterhtml); 
		
		
		 for (var x in e.data.data.activeFilters){
			$("#bookmarkFilter .js-filtername_div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').prop( "checked", true );
			$("#bookmarkFilter .js-filtername_div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').parents().siblings(".filtername").addClass("selectebookmarkfilter");	
			$("#bookmarkFilter .js-filtername_div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').parents().siblings(".filtername").addClass("textbold");
			$("#bookmarkFilter .js-filtername_div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').parents().siblings(".selectedfiltername").toggleClass("displayimg");
		 }
		 
		$('#bookmarkFilter').modal('show');			
		$(".js-filtername_div").unbind().bind('click',this,function(e){
			$(this).find('.selectedfiltername').toggleClass("displayimg");
			//$(this).find('.switch .quizfilterCheckbox').click();
			$(this).find('.switch .bookmarkfilterCheckbox').is(":checked") ? $(this).find('.switch .bookmarkfilterCheckbox').prop( "checked", false ):$(this).find('.switch .bookmarkfilterCheckbox').prop( "checked", true );
			$(this).find('.switch .bookmarkfilterCheckbox').is(":checked") ? $(this).find(".filtername").addClass("selectebookmarkfilter") : 				
			$(this).find(".filtername").removeClass("selectebookmarkfilter");
		});	
		$(".js-bookmark_filter").unbind().bind('click',this,function(e){
				var checkboxes = $("#bookmarkFilter .js-filtername_div .switch").find('input[type=checkbox]');
				var filters = [];
				$(checkboxes).each(function(key, value) {
					if ($(value).prop('checked') == true) {
						filters.push($(value).val()); //+'_'+$(value).attr('filter-groupid')
					}
				});
				//var route_url= encodeURIComponent('lists/batch&id='+courselistid+'&filter='+filters.join(','));
				var filter = encodeURIComponent(filters.join(','));
				$('#bookmarkFilter').modal('hide');
				var urlMgmt = UrlMgmt.getObj();
				if(filters.length > 0)
				{ //&page='+courselistid+'
					urlMgmt.Route({route: 'common/bookmark&bookmarkId='+filter, needData: true}, function(){
						urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
					});
				}
				else
				{
					$('.js-bookmark_filter_reset').click();
				}
 
			});
		$('.js-bookmark_filter_reset').unbind().bind('click',this,function(e){
			var route_url= 'common/bookmark' ;
			var checkboxes = $("#bookmarkFilter .js-filtername_div .switch").find('input[type=checkbox]');
			var filters = [];
			$(checkboxes).each(function(key, value) {
				$(value).prop("checked", false);
			});					
			$('#bookmarkFilter').modal('hide');
			var urlMgmt = UrlMgmt.getObj();
			urlMgmt.Route({route: route_url, needData: true}, function(){
				urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
			});
		});					
    });

	if(typeof this.data.activeFilters != 'undefined' && Object.keys(this.data.activeFilters).length > 0){
		var html = "<sup>("+Object.keys(this.data.activeFilters).length+")</sup>";
		$('.js-bookmarkfilter sup').remove();
		$('.js-bookmarkfilter').append(html);
	}
	else{
		var html = "<sup></sup>";
		$('.js-bookmarkfilter sup').remove();
		$('.js-bookmarkfilter').append(html);
		
		var checkboxes = $("#bookmarkFilter .js-filtername_div .switch").find('input[type=checkbox]');
		$(checkboxes).each(function(key, value) {
				$(value).prop("checked", false);
			});
	}

};


commonbookmarkController.prototype.PopulateBookmarkQuestions = function()
{
	
		var bookmarkDatahtml= '';
			if(parseInt(this.data.tag.questioncount) > 0)
			{
				for (var questionSection in this.data.tag.questions) 
				{
					for(var questionNo in this.data.tag.questions[questionSection])
					{
						var qitem = this.data.tag.questions[questionSection][questionNo];
						
							if(typeof qitem.QuestionData != "undefined")
							{
								bookmarkDatahtml += '<div class="bookmark-view bookmarkDiv " >'+
														'<div class="bookmark-title" data-toggle="collapse" >'+
															'<span class="questionTitle">'+qitem.QuestionData.title+'</span>'+
															'<span class="glyphicon icon glyphicon-chevron-down"></span>'+
														'</div>'+
														'<div class="questionData">'+
												   			'<div class="questiondiv" qtype="'+qitem.qType+'">';
												   				if(parseInt(qitem.qType) == QuestionType.BLANK)
																{
								bookmarkDatahtml +=					'<div class="qText">'+qitem.QuestionData.question+'</div>';
																}
																else{
								bookmarkDatahtml +=						qitem.QuestionData.question ;
																}
																
																if(parseInt(qitem.qType) == QuestionType.MMQ)
																{
								bookmarkDatahtml +=				'<div class="_columnOption_ Questionboard-body" hideanswer="true">'+
																	'<table>'+
																		'<tr><td>Column I</td><td>Column II</td></tr>';
																		var colILenght = qitem.QuestionData.columnIoption.length;
																		var colIalphebet = ['A','B','C','D','E','F','G','H','I','J','K'];
																		
																		var colIILenght = qitem.QuestionData.columnIIoption.length;
																		var colIIalphebet = ['P','Q','R','S','T','U','V','W','X','Y','Z'];
																		
																		for( key in ((colILenght > colIILenght)?qitem.QuestionData.columnIoption:qitem.QuestionData.columnIIoption))
																		{ //key, value
								bookmarkDatahtml +=							'<tr>'+
																				'<td >';
																					if( typeof qitem.QuestionData.columnIoption[key] != "undefined" && typeof qitem.QuestionData.columnIoption[key].text != "undefined" )
																					{
								bookmarkDatahtml +=										'<div class="option-holder">'+
																							'<span class="optionIndicator">'+colIalphebet[key]+'</span>'+
																							'<span class="option">'+qitem.QuestionData.columnIoption[key].text+'</span>'+
																						'</div>';
																					}
								bookmarkDatahtml += 							'</td>'+
																				'<td class='+((typeof qitem.QuestionData.columnIoption[key] != "undefined" && qitem.QuestionData.columnIoption[key].text)?"correctOption":"")+'>';
																					if( qitem.QuestionData.columnIIoption[key].text )
																					{
								bookmarkDatahtml +=										'<div class="option-holder">'+
																							'<span class="optionIndicator">'+colIIalphebet[key]+'</span>'+
																							'<span class="option">'+qitem.QuestionData.columnIIoption[key].text+'</span>'+
																						'</div>';
																					}
								bookmarkDatahtml +=								'</td>'+
																			'</tr>';
																		}
								bookmarkDatahtml +=					'</table>'+
																	'<table class="matrixTable">'+
																		'<tr>'+
																		'<td></td>';
																		for (var key in ((colILenght > colIILenght)?qitem.QuestionData.columnIoption:qitem.QuestionData.columnIIoption))
																		{
								bookmarkDatahtml +=							'<td>'+colIIalphebet[key]+'</td>';
																		}
								bookmarkDatahtml +=						'</tr>';
																		for (key in ((colILenght < colIILenght)?qitem.QuestionData.columnIoption:qitem.QuestionData.columnIIoption))
																		{
								bookmarkDatahtml +=							'<tr class="optionRow">'+
																				'<td>'+colIalphebet[key]+'</td>';
																				
																				for( key1 in (colILenght > colIILenght)?qitem.QuestionData.columnIoption:qitem.QuestionData.columnIIoption )
																				{
																					var  classsName = (qitem.correctOption[key][key1])?'correctOption optionMark':'optionMark' ;
																					
								bookmarkDatahtml +=									'<td><span class="'+classsName+'"></span></td>';
																				} 
								bookmarkDatahtml += 						'</tr>';
																		}
								bookmarkDatahtml +=					'</table>'+
																'</div>';						
																}
								bookmarkDatahtml +=				'</div>';
								bookmarkDatahtml += 			'<div class="optionsdiv">';
																	if(qitem.qType == QuestionType.BLANK)
																	{
								bookmarkDatahtml +=					'<div class="QuestionOptions" hideanswer="true">'+
																		'<div class="qReviewHRaw">';
																		for (key in qitem.QuestionData.answers )
																		{
								bookmarkDatahtml +=							'<div class="qReviewHCell answerText">'+
																				'<div class="BlankOptionIndicator" data-attribute="blank-'+(key+1)+'">blank-'+(key+1)+'</div>';
																				for( key1 in qitem.QuestionData.answers[key] )
																				{
																					if( qitem.correctOption[key] == key1)
																					{
								bookmarkDatahtml +=										'<div class="blankOption " correct="true">'+
																							'<span>'+qitem.QuestionData.answers[key][key1].text+'</span>'+
																						'</div>';
																		
																					}
																					else
																					{
								bookmarkDatahtml +=										'<div class="blankOption" correct="false">'+
																							'<span>'+qitem.QuestionData.answers[key][key1].text+'</span>'+
																						'</div>';
																					}
																				}
								bookmarkDatahtml +=							'</div>';
																		}
								bookmarkDatahtml +=						'</div>'+
																	'</div>';
																	}
																	else
																	{
																	    var optionalphebet = ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'];
																		var optionsIndex   = 0;	
																							   			for(var answerOption in qitem.QuestionData.answers )
																							   			{
																		    bookmarkDatahtml +=				'<div class="option_div '+ (qitem.correctOption[optionsIndex]== 1 ? "correctOp":"" )+' ">'+
																		    									'<div class="optionindex">'+optionalphebet[optionsIndex]+'</div>'+
																												'<div class="optons">'+qitem.QuestionData.answers[answerOption].text+'</div>'+
																											'</div>';
																											optionsIndex++;
																						   				}
												   					}
									bookmarkDatahtml +=			'<div class="UserActions" >'+    
															   		'<a class="btn btn-primary showSolution">Show Solution</a>'+
													   			'</div>'+
													   			'<div class="solution">';
													   					if(qitem.qType == QuestionType.NIQ)
													   					{
									bookmarkDatahtml +=				   		'<span class="NIQSol">The correct answer is '+
																				'<span>'+qitem.correctOption[0]+'</span> ';
																				if (qitem.correctOption[1] > 0 )
																				{
									bookmarkDatahtml +=								'<span>&#177; </span><span>'+qitem.correctOption[1]+'</span>';
																				}
																				if(qitem.solution.length > 0)
																				{
									bookmarkDatahtml +=								'<div>'+qitem.solution+'</div>';
																				}
									bookmarkDatahtml +=						'<span>';					
													   					}
													   					else if(qitem.solution.length == 0)
													   					{
									bookmarkDatahtml +=				   		'<span class="solText" style="display:none">No Solution</span>';
													   					}
													   					else{
									bookmarkDatahtml +=				   						qitem.solution; 
													   					}
													   					
									bookmarkDatahtml += 		'</div>'+
															'</div>'+
									   					'</div>'+
									   				'</div>';
						}	   
					}
			
				}
			}
			else if(parseInt(this.data.tag.questioncount) == 0)
			{
				bookmarkDatahtml += 	'<div class="shared-space">'+
											'<div class="shared-txt">'+
												'Hey, You have not bookmarked any question!' + 
											'</div>'+
										'</div>';
			}
		
		$(this.dom).find(".bookmark-container").append(((bookmarkDatahtml).replace(/\/attachment.php/g, remoteServer+"/attachment.php")).replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$"));
		MathJax.Hub.Queue(["Typeset", MathJax.Hub]);  
};
commonbookmarkController.prototype.LoadMoreData = function() {
	var externalthis = this;
	var buttonhtml = "<div class='loadquestions ' style='text-align: center;'><img src='img/refresh.svg' alt='refreshing' style='height:30px;width:30px;background-color:white;border-radius:50%;'/></div>";

 	$(this.dom).find('.bookmark-container').append(buttonhtml);	

	var checkboxes = $("#bookmarkFilter .js-filtername_div .switch").find('input[type=checkbox]');
	var filters = [];
			$(checkboxes).each(function(key, value) {
				if ($(value).prop('checked') == true) {
					filters.push($(value).val());
				}
			});	
    var filter = encodeURIComponent(filters.join(','));
    if(filters.length > 0)
	{
		UrlMgmt.getObj().Route({route:'common/bookmark&page='+(this.data.currentPage+1)+'&bookmarkId='+filter, needData: true, terminate: true},function(data){
			this.data = data.controler.data;
			$(this.dom).find('.bookmark-container').find('.loadquestions').remove();			
			this.PopulateBookmarkQuestions();
			this.BindEvents();			
			this.dataLoadmoreflag = false;
			UrlMgmt.getObj().removeLoader();
		}.bind(this));
	}
	else{
		UrlMgmt.getObj().Route({route:'common/bookmark&page='+(this.data.currentPage+1)+'', needData: true, terminate: true},function(data){
				this.data = data.controler.data;
				$(this.dom).find('.bookmark-container').find('.loadquestions').remove();			
				this.PopulateBookmarkQuestions();
				this.BindEvents();			
				this.dataLoadmoreflag = false;
				UrlMgmt.getObj().removeLoader();
		}.bind(this));
	}
	
};