/**** Checkout ****/
var commoncheckoutController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;

	this.txId = null;
	this.transaction = null;
	this.applyCouponInprogress == false;
	this.purchaseInprogress = false;
	this.txnBrowserForceExit = false; 	//if payment browser  window is closed forcefully
	this.txnStatusCounter = 0; 		//check transaction counter
	this.pkgExploreId = 0;
};
commoncheckoutController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
		this.OfflineInit();
	}
	else{
		this.OnlineInit();
	}
	this.GetPackageExploreId();
	urlMgmt.removeLoader();
};
commoncheckoutController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Checkout', false, true, false);
};
commoncheckoutController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);
};
commoncheckoutController.prototype.OnlineInit = function()
{
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		$('#purchaseredirect-modal').modal("show");
		$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
		UrlMgmt.getObj().PopView();
	}
	else
	{
		this.PopulateUI();
		this.BindEvents();
		var key = typeof this.id != 'undefined' ? this.id : '';
		if(typeof webengage != 'undefined' && webengage == true){
			TRTracker.getObj().TrackWEEvent("PageView_CheckOut", key);
		}
		analytics_trackView('Checkout');
		analytics_trackEvent('Checkout','/'+key);
	}		
	
};
commoncheckoutController.prototype.GetPackageExploreId = function()
{
	var urlMgmt = UrlMgmt.getObj();
	var route = urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route;
	var actionSegments = route.split('&');
	for(var action in actionSegments){
		var key = actionSegments[action].split('=')[0];
		if(key == 'pkgexploreid'){
			if(actionSegments[action].split('=')[1] > 0)
				this.pkgExploreId = actionSegments[action].split('=')[1];
		}
	}
};
commoncheckoutController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
commoncheckoutController.prototype.BindEvents = function()
{
	this.dom.find('._eventListener').unbind().bind('click',this,function(e){
		UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true});
	});

	this.dom.find('div.TextDark .well .CouponDiv input').bind('click',this,function(e){
		if($(e.data.dom).find('.Address-details').length > 0)
		{
			var r = document.querySelector('#commoncheckoutController .ItemInfo');
			var p = r.querySelector('.Address-details.checkout');
			$(e.data.dom).animate({
				scrollTop : parseInt( p.getElementsByClassName('fieldDiv')[0].offsetTop) + 400
			}, 1000);
		}
		else
		{
			var r = document.querySelector('#commoncheckoutController .ItemInfo');
			var p = r.querySelector('div.TextDark .well');
			$(e.data.dom).animate({
				scrollTop : parseInt( p.getElementsByClassName('CouponDiv')[0].offsetTop)
			}, 1000);
		}
	});

	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	
		this.dom.find('.js-checkout').html("More");
	}
	else
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
			var urlMgmt = UrlMgmt.getObj();
			var action = urlMgmt.actionStack[urlMgmt.actionStack.length - 1];
			if(action.view.hasClass('controller-commoncheckoutController')){
				urlMgmt.PopView(function(){
					urlMgmt.Route({route: $(e.currentTarget).data('action'), needData: true, offlineAllowed: false});
				});
			}
			else{
				urlMgmt.Route({route: $(this).data('action'), needData: true, offlineAllowed: false});
			}
		});		
	}

    this.dom.find(".buyItem").unbind().bind("click",this,function(e){
    	
		if( typeof e.data.data.buyFrom != "undefined" && e.data.data.buyFrom != "" && e.data.data.buyFrom != null)
	    {
	   		URLRedirection(e.data.data.buyFrom);
	   		return;
	    }
    	 if(typeof e.data.data.addressSectionId != "undefined" && jQuery.isEmptyObject(e.data.data.address.values))
    	 {
    	 	alert("Updating the users address is mandatory");
    	 	var r = document.querySelector('#commoncheckoutController .ItemInfo');
			var p = r.querySelector('.Address-details.checkout');
			$(e.data.dom).animate({
				scrollTop : parseInt( p.getElementsByClassName('fieldDiv')[0].offsetTop)
			}, 1000);
    	 	return;
    	 }		 
		 if ($(e.data.dom).find('.GatewayInfo a.InitiatePayment').length > 0) {
    		$($(e.data.dom).find('.GatewayInfo a.InitiatePayment')[0]).click();
  		 } else if ($(".GatewayInfo").length > 0) {
    			e.data.dom.animate({scrollTop: $(".GatewayInfo").offset().top - 60}, 1000);
  		 }
		 e.data.dom.animate({scrollTop: $(".GatewayInfo").offset().top - 60}, 1000);
	});

	this.dom.find('.InitiatePayment').unbind().bind("click", this,function(e){
		if(typeof e.data.data.addressSectionId != "undefined" && jQuery.isEmptyObject(e.data.data.address.values))
    	 {
    	 	alert("Updating the users address is mandatory");
    	 	var r = document.querySelector('#commoncheckoutController .ItemInfo');
			var p = r.querySelector('.Address-details.checkout');
			$(e.data.dom).animate({
				scrollTop : parseInt( p.getElementsByClassName('fieldDiv')[0].offsetTop)
			}, 1000);
    	 	return;
    	 }		
		e.data.Buy({
  			itemId: e.target.dataset.itemid,
  			coupon:e.target.dataset.coupon,
  			redirect:'payment-complete-in-app',
  			gateway:e.target.dataset.gateway,
  			coupon:$('.ApplyCouponBtn').attr("data-coupon-code")
		});
	});

	this.dom.find('.ApplyCouponBtn').unbind().bind('click', this,function(e){
		if(typeof e.data.data.addressSectionId != "undefined" && jQuery.isEmptyObject(e.data.data.address.values))
    	 {
    	 	alert("Updating the users address is mandatory");
    	 	var r = document.querySelector('#commoncheckoutController .ItemInfo');
			var p = r.querySelector('.ItemInfo .Address-details.checkout');
			$(e.data.dom).animate({
				scrollTop : parseInt( p.getElementsByClassName('fieldDiv')[0].offsetTop)
			}, 1000);
    	 	return;
    	 }		
		e.data.dom.find(".CouponApplyStatusStatus").html("");
		e.data.dom.find('.ApplyCouponBtn').attr("data-coupon-code", "");
		e.data.dom.find('tr.CouponDiscount td:first-child').html("Discount from Coupon Code");
		e.data.dom.find('tr.CouponDiscount td:last-child').html("Rs 0");

		e.data.dom.find('tr.GrandTotal td:last-child').html($('tr.GrandTotal').attr("data-cost"));

		var coupon = e.data.dom.find(".CouponDiv input").val();
		if(coupon.length == 0)
		{
			e.data.dom.find(".CouponDiv .CouponApplyStatusStatus").html('<div class="errorMsg">Coupon Code cannot be empty!</div>');
			return;
		}
		var itemId = e.target.dataset.itemid;
		e.data.ApplyCoupon({
  			itemId: itemId,
  			coupon: coupon,
  			callback:function(data){
  				if(data.result.state != "ok")
  				{
  					e.data.dom.find(".CouponDiv .CouponApplyStatusStatus").html('<div class="errorMsg">'+data.result.meta+'</div>');
  				}
  				else if(data.data.state == true)
  				{
  					e.data.dom.find(".CouponDiv .CouponApplyStatusStatus").html('<div class="successMsg">Coupon Code applied successfully!</div>');
  					e.data.dom.find('.ApplyCouponBtn').attr("data-coupon-code", e.data.dom.find(".CouponDiv input").val());
  					e.data.dom.find('tr.CouponDiscount td:first-child').html("Coupon Applied ("+e.data.dom.find(".CouponDiv input").val()+")");
					e.data.dom.find('tr.CouponDiscount td:last-child').html("Rs "+data.data.discount.amount+(data.data.discount.cashback == true?" (CashBack)":""));
					e.data.dom.find('tr.GrandTotal td:last-child').html("Rs "+ data.data.discount.new_cost);
  				}
  				else
  				{
  					e.data.dom.find(".CouponDiv .CouponApplyStatusStatus").html('<div class="errorMsg">'+data.data.msg+'</div>');
  				}

  			}
		});
	});
	$(".UpdateAddress").unbind().bind("click", this, function(e){
		if($(this).text() == 'Edit Address')
		{
			$(e.data.dom).find('.Address-details').find(".fieldDiv").each(function(){
				$(this).find('.edit_disabled').removeClass("edit_disabled");
			});
			$(this).text('Save Address');
		}
		else
		{
			Factory.getObj().UpdateAddress({
			  sectionId: parseInt(e.data.data["addressSectionId"]),
			  dom : e.data.dom,
			});
		}
	});
	this.dom.find('.TermsandConditiondiv .TermsandConditionlink').unbind().bind('click', this,function(e){
		e.preventDefault();
		UrlMgmt.getObj().Route({route: 'app/termsandconditions', needData: false, offlineAllowed: false});
	});
};
commoncheckoutController.prototype.PopulateUI = function()
{
	var buyFrom_meta = typeof this.data.buyFrom == "undefined" || 
					   (typeof this.data.buyFrom != "undefined" && this.data.buyFrom == "")||
			           (typeof this.data.buyFrom != "undefined" && this.data.buyFrom == null);
	var html = '';

		validurl = true;

		cost = (typeof this.data.priceInfo.cost !== 'undefined' && parseFloat(this.data.priceInfo.cost) !== NaN)?parseFloat(this.data.priceInfo.cost) : 0;

		canBuy = (cost > 0);

	var itemInCart = this.data.item != undefined ? 1 : 0;
	if(this.data.item || this.data.ownerPackages || (this.data.suggestedpcount && this.data.suggestedpcount > 0)){
		html +=
			'<div class=" ItemInfo">';
		if(canBuy && (this.data.expired == undefined || this.data.expired == 0) && itemInCart == 1){
			html +=
				'<div class="col-lg-12 col-sm-12 TextDark">'+
					'<h3><span class="prodinfo" id="one1">Product in Cart: <span class ="prodinfo" id="two2">'+this.data.item.title+'</span></span></h3>';

			(this.data.item.itemType == "package")?
			html += '<p>Package ID - '+this.data.item.id+' </p>':
			html += '<p>Item ID - '+this.data.item.id+'</p>';

		if(typeof this.data.priceInfo.validTill !== 'undefined' && this.data.priceInfo.validTill)
		{
			html += '<p>Expires On: '+tr$.dateFormat(this.data.priceInfo.validTill)+'</p>';
		}
		html += '<p id="border1"></p>';
		if(typeof this.data.addressSectionId != "undefined" && typeof this.data.address != "undefined")
		{
			var profileDetails = '';
			profileDetails  +=    '<div class="Address-details checkout">';
								  		for(field in this.data.address.fields)
								  		{
			profileDetails  +=	  			'<div class="fieldDiv" data-fieldId="'+this.data.address.fields[field].id+'" data-typeId="'+this.data.address.fields[field].typeId+'" isRequired = "'+this.data.address.fields[field].isRequired+'">'+
											'<label for = "userProfile_'+this.data.address.fields[field].id+'">'+this.data.address.fields[field].text+': </label>';
											if(this.data.address.fields[field].typeId == "4")
											{
			profileDetails  += 					'<select id="userProfile_'+this.data.address.fields[field].id+'" data-typeId="'+this.data.address.fields[field].typeId+'"'+
												((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? 'class="edit_disabled"' : "" )+'>'+
													'<option value="-1" >Select</option>';
														for(enumValid in this.data.address.fieldValues[this.data.address.fields[field].id])
														{
			profileDetails  +=								'<option value="'+this.data.address.fieldValues[this.data.address.fields[field].id][enumValid]+'"'+
															((this.data.address.values[this.data.address.fields[field].id] == this.data.address.fieldValues[this.data.address.fields[field].id][enumValid])?'selected': '')+'>'+enumValid+'</option>';
														}
			profileDetails  +=					'</select>'+
												'<div class="ErrorMsg"></div>';									
											}
											else
											{
			profileDetails  +=					'<input id="userProfile_'+this.data.address.fields[field].id+'" value="'+
												((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? this.data.address.values[this.data.address.fields[field].id] : "" )+'"'+
												((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? 'class="edit_disabled"' : "" )+' type="text" data-typeId="'+this.data.address.fields[field].typeId+'"/>'+
												'<div class="ErrorMsg"></div>';				
											}
			profileDetails  +=				'</div>';				
								  		}
			profileDetails  +=			'<div class="UpdateAddressdiv"><a class="btn btn-primary UpdateAddress" >'+(((typeof this.data.address.values != "undefined")&&(!jQuery.isEmptyObject(this.data.address.values)))?'Edit Address':'Save Address')+'</a></div>'; 		  		
			profileDetails  +=	  '</div>';	
			html +=	profileDetails;					  	
		}
		if(typeof this.data.priceInfo.reverted !== 'undefined' &&
			this.data.priceInfo.reverted == 0 &&
			typeof this.data.priceInfo.unlockValidity !== 'undefined' &&
			((this.data.priceInfo.unlockValidity != null &&
			new Date(this.data.priceInfo.unlockValidity) > new Date()) || (this.data.priceInfo.unlockValidity == null)))
		{
			canBuy = false;
			html += '<h2 class="TextDark container">You have already purchased this '+this.data.item.itemType+'</h2>';
		}

		html +=
			'<div class="col-lg-5 col-sm-6 well">'+
				'<h3> <span id="pricep"> Price Details </h3>'+
				'<table class="CostInfo">';
			var mrp = (typeof this.data.item.mrp !== 'undefined' && parseFloat(this.data.item.mrp) !== NaN ) ? parseFloat(this.data.item.mrp): 0;
			if(mrp > 0  && mrp < cost)
			{
				html +=
					'<tr>'+
						'<td class="TextDark">Price:</td>'+
						'<td class="TextDark">Rs. '+mrp+'</td>'+
					'</tr>'+
					'<tr>'+
						'<td>Discount:</td>'+
						'<td><span class="TextHeilight">- Rs.'+(mrp-cost)+' ('+(Math.round(100 - (100 * (cost/mrp))),2)+'%)</span></td>'+
					'</tr>'+
					'<tr>';
					if( buyFrom_meta )
			        {  
				html +=	'<td class="TextDark">Sub-Total:</td>'+
						'<td class="TextDark">Rs. '+cost+'</td>';
					}
					else
					{
				html +=	'<td class="TextDark">Total Payable:</td>'+
						'<td class="TextDark">Rs. '+cost+'</td>';						
					}	
			html +=	'</tr>';
			}
			else
			{
				html +=
					'<tr>'+
						'<td class="TextDark">Price:</td>'+
						'<td class="TextDark">Rs. '+cost+'</td>'+
					'</tr>';
			}
			
			if(buyFrom_meta)
			{
				if(this.data.item.itemType == "package")
				{
					var upgradationDiscount = (typeof this.data.priceInfo.upgradationDiscount !== 'undefined' && parseFloat(this.data.priceInfo.upgradationDiscount) !== NaN)?
													parseFloat(this.data.priceInfo.upgradationDiscount) : 0;
					html +=
						'<tr>'+
							'<td>Package Upgradation Discount:</td>'+
							'<td><span class="TextHeilight">'+(upgradationDiscount > 0 ? '-': '')+' Rs. '+upgradationDiscount+'</span></td>'+
						'</tr>'+
						'<tr class="CouponDiscount">'+
								'<td>Discount from Coupon:</td>'+
								'<td class="TextHeilight"> Rs. 0</td>'+
						'</tr>';
				}
				var AccountBalance = (typeof this.data.ecomm.account !== 'undefined' &&
										typeof this.data.ecomm.account.balance !== 'undefined' &&
										parseFloat(this.data.ecomm.account.balance) !== NaN)?
										parseFloat(this.data.ecomm.account.balance) : 0;
				html +=
					'<trclass="WalletBalance" data-walletbal="'+AccountBalance+'">'+
					   ' <td> Wallet Balance: </td>';
				if(LoggedInUser.Auth())
				{
					html +=
						'<td> Rs. <span class="TextDark">'+AccountBalance+'</span> </td>';
				}
				else
				{
					html +=
						'<td> <span class="TextDark"> -- </span> </td>';
				}
				html +=
					'</tr>'+
					'<tr class="GrandTotal" data-cost="Rs '+ Math.max(parseFloat(this.data.priceInfo.finalPrice)- AccountBalance,0) +'">'+
						'<td class="TextDark">Total Payable:</td>'+
						'<td class="TextDark">Rs. '+ Math.max(parseFloat(this.data.priceInfo.finalPrice)- AccountBalance, 0) +'</td>'+
					'</tr>'+
				'</table>';
				if(validurl == true && this.data.item.itemType == "package")
				{
					html +=
						'<div class="CouponDiv">'+
							'<input type="text" placeholder="Enter your coupon here" class="TextDark"/><a class="ApplyCouponBtn btn btn-primary" data-ItemId="'+this.data.item.id+'" data-coupon-code="">Apply Coupon</a>'+
							'<div class="CouponApplyStatusStatus"></div>'+
						'</div>';
				}
			}
			else
			{
				html += '</table>';
			}
			
			if(typeof this.data.paymentTerms != 'undefined' && this.data.paymentTerms.length > 5)
			{
				html +=
				'<div class="TermsandConditiondiv">Please Read <a class="TermsandConditionlink" href="'+this.data.paymentTerms+'">Terms and Conditions</a> before making the payment.</div>';
			}
			if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 0)
			{
				html += '<div class="paymentpolocies_div"><span>This content can be consumed on our website as well.</span></div>';
			}
			html +=
				'<div class="text-center"><a class="buyItem btn btn-primary" data-ItemId="'+this.data.item.id+'" > Buy </a></div>'+
			'</div>';
		}
		html +=
		'</div>';

		if((this.data.packagePlanCount && this.data.packagePlanCount.packages > 0) || (this.data.packagePlanCount && this.data.packagePlanCount.plans > 0) || this.data.suggestedpcount > 0){
			html += '<div class="PackageContainer container" id="PlansAndPackages">';
			if(canBuy && this.data.expired == 0 && this.data.item && this.data.item.itemtype && this.data.item.itemType == "package"){
				html += '<div class = "TextDark"><h2>Related Plans &amp; Packages</h2></div>';
			}
			else if(canBuy && this.data.expired == 1){
				html += '<div class = "TextDark"><h2>Sorry this Package has expired! Explore similar packages below:</h2></div>';
			}
			else{
				html += '<div class = "TextDark"><h2 >Buy one of these packages to avail this item.</h2></div>';
			}


			html +=
				'<div class="packageContainerTab">'+
				'<ul class="nav nav-tabs">';
			var PlansTab = 'active';
			if(typeof this.data.packagePlanCount.packages !== undefined && parseFloat(this.data.packagePlanCount.packages) > 0)
			{
				html +=
					'<li class="active">'+
						'<a href="#checkoutPackagesTab" data-toggle="tab">Packages<span class="TextHeilight"> ('+ this.data.packagePlanCount.packages +') </span></a>'+
					'</li>';
				PlansTab = '';
			}
			if(typeof this.data.packagePlanCount.plans !== 'undefined' && parseFloat(this.data.packagePlanCount.plans) > 0)
			{
				html +=
					'<li class="'+PlansTab+'">'+
						'<a href="#checkoutPlansTab" data-toggle="tab">Plans<span class="TextHeilight"> ('+this.data.packagePlanCount.plans+') </span></a>'+
					'</li>';
			}
			html +=
				'</ul>'+
				'<div class="tab-content p2List">';
				if(typeof this.data.packagePlanCount.plans !== 'undefined' && this.data.packagePlanCount.plans > 0)
				{
					html +=
						'<div class="tab-pane '+PlansTab+'" id="checkoutPlansTab">'+
							'<div class="packageDiv Card">'+
								'<div class="packageList container">'+
									'<div class="packageposition">';

					for(i=0; i < this.data.packagePlanCount.plans; i++)
					{
						html += Factory.getObj().PackageCard(this.data.plansAndPackages.plans[i]);
					}
					html +=
									'</div>'+
								'</div>'+
							'</div>'+
						'</div>';
				}
				if(typeof this.data.packagePlanCount.packages !== 'undefined' && this.data.packagePlanCount.packages > 0)
				{
					html +=
						'<div class="tab-pane active" id="checkoutPackagesTab">'+
							'<div class="packageDiv Card">'+
								'<div class="packageList container">'+
									'<div class="packageposition">';

					for(i=0; i < this.data.packagePlanCount.packages; i++)
					{
						html += Factory.getObj().PackageCard(this.data.plansAndPackages.packages[i]);
					}
					html +=
									'</div>'+
								'</div>'+
							'</div>'+
						'</div>';
				}
				html +=
				'</div>'+
			'</div>'+
		'</div>';
		}
	}
	else
	{
		validurl = false;
		html +=
			'<h2 class="TextDark container">It seems the item you are trying to find is not available now!</h2>';
	}
	if(canBuy && validurl && itemInCart == 1 && buyFrom_meta )
	{
		html +=
			'<div class="BGOnCard Checkout">';
		for(var i in this.data.ecomm.wallet.payment_gateways)
		{
			var gateway = this.data.ecomm.wallet.payment_gateways[i];
			html +=
				'<div class="GatewayInfo">'+
					'<div class="col-xs-12 col-sm-2">'+
						'<img src="'+gateway.settings.public.logo+'" alt="'+gateway.name+'" title="'+gateway.name+'"/>'+
					'</div>'+
				'<div class="col-xs-12 col-sm-6 GatwayDescription">'+
					'<div class="GetewaySupports">'+
						'<h2>Supported Payment Methods & Wallets</h2>'+
						'<span class ="imgContainer">'+
						'<img src = "https://cdn.toprankers.net/images/visa-0237d2036c1c4.png"/>'+
						'<p>Credit Card / Debit Card / Netbanking</p>'+
						'</span>'+
						'<span class="imgContainer">'+
						'<img src = "https://cdn.toprankers.net/images/upiflogo-0237e864b7574.png " />'+
						'<p>UPI</p>	'+
						'</span>'+
					'</div'+
					'<div class="WalletSupports">';
			if(gateway.gateway == 1)//Instamojo
			{
				html +=
					    '<div class="img1">'+
    					'<img src="https://cdn.toprankers.net/images/bhim-0237d1ef005db.png"/>'+
    					'<p>BHIM</p>'+
						'</div>'+
						'<div class="img1">'+
    					'<img src="https://cdn.toprankers.net/images/olamoney-0237d1eefa4b4.png"/>'+
    					'<p>OLAMoney </p>'+
						'</div>'+
						'<div class="img1">'+
     					'<img src="https://cdn.toprankers.net/images/mobi-0237d1eefb374.png" />'+
    					'<p>MobiKwik</p>'+
						'</div>'+
						'<div class="img1">'+
     					'<img src="https://cdn.toprankers.net/images/freecharge-0237d1eefe2fa.png" />'+
    					'<p>Freecharge</p>'+
						'</div>'+
						'<div class="img1">'+
     					'<img src="https://cdn.toprankers.net/images/jiomoney-0237d1eefc226.png" />'+
    					'<p>JioMONEY</p>'+
						'</div>';
			}
			else if(gateway.gateway == 2)//Paytm
			{
				html +=
						'<div class="img1" id="paytm1">'+
						'<img src="https://cdn.toprankers.net/images/paytm-0237d1ef024a9.png" />'+
						'<p>PayTM</p>'+
						'</div>';
			}
			else if(gateway.gateway == 3)//PayUMoney
			{
				html +=
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/freecharge-0237d1eefe2fa.png" />'+
						'<p>Freecharge</p>'+
						'</div>'+
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/olamoney-0237d1eefa4b4.png" />'+
						'<p>OLAMoney</p>'+
						'</div>'+
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/airtel money-0237d1ef03e13.png" />'+
						'<p>AirtelMoney</p>'+
						'</div>'+
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/oxigen-0237d1eef9196.png" />'+
						'<p>Oxigen</p>'+
						'</div>'+
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/jiomoney-0237d1eefc226.png"/>'+
						'<p>JioMoney</p>'+
						'</div>'+
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/paycash-0237d1ef032d5.png" />'+
						'<p>Paycash</p>'+
						'</div>';
			}
			else if(gateway.gateway == 4)//CCAvenue
			{
				html +=
						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/freecharge-0237d1eefe2fa.png" />'+
						'<p>Freecharge</p>'+
						'</div>'+

						'<div class="img1">'+
     					'<img src="https://cdn.toprankers.net/images/mobi-0237d1eefb374.png"/>'+
    					'<p>MobiKwik</p>'+
						'</div>'+

						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/paytm-0237d1ef024a9.png" />'+
						'<p>PayTM</p>'+
						'</div>'+

						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/jiomoney-0237d1eefc226.png"/>'+
						'<p>JioMoney</p>'+
						'</div>'+

						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/sbi buddy-0237d1ef0143f.png" />'+
						'<p>Buddy</p>'+
						'</div>'+

						'<div class="img1">'+
						'<img src="https://cdn.toprankers.net/images/itzcash-0237d1eefd5f9.png"  />'+
						'<p>ItzCash</p>'+
						'</div>';
			}
			else if(gateway.gateway == 5) //razorpay
			{
				html += '<div class="img1">'+
	         				'<img src="https://cdn.toprankers.net/images/mobi-0237d1eefb374.png" alt="mobikwik"/>'+
	        				'<p>MobiKwik</p>'+
	    				'</div>'+
	    				'<div class="img1">'+
							'<img src="https://cdn.toprankers.net/images/olamoney-0237d1eefa4b4.png" alt="olamoney"/>'+
							'<p>OLAMoney</p>'+
						'</div>'+
						'<div class="img1">'+
							'<img src="https://cdn.toprankers.net/images/airtel money-0237d1ef03e13.png" alt="airtelmoney"/>'+
							'<p>AirtelMoney</p>'+
						'</div>'+
						'<div class="img1">'+
							'<img src="https://cdn.toprankers.net/images/freecharge-0237d1eefe2fa.png" alt="freecharge"/>'+
							'<p>Freecharge</p>'+
						'</div>'+
						'<div class="img1">'+
							'<img src="https://cdn.toprankers.net/images/jiomoney-0237d1eefc226.png" alt="jiomoney"/>'+
							'<p>JioMoney</p>'+
						'</div>';
						//'<script src="https://checkout.razorpay.com/v1/checkout.js"></script>';
			}


			html +=	'</div>'+
						'</div>';
			if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 0)
			{
				html += '<div class="paymentpolocies_div"><span>This content can be consumed on our website as well.</span></div>';
			}			
				html += '<div class="col-xs-12 col-sm-4">'+
							'<a class="btn btn-primary InitiatePayment" '+
								'data-gateway="'+gateway.id+'" '+
								'data-itemId="'+this.data.item.id+'" '+
								'data-redirect="'+this.data.item.redirect+'" '+
								'data-coupon="">Proceed to Pay</a>'+
						'</div>'+
				'</div>';

		}
	html +=
		'</div>';
	}
	this.dom.html(html);
};

commoncheckoutController.prototype.Buy = function(e)
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	if(this.purchaseInprogress)
	{
		return;
	}
	if(LoggedInUser.Auth())
	{
		this.purchaseInprogress = true;
		$.ajax({
			type: "POST",
			url: remoteServer + "/?route=common/ajax",
			xhrFields: {
			   withCredentials: true
			},
			crossDomain: true,
		    context:this,
		    timeout: 30000,
			data:
			{
				mod: "tr2ecomm",
				ack: "purchaseitem",
				id:e.itemId,
	           	coupon:e.coupon,
	           	redirect:e.redirect,
	           	gateway:e.gateway
			},
			success: function(reply)
			{
				try
				{
					if(reply.result.state == "ok")
					{
						if(reply.data.ack == "unlocked")
						{
							this.txId = null;
							this.CheckTransaction();
						}
						else if(reply.data.ack == "redirect")
						{
							this.txId = reply.data.id;
							//For razor pay
							if(reply.data.hasOwnProperty('rezorpay')){
								var rzpOptions = {
								    key: reply.data["keyId"],
								    amount: parseInt(reply.data["amount"]) *  100, // 2000 paise = INR 20
								    name: remoteHost,
								    "order_id":reply.data["externalId"],
								    handler: function (response){
								        console.log(response);
								    },
								    prefill: {
								        "name": typeof(urlMgmt.userData.displayName) != "undefined" ? urlMgmt.userData.displayName:"",
						 		        "email": typeof(urlMgmt.userData.emailId) != "undefined" ?urlMgmt.userData.emailId:"",
						 		        "contact": typeof(urlMgmt.userData.settings) != "undefined" && typeof(urlMgmt.userData.settings[0] != "undefined") && typeof(urlMgmt.userData.settings[0][2] != "undefined") ? urlMgmt.userData.settings[0][2] : "",
								    },
								    notes: {

								    },
								    theme: {
								        color: "#F37254"
								    }
								};
								RazorpayCheckout.open(rzpOptions, function(payment_id){
            						this.CheckTransaction();
            					}.bind(this), function(error){
            						this.purchaseInprogress = false;
            						if(error.code == 2){
            							alert("Please try again");
            						}
            						UrlMgmt.getObj().removeLoader();
            					}.bind(this));
        						this.purchaseInprogerss = false;
								return;
							}

							var TransactionWindow = cordova.InAppBrowser.open(encodeURI(reply.data.payment_url), "_blank", "location=no");

							//check for payment success
							var txnSuccess = false;
							TransactionWindow.addEventListener('loadstart', function(e){
								if(e.url.indexOf('/redirect/') > 0 && e.url.indexOf("payment-complete-in-app") > 0)
								{
									txnSuccess = true;
									TransactionWindow.close();
									this.CheckTransaction();								}
							}.bind(this));

							//check if browser window is closed forefully
							TransactionWindow.addEventListener('exit', function(e){
								if(!txnSuccess)
								{
									this.txnBrowserForceExit = true;
									this.CheckTransaction();
								}
							}.bind(this));
						}
					}
					else if(reply.result.meta == "loginRequired")
					{
						UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
					}
					else
					{
						alert(reply.result.meta);
					}

					this.purchaseInprogress = false;
				}
				catch(e)
				{
					this.purchaseInprogress = false;
				}
				UrlMgmt.getObj().removeLoader();
			}
		});
	}
	else
	{
		UrlMgmt.getObj().removeLoader();
		UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
	}
};

commoncheckoutController.prototype.CheckTransaction = function(){
	var itemType = this.data.item.itemType;
	if(this.txId)
	{
	    tr$.ajax({
	        mod: "ecomm",
            ack: "verifypayment",
            additionalParams:{
				txId: this.txId,
			},
	        successClb: function(response)
	        {
	        	var TSModalDom = $("#transaction-status-modal");
				if(TSModalDom.is(':visible') || this.txnStatusCounter == 0)
				{
					if(this.txnStatusCounter == 0)
		        	{
		        		TSModalDom.modal('show');
		        	}
					switch(parseInt(response.data))
					{
						case PaymentGatewayTransactionStatus.Cancelled:
							TSModalDom.find(".modal-title").text("Transaction cancelled!");
							TSModalDom.find(".modal-body").html('<div class="alert alert-danger"><span><img src="img/alert_white.png"></span><p>Transaction cancelled! Please try again.</p></div>');
							TSModalDom.find(".modal-footer span").text("GO BACK");
							break;
						case PaymentGatewayTransactionStatus.Failed:
							TSModalDom.find(".modal-title").text("Transaction failed!");
							TSModalDom.find(".modal-body").html('<div class="alert alert-danger"><span><img src="img/alert_white.png"></span><p>Transaction failed! Please try again.</p></div>');
							TSModalDom.find(".modal-footer span").text("GO BACK");
							break;
						case PaymentGatewayTransactionStatus.Success:
							var key = typeof this.id != 'undefined' ? this.id : '';
							analytics_trackEvent('Transaction successful from app','/'+key);
							TSModalDom.find(".modal-title").text("Transaction Successful!");
							TSModalDom.find(".modal-body").html('<div class="alert alert-success">Thank you for your recent purchase. Your '+itemType+' has been unlocked.</div>');
							TSModalDom.find(".modal-footer span").text("TAKE TEST");
							if(this.pkgExploreId)
							{
								UrlMgmt.getObj().PopView(function(){
									UrlMgmt.getObj().Route({route: 'item/package&id='+this.pkgExploreId, needData: true, offlineAllowed: true});
								}.bind(this));
							}
							else
							{
								UrlMgmt.getObj().PopView();
							}
							break;
						default:
							//browser window is closed forefully
							if(this.txnBrowserForceExit)
							{
								TSModalDom.find(".modal-title").text("Transaction cancelled!");
								TSModalDom.find(".modal-body").html('<div class="alert alert-danger"><span><img src="img/alert_white.png"></span><p>If you have accidentally closed the window, please try again.</p></div>');
								TSModalDom.find(".modal-footer span").text("GO BACK");
							}
							//Check Transaction Again
							else if(this.txnStatusCounter < 10)
							{
								this.txnStatusCounter++;
								TSModalDom.find(".modal-title").text("Waiting for your transaction to complete");
								TSModalDom.find(".modal-body").html(
									'<div><div class="Loader"><img src="img/loader.svg"></div><div class="alert alert-info transaction-msg"><p>Waiting for your transaction to complete...</p><p>If you have accidentally closed the window, please try again.</p></div></div>'
									);

								setTimeout(function(){
								    this.CheckTransaction();
								}.bind(this), 2000);
								return;
							}
							else
							{
								TSModalDom.find(".modal-title").text("Transaction failed!");
								TSModalDom.find(".modal-body").html('<div class="alert alert-danger">Transaction failed! Please try again.</div>');
							}
							UrlMgmt.getObj().removeLoader();
					}
				}
				this.txnStatusCounter = 0;
				this.txnBrowserForceExit = false;
			}.bind(this),
		});
	}
	else{
		if(this.pkgExploreId)
		{
			UrlMgmt.getObj().PopView(function(){
				UrlMgmt.getObj().Route({route: 'item/package&id='+this.pkgExploreId, needData: true, offlineAllowed: true});
			}.bind(this));
		}
		else
		{
			UrlMgmt.getObj().PopView();
		}

		var TSModalDom = $("#transaction-status-modal");
		TSModalDom.modal('show');
		TSModalDom.find(".modal-title").text("Transaction Successful!");
		TSModalDom.find(".modal-body").html('<div class="alert alert-success">Thank you for your recent purchase. Your '+itemType+' has been unlocked.</div>');
		TSModalDom.find(".modal-footer span").text("TAKE TEST");
		//UrlMgmt.getObj().PopView();
	}
};

commoncheckoutController.prototype.ApplyCoupon = function(e)
{
	if(this.applyCouponInprogress)
	{
		return;
	}

	if(LoggedInUser.Auth())
	{
		this.applyCouponInprogress = true;
		$.ajax({
			type: "POST",
			url: remoteServer + "/?route=common/ajax",
			xhrFields: {
			   withCredentials: true
			},
			crossDomain: true,
		    context:this,
		    timeout: 30000,
			data:{
					mod: "tr2ecomm",
					ack: "couponcheck",
					item: e.itemId,
					code: e.coupon
				},
			success: function(reply)
			{
	           	try
	           	{
	           		this.applyCouponInprogress = false;
	           		if(reply.result.meta == "loginRequired")
	           		{
						UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
	           		}
	           		else if(typeof e.callback == "function")
	           		{
						e.callback(reply);
					}
	           }
	           catch(e)
	           {
	           		this.applyCouponInprogress = false;
					if(typeof callback == "function")
						e.callback({data:null, result:{state:"error", meta:e.message+"\n"+JSON.stringify(event.responseJSON)}});
	           }
			}
		});
	}
	else
	{
		UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
	}
};
