var commonprofileController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.editProfilenode = null;
	this.transferNode = null;
	this.overlay = null;
	this.userInfo = null;
	this.refresh = true;
	this.freetestflag = true;
};
commonprofileController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	this.freetestflag = true;
	this.stableDom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();	
};
commonprofileController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'My Profile', false, true, false);
};
commonprofileController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);
};
commonprofileController.prototype.OnlineInit = function()
{
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	var urlMgmt = UrlMgmt.getObj();
	HOME_silentLogin(function(){
		this.userInfo = urlMgmt.userData;
		this.ProfileDetails();
		this.BindEvents();
		this.accountId = $(".user-account-info").attr("data-account-id");
		this.userBalance = $(".user-account-info").attr("data-user-balance");
	}.bind(this));
};
commonprofileController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
commonprofileController.prototype.BindEvents = function()
{
	var urlMgmt = UrlMgmt.getObj();
	$(this.dom).find("a[data-action]").unbind().bind("click", function(e){
		e.preventDefault();
		var url = $(e.currentTarget).attr('href');
		var dataAction = $(e.currentTarget).attr('data-action');
		URLRedirection(url, dataAction);
		urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-1].controler.dom).attr('id'));
	});
	$('[data-action="examPage"]').unbind().bind("click",this,function(e){
		e.preventDefault();
		var examId = $(this).attr("data-delivery-id");
		var testListId = e.data.data.header.exams[examId]["testListId"][0];
		
		var SecondcontrolerName = UrlMgmt.getObj().actionStack[urlMgmt.actionStack.length-2].controlerName;
		if(SecondcontrolerName == "liststestController")
		{
			urlMgmt.PopView();
		}
		urlMgmt.Route({route: "lists/test&id="+testListId, needData: true, offlineAllowed: true, emptyStack: false}, function(obj){
			urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
		});
	});
	$('[data-action="verifyemail"]').unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		e.data.SentEmailVerificationLink(function(reply){
			if(reply.result.state == "ok")
			{
				
				if(reply.data.result == "ok")
				{
					alert(reply.data.msg);
				}
				else
				{
					alert(reply.data.msg);
				}
			}
			else
			{
				alert(reply.result.meta);
			}
		});
	});
	$('[data-action="verifyphoneno"]').unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		LoggedInUser.ShowVerifyMobileNumberDlg((!isNaN(UrlMgmt.getObj().userData['settings'][0][UserSettings.PhoneNumber])?UrlMgmt.getObj().userData['settings'][0][UserSettings.PhoneNumber]:undefined),true);
		
	});
	$('[data-action="uploadprofileinfo"]').unbind().bind("click", this, function(e){
			e.data.editProfilenode = null;
			e.data.OpenProfileEdit();
			$("#editProfile-modal").find('.modal-body').find('input').on('focus', function(e){
				$(e.currentTarget).css('border-bottom', '2px solid #30B8E2');
			});
			$("#editProfile-modal").find('.modal-body').find('input').on('blur', function(e){
				$(e.currentTarget).css('border-bottom', '1px solid #87A7AF');
			});
	});
	$('[data-action="getAccountDetails"]').unbind().bind("click", this, function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		e.data.accountNode = null;
		e.data.GetuserAccount();
	});
	$('[data-action="transferCashOpen"]').unbind().bind("click", this, function(e){
			if(e.data.transferNode == null)
			{
				e.data.createTransferCashNode(function(){
					$("#transferAppendModal").append(e.data.transferNode);
					$('#transferCash').modal('show');
					UrlMgmt.getObj().modalObj = $('#transferCash');
					$('[data-action="transfertrcash"]').unbind().bind("click", e.data, function(e){
						e.data.Transfertrcash();
					});
				});
			}
			else
				$('#transferCash').modal('show');
				UrlMgmt.getObj().modalObj = $('#transferCash');
	});
	$('[data-action="subscribe"]').unbind().bind("click", this, function(e){
		urlMgmt.sideMenuAction.controler.CloseView();
		urlMgmt.Route({route: 'common/tr2subscription', needData: false});
	});
	if($('[data-action="viewlinkLists"]').length > 0)
	{
		$('[data-action="viewlinkLists"]').unbind().bind("click", this, function(e){
			e.data.linknode = $(this);
			e.data.linkpopup = e.data.linknode.find('.page-link').addClass('visibled');
			e.data.overlay = e.data.linknode.find('.dashboard-overlay');
			if(e.data.overlay.length == 0)
				e.data.overlay = $('<div class="dashboard-overlay"></div>').appendTo(e.data.linknode);
			else 
				e.data.overlay.appendTo(e.data.linknode);
			e.data.linkpopup.siblings('.dashboard-overlay').css("display", "block");
			e.data.overlay.unbind().bind('click', this, function(evt){
				evt.stopPropagation();
				e.data.linkpopup.removeClass('visibled');
				e.data.linkpopup.siblings('.dashboard-overlay').css("display", "none");
			}.bind(e.data));
		});
	}
	$('[data-action="sharedashboard"]').unbind().bind("click", this, function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(e.data.userInfo.settings.length > 0 && e.data.userInfo.settings[0][8] == 0)
		{
			e.data.showPublicmodal(function(changedPrivacy){
				if(changedPrivacy)
				{
					e.data.userInfo.settings[0][8] = 1;
					e.data.ShowShareDialog();
				}
				if(e.data.editProfilenode != null)
					$('.Privacy option[value="'+e.data.userInfo.settings[0][8]+'"]').attr('selected','selected');
			}.bind(e.data));
		}
		else
			e.data.ShowShareDialog();
	});
	$('[data-action="uploaddata"]').unbind().bind("click", this, function(e){
		console.log($('.profile-dashboard-info').find('.phone-info').find('.number-text'));
		$('#getContactDetails-modal .modal-dialog .modal-content .modal-body .contact-element_phoneno input').val("");
		$('#getContactDetails-modal .modal-dialog .modal-content .modal-body .warning-msg').css("display", "none");
		e.data.getContactDetailsmodal();
	});
	
	$("#btn_logout").unbind().click(function(){
		var urlmgmt = UrlMgmt.getObj();
		if(!urlmgmt.App.isOnline){
			alert('Connect to internet');
			return;
		}
		LoggedInUser.canSkip = false;
		LoggedInUser.logout();
	});
	$(".UpdateAddress").unbind().bind("click", this, function(e){
			if($(this).text() == 'Edit Address')
			{
				$(e.data.dom).find('.Address-details').find(".fieldDiv").each(function(){
					$(this).find('.edit_disabled').removeClass("edit_disabled");
				});
				$(this).text('Save Address');
			}
			else
			{
				Factory.getObj().UpdateAddress({
				  sectionId: parseInt(e.data.data["addressSectionId"]),
				  dom : e.data.dom,
				});
			}
	});
	if($(".impDateDiv").length > 0){
		slider("impDateDiv","dateList","importantDate");
	}
	if($(".catList").length > 0){
		slider("catList","cattabList","category-head");
		Factory.getObj().scrollToCenter('.userInteraction .cattabList li');
	}
	if($(".pkgList").length > 0){
		slider("pkgList","pkgtabList","package-head");
		Factory.getObj().scrollToCenter('.userInteraction .pkgtabList li');
	}
	if($(".examDiv").length > 0){
			slider("examDiv", 'examList', "Exam");
	}	
	Factory.getObj().scrollToCenter('.userInteraction .tabList li');
};

commonprofileController.prototype.ProfileDetails = function()
{
	var profileDetails = "";
	if((typeof this.data.privateprofile === 'undefined') || (this.data.privateprofile == 0))
	{
		 profileDetails = '<div class="container user-info">'+
							 '<div class="Profile-details">'+
							 	'<div class="flex-box">'+
							 		'<div class="Profile-image" style="background-image: url('+remoteServer+'/attachment/profile-thumbnail/'+UrlMgmt.getObj().userData['id']+'/'+(new Date().getTime())+');">';      ///'+this.data.dashboardId+'
							 					
		profileDetails	+= 				'<div class="profile_pic_Notification"></div>'+
										
									'</div>'+
									'<div class="profile-dashboard-info"><div class="name-info text-bold flex-box">'+this.userInfo.displayName+'</div>';
										
										
										if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))			 				
							 			{
		profileDetails	+= 					'<div class="email-info">'+
							 					'<span><img src="https://cdn.toprankers.net/images/mail@2x-023c731b3e263.png"/></span>';
							 					if((typeof this.userInfo.emailId !== 'undefined') && this.userInfo.emailId !== null && this.userInfo.emailId.length > 0 )
							 					{
		profileDetails	+=	    					'<span class="mail">'+this.userInfo.emailId+'</span>';
							 						if((this.userInfo.settings.length > 0))
							 						{
								 						if( (typeof UrlMgmt.getObj().userData.settings[0][UserSettings.EmailVerified] == "undefined") || (parseInt(this.userInfo.settings[0][UserSettings.EmailVerified]) == 0) )
								 						{
			profileDetails	+=								'<div class="btn-alt btn-green" data-action="verifyemail">Verify Email</div>';
								 						}
								 						else
								 						{
			profileDetails	+= 								'<div class="btn-alt btn-green-success"><span class="glyphicon glyphicon-ok"></span><span class="verified">Verified</span></div>';
								 						}
							 						}
							 						else{
			profileDetails	+=								'<div class="btn-alt btn-green" data-action="verifyemail">Verify Email</div>';
							 						}
							 					}
							 					else
							 					{
		profileDetails	+= 	 						'<div class="btn-alt btn-green" data-action="uploaddata">Upload Email</div>';
							 					}
		profileDetails	+= 					'</div>'+
							 				'<div class="phone-info">'+
							 					'<span><img src="https://cdn.toprankers.net/images/phone@2x-023c731b3de40.png"/></span>';
							 					//'<span class="number-text"></span>';
							 					if((this.userInfo.settings.length > 0) && (typeof this.userInfo.settings[0]["2"] !== 'undefined') && (this.userInfo.settings[0]["2"].length > 0) && !isNaN(this.userInfo.settings[0]["2"]))
							 					{
							 						 if($('.phone-info').find('.number-text').text() != "NaN")
							 						 {
		profileDetails	+= 								'<span class="number-text">'+(!isNaN(this.userInfo.settings[0]["2"])?this.userInfo.settings[0]["2"]:'')+'</span>';
												     }
												     else
							 						 {
		profileDetails	+=	 							'<div class="btn-alt btn-green" data-action="uploaddata">Upload Phone no.</div>';
							 						 }
													if((this.userInfo.settings.length > 0)  && (typeof this.userInfo.settings[0]["3"] == "undefined") || (this.userInfo.settings[0]["3"] == 0))
							 						{
							 							if(typeof UrlMgmt.getObj().verifyOtp != 'undefined' && UrlMgmt.getObj().verifyOtp == 1){
		profileDetails	+= 									'<div class="btn-alt btn-green" data-action="verifyphoneno">Verify Number</div>';
														}
							 						}
							 						else
							 						{
		profileDetails	+= 								'<div class="btn-alt btn-green-success"><span class="glyphicon glyphicon-ok"></span><span class="verified">Verified</span></div>';
							 						}
							 					}
							 					else
							 					{
		profileDetails	+=	 						'<div class="btn-alt btn-green" data-action="uploaddata">Upload Phone no.</div>';
							 					}
		profileDetails	+= 					'</div>';
							 			}
		profileDetails	+=			'</div>';
							 		if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))			 				
							 		{
		profileDetails	+=  			'<div class="editprofile">';
								 			if(this.data.myDashboard)
								 			{
		profileDetails	+=	 					'<span data-action="uploadprofileinfo"><img src="https://cdn.toprankers.net/images/edit@2x-023c731b3e6ef.png" /></span>';
								 			}
								 			else
								 			{
		profileDetails	+=	 					'<span disabled><img src="https://cdn.toprankers.net/images/edit@2x-023c731b3e6ef.png" /></span>';
								 			}
		
		profileDetails	+= 				'</div>';
							 		}
		profileDetails	+= 		'</div>';
							 	if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
							 	{
		profileDetails	+=	 		'<div class="flex-box user-info-flex">'+
								 		'<div class="user-account-info" data-account-id='+this.data.ecomm.account.id+' data-user-balance='+this.data.ecomm.account.balance+'>'+
								 			'<div class="text-bold"><img class="wallet-img" src="https://cdn.toprankers.net/images/wallet@2x-023c731b3be88.png"><span>Wallet Balance</span></div>'+
								 			'<div class="account-balance"><span class="rupee">₹</span><span class="number-text">'+this.data.ecomm.account.balance+'</span></div>'+
								 		'</div>'+
								 		'<div class="user-account" >'+
								 			'<a class="btn btn-default" data-action="getAccountDetails">Accounts</a>';
								 			if(this.data.canTransfer)
								 			{
		profileDetails	+=	 					'<a class="btn btn-primary" data-action="transferCashOpen">Transfer Cash</a>';
								 			}
		profileDetails	+=				'</div>'+
							 		'</div>';
								 }
								 else if(this.userInfo.id > 0)
								 {
		profileDetails	+= 			'<div class="flex-box">'+
							 			'<div class="shared-space">'+
							 				'<span class="shared-txt">Hey! Have been using '+Application_name+' platform for my prep & I feel its pretty awesome! Recommend to give it a try. It\'s absolutely FREE!</span>'+
								 				// '<div class="flex-box">'+
								 					// '<a class="btn btn-primary" href='+this.userInfo.profileUrl+'>Go To my Dashboard</a>'+
								 				// '</div>'+
							 			'</div>'+
							 		'</div>'; 
								 }
								 else
							 	 {
		profileDetails	+= 			'<div class="flex-box">'+
							 			'<div class="shared-space">'+
							 				'<span class="shared-txt">Hey! Have been using '+Application_name+' platform for my prep & I feel its pretty awesome! Recommend to give it a try Its absolutely FREE!......</span>'+
								 			'<div class="flex-box">'+
								 				'<div class="btn btn-primary" data-action="login-modal">login to start</div>'+
								 				'<div class="btn btn-default" data-action="register-modal">Register for Free</div>'+
								 			'</div>'+
							 			'</div>'+
							  		'</div>';
								 }
		profileDetails	+= 	  '</div>';

								if(typeof this.data.addressSectionId != "undefined" && typeof this.data.address != "undefined")
								{
		profileDetails  +=    '<div class="Address-details checkout">';
							  		for(field in this.data.address.fields)
							  		{
		profileDetails  +=	  			'<div class="fieldDiv" data-fieldId="'+this.data.address.fields[field].id+'" data-typeId="'+this.data.address.fields[field].typeId+'" isRequired = "'+this.data.address.fields[field].isRequired+'">'+
										'<label for = "userProfile_'+this.data.address.fields[field].id+'">'+this.data.address.fields[field].text+': </label>';
										if(this.data.address.fields[field].typeId == "4")
										{
		profileDetails  += 					'<select id="userProfile_'+this.data.address.fields[field].id+'" data-typeId="'+this.data.address.fields[field].typeId+'"'+
											((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? 'class="edit_disabled"' : "" )+'>'+
												'<option value="-1" >Select</option>';
													for(enumValid in this.data.address.fieldValues[this.data.address.fields[field].id])
													{
		profileDetails  +=								'<option value="'+this.data.address.fieldValues[this.data.address.fields[field].id][enumValid]+'"'+
														((this.data.address.values[this.data.address.fields[field].id] == this.data.address.fieldValues[this.data.address.fields[field].id][enumValid])?'selected': '')+'>'+enumValid+'</option>';
													}
		profileDetails  +=					'</select>'+
											'<div class="ErrorMsg"></div>';									
										}
										else
										{
		profileDetails  +=					'<input id="userProfile_'+this.data.address.fields[field].id+'" value="'+
											((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? this.data.address.values[this.data.address.fields[field].id] : "" )+'"'+
											((typeof this.data.address.values[this.data.address.fields[field].id] != "undefined") ? 'class="edit_disabled"' : "" )+' type="text" data-typeId="'+this.data.address.fields[field].typeId+'"/>'+
											'<div class="ErrorMsg"></div>';				
										}
		profileDetails  +=				'</div>';				
							  		}
		profileDetails  +=			'<div class="UpdateAddressdiv"><a class="btn btn-primary UpdateAddress" >'+(((typeof this.data.address.values != "undefined")&&(!jQuery.isEmptyObject(this.data.address.values)))?'Edit Address':'Save Address')+'</a></div>'; 		  		
		profileDetails  +=	  '</div>';	
						  	
								}	

		profileDetails	+=    '</div>';
						   if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
						   {
		profileDetails	+= 	'<div class="container">'+
						  		'<div class="flex-box share-dashboard" data-action="sharedashboard">'+
						  			'<img src="https://cdn.toprankers.net/images/share@2x-023c72567c178.png">'+
						  			'<span class="text-blue">Share Your Profile</span>'+
						  		'</div>'+
						  	'</div>';
						  }
						  if((typeof this.data.importantDates !== 'undefined') && Object.keys(this.data.importantDates).length > 0)
						  {
		profileDetails	+= 	'<div class="container examDates">'+
						  		'<div class="titleDiv text-blue">Upcoming Dates</div>'+
						  		'<div class="impDateDiv flex-box">'+
						  			'<span class="importantDatebtnleft glyphicon glyphicon-chevron-left"></span>'+
					  				'<div class="dateList">';
					  				for(var i in this.data.importantDates)
					  				{  
					  					var impDate = this.data.importantDates[i];
		profileDetails	+=				'<div class="importantDate" data-delivery-id='+i+' data-action="examPage">'+
					  						
					  						 	'<span class="exam-name text-blue">'+impDate.examTitle+'</span>'+
					  						 	'<span class="event text-bold">'+impDate.title+'</span>'+
					  						 	'<span class="impdate">'+impDate.date.split(' ')[0]+'</span>'+
					  					'</div>';
					  				}
		profileDetails	+=			'</div>'+
					  				'<span class="importantDatebtnright glyphicon glyphicon-chevron-right"></span>'+
					  			'</div>'+
					  		'</div>';
						  }
						  if((typeof this.data.subscribedExams !== "undefined" && typeof this.data.subscribedExams.categories != 'undefined') && Object.keys(this.data.subscribedExams.categories).length > 0)
						  {
		profileDetails	+=	'<div class="FreeList">'+
								'<div class="freelist-title"> Free For YOU!</div>'+
									'<div class="examDiv">'+
										'<span class="glyphicon glyphicon-chevron-left Exambtnleft"></span>'+
											'<div class="examList">'+
												'<div class="exam-position">';
												for(var cIndex in this.data.subscribedExams.categories)
												{
													var category = this.data.subscribedExams.categories[cIndex];
													for(var eIndex in category.Exams)
													{
														var examData = category.Exams[eIndex];
														if((typeof examData.testcount != 'undefined' && examData.testcount > 0)
															|| (typeof examData.videocount != 'undefined' && examData.videocount > 0)
															|| (typeof examData.quizcount != 'undefined' && examData.quizcount > 0))
														{
															this.freetestflag = false;
															profileDetails	+=  Factory.getObj().ExamCard({
																				examId: eIndex,
																				title: examData.title,
								 												videocount: examData.videocount,
								 												batches: examData.Batch,
								 												testcount: examData.testcount,
								 												testLists: examData.testList,
								 												quizcount: examData.quizcount,
								 												quizLists: examData.quizList,
							 												});
							 							}	
													}
												}
		profileDetails	+=						'</div>'+
											'</div>'+
											'<span class="glyphicon glyphicon-chevron-right Exambtnright"></span>'+
										'</div>'+
									'</div>';  	
						  }
		profileDetails	+= '<div class="">';
		                  /* if((typeof showUsersIntraction == 'undefined') || (typeof showUsersIntraction != 'undefined' && showUsersIntraction == true))
		                   {
		profileDetails	+= 	'<div class="userInteraction">'+
						  		'<div class="packageview">';
						  			var a ="";
						  			if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
						  			{
						  				a = 'My Plans & Packages';
						  			}
						  			else
						  			{
						  				a = "Plans & Packages";
							  		}
		profileDetails +=	  		'<div class="userInteraction-title">'+a+'</div>';
							  		if((typeof this.data.userPackageLinks !== 'undefined') && Object.keys(this.data.userPackageLinks.packages).length > 0)
									{
		profileDetails +=				this.UserPackageDetails(this.data.userPackageLinks);
									}
									else if(this.data.myDashboard == true)
							  		{
							  			var plans_PackageId,urlMgmt = UrlMgmt.getObj();
										for(var x in urlMgmt.menuData.packageLists )
										{
											if(urlMgmt.menuData.packageLists[x].urlKey == "subscription-plans")
											{
												plans_PackageId = urlMgmt.menuData.packageLists[x].id;
											}
										}
		profileDetails +=				'<div class="nothing-bought">'+	
											'<img src="https://cdn.toprankers.net/images/group-2244-023c7c58bfe20.png" />'+
												'<span class="nothing-bought-txt">You have not bought anything to prepare for your exam</span>'+
												'<span class="nothing-bought-suggest">Buy any Plans or Packages to Prepare for exam</span>'+
										'</div>'+
										'<a class="buy-plans" href="/subscription-plans" data-action="lists/package&id='+plans_PackageId+'">'+
											'<span class="text-blue">Buy Plans and Packages</span>'+
										'</a>';	  				
							  		}
							  		else
							  		{
		profileDetails +=				'<a class="explore-plans" href="/subscription-plans">'+
											'<span class="text-blue">Explore Plans and Packages</span>'+
										'</a>';  				
							  		}
		profileDetails +=  			'<div class="examSubscription">';
							  		var a ="";
							  		if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
							  		{
							  			a = "My Subscribed Exams";
							  		}
							  		else
							  		{
							  			a = "Subscribed Exams";
							  		}
		profileDetails +=   			'<div class="userInteraction-title">'+a+'</div>';	  			
						  			if((typeof this.data.subscribedExams !=='undefined') && Object.keys(this.data.subscribedExams).length > 0)
						  			{
		profileDetails +=				this.UserSubscribedExamsDetails(this.data.subscribedExams);
						  			}
						  			else if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
						  			{
		profileDetails +=       		'<div class="nothing-subscribed">'+
											'<img src="https://cdn.toprankers.net/images/group-2244-023c7c58bfe20.png" />'+
											'<span class="nothing-subscribed-txt">You have not subscribe to any exam yet</span>'+
											'<span class="nothing-subscribed-suggest">Explore and subscribe the exams you are preparing for</span>'+
										'</div>'+
										'<div class="subscribe-exams" data-action="subscribe">'+
											'<span class="text-blue">Subscribe Exams</span>'+
										'</div>';	  					
						  			}
						  			else
						  			{
		profileDetails += 				'<div class="explore-exams" data-action="subscribe">'+
											'<span class="text-blue">Explore & Subscribe Exams</span>'+		  					
										'</div>';
						  			}
		profileDetails +=			'</div>'+
								'</div>'+
							'</div>';
							}*/
						}
						else
						{
	profileDetails += 		'<div class="private-profile text-center">'+
								'<span class="text-bold">This is a Private profile. Only the Particular User can see the contents of the page.</span>';
								if(this.userInfo.id > 0)
								{
	//profileDetails +=        		'<a class="btn btn-primary" href="user.profileUrl">Go To my Dashboard</a>';								
								}
								else
								{
	profileDetails +=      			'<div class="flex-box">'+
										'<div class="btn btn-primary" data-action="login-modal">Log in to Start</div>'+
										'<div class="btn btn-default" data-action="register-modal">Register for Free</div>'+
									'</div>';								
								}
	profileDetails +=       '</div>';							
						}
	profileDetails += 	'<div id="profileAppendModal"></div>'+
						'<div id="accountInfoAppendModal"></div>'+
						'<div id="transferAppendModal"></div>'+
						'<div id="appendsharemodal"></div>'+
						'<div id="contactDetailsmodal"></div>';					  
	$(this.dom).html(profileDetails);
	//Hide Exam Subscription based on meta
	if(typeof UrlMgmt.getObj().subscription != 'undefined' && UrlMgmt.getObj().subscription == "0"){
		$(this.dom).find('.examSubscription').remove();
	} 
	$(this.dom).append('<button id="btn_logout" type="button" class="btn btns-common">LOGOUT</button>');	
	if((typeof this.data.subscribedExams !=='undefined') && Object.keys(this.data.subscribedExams).length > 0)
	{
		slider("catList", 'cattabList', "category-head");	 	
	}
	if(this.freetestflag){
		$('.FreeList .freelist-title').hide();
	}
	else{
		$('.FreeList .freelist-title').show();
	}
};
commonprofileController.prototype.UserPackageDetails = function(userPackageData)
{
	var pkgData = "";
		pkgData +=   '<div class="userPackageInfo">'+
						 '<div class="pkgList">'+
						  	'<span class="glyphicon glyphicon-chevron-left package-headbtnleft"></span>'+
						  	'<ul class="nav nav-tabs pkgtabList">';
							  	var once = true;
							  	for(var i in userPackageData.packages)
							  	{
							  		var userPackageLinks = userPackageData.packages[i];			
							  		if(once)
							  		{
		pkgData +=	  					'<li class="active package-head" data-itemid="'+userPackageLinks.packageId+'" data-delivery-id="'+userPackageLinks.id+'"><a href="#package'+userPackageLinks.packageId+'" data-toggle="tab">'+userPackageLinks.title+'</a></li>';
							  		}
							  		else
							  		{
		pkgData +=	  					'<li class="package-head" data-itemid='+userPackageLinks.packageId+' data-delivery-id='+userPackageLinks.id+'><a href="#package'+userPackageLinks.packageId+'" data-toggle="tab">'+userPackageLinks.title+'</a></li>';
							  		}
							  		once =false;
							  	}
		pkgData +=	  		'</ul>'+
						  	'<span class="glyphicon glyphicon-chevron-right package-headbtnright"></span>'+
						  '</div>'+
						  '<div class="tab-content">';
						  	 var once1 = true;
							 for(var i in userPackageData.packages)
					  		 {
					  			var userPackageLinks = userPackageData.packages[i];
					  			if(once1)
					  			{
		pkgData +=					'<div id="package'+userPackageLinks.packageId+'" class="package-view tab-pane fade in active" data-item='+userPackageLinks.packageId+' data-delivery-id='+userPackageLinks.id+'>';
					  			}
					  			else
					  			{
		pkgData +=					'<div id="package'+userPackageLinks.packageId+'" class="package-view tab-pane fade" data-item='+userPackageLinks.packageId+' data-delivery-id='+userPackageLinks.id+'>';
					  			}
					  			once1 =false;
					  			if(typeof userPackageLinks.Batch !== 'undefined')
					  			{
		pkgData +=	  				this.UserPackageBatchDetails(userPackageLinks.Batch, userPackageLinks.id);
					  			}
					  			if(typeof userPackageLinks.TestList !== 'undefined')
					  			{
		pkgData +=	  				this.UserPackageTestListDetails(userPackageLinks.TestList, userPackageLinks.id);
				  				}							
		pkgData +=					'</div>';						
				  			}
		pkgData +=		  '</div>'+
				  		'</div>'+
				  		'<a class="buy-plans" href="/subscription-plans" data-action="lists/package&id=11">'+
				  			'<span class="text-blue">Buy Plans and Packages</span>'+
				  		'</a>';
		return pkgData;			  			
};
commonprofileController.prototype.UserPackageBatchDetails = function(userBatchData, packageId)
{
	var bthData = "";
				for(var batch in userBatchData)
				{
					var batchData = userBatchData[batch];
					var dataAction = "item/batch&id="+batch;
					var url = this.data.actions["item/batch&id="+batch];
					
					if(typeof vidu != 'undefined' && vidu == 1){
						dataAction = "item/package&id="+packageId;
						url = this.data.actions["item/package&id="+packageId];
					}
					if(batchData.ongoing > 0)
					{
	bthData +=			'<div class="batch first-ordrer" data-action="batchPage">'+
							'<div class="text-blue">'+batchData.BatchTitle+'</div>'+
								'<a href ="'+url+'#ongoing" class="link-info" data-action="'+dataAction+'" data-delivery-id='+batch+'>';
					}
					else if(batchData.upcoming > 0)
					{
	bthData +=			'<div class="batch third-ordrer" data-action="batchPage">'+
							'<div class="text-blue">'+batchData.BatchTitle+'</div>'+
								'<a href ="'+url+'#upcoming" class="link-info" data-action="'+dataAction+'" data-delivery-id='+batch+'>';
					}
					else if(batchData.past > 0)
					{
	bthData +=			'<div class="batch fourth-ordrer" data-action="batchPage">'+
							'<div class="text-blue">'+batchData.BatchTitle+'</div>'+
								'<a href ="'+url+'#past" class="link-info" data-action="'+dataAction+'" data-delivery-id='+batch+'>';
					}
					else 
					{
	bthData +=			'<div class="batch first-ordrer" data-action="batchPage">'+
							'<div class="text-blue">'+batchData.BatchTitle+'</div>'+
								'<a href ="'+url+'#demo" class="link-info" data-action="'+dataAction+'" data-delivery-id='+batch+'>';
					}
					
	bthData +=						'<div class="batch-info">'+
										'<div class="video-img batch-stat">'+
											'<img src="https://cdn.toprankers.net/images/recordedvideos-0239b7c9ba659.png" />'+
										'</div>'+
										'<div class="batch-stat total">'+
											'<span class="statnum">'+batchData.VideoCount+'</span>'+
											'<span class="text-bold">Total Videos</span>'+
										'</div>'+
										'<div class="batch-stat watched">';							
											var a ="";
											if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
											{
												a = batchData.watchCount;
											}
	bthData +=								'<span class="statnum">'+a+'</span>'+
											'<span class="text-bold">Watched Videos</span>'+
										'</div>';
										if(batchData.ongoing > 0)
							  			{
	bthData +=								'<div class="batch-stat ongoing">'+
				 								'<span class="statnum">'+batchData.ongoing+'</span>'+
				 								'<span class="text-bold">Ongoing Videos</span>'+
				 							'</div>';
							  			}
							  			else if(batchData.upcoming > 0)
							  			{
	bthData +=								'<div class="batch-stat upcoming">'+
				 								'<span class="statnum">'+batchData.upcoming+'</span>'+
				 								'<span class="text-bold">Upcoming Videos</span>'+
				 							'</div>';
							  			}
							  			else if(batchData.past > 0)
							  			{
	bthData +=								'<div class="batch-stat past">'+
				 								'<span class="statnum">'+batchData.past+'</span>'+
				 								'<span class="text-bold">Past Videos</span>'+
				 							'</div>';
							  			}
							  			else if(batchData.demo > 0)
							  			{
	bthData +=								'<div class="batch-stat demo">'+
				 								'<span class="statnum">'+batchData.demo+'</span>'+
				 								'<span class="text-bold">Demo Videos</span>'+
				 							'</div>';
							  			}
	bthData +=						'</div>'+
								'</a>';
								if(batchData.ongoing > 0)
								{
	bthData +=						'<a href="'+url+'#ongoing" data-action="'+dataAction+'" data-delivery-id='+batch+'>';											
								}
								else if(batchData.upcoming > 0)
								{
	bthData +=						'<a href="'+url+'#upcoming" data-action="'+dataAction+'" data-delivery-id='+batch+'>';											
								}
								else if(batchData.past > 0)
								{
	bthData +=						'<a href="'+url+'#past" data-action="'+dataAction+'" data-delivery-id='+batch+'>';											
								}
								else 
								{
	bthData +=						'<a href="'+url+'#demo" data-action="'+dataAction+'" data-delivery-id='+batch+'>';											
								}						
	bthData +=							'<div class="watch-video flex-box">'+
											'<img src="https://cdn.toprankers.net/images/play-video-big@2x-023c731b3d8ff.png" />'+
											'<span class="text-blue">Watch Video</span>'+
										'</div>'+
									'</a>'+
							'</div>';	
				  	}
			 		return bthData;
};
commonprofileController.prototype.UserPackageTestListDetails = function(userTestListData, packageId)
{
	var tlData = "";
				for(var testlist in userTestListData)
				{
					var testListData = userTestListData[testlist];
					var dataAction = "lists/test&id="+testlist;
					var url = this.data.actions["lists/test&id="+testlist];
					if(typeof vidu != 'undefined' && vidu == 1){
						dataAction = "item/package&id="+packageId;
						url = this.data.actions["item/package&id="+packageId];
					}
					if(testListData.pauseCount > 0 && (this.data.myDashboard == true))
				  	{
	tlData +=			'<div class="testList second-order" data-action="testlistPage" data-delivery-id='+testlist+'>'+
							'<div class="text-blue">'+testListData.TestListTitle+'</div>'+
							'<a href="'+url+'#attemptedTests" data-action="'+dataAction+'" class="link-info" data-delivery-id='+testlist+'>';								
				  	}
				  	else if(this.data.myDashboard == true)
				  	{
	tlData +=       	'<div class="testList"  data-action="testlistPage" data-delivery-id='+testlist+'>'+
							'<div class="text-blue">'+testListData.TestListTitle+'</div>'+
							'<a href="'+url+'#purchasedTests" data-action="'+dataAction+'" class="link-info" data-delivery-id='+testlist+'>';					
				  	}
				  	else
				  	{
	tlData +=       	'<div class="testList" data-action="testlistPage" data-delivery-id='+testlist+'>'+
							'<div class="text-blue">'+testListData.TestListTitle+'</div>'+
							'<a href="'+url+'#freeTests" data-action="'+dataAction+'" class="link-info" data-delivery-id='+testlist+'>';							
				  	}
	tlData +=       			'<div class="testList-info">'+
									'<div class="test-img testList-stat">'+
										'<img src="https://cdn.toprankers.net/images/mocktest-0239b7c9bb059.png" />'+
									'</div>'+
									'<div class="testList-stat total">'+
										'<span class="statnum">'+testListData.TestCount+'</span>'+
										'<span class="text-bold">Total Tests</span>'+
									'</div>'+
									'<div class="testList-stat attempted">';
										var a ="";
										if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
										{
											a = testListData.attemptCount;
										}
	tlData +=            				'<span class="statnum">'+a+'</span>'+
										'<span class="text-bold">Attempted Tests</span>'+
									'</div>';
									var unattempted = testListData.TestCount-testListData.attemptCount;
	tlData +=                       '<div class="testList-stat unattempted">';									
										if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true))
										{
	tlData += 								'<span class="statnum">'+unattempted+'</span>';
										}
	tlData += 								'<span class="text-bold">Unattempted Tests</span>'+
									'</div>'+
								' </div>'+
							'</a>';
							if(testListData.pauseCount > 0 && (this.data.myDashboard == true))
							{
	tlData +=					'<a href="'+url+'#attemptedTests" data-action="'+dataAction+'" data-delivery-id='+testlist+'>'+
									'<div class="take-test flex-box">'+
										'<img src="https://cdn.toprankers.net/images/retake-test@2x-023c731b3d4d9.png" />'+
										'<span class="text-blue">Resume Test</span>'+
									'</div>'+
								'</a>';
							}
							else if(this.data.myDashboard == true)
							{
	tlData +=					'<a href="'+url+'#purchasedTests" data-action="'+dataAction+'" data-delivery-id='+testlist+'>'+
									'<div class="take-test flex-box">'+
										'<img src="https://cdn.toprankers.net/images/take-test-big@2x-023c731b3cf86.png" />'+
										'<span class="text-blue">Take Test</span>'+
									'</div>'+
								'</a>';
							}
							else
							{
	tlData +=					'<a href="'+url+'#freeTests" data-action="'+dataAction+'" data-delivery-id='+testlist+'>'+
									'<div class="take-test flex-box">'+
										'<img src="https://cdn.toprankers.net/images/take-test-big@2x-023c731b3cf86.png" />'+
										'<span class="text-blue">Resume Test</span>'+
									'</div>'+
								'</a>';
							}
	tlData +=			'</div>';
				}
				return tlData;
};
commonprofileController.prototype.UserSubscribedExamsDetails = function(subSExamsData)
{
	var subscribedExams = "";
	subscribedExams +=	'<div class="userSubscriptionInfo">'+
							'<div class="catList">'+				
								'<span class="glyphicon glyphicon-chevron-left category-headbtnleft"></span>'+
								'<ul class="nav nav-tabs cattabList">';
									var once = true;
								  	for(var cindex in subSExamsData.categories)
								  	{
								  		var categoryData = subSExamsData.categories[cindex];
								  		if(once)
								  		{
	subscribedExams +=	  					'<li class="active category-head" data-delivery-id='+cindex+'><a href="#category'+cindex+'" data-toggle="tab">'+categoryData.title+'</a></li>';
								  		}
								  		else
								  		{
	subscribedExams +=	  					'<li class="category-head" data-delivery-id='+cindex+'><a href="#category'+cindex+'" data-toggle="tab">'+categoryData.title+'</a></li>';
								  		}
								  		once = false;
								  	}
	subscribedExams +=			 '</ul>'+
								 '<span class="glyphicon glyphicon-chevron-right category-headbtnright"></span>'+
							'</div>'+
							'<div class="tab-content">';
								var once1 = true;
							  	for(var cindex in subSExamsData.categories)
							  	{
							  		
							  		var categoryData = subSExamsData.categories[cindex];	
							  		if(once1)
							  		{
	subscribedExams +=	  				'<div id="category'+cindex+'" class="category-view tab-pane fade in active" data-item='+cindex+' data-delivery-id='+categoryData.id+'>';
							  		}
							  		else
							  		{
							  			
	subscribedExams +=	  				'<div id="category'+cindex+'" class="category-view tab-pane fade" data-item='+cindex+' data-delivery-id='+categoryData.id+'>';
							  		}
							  		once1 = false;
							  		for(var exam in categoryData.Exams)
							  		{
							  				var examData = categoryData.Exams[exam];
	subscribedExams +=                      '<div class="exam" data-delivery-id='+exam+'>'+
												'<div class="ExamTitle">'+examData.title+'</div>'+
												'<div class="page-links">';
													if((typeof examData.Batch !=='undefined') && Object.keys(examData.Batch).length == 1)
													{
	subscribedExams +=									'<div class="batch-link flex-box" data-action="batchPage">';
															for(var batch in examData.Batch)
															{
																var dataAction = "item/batch&id="+batch;
																var url = this.data.actions["item/batch&id="+batch];
																var batchData = examData.Batch[batch];
	subscribedExams +=											'<a href="'+url+'#demo" data-action='+dataAction+' data-delivery-id='+batch+'>'+
																	'<span class="watch-video1 flex-box">'+
																		'<img src="https://cdn.toprankers.net/images/play-video-big@2x-023c731b3d8ff.png" />'+
																		'<span class="text-link">Watch Video</span>'+
																	'</span>'+
																'</a>';			
															}
	subscribedExams +=    		                          '</div>';																												
													}
													else if((typeof examData.Batch !=='undefined') && Object.keys(examData.Batch).length >1)
													{
	subscribedExams += 									'<div class="batch-link flex-box">'+
															'<span class="watch-video1 flex-box" data-action="viewlinkLists">'+
																'<img src="https://cdn.toprankers.net/images/play-video-big@2x-023c731b3d8ff.png" />'+
																'<span class="text-link">Watch Video</span>'+
																'<div class="page-link" data-action="batchPage">'+
																	'<div class="page-link-head" >Select The Batch You Want to go</div>';
																	for(var batch in examData.Batch)
																	{
																		var batchData = examData.Batch[batch];
																		var dataAction = "item/batch&id="+batch;
																		var url = this.data.actions["item/batch&id="+batch];
	subscribedExams +=													'<a href="'+url+'#demo" data-action='+dataAction+' data-delivery-id='+batch+'>'+
																			'<div class="subscribed-link flex-box">'+
																				'<img src="https://cdn.toprankers.net/images/recordedvideos-0239b7c9ba659.png">'+
																				'<span>'+batchData.title+'</span>'+
																			'</div>'+
																		'</a>';			
																	}
	subscribedExams +=											'</div>'+
															'</span>'+
														'</div>';																	
													}
													if((typeof examData.testList !=='undefined') && Object.keys(examData.testList).length == 1)
													{
	subscribedExams +=									'<div class="testList-link flex-box" data-action="testlistPage">';	
															for(var testlist in examData.testList)
															{
																var testlistData = examData.testList[testlist];
																var dataAction = "lists/test&id="+testlist;
																var url = this.data.actions["lists/test&id="+testlist];
	subscribedExams +=											'<a href="'+url+'#demo" data-action='+dataAction+' data-delivery-id='+testlist+'>'+	
																	'<span class="take-test1 flex-box">'+
																		'<img src="https://cdn.toprankers.net/images/take-test-big@2x-023c731b3cf86.png" />'+
																		'<span class="text-link">Take Test</span>'+
																	'</span>'+
																'</a>';													
															}
	subscribedExams +=									'</div>';
													}
													else if((typeof examData.testList !=='undefined') && Object.keys(examData.testList).length > 1)
													{
	subscribedExams +=									'<div class="testList-link flex-box">'+
															'<span class="take-test1 flex-box" data-action="viewlinkLists">'+
																'<img src="https://cdn.toprankers.net/images/take-test-big@2x-023c731b3cf86.png" />'+
																'<span class="text-link">Take Test</span>'+
																'<div class="page-link" data-action="testlistPage">'+
																	'<div class="page-link-head">Select The TestList You Want to go</div>';
																	for(var testlist in examData.testList)
																	{
																		var testlistData = examData.testList[testlist];
																		var dataAction = "lists/test&id="+testlist;
																		var url = this.data.actions["lists/test&id="+testlist];
	subscribedExams +=													'<a href="'+url+'#demo" data-action='+dataAction+' data-delivery-id='+testlist+'>'+	
																			'<div class="subscribed-link flex-box">'+
																				'<img src="https://cdn.toprankers.net/images/mocktest-0239b7c9bb059.png">'+
																				'<span>'+testlistData.title+'</span>'+
																			'</div>'+
																		'</a>';													
																	}
	subscribedExams +=											'</div>'+
															'</span>'+
														'</div>';
													}
	subscribedExams +=	  						'</div>'+
											'</div>';		
						  				}
	subscribedExams +=				 '</div>';
						  			}
	subscribedExams +=	 		 '</div>'+
							'</div>'+
							'<div class="subscribe-exams" data-action="subscribe">'+
								'<span class="text-blue">Subscribe Exams</span>'+
							'</div>';				
	return subscribedExams;
};
commonprofileController.prototype.showPublicmodal = function(callback)
{
	if(confirm("Change your profile privacy to public."))
	{
		tr$.ajax({
			type: "POST",
			mod: "tr2user",
			ack: "makepublicprofile",
			successClb: function(reply){
				if(reply.result.state == "ok")
				{
					callback(true);
				}
				else
				{
					alert(reply.result.meta); 
				}
			}.bind(this)
		});
	}
};
commonprofileController.prototype.ShowShareDialog = function()
{
	$("#profile-share-modal .js-share").unbind().bind("click",this,function(e){
		$("#profile-share-modal").modal('hide');
		//var	url = document.URL.split("#")[0];
		
		tr$.ajax({
			mod : "user",
			ack : "getprofileurl",
			
			successClb : function(response) {
				try {
						if (response.result.state == "ok") 
						{
							console.log(response.data);
							console.log(this);
							console.log(e);
							var	url = remoteServer+"/"+response.data;
							var media = $(this).data("media");
							e.data.SharePost(url,media);
						}
					} catch(e) {
						console.log(response.data);
						console.log("error=" + e);
					}
			}.bind(this),
			errorClb : function() {
				//TODO show some relavent msg
			}
		});
		
	});
	$("#profile-share-modal").modal('show');
	UrlMgmt.getObj().modalObj = $("#profile-share-modal");
};
commonprofileController.prototype.getContactDetailsmodal = function()
{

		$('#getContactDetails-modal').modal('show');
		var phoneNo = ((this.userInfo.settings.length > 0) && typeof this.userInfo.settings[0] != "undefined" && typeof this.userInfo.settings[0]["2"] != "undefined" && !isNaN(this.userInfo.settings[0]["2"])) ? this.userInfo.settings[0]["2"] : "";
		var getContactDetails="";
		$("#getContactDetails-modal .modal-dialog .modal-content .modal-body .contact-element_phoneno input").attr("value", phoneNo);
		
		if(typeof this.userInfo.emailId != "undefined" && this.userInfo.emailId != "" && this.userInfo.emailId !== null)
        {
        	getContactDetails = '<input type = "text"  class="disablepointerevent" data-contact-type="emailId" placeholder="Enter email" value="'+this.userInfo.emailId+'">';
        }
        else
        {
        	var emailId = this.userInfo.emailId == null ? '' : this.userInfo.emailId;
        	getContactDetails = '<input type = "text"  data-contact-type="emailId" placeholder="Enter email" value="'+emailId+'">';
        }
		$("#getContactDetails-modal .modal-dialog .modal-content .modal-body .contact-element").html(getContactDetails);
		
		var urlmgmt = UrlMgmt.getObj();
		var userId = this.userInfo.id;
		 $('[data-action="detailsSubmit"]').unbind().bind("click",this,function(){
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().App.onOffline();
				return false;
			}
			$(".warning-msg").hide();
			var phoneNoTxt = $("[data-contact-type='mobileNo']").val();
			if(phoneNoTxt == "")
			{
				$(".warning-msg").hide();
				$(".warning-msg.msg3").show();
				return;
			}
			var	phoneNo = parseInt(phoneNoTxt);
			var emailId = $("[data-contact-type='emailId']").val();
			var detailerror = 0;
			
			if(phoneNoTxt != ""){
				if(isNaN(phoneNo))
				{
					$(".warning-msg.msg1").show();
					detailerror = 1;
				}
				if(phoneNo < 1000000000 || phoneNo>9999999999)
				{
					$(".warning-msg.msg2").show();
					detailerror = 1;
				}
			}
			if(emailId != "")
			{
				var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
  				if(!regex.test(emailId))
  				{
					$(".warning-msg.msg4").show();
					detailerror = 1;
  				}
			}
			if(detailerror == 1)
				return;
				
			var urlMgmt = UrlMgmt.getObj();
			urlMgmt.showLoader();				
			tr$.ajax({
				type : "POST",
				mod : "user",
				ack : "getContactDetails",
				additionalParams:{
					userId : userId,
					phno : phoneNo,
					emailId : emailId,
					code: "+91"
				},
				successClb : function(reply){
					try 
					{
						if (reply.result.state == "ok")
						{
							$('#getContactDetails-modal').modal('hide');
							
							setTimeout(function(){
									UrlMgmt.getObj().Refresh();
									var urlMgmt = UrlMgmt.getObj();
									urlMgmt.removeLoader();
							}, 3000);
						}
					} catch(e) {
						alert("Internal System Error");
					}
				}
			});
		});
};
commonprofileController.prototype.SharePost = function(url,media)
{
	switch(media)
	{
		case "facebook":
			//window.plugins.socialsharing.shareViaFacebook("Shared data in Facebook",null, url, function(){console.log("shared successful");},function(){console.log("shared unsuccessful");});
			window.open('https://www.facebook.com/sharer/sharer.php?u=' + encodeURIComponent(url), 'facebook-popup', 'height=350,width=600').focus();
			break;
		case "twitter":
			window.open('https://twitter.com/share?url=' + encodeURIComponent(url), 'twitter-popup', 'height=350,width=600').focus();
			break;
		case "google-plus":
			window.open('https://plus.google.com/share?url=' + encodeURIComponent(url), 'gshare', 'height=350,width=600').focus();
			break;
	}
};
commonprofileController.prototype.createTransferCashNode = function(callback){
	this.transferNode = '<div class="common-modal-style transferCash modal fade" id="transferCash" tabindex="-1" role="dialog" aria-labelledby="memberModalLabel" aria-hidden="true">'+
						    '<div class="modal-dialog comnTransition">'+
						        '<div class="modal-content">'+
						            '<div class="modal-header">'+
						                '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><img src="img/backward_arrow_white.png" /></button>'+
						                '<h4 class="modal-title text-center" id="memberModalLabel">Transfer Cash</h4></div>'+
						            '<div class="modal-body">'+
										'<div class="TransferAmountDiv">'+
											'<input type="text" class="TRCashRecipent" placeholder="Account No of the Cash Recipent">'+
											'<input type="text" class="TRCashAmount" data-balance="'+this.userBalance+'" data-acc="'+this.accountId+'" placeholder="Amount to transfer">'+
											'<a class="TransferTRCash btn btn-primary" data-loading="false" data-action="transfertrcash">Transfer</a>'+
										'</div>'+
									'</div>'+
								'</div>'+
							'</div>'+
						'</div>';
	callback();
};
commonprofileController.prototype.GetuserAccount = function(callback)
{
	tr$.ajax({
		type: "POST",
		mod: "tr2user",
		ack: "GetUserEcommAccount",
		additionalParams:{
			domain: -100,                 ///ecommDomainId,
			userId: this.userInfo.id,
			accountId: this.accountId,
		},
		successClb: function(reply){
			if(reply.result.state == "ok"){
				this.accountData = reply.data;
				this.CreateAccountView(function(accountModal){
					//$("#accountInfoAppendModal").html(accountModal);
					$('#accountInfo #couponRedemptionmsg').html('');
					$('#accountInfo .AccountView .redeem-vouchar .CouponTxt').val('');
					$('#accountInfo').modal('show');
					UrlMgmt.getObj().modalObj = $('#accountInfo');
					$('[data-action="redeemvoucher"]').unbind().bind("click", this, function(e){
						if(typeof e.data.data.addressSectionId != "undefined" && jQuery.isEmptyObject(e.data.data.address.values))
						{
							alert("Updating the users address is mandatory");
							$('#accountInfo').modal('hide');
						 	var r = document.querySelector('#commonprofileController .user-info');
							var p = r.querySelector('.Address-details');
							$(e.data.dom).animate({
								scrollTop : parseInt( p.getElementsByClassName('fieldDiv')[0].offsetTop)
							}, 1000);
							return;
						}						
						e.data.Redeemvoucher(function(success,reply){
							$("#couponRedemptionmsg").text((success?"Congratulations! ":"Sorry! ")+reply);
							$("#couponRedemptionmsg").removeClass('success').removeClass('fail').addClass(success?'success':'fail');
							if(success) {
								setTimeout(function(){
									UrlMgmt.getObj().Refresh();
								}, 3000); 
							}
						});
					});
					$('[data-action="downloadstatement"]').unbind().bind("click", this, function(e){
						var output = "";
						
						$(".accountstatement").find("tr").each(function(){
								$(this).find("th, td").each(function(){
									output += ($(this).text()+", ");
								});
								output += "\n";
							});
						if(output == "")
						{
							alert("There is no statement to download");
							return;
						}
						window.resolveLocalFileSystemURL("file:///storage/emulated/0", function(dir) {
							dir.getFile("my_statement.csv", {create:true}, function(fileEntry) {
								fileEntry.createWriter(function(writer){
									writer.onwrite = function(evt) {
								        alert("my_statement.csv downloaded");
								    };
								    writer.write(output);
								    
								});
							});
						});
					}.bind(this));
					$(".sel-smt-month").change(this,function(e){
						e.data.GetUserTransactionPerMonth($(this).val());
					});
				}.bind(this));
			}
			else
				console.log(reply.result.meta);
		}.bind(this),
		
	});
};
commonprofileController.prototype.Transfertrcash = function()
{
	var recipentacc = parseInt($(".TRCashRecipent").val());
	$(".TRCashRecipent").removeClass("TError");
	if(isNaN(recipentacc) || recipentacc == 0)
	{
		$(".TRCashRecipent").addClass("TError");
		alert("Please provide a valid numeric Account Number to whom you want to transfer!");
		return;
	}
	$(".TRCashAmount").removeClass("TError");
	var amountToTransfer = parseInt($(".TRCashAmount").val());
	if(isNaN(amountToTransfer) || amountToTransfer <= 0)
	{
		$(".TRCashAmount").addClass("TError");
		alert("Please provide positive non-zero amount to transfer!");
		return;
	}
	
	var balance = parseInt($(".TRCashAmount").attr("data-balance"));
	if(isNaN(balance) || amountToTransfer > balance)
	{
		$(".TRCashAmount").addClass("TError");
		alert("Insufficient funds in your wallet!");
		return;
	}
	if($('.TransferTRCash').attr("data-loading") == "true")
	{
		alert("Transaction is in progress!");
		return;
	}
	$('.TransferTRCash').attr("data-loading", "true"); 
	var transfereracc = parseInt($(".TRCashAmount").attr("data-acc"));
	tr$.ajax({
		type: "POST",
		mod: "ecomm",
		ack: "getAccountHoldersName",
		additionalParams:{
				recipentacc:recipentacc,
				amount:amountToTransfer,
				transfereracc:transfereracc
		},
		//context:{amount:amountToTransfer, recipentacc:recipentacc, transfereracc:transfereracc},	
		successClb: function(reply){
			if(reply.result.state == "ok")
			{
				if(confirm("Are you sure you want to transfer ₹"+amountToTransfer+" to "+reply.data+"?"))
				{
					tr$.ajax({
						type: "POST",
						mod: "ecomm",
						ack: "transferTRCash",
						additionalParams:{
							recipentacc:recipentacc,
							amount:amountToTransfer,
							transfereracc:transfereracc
						},
							successClb: function( reply1){
								if(reply1.result.state == "ok")
								{
									alert("Transferred successfully!");		
									setTimeout(function(){
										UrlMgmt.getObj().Refresh();
									}, 3000); 					
								}
								else
								{
									alert(reply1.result.meta);
								}
								$('.TransferTRCash').attr("data-loading", "false");
							}
					});
				}
				else
				{
					$('.TransferTRCash').attr("data-loading", "false");
				}	
			}
			else
			{
				alert(reply.result.meta);
				$('.TransferTRCash').attr("data-loading", "false"); 
			}
		}
	});	
};
commonprofileController.prototype.Redeemvoucher = function(callbackFunc){
	$("#couponRedemptionmsg").text('Loading..');
	var code = $(".CouponTxt").val().toUpperCase();
	tr$.ajax({
		type: "POST",
		mod: "ecomm",
		ack: "couponredeem",
		additionalParams:{
			code : code,
		},
		successClb: function( reply){
           try
           {
			  	if(reply.result.state == "ok")
			   	{
					if(typeof callbackFunc == "function")
						callbackFunc.call(null,reply.data.state,reply.data.msg);
				}
			   else
			   {
					if(typeof callbackFunc == "function")
						callbackFunc.call(null,false,reply.result.meta);
				}
           }
           catch(e)
           {
				if(typeof callbackFunc == "function")
					callbackFunc.call(null,false,"Unexpected system error!\n"+e.message+"\n"+JSON.stringify(event.responseJSON));
           }		   
		}
	});		
};
commonprofileController.prototype.CreateAccountView = function(callback){
	this.balance = $('.account-balance .number-text').html();
										    
	 var AccountsInfo =
												'<table class="AccountsTable">'+
													'<tbody>'+
														'<tr>'+
															'<th>Account No:</th>'+
															'<th>Balance</th>'+
														'</tr>'+
														'<tr>'+
															'<td>'+this.accountId+'</td>'+
															'<td>'+this.balance+'</td>'+
														'</tr>'+
													'</tbody>'+
												'</table>';
	$('#accountInfo .modal-dialog .modal-content .modal-body .AccountView .AccountsInfo').html(AccountsInfo);
	var total = parseInt(this.accountData.UserTransaction.prev_total)+parseInt(this.accountData.UserTransaction.month_total);										
	var Accountdebitcredit =
													'<label class="balance">Opening Balance: </label> <span class="txt-bal">'+this.accountData.UserTransaction.prev_total+'</span>'+
													'<label class="balance">Debits: </label> <span class="txt-bal">'+this.accountData.UserTransaction.total_debit+'</span>'+
													'<label class="balance">Credits: </label> <span class="txt-bal">'+this.accountData.UserTransaction.total_credit+'</span>'+ 
													'<label class="balance">Total: </label> <span class="txt-bal bal-month">'+this.accountData.UserTransaction.month_total+'</span>'+
													'<label class="balance">Closing Balance: </label> <span class="txt-bal bal-total">'+total+'</span>';
											
	$('#accountInfo .modal-dialog .modal-content .modal-body .AccountView .Accountdebitcredit').html(Accountdebitcredit);											
	var  listoftransaction =
											// '<div class="listoftransaction" accountId="'+this.accountId+'">'+
												'<div class="table-caption text-blue">ACCOUNT STATEMENT</div>'+
												'<div class="statement-paginate">'+
													'<label>Monthly Statement: </label>'+
													'<select class="sel-smt-month" id="accounts">';
	var monthNames = ['','January(1)',
			'February(2)',
			'March(3)',
			'April(4)',
			'May(5)',
			'June(6)',
			'July(7)',
			'August(8)',
			'September(9)',
			'October(10)',
			'November(11)',
			'December(12)'];
	var i = 0;
	for (i = 0; i < this.accountData.UserDebitCreditInfo.length; i++) 
	{ 
		listoftransaction +=								'<option value="'+this.accountData.UserDebitCreditInfo[i].year+','+this.accountData.UserDebitCreditInfo[i].month+'">'+monthNames[this.accountData.UserDebitCreditInfo[i].month]+'</option>';
	}
	listoftransaction +=
													'</select>'+
													'<div class="downloadbox" data-action="downloadstatement">'+
														'<a id="downloadStatement" class="downloadBtn btn btn-primary"><x-icon src="icon_download-arrow" class="small" ></x-icon> Download</a>'+
													'</div>'+
												'</div>'+
												'<div class="table_div">'+	
												'<table class="accountstatement text-center">'+
													'<thead>'+
														'<tr>'+
															'<th class="acntstateHead">Transaction Id</th>'+
															'<th class="acntstateHead">Related TrnsId</th>'+
															'<th class="acntstateHead">Date / Time</th>'+
															'<th class="acntstateHead">Amount</th>'+
															'<th class="acntstateHead">Type</th>'+
															'<th class="acntstateHead">Comment</th>'+
														'</tr>'+
													'</thead>'+
													'<tbody class="accstatemntbdy">';
	for (i = 0; i < this.accountData.UserTransaction.list.length; i++)
	{
		if(this.accountData.UserTransaction.list[i].amount > 0)
			var type = "Credit";
		else if(this.accountData.UserTransaction.list[i].amount > 0)
			var type = "Debit";
		else
			var type = "-";
		var relTxnId = (this.accountData.UserTransaction.list[i].relTxnId != null)?this.accountData.UserTransaction.list[i].relTxnId:'';
	listoftransaction +=
														'<tr>'+
															'<td class="accountvalues txn">'+this.accountData.UserTransaction.list[i].id+'</td>'+
															'<td class="accountvalues rel-txn">'+relTxnId+'</td>'+
															'<td class="accountvalues date-time">'+this.accountData.UserTransaction.list[i].createdOn+'</td>'+
															'<td class="accountvalues amt">'+this.accountData.UserTransaction.list[i].amount+'</td>'+
															'<td class="accountvalues type">'+type+'</td>'+
															'<td class="accountvalues comment">'+this.accountData.UserTransaction.list[i].comment+'</td>'+		
														'</tr>';
	}
	listoftransaction +=
													'</tbody>'+
												'</table>'+
												'</div>';
    $('#accountInfo .modal-dialog .modal-content .modal-body .AccountView .listoftransaction').html(listoftransaction);
    $('#accountInfo .modal-dialog .modal-content .modal-body .AccountView .listoftransaction').attr("accountId", this.accountId);
	var acountModal  = "";
	callback(acountModal);
};
commonprofileController.prototype.GetUserValues =function(callback){
	this.name = $(".Username").val();
	this.phone = $(".Userphone").val();
	this.email = $(".Useremail").val();
	this.newpassword = $(".newpassword").val().trim();
	this.confirmpassword = $(".confirmpassword").val().trim();
	this.profilePrivacy = $(".Privacy").val(); // needs to be implemented
	callback();
};
commonprofileController.prototype.OpenProfileEdit = function ()
{
	var profileData = this.userInfo;
	var html = "";
	$('#editProfile-modal').modal('show');
	html += '<div class="Profile-image1" style="background-image: url('+remoteServer+'/attachment/profile-thumbnail/'+UrlMgmt.getObj().userData['id']+'/'+(new Date().getTime())+');">';
	if((typeof this.data.myDashboard !== "undefined") && (this.data.myDashboard === true)){
		html +=	'<span class="uploadprofilepic-icon" data-action="uploadprofilepic" aria-hidden="true">'+
					'<img src="https://cdn.toprankers.net/images/edit@2x-023c731b3e6ef.png" />'+
				'</span>';
	}	 			
	html += '<input type="file" id="profile_uploadPicture" accept="image/x-png, image/jpeg">'+
			'<div class="profile_pic_Notification"></div>'+
		'</div>'+
		'<span class="uploading_status"></span>'+
		'<div class="profile-element" style="margin-top:15px;">'+
			'<input type = "text" class="Username" value="'+profileData.displayName+'">'+
		'</div>'+
		'<div class="profile-element_phoneno">'+
			'<span class="country-code">+91</span>'+
			'<input type = "text" class="Userphone" value="'+((profileData.settings.length > 0) && !isNaN(profileData.settings[0]["2"])?profileData.settings[0]["2"]:"")+'">'+
		'</div>'+
		'<div class="profile-element privacy-elem">'+
			'<span>Privacy:</span>'+
			'<select class="Privacy">'+
				'<option value="0">Private</option>'+
				'<option value="1">Public</option>'+
			'</select>'+
		'</div>'+
		'<div class="profile-element" style="margin-top:15px;">'+
			'<h4 class="text-left">Change Password</h4>'+
			'<input type = "password" class="newpassword" placeholder="Enter new password">'+
			'<input type = "password" class="confirmpassword" placeholder="Confirm new password">'+
		'</div>'+
		'<div class="profile_msg"></div>'+
			'<button class="savesettings btn btn-primary" data-action="savesettings">Save Settings</button>'+
		'</div>'+
	'</div>'+
	'</div>'+
	'</div>';
						
	$('#editProfile-modal').find('.modal-body').html(html);
	$('.Privacy option[value="'+((this.userInfo.settings.length > 0)?this.userInfo.settings[0]["8"]:"")+'"]').attr('selected','selected');
	this.editProfilenode = $(html);
	
	UrlMgmt.getObj().modalObj = $('#editProfile-modal');
	$('[data-action="savesettings"]').unbind().bind("click", this, function(e){
		e.data.GetUserValues(function(){
			e.data.SaveProfile();
		}.bind(e.data));
	});
	$('[data-action="uploadprofilepic"]').unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		this.UploadProfilePic();
	}.bind(this));
	var newpassword = $("input.newpassword"); // to remove the spaces if the user gives it as a passowrd.
 	var func = function() {
     	newpassword.val(newpassword.val().replace(/\s/g, ''));
 	};
 	newpassword.keyup(func).blur(func);
 	var confirmpassword = $("input.confirmpassword");
 	var func1 = function() {
    confirmpassword.val(confirmpassword.val().replace(/\s/g, ''));
 	};
 	confirmpassword.keyup(func1).blur(func1);
};
commonprofileController.prototype.SentEmailVerificationLink = function(callbackFunction)
{
	tr$.ajax({
		type: "POST",
		mod: "user",
		ack: "sentemailverificationlink",
		successClb: function( reply){
			callbackFunction(reply);	   
		}
	});
};
commonprofileController.prototype.UploadProfilePic = function() {
	
	navigator.camera.getPicture(onSuccess, onFail, {
		quality : 100,
		destinationType : Camera.DestinationType.FILE_URI,
		sourceType : Camera.PictureSourceType.PHOTOLIBRARY
	});

	function win(r) {
		console.log("Code = " + r.responseCode);
		console.log("Response = " + r.response);
		console.log("Sent = " + r.bytesSent);
		if(r.bytesSent > 4000000)
		{
			$('#editProfile-modal .modal-dialog .modal-content .modal-body .uploading_status').html('');
			alert("Image must not be more that 4MB");
			
		}
		if(JSON.parse(r.response).result.state == "ok")
		{
			$('#editProfile-modal .modal-dialog .modal-content .modal-body .uploading_status').html('');
			$('#editProfile-modal').modal('hide');
			UrlMgmt.getObj().Refresh();
		}
	}

	function fail(error) {
		alert("An error has occurred: Code = " + error.code);
		console.log("upload error source " + error.source);
		console.log("upload error target " + error.target);
	}

	function onSuccess(imageURI) {
		var uri = encodeURI(remoteServer + '/?route=common/ajaxupload&uploadtype=0');
		var filepath = imageURI;
		var options = new FileUploadOptions();
		options.chunkedMode = true;
		options.fileKey = "image";
		options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
		var ft = new FileTransfer();
		$('#editProfile-modal .modal-dialog .modal-content .modal-body .uploading_status').html('Uploading...');
		ft.upload(filepath, uri, win, fail, options);
		
	}
	function onFail(message) {
		alert('Failed because: ' + message);
		$('#editProfile-modal .modal-dialog .modal-content .modal-body .uploading_status').html('');
	}

}; 

commonprofileController.prototype.SaveProfile = function()
{
	$(".profile_msg").html("");
	var password1 = this.newpassword;
	var password2 = this.confirmpassword;
	var name = this.name;
	var phno = this.phone;
	var code = "+91";
	var ProfilePrivacy = this.profilePrivacy;
	if(name == "")
	{
		$(".profile_msg").html("<span class='error'>Error: Name can not be empty</span>");
		return;
	}
	if(name.length > 42)
	{
		$(".profile_msg").html("<span class='error'>Error: Name can not be of more than 42 characters</span>");
		return;
	}
	if(password1 != password2)
	{
		$(".profile_msg").html("<span class='error'>Error: Confirmed password is different</span>");
		return;
	}
	if(phno.length > 0 && phno.length != 10 || phno.match(/[^0-9]/))
	{
		$(".profile_msg").html("<span class='error'>Error: Mobile number should be 10 digits</span>");
		return;
	}
	tr$.ajax({
		type: "POST",
		mod: "tr2user",
		ack: "updateprofile",
		additionalParams:{
				name : name,
				password:password2,
				code: code,
				phno: phno,
				ProfilePrivacy: ProfilePrivacy
		},	
		successClb: function(reply){
           try
           {
			  	if(reply.result.state == "ok")
			   	{
					$(".profile_msg").html("<span class='success'>Your settings have been saved!</span>");
					if(this.userInfo.settings.length > 0)
					{
					this.userInfo.settings[0]["8"] = parseInt(ProfilePrivacy);
					this.userInfo.settings[0]["2"] = (!isNaN(phno)?phno:"");
					$('.Privacy option[value="'+this.userInfo.settings[0]["8"]+'"]').attr('selected','selected');
					}
					
					this.userInfo.displayName = name;
					
					$('#editProfile-modal').modal('hide');
					
					$('.profile-dashboard-info').find('.name-info').text('');
					$('.profile-dashboard-info').find('.name-info').text(name);
					
					$('.phone-info').find('.number-text').text('');
					$('.phone-info').find('.number-text').text(phno);
					setTimeout(function(){
						$(".profile_msg").html("<span class='success'>Your settings have been saved!</span>");
					});
					setTimeout(function(){
						UrlMgmt.getObj().Refresh();
					}, 300); 
				}
			    else
			    {
				   $(".profile_msg").html("<span class='error'>Error: "+reply.result.meta +"!</span>");
				}
           }
           catch(e)
           {
			   $(".profile_msg").html("<span class='error'>Internal System Error!</span>");
           }		   
		}.bind(this)
	});
};
commonprofileController.prototype.GetUserTransactionPerMonth = function(value) {
	var accountId = this.accountId;
	
	if(this.userInfo.id > 0)
	{
		tr$.ajax({
		type: "GET",
		mod: "ecomm",
		ack: "getusermonthlytransactions",
		additionalParams:{
				id:accountId,
				month: value,
			},
		successClb: function( reply){
			try
			{
				$(".accstatemntbdy").html("");
				for(var t in reply.data.list)
				{
					var r = reply.data.list[t];
					var row = $(
							'<tr>'+
								'<td class="accountvalues txn">Txn</td>'+
					  			'<td class="accountvalues rel-txn">Rel Txn</td>'+
					  			'<td class="accountvalues date-time">Date/Time</td>'+
					  			'<td class="accountvalues amt">Amount</td>'+
					  			'<td class="accountvalues type"></td>'+
					  			'<td class="accountvalues comment">Comment</td>'+	
							'</tr>');
				   $(".accstatemntbdy").append(row);
				   var type = "-";
				   if(r.amount > 0)
					{type = "Credit";}
					else if(r.amount < 0)
					{type = "Debit";}
				   row.find(".txn").text(r.id);
				   row.find(".rel-txn").text(r.relTxnId?r.relTxnId:"-");
				   row.find(".date-time").text(r.createdOn);
				   row.find(".amt").text(r.amount);
				   row.find(".type").text(type);
				   row.find(".comment").text(r.comment);
				}
			}
			catch(e)
			{	
					
			}		   
			}.bind(this)
		});
	}
};