var commontr2quizlistsController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	
	this.quizlists = null;
};
commontr2quizlistsController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.quizlists = urlMgmt.menuData.quizLists;
	this.SetLayout();
	this.PopulateUI();
	this.BindEvents();
	analytics_trackView("quiz_list");
	analytics_trackEvent("quiz_list" , '/quiz_list');
	urlMgmt.removeLoader();
};
commontr2quizlistsController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Quizzes', false, true, false);
};
commontr2quizlistsController.prototype.BindEvents = function()
{
	var urlMgmt = UrlMgmt.getObj();
	$('[data-action="quizlistPage"]').unbind().bind('click',function(e){
		var quizlistId = $(e.currentTarget).attr('quizlist-id');
		urlMgmt.Route({route: "lists/quiz&id="+quizlistId, needData: true, offlineAllowed: true, emptyStack: true});
	}.bind(this));
};
commontr2quizlistsController.prototype.PopulateUI = function()
{
	console.log(this.quizlists);
	var html = "";
	for(var quizlistId in this.quizlists)
	{	
		var quizlist = this.quizlists[quizlistId];
		html += '<div class="quizlistname" quizlist-id="'+ quizlist["id"] +'" data-action="quizlistPage">'+
					'<p>'+quizlist["title"]+'</p>'+
					'<img src="img/right-nav-blue.png">'+
				'</div>';	
	}
	this.dom.find('.quizlistsContainer').html(html);
};