var itemdescriptivetestController = function()
{ 
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.report = 0;
	outerthis = null;
	outerdom = null;
};

itemdescriptivetestController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	outerdom = viewDom;
	outerthis = this;
	var urlMgmt = UrlMgmt.getObj();
	this.SetLayout();
	tr$.ajax({
			    url: this.id+'?response-type=2',
			    successClb : function(response) {
			      // try 
			      // {
			        // console.log(response.data);
			        this.data = response.data;
			        if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
						this.OfflineInit();	
					}
					else{
						this.OnlineInit();
					}
					urlMgmt.removeLoader();
			      // }
			      // catch(e) 
			      // {
			        // console.log(e);
			      // }
			    }.bind(this),
			    errorClb : function() {
			      //TODO show some relavent msg
			    }
			});

};

itemdescriptivetestController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Descriptive Test', false, true, false);	
};

itemdescriptivetestController.prototype.OnlineInit = function()
{
	if($(this.dom).find(".tryagain").length != 0)
	$(this.dom).find(".tryagain").remove();
	
	// tr$.touchScrollAnimation(this.dom);
	this.LoadContent();
	// this.LoadFaqs();
	this.BindEvents();
};

itemdescriptivetestController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);	
};

itemdescriptivetestController.prototype.LoadContent = function()
{
	UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, this.data.testData.title, false, true, false);	
	var descriptive_html = '';
	descriptive_html +=	    '<div class="">'+
								'<div class="Assignment">'+
									'<div class="assignment_discription">'+
										'<span>'+
											'<h3 class="title">'+this.data.testData.title+'</h3>'+
										'</span>';//qcommonText.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
	var formula_conversion = '';
	if(typeof this.data.testData.data != "undefined" && this.data.testData.data != null)
	{
		formula_conversion = (this.data.testData.data.description).replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
	}
	
	descriptive_html +=					'<span>'+formula_conversion+'</span>'+
										// '<hr>'+
										// '<span>Marks:</span>'+this.data.testData.data.totalMarks+
										// '<span>Closes on: </span>'+this.data.testData.endDate+
									// '<hr>'+
									'</div>';
									if (this.data.testData.attachments.length > 0)
									{
			    descriptive_html += '<div>'+
										'<span><h3 class="H3Color">List of Attachments</h3></span>'+
									'</div>'+
									'<div class="listofattachements_div">'+
										'<ul class="listofattachements">';
											for(attchment in this.data.testData.attachments)
											{
												descriptive_html += '<li>'+
																		'<span><img class="doc" src="/images/icons/icons_1.jpg" alt=""></span>'+
																		'<a class="download_content" href-data="/?route=item/descriptivetest&file='+this.data.testData.attachments[attchment].key+'" target="_blank">'+this.data.testData.attachments[attchment].name+' <span class="glyphicon glyphicon-download-alt"></span></a>'+
																	'</li>';
											}
				descriptive_html +=		'</ul>'+
									'</div>';
									}
				 if(typeof this.data.testData.uploadables != "undefined" && this.data.testData.uploadables == 1)
				 {					
					 descriptive_html += '<div class="UploadAssignments">'+
											'<div class="uploadAttachment "'+(parseInt(this.data.testAccess) == 2 ? 'results':'')+'">'+
												'<span><h3 class="H3Color">Upload Your Answer</h3></span>'+
												'<label for="addAttachmentBtn" class="btn btn-primary">Browse &amp; Upload Answer</label>'+
												'<input id="addAttachmentBtn" type="file" multiple="true" data-id="'+this.data.testData.itemId+'">'+
												'<div class="text" style="color: #8c8c8c; font-size: 12px;">'+
													'(File Format : doc / pdf/ txt/ img)'+
												'</div>'+
											'</div>'+
											'<span><br><h3 class="H3Color">Your Submissions</h3></span>'+
											'<ul class="your_submissions">';
													for(user_attachment in this.data.testData.user_attachments)
													{
							descriptive_html += '<li class="userattachsolution">'+
													'<span class="doc-attach"><img class="doc" src="/images/icons/icons_1.jpg" alt=""/></span><a class="userattachlist" href-data=\'/s3-attachment/'+this.data.testData.user_attachments[user_attachment].key+'\' target="_blank">'+this.data.testData.user_attachments[user_attachment].name+'</a>'+
													'<span class="remove_att_btn '+(this.data.testAccess == 2 ? 'results':'')+'" key="'+this.data.testData.user_attachments[user_attachment].key+'"><span class="glyphicon glyphicon-remove"></span></span>'+
												'</li>';
													}
						descriptive_html += '</ul>'+
										'</div>'+
										'<div class="newComment">'+
											'<h3 class="H3Color">Remark:</h3>'+
											'<textarea rows="4" style="width: 90%;" class="newCommentDesc" placeholder="Note on this...."></textarea>'+
										'</div>'+
										'<div class="AssignmentSubmission '+(this.data.testAccess == 2 ? 'results':'')+'" assgnId="'+this.data.testData.itemId+'">'+
											'<a id="submitAssignBtn" class="btn btn-primary" href="javascript:;">Submit Assignment </a>'+
											'<div class="value"></div>'+
										'</div>'+
										'<div class="AssignmentClosingDate '+(this.data.testAccess == 2 ? 'results':'')+'">'+
											'<h4>Last Date for Submission of Assignment was: '+this.data.testData.endDate+'</h4>'+
										'</div>'+
										'<div class="comments true" commentexist="true">'+
											'<div class="AssignmentCommentContent">';
												if(this.data.testData.submittedOn != null)
												{
							descriptive_html +=	'<span>Last Submission: </span>'+this.data.testData.submittedOn+' ago';
												}
								
												if(this.data.testData.assignData !=null)
												{
													var res = (this.data.testData.assignData).replace(/\\n/g, "\n");
													//this.data.testData.assignData
							descriptive_html += '<div class="detail">'+
													 '<span>'+
														 '<br>Last Comment:'+
													 '</span>'+
													 '<span class="AssignmentCommentContent_div">'+
													 res+
													 '</span>'+
												 '</div>';
												}
									
							descriptive_html +=	'</div>'+
										'</div>';
										
										if(this.data.testData.evaluatedOn != null)
										{
						descriptive_html += '<hr class="assignment_hr">'+
											'<div class="AssignmentEvaluation">'+
												'<span class="Assignment_Scroll"><h3 class="H3Color">Evaluated Result</h3></span>'+
												'<div><span>&rArr; Marks Obtained:</span> '+this.data.testData.score+'</div>'+
												'<div><span>&rArr; Teacher\'s Review:</span> '+this.data.testData.evaluationData+'</div>'+
											'</div>'+
											'<hr class="assignment_hr">';
										}
										else if( this.data.testData.submittedOn != null )
										{
						descriptive_html +=
											'<div class="AssignmentEvaluation">'+
												'<span><h3 class="H3Color">Evaluated Result</h3></span>'+
													'<div><span>&rArr; Under Review...</span>'+
											'</div>';
										}
					}	
					descriptive_html +='</div>'+
								   '</div>'+
								'</div>';	
		$(this.dom).find(".descriptive_content").html(descriptive_html);
		$(this.dom).find('img').each(function () {
		    if(($(this).attr("src")).startsWith("/attachment.php"))
		    {
		    	 $(this).attr("src",(remoteServer).concat($(this).attr("src")));
		    }
		});
		MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
};
itemdescriptivetestController.prototype.BindEvents = function()
{
	if(this.report)
	{
		// var sdiff = $('.AssignmentEvaluationv').scrollTop();
		// var dist = $(this.dom).find('.Assignment').position(0).top;   //solutioin tab is the respective tab.
		// $(this.dom).animate({
		    // scrollTop : (dist + sdiff)
		// }, 1000);

		var r = document.querySelector('.Assignment');   // outer most dom
        var p = r.querySelector('.AssignmentEvaluation');  // the outer div of the element which has to be scrolled
        $(this.dom).animate({
            scrollTop : parseInt( p.getElementsByClassName('Assignment_Scroll')[0].offsetTop - 65)   //the element // that has to be scrolled
        }, 1000);

	}
	var self = this;
	$(this.dom).find(".uploadAttachment #addAttachmentBtn").unbind().bind("change",this,function(e)
	{
		console.log(e);
		console.log(this);
		if(typeof this.files != "undefined" && typeof this.files[0] != "undefined")
    	{
    		for(var f = 0; f < this.files.length; f++)
        	{
        		var loader = $("<li class='userattachsolution'><img class='loader' src='img/loader.svg' /></li>");
            	$(this).parents(".UploadAssignments").find("ul").append(loader);
				$.ajax({
					url : remoteServer+"/?route=common/ajax",
					context:{
						loader:loader,file:this.files[f]
					},
					type : "POST",
					data : {
						mod : "tr2tests",
						ack : "getform",
						data : JSON.stringify({
							'type' : 1/*AssignmentAnswerAttachment*/,
							aId : $(this).attr("data-id")
						})
					},
					xhrFields : {
						withCredentials : true
					},
					crossDomain : true,
					complete : function(reply) {
						try
                    	{
	                        response = reply.responseJSON;
	                        if(response.result.state == "ok")
	                        {
	                        	
	                            var formData = response.data;
	                            var file = this.file;
	                            var form = new FormData();          
	                            formData.data['Content-Type'] = file.type;
	                            for(var key in formData.data)
	                            {
	                                form.append(key,formData.data[key]);
	                            }
	                            form.append("file",file);
	                            console.log(formData.url);
	                            console.log(form);
	                            console.log(this.loader);
	                            // console.log(formData.url);
	                            $.ajax({
	                                url: formData.url,
	                                type: 'POST',
	                                data: form,
	                                processData: false, // Don't process the files
	                                contentType: false, // Set content type to false as jQuery will tell the server its a query string request
	                                context:{
	                                	loader:this.loader
	                                },
									xhrFields : {
										withCredentials : true
									},
									crossDomain : true,
	                                success: function(response, textStatus, jqXHR)
	                                {
	                                    if(response.result.state == "ok")
	                                    {
	                                    	response.data.name = response.data.name.substring(response.data.name.indexOf("-") + 1);
                                        	this.loader.html("<span class='doc-attach'><img class='doc' src='/images/icons/icons_1.jpg' alt=''/></span><a class='userattachlist' href-data='/s3-attachment/"+ encodeURI(response.data.key)+"' key='"+ response.data.key+"' target='_blank'>"+response.data.name+"</a>" +
                                        				 "<span class='remove_att_btn' key='"+response.data.key+"'><span class='glyphicon glyphicon-remove'></span></span>");
                                            this.loader.find(".remove_att_btn").unbind().bind("click",this,function(e){	
													outerthis.RemoveAttachment(this);
											});  
											this.loader.find(".userattachlist").unbind().bind("click",this,function(e){
													// event.preventDefault();
													var link = $(this).attr("href-data");
													console.log(remoteServer+link);
													//window.open(remoteServer+link, '_system');
													// createTempSession(link);
													// AppBrowser.getObj().Open(remoteServer+link);
													createTempSession(link);
													// AppBrowser.getObj().OpenWPBlog(remoteServer+link);
													// URLRedirection(remoteServer+link);
												});                                     				 
	                                    }
	                                    else
	                                    {
	                                        this.loader.addClass("error");
	                                        this.loader.html("Error uploading file!");
	                                    }
	                                },
	                                error: function(jqXHR, textStatus, errorThrown)
	                                {
	                                    console.log('ERROR: ' + textStatus,errorThrown,jqXHR);
	                                    this.loader.addClass("error");
	                                    this.loader.html("Error uploading file!");
	                                },
	                                xhr: function() {  // Custom XMLHttpRequest
	                                    var myXhr = $.ajaxSettings.xhr();
	                                    if(myXhr.upload){ // Check if upload property exists
	                              //          myXhr.upload.addEventListener('progress',AssignmentType_0.UploadProgressHandling, false); // For handling the progress of the upload
	                                    }
	                                    return myXhr;
	                                },
	                            });  
	                        }
	                        else
	                        {
	                            this.loader.addClass("error");
	                            if(typeof response != "undefined" && typeof response.result != "undefined" && typeof response.result.meta != "undefined")
	                            {
	                                this.loader.html(response.result.meta);
	                            }
	                            else
	                            {
	                                this.loader.html("Error uploading file!");
	                            }
	                        }
	                    }
	                    catch(e)
	                    {		
	                    }
					}//.bind(e.data)
				}); 
			}
		}
	});
	$(this.dom).find(".remove_att_btn").unbind().bind("click",this,function(e){
		e.data.RemoveAttachment(this);
	});
	$(this.dom).find(".download_content").unbind().bind("click",this,function(e){
		// event.preventDefault();
		var link = $(this).attr("href-data");
		var serverAddress = remoteServer;
		if(typeof UrlMgmt.getObj().menuData != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta.homeUrl != 'undefined'&& UrlMgmt.getObj().menuData.domainmeta.homeUrl.length > 0){
			serverAddress = 'http://'+UrlMgmt.getObj().menuData.domainmeta.homeUrl;
		}
		window.open(serverAddress+link, '_system');
		//createTempSession(link);
		console.log();
		// URLRedirection(remoteServer+link);
	});
	$(this.dom).find(".userattachlist").unbind().bind("click",this,function(e){
		var link = $(this).attr("href-data");
		// window.open(remoteServer+link, '_system');
		// AppBrowser.getObj().Open(remoteServer+link);
		
		createTempSession(link);
		// setTimeout(function(){ AppBrowser.getObj().OpenWPBlog(remoteServer+link); }, 100);
		//createTempSession(link);
	});
	
	$(this.dom).find(".AssignmentSubmission #submitAssignBtn").unbind().bind("click",this,function(e)
	{
		var asgId = $(".AssignmentSubmission").attr("assgnid");
		assigndata = $(".newComment").find(".newCommentDesc").val();
		// assigndata = ($(".newComment").find(".newCommentDesc").val()).replace(/["]/g,"\\\"");
		// console.log(assigndata);
		var jsonTxt = {
				comment : []
		};
	
		comment =$(".newComment").find(".newCommentDesc");
		comment.each(function(i) {
			comment = {	commentkey:i, 
						AssignData: assigndata,
					};
			jsonTxt.comment.push(comment);
		 });
		 
		var Assignmentdata =JSON.stringify(comment);
		
		$.ajax({
			url : remoteServer+"/?route=common/ajax",
			type : "POST",
			data : {
				mod : "tr2tests",
				ack : "submitDescriptiveTest",
				assignmentId : asgId,
				data : Assignmentdata
			},
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			complete : function(event) {
				try {
					reply = event.responseJSON;
					if (reply.result.state == "ok") {
						alert("Assignment Submitted");
						// UrlMgmt.getObj().Refresh();
						this.Init(this.dom);
						return;
						// location.reload();
					} else {
						$(".AssignmentSubmission .value").html('<span class="error">' + reply.result.meta + '</span>');
					}
				} catch(e) {
				}
			}.bind(e.data)
		}); 

	});
};

itemdescriptivetestController.prototype.RemoveAttachment = function(btn)
{
		var key = $(btn).attr("key");
	    $.ajax({
	    	url : remoteServer+"/?route=common/ajax",
			type: "POST",
	    	data:{	
	    		mod: "tr2tests",
	            ack: "deleteAssignment",
	            key: key
	       	},
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			complete: function( event){
			try
			{
				reply = event.responseJSON;
				$(btn).parents(".userattachsolution").remove();
			}
			catch(e)
			{		
			}		   
		  }
		});	
};
