var _classObj = null;
var firebaseResumeDownloadAdd = null;
var itemliveclassesController = function()
{
	this.view = "default";
	this.style = "default";
	this.data = null;
	this.dom = null;
	this.id = 0;
	this.refresh = true;
	_classObj = null;
	 firebaseResumeDownloadAdd = null;
	timer = null;
};
itemliveclassesController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if(!urlMgmt.App.isOnline){
		
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
itemliveclassesController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.unlockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Live Class', false, true, true);
};
itemliveclassesController.prototype.OfflineInit = function()
{
	$(this.dom).find(".liveclasses").hide();
	Factory.getObj().LoadViewForOffline(this);
};
itemliveclassesController.prototype.OnlineInit = function()
{
	$(this.dom).find(".liveclasses").show();
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();	
	this.LoadQuiz();
	Factory.getObj().LoadDiscussions(this.data, this.dom);
	this.LoadVideo();
	LvClass.getObj(this.id, this.data);
	this.BindEvents();
	var urlKey = typeof this.data.urlKey != 'undefined' ? this.data.urlKey : '';
	analytics_trackView("item_liveclass");
	analytics_trackEvent("item_liveclass" , '/'+urlKey);

};
itemliveclassesController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
itemliveclassesController.prototype.BindEvents = function()
{
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	   this.dom.find('.js-checkout').html("More");				
	}
	else
	{
		this.dom.find('.js-checkout').unbind().bind('click', function(e){
			e.preventDefault();
			var urlMgmt = UrlMgmt.getObj();
			urlMgmt.Route({route: $(e.currentTarget).data('action'), needData: true, offlineAllowed: false}, function(obj){
				urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
			}.bind(this));
		}.bind(this));		
	}
	this.dom.find('._eventListener').unbind().bind('click', function(e){
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.Route({route: $(e.currentTarget).data('action'), needData: true, offlineAllowed: false});
	});
	this.dom.find('.attemptsRequired').parents(".LvClassPrview").unbind().bind("click",function(){
		alert("Watch Duration Quota for this Video Exhausted");
	});
	$('.header-back-btn').unbind().bind('click',this,function(e){
		clearInterval(LvClass.getObj().heartBitTimerId);
		if($(e.data.dom).find('.vimeo iframe').length > 0){
			clearInterval(e.data.timer);
		}
		if(typeof jwplayer != 'undefined'){
			if($("#"+LvClass.getObj().video1InPlay).length !=0){
				jwplayer(LvClass.getObj().video1InPlay).stop();
				jwplayer(LvClass.getObj().video1InPlay).remove();
			}
			if($("#"+LvClass.getObj().video2InPlay).length !=0){
				jwplayer(LvClass.getObj().video2InPlay).stop();	
				jwplayer(LvClass.getObj().video2InPlay).remove();
			}
		}
		if(typeof videojs != 'undefined')
		{
			var allPlayers = videojs.getAllPlayers();
			for(var i=0;i<allPlayers.length;i++)
			{
				if($("#"+allPlayers[i].id_).length !=0)
				{
					videojs(allPlayers[i].id_).reset();
			    	videojs(allPlayers[i].id_).dispose();
			   	}
			}
		}
		if (viewFromNotification && UrlMgmt.getObj().actionStack.length == 1){
			viewFromNotification = false;
			UrlMgmt.getObj().PopView();
			UrlMgmt.getObj().Route({route: 'common/home', needData: true, offlineAllowed: true});
		}
		else{
			UrlMgmt.getObj().PopView();
		}
	});
	$(this.dom).unbind().bind('webkitfullscreenchange', function(){
		var state = ((typeof document.webkitIsFullScreen !== 'undefined' && document.webkitIsFullScreen) || 
	    			(typeof document.isFullScreen !== 'undefined' && document.isFullScreen));
		if(!state && !this.isfullscreen)
		{ 
			var cancelFunc = (document.cancelFullScreen || document.webkitCancelFullScreen);
			cancelFunc.call(document);
	    	$(".PlayContainer").removeClass("InFullScreen");
	    	screen.orientation.lock('portrait');
		}
		else{
			this.isfullscreen = false;	 
		}
	
	});

};
itemliveclassesController.prototype.LoadVideo = function()
{
	$('.lvTitle').append('<h1>'+this.data.title+'</h1>');
	var videoData = "";
	if(this.data.tr1info.applicationName !== 'youtube' && this.data.tr1info.applicationName !== 'vimeo' ){
		videoData += '<div data-itemId="'+this.data.itemId+'" class="container PlayLVHere" data-access="'+this.data.tr1info.access+'" data-lastPause="'+this.data.lastPause+'">'+				'<div class="PlayContainer">'+
	      					'<div class="VideoContainer">'+
		      					'<div id="VideoHere">';
		var redirectLPage ="";
		if(!LoggedInUser.Auth())
		{
			redirectLPage = '_eventListener" data-action="common/tr2login';
		}
		var overlayclass = '';
		if((typeof(this.data.classecomm != 'undefined')) && this.data.classecomm.hasOwnProperty(this.data.itemId) && (this.data.classecomm[this.data.itemId]["purchesed"] == 0))
		{
			var overlayclass = '';
		}
		else if(LoggedInUser.Auth() && typeof(this.data.tr1info.state != 'undefined') && (this.data.tr1info.state == 2 || this.data.tr1info.state == 3 || this.data.tr1info.state == 4)){
			var overlayclass = 'processingoverlay';
		} 
		var ecomm = (typeof this.data.classecomm != 'undefined') &&
						 this.data.classecomm.hasOwnProperty(this.data.itemId) && 
						 (this.data.classecomm[this.data.itemId]['purchesed'] ==0 ) ? ' Locked':'';
		    videoData += 		'<div class="LvClassPrview '+this.data.tr1info.currentVideoState+' '+ecomm+' '+overlayclass+redirectLPage+'">';
		    					 var pImage = "";
		    					 if (this.data.tr1info.priviewImageUrl && this.data.tr1info.priviewImageUrl.length > 5){
									 pImage = this.data.tr1info.priviewImageUrl;
								 }
								 else{
								 	pImage = "img/client_images/defaultlv_class.jpg";
								 }
			videoData +=         '<img src="'+pImage+'" alt="'+this.data.title+'" />';
								if(typeof(this.data.tr1info.state)!= 'undefined' && ((this.data.tr1info.state) == 2) || (this.data.tr1info.state == 3) || (this.data.tr1info.state == 4)){
			videoData +=			'<div class="videoprocessingoverlay"></div>';
								}
								if(this.data.tr1info.currentVideoState  == "upcoming"){
			videoData+=          '<p class="LiveOn">We will be live on: <span>'+this.data.tr1info.startDate+'</span></p>';	 //doubt	// | date("jS M h:i A")				
								}
								else if(this.data.tr1info.currentVideoState  == "ongoing"){
			videoData+= 		 '<p class="LiveOn">Streaming now! Started at: <span>'+this.data.tr1info.startDate +'</span></p>';    //| date("jS M h:i A")
								}
			var flag = false;
								if(!LoggedInUser.Auth()){      //doubt
			videoData+= 		 '<p class="LoginRequired ">Please Register or login to watch this video.</p>';
								}
								else if((typeof this.data.remainingVideoDuration != 'undefined') && this.data.remainingVideoDuration <=0){
			videoData+= 		 '<p class="attemptsRequired">Watch Duration Quota for this Video Exhausted.</p>';
								}
								else if ((typeof this.data.classecomm != 'undefined') &&
						 this.data.classecomm.hasOwnProperty(this.data.itemId) && 
						 (this.data.classecomm[this.data.itemId]['purchesed'] ==0 )){
			videoData+= 		 '<a class="purchaseRequired js-checkout" data-action="common/checkout&for='+this.data.urlKey+'">'+
										'Purchase now and watch the full video!</a>';
								}
								else if((typeof(this.data.tr1info.state) != 'undefined') && ((this.data.tr1info.state) == 2) || (this.data.tr1info.state == 3) || (this.data.tr1info.state == 4)){
			videoData+=			'<p class="processing_msg">Live Class has already ended at ' +
								((typeof(this.data.tr1info.endDate)!= "undefined")? this.data.tr1info.endDate : "")+'<br>Please wait.. Video will be available soon! </p>';
								}
								else{
									flag = true;
								}
			videoData+=			'</div></div></div>';
			videoData+=			'<div class="currentStreamVideoStatus" style="display:none;" data-videoStreamStatus="live"></div>';
			videoData +=  		'<div id="chatHere" class="showChat hidechat">'+
	      							'<div class="ChatLoader">Loading group chat window</div>'+
	      							'<div class="firechat-wrapper Hidden"></div>'+
	      							'<div id="closeChat"><span class="glyphicon glyphicon-remove-circle"></span></div>'+		      					
	      						'</div>'+
	      						'</div>'+
						      	'<div id="lvOnLandscape">'+
						      		'<img src="img/dangerping.png">'+
									'<span>Tap here to view in full screen mode</span>'+
							    '</div></div>';
			if(flag == true && typeof this.data.videoTimeRestriction != 'undefined' && typeof this.data.videoTimeRestriction.functionalityEnabled != 'undefined' && this.data.videoTimeRestriction.functionalityEnabled == 1){
		   		var totalDuration = typeof this.data.videoTimeRestriction.totalDuration != 'undefined' ? getTimeFormat(this.data.videoTimeRestriction.totalDuration) : 0;
		   		var remainingDuration = typeof this.data.videoTimeRestriction.remainingVideoDuration != 'undefined' ? getTimeFormat(this.data.videoTimeRestriction.remainingVideoDuration) : 0;
				videoData +=   '<div class="videoInfo container">'+
							    	'<div class="totalDuration">Watch Duration of <b>'+remainingDuration +'</b> is remaining out of <b>'+totalDuration+'</b></div>'+
							    	//'<div class="remainingDuration">Remaining duration:  '+remainingDuration+'</div>'+
							    '</div>';
			}
			videoData += '<div class="container lvSection">'+      		
									'<div class="lvSectionDetails">'; 
								 
									if(this.data.tr1info.data.preDescription && this.data.tr1info.data.preDescription != ""){
			videoData+=					'<div class="descripton post">'+this.data.tr1info.data.preDescription+'</div>';
									}
									else{
										'<div class="descripton post">'+this.data.description+'</div>';
									}
			videoData+=			'</div><div id="dynamicModelTxt"></div></div>';									 
	}
	else if(this.data.tr1info.applicationName == 'vimeo'){
		var ecomm = (typeof this.data.classecomm != 'undefined') &&
						 this.data.classecomm.hasOwnProperty(this.data.itemId) && 
						 (this.data.classecomm[this.data.itemId]['purchesed'] ==0 ) ? 'Locked':'';
		if(ecomm == 'Locked')
		{
			videoData += '<div id="VideoHere">'+
							'<div class="LvClassPrview past  Locked vimeo ">'+
								'<img src="img/client_images/defaultlv_class.jpg" alt="Video">'+
								'<a class="purchaseRequired js-checkout" data-action="common/checkout&amp;for='+this.data.urlKey+'">Purchase now and watch the full video!</a>'+
							'</div>'+
						'</div>';
		}
		else{
			var vimeo_iframe = '<iframe src="https://player.vimeo.com/video/'+this.data.tr1info.data.preDescription+'?playsinline=false"  frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>';
			videoData+=	'<div class="text-center vimeo">'+vimeo_iframe+'</div>';
		}
	}
	else{
		videoData+=	'<div class="text-center">'+this.data.tr1info.data.preDescription+'</div>';
	};
	
	$(this.dom).find('.lvContainer').html(videoData);
	var iframe_count = $(this.dom).find('iframe').length;
	if(iframe_count > 0 && this.data.tr1info.applicationName == 'vimeo')
	{
		var iframe = $(this.dom).find('iframe');
	    var player = new Vimeo.Player(iframe);
	
	    player.on('play', function() {
	    	if(device.isVirtual ==  true){
				alert("Can't play video !!");
				UrlMgmt.getObj().Refresh();
				return;
			}
			//this.timer = setInterval(function(){this.ShowFlashCode();}.bind(this), 30000);	
	    }.bind(this));
	    player.on('pause', function() {
			//clearInterval(this.timer);
	    }.bind(this));	
	}	
};
itemliveclassesController.prototype.LoadQuiz = function()
{
	var QuizHTML = '';
	var currentTimestamp = new Date().getTime();
	if(typeof this.data.dquizcount != "undefined" && this.data.dquizcount > 0)
	{
		var activeQuizCard = 'active';
		QuizHTML = '<h2 class="TextDark quizheading">Quiz</h2><div id="QuizCarousel-'+currentTimestamp+'" class="carousel slide" data-ride="carousel">';
		QuizHTML += '<ol class="carousel-indicators">';
		var count=0;
		for(var key in this.data.dquiz)
		{	
			if(count == 0)
			{			
		      QuizHTML += '<li data-target="#QuizCarousel-'+currentTimestamp+'" data-slide-to="'+count +'" class="active"></li>';
		      count++;
		      continue;
	      	}
	      	QuizHTML += '<li data-target="#QuizCarousel-'+currentTimestamp+'" data-slide-to="'+count +'" ></li>';
	      	count++;	    
	    }
	    QuizHTML += '</ol>'+
	    			'<div class="carousel-inner">';	
	    for(var key in this.data.dquiz)
		{
			var quiz = this.data.dquiz[key];
			
			QuizHTML += Factory.getObj().dQuizCard({quiz:quiz},activeQuizCard); //, lockInfo:lockInfo, UrlKey:this.data.urlKey, ItemId:this.data.itemId, Quizclassecomm:this.data.classecomm
			if(activeQuizCard == 'active'){
				activeQuizCard = '';
			}
		}
		QuizHTML += '</div></div>';

		$(this.dom).find('.quizDiv').html(QuizHTML);
		tr$.carouselSet(this.dom.find('#QuizCarousel-'+currentTimestamp),this.dom);
		
		this.dom.find('.takeQuiz').unbind().bind('click',function(){
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().App.onOffline();
				return false;
			}
			if(!LoggedInUser.Auth()){
				UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
				return false;		
			}
			UrlMgmt.getObj().Route({route : $(this).data('action'), needData: false});
		});
		this.dom.find('.quiz_buy').unbind().bind('click',function(){			
			this.dom.find(".js-checkout").trigger('click');
		}.bind(this));
		
		this.dom.find('.report').unbind().bind('click',function(){
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().App.onOffline();
				return false;
			}
			if(!LoggedInUser.Auth()){
				UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
				return false;		
			}
			UrlMgmt.getObj().Route({route : $(this).data('action'), needData: false});
		});
	}
	
};
itemliveclassesController.prototype.ShowFlashCode = function()
{
	
	var min = 600;
	var max = 1200;
	if($(this.dom).find(".vimeo iframe").height() <= 150)
	{
		min = 600;
		 max = 700;
	}
	else
	{
		min = 600;
		max = 1200;
	}
	if(typeof UrlMgmt.getObj().userData != "undefined" && typeof UrlMgmt.getObj().userData.id != "undefined")
	{
		window.plugins.toast.showWithOptions({
		      message: UrlMgmt.getObj().userData.id,
		      duration: "long",
		      position: "top",
		      addPixelsY: Math.random() * (max - min) + min,
		      styling: {
			      opacity: 0.75,
			      backgroundColor: '#E4E4E4',
			      textColor: '#000000',
			      textSize: 10,
			      cornerRadius: 0,
			      horizontalPadding: 10,
			      verticalPadding: 10
			   }
		});
	}
};