function slider(outerdiv,innerdiv,entity){
	var entityslide = new Array();
	if(typeof outerdiv === 'string')
	{
		for(i = 0;i < $('.'+outerdiv).length; i++){
			entityslide[i] = new slidediv();
			entityslide[i].Init(outerdiv,innerdiv,entity,i);
		}
	}
	else
	{
		new slidediv().Init(outerdiv,innerdiv,entity);
	}
	
}
function slidediv(){
	this.slidediv = null;
}
// only the outdiv value have to be distinctly classified and it might be an object or a classname or an id.
// the innerdiv and entity have to be a classname and the buttons should have entity name appended with it.
// index may or may not be defined. 
slidediv.prototype.Init = function(outerdiv,innerdiv,entity,index){ 
	if (typeof outerdiv === 'string'){
		this.outdiv = $('.'+outerdiv).eq(index);
	}
	else
		this.outdiv = outerdiv.eq(0);
	this.indiv = this.outdiv.find('.'+innerdiv);
	this.leftbtn = this.outdiv.find('.'+entity+'btnleft');
	this.rightbtn = this.outdiv.find('.'+entity+'btnright');
	this.entity = $('.'+entity);
	this.CheckPosition();
	
	this.rightbtn.unbind().bind('click',function() {
		var move = this.indiv[0].clientWidth -(this.indiv[0].clientWidth % this.entity.outerWidth(true));
		if(move <= 0){
			move = this.indiv[0].clientWidth;
		}
		this.indiv.animate({
			scrollLeft: "+="+move+"px"
		}, 1000,function(){
		    this.CheckPosition();
		}.bind(this));
	}.bind(this));
	  
	this.leftbtn.unbind().bind('click',function() {
		var move = this.indiv[0].clientWidth - (this.indiv[0].clientWidth % this.entity.outerWidth(true));
	    if(move <= 0){
			move = this.indiv[0].clientWidth;
		}
	    this.indiv.animate({
			scrollLeft: "-="+move+"px"
		}, 1000,function(){
		    this.CheckPosition();
		}.bind(this));
	}.bind(this));
	this.Swipebox();
	this.indiv.scroll(function(){
		this.CheckPosition();
	}.bind(this));
};
slidediv.prototype.Swipebox = function(){
	var startx = 0;
	var boxleft = 0;
	var dist = 0;
	touchobj = null;
	this.indiv[0].addEventListener('touchstart', function(e){
        touchobj = e.changedTouches[0]; 
        boxleft = parseInt(this.indiv[0].style.left); 
        startx = parseInt(touchobj.clientX);
    }.bind(this), false);
	this.indiv[0].addEventListener('touchmove', function(e){
	 	var touchobj = e.changedTouches[0];
	    var dist = parseInt(touchobj.clientX) - startx;
	    if(dist != 0){
	    	this.CheckPosition();
	    }
	    this.indiv[0].style.left = ( ( boxleft + dist > 30)? 30 : ( boxleft + dist < 0)? 0 : boxleft + dist ) + 'px';
	}.bind(this), false);
};
slidediv.prototype.CheckPosition = function(){
	var outer_width = this.indiv[0].clientWidth;
  	var inner_width = this.indiv[0].scrollWidth;
   	var menuscrollLeft = this.indiv[0].scrollLeft;
   	if(menuscrollLeft <= 0)
   	{
   		this.leftbtn.css("visibility","hidden");
   	}
   	else
   	{
		this.leftbtn.css("visibility","visible");
   	}
   	if((outer_width + menuscrollLeft) < inner_width)
   	{
   		this.rightbtn.css("visibility","visible");
   	}
   	else
   	{
		this.rightbtn.css("visibility","hidden");
   	}
};
