/******* Factory *******/
var _factory = null;
function Factory (){};

Factory.getObj = function()
{
	if(_factory === null)
	{
		_factory = new Factory();
	}
	return _factory;
};
Factory.prototype.ExamCard = function (data)
{
	var examCard = '<div class="Exam" data-delivery-id="'+data.examId+'">'+
						'<div class="Exam-title">'+data.title+'</div>'+
						'<div class="Exam-element">'+
							'<span class="element-title test-title"><img src="https://cdn.toprankers.net/images/take-test-big@2x-023c731b3cf86.png">Free Tests:</span><span class="number-text">'+data.testcount+'</span>'+
						'</div>'+
						'<div class="Exam-element">'+
							'<span class="element-title video-title"><img src="https://cdn.toprankers.net/images/play-video-big@2x-023c731b3d8ff.png">Demo Videos:</span><span class="number-text">'+data.videocount+'</span>'+
						'</div>'+
						'<div class="Exam-element">'+
							'<span class="element-title quiz-title"><img src="https://cdn.toprankers.com/images/liveclasquiz-023b11deb59b4.png">Free Quizes:</span><span class="number-text">'+data.quizcount+'</span>'+
						'</div>'+
						'<a class="btn btn-primary explore-examPage" data-delivery-id='+data.examId+' data-action="examPage">'+
							'<span>Explore More</span>'+
							'<span class="glyphicon glyphicon-menu-right"></span>'+
						'</a>'+
					'</div>';
	return examCard;
};
Factory.prototype.TestTabs = function (data)
{
	var currentTimestamp = new Date().getTime();
	var testTabs = '';
	var testTabs = 
			'<div class="tests-container">'+
			'<div class="tabDiv">'+'<span class="testTabbtnleft"><img src="img/slideleft.png"/></span>'+
					'<ul class="nav nav-tabs tabList container">';
		if(data.testGroupCount.Free > 0){
		if(parseInt(data.listType) == 1)
		{
			testTabs += '<li id="Free" style="float:left;" class="testTab '+(data.activeTab == 'Free'? 'active':'')+'">'+
							'<a href="#freeTests-'+currentTimestamp+'" data-toggle="tab">Assignments (<span class="TextHeilight testCount">'+ data.testGroupCount.Free +'</span>)</a>'+
						'</li>';			
		}
		else if(parseInt(data.listType) == 2)
		{
			testTabs += '<li id="Free" style="float:left;" class="testTab '+(data.activeTab == 'Free'? 'active':'')+'">'+
							'<a href="#freeTests-'+currentTimestamp+'" data-toggle="tab">Courseware (<span class="TextHeilight testCount">'+ data.testGroupCount.Free +'</span>)</a>'+
						'</li>';			
		}		
		else{
			testTabs += '<li id="Free" style="float:left;" class="testTab '+(data.activeTab == 'Free'? 'active':'')+'">'+
							'<a href="#freeTests-'+currentTimestamp+'" data-toggle="tab">Free Tests (<span class="TextHeilight testCount">'+ data.testGroupCount.Free +'</span>)</a>'+
						'</li>';			
		}
	}
	if(data.testGroupCount.Premium > 0){
		if(parseInt(data.listType) == 1)
		{
			testTabs += '<li id="Premium" style="float:left;" class="testTab '+(data.activeTab == 'Premium'? 'active':'')+'">'+
							'<a href="#premiumTests-'+currentTimestamp+'" data-toggle="tab">Premium Assignments (<span class="TextHeilight testCount">'+ data.testGroupCount.Premium +'</span>)</a>'+
						'</li>';
		}
		else if(parseInt(data.listType) == 2)
		{
			testTabs += '<li id="Premium" style="float:left;" class="testTab '+(data.activeTab == 'Premium'? 'active':'')+'">'+
							'<a href="#premiumTests-'+currentTimestamp+'" data-toggle="tab">Premium Courseware (<span class="TextHeilight testCount">'+ data.testGroupCount.Premium +'</span>)</a>'+
						'</li>';
		}
		else{
			testTabs += '<li id="Premium" style="float:left;" class="testTab '+(data.activeTab == 'Premium'? 'active':'')+'">'+
							'<a href="#premiumTests-'+currentTimestamp+'" data-toggle="tab">Premium Tests (<span class="TextHeilight testCount">'+ data.testGroupCount.Premium +'</span>)</a>'+
						'</li>';
		}
	}
	if(data.testGroupCount.Purchased > 0){
		if(parseInt(data.listType) == 1)
		{
			testTabs += '<li id="Purchased" style="float:left;" class= "testTab '+(data.activeTab == 'Purchased'? 'active':'')+'">'+
							'<a href="#purchasedTests-'+currentTimestamp+'" data-toggle="tab">My Assignments (<span class="TextHeilight testCount">'+ data.testGroupCount.Purchased +'</span>)</a>'+
						'</li>';
		}
		else if(parseInt(data.listType) == 2)
		{
			testTabs += '<li id="Purchased" style="float:left;" class= "testTab '+(data.activeTab == 'Purchased'? 'active':'')+'">'+
							'<a href="#purchasedTests-'+currentTimestamp+'" data-toggle="tab">My Courseware (<span class="TextHeilight testCount">'+ data.testGroupCount.Purchased +'</span>)</a>'+
						'</li>';
		}
		else{
			testTabs += '<li id="Purchased" style="float:left;" class= "testTab '+(data.activeTab == 'Purchased'? 'active':'')+'">'+
							'<a href="#purchasedTests-'+currentTimestamp+'" data-toggle="tab">My Tests (<span class="TextHeilight testCount">'+ data.testGroupCount.Purchased +'</span>)</a>'+
						'</li>';
		}
	}
	if(data.testGroupCount.Attempted > 0){
		if(parseInt(data.listType) == 1)
		{
			testTabs += '<li id="Attempted" style="float:left;" class= "testTab '+(data.activeTab == 'Attempted'? 'active':'')+'">'+
							'<a href="#attemptedTests-'+currentTimestamp+'" data-toggle="tab">Attempted Assignments (<span class="TextHeilight testCount">'+ data.testGroupCount.Attempted +'</span>)</a>'+
						'</li>';
		}
		else{
			testTabs += '<li id="Attempted" style="float:left;" class= "testTab '+(data.activeTab == 'Attempted'? 'active':'')+'">'+
							'<a href="#attemptedTests-'+currentTimestamp+'" data-toggle="tab">Attempted Tests (<span class="TextHeilight testCount">'+ data.testGroupCount.Attempted +'</span>)</a>'+
						'</li>';
		}
	}
	if(data.testGroupCount.Past > 0){
		if(parseInt(data.listType) == 1)
		{
			testTabs += '<li id="Past" style="float:left;" class= "testTab '+(data.activeTab == 'Past'? 'active':'')+'">'+
							'<a href="#pastTests-'+currentTimestamp+'" data-toggle="tab">Missed Assignments (<span class="TextHeilight testCount">'+ data.testGroupCount.Past +'</span>)</a>'+
						'</li>';
		}
		else if(parseInt(data.listType) == 2)
		{
			testTabs += '<li id="Past" style="float:left;" class= "testTab '+(data.activeTab == 'Past'? 'active':'')+'">'+
							'<a href="#pastTests-'+currentTimestamp+'" data-toggle="tab">Missed Courseware (<span class="TextHeilight testCount">'+ data.testGroupCount.Past +'</span>)</a>'+
						'</li>';
		}
		else{
			testTabs += '<li id="Past" style="float:left;" class= "testTab '+(data.activeTab == 'Past'? 'active':'')+'">'+
							'<a href="#pastTests-'+currentTimestamp+'" data-toggle="tab">Missed Tests (<span class="TextHeilight testCount">'+ data.testGroupCount.Past +'</span>)</a>'+
						'</li>';
		}
	}
	testTabs += '</ul>'+'<span class="testTabbtnright"><img src="img/slideright.png"/></span>'+'</div>';
	
	testTabs += '<div class="tab-content">'+
					'<div class="tab-pane '+(data.activeTab == 'Free'? 'active':'')+'" id="freeTests-'+currentTimestamp+'">';
	if(data.tests["testGroups"]["Free"] && Object.keys(data.tests["testGroups"]["Free"]).length > 0){
							
		testTabs += this.LoadTestCards(data.tests, 'Free');
	}
	else{
		testTabs += '<div class="not-available"><img src="img/Alert.png"/><h4>Sorry, no free tests are available for now. Be with us to get more free tests.</h4></div>';
	}
	testTabs += '</div>';
	
	testTabs += '<div class="tab-pane '+(data.activeTab == 'Premium'? 'active':'')+'" id="premiumTests-'+currentTimestamp+'">';
	if(data.tests["testGroups"]["Premium"] && Object.keys(data.tests["testGroups"]["Premium"]).length > 0){
		testTabs += this.LoadTestCards(data.tests, 'Premium');
	}
	else{}
	testTabs += '</div>';
	
	testTabs += '<div class="tab-pane '+(data.activeTab == 'Purchased'? 'active':'')+'" id="purchasedTests-'+currentTimestamp+'">';
	if(data.tests["testGroups"]["Purchased"] && Object.keys(data.tests["testGroups"]["Purchased"]).length > 0){
		testTabs += this.LoadTestCards(data.tests, 'Purchased');
	}
	else{
		testTabs += '<div class="not-available"><img src="img/Alert.png"/><h4>You have not purchased any test yet.</h4></div>';
	}
	testTabs += '</div>';
	
	testTabs += '<div class="tab-pane '+(data.activeTab == 'Attempted'? 'active':'')+'" id="attemptedTests-'+currentTimestamp+'">';
	if(data.tests["testGroups"]["Attempted"] && Object.keys(data.tests["testGroups"]["Attempted"]).length > 0){
		testTabs += this.LoadTestCards(data.tests, 'Attempted');
	}
	else{
		testTabs += '<div class="not-available"><img src="img/Alert.png"/><h4>You have not attempted any test yet.</h4></div>';
	}
	testTabs += '</div>';
	
	testTabs += '<div class="tab-pane '+(data.activeTab == 'Past'? 'active':'')+'" id="pastTests-'+currentTimestamp+'">';
	if(data.tests["testGroups"]["Past"] && Object.keys(data.tests["testGroups"]["Past"]).length > 0){
		testTabs += this.LoadTestCards(data.tests, 'Past');
	}
	else{}
	testTabs += '</div></div></div>';
	
	return testTabs;
};

Factory.prototype.LoadTestCards = function(data, typeId)
{
	var testDataHTML = '';
	var sectionCount = 0;
	var currentTimestamp = new Date().getTime();
	var testTypeId = typeId.toLowerCase() +"Tests";
	var count = 0 ;
	for(var section in data["testGroups"][typeId]){
		var sectionTest = data["testGroups"][typeId][section];
		var ariaExpanded = '';
		var collapseClass = '';
		if(sectionCount == 0){
			ariaExpanded = 'true';
			collapseClass = 'in';
		}
		
		if((typeof data.listType != "undefined") && (parseInt(data.listType) == 1)  )
		{

		}
		else if ((typeof data.listType != "undefined") && (parseInt(data.listType) == 2))
		{
			
		}
		else
		{
			testDataHTML += '<div  class="common-panel" data-toggle="collapse" data-target="#'+typeId+'-'+tr$.strReplace(section)+'-collapse-'+(currentTimestamp+count)+'" aria-expanded='+ariaExpanded+'>'+
									'<h2>'+section+'</h2><span class="TotalTest"> ('+Object.keys(sectionTest).length+' TESTS) </span>'+
									'<span class="panel-img"></span>'+
								'</div>'+
								'<div id="'+typeId+'-'+tr$.strReplace(section)+'-collapse-'+(currentTimestamp+count)+'" class="collapse '+collapseClass+'">';			
		}
		count++;
		var testflagCount = 0;
		var flag_count = true;	
		for(var test in sectionTest){
			var testData = sectionTest[test];
			var shortreport1 = null;
			var shortReport2 = null;
			if(data.testShortReport[testData.itemId]){
				//state 5 is to handle the pause state(SaveForLater), 6 is for PauseBreaked
				//State 1 & 6 ->Resume Test & State 5 ->Paused Test
				if(data.testShortReport[testData.itemId][1]){
					shortreport1 = data.testShortReport[testData.itemId][1];
				}
				else if(data.testShortReport[testData.itemId][5]){
					shortreport1 = data.testShortReport[testData.itemId][5];
				}
				else if(data.testShortReport[testData.itemId][6]){
					shortreport1 = data.testShortReport[testData.itemId][6];
				}
				if(data.testShortReport[testData.itemId][2]){
					shortReport2 = data.testShortReport[testData.itemId][2];
				}
				if(parseInt(testData.typeId) == 4 )
				{
					shortReport2 = data.testShortReport[testData.itemId];
				}
			}
			var ecommData = null;
			if(data.testEcomm[testData.itemId]){
				ecommData = data.testEcomm[testData.itemId];
			}
			var userAttempts = null;
			if(data.userTestAttempts[testData.itemId]){
				userAttempts = data.userTestAttempts[testData.itemId];
			}
			if(typeId == "Purchased" || typeId == "Free"){
				ecommData = null;
			}
			if(testflagCount == 2 && flag_count == true)
			{
				if((typeof data.listType != "undefined") && (parseInt(data.listType) == 1))
				{
					testDataHTML += '<div style="text-align: center;" class="tempmorebtn"><button class="btn btn-default btn-show"> +'+(Object.keys(sectionTest).length - 2)+' More Assignments&nbsp;&nbsp;'+
										'</button></div>';
					testDataHTML += '<div class="toggle-list collapse">';
					flag_count = false;
				}
				else if((typeof data.listType != "undefined") && (parseInt(data.listType) == 2))
				{
					testDataHTML += '<div style="text-align: center;" class="tempmorebtn"><button class="btn btn-default btn-show"> +'+(Object.keys(sectionTest).length - 2)+' More Courseware&nbsp;&nbsp;'+
										'</button></div>';
					testDataHTML += '<div class="toggle-list collapse">';
					flag_count = false;
				}
				else
				{
					testDataHTML += '<div style="text-align: center;" class="tempmorebtn"><button class="btn btn-default btn-show"> +'+(Object.keys(sectionTest).length - 2)+' More Tests&nbsp;&nbsp;'+
										'</button></div>';
					testDataHTML += '<div class="toggle-list collapse">';
					flag_count = false;					
				}
			}
			if(flag_count == true)
				testflagCount++;
			testDataHTML += this.TestCard(testData, shortreport1, shortReport2, ecommData, userAttempts, data.listType);
			sectionCount++;
		}
		if(flag_count == false)
		{
			if((typeof data.listType != "undefined") && (parseInt(data.listType) == 1))
			{
				testDataHTML += '</div>';
				testDataHTML += '<div style="text-align: center;" class="temphidebtn""><button class="btn btn-default btn-hide"> Hide '+(Object.keys(sectionTest).length - 2)+' Assignments&nbsp;&nbsp;'+
										'</button></div>';				
			}
			else if((typeof data.listType != "undefined") && (parseInt(data.listType) == 2))
			{
				testDataHTML += '</div>';
				testDataHTML += '<div style="text-align: center;" class="temphidebtn""><button class="btn btn-default btn-hide"> Hide '+(Object.keys(sectionTest).length - 2)+' Courseware&nbsp;&nbsp;'+
										'</button></div>';				
			}
			else
			{
				testDataHTML += '</div>';
				testDataHTML += '<div style="text-align: center;" class="temphidebtn""><button class="btn btn-default btn-hide"> Hide '+(Object.keys(sectionTest).length - 2)+' Tests&nbsp;&nbsp;'+
										'</button></div>';				
			}

		}
		if(parseInt(data.listType) != 1 && parseInt(data.listType) != 2)
		{
		testDataHTML += '</div>';
		}
	}		
	return testDataHTML;
};

Factory.prototype.TestCard = function(testData, reportPartial, reportFull, ecomm, userAttempts, listType)
{
	var canTake = true;
	var showAttempts = true;
	var testCard = '<div class="testItem TStest container-fluid Card" showReport="'+testData.showReport+'" data-item="'+testData.itemId+'" bucket="'+testData.bucket+'" tr2TestId="'+testData.testId+'"'+((parseInt(testData.typeId) == 4)?('typeid="'+testData.typeId+'" urlkey="'+testData.urlKey+'"'):'') +'>'+
						'<div class="col-xs-12 col-sm-12">'+
							'<h3 class="H3Color">'+testData.title+'</h3>';
					if(parseInt(testData.typeId) != 4){
						testCard +=	'<table class="testData-brief">'+
									'<tr>';
						if((testData.type == 5 || (testData.type >= 21 && testData.type <= 23)) == false){
							testCard += '<td>'+
											'<span class="TextDark">'+testData.totalQuestions+'</span><span> Questions </span>'+
										'</td>'+
										'<td>'+
											'<span class="TextDark">'+testData.totalScore+'</span><span> Marks </span>'+
										'</td>';
						}
						testCard += '<td>'+
										'<span class="TextDark">'+testData.totalTime+'</span><span> Minutes </span>'+
									'</td>'+
								'</tr>'+
							'</table>';
					}
		testCard +=	'</div>'+
						'<div class="col-xxs-12 col-xs-12 col-sm-12">';
								if(parseInt(testData.typeId) == 4 && (typeof listType != "undefined" && parseInt(listType) == 2))
								{
									if(testData.startDate != null && new Date(testData.startDate).getTime() <= new Date().getTime()){
										// canTake = false;
										testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
										'<span><img src="img/time-icon-test.png"></span>'+
										'Published on '+tr$.dateFormat(testData.startDate)+'</div>';
									}
									else if(testData.endDate != null){
										if(new Date(testData.endDate).getTime() > new Date().getTime()){
											testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
											'<span><img src="img/time-icon-test.png"></span>'+
											'Closes on '+tr$.dateFormat(testData.endDate)+'</div>';
										}
										else if(new Date(testData.endDate).getTime() < new Date().getTime()){
											canTake = false;
											showAttempts = false;
											testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
											'<span><img src="img/time-icon-test.png"></span>'+
											'Closed on '+tr$.dateFormat(testData.endDate)+'</div>';
										}
									}									
								}
								else{
									if(testData.startDate != null && new Date(testData.startDate).getTime() > new Date().getTime()){
										canTake = false;
										testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
										'<span><img src="img/time-icon-test.png"></span>'+
										'Available from '+tr$.dateFormat(testData.startDate)+'</div>';
									}
									else if(testData.endDate != null){
										if(new Date(testData.endDate).getTime() > new Date().getTime()){
											testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
											'<span><img src="img/time-icon-test.png"></span>'+
											'Closes on '+tr$.dateFormat(testData.endDate)+'</div>';
										}
										else if(new Date(testData.endDate).getTime() < new Date().getTime()){
											canTake = false;
											showAttempts = false;
											testCard += '<div class="test-close col-xxs-6 col-xs-6 col-sm-6">'+
											'<span><img src="img/time-icon-test.png"></span>'+
											'Closed on '+tr$.dateFormat(testData.endDate)+'</div>';
										}
									}
								}
								testCard += '<div class="testAttemptCount col-xxs-6 col-xs-6 col-sm-6">';
							
							if(parseInt(testData.typeId) == 4 && (typeof listType != "undefined" && parseInt(listType) == 2))
							{

							}
							else
							{
								if(showAttempts){
									var attemptsLeft;
									if(testData.attempts > -1){
										if(userAttempts != null){
											attemptsLeft = testData.attempts - userAttempts;
											if(attemptsLeft <= 0){
												canTake = false;
											}
											testCard += '<span class="attemptCount">'+userAttempts +'</span> / <span class="totalCount">'+ testData.attempts+ ' </span> times attempted';
										}
										else{
											testCard += testData.attempts +' Attempts Available';
										}
									}
									else{
										testCard += '<span class="totalCount">Unlimited attempts';
									}
								}								
							}
								testCard += '</div>'+
											'</div>';
	
	if(reportFull != null && testData.showReport == 1){
		var dataNegative = reportFull.score<0 ? 'true' : 'false';
		var dataNegativeTyping = reportFull.accuracy<0 ? 'true' : 'false';
		if ((testData.type == 5) || (testData.type >= 21 && testData.type <= 23)){
				testCard+= '<div class="col-xxs-12 col-xs-12 col-sm-12">'+
							    '<table style="width:100%;"><tbody><tr><td><div>'+
									'<span>Gross Speed: </span>'+
									'<span class="Number tDark">'+reportFull.grossTypingSpeed+'</span>'+
								'</div></td>'+
								'<td><div>'+
									'<span>Net Speed: </span>'+
									'<span class="Number tDark">'+reportFull.netTypingSpeed+'</span>'+
								'</div></td>'+
								'<td><div>'+
									'<span>Accuracy: </span>'+
									'<span class="Number tDark">'+reportFull.accuracy+'%</span>'+
								'</div></td></tr></table>'+
								'<div class="Percentage" data-Nagative="'+dataNegativeTyping+'">'+
									'<span style="width:'+reportFull.accuracy+'%"></span>'+
								'</div>'+
							'</div>';
		}
		else{
			testCard += '<div class="col-xxs-12 col-xs-12 col-sm-12">'+
						'<div class="testScore col-xs-3 col-sm-3 co-lg-3">';
			if((parseInt(testData.typeId) != 4))
			{			
			testCard +=		'<span>Score: </span>'+
							'<span class=" Number tDark">'+reportFull.score+'</span>';
			}
			testCard +=	'</div>';
			if((parseInt(testData.typeId) != 4))
			{
			testCard +=		'<div class="Percentage col-xs-9 col-sm-9 co-lg-9" data-Nagative="'+dataNegative+'">'+
								'<span style="width:'+Math.abs(100*reportFull.score/testData.totalScore)+'%"></span>'+
							'</div>';
			}
			testCard +=	'</div>';
				}
	}
	else{
		testCard += '<div class="col-xxs-12 col-xs-12 col-sm-12 NotValied">';
				if((parseInt(testData.typeId) != 4))
				{
		testCard +=		'<div class="testScore col-xs-3 col-sm-3 co-lg-3">'+
							'<span>Score: </span>'+
						'</div>'+
						'<div class="Percentage NotValied col-xs-9 col-sm-9 co-lg-9">'+
						'</div>';
				}
		testCard +=	'</div>';
	}
	testCard += '<div class="col-xxs-12 col-xs-12 col-sm-12 co-lg-12">';
	if(((testData.type == 5) || (testData.type >= 21 && testData.type <= 23)) == false || ((testData.typeId == 4)) == true){
		//Not typing test
		if((reportFull != null && testData.showReport == 1 && (testData.typeId != 4))){
			//checkIfDataExists('shortReport', testData.itemId, function(result, id){
			//if(result == 0){
			//	if(offlineMode){
			//		testCard += '<div class="btn btn-primary testReport noOfflineData OfflineMode">Report</div>';
			//	}
			//	else{
			//		testCard += '<div class="btn btn-primary testReport noOfflineData">Report</div>';
			//	}
			//}
			//else{
				//testCard += '<div class="btn btn-primary testReport">Report</div>';
			//}
		//});

			testCard += '<table><tr><td><div class="testReport test-report"  data-action="item/test&id='+testData.testId+'&sessionid='+reportFull.sessionId+'&report=1" >Report</div></td>';
			testCard += '<td><div class="testReport solution test-report" data-action="item/test&id='+testData.testId+'&sessionid='+reportFull.sessionId+'&solution=1" >Solution</div></td>';
		}
		else if(((testData.typeId == 4) && (typeof reportFull != "undefined" && reportFull != null && reportFull.evaluated == 1) )){
			testCard += '<table><tr><td><div class="testReport test-report">Score</div></td>'; //data-action="item/test&id='+testData.testId+'&sessionid='+reportFull.sessionId+'&report=1";
			// testCard += '<td><div class=" NotValied  testReport solution">Solution</div></td>';
		}
		else{
			if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
			{
				if(typeof listType != "undefined" && listType != 2)
				{
					testCard += '<table><tr><td><div class= "NotValied  testReport">Score</div></td>';
				}
				// testCard += '<td><div class=" NotValied  testReport solution">Solution</div></td>';
			}
			else
			{
				testCard += '<table><tr><td><div class= "NotValied  testReport">Report</div></td>';
				testCard += '<td><div class=" NotValied  testReport solution">Solution</div></td>';			
			}

		}
		if(canTake == false){
			if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
			{
				if(typeof listType != "undefined" && listType == 2)
				{
					testCard += '<td><div class="TSButtons NotValied btntxt ">Explore</div></td></tr></table>';				
				}
				else
				{
					testCard += '<td><div class="TSButtons NotValied btntxt ">Submit</div></td></tr></table>';				
				}
			}
			else
			{
				testCard += '<td><div class="TSButtons NotValied btntxt ">Take Test</div></td></tr></table>';				
			}
		}
		else if(reportPartial != null){
			var btnText = "Resume Test";
			if(reportPartial.stateId == '5'){
				btnText = "Paused Test";
			}
			testCard += '<td><div class="TSButtons btntxt " style="color:#FFAA46;;">'+btnText+'</div></td></tr></table>';
		}
		else if(reportFull != null){
			if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
			{
				if(typeof listType != "undefined" && listType == 2)
				{
					testCard += '<td><div class="TSButtons btntxt ">Explore</div></td></tr></table>';
				}
				else
				{
					testCard += '<td><div class="TSButtons btntxt ">Submit</div></td></tr></table>';
				}
			}
			else
			{
				testCard += '<td><div class="TSButtons btntxt ">Re Take Test</div></td></tr></table>';
			}	
		}
		else if(ecomm != null){
			if(ecomm.cost > 0){
				testCard += '<td><div class="TSButtonsPurchase txt  js-checkout" data-action="common/checkout&for='+testData.urlKey+'">Buy for Rs. '+ecomm.cost+'</div></td></tr></table>';
			}
			else if(ecomm.locked == 1){
				testCard += '<td><div class="TSButtonsPurchase txt  js-checkout" data-action="common/checkout&for='+testData.urlKey+'">Buy Package</div></td></tr></table>';
			}
			else{
				if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
				{
					if(typeof listType != "undefined" && listType == 2)
					{	
						testCard += '<td><div class="TSButtons btntxt ">Explore</div></td></tr></table>';	
					}
					else
					{
						testCard += '<td><div class="TSButtons btntxt ">Submit</div></td></tr></table>';	
					}
				}
				else
				{
					testCard += '<td><div class="TSButtons btntxt ">Take Test</div></td></tr></table>';		
				}	
			}
		}
		else if(testData.accessType == TR2AccessType.LOGIN_REQUIRED &&  !(LoggedInUser.Auth())){
			if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
			{
				if(typeof listType != "undefined" && listType == 2)
				{
					testCard += '<td><div class="TSButtons btntxt  loginRequired">Explore</div></td></tr></table>';
				}
				else
				{
					testCard += '<td><div class="TSButtons btntxt  loginRequired">Submit</div></td></tr></table>';
				}
			}
			else
			{
				testCard += '<td><div class="TSButtons btntxt  loginRequired">Take Test</div></td></tr></table>';				
			}	
		}
		else{
			if((typeof testData.typeId != "undefined") && (testData.typeId == 4))
			{
				if(typeof listType != "undefined" && listType == 2)
				{
					testCard += '<td><div class="TSButtons btntxt ">Explore</div></td></tr></table>';
				}
				else
				{
					testCard += '<td><div class="TSButtons btntxt ">Submit</div></td></tr></table>';
				}
			}
			else
			{
				testCard += '<td><div class="TSButtons btntxt ">Take Test</div></td></tr></table>';				
			}
		}
		
	}
	else{
		testCard += '<div><span>Typing Test is available in web only.</span></div>';
	}
	
	testCard += '</div>'+	
				'</div>';
	return testCard;
};
Factory.prototype.studyMaterialTabs = function (data)
{
	var studyMaterialTabs = '';
	var studyMaterialTabs = 
			'<div class="studyMaterialContainer">';
	studyMaterialTabs += '<div class="tabDiv tab-content">'+
					'<div class="tab-pane '+(data.activeTab == 'All'? 'active':'')+'" id="AllstudyMaterials">';
	if(data.studyMaterials && Object.keys(data.studyMaterials).length > 0){
		for(var sm in data.studyMaterials){
			studyMaterialTabs += this.StudyMaterialCard(data.studyMaterials[sm], data.studyMaterialEcomm[data.studyMaterials[sm]["itemId"]], data.baseUrl, 'All');
		}
	}
	studyMaterialTabs += '</div>'+
						'</div>';
	
	return studyMaterialTabs;
};
Factory.prototype.StudyMaterialCard = function(smData, ecommData, baseUrl, typeId)
{
	var html = "";
	if(typeof ecommData != 'undefined'){
		if((typeof ecommData.reverted != 'undefined' && ecommData.reverted == null) || (typeof ecommData.reverted != 'undefined' && ecommData.reverted == 1) || ((typeof ecommData.reverted != 'undefined' && ecommData.reverted == 0) && (typeof ecommData.expiry != 'undefined' && ecommData.expiry != null && ecommData.expiry < new Date()))){
			html += '<div data-toggle="collapse" data-target="#allStudyMaterials_collapse_'+smData.itemId+'" class="studyMaterialContent" data-itemid="'+smData.itemId+'">'+
				'<h2 class="TextDark">'+smData.title+'</h2>';
	
			html += '<a class="buystudyMaterialBtn btn btn-primary-alt pull-right" data-event="js-checkout" data-action="common/checkout&for='+baseUrl+'">BUY NOW</a>'
					+'<span class="locked">'+
						'<img src="img/locked.png" class="pull-right">'+
					'</span>';
		}
		else{
			html += '<div data-toggle="collapse" data-target="#allStudyMaterials_collapse_'+smData.itemId+'" class="studyMaterialContent" data-action="_eventListener" data-itemid="'+smData.itemId+'">'+
				'<h2 class="TextDark">'+smData.title+'</h2>';
	
			html += '<span class="glyphicon glyphicon-chevron-down pull-right"></span>';
			html += '<div id="allStudyMaterials_collapse_'+smData.itemId+'" class="collapse">'+
						'<div class="studyMaterial container-fluid Card">'+
							'<div class="studyMaterialaction">'+
							'<ul>' +
							'</ul>' +
							'</div>'+
						'</div>'+
					'</div>';
		}
	}
	else{
		html += '<div data-toggle="collapse" data-target="#allStudyMaterials_collapse_'+smData.itemId+'" class="studyMaterialContent" data-action="_eventListener" data-itemid="'+smData.itemId+'">'+
				'<h2 class="TextDark">'+smData.title+'</h2>';
	
		html += '<span class="glyphicon glyphicon-chevron-down pull-right"></span>';
		html += '<div id="allStudyMaterials_collapse_'+smData.itemId+'" class="collapse">'+
				'<div class="studyMaterial container-fluid Card">'+
					'<div class="studyMaterialaction">'+
					'<ul>' +
				     '</ul>' +
					'</div>'+
				'</div>'+
			'</div>';
	}
		
	html += '</div>';
	return html;
};
Factory.prototype.ShowHideList = function (viewDom)
{
	var posT = null;
	viewDom.find(".btn-hide").hide();
	viewDom.find(".btn-show").add(".btn-hide").click(function(){
		if($(this).hasClass("btn-show"))
		{
			posT = $(viewDom).scrollTop();
		}
		else{
			$(viewDom).scrollTop(posT);
		}
		var parentDom = $(this).parent().parent();
		parentDom.children(".toggle-list").collapse("toggle");
		parentDom.find(".btn-show").toggle();
		parentDom.find(".btn-hide").toggle();
	});
};
Factory.prototype.PackageTabs = function (data)
{
	packageTabs = "";
	if((typeof data.packagePlanCount != 'undefined') && (data.packagePlanCount.hasOwnProperty('plans') ||
			data.packagePlanCount.hasOwnProperty('packages') ||
			data.packagePlanCount.hasOwnProperty('subscribed'))){
		if(data.packagePlanCount.packages +  data.packagePlanCount.plans + data.packagePlanCount.subscribed > 0 )
		{
			packageTabs +=
						'<div class="packageContainerTab">'+
							'<ul class="nav nav-tabs">';
			if(data.packagePlanCount.plans > 0)
			{
				packageTabs +=
					'<li class="'+(data.PackageActiveTab == 'Plans'? 'active':'')+'">'+
						'<a href="#plansTab" data-toggle="tab">Plans(<span class="TextHeilight">'+data.packagePlanCount.plans+'</span>)</a>'+
					'</li>';
			}
			if((data.packagePlanCount.packages > 0))
			{
				packageTabs +=
					'<li class="'+(data.PackageActiveTab == 'Packages'? 'active':'')+'">'+
						'<a href="#packagesTab" data-toggle="tab">Packages(<span class="TextHeilight">'+data.packagePlanCount.packages+'</span>)</a>'+
					'</li>';
			}
			packageTabs +=
					'<li class="'+(data.PackageActiveTab == 'Subscribed'? 'active':'')+'">'+
						'<a href="#subscribedPackagesPlans" data-toggle="tab" class="'+(data.packagePlanCount.subscribed == 0 ? 'NotValied':'')+'">My Plans & Packages(<span class="TextHeilight">'+ data.packagePlanCount.subscribed +'</span>)</a>'+
					'</li>'+
				'</ul>'+
				'<div class="tab-content p2List">'+
					'<div class="tab-pane '+(data.PackageActiveTab == 'Packages'? 'active':'')+'" id="packagesTab">'+
						'<div class="packageDiv Card">'+
							'<div class="packageList container">'+
								'<div class="packageposition">';
				if(data.plansAndPackages.packages.length > 0)
				{
					for(var i in data.plansAndPackages.packages)
					{
						packageTabs += this.PackageCard(data.plansAndPackages.packages[i]);
					}
				}
				packageTabs+=
								'</div>'+
							'</div>'+
							//'<span class="glyphicon glyphicon-menu-left packagebtnleft"></span>'+
							//'<span class="glyphicon glyphicon-menu-right packagebtnright"></span>'+
						'</div>'+
					'</div>'+
					'<div class="tab-pane '+(data.PackageActiveTab == 'Plans'? 'active':'')+'" id="plansTab">'+
						'<div class="packageDiv Card">'+
							'<div class="packageList container">'+
								'<div class="packageposition">';
				if(data.plansAndPackages.plans.length > 0 )
				{
					for(var i in data.plansAndPackages.plans)
					{
						packageTabs += this.PackageCard(data.plansAndPackages.plans[i]);
					}
				}
				packageTabs+=
								'</div>'+
							'</div>'+
						'</div>'+
					'</div>'+
					'<div class="tab-pane '+(data.PackageActiveTab == 'Subscribed'? 'active':'')+'" id="subscribedPackagesPlans">'+
						'<div class="packageDiv Card">'+
							'<div class="packageList container">'+
								'<div class="packageposition">';
				if(data.plansAndPackages.subscribed.length > 0 )
				{
					for(var i in data.plansAndPackages.subscribed)
					{
						packageTabs += this.PackageCard(data.plansAndPackages.subscribed[i]);
					}
				}
				packageTabs+=
								'</div>'+
							'</div>'+
							//'<span class="glyphicon glyphicon-menu-left packagebtnleft"></span>'+
							//'<span class="glyphicon glyphicon-menu-right packagebtnright"></span>'+
						'</div>'+
					'</div>'+
				'</div>'+
			'</div>';
		}
	}
	else{
		packageTabs = 0;
	}
	return packageTabs;
};
Factory.prototype.PackageCard = function(packageData)
{
	var packageCard = '';

	if(tr$.length(packageData.details) > 0)
	{
		var mrp = parseFloat(packageData.mrp);

			cost = parseFloat(packageData.details.cost);

			maxCostOfPaidRelatedPackage = parseFloat(packageData.details.maxCostOfPaidRelatedPackage);

			finalCost = maxCostOfPaidRelatedPackage > 0 ? Math.max(cost - maxCostOfPaidRelatedPackage,0):cost;

			curTimestamp = Date.parse(new Date);

			validTill = packageData.details.tillDate;

			unlockValidity = typeof packageData.details.unlockValidity !== 'undefined' ? packageData.details.unlockValidity : null;

		packageCard +=
			'<div class="package"  data-itemId="'+packageData.itemId+'" data-deliveryId="'+packageData.id+'" pkgType="'+((packageData.isPkgVersionSec == 1)?"scoreup":"course")+'" >'+
				'<div class="pkgHeader">'+
					'<p>'+packageData.title+'</p>'+
					'<div class="Price">';

					if(mrp > cost)
					{
						packageCard +=
							'<s class="Number">&#8377;'+mrp+'/-</s> <span class="Number BuyingPrice">&#8377;'+cost+'/-</span>'+
							'<span class="discount">'+Math.round(100 - (100 *cost/mrp),2)+'% OFF</span>';
					}
					else
					{
						packageCard +=
							'<span class="BuyingPrice Number">&#8377;' +cost+'/-</span>';
					}
		packageCard +=
					'</div>';

					if(maxCostOfPaidRelatedPackage > 0 && finalCost > 0)
					{
						packageCard +=
							'<div class="Price"> Upgrade at'+
								'<span class="Number">'+
								'&#8377; '+finalCost+'/-'+
								'</span>'+
							'</div>';
					}
		packageCard +=
				'</div>'+
				'<div class="pkgDetail">'+
					'<span class="glyphicon glyphicon-menu-up descriptionlinesbtnup"></span>'+
					'<div class="pkgDescription">';
					if(unlockValidity != null && new Date(unlockValidity) > new Date())
					{
						packageCard +=
							'<p class="errorMsg"><strong>Expires on: '+tr$.dateFormat(unlockValidity) +'</strong></p>';
					}
					if(tr$.length(packageData.shortdescription))
					{
						for(var i in packageData.shortdescription)
						{
							packageCard +=
							'<p class="descriptionlines">'+packageData.shortdescription[i]+'</p>';
						}
					}
					if(validTill != null && validTill != "")// && new Date(validTill) > new Date())
					{
						packageCard +=
						'<p><strong>Valid till:'+tr$.dateFormat(validTill)+'</strong></p>';
					}
		packageCard +=
					  '</div>' +
					  '<span class="glyphicon glyphicon-menu-down descriptionlinesbtndown"></span>';
					  var validFrom = null;
					  if(typeof packageData.details.validFrom != undefined && packageData.details.validFrom != null && packageData.details.validFrom.length > 0){
					  	validFrom = new Date(packageData.details.validFrom);
					  }
					  var tillDate = null;
					  if(typeof packageData.details.tillDate != undefined && packageData.details.tillDate != null && packageData.details.tillDate.length > 0){
					  	tillDate = new Date(packageData.details.tillDate);
					  }
					  var presentDate = new Date();
					  if(validFrom != null && validFrom > presentDate){
					  	 var monthNames = ["January", "February", "March", "April", "May", "June",
  															"July", "August", "September", "October", "November", "December"
															 ];
						var validmessage = 'Enrollment starts from '+validFrom.getDate()+' '+monthNames[validFrom.getMonth()]+' '+validFrom.getFullYear()+' ';
							packageCard +=		  '<div class="ribbon-front">'+
																			'<span class="valid_datemessage">'+validmessage+'</span>';
							if(typeof packageData.noExplore === "undefined" && packageData.noExplore !== 1)
							{
								if(typeof packageData.urlKey != 'undefined')
									packageCard += 	'<a class="btn btn-primary _eventListener valid_datemessage_explore" data-url="'+packageData.urlKey+'" data-action="item/package&id='+packageData.id+'">Explore</a>';
								else
									packageCard += 	'<a class="btn btn-primary _eventListener valid_datemessage_explore" data-action="item/package&id='+packageData.id+'">Explore</a>';
							}
							packageCard +=	'</div>';
					  }
					  else if(tillDate != null && tillDate < presentDate){
					  	 var monthNames = ["January", "February", "March", "April", "May", "June",
  															"July", "August", "September", "October", "November", "December"
															 ];
						var validmessage = 'Enrollment closed on '+tillDate.getDate()+' '+monthNames[tillDate.getMonth()]+' '+tillDate.getFullYear()+' ';
						packageCard += '<div class="ribbon-front">'+
										'<span class="valid_datemessage">'+validmessage+'</span>';
						if(typeof packageData.noExplore === "undefined" && packageData.noExplore !== 1)
						{
							if(typeof packageData.urlKey != 'undefined')
								packageCard += 	'<a class="btn btn-primary _eventListener valid_datemessage_explore" data-url="'+packageData.urlKey+'" data-action="item/package&id='+packageData.id+'">Explore</a>';
							else
								packageCard += 	'<a class="btn btn-primary _eventListener valid_datemessage_explore" data-action="item/package&id='+packageData.id+'">Explore</a>';
						}
						packageCard +=	'</div>';
					  }
					  else{
					  	packageCard +=		  '<div class="ribbon-front">';
					  	if(( finalCost > 0 && ((packageData.details.reverted == null || (packageData.details.reverted == 1)) || (packageData.details.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp))) && typeof payment_policies != "undefined" && parseInt(payment_policies) == 0)
						{
							packageCard += '<div class="paymentpolocies_div"><span>This content can be consumed on our website as well.</span></div>';
						}
						if(typeof packageData.noExplore === "undefined" && packageData.noExplore !== 1)
						{
							if(typeof packageData.urlKey != 'undefined')
								packageCard += '<a class="btn btn-primary _eventListener" data-url="'+packageData.urlKey+'" data-action="item/package&id='+packageData.id+'">Explore</a>';
							else
								packageCard += '<a class="btn btn-primary _eventListener" data-action="item/package&id='+packageData.id+'">Explore</a>';	
						}

						if( finalCost > 0 && ((packageData.details.reverted == null || (packageData.details.reverted == 1)) || (packageData.details.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp)) )
						{
							packageCard +=
									'<a class="btn btn-primary  js-checkout" data-action="common/checkout&for='+packageData.urlKey+'&pkgexploreid='+packageData.id+'">';
							packageCard += (maxCostOfPaidRelatedPackage > 0)? 'Upgrade Now' : 'Buy Now' ;
							packageCard +=
									'</a>';
						}
						packageCard += '</div>';
					  }
			packageCard +=	'</div>'+
			'</div>';
	}
	return packageCard;
};
Factory.prototype.VideoTabs = function (data)
{
	var currentTimestamp = new Date().getTime();
	var videoTabs = '';
	if(data.videoCount.demo +  data.videoCount.ongoing + data.videoCount.past + data.videoCount.upcoming > 0 )
	{
		videoTabs +=
		'<div class="videos-container">'+
			'<div class="videotabDiv">'+
				'<span class="videoTabbtnleft"><img src="img/slideleft.png"/></span>'+
				'<ul class="nav nav-tabs tabList">';
		if(data.videoCount.demo > 0 ) 
		{
		videoTabs +=
					'<li class="videoTab '+((data.videoActiveTab == 'demo')&&(data.videoCount.demo > 0)? 'active':'')+'">'+
						'<a href="#demo-'+currentTimestamp+'" data-toggle="tab">Demo Classes(<span class="TextHeilight">'+data.videoCount.demo+'</span>)</a>'+
					'</li>';
		}
		if(data.videoCount.ongoing > 0 )
		{
		videoTabs +=
					'<li class="videoTab '+((data.videoActiveTab == 'ongoing')&&(data.videoCount.ongoing > 0)? 'active':'')+'">'+
						'<a href="#ongoing-'+currentTimestamp+'" data-toggle="tab">Ongoing Classes(<span class="TextHeilight">'+data.videoCount.ongoing+'</span>)</a>'+
					'</li>';
		}			
		if(data.videoCount.upcoming > 0 )
		{
		videoTabs +=
					'<li class="videoTab '+((data.videoActiveTab == 'upcoming')&&(data.videoCount.upcoming > 0)? 'active':'')+'">'+
						'<a href="#upcoming-'+currentTimestamp+'" data-toggle="tab">Upcoming Classes(<span class="TextHeilight">'+data.videoCount.upcoming+'</span>)</a>'+
					'</li>';
		}
		if(data.vodOnly == 1 && data.videoCount.past > 0 )
		{

			videoTabs +=
						'<li class="videoTab '+((data.videoActiveTab == 'past')&&(data.videoCount.past > 0)? 'active':'')+'">'+
							'<a href="#past-'+currentTimestamp+'" data-toggle="tab">Videos (<span class="TextHeilight">'+data.videoCount.past+'</span>)</a>'+
						'</li>';
		}
		else if(data.videoCount.past > 0){
				
					videoTabs +=
							'<li class="videoTab '+(data.videoActiveTab == 'past'? 'active':'')+'">'+
								'<a href="#past-'+currentTimestamp+'" data-toggle="tab">Past Classes(<span class="TextHeilight">'+data.videoCount.past+'</span>)</a>'+
							'</li>';
				
		}
		videoTabs +=
				'</ul>'+
				'<span class="videoTabbtnright"><img src="img/slideright.png"/></span>'+
			'</div>';

		videoTabs += '<div class="tab-content">';
		if(data.videoGroup["demo"] && Object.keys(data.videoGroup["demo"]).length > 0){
			videoTabs += '<div class="tab-pane '+(data.videoActiveTab == 'demo'? 'active':'')+'" id="demo-'+currentTimestamp+'">';
			videoTabs += this.LoadVideoCards(data, 'demo');
			videoTabs += '</div>';
		}
		
		if(data.videoGroup["ongoing"] && Object.keys(data.videoGroup["ongoing"]).length > 0){
			videoTabs +=	'<div class="tab-pane '+(data.videoActiveTab == 'ongoing'? 'active':'')+'" id="ongoing-'+currentTimestamp+'">';
			videoTabs += this.LoadVideoCards(data, 'ongoing');
			videoTabs += '</div>';
		}
		
		if(data.videoGroup["upcoming"] && Object.keys(data.videoGroup["upcoming"]).length > 0){
			videoTabs +=	'<div class="tab-pane '+(data.videoActiveTab == 'upcoming'? 'active':'')+'" id="upcoming-'+currentTimestamp+'">';
			videoTabs += this.LoadVideoCards(data, 'upcoming');
			videoTabs += '</div>';
		}
		
		if(data.videoGroup["past"] && Object.keys(data.videoGroup["past"]).length > 0){
			videoTabs +=	'<div class="tab-pane '+(data.videoActiveTab == 'past'? 'active':'')+'" id="past-'+currentTimestamp+'">';
			videoTabs += this.LoadVideoCards(data, 'past');
			videoTabs += '</div>';
		}
		videoTabs += '</div>'+
					'</div>';
	}
	return videoTabs;
};
Factory.prototype.LoadVideoCards = function(data, typeId)
{
	var currentTimestamp = new Date().getTime();
	var videoDataHTML = '';
	var sectionCount = 0;
	var count = 0 ;
	var videoTypeId = typeId.toLowerCase() +"Videoes";
	if(typeId == 'upcoming' || typeId == 'ongoing' ){
		for(var video in data["videoGroup"][typeId]){
			var videoData = data["videoGroup"][typeId][video];
			var ecomm = data.liveClassesEcomData[video];
			videoDataHTML += this.VideoCard(videoData, ecomm, typeId);
		}
	}
	else{
		for(var section in data["videoGroup"][typeId]){
			var sectionVideo = data["videoGroup"][typeId][section];
			var videoList = sortObject(data["videoGroup"][typeId][section]);
			var ariaExpanded = '';
			var collapseClass = '';
			if(sectionCount == 0){
				ariaExpanded = 'true';
				collapseClass = 'in';
			}

			videoDataHTML += '<div class="common-panel" data-toggle="collapse" data-target="#'+videoTypeId+'-'+tr$.strReplace(section)+'-collapse-'+(currentTimestamp+count)+'" aria-expanded='+ariaExpanded+'>'+
									'<h2>'+section+'</h2><span class="type-count">('+Object.keys(sectionVideo).length+' Classes)</span>'+
									'<span class="panel-img"></span>'+
								'</div>'+
								'<div id="'+videoTypeId+'-'+tr$.strReplace(section)+'-collapse-'+(currentTimestamp+count)+'" class="collapse '+collapseClass+'">';
			count++;
			var videoflagCount = 0;
			var flag_count = true;
			for(var video in videoList){

				var videoData = videoList[video][0];
				var ecomm = data.liveClassesEcomData[videoData.itemId];
				//console.log(ecomm);
				if(videoflagCount == 2 && flag_count == true)
				{
					videoDataHTML += '<div style="text-align: center;display:block; margin:auto;" class="tempmorebtn"><button class="btn btn-default btn-show"> +'+(Object.keys(sectionVideo).length - 2)+' More Videos&nbsp;&nbsp;'+
									'</button></div>';
					videoDataHTML += '<div class="toggle-list collapse">';
					flag_count = false;

				}
				if(flag_count == true)
					videoflagCount++;

				videoDataHTML += this.VideoCard(videoData, ecomm, typeId);
				sectionCount++;
			}
			if(flag_count == false)
			{
				videoDataHTML += '</div>';
				videoDataHTML += '<div style="text-align: center;" class="temphidebtn""><button class="btn btn-default btn-hide"> Hide '+(Object.keys(sectionVideo).length - 2)+' Videos&nbsp;&nbsp;'+
									'</button></div>';
			}
			videoDataHTML += '</div>';
		}
	}
	return videoDataHTML;
};
Factory.prototype.VideoCard = function(videoData, ecomm, typeId){

	var videoImageUrl = "img/client_images/defaultlv_class.jpg";
	if(typeof videoData.tr1Data.priviewImageUrl != 'undefined' && videoData.tr1Data.priviewImageUrl != null && videoData.tr1Data.priviewImageUrl.length > 0){
		videoImageUrl = videoData.tr1Data.priviewImageUrl;
	}
	videoCard = '<div class="video">'+
					'<div>'+
						'<div class="preview _eventListener lazy" data-action="item/liveclasses&id='+videoData.id+'" data-bg="url('+videoImageUrl+')" >'+
							'<div class="videooverlay"><img src="img/play-btn.png"></div>'+
						'</div>'+
						'<div>'+
						'<p class="title">'+videoData.title+'</p>'+
						'<div class="start-date">'+
						'<span><img src = "img/timer.png"/></span>';
						if(typeId == 'upcoming'){
							videoCard += '<span>Scheduled On:</span>';
						}
						else{
							videoCard += '<span>Conducted On:</span>';
						}
						videoCard += videoData.tr1Data.startDate+
							'</div></div></div>';
	if(typeof ecomm !== 'undefined' &&	ecomm.purchesed === 0){
		videoCard += '<a class="buy-class _eventListener js-checkout" data-action="common/checkout&for=' + videoData.urlKey + '">' + '<p class="videobuy btn-default">Buy Now </p>' + '</a>';
		}


	videoCard +=    '</div>';

	return videoCard;
};
Factory.prototype.Faqs = function(data){
	var faqs = {
		html:'',
		bindEvents: function(){
			$(".faqAnswer").hide();
			$('.faqdropdown').find('.faqQuestion').click(function(){
				$(".faqAnswer").not($(this).next()).slideUp('fast');
				$(this).next().slideToggle('fast');
				var closing = $(this).find('span.glyphicon.glyphicon-chevron-down').length == 0;

				$(this).parents('.faqdropdown').find('span.glyphicon.glyphicon-chevron-up').each(function(){
					$(this).removeClass('glyphicon-chevron-up');
					$(this).addClass('glyphicon-chevron-down');
				});
				if(!closing)
				{
					$(this).find('span.glyphicon').removeClass('glyphicon-chevron-down');
					$(this).find('span.glyphicon').addClass('glyphicon-chevron-up');
				}
		    });
		}
	};
	if(typeof data !== "undefined" && tr$.length(data) > 0)
	{
		faqs.html +=
			'<h2 class="TextDark">FAQ\'s</h2>'+
			'<div class="faqdropdown Card">';
		for(var i in data)
		{
			faqs.html +=this.FaqCard(data[i]);
		}
		faqs.html +=
			'</div>';
	}
	return faqs;
};
Factory.prototype.FaqCard = function(data){
	var faqCard =
		'<div class="faq">'+
			'<div class="faqQuestion"><span>'+data.question+'</span><span class="glyphicon glyphicon-chevron-down icon"></span></div>'+
			'<div class="faqAnswer">'+
				'<div class="faq_padding"></div>'+
				'<p class="faq_spacing">'+data.answer+'</p>'+
			'</div>'+
		'</div>';
	return faqCard;
};
Factory.prototype.dQuizCard = function(data,activeQuizCard){
	var quizCard = '';
	quizCard += '<div class="quiz item ' + activeQuizCard + ' " quizId ="' + data.quiz.id + '" style="background-color: ' + data.quiz.color + ';">' +
	 				'<div class="quizHeader">' +
	 					'<div class="heading">' +
	 						'<span class="cardTitle">' +
	 							data.quiz.title +
	 						'</span>' +
	 						'<span class="quizimg"><img src = "https://cdn.toprankers.com/images/liveclasquiz-023b11deb59b4.png"/></span>' +
	 						'<div class="dquizdate">'+
							'<p>';
							if(typeof data.dateSegregation != "undefined" && parseInt(data.dateSegregation) == 1)
							{
								quizCard	+= ((typeof data.quiz.date != "undefined"  && data.quiz.date != null && data.quiz.date != "00-00-0000")?data.quiz.date:data.quiz.createdOn);
							}
				quizCard += '</p>'+
							'</div>' +
							'</div>' +
	 						'</div>' +
	 						/* '<div class="quizdescription">' + 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy' +
	 						 * '</div>' + */
	 						 '<div class="quizStates quizdetails">';
	if (typeof data.quiz.attemptInfo !== "undefined" && data.quiz.attemptInfo && data.quiz.attemptInfo.state == 2) {
		quizCard += '<div class="col-xs-4">' +
						'<span class="label label-success">' + data.quiz.attemptInfo.correctAttempt + '/' + data.quiz.attemptInfo.lastQuestion + '</span>' +
						'<span class="report-text" >CORRECT</span>' +
					'</div>' +
					'<div class="col-xs-4">' +
						'<span class="label label-danger">' +
							(parseInt(data.quiz.attemptInfo.lastQuestion) + 0 - parseInt(data.quiz.attemptInfo.correctAttempt)) + '/' + data.quiz.attemptInfo.lastQuestion +
						'</span>' +
						'<span class="report-text" >INCORRECT</span>' +
					'</div>' +
					'<div class="col-xs-4">' +
						'<span class="label label-info">' +
							Math.round((parseInt(data.quiz.attemptInfo.correctAttempt) * 100.0 / parseInt(data.quiz.attemptInfo.lastQuestion)) * 10) / 10 + '%</span>' + // Math.round( num * 10 ) / 10; to get in single decimal digit
						'<span class="report-text">ACCURACY</span>' +
					'</div>';
	} else {
		quizCard += '<span class="quesdetail">No of Questions: <span>' + data.quiz.totalQuestions + '</span></span>' + '<span class="timedetail">Total Marks: <span>' + data.quiz.totalScore + '</span></span>';
	}
	quizCard += '</div><div class="attempt-count">';
	if(typeof data.quiz.attemptCount != 'undefined' && parseInt(data.quiz.attemptCount) > 250){
		quizCard += '<span>'+data.quiz.attemptCount+' Attempts</span>';
	}
	quizCard += '</div>'+
				'<div class="quizFooter">';

	if (parseInt(data.quiz.lock) == 1) {
		quizCard += '<button class="btn btn-primary quiz-btns quiz_buy">Buy Now' +
					'</button>';
	} else {
		var addclasses = "";
		//addclasses = ( typeof data.quiz.attemptInfo !== "undefined" && data.quiz.attemptInfo.state == 2 ) ? ' ' : 'displaynone disabledone disabled';
		quizCard += '<div class="quiz-btns" style="background-color: ' + data.quiz.color + ';">';
		if ( typeof data.quiz.attemptInfo !== "undefined" && data.quiz.attemptInfo.state == 2) {
			quizCard += '<button class="btn btn-primary report" data-action="app/quizreport&id=' + data.quiz.itemId + '">' + 'Report' + '</button>';
		}
		else if ( typeof data.quiz.attemptInfo !== "undefined" && data.quiz.attemptInfo.state != 2){ //&& tr$.length(data.quiz.attemptInfo) > 0) {
			//if (parseInt(data.quiz.attemptInfo.lastQuestion) < parseInt(data.quiz.totalQuestions)) {
				quizCard += '<button class="btn btn-default resumQuiz takeQuiz " data-action="app/quiz&id=' + data.quiz.itemId + '">' + /*resumQuiz*/
				'Resume' + '</button>';
			//}
		} else {
			quizCard += '<button class="btn btn-primary takeQuiz" data-action="app/quiz&id=' + data.quiz.itemId + '" >' + 'Start Quiz' + '</button>';
		}
		quizCard += '</div>';
	}
	quizCard += '</div>' + '</div>';
	return quizCard;
};

Factory.prototype.showBookmarks = function() {
	tr$.ajax({
		mod : "user",
		ack : "getBookmarkLink",
		successClb : function(reply) {
			var serverAddress = remoteServer;
			if(typeof UrlMgmt.getObj().menuData != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta.homeUrl != 'undefined'&& UrlMgmt.getObj().menuData.domainmeta.homeUrl.length > 0){
				serverAddress = 'http://'+UrlMgmt.getObj().menuData.domainmeta.homeUrl;
			}
			window.open(serverAddress + reply.data, '_system');
		}
	});
};
Factory.prototype.scrollToCenter = function(selectorString) {
	var parentDom = $(selectorString).parent();
	var activeElement = $(selectorString+'.active');
	if(activeElement.length !== 0)
	{
		var offset = parentDom.scrollLeft() + activeElement.offset().left - parentDom.offset().left - parentDom[0].clientWidth/2 + activeElement.outerWidth(true)/2;
		parentDom.animate({scrollLeft: offset}, 1000);
	}
	$(selectorString).unbind().bind('click', function(){
		var offset = parentDom.scrollLeft() + $(this).offset().left - parentDom.offset().left - parentDom[0].clientWidth/2 + $(this).outerWidth(true)/2;
		parentDom.animate({scrollLeft: offset}, 1000);
    });
};
Factory.prototype.QuickAccess = function(dataObj){
	/* if top view changes html of modal, after pop below view infobtn will show the changed html,
	it is better top populate and show quick access on btn-click */
	try
	{
		dataObj.buttonDom.unbind().bind('click',dataObj,function(e){
			if(typeof e.data.title === 'string')
			{
				$('#info-modal').find(".modalheading").text(e.data.title);
			}
			var QuickAccessCards = '';
		    for(var key in e.data.quickaccessList){

		        var value = e.data.quickaccessList[key];
		        QuickAccessCards +=
		        	'<div class="examQuickAccessCard" data-url="'+value["url"]+'">'+value["title"]+'</div>';
		    }
		    $(".examinfomodal").html(QuickAccessCards);

		    $('#info-modal').modal('show');

		    if(!UrlMgmt.getObj().App.isOnline)
			{
				$('#info-modal').find(".modal-dialog").css("margin-bottom","18px");
			}
			else{
				$('#info-modal').find(".modal-dialog").css("margin-bottom","0px");
			}

		    setTimeout(function(){
		    	var quickAccessSlide = new slideVertical();
				quickAccessSlide.Init("examinfobody", "examinfomodal", "examQuickAccessCard",0);
		    }, 300);
		    if(typeof dataObj.bindevents === 'function')
		    {
		    	dataObj.bindevents();
		    }
		});
	}
	catch(e)
	{
		console.log(e);
	}
};
Factory.prototype.LoadFeaturedArticles = function(data){
	var html = '';
	try
	{
		var articles = indicators = '';
			active = 'active';
			curTimestamp = new Date().getTime();
		for(var key in data){
			var fArticle = data[key];
			articles += "<div class='item "+active+" col-sm-6 col-xs-12'>"+
						"<a href='"+fArticle["url"]+"' title='"+fArticle["title"]+"'>"+
								"<div class='thumbnail'>"+
								"<img class='lazy' data-src='"+fArticle["imageUrl"]+"' src=\"img/default-img.jpg\"  alt='"+fArticle["title"]+"'/>"+
									"<div class='caption'>"+
										"<p>"+fArticle["text"]+"</p>"+
									"</div>"+
								"</div>"+
							"</a>"+
	   					"</div>";
	   		indicators += "<li class='featArt-dot "+active+"' data-target='#featuredArticle-carousel-"+curTimestamp+"' data-slide-to='"+key+"'></li>";
	   		active = '';
	   	}
	   	var html =
	   		'<h4 class="featured-article-msg">Featured Articles</h4>'+
			'<div class="featuredArticleDiv">'+
				'<div class="featuredArticleList">'+
					'<div id="featuredArticle-carousel-'+curTimestamp+'" class="carousel slide" data-interval="false">'+
						'<ol class="carousel-indicators">'+
							indicators+
		  				'</ol>'+
						'<div class="carousel-inner featArticle" role="listbox">'+
							articles+
						'</div>'+
					'</div>'+
				'</div>'+
			'</div>';
	}
	catch(e)
	{
		console.log(e);
	}
	return html;
};
Factory.prototype.LoadSubMenus = function(data, dom)
{
	var submenuCards = '';
	var urls = [];
	try
	{
		for(var key in data)
		{
			var value = data[key];
			var forApp = ( typeof value.forApp !== 'undefined' && value.forApp == 0) ? false : true;
			if(forApp)
			{
				submenuCards += '<a href="'+value["url"]+'" class="" accessType="'+value["accessType"]+'" data-action="">'+
									'<div class="submenu">'+
										'<span class="textcontent">'+value["title"]+'</span>'+
									'</div>'+
								'</a>';
				var str = value["url"].split('#')[0];
				if (str.length > 0) {
					urls.push(value["url"]);
				}
			}
		}
		$(dom).html(submenuCards);

		if (urls.length > 0) {
			tr$.ajax({
				mod : "tr2app",
				ack : "geturlaction",
				additionalParams : {
					urls : urls
				},
				successClb : function(response) {
					var data = response.data;
					if (Object.keys(data).length > 0) {
						for (var i in data) {

							if(data[i]["action"].startsWith('common/exam')){
								//return false;
							}
							else{
								$(dom).find('a[href="' + i + '"]').attr("data-action", data[i]["action"] + "&response-type=2&fromapp=1");
							}

							if (!( typeof window.sqlitePlugin == 'undefined' || SQLiteOps.getObj().databaseOpen == false)) {
								SQLiteOps.getObj().WriteTable("urlaction", data[i].urlKey, data[i]["action"]);
							}
						}
					}
					$(dom).find('a').unbind().bind("click", function(e) {
						e.preventDefault();
						if ($(e.currentTarget).attr("accesstype") == TR2AccessType.LOGIN_REQUIRED && !LoggedInUser.Auth()) {
							UrlMgmt.getObj().Route({
								route : 'common/tr2login',
								needData : false
							});
							return false;
						}
						if($(e.currentTarget).attr('href') == '#thread'){
							var currentDom = UrlMgmt.getObj().actionStack[UrlMgmt.getObj().actionStack.length - 1].controler.stableDom;
							if($(currentDom).find('.discussion_div').find('.loadDiscussion').length > 0){
								$(currentDom).find('.discussion_div').find('.loadDiscussion').click();
							}
							else{
								URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
							}
						}
						else{
							URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
						}
					});
				}.bind(this),
				errorClb : function() {
					$(dom).find('a').unbind().bind("click", function(e) {
						e.preventDefault();
						if ($(e.currentTarget).attr("accesstype") == TR2AccessType.LOGIN_REQUIRED && !LoggedInUser.Auth()) {
							UrlMgmt.getObj().Route({
								route : 'common/tr2login',
								needData : false
							});
							return false;
						}
						if($(e.currentTarget).attr('href') == '#thread'){
							var currentDom = UrlMgmt.getObj().actionStack[UrlMgmt.getObj().actionStack.length - 1].controler.stableDom;
							if($(currentDom).find('.discussion_div').find('.loadDiscussion').length > 0){
								$(currentDom).find('.discussion_div').find('.loadDiscussion').click();
							}
							else{
								URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
							}
						}
						else{
							URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
						}
					});
				}
			});
		}
	}
	catch(e)
	{
		console.log(e);
	}
	return submenuCards;
};
Factory.prototype.blinkIndicators = function(view,selectorString,scrollString){

	$(view).find(selectorString).find('.rightblink').remove();
	$(view).find(selectorString).find('.leftblink').remove();

	var blinkindicator = '<img src="img/scroll-btn-right-2x.png" class="rightblink">'+
						 '<img src="img/scroll-btn-left-2x.png" class="leftblink">';
	$(blinkindicator).appendTo(selectorString);
	if(selectorString[0] == scrollString[0])
	{
		var height = $(view).find(selectorString).height();
		var scroller= $(view).find(selectorString);
	}
	else
	{
		var height = $(view).find(selectorString).find(scrollString).height();
		var scroller= $(view).find(selectorString).find(scrollString);
	}
	var width = $(view).width();
	var diffwidth = $(view).find(selectorString).outerWidth();
	diffwidth = diffwidth - width;
	if(diffwidth <= 0)
	{
		diffwidth = 0;
	}
	var rblink = $(view).find(selectorString).find('.rightblink');
	var lblink = $(view).find(selectorString).find('.leftblink');
	var diffheight = $(rblink).height();
	height = height - diffheight;
	height = height/2;
	$(view).find(selectorString).css({"position":"relative"});
	$(lblink).css({"position":"absolute","top": height,"left":diffwidth,"animation-name":"blink","animation-duration":"3s","animation-iteration-count":"infinite"});
	$(rblink).css({"position":"absolute","top": height,"right":diffwidth,"animation-name":"blink","animation-duration":"3s","animation-iteration-count":"infinite"});

	$(view).find(scroller).on("scroll", function(){
		$(lblink).remove();
		$(rblink).remove();
		$(this).off();
	});

};
//Load view in offline mode when offline data is also not available
Factory.prototype.LoadViewForOffline = function (target)
{
	tr$.touchScrollAnimation(target.dom);
	var tryagain = '<div class="tryagain">'+
		'<div>No Internet Connection</div>'+
		'<button type="button" class="btnTryAgain btn btn-danger">Try again</button>'+
		'</div>';

	$(tryagain).appendTo($(target.dom));
	$(".tryagain").find('.btnTryAgain').unbind().bind("click", function(e) {
		if(!UrlMgmt.getObj().App.isOnline)
		{
			UrlMgmt.getObj().App.onOffline();
		}
		else{
			var urlMgmt = UrlMgmt.getObj();
			urlMgmt.Refresh();
		}
	}.bind(this));
};
//Notify update
Factory.prototype.ShowNotifyUpdate = function()
{
	if(typeof UrlMgmt.getObj().notifyUpdate != 'undefined' && UrlMgmt.getObj().notifyUpdate == true){
		$('.app_update_notification').show();
	 	//$('.versioncontent').text("App Current version is "+TRHelper._version+". New version of the App "+UrlMgmt.getObj().App.version['id'] +" has been released.");
		$('.app_update_notification').find('.versioncontent').text("To experience the latest features, please update our app from playstore.");

		$('.appupdate').find('.btnAppUpdate').unbind().bind("click",function(){
			 cordova.plugins.market.open(packageName);
		});
	}
	else{
		$('.app_update_notification').hide();
	}
};
//Load discussions
Factory.prototype.LoadDiscussions = function(data, dom)
{
	var urlMgmt = UrlMgmt.getObj();

	if ( typeof data.threadId != "undefined" && parseInt(data.threadId) > 0) {
		$(dom).find(".discussion_header").html("Discussion");
		if(!urlMgmt.App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		urlMgmt.Route({
			route : 'lists/discussion&id=' + data.threadId,
			needData : false,
			terminate : true
		}, function(object) {
			object.controler.data = {};
			object.controler.data["discussions"] = data.discussions;
			object.controler.data["threadId"] = data.threadId;
			object.controler.Init(dom);
		});
	}
};
Factory.prototype.DashboardScoreupCard = function(data, loop)
{
	console.log("inside scoreup card");
	
	var cardHtml = "";
	if(typeof loop != 'undefined' && loop == 1)
	{
		cardHtml += '<div data-scoreup-view="open" class="scoreup-div scoreupcard" data-item="'+data.packageId+'" data-delivery-id="'+data.id+'" packageType="scoreup">';
	}
	else
	{
		cardHtml += '<div class="scoreup-div scoreupcard" data-item="'+data.packageId+'" data-delivery-id="'+data.id+'" packageType="scoreup">';
	}
	 	cardHtml += 	'<div class="flex-box scoreup-toggle collapsed" data-toggle="collapse" data-target="#scoreup_container'+data.packageId+'">'+
	 						'<div class="scoreup-header">'+
	 							'<div class="scoreup-title">'+
	 								'<div class="scoreup_title_left">'+
	 									'<img src="https://cdn.toprankers.net/svg/tr-dashboard/tr-scoreup-logo.svg" alt="Scoreup" class="loading" data-was-processed="true"> <br>'+
	 									'<span class="ft_wght1">'+data.title+'</span>'+
	 								'</div>'+
 									'<div class="scoreup_title_right">'+
 										'<div class="purchasetitle">'+
 											'<span>purchased on &nbsp;-&nbsp;</span>'+
 											'<span>'+this.getdateformat(data.validFrom)+'</span>'+
 										'</div>';
								if(typeof data.validTill != 'undefined' && data.validTill != null)
								{
									//var yesterday = new Date(new Date().setDate(new Date().getDate()-1));
									var d = new Date();
									d.setDate(d.getDate()-1);
									d.setMonth(d.getMonth() + 1);
									var yesterday = d.getFullYear()+"-"+('0'+d.getMonth()).substr(-2)+"-"+('0'+d.getDate()).substr(-2)+ " 00:00:00";
									if(data.validTill > yesterday)
									{
										//var validTill = new Date(data.validTill);
										var validTill = this.getdateformat(data.validTill);
		cardHtml +=						'<div class="packageDuration"><span class="soreup-vaidity">Valid till &nbsp;-&nbsp;</span>'+
											'<span class="soreup-vaidity">'+validTill+'</span>'+
										'</div>';
									}
									else
									{
										//var validTill = new Date(data.validTill);
										var validTill = this.getdateformat(data.validTill);
		cardHtml +=						'<div class="packageDuration">'+
											'<span class="soreup-vaidity expired">Expired On &nbsp;-&nbsp;</span>'+
											'<span class="soreup-vaidity expired">'+validTill+'</span>'+
										'</div>';	
									}
								}
		cardHtml +=					'</div>'+
								'</div>'+
							'</div>'+
							'<span class="collapse_arrows">'+
								'<span class="glyphicon glyphicon-menu-right" aria-hidden="true"></span>'+
							'</span>'+
						'</div>'+
					'</div>';
		return cardHtml;
								
};
Factory.prototype.DashboardCourseCard = function(data)
{
	console.log("inside course card");
	var cardHtml = "";
		cardHtml += '<div class="scoreup-div course_list_withoutcallpa courseCard " data-itemId="'+data.packageId+'" data-delivery-id="'+data.id+'" data-card="course"  data-subcategory=\''+(typeof data.subCategeroies != "undefined"? JSON.stringify(data.subCategeroies):'')+'\'>'+
						'<div class="flex-box scoreup-toggle collapsed course_list_withoutcallpa2 bages_green" data-toggle="collapse" data-target="#course_list_'+data.packageId+'">';
	
		cardHtml += 		'<div class="package_item">'+
								'<div class="package_colmn1">'+
									'<div class="package_colmn_lft " data-itemId="'+data.packageId+'" data-delivery-id="'+data.id+'" type="package">'+
										'<div class="course_list_title">'+data.title+'</div>';
	if(typeof data.subCategeroies == 'undefined')
	{
		cardHtml +=						'<div class="course_list_cnt" >'+
											'<span data-info="test-total">0 Total Tests</span>'+
											'<span data-info="test-attempted">0 Attempted</span>'+
											'<span data-info="test-unattempted">0 Unattempted</span>'+
											'<span data-info="video-total">0 Total Videos</span>'+
											'<span data-info="video-watched">0 Videos Watched</span>'+
										'</div>';
	}
	else if(typeof data.linkcount != 'undefined' && data.linkcount == 1)
	{
		if(typeof data.subCategeroies.testlist != 'undefined')
		{
			cardHtml +=	 				'<div class="course_list_cnt" data-delivery-id="'+data.subCategeroies.testlist[0].id+'" type="testList">'+
											'<span data-info="test-attempted">0 Attempted</span>'+
											'<span data-info="test-unattempted">0 Unattempted</span>'+
										'</div>';
		}
		else
		{
			cardHtml +=	 				'<div class="course_list_cnt" data-delivery-id="'+data.subCategeroies.batch[0].id+'" type="batch">'+
											'<span data-info="video-total">0 Total Videos</span>'+
											'<span data-info="video-watched">0 Videos Watched</span>'+
										'</div>';
		}				
	}
	cardHtml +=           			'</div>'+
									'<div class="package_colmn_rgt">'+
										'<div class="package_date">'+
											'<div class="packagetitle">'+
												'<span>purchased on &nbsp;- &nbsp;</span>'+
												'<span>'+this.getdateformat(data.validFrom)+'</span>'+
											'</div>';
									if(typeof data.validTill != 'undefined' && data.validTill != null)
									{
										var d = new Date();
										d.setDate(d.getDate()-1);
										d.setMonth(d.getMonth() + 1);
										var yesterday = d.getFullYear()+"-"+('0'+d.getMonth()).substr(-2)+"-"+('0'+d.getDate()).substr(-2)+ " 00:00:00";
										if(data.validTill > yesterday)
										{
											var validTill = this.getdateformat(data.validTill);
						cardHtml +=			'<div class="packageDuration"><span class="soreup-vaidity">Valid till &nbsp;-&nbsp;</span>'+
												'<span class="soreup-vaidity">'+validTill+'</span>'+
											'</div>';
										}
										else
										{
											var validTill = this.getdateformat(data.validTill);
						cardHtml +=			'<div class="packageDuration">'+
												'<span class="soreup-vaidity expired">Expired On &nbsp;-&nbsp;</span>'+
												'<span class="soreup-vaidity expired">'+validTill+'</span>'+
											'</div>';					
										}
									}
	cardHtml +=							'</div>'+
									'</div>'+
								'</div>'+
								'<div class="package_colmn2">'+
									'<div class="package_colmn_lft " data-itemId="'+data.packageId+'" data-delivery-id="'+data.id+'" type="package">'+
										'<div class="cards_video_info">'+
											'<div data-type="video" video-status="None" class="display-none ">'+
												'<span status-text="video-status"></span>'+
												'<span class="time_caption" video-start-date-text="start-date-text">Starts At: <span video-start-date="start-date"></span></span>'+
											'</div>'+
										'</div>'+
									'</div>'+
							'</div>'+
						'</div>'+
						'<span class="collapse_arrows">'+
							'<span class="glyphicon glyphicon-menu-right" aria-hidden="true"></span>'+
						'</span>';
					
	cardHtml += 	'</div>';
	cardHtml +=	 '</div>';							
	return cardHtml;
};

Factory.prototype.ScoreUpFilterModel = function(data)
{
	console.log(pkgId);
	var allTags = data.allTags;
	var seletedTags = data.selectedTags;
	var pkgId = data.pkgDeliveryId;
	var filterhtml =   '';
	for (var k in allTags)
	{			       
		 filterhtml +=   '<li class="categoryfilterLi ">'+
							 '<a class="js-categoryfiltername_div" value="'+k+'"" >'+
							 '<span class="filtername">'+allTags[k].categoryTitle+'</span>'+
								 '<label class="switch">'+
								 	'<input type="radio" name="categoryRadio" class="categoryRadio" value="'+k+'"">'+
								 '</label>'+
					    	 '</a>'+
				         '</li>';					    			
    }
   $('#scoreupfilter').find('.CourseFilteroption').attr('pkgDeliveryId', pkgId);
   $('#scoreupfilter').find('.CourseFilteroption .catFilterHead').html(filterhtml);	
   
   					
   $('#scoreupfilter').modal('show'); 
   
   //slider("catDiv", 'cattabList', "categoryTab")
		$(".categoryfilterLi").unbind().bind('click',this,function(evt){
			$(this).closest('.catFilterHead').find('li').removeClass('active');
			$(this).addClass('active');
			var calculate1 = $(this).closest('.catFilterHead').scrollLeft() + $(this).offset().left-$(this).closest('.catFilterHead').offset().left-$(this).closest('.catFilterHead')[0].clientWidth/2 + $(this).outerWidth(true)/2;
			$(this).closest('.catFilterHead').animate({
				scrollLeft: calculate1
			}, 1000);
		});
		$(".js-categoryfiltername_div").unbind().bind('click',this,function(evt){
			 $(this).find('.categoryRadio').prop("checked", true);
			 var checked_val =  $(this).find('.categoryRadio').prop("value");		
			 if(typeof(Object.keys(allTags[checked_val].subCategories)) != 'undefined' && Object.keys(allTags[checked_val].subCategories).length > 0)	
			 {
			 	 evt.data.ScoreUpFilterLoadSubCategory(checked_val,allTags,seletedTags, pkgId); 
		 	 }
		});
		

		
		$(".js-course_filter").unbind().bind('click',this,function(evi)
		{
			var dim1_value = $("#courseFilter .js-categoryfiltername_div").find("input[name=categoryRadio]:checked").prop("value");		
			var dim2_value = $("#courseFilter .sub_categoryfilter .js-sub_categoryfiltername_div").find("input[name=sub_categoryRadio]:checked").prop("value");  
			$('#courseFilter').modal('hide');
			 if(typeof(Object.keys(allTags[dim1_value].subCategories)) != 'undefined' && Object.keys(allTags[dim1_value].subCategories).length > 0)	
			 {
			   UrlMgmt.getObj().Route({route: 'item/package&id='+evi.data.id+'&tag1='+dim1_value+'&tag2='+dim2_value+'', needData: true, offlineAllowed: true});	  
		    } else {
		       UrlMgmt.getObj().Route({route: 'item/package&id='+evi.data.id+'', needData: true, offlineAllowed: true});	  
			
		    }
		});
				
		$('.js-course_filter_reset').unbind().bind('click',this,function(e)
		{
			$('#scoreupfilter').modal('hide');
		});
		
 		$("#scoreupfilter .js-categoryfiltername_div [value ="+seletedTags.tag1+"]").click();
 		//slider($('#scoreupfilter').find("categoryfilter"),$('#scoreupfilter').find('.catFilterHead'),"categoryfilterLi");
 		slider("categoryfilter",'catFilterHead',"categoryfilterLi");
 		// slider($('#scoreupfilter').find(".categoryfilter.catDiv"), 'cattabList', 'categoryTab');
 		
 		
 		//buy
 		var buyDom = $('#scoreupfilter').find('.buy-scoreup');
 		
 		if(typeof data.buyObj !== 'undefined' && data.buyObj.showBuy)
 		{
 			if(data.buyObj.mrp > data.buyObj.cost)
 			{
 				buyDom.find('.filed-mrp').text(data.buyObj.mrp);
 				buyDom.find('.discount').html(data.buyObj.discount+'&#37; OFF');
 				buyDom.find('.strikethrough').show();
 				buyDom.find('.discount').show();
 			}
 			else
 			{
 				buyDom.find('.strikethrough').hide();
 				buyDom.find('.discount').hide();
 			}
 			buyDom.find('.filed-cost').text(data.buyObj.cost);
 			
 			buyDom.find('.js-buy-scoreup').attr('data-action',buyObj.checkoutAction);
			if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
			{
				buyDom.find('.js-buy-scoreup').unbind().bind('click',function(e){
						$('#purchaseredirect-modal').modal("show");
						$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
			        });
			    buyDom.find('.js-buy-scoreup').html("More");
			}
			else
			{ 			
	 			buyDom.find('.js-buy-scoreup').unbind().bind('click',function(){
	 				UrlMgmt.getObj().Route({route: $(this).attr('data-action'), needData: true, offlineAllowed: false});
	 				$('#scoreupfilter').modal('hide');
	 			});
	 			buyDom.find('.js-buy-scoreup').html("Buy");
 			}
 			buyDom.show();
 		}
 		else
 		{
 			buyDom.hide();
 		}
};

Factory.prototype.ScoreUpFilterLoadSubCategory = function(dim1_value,allTags,seletedTags, pkgId)
{		
		var tagIds = [];
		var SCfilterhtml =  '<div class="sub_catfilter stickyTabs catDiv" >';
		for(var k in allTags[dim1_value].subCategories)
		{ 
			tagIds.push(allTags[dim1_value].subCategories[k].id);
			SCfilterhtml +='<div class="js-sub_categoryfiltername_div" tag1="'+dim1_value+'" tag2="'+k+'" data-deliveryId="'+allTags[dim1_value].subCategories[k].id+'">'+
							 '<span class="sub_filtername">'+allTags[dim1_value].subCategories[k].Title+'</span>'+
							 '<label class="sub_switch">'+
							 '<input type="radio" name="sub_categoryRadio"  value="'+k+'" class="sub_categoryRadio">'+
							 '</label>'+
							 '<div class="cardCount"></div>'+
							 '<img src="img/right-nav-blue.png">'+							 
					    	 '</div>';
					    	 				
		  }
		      SCfilterhtml += '</div>';
		  	$('#scoreupfilter').find('.sub_categoryfilter').html(SCfilterhtml);
		  	$('#scoreupfilter').find('.sub_categoryfilter').find(".js-sub_categoryfiltername_div").unbind().bind('click',this,function(e){
				 var tag1 = $(e.currentTarget).attr('tag1');
				 var tag2 = $(e.currentTarget).attr('tag2');
				 UrlMgmt.getObj().Route({route: 'item/package&id='+parseInt(pkgId)+'&tag1='+tag1+'&tag2='+tag2, needData: true, offlineAllowed: false});
				// console.log(e.data);
				 //URLRedirection(allTags[tag1]["subCategories"][tag2].url);
				 $('#scoreupfilter').modal('hide');
			});	
	var cat_value = $("#scoreupfilter .js-categoryfiltername_div").find("input[name=categoryRadio]:checked").prop("value");		
			
	 if (cat_value == seletedTags.tag1) 
	  {
	
	   $("#scoreupfilter .sub_categoryfilter .js-sub_categoryfiltername_div [value ="+seletedTags.tag2+"]").prop("checked", true);
	
      } else 
      {
      	$("#scoreupfilter .sub_categoryfilter .js-sub_categoryfiltername_div [value="+Object.keys(allTags[dim1_value].subCategories)[0]+"]").prop("checked", true);
      }
      //var activeDom = $("#scoreupfilter .sub_categoryfilter)
      console.log(tagIds);
      console.log($("#scoreupfilter .sub_categoryfilter"));
      if(tagIds.length > 0)
      {
      	this.GetUserTestsAttemptedDatabyTags(tagIds, $("#scoreupfilter .sub_categoryfilter"));	
      }
};
Factory.prototype.ExplorePkg = function(dom, callback)
{
	console.log(dom);
	var pkgId = dom.attr('data-itemid');
	var domainId = domaingroupId;
	tr$.ajax({
		mod: "tr2package",
		ack: "getAllTags",
		additionalParams:{
			pkgId: pkgId,
			domainId: domainId
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var data = response.data;
			callback(data);
		}.bind(this),
		errorClb: function(){
			callback(null);
		}
	});
};

Factory.prototype.PackageMenuModel = function(subcategories)
{
	var testList = '';
	var BatchList = '';
		if(typeof subcategories.batch != "undefined" && subcategories.batch.length == 1 && typeof subcategories.testlist == "undefined")
		{	
				URLRedirection(remoteServer+subcategories.batch[0].url);
				return;
		}
		if(typeof subcategories.testlist != "undefined" && subcategories.testlist.length == 1 && typeof subcategories.batch == "undefined")
		{
			    URLRedirection(remoteServer+subcategories.testlist[0].url);
				return;
		}
		var testListIds = [];
		var batchIds = [];
		if(typeof subcategories.testlist != "undefined" && subcategories.testlist.length > 0 && typeof subcategories.batch == "undefined") //&& typeof subcategories.batch == "undefined"
		{
			var testListhtml = '';
			(subcategories.testlist).forEach(function(item, index){
				testListhtml += '<div class="subItem" data-id="'+item["id"]+'" data-url="'+item["url"]+'" data-type="'+item["type"]+'">'+
							  	'<p>'+item["title"]+'</p>'+
							  	'<img src="img/right-nav-blue.png">'+
							  	'<div class="coursecount"><span data-info="test-attempted"></span><span data-info="test-unattempted"></span></div>'+
							    '</div>';
				testListIds.push(item["id"]);				
			});
			$("#explorableLinksCourseCard").find(".course-nav").hide();
			$(".tab-content #test-tab").addClass('active');
			$("#explorableLinksCourseCard .tab-content #test-tab").html(testListhtml);
			$("#explorableLinksCourseCard .tab-content #batch-tab").html("");
			
		}
		else if(typeof subcategories.batch != "undefined" && subcategories.batch.length > 0 && typeof subcategories.testlist == "undefined") //&& typeof subcategories.testlist == "undefined"
		{
			var batchListhtml = '';
			(subcategories.batch).forEach(function(item, index){
				batchListhtml += '<div class="subItem" data-id="'+item["id"]+'" data-url="'+item["url"]+'" data-type="'+item["type"]+'">'+
							  	'<p>'+item["title"]+'</p>'+
							  	'<img src="img/right-nav-blue.png">'+
							  	'<div class="coursecount"><span data-info="video-watched"></span><span data-info="video-total"></span></div>'+
							    '<div data-type="video" video-status="None" class="display-none">'+
							    	'<span status-text="video-status">'+
							    	'</span><span class="time_caption" video-start-date-text="start-date-text">Starts At: <span video-start-date="start-date"></span></span>'+
							    '</div></div>'+
							    '</div>';
				batchIds.push(item["id"]);			
			});
			$("#explorableLinksCourseCard").find(".course-nav").hide();
			$(".tab-content #batch-tab").addClass('active');
			$("#explorableLinksCourseCard .tab-content #batch-tab").html(batchListhtml);
			$("#explorableLinksCourseCard .tab-content #test-tab").html("");
		}
		else if(subcategories.batch.length > 0 && subcategories.testlist.length > 0 )
		{
			var testListhtml = '';
			(subcategories.testlist).forEach(function(item, index){
				testListhtml += '<div class="subItem" data-id="'+item["id"]+'" data-url="'+item["url"]+'" data-type="'+item["type"]+'">'+
							  	'<p>'+item["title"]+'</p>'+
							  	'<img src="img/right-nav-blue.png">'+
							  	'<div class="coursecount"><span data-info="test-attempted"></span><span data-info="test-unattempted"></span></div>'+
							    '</div>';	
				testListIds.push(item["id"]); 			
			});
			$("#explorableLinksCourseCard .tab-content #test-tab").html(testListhtml);
			var batchListhtml = '';
			(subcategories.batch).forEach(function(item, index){
				batchListhtml += '<div class="subItem" data-id="'+item["id"]+'" data-url="'+item["url"]+'" data-type="'+item["type"]+'">'+
							  	'<p>'+item["title"]+'</p>'+
							  	'<img src="img/right-nav-blue.png">'+
							  	'<div class="coursecount"><span data-info="video-watched"></span><span data-info="video-total"></span></div>'+
							    '<div data-type="video" video-status="None" class="display-none">'+
							    	'<span status-text="video-status">'+
							    	'</span><span class="time_caption" video-start-date-text="start-date-text">Starts At: <span video-start-date="start-date"></span></span>'+
							    '</div>'+
							    '</div>';
				batchIds.push(item["id"]);			
			});
			$("#explorableLinksCourseCard .tab-content #batch-tab").html(batchListhtml);
			$("#explorableLinksCourseCard").find(".course-nav").show();
		}
		if(testListIds.length > 0)
		{
			this.GetUserTestsAttemptedData(testListIds);
		}
		if(batchIds.length > 0)
		{
			this.GetUserWatchedVideoData(batchIds);
			var tabDom = $("#explorableLinksCourseCard .tab-content #batch-tab .subItem");
			this.getpackageBatchattributes(batchIds,tabDom);
		}
		$("#explorableLinksCourseCard").modal('show');

		Factory.getObj().PackageMenuModelBindEvent();
	
};

Factory.prototype.PackageMenuModelBindEvent = function()
{
	$("#explorableLinksCourseCard").find('.subItem').unbind().bind('click',this,function(e){
		$("#explorableLinksCourseCard").modal('hide');
		URLRedirection($(this).attr('data-url'));
	});
	$("#explorableLinksCourseCard").find('[filterTab="batchTestTab"]').unbind().bind('click',this,function(e){
		var id = $(e.currentTarget).find('a').attr('href');
		var tabContent = $("#explorableLinksCourseCard").find('.tab-content '+id+'');
		
		batchIds = [];
		testListIds = [];
		tabContent.find('.subItem').each(function(i, obj)
		{
			var id = $(obj).attr('data-id');
			console.log(id);
			if($(obj).attr('data-type') == 'batch')
			{
				batchIds.push(id);
			}
			if($(obj).attr('data-type') == 'testList')
			{
				testListIds.push(id);
			}
		});
		if(testListIds.length > 0)
		{
			this.GetUserTestsAttemptedData(testListIds);
		}
		if(batchIds.length > 0)
		{
			this.GetUserWatchedVideoData(batchIds);
			var tabDom = $("#explorableLinksCourseCard .tab-content #batch-tab .subItem");
			this.getpackageBatchattributes(batchIds,tabDom);
		}
	}.bind(this));
};
Factory.prototype.GetUserTestsAttemptedDatabyTags = function(tagIds, activetabdom)
{
	tr$.ajax({
		mod: "tr2user",
		ack: "getusertestsattempteddatabytags",
		additionalParams:{
			tags:tagIds,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var data = response.data;
			console.log(data);
			var tagDom = activetabdom.find('.sub_catfilter .js-sub_categoryfiltername_div');
			console.log(tagDom);
			$(tagDom).each(function(){
				var tagId = $(this).attr('data-deliveryid');
				if(typeof data[tagId] != "undefined")
				{
				 var html = '<span class="test-attempted" data-info="test-attempted"><b>'+ data[tagId]['attemptcount'] +'</b> Attempted </span>'+
							'<span class="test-unattempted" data-info="test-unattempted"><b>'+ data[tagId]['unattemptcount'] +'</b> Unattempted</span>';
				}
				$(this).find('.cardCount').html(html);
			});
			
		}.bind(this),
		errorClb: function(){
			
		}
	});
};
Factory.prototype.GetUserWatchedVideoData = function(batchIds)
{
	console.log(batchIds);
	tr$.ajax({
		mod: "tr2user",
		ack: "getuserwatchedvideodata",
		additionalParams:{
			batchid:batchIds,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var userwatcheddata = response.data;
			 $.each( userwatcheddata, function( batchlistId, data ) {
					 var batchDom = $("#explorableLinksCourseCard .tab-content [data-type='batch'][data-id='"+batchlistId+"']");
					 $(batchDom).find('[data-info="video-total"]').html("<b>"+data.totalcount+'</b> Total Videos');
				 	 $(batchDom).find('[data-info="video-watched"]').html("<b>"+data.watchedcount+'</b> Videos Watched');
				 });
			
		}.bind(this),
		errorClb: function(){
			
		}
	});
};
Factory.prototype.GetUserTestsAttemptedData = function(testlistdid)
{
	console.log(testlistdid);
	tr$.ajax({
		mod: "tr2user",
		ack: "getusertestsattempteddata",
		additionalParams:{
			testlistids:testlistdid,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var usertestdata = response.data;
			console.log(usertestdata);
			 $.each( usertestdata, function( testlistdid, data ) {
					 var testListDom = $("#explorableLinksCourseCard .tab-content [data-type='testList'][data-id='"+testlistdid+"']");
					 console.log(testListDom);
					 $(testListDom).find('[data-info="test-attempted"]').html('<b>'+data.attemptcount+'</b> Attempted');
				 	 $(testListDom).find('[data-info="test-unattempted"]').html('<b>'+data.unattemptcount+'</b> Unattempted');
				 });
			
		}.bind(this),
		errorClb: function(){
			
		}
	});
};
Factory.prototype.getpackageBatchattributes = function(batches, coursedom)
{
	
	tr$.ajax({
		mod: "tr2user",
		ack: "getBatchStatus",
		additionalParams:{
			batchid	: batches,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var userbatchdata = response.data;
			console.log(userbatchdata);
			 $.each(userbatchdata, function(index, batch) {
			 	var dom = $('#explorableLinksCourseCard').find('[data-type="batch"][data-id="'+index+'"]');
			 	
					if(typeof batch.live != 'undefined')
				    {
				    	dom.find('[data-type="video"]').attr('video-status', 'live');
				    	//dom.find('[data-type="video"] [video-title="title"]').text(batch.live.title);
				    	dom.find('[data-type="video"] [video-start-date="start-date"]').hide();
				    	dom.find('[data-type="video"] [video-start-date-text="start-date-text"]').hide();
				    	dom.find('[data-type="video"] [status-text="video-status"]').text('LIVE');
				    	dom.find('[data-type="video"] [status-text="video-status"]').removeClass('upcoming');
				    	dom.find('[data-type="video"] [status-text="video-status"]').addClass('live');
				   		$('[video-status="live"]').removeClass('display-none');
				   		
				    }
				    else if(typeof batch.upcoming != 'undefined')
				    {
				    	if(dom.find('[data-type="video"]').attr('video-status') != 'live')
				    	{
				    		dom.find('[data-type="video"]').attr('video-status', 'upcoming');
				    		if(dom.find('[data-type="video"] [video-start-date="start-date"]').text() !='')
				    		{
				    			var d1 = new Date(dom.find('[data-type="video"] [video-start-date="start-date"]').text());
				    			var d2 = new Date(batch.upcoming.startDate);
				    			if(d1 > d2)
				    			{
				    				//dom.find('[data-type="video"] [video-title="title"]').text(packageData.upcoming.title);
				    				dom.find('[data-type="video"] [video-start-date="start-date"]').text(this.getdateformat(batch.upcoming.startDate));
				    			}
				    		}
				    		else
				    		{
				    			//dom.find('[data-type="video"] [video-title="title"]').text(batch.upcoming.title);
				    			dom.find('[data-type="video"] [video-start-date="start-date"]').text(this.getdateformat(batch.upcoming.startDate));
				    		}
				    		dom.find('[data-type="video"] [status-text="video-status"]').text('UPCOMING');
				    		dom.find('[data-type="video"] [status-text="video-status"]').addClass('upcoming');
				    	}
				    	$('#explorableLinksCourseCard').find('[video-status="upcoming"]').removeClass('display-none');
				    }
				 }.bind(this));
			
		}.bind(this),
		errorClb: function(){
			
		}
	});
};
Factory.prototype.getdateformat = function(data_data)
{
	var d = new Date(data_data);
	var month = new Array();
	month[0]  = "Jan";
	month[1]  = "Feb";
	month[2]  = "Mar";
	month[3]  = "Apr";
	month[4]  = "May";
	month[5]  = "Jun";
	month[6]  = "Jul";
	month[7]  = "Aug";
	month[8]  = "Sep";
	month[9]  = "Oct";
	month[10] = "Nov";
	month[11] = "Dec";	
	var a = d.getHours() > 12 ? d.getHours() - 12:d.getHours();
	var b = d.getHours() > 12 ? "PM":"AM";
	return(('0'+d.getDate()).substr(-2)+" "+month[d.getMonth()]+" "+d.getFullYear());
};
Factory.prototype.UpdateAddress = function(data){
	
	var sectionId = data.sectionId;
	var postData = {};
	var vError=false;
	
	$(data.dom).find(".Address-details").find(".fieldDiv").each(function(){
		var typeId = parseInt($(this).attr("data-typeid"));
		var required = parseInt($(this).attr("isrequired"));
		
		switch(typeId)
		{
			case UserProfileFieldsType.PlainText:
				var val = $(this).find("input").val();
				if(required == 1 && val.length==0)
				{
					$(this).addClass("ErrorInput");
					$(this).find(".ErrorMsg").text('field cannot be empty');
					vError = true;	
				}
				else if(val.length > 0)
				{
					$(this).find(".ErrorMsg").text('');
					postData[$(this).attr("data-fieldid")] = val;
				}
			break;
			case UserProfileFieldsType.ENUM:
    			var val = $(this).find("select").val();
    			if(required == 1 && val == -1)
				{
					$(this).addClass("ErrorInput");
					$(this).find(".ErrorMsg").text('Please select State');
					vError = true;	
				}
				else if(val != -1)
				{
					$(this).find(".ErrorMsg").text('');
					postData[$(this).attr("data-fieldid")] = val;
				}
    		break;
		}	
	});
	if(vError == true)
	{
		//$(".profile_msg").html("<span class='error'>Error: Fix all the errors and then try to save!</span>");
		return;	
	}
	tr$.ajax({
		mod : "profilefields",
		ack : "saveprofile",
		additionalParams : {
			data: postData,
			id: sectionId
		},
		successClb : function(response) {
			try {
				if (response.result.state == "ok") 
				{
					alert("Successfully Saved");
					$(data.dom).find('.Address-details').find('.fieldDiv').each(function(){
						if($(this).find('input').length > 0)
						{
							$(this).find('input').addClass("edit_disabled");
						}
						else if($(this).find('select').length > 0)
						{
							$(this).find('select').addClass("edit_disabled");
						}
					});
					$(this.dom).find('.Address-details').find('.UpdateAddress').text('Edit Address');
					 UrlMgmt.getObj().Refresh();
				}
				else
				{
					   alert("Error: "+response.result.meta+" ");
				}
			} catch(e) {
				console.log(response.data);
				console.log("error=" + e);
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
	
};

Factory.prototype.ActiveCourseCard = function(coursearray)
{
	var coursecard = '';
	for(var key in coursearray)
	{
		var data = coursearray[key];
		if(tr$.length(data.details) > 0)
		{
			var mrp = parseFloat(data.mrp);
	
				cost = parseFloat(data.details.cost);
	
				maxCostOfPaidRelatedPackage = parseFloat(data.details.maxCostOfPaidRelatedPackage);
	
				finalCost = maxCostOfPaidRelatedPackage > 0 ? Math.max(cost - maxCostOfPaidRelatedPackage,0):cost;
	
				curTimestamp = Date.parse(new Date);
	
				validTill = data.details.tillDate;
	
				unlockValidity = typeof data.details.unlockValidity !== 'undefined' ? data.details.unlockValidity : null;
	coursecard +='<div class="mpackage" data-links=\''+data.exploreLinks+'\' data-packageurlkey='+data.urlKey+' data-itemid='+data.itemId+' data-deliveryid='+data.id+' style="'+(typeof data.listIndex !="undefined"?'order:'+data.listIndex:'')+'">'+
					'<div class="mpackage_innerDiv">'+
						'<div class="head">';
							if(data.cardImgUrl!=null && data.cardImgUrl!= "" )
							{
	            			 coursecard += '<div class="card-img">'+
	            			 	'<img class="lazy loaded" data-src="'+data.cardImgUrl+'"/>';
	            			}
	            			else
	            			{
	            			 coursecard +='<div class="card-img defaultimg">'+
	            			 '<img class="lazy loaded default" data-src="https://cdn.toprankers.net/images/default-thumb-image-024bff0f40094.jpg"/>';
	            			}
	       coursecard +='</div>'+
	            			'<div class="card-info">'+
							 '<div class = "mtitle">'+data.title+'</div>';
							 if(data.cardDescription!= null)
							 {
							 coursecard +='<div class="desc">'+data.cardDescription+'</div>';
							 }
							 else{
							 	coursecard +='<div class="desc"></div>';
							 }
							coursecard +='</div>'+
						'</div>'+					
							'<div class="foot">';
									coursecard +=	'<div class="Price">';
															if(mrp > cost)
															{
																coursecard +=
																	'<s class="Number mrp">&#8377;'+mrp+'</s> <span class="Number BuyingPrice">&#8377;'+cost+'</span>'+
																	'<span class="save_word">Save</span><span class="save_price">&#8377;'+Math.round(mrp - cost)+'</span>';
															}
															else
															{
																coursecard +=
																	'<span class="Number BuyingPrice">&#8377;' +cost+'/-</span>';
															}
															if( finalCost > 0 && ((data.details.reverted == null || (data.details.reverted == 1)) || (data.details.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp)) )
														{
																coursecard +=   '</div>'+
																 '<div class="action-btns">'+	
																 		'</span>'+	 
																			'<a class="btn-submit js-checkout" data-action="common/checkout&for='+data.urlKey+'&pkgexploreid='+data.id+'">BUY NOW</a>'+
																		'</span>'+
																'</div>';
														}else
														{
																coursecard +=   '</div>'+
																 '<div class="action-btns">'+	
																 		'<span>'+	 
																			'<a class="btn-explore js-checkout" data-action="item/package&id='+data.id+'">EXPLORE</a>'+
																		'</span>'+
																'</div>';															
														}
															
	
			   coursecard +=    '</div>'+
			         '</div>'+
			     '</div>';
									
		}
	}
	return coursecard;
};   
