/******* TR Helper *******/
var _trTracker = null;
function TRTracker(){}
TRTracker.getObj = function()
{
	if(_trTracker == null)
	{
		_trTracker = new TRTracker();
	}
	return _trTracker;
};

TRTracker.prototype.TrackWEEvent = function(event, view, callback)
{
	var we = 0;
	if(typeof UrlMgmt.getObj().App.version != 'undefined' && typeof UrlMgmt.getObj().App.version["web_engage"] != 'undefined'){
		we = UrlMgmt.getObj().App.version["web_engage"];
	}
	if(we == 0){
		console.log("Web engage disabled");
		return false;
	}
	console.log("Web engage enabled");
	var urlMgmt = UrlMgmt.getObj();
	try{
			switch(event){
				case "Login":
					if(typeof webengage !== 'undefined'){
						webengage.user.login(urlMgmt.userData.id);
					   	webengage.user.setAttribute('we_email', urlMgmt.userData.emailId);
					   	webengage.user.setAttribute('we_phone', urlMgmt.userData.settings[0][2]);
					   	webengage.user.setAttribute('we_name', urlMgmt.userData.displayName);
					   	webengage.user.setAttribute('fromApp', "yes");
					  }
				   	break;
				case "Registration":
					if(typeof webengage !== 'undefined'){
						webengage.track("Registration",{
						    "tempID" : UrlMgmt.getObj().tempUserId,
						    "fromApp"   : "yes"
						});
					}
				   	break;
				case "Logout":
					if(typeof webengage !== 'undefined'){
						webengage.user.logout();
					}
				   	break;
				default:
					if(typeof webengage !== 'undefined'){
						var weObj = {
										"tempID" : UrlMgmt.getObj().tempUserId,
						    			"fromApp": "yes"
						    		};
						if (typeof view != 'undefined'){
							weObj["viewUrl"] = view;
						}
						webengage.track(event, weObj);
					}
			}
	}
	catch(error){
		console.log(error);
	}
};
TRTracker.prototype.InviteReferral = function()
{
	var ir = UrlMgmt.getObj().App.version["invite_referral"];
	if(ir == 0){
		console.log("Invite Referral disabled");
		return false;
	}
	console.log("Invite Referral enabled");
	var urlMgmt = UrlMgmt.getObj();
	var actionStack = urlMgmt.actionStack;
	var currentaction = actionStack[actionStack.length-1];
	var inviteReferralRule = currentaction.filePath.replace('/','_');
	if(typeof currentaction.controler.data.urlKey != 'undefined'){
		inviteReferralRule += '_'+currentaction.controler.data.urlKey;
	}
	if(typeof window.invitereferrals != 'undefined')
		invitereferrals.invite(inviteReferralRule);
};
