var LiveClassesType =
{
	Live :1,
	VOD :0,
    Str : [
        'Live',
        'VOD',
    ]
};
var VideoPlayer =
{
	JWPlayer :0,
	VideoJS :1,
    Str : [
        'JWPlayer',
        'VideoJS',
    ]
};
var hideZopim = true;
var _chatObj = null;
function LvClass(id, data)
{
	_chatObj = null;
	this.id = id;
	this.vedioIsPlaying = false;
	
	this.videoType =  LiveClassesType["VOD"];
	this.app = data.tr1info.applicationName;
	this.classId = data.tr1info.itemId;
	this.url = data.tr1info.classUrl;
	this.stream1 = data.tr1info.primaryStream;
	this.stream2 = data.tr1info.streamOne;
	this.postFix = data.tr1info.urlPostFix;
	this.startDate = data.tr1info.startDate;
	this.vod1 =  data.tr1info.primPlaybackUrl;
	this.vod2 =  data.tr1info.secPlaybackUrl;
	if(this.vod1 != null){
		this.isVod1Secure = this.vod1.includes('slhdovces');
	}
	if(this.vod2 != null){
		this.isVod2Secure =  this.vod2.includes('slhdovces');
	}
	this.activePlayer = VideoPlayer["JWPlayer"];
	if(typeof data.activePlayer != 'undefined'){
		this.activePlayer = data.activePlayer;
	}
	this.state = data.tr1info.currentVideoState;
	this.purchased = (typeof data.classecomm != 'undefined') && data.classecomm.hasOwnProperty(data.itemId) && 
					 (data.classecomm[data.itemId]['purchesed'] ==0 ) ? false:true;
	this.canSeePreview = true;
	this.videoContainer = "VideoHere";
	this.video1InPlay = "video1InPlay";
	this.video2InPlay = "video2InPlay";
	this.host = (typeof data.tr1info.hostUrl != 'undefined' && data.tr1info.hostUrl != null)?data.tr1info.hostUrl:"https://5a308835f271b.streamlock.net";
	this.classroomHostUrl = (typeof data.tr1info.classroomHostUrl != 'undefined' && data.tr1info.classroomHostUrl != null)?data.tr1info.classroomHostUrl:"rtmp://13.127.170.47:1935";
	this.forceChat = false; 
	this.logoUrl = (data.tr1info.logoUrl != "")?data.tr1info.logoUrl:client_logoimg_cdnurl;
	this.classInitated = false;
	this.urlKey = data.urlKey;
	this.maxPlayTime = 0;
	this.continueAnyWay = false;
	this.heartBitTimerId = 0;
	this.heartBitTimerVal = 0;
	this.orientation = null;
	this.presenterId = (typeof data.tr1info.userId != 'undefined') ? data.tr1info.userId : 0;	
	this.appheight = null;
	this.streamState = data.tr1info.state;
	this.endDate = data.tr1info.endDate;
	this.video1QualityLevels = [];
	this.video2QualityLevels = [];
	this.videoQualitySync = 1;  //video Quality Sync
	this.jwPlayerLicenseKey = (typeof data.tr1info.jwPlayerLicenseKey != "undefined")?data.tr1info.jwPlayerLicenseKey:"Kl4x01CwJKjgJt76K3gToZ50zHkNllHyRSbiszCm4pQ=";
	this.signedCookieHost = (typeof data.tr1info.signedCookieHost !== "undefined") ? data.tr1info.signedCookieHost : "https://www.toprankers.com";
	this.isLiveCDN = (typeof data.tr1info.isLiveCDN !== "undefined")?data.tr1info.isLiveCDN:"0";
	this.secureLiveUsingCookie = (typeof data.tr1info.secureLiveUsingCookie !== "undefined")?data.tr1info.secureLiveUsingCookie:false;
	this.vjsVod1Secure = data.tr1info.vjsVod1Secure;
	this.vjsVod2Secure = data.tr1info.vjsVod2Secure;
	this.show_playIcon1 = true;
	this.show_playIcon2 = true;
	
	this.BindEvents();
}
LvClass.getObj = function(id, data)
{
	
	if(_classObj == null){
		_classObj = new LvClass(id, data);
	}
	return _classObj;
};
LvClass.prototype.BindEvents = function()
{
	if(typeof videoSecurity != 'undefined' && videoSecurity == true){
		try {
		  var deviceManufacturer = device.manufacturer;
		  deviceManufacturer = deviceManufacturer.toLowerCase();
		  console.log("Able to get the device manufacturer : "+deviceManufacturer );
		}
		catch(err) {
		  console.log("Unable to get the device manufacturer : "+err );
		}
		if(typeof deviceManufacturer != "undefined" && deviceManufacturer.includes("motorola")){
			alert("Due to security reasons video playback is not possible on your device. Please contact 'Administrator' for more details.");
			UrlMgmt.getObj().PopView();
		}
	}
	if($('#itemliveclassesController').find('.lvContainer').find('iframe').length > 0){
		screen.orientation.unlock();
	}
	else{
		screen.orientation.lock('portrait');
	}
	$("#"+this.videoContainer+" .LvClassPrview").unbind().bind("click", this, function(e){
		if(e.data.state == "upcoming")
		{
			$("#dynamicModelTxt").html("<h2>Stay tuned!</h2><p>"+$('.LiveOn').html()+"</p>"); 
			$("#dynamicModelBtn").click();
			return;
		}
		else if( e.data.vod1 != null)
		{
			if(e.data.purchased || e.data.canSeePreview)
			{
				if(e.data.activePlayer == VideoPlayer["VideoJS"])
				{
					e.data.PlayVideoJSVOD();
					e.data.VideoJSfullScreen();
				}
				else
				{
					e.data.PlayVOD();
					e.data.fullScreen();
				}
			}
			
			else if($('.purchaseRequired').length > 0)
			{
				$('.purchaseRequired').addClass("Blink");
				var t = setTimeout(function()
				{
					$('.purchaseRequired').removeClass("Blink");
				}, 3000);
			}
		}
		else
		{
			if(e.data.purchased && e.data.stream1 != null)
			{
				if(e.data.activePlayer == VideoPlayer["VideoJS"])
				{		
					if((e.data.streamState == "2") || (e.data.streamState == "3") || (e.data.streamState == "4")){
						LvClass.getObj().UpdateStreamStateAndRefresh(true, e); //first argument is true if to play VOD
					}
					else{	
						e.data.PlayVideoJSLive();
						e.data.VideoJSfullScreen();
					}
				}
				else{
					e.data.PlayLive();
					e.data.fullScreen();	
				}
			}
				
			else if($('.purchaseRequired').length > 0)
			{
				$('.purchaseRequired').addClass("Blink");
				var t = setTimeout(function()
				{
					$('.purchaseRequired').removeClass("Blink");
				}, 3000);
			}
		}
	});
	this.SetSize();
	
	$("#lvOnLandscape").bind("click", this, function(e){e.data.fullScreen();});
};

LvClass.prototype.BindEventsAfterSetup = function()
{
	screen.orientation.lock('landscape');
	if(this.classInitated)
	{
		return;
	}
	this.classInitated = true;
	if(this.videoType == LiveClassesType["Live"] || this.forceChat)
	{
		var chatObj = Chat.getObj();
		var bindChatEvent = setInterval(function(){
			if($('#firechat-tab-content textarea').length > 0){
				
				var actionStack = UrlMgmt.getObj().actionStack;
				var currentDom = actionStack[actionStack.length - 1].controler.dom;  
				$('#firechat-tab-content textarea').on('focus', function(){
					if(screen.orientation.type == "portrait-primary"){
						$(currentDom).animate({
							scrollTop : parseInt($('#firechat-tab-content textarea').offset().top) + $(currentDom).scrollTop() - 300
						}, 500);
					}
				});
				$('#firechat-tab-content textarea').on('blur', function(){
					if(screen.orientation.type == "portrait-primary"){
						$(currentDom).animate({
							scrollTop : 0
						}, 500);
					}
				});
				clearInterval(bindChatEvent);
			}
			
		}, 3000);
		
	}
	
	jwplayer(this.video1InPlay).on('ready', function(){
		var classObj = LvClass.getObj();
		$("#"+classObj.videoContainer+" .LvClassPrview").hide();
		jwplayer(classObj.video1InPlay).setMute(false);
	});
	
	jwplayer(this.video1InPlay).on('firstFrame', function() {
		var lastPause = $(".PlayLVHere").attr("data-lastPause");
		var classObj = LvClass.getObj();
		classObj.maxPlayTime = parseInt(jwplayer(this.video1InPlay).getDuration());
		if(lastPause > 0)
		{		
			jwplayer(this.video1InPlay).seek(lastPause);
			$(".PlayLVHere").attr("data-lastPause", 0);
		}
	});
	
	var hidePreviewTimer = setTimeout(function()
	{
		var classObj = LvClass.getObj();
		$("#"+classObj.videoContainer+" .LvClassPrview").hide();
	}, 2000);
	
	var overLay = $('<div id="overlay"> </div>').appendTo($('#'+this.videoContainer));
	
	overLay.unbind('dblclick').bind('dblclick',function(){
		var classObj = LvClass.getObj();
		classObj.fullScreen();
	});
	
	overLay.unbind('click').bind('click', this, function(e){
		// var PVideoId = $('.wrapperLv:not(.lvVidCorner) .jwplayer').attr("id");
		// jwplayer(PVideoId).setControls(); //makes controls hidden
		// jwplayer(PVideoId).setControls();  //makes controls visible
		if($(".lvVidCornerToggle:not(.lvVidCorner) >div.jw-flag-user-inactive").length){
			var $videoclickOverlay =$(".lvVidCornerToggle:not(.lvVidCorner) >div");
			$videoclickOverlay.removeClass("jw-flag-user-inactive");
			setTimeout(function(){
				$videoclickOverlay.addClass("jw-flag-user-inactive");
			},5000);
		}
		e.data.HideSecondVideo(false);
	});

	jwplayer(this.video1InPlay).addButton(
        "https://cdn.toprankers.com/images/full-screen-normal-023b3278e46d9.png",
        "Full Screen", 
		function() {
			var classObj = LvClass.getObj();
	    	classObj.fullScreen();
	  	},	
	  "fullScreen",
	  "jw-tr-fullScreen"       
	);
	
	if(this.videoType == LiveClassesType["Live"] || this.forceChat)
	{
		jwplayer(this.video1InPlay).addButton(
	        "https://cdn.toprankers.net/images/lvchat-0236c9b14a28c.png",
	        "Chat Now", 
			function() {
		    	$("#chatHere").toggle(400);
		    		if((document.webkitIsFullScreen || document.isFullScreen)){
						console.log("Full Screen Mode1 is ON");
	 					$("#chatHere").addClass("InFullScreen");
	 					$("#firechat-tab-content").addClass("InFullScreen");
	  				}else{
	  					$("#chatHere").removeClass("InFullScreen");
	  					$("#firechat-tab-content").removeClass("InFullScreen");
	  				}	
		  	},	
		  "chatButton",
		  "jw-tr-chatButton"        
		);
	}
	if(this.videoType == LiveClassesType["VOD"] && this.purchased == false)
	{
		jwplayer(this.video1InPlay).on('time', function(){
			var classObj = LvClass.getObj();
			if (jwplayer(classObj.video1InPlay).getPosition() >= '120') {
				var classObj =  LvClass.getObj();
				classObj.canSeePreview = false;	
				var a = '<h2>Just a step away!</h2>'+
						'<p>Watch the full video</p>'+
						'<a class="btn btn-primary _eventListener js-checkout" data-action="common/checkout&for='+classObj.urlKey+'">Purchase Now</a>';
				$("#dynamicModelBtn").find('.dynamicModel-body').empty();
				$("#dynamicModelBtn").find('.dynamicModel-body').append(a);
				
				if($('.PlayLVHere').find('.PlayContainer').hasClass('InFullScreen')){
					classObj.fullScreen();
				}
				$("#dynamicModelBtn").modal('show');
				UrlMgmt.getObj().modalObj = $('#dynamicModelBtn');
				$("#"+classObj.videoContainer+" .LvClassPrview").addClass("VodPreviewed");
				$('#dynamicModelBtn').find('._eventListener').unbind().bind('click', function(){
					$("#dynamicModelBtn").modal('hide');
					
					var urlMgmt = UrlMgmt.getObj();
					var urlMgmtObj = {route: $(this).data('action'), needData: true, offlineAllowed: false};
					urlMgmt.Route(urlMgmtObj, function(obj){
						urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
					}.bind(this));
				});
				$("#"+classObj.videoContainer+" .LvClassPrview").removeClass("LoadingVedio").show();
				$('#VideoHere').find('.lvVidCornerToggle').hide();
				jwplayer(classObj.video1InPlay).stop();
				jwplayer(classObj.video2InPlay).stop();
			}
		});
	}
	
	if($("#"+this.video2InPlay).length != 0)
	{
		jwplayer(this.video2InPlay).addButton(
            "https://cdn.toprankers.com/images/full-screen-normal-023b3278e46d9.png",
            "Full Screen", 
			function() {
				var classObj = LvClass.getObj();
		    	classObj.fullScreen();
		  	},	
		  "fullScreen",
		  "jw-tr-fullScreen"       
		);
		if(this.videoType == LiveClassesType["Live"] || this.forceChat)
		{
			jwplayer(this.video2InPlay).addButton(
	            "https://cdn.toprankers.net/images/lvchat-0236c9b14a28c.png",
	            "Chat Now", 
				function() {
					
			    	$("#chatHere").toggle(400);
		    		if((document.webkitIsFullScreen || document.isFullScreen)){
						$("#chatHere").addClass("InFullScreen");
	 					$("#firechat-tab-content").addClass("InFullScreen");
	  				}else{
	  					$("#chatHere").removeClass("InFullScreen");
	  					$("#firechat-tab-content").removeClass("InFullScreen");
	  				}	 	
	        	},	
			  "chatButton",
			  "jw-tr-chatButton"       
			);
		}

		jwplayer(this.video1InPlay).addButton(
			"https://cdn.toprankers.com/images/right-top-023b639f461f1.png",
			"Hide Second Video",
			function() 
			{
				var classObj = LvClass.getObj();
		    	classObj.HideSecondVideo();
		  	},	
		  	"hideSecondVideo",
		  	"jw-tr-hideSecondVideo"
		);
		jwplayer(this.video2InPlay).addButton(
			"https://cdn.toprankers.com/images/right-top-023b639f461f1.png",
			"Hide Second Video",
			function() {
				var classObj = LvClass.getObj();
		    	classObj.HideSecondVideo();
		  	},	
		  "hideSecondVideo",
		  "jw-tr-hideSecondVideo"
		);
		
		jwplayer(this.video1InPlay).addButton(
			"https://cdn.toprankers.com/images/swap-video-normal-023b327dbe22c.png",
			"Swap Video",
			function() {
				$(".lvVidCornerToggle").toggleClass("lvVidCorner");
				var classObj = LvClass.getObj();
				classObj.SetSize();
		  },	
		  "toggleVideo",
		  "jw-tr-toggleVideo"
		);
		
		jwplayer(this.video2InPlay).addButton(
			"https://cdn.toprankers.com/images/swap-video-normal-023b327dbe22c.png",
			"Swap Video",
			function() {
		    	$(".lvVidCornerToggle").toggleClass("lvVidCorner");
		    	var classObj = LvClass.getObj();
				classObj.SetSize();
		  },	
		  "toggleVideo",
		  "jw-tr-toggleVideo"
		);
		
		jwplayer(this.video2InPlay).on('firstFrame', function() {
		var lastPause = parseInt(jwplayer(this.video1InPlay).getPosition());
		if(lastPause > 0)		 
			jwplayer(this.video2InPlay).seek(lastPause);
		});
		
		jwplayer(this.video1InPlay).on('play', function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = true;
			jwplayer(classObj.video2InPlay).play(true);
			classObj.HeartBitCounter();
			//in case of live if video is playing disable stream status			
			$('[data-videoStreamStatus="live"]').css("display","none");
		});
		jwplayer(this.video2InPlay).on('play', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video1InPlay).play(true);
		});
		
		
		jwplayer(this.video1InPlay).on('pause', function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = false;
			jwplayer(classObj.video2InPlay).pause(true);
			console.log("clear video1InPlay in pause timer id",classObj.heartBitTimerId);
			clearInterval(classObj.heartBitTimerId);
		});
		jwplayer(this.video2InPlay).on('pause', function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = false;
			jwplayer(classObj.video1InPlay).pause(true);
			console.log("clear video2InPlay inh pause timer id",classObj.heartBitTimerId);
			clearInterval(classObj.heartBitTimerId);
		});
		
		jwplayer(this.video1InPlay).on('mute', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video2InPlay).setMute(jwplayer(classObj.video1InPlay).getMute());;
		});
		jwplayer(this.video2InPlay).on('mute', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video1InPlay).setMute(jwplayer(classObj.video2InPlay).getMute());;
		});
		
		jwplayer(this.video1InPlay).on('volume', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video2InPlay).setVolume(jwplayer(classObj.video1InPlay).getVolume());
		});
		jwplayer(this.video2InPlay).on('volume', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video1InPlay).setVolume(jwplayer(classObj.video2InPlay).getVolume());
		});
		
		jwplayer(this.video1InPlay).on('playbackRateChanged', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video2InPlay).setPlaybackRate(jwplayer(classObj.video1InPlay).getPlaybackRate());
		});
		
		jwplayer(this.video2InPlay).on('playbackRateChanged', function(){
			var classObj = LvClass.getObj();
			jwplayer(classObj.video1InPlay).setPlaybackRate(jwplayer(classObj.video2InPlay).getPlaybackRate());
		});
		
		if(this.videoQualitySync == 1)
		{
			jwplayer(this.video1InPlay).on('levels', function(e){						
				var classObj = LvClass.getObj();
				classObj.video1QualityLevels = [];
				e.levels.forEach(function(level){
					classObj.video1QualityLevels.push(level.label);
				});				
			});
			jwplayer(this.video2InPlay).on('levels', function(e){								
				var classObj = LvClass.getObj();
				classObj.video2QualityLevels = [];
				e.levels.forEach(function(level){
					classObj.video2QualityLevels.push(level.label);
				});
			});
						
			jwplayer(this.video1InPlay).on('levelsChanged', function(e){
				var classObj = LvClass.getObj();
				var quality = e.levels[e.currentQuality].label;
				if((index = classObj.video2QualityLevels.indexOf(quality)) != -1 && classObj.video2QualityLevels[jwplayer(classObj.video2InPlay).getCurrentQuality()] != quality)
				{
					jwplayer(classObj.video2InPlay).setCurrentQuality(index);
				}				
			});
			
			jwplayer(this.video2InPlay).on('levelsChanged', function(e){
				var classObj = LvClass.getObj();
				var quality = e.levels[e.currentQuality].label;
				if((index = classObj.video1QualityLevels.indexOf(quality)) != -1 && classObj.video1QualityLevels[jwplayer(classObj.video1InPlay).getCurrentQuality()] != quality)
				{
					jwplayer(classObj.video1InPlay).setCurrentQuality(index);
				}				
			});
		}
		
	} else {
		jwplayer(this.video1InPlay).on('play', function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = true;
			classObj.HeartBitCounter();
			
			//in case of live if video is playing disable stream status			
			$('[data-videoStreamStatus="live"]').css("display","none");
		});
		
		jwplayer(this.video1InPlay).on('pause', function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = false;
			clearInterval(classObj.heartBitTimerId);
		});
	}
	
	// if video is completed or buffered change playing status to false
	jwplayer(this.video1InPlay).on('buffer complete remove idle', function(){
		var classObj = LvClass.getObj();
		classObj.vedioIsPlaying = false;
		clearInterval(classObj.heartBitTimerId);
	});
	// var overLay = $('<div id="overlay"><div class="useridwatermark" style="display:none;">'+UrlMgmt.getObj().userData['id']+'</div> </div>').appendTo($('#'+this.videoContainer));
	
	jwplayer(this.video1InPlay).play();
	
	$(window).resize(function()
	{
		var classObj = LvClass.getObj();
		classObj.SetSize();
	});
	this.SetSize();
	
	window.addEventListener("orientationchange", function() 
	{
		
		setTimeout(function() 
		{
			var classObj = LvClass.getObj();
			classObj.ValidateOrientation();		
		}, 300);
	});
	
	this.ValidateOrientation(); 
	
};
LvClass.prototype.VideoJSBindEventsAfterSetup = function()
{
	if(this.classInitated)
	{
		return;
	}
	this.classInitated = true;
	if(this.videoType == LiveClassesType["Live"] || this.forceChat)
	{
		var chatObj = Chat.getObj();
	}
	
	videojs(this.video1InPlay).on('ready', function(){		
		var classObj = LvClass.getObj();
		$("#"+classObj.videoContainer+" .LvClassPrview").hide();
		videojs(classObj.video1InPlay).muted(false);
		
		//disable the normal double click and add our custom dblclick to player-1
		videojs(classObj.video1InPlay).tech_.off('dblclick');
		videojs(classObj.video1InPlay).tech_.on('dblclick',function(){
			var classObj = LvClass.getObj();
			classObj.VideoJSfullScreen();
		});
		
		if(classObj.videoType == LiveClassesType["Live"]){
			//bind events to error
			videojs(classObj.video1InPlay).tech_.on('error',function(e){
				var classObj = LvClass.getObj();
				var errorInfo = videojs(classObj.video1InPlay).error() || e.error;
				if(classObj.streamState == 0){
					$('[data-videoStreamStatus="live"]').css("display","table");
					$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> The class has not started yet. Please wait... <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh(false, this)'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
				}
				else if(errorInfo.code == 4 || errorInfo.code == 2){
					$('[data-videoStreamStatus="live"]').css("display","table");
					if(classObj.endDate && (classObj.endDate != "0000-00-00 00:00:00" || classObj.streamState == 2 || classObj.streamState == 3 || classObj.streamState == 4)){
						$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Oops... Class is already ended at <strong>"+classObj.endDate+"</strong>. Please Wait... Video will be available soon.");
					}else{
						$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Network Instability Detected (Live Stream Down) or Please Check Your Internet Connection. <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh(false, this)'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
						}
				}
				else{
					$('[data-videoStreamStatus="live"]').css("display","table");
					$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Network Instability Detected (Live Stream Down) or Please Check Your Internet Connection. <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh(false, this)'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
				}
			});

			//count the no.of time the player is retrying the connection
			videojs(classObj.video1InPlay).tech_.on('retryplaylist', function(e){
		      	var classObj = LvClass.getObj();
		      	if(classObj.connectionRetryCount >=3){
		      		videojs(classObj.video1InPlay).tech_.trigger({type:'error',error:{code:2,status:0}});
		      		classObj.vedioIsPlaying = false;
		      		videojs(classObj.video1InPlay).reset();
	      			if($("#"+classObj.video2InPlay).length)
	      				videojs(classObj.video2InPlay).reset();
	      		}
		      	classObj.connectionRetryCount+=1;	      		
		      	if(classObj.connectionRetryCount == 70){
		      		videojs(classObj.video1InPlay).dispose();
		      	}
		  	});
		 }
	});
	videojs(this.video1InPlay).on('contextmenu', function(e){
		e.preventDefault();
	});
	videojs(this.video1InPlay).on('firstplay', function(){		
		var lastPause = $(".PlayLVHere").attr("data-lastPause");
		var classObj = LvClass.getObj();
		var maxPlayTime = parseInt(videojs(classObj.video1InPlay).duration());
		if(lastPause > 0)
		{		
			videojs(classObj.video1InPlay).currentTime(lastPause);
			$(".PlayLVHere").attr("data-lastPause", 0);
		}
	});
	videojs(this.video1InPlay).on(['loadeddata'], function(){
	  	var classObj = LvClass.getObj();
	  	$('.vjs-control-bar').find('.vjs-http-source-selector').addClass("vjs-hidden");
	  	$("#"+classObj.video1InPlay).find('.vjs-control-bar div.vjs-playback-rate').addClass("vjs-hidden");
	  	$("#"+classObj.video1InPlay).find('.vjs-control-bar div.vjs-playback-rate .vjs-playback-rate-value').addClass("vjs-hidden");
	  	
	  	if($('.lvVidCorner .video-js').length > 0 || 
	   ($(".vjs-button.vjs-http-source-selector").length > 0 && typeof videojs(classObj.video1InPlay).player().qualityLevels() != 'undefined' 
		&& videojs(classObj.video1InPlay).player().qualityLevels().levels_.length > 1) ||
		$('#'+classObj.video1InPlay).find("div.vjs-playback-rate .vjs-menu .vjs-menu-content li").length > 0	
	  )
	  {	
	
		//Setting button addded - Player 1
		var player1 = videojs(classObj.video1InPlay);
		var Component = videojs.getComponent('Component');
		var settingholder = new Component(player1);
		var settingButtonDiv = player1.controlBar.addChild(settingholder, {}, 16);
		settingButtonDiv.addClass("vjs-settingHolder");
		settingButtonDiv.addClass("vjs-settingHolder-player1");
	
		var SetButton = videojs.getComponent('Button');
		var SettingButton = videojs.extend(SetButton, {
			constructor : function() {
				SetButton.apply(this, arguments);
				/* initialize your button */
				this.addClass("vjs-tr-settings");
				this.addClass("vjs-tr-settings-player1");
				this.setAttribute("title", "Settings");
			},
			handleClick : function() {
				/* do something on click */
				var classObj = LvClass.getObj();
				if($("#"+classObj.video1InPlay).find(".vjs-setting-hover").length > 0)
				{
					$("#"+classObj.video1InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
				}
				else{
					$("#"+classObj.video1InPlay).find(".vjs-settingHolder").addClass("vjs-setting-hover");
				}
			}
		});
		videojs.registerComponent('SettingButton', SettingButton);
	
		// adding Setting Button to player-1
		videojs(classObj.video1InPlay).controlBar.addChild('SettingButton', {}, 16);
		$(".vjs-settingHolder-player1").append($(".vjs-tr-settings-player1"));
		//setting buttons
		var settingbuttons = $('<div class="settingbuttons settingbuttons1"></div>').appendTo($(".vjs-settingHolder-player1"));
		//Setting button ends - player1
	}
	
	  	var divNo = 0;
	  	if($('.lvVidCorner .video-js').length > 0)
		  {
		  	  divNo += 1; 
			  var secvideoHTML = '<div class="settings-hideSecondvideo settings-hideSecondvideo-player1">'+
									'<div class="vjs-setting-head">'+
									'</div>'+
									'<div class="vjs-menu">'+
										'<ul class="vjs-menu-content" role="menu">'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="0"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo vjs-selected" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="1"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="2"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="3"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="4"></li>'+
										'</ul>'+
									'</div>'+
								'</div>';
			 console.log($(".settingbuttons1"));
			  $(".settingbuttons1").append(secvideoHTML);
		      $(".settings-hideSecondvideo-player1").append($('#'+classObj.video1InPlay).find(".vjs-button.vjs-tr-toggleVideo .vjs-menu"));
		  	  $('.settings-hideSecondvideo .vjs-menu-item').on('click', function(e){
		  	  	  classObj.orientation = parseInt($(e.currentTarget).attr('video-orientation')) - 1;
		  	  	  $(".topRightCornerVid").attr("data-orientation",classObj.orientation);
		  	  	  classObj.vjsHideSecondVideo();
		  	  	  e.stopPropagation();
			  });
		  }
		  
		  //appending playback rate button only for vod
		  if(classObj.videoType == LiveClassesType["VOD"])
		  {
		  	  divNo += 1; 
			  var playBackHTML = '<div class="settings-playbackrate settings-playbackrate-player1">'+
								 	'<div class="vjs-setting-head">'+ 
									'</div>'+ 
								 '</div>';
			  $(".settingbuttons1").append(playBackHTML);
			  $(".settings-playbackrate-player1").append($('#'+classObj.video1InPlay).find("div.vjs-playback-rate .vjs-menu"));
		  }
		  //appending bitrate button
		  if($(".vjs-button.vjs-http-source-selector").length > 0 && 
		     videojs(classObj.video1InPlay).player().qualityLevels().levels_.length > 1)
		  {
		  	  divNo += 1; 
			  var bitrateHTML = '<div class="settings-bitrate settings-bitrate-player1">'+
									'<div class="vjs-setting-head">'+
									'</div>'+
								'</div>';
			  $(".settingbuttons1").append(bitrateHTML);
			  $('#'+classObj.video1InPlay).find(".vjs-button.vjs-http-source-selector .vjs-menu .vjs-menu-item:first-child").addClass('vjs-selected');
		      $(".settings-bitrate-player1").append($('#'+classObj.video1InPlay).find(".vjs-button.vjs-http-source-selector .vjs-menu"));
		  }
		  if(divNo == 3){
		  	$('.settingbuttons1').addClass('settingbuttons-threeDiv');
		  }
	  	if(classObj.videoType == LiveClassesType["VOD"])
	  	{
				var player1 = videojs(classObj.video1InPlay);
				var Component = videojs.getComponent('Component');
				var btnholder1 = new Component(player1);
				var btnholderDiv1 = player1.addChild(btnholder1, {}, 2);
				btnholderDiv1.addClass("vjs-btnHolder1");
				btnholderDiv1.addClass("vjs-btnHolder-player1");
				
				var RWButtonP1 = videojs.getComponent('Button');
				var ReWindButtonP1 = videojs.extend(RWButtonP1, {
				  constructor: function() {
				    RWButtonP1.apply(this, arguments);
				   	this.addClass("vjs-tr-rewind");
				   	this.addClass("vjs-tr-rewindp1");
				   	this.addClass("vjs-fade-out");
				   	this.setAttribute("title","Rewind");
				  },
				  handleClick: function(e) {
				    var classObj = LvClass.getObj();
				    var t = (videojs(classObj.video1InPlay).currentTime() < 11)?videojs(classObj.video1InPlay).currentTime():10;
					videojs(classObj.video1InPlay).currentTime(videojs(classObj.video1InPlay).currentTime()-t);
				  	
				  	$('.vjs-tr-rewind').addClass('rewindbtnspin');
				  	$('.vjs-tr-rewind').removeClass('rewindbtnspinagain');
			        classObj.rewindSpinBtn = setTimeout(function()
			        {
			        	clearInterval(classObj.rewindSpinBtn);
						$('.vjs-tr-rewind').removeClass('rewindbtnspin');
						$('.vjs-tr-rewind').addClass('rewindbtnspinagain');
			        }, 500);
				  }
				});
				videojs.registerComponent('ReWindButton', ReWindButtonP1);	
				videojs(classObj.video1InPlay).addChild('ReWindButton', {}, 5);
				$(".vjs-btnHolder-player1").append($(".vjs-tr-rewindp1"));
				
				var PlayPauseButtonP1 = videojs.getComponent('PlayToggle');
				var PlayPauseScreenButtonP1 = videojs.extend(PlayPauseButtonP1, {
				  constructor: function() {
				    PlayPauseButtonP1.apply(this, arguments);
				   	this.addClass("vjs-tr-playpause");
				   	this.addClass("vjs-tr-playpausep1");
				   	this.addClass("vjs-fade-out");
				  },
				  handleClick: function() {
					  	var classObj = LvClass.getObj();
					  	if($('.vjs-play-control').hasClass('vjs-playing'))
					  	{
					  		classObj.vedioIsPlaying = false;
					  		videojs(classObj.video1InPlay).pause();
					  		$('.vjs-play-control').removeClass('vjs-playing');
					  		$('.vjs-play-control').addClass('vjs-paused');
					  		this.addClass("vjs-paused");
					  	}
						else
						{
							classObj.vedioIsPlaying = true;
							videojs(classObj.video1InPlay).play();
							$('.vjs-play-control').addClass('vjs-playing');
					  		$('.vjs-play-control').removeClass('vjs-paused');
							this.removeClass("vjs-paused");
						}
					}
				});
				videojs.registerComponent('PlayPauseScreenButton', PlayPauseScreenButtonP1);
				videojs(classObj.video1InPlay).addChild('PlayPauseScreenButton', {}, 6);
				$(".vjs-btnHolder-player1").append($(".vjs-tr-playpausep1"));
				
				var FWButtonP1 = videojs.getComponent('Button');
				var ForwardButtonP1 = videojs.extend(FWButtonP1, {
				  constructor: function() {
				    FWButtonP1.apply(this, arguments);
				   	this.addClass("vjs-tr-forward");
				   	this.addClass("vjs-tr-forwardp1");
				   	this.addClass("vjs-fade-out");
				   	this.setAttribute("title","Forward");
				  },
				  handleClick: function() {
				  	var classObj = LvClass.getObj();
					var timediff = videojs(classObj.video1InPlay).duration() - videojs(classObj.video1InPlay).currentTime(); 
					videojs(classObj.video1InPlay).currentTime(videojs(classObj.video1InPlay).currentTime() + (timediff < 11?timediff:10));
				  	$('.vjs-tr-forward').addClass('fwbtnspin');
				  	$('.vjs-tr-forward').removeClass('fwbtnspinagain');
			        
			        classObj.fwSpinBtn = setTimeout(function () {
			        	clearInterval(classObj.fwSpinBtn);
			            $('.vjs-tr-forward').removeClass('fwbtnspin');
			            $('.vjs-tr-forward').addClass('fwbtnspinagain');
			        }, 500);
				  }
				});
				videojs.registerComponent('ForwardButton', ForwardButtonP1);
				videojs(classObj.video1InPlay).addChild('ForwardButton', {}, 7);
				$(".vjs-btnHolder-player1").append($(".vjs-tr-forwardp1"));
				$('.vjs-text-track-display').addClass('vjs-delay-black-out');
				videojs(classObj.video1InPlay).on('userinactive', function(){ 
				  $('.vjs-tr-forward').addClass('vjs-fade-out');
				  $('.vjs-tr-playpause').addClass('vjs-fade-out');
				  $('.vjs-tr-rewind').addClass('vjs-fade-out'); 
				  $('.vjs-text-track-display').addClass('vjs-delay-black-out');
				  $('.vjs-text-track-display').removeClass('vjs-delay-black-out1');
				  classObj.show_playIcon1 = false;
				  classObj.show_playIcon2 = false;
				  $(".vjs-btnHolder-player1").addClass('hidebtns');
				  $(".vjs-text-track-display").addClass('removeopacity');
				  if($("#"+classObj.video1InPlay).find(".vjs-setting-hover").length > 0)
				  {
					  $("#"+classObj.video1InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
				  }
				});
				
				videojs(classObj.video1InPlay).on('click', function(){ 
					if(classObj.show_playIcon1)
					{
						classObj.show_playIcon1 = false;
						classObj.show_playIcon2 = false;
						$(".vjs-btnHolder-player1").addClass('hidebtns');
				  		$(".vjs-text-track-display").addClass('removeopacity');
					}
					else{
						showPlayIcon();
					}
				});
	  	}
	  	else if(classObj.videoType == LiveClassesType["Live"])
	  	{
	  		var classObj = LvClass.getObj();
	  		videojs(classObj.video1InPlay).on('userinactive', function()
	  		{ 
	  			if($("#"+classObj.video1InPlay).find(".vjs-setting-hover").length > 0)
				  {
					  $("#"+classObj.video1InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
				  }
	  		});
	  	}
	  	videojs(classObj.video1InPlay).off(['loadeddata']);
	});
	
	if(this.videoType == LiveClassesType["VOD"]){
		//add dummy space bar for gap to player-1
		var player1 = videojs(this.video1InPlay);
		var Component = videojs.getComponent('Component');
		var progressBar = new Component(player1);
		var progressBarDiv = player1.controlBar.addChild(progressBar,{},10);
		progressBarDiv.addClass("vjs-progress-control");
		progressBarDiv.addClass("vjs-control");
		progressBarDiv.addClass("dummy-vjs-progress-control");		
	}
	var FSButton = videojs.getComponent('Button');
	var FullScreenButton = videojs.extend(FSButton, {
	  constructor: function() {
	    FSButton.apply(this, arguments);
	    /* initialize your button */
	   	this.addClass("vjs-tr-fullscreen");
	   	this.setAttribute("title","Full Screen");
	  },
	  handleClick: function() {
	    /* do something on click */
	    var classObj = LvClass.getObj();
		classObj.VideoJSfullScreen();
	  }
	});
	videojs.registerComponent('FullScreenButton', FullScreenButton);
	
	// adding Full Screen Button to player-1	
	videojs(this.video1InPlay).controlBar.addChild('FullScreenButton', {}, 17);
	
	if(this.videoType == LiveClassesType["Live"] || this.forceChat){
		var CTButton = videojs.getComponent('Button');
		var ChatButton = videojs.extend(CTButton, {
		  constructor: function() {
		    CTButton.apply(this, arguments);
		    /* initialize your button */
		   	this.addClass("vjs-tr-chatButton");
		   	this.setAttribute("title","Chat Now");
		  },
		  handleClick: function() {
		    /* do something on click */
		    $("#chatHere").toggle(400);
			$(".container.lvTitle").toggleClass("lvtitlechat");
			var userObj = UrlMgmt.getObj().userData['id'];
			if((document.webkitIsFullScreen || document.isFullScreen)){
				console.log("Full Screen Mode1 is ON");
				$("#chatHere").addClass("InFullScreen");
				$("#firechat-tab-content").addClass("InFullScreen");
				
				if(userObj == 1) 
				{
					var classObj = LvClass.getObj();
					$(".InFullScreen #chatHere").addClass("chatForAdmin");
					videojs(classObj.video1InPlay).pause();
				}
				
			}else{
				$("#chatHere").removeClass("InFullScreen");
				if(userObj.userId == 1) 
				{
					$(".InFullScreen #chatHere").removeClass("chatForAdmin");
				}
				$("#firechat-tab-content").removeClass("InFullScreen");
			}
		  }
		});
		videojs.registerComponent('ChatButton', ChatButton);
		
		//Add Chat Button to Player-1
		videojs(this.video1InPlay).controlBar.addChild('ChatButton', {}, 11);
	}
	if(this.videoType == LiveClassesType["VOD"] && this.purchased == false)
	{
		videojs(this.video1InPlay).on('timeupdate', function(){			
			var classObj = LvClass.getObj();			
			if (videojs(classObj.video1InPlay).currentTime() >= '120') {
				videojs(classObj.video1InPlay).reset();
				videojs(classObj.video1InPlay).dispose();
				$("#"+classObj.videoContainer+" .LvClassPrview.LoadingVedio").removeClass("LoadingVedio");
				$("#"+classObj.videoContainer+" .LvClassPrview").css("display","");
				classObj.canSeePreview = false;
				$("#"+classObj.videoContainer+" .LvClassPrview").addClass("VodPreviewed");
				
				var a = '<h2>Just a step away!</h2>'+
						'<p>Watch the full video</p>'+
						'<a class="btn btn-primary _eventListener js-checkout" data-action="common/checkout&for='+classObj.urlKey+'">Purchase Now</a>';
				$("#dynamicModelBtn").find('.dynamicModel-body').empty();
				$("#dynamicModelBtn").find('.dynamicModel-body').append(a);
				
				if($('.PlayLVHere').find('.PlayContainer').hasClass('InFullScreen')){
					classObj.VideoJSfullScreen();
				}
				$("#dynamicModelBtn").modal('show');
				UrlMgmt.getObj().modalObj = $('#dynamicModelBtn');
				$("#"+classObj.videoContainer+" .LvClassPrview").addClass("VodPreviewed");
				$('#dynamicModelBtn').find('._eventListener').unbind().bind('click', function(){
					$("#dynamicModelBtn").modal('hide');
					var urlMgmt = UrlMgmt.getObj();
					var urlMgmtObj = {route: $(this).data('action'), needData: true, offlineAllowed: false};
					urlMgmt.Route(urlMgmtObj, function(obj){
						urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
					}.bind(this));
				});
				$("#"+classObj.videoContainer+" .LvClassPrview").removeClass("LoadingVedio").show();
				$('#VideoHere').find('.lvVidCornerToggle').hide();
			}
		});
	}
	if($("#"+this.video2InPlay).length != 0 && ((this.stream2 != "" && this.stream2 != null) || (this.vod2 != "" && this.vod2 != null))){
		videojs(this.video2InPlay).on('ready',function(){
			//disable the normal double click and add our custom dblclick to player-2
			var classObj = LvClass.getObj();
			videojs(classObj.video2InPlay).tech_.off('dblclick');
			videojs(classObj.video2InPlay).tech_.on('dblclick',function(){				
				var classObj = LvClass.getObj();
				classObj.VideoJSfullScreen();
			});
			
			if(classObj.videoType == LiveClassesType["Live"]){
				//count the no.of time the player is retrying the connection
				videojs(classObj.video2InPlay).tech_.on('retryplaylist', function(e){
			      	var classObj = LvClass.getObj();
			      	if(classObj.connectionRetryCount1 >= 3){
			      		videojs(classObj.video1InPlay).tech_.trigger({type:'error',error:{code:2,status:0}});
			      		videojs(classObj.video2InPlay).reset();
						classObj.vedioIsPlaying = false;	
			      	}
			      	classObj.connectionRetryCount1+=1;					
			      	if(classObj.connectionRetryCount1 == 70){
			      		videojs(classObj.video2InPlay).dispose();
			      	}
			  	});
			}
		});
		videojs(this.video2InPlay).on('contextmenu', function(e){
			e.preventDefault();
		});
		videojs(this.video2InPlay).on(['loadeddata'], function(){
		  var classObj = LvClass.getObj();
		  $('.vjs-control-bar').find('.vjs-http-source-selector').addClass("vjs-hidden");
		  $("#"+classObj.video2InPlay).find('.vjs-control-bar div.vjs-playback-rate').addClass("vjs-hidden");
		  $("#"+classObj.video2InPlay).find('.vjs-control-bar div.vjs-playback-rate .vjs-playback-rate-value').addClass("vjs-hidden");
		  
		  if($('.lvVidCorner .video-js').length > 0 || 
		 ($(".vjs-button.vjs-http-source-selector").length > 0 && typeof videojs(classObj.video2InPlay).player().qualityLevels() != 'undefined' 
			&& videojs(classObj.video2InPlay).player().qualityLevels().levels_.length > 1) ||
			$('#'+classObj.video2InPlay).find("div.vjs-playback-rate .vjs-menu .vjs-menu-content li").length > 0	
		 )
		 {	
			//adding Setting Button to player-2
			var player2 = videojs(classObj.video2InPlay);
			var Component = videojs.getComponent('Component');
			var settingholder = new Component(player2);
			var settingButtonDiv = player2.controlBar.addChild(settingholder, {}, 16);
			settingButtonDiv.addClass("vjs-settingHolder");
			settingButtonDiv.addClass("vjs-settingHolder-player2");
	
			var SetButton = videojs.getComponent('Button');
			var SettingButton = videojs.extend(SetButton, {
				constructor : function() {
					SetButton.apply(this, arguments);
					/* initialize your button */
					this.addClass("vjs-tr-settings");
					this.addClass("vjs-tr-settings-player2");
					this.setAttribute("title", "Settings");
				},
				handleClick : function() {
					/* do something on click */
					var classObj = LvClass.getObj();
					if($("#"+classObj.video2InPlay).find(".vjs-setting-hover").length > 0)
					{
						$("#"+classObj.video2InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
					}
					else{
						$("#"+classObj.video2InPlay).find(".vjs-settingHolder").addClass("vjs-setting-hover");
					}
				}
			});
			videojs.registerComponent('SettingButton', SettingButton);
	
			// adding Setting Button to player-2
			videojs(classObj.video2InPlay).controlBar.addChild('SettingButton', {}, 16);
	
			$(".vjs-settingHolder-player2").append($(".vjs-tr-settings-player2"));
	
			//setting buttons
			var settingbuttons = $('<div class="settingbuttons settingbuttons2"></div>').appendTo($(".vjs-settingHolder-player2"));
			//Setting button ends - player2
		}
		  var divNo = 0;
		  if($('.lvVidCorner .video-js').length > 0)
		  {
		  	  divNo += 1;
			  var secvideoHTML = '<div class="settings-hideSecondvideo settings-hideSecondvideo-player2">'+
									'<div class="vjs-setting-head">'+
									'</div>'+
									'<div class="vjs-menu">'+
										'<ul class="vjs-menu-content" role="menu">'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="0"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo vjs-selected" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="1"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="2"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="3"></li>'+
											'<li class="vjs-menu-item vjs-tr-hideSecondVideo" tabindex="-1" role="menuitemradio" aria-disabled="false" aria-checked="false" video-orientation="4"></li>'+
										'</ul>'+
									'</div>'+
								'</div>';
			  $(".settingbuttons2").append(secvideoHTML);
		  	  $('.settings-hideSecondvideo .vjs-menu-item').on('click', function(e){
		  	  	  classObj.orientation = parseInt($(e.currentTarget).attr('video-orientation')) - 1;
		  	  	  $(".topRightCornerVid").attr("data-orientation",classObj.orientation);
		  	  	  classObj.vjsHideSecondVideo();
		  	  	  e.stopPropagation();
			  });
		  }
		  
		  //appending playback rate button only for vod
		  if(classObj.videoType == LiveClassesType["VOD"])
		  {
		  	  divNo += 1;
			  var playBackHTML = '<div class="settings-playbackrate settings-playbackrate-player2">'+
								 	'<div class="vjs-setting-head">'+
									'</div>'+ 
								 '</div>';
			  $(".settingbuttons2").append(playBackHTML);
			  $(".settings-playbackrate-player2").append($('#'+classObj.video2InPlay).find("div.vjs-playback-rate .vjs-menu"));
		  }
		  
		  //appending bitrate button
		  if($(".vjs-button.vjs-http-source-selector").length > 0 && 
		     videojs(classObj.video2InPlay).player().qualityLevels().levels_.length > 1)
		  {
		  	  divNo += 1;
			  var bitrateHTML = '<div class="settings-bitrate settings-bitrate-player2">'+
									'<div class="vjs-setting-head">'+
									'</div>'+
								'</div>';
			  $(".settingbuttons2").append(bitrateHTML);
			  $('#'+classObj.video2InPlay).find(".vjs-button.vjs-http-source-selector .vjs-menu .vjs-menu-item:first-child").addClass('vjs-selected');
		      $(".settings-bitrate-player2").append($('#'+classObj.video2InPlay).find(".vjs-button.vjs-http-source-selector .vjs-menu"));
		  }
		  if(divNo == 3){
		  	$('.settingbuttons2').addClass('settingbuttons-threeDiv');
		  }
		  if(classObj.videoType == LiveClassesType["VOD"])
		  {
				console.log("Video player 2");
			  	var player2 = videojs(classObj.video2InPlay);
				var Component2 = videojs.getComponent('Component');
				var btnholder2 = new Component2(player2);
				var btnholderDiv2 = player2.addChild(btnholder2, {}, 1);
				btnholderDiv2.addClass("vjs-btnHolder2");
				btnholderDiv2.addClass("vjs-btnHolder-player2");
				console.log($(btnholderDiv2));
				var RWButton = videojs.getComponent('Button');
				var ReWindButton = videojs.extend(RWButton, {
				  constructor: function() {
				    RWButton.apply(this, arguments);
				   	this.addClass("vjs-tr-rewind");
				   	this.addClass("vjs-tr-rewindp2");
				   	this.addClass("vjs-fade-out");
				   	this.setAttribute("title","Rewind");
				  },
				  handleClick: function(e) {
				    var classObj = LvClass.getObj();
				    var t = (videojs(classObj.video2InPlay).currentTime() < 11)?videojs(classObj.video2InPlay).currentTime():10;
					videojs(classObj.video2InPlay).currentTime(videojs(classObj.video2InPlay).currentTime()-t);
				  	
				  	$('.vjs-tr-rewind').addClass('rewindbtnspin');
				  	$('.vjs-tr-rewind').removeClass('rewindbtnspinagain');
				  	
			        classObj.rewindSpinBtn = setTimeout(function(){
			        	clearInterval(classObj.rewindSpinBtn);
						$('.vjs-tr-rewind').removeClass('rewindbtnspin');
						$('.vjs-tr-rewind').addClass('rewindbtnspinagain');
			        }, 500);
				  }
				});
				videojs.registerComponent('ReWindButton', ReWindButton);	
				videojs(classObj.video2InPlay).addChild('ReWindButton', {}, 5);
				$(".vjs-btnHolder-player2").append($(".vjs-tr-rewindp2"));
					
				var PlayPauseButton = videojs.getComponent('PlayToggle');
				var PlayPauseScreenButton = videojs.extend(PlayPauseButton, {
				  constructor: function() {
				    PlayPauseButton.apply(this, arguments);
				   	this.addClass("vjs-tr-playpause");
				   	this.addClass("vjs-tr-playpausep2");
				   	this.addClass("vjs-fade-out");
				  },
				  handleClick: function() {
				  	var classObj = LvClass.getObj();
				  	if($('.vjs-play-control').hasClass('vjs-playing'))
				  	{
				  		classObj.vedioIsPlaying = false;
				  		videojs(classObj.video2InPlay).pause();
				  		$('.vjs-play-control').removeClass('vjs-playing');
				  		$('.vjs-play-control').addClass('vjs-paused');
				  		this.addClass("vjs-paused");
				  	}
					else
					{
						classObj.vedioIsPlaying = true;
						videojs(classObj.video2InPlay).play();
						$('.vjs-play-control').addClass('vjs-playing');
				  		$('.vjs-play-control').removeClass('vjs-paused');
						this.removeClass("vjs-paused");
					}
				  }
				});
				videojs.registerComponent('PlayPauseScreenButton', PlayPauseScreenButton);
				videojs(classObj.video2InPlay).addChild('PlayPauseScreenButton', {}, 6);
				$(".vjs-btnHolder-player2").append($(".vjs-tr-playpausep2"));
				
				var FWButton = videojs.getComponent('Button');
				var ForwardButton = videojs.extend(FWButton, {
				  constructor: function() {
				    FWButton.apply(this, arguments);
				   	this.addClass("vjs-tr-forward");
				   	this.addClass("vjs-tr-forwardp2");
				   	this.addClass("vjs-fade-out");
				   	this.setAttribute("title","Forward");
				  },
				  handleClick: function() {
				  	var classObj = LvClass.getObj();
					var timediff = videojs(classObj.video2InPlay).duration() - videojs(classObj.video2InPlay).currentTime(); 
					videojs(classObj.video2InPlay).currentTime(videojs(classObj.video2InPlay).currentTime() + (timediff < 11?timediff:10));
				  	$('.vjs-tr-forward').addClass('fwbtnspin');
				  	$('.vjs-tr-forward').removeClass('fwbtnspinagain');
			        
			        classObj.fwSpinBtn = setTimeout(function () {
			        	clearInterval(classObj.fwSpinBtn);
			            $('.vjs-tr-forward').removeClass('fwbtnspin');
			            $('.vjs-tr-forward').addClass('fwbtnspinagain');
			        }, 500);
				  }
				});
				videojs.registerComponent('ForwardButton', ForwardButton);
				videojs(classObj.video2InPlay).addChild('ForwardButton', {}, 7);
				$(".vjs-btnHolder-player2").append($(".vjs-tr-forwardp2"));
				$('.vjs-text-track-display').addClass('vjs-delay-black-out');
				videojs(classObj.video2InPlay).on('userinactive', function(){ 
				  $('.vjs-tr-forward').addClass('vjs-fade-out');
				  $('.vjs-tr-playpause').addClass('vjs-fade-out');
				  $('.vjs-tr-rewind').addClass('vjs-fade-out'); 
				  $('.vjs-text-track-display').addClass('vjs-delay-black-out');
				  $('.vjs-text-track-display').removeClass('vjs-delay-black-out1');
				  classObj.show_playIcon1 = false;
				  classObj.show_playIcon2 = false;
				  $(".vjs-btnHolder-player2").addClass('hidebtns');
				  $(".vjs-text-track-display").addClass('removeopacity');
				  if($("#"+classObj.video2InPlay).find(".vjs-setting-hover").length > 0)
				  {
					  $("#"+classObj.video2InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
				  }
				  
				});
				
				videojs(classObj.video2InPlay).on('click', function(){ 
					if(classObj.show_playIcon2)
					{
						classObj.show_playIcon1 = false;
						classObj.show_playIcon2 = false;
						$(".vjs-btnHolder-player2").addClass('hidebtns');
				  		$(".vjs-text-track-display").addClass('removeopacity');
					}
					else{
						showPlayIcon();
					}
				});
	  	  }
	  	  else if(classObj.videoType == LiveClassesType["Live"])
	  	  {
				var classObj = LvClass.getObj();
				videojs(classObj.video2InPlay).on('userinactive', function()
				{ 
					if($("#"+classObj.video2InPlay).find(".vjs-setting-hover").length > 0)
					  {
						  $("#"+classObj.video2InPlay).find(".vjs-settingHolder").removeClass("vjs-setting-hover");
					  }
				});
	  	  }
		  videojs(classObj.video2InPlay).off(['loadeddata']);
		});
		
		if(this.videoType == LiveClassesType["VOD"]){
			//add dummy space bar for gap to player-2
			var player2 = videojs(this.video2InPlay);
			var Component = videojs.getComponent('Component');
			var progressBar = new Component(player2);
			var progressBarDiv = player2.controlBar.addChild(progressBar,{},10);
			progressBarDiv.addClass("vjs-progress-control");
			progressBarDiv.addClass("vjs-control");
			progressBarDiv.addClass("dummy-vjs-progress-control");
		}
		
		// adding Full Screen Button to player-2
		videojs(this.video2InPlay).controlBar.addChild('FullScreenButton', {}, 17);
		
		if(this.videoType == LiveClassesType["Live"] || this.forceChat)
		{
			//Add Chat Button to Player-2
			videojs(this.video2InPlay).controlBar.addChild('ChatButton', {}, 11);			
		}

		var TVButton = videojs.getComponent('Button');
		var ToggleVideoButton = videojs.extend(TVButton, {
		  constructor: function() {
		    TVButton.apply(this, arguments);
		    /* initialize your button */
		   	this.addClass("vjs-tr-toggleVideo");
		   	this.setAttribute("title","Swap Video");
		  },
		  handleClick: function() {
		    /* do something on click */
		    $(".lvVidCornerToggle").toggleClass("lvVidCorner");
			var classObj = LvClass.getObj();
			classObj.SetSize();
			if(classObj.videoType == LiveClassesType["VOD"]){
			 	showPlayIcon();
			}
		  }
		});
		videojs.registerComponent('ToggleVideoButton', ToggleVideoButton);
		
		// adding Swap/Toggle Video Button to player-1
		videojs(this.video1InPlay).controlBar.addChild('ToggleVideoButton',{},11);
			
		// adding Swap/Toggle Video Button to player-2
		videojs(this.video2InPlay).controlBar.addChild('ToggleVideoButton',{},11);
		
		videojs(this.video2InPlay).on('firstplay', function(){
			var classObj = LvClass.getObj();		
			var lastPause = parseInt(videojs(classObj.video1InPlay).currentTime());
			if(lastPause > 0)		 
				videojs(classObj.video2InPlay).currentTime(lastPause);
		});
		//play the secondary video if primary video is playing
		videojs(this.video1InPlay).on(['playing'], function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = true;
			videojs(classObj.video2InPlay).play();	
			classObj.HeartBitCounter();	
			if(classObj.videoType == LiveClassesType["VOD"]){
			 	showPlayIcon();
			}
		});
		//play the primary video if secondary video is playing
		videojs(this.video2InPlay).on(['playing'], function(){
			var classObj = LvClass.getObj();			
			videojs(classObj.video1InPlay).play();
			if(classObj.videoType == LiveClassesType["VOD"]){
			 	showPlayIcon();
			}	
		});
		
		//pause the secondary video if primary video is paused or buferring
		videojs(this.video1InPlay).on(['pause'], function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = false;
			videojs(classObj.video2InPlay).pause();
			console.log("clear video1InPlay in pause timer id",classObj.heartBitTimerId);
			clearInterval(classObj.heartBitTimerId);
			if(classObj.videoType == LiveClassesType["VOD"]){
			 	showPlayIcon();
			}
		});
		
		//pause the primary video if secondary video is paused or buferring
		videojs(this.video2InPlay).on(['pause'], function(){
			var classObj = LvClass.getObj();	
			classObj.vedioIsPlaying = false;		
			videojs(classObj.video1InPlay).pause();
			console.log("clear video2InPlay in pause timer id",classObj.heartBitTimerId);
			clearInterval(classObj.heartBitTimerId);
			if(classObj.videoType == LiveClassesType["VOD"]){
			 	showPlayIcon();
			}
		});
		
		//change the volume of video2 if video1 volume changed
		videojs(this.video1InPlay).on(['volumechange'],function(){
			var classObj = LvClass.getObj();
			var muted = videojs(classObj.video1InPlay).muted();			
			if(muted == true)
				videojs(classObj.video2InPlay).muted(true);
			else
			{
				videojs(classObj.video2InPlay).muted(false);
				videojs(classObj.video2InPlay).volume(videojs(classObj.video1InPlay).volume());
			}				
		});
		//change the volume of video1 if video2 volume changed
		videojs(this.video2InPlay).on(['volumechange'],function(){
			var classObj = LvClass.getObj();
			var muted = videojs(classObj.video2InPlay).muted();			
			if(muted == true)
				videojs(classObj.video1InPlay).muted(true);
			else
			{
				videojs(classObj.video1InPlay).muted(false);
				videojs(classObj.video1InPlay).volume(videojs(classObj.video2InPlay).volume());
			}							
		});
		//change the playbackrate of video2 if video1 playbackrate changed
		videojs(this.video1InPlay).on(['ratechange'],function(){
		    var classObj = LvClass.getObj();
		    videojs(classObj.video2InPlay).playbackRate(videojs(classObj.video1InPlay).playbackRate());
		});
		//change the playbackrate of video1 if video2 playbackrate changed		
		videojs(this.video2InPlay).on(['ratechange'],function(){
		    var classObj = LvClass.getObj();
		    videojs(classObj.video1InPlay).playbackRate(videojs(classObj.video2InPlay).playbackRate());
		});
		//dispose the video2 if video1 is disposed
		videojs(this.video1InPlay).on(['dispose'], function(){
			var classObj = LvClass.getObj();			
			videojs(classObj.video2InPlay).dispose();
		});
		videojs(this.video2InPlay).on(['dispose'], function(){
			var classObj = LvClass.getObj();			
			videojs(classObj.video1InPlay).dispose();
		});
		//control bar is active if user hover on any player
		videojs(this.video1InPlay).on(['useractive'], function(){
			var classObj = LvClass.getObj();
			videojs(classObj.video2InPlay).userActive(true);
		});
		videojs(this.video2InPlay).on(['useractive'], function(){
			var classObj = LvClass.getObj();
			videojs(classObj.video1InPlay).userActive(true);
		});
		//for multibitrate sync btn players
		if((typeof videojs(this.video1InPlay).qualityLevels !="undefined" || 
			typeof videojs(this.video2InPlay).qualityLevels !="undefined")
			&& this.videoQualitySync == 1)
		{
			videojs(this.video1InPlay).qualityLevels().on('change',function(e)
			{
				if(e.selectedIndex != -1){
					var classObj = LvClass.getObj();
					var selectedlabel = videojs(classObj.video1InPlay).qualityLevels().levels_[e.selectedIndex].height;
					var selectedIndexSec = videojs(classObj.video2InPlay).qualityLevels().selectedIndex;
					if(selectedIndexSec != -1 && videojs(classObj.video2InPlay).qualityLevels().levels_[selectedIndexSec].height != selectedlabel)
					{
						var seclength = videojs(classObj.video2InPlay).qualityLevels().levels_.length;
						for(var i=0; i< seclength; i++)
						{
							if(videojs(classObj.video2InPlay).qualityLevels().levels_[i].height == selectedlabel)
							{
								videojs(classObj.video2InPlay).qualityLevels().levels_[i].enabled_(true);
								videojs(classObj.video2InPlay).qualityLevels().levels_[selectedIndexSec].enabled_(false);
								break;
							}
						}	
					}	
				}	
			});
			videojs(this.video2InPlay).qualityLevels().on('change',function(e)
			{
				if(e.selectedIndex != -1)
				{
					var classObj = LvClass.getObj();
					var selectedlabel = videojs(classObj.video2InPlay).qualityLevels().levels_[e.selectedIndex].height;
					var selectedIndexprim = videojs(classObj.video1InPlay).qualityLevels().selectedIndex;
					if(selectedIndexprim != -1 && videojs(classObj.video1InPlay).qualityLevels().levels_[selectedIndexprim].height != selectedlabel)
					{
						var primlength = videojs(classObj.video1InPlay).qualityLevels().levels_.length;
						for(var i=0; i< primlength; i++)
						{
							if(videojs(classObj.video1InPlay).qualityLevels().levels_[i].height == selectedlabel)
							{
								videojs(classObj.video1InPlay).qualityLevels().levels_[i].enabled_(true);
								videojs(classObj.video1InPlay).qualityLevels().levels_[selectedIndexprim].enabled_(false);
								break;
							}
						}	
					}	
				}
			});
			videojs(this.video1InPlay).qualityLevels().on('qualityChange', function(e){
				var classObj = LvClass.getObj();
				var levels_1 = videojs(classObj.video1InPlay).qualityLevels().levels_;
				var levels_2 = videojs(classObj.video2InPlay).qualityLevels().levels_;
				if(classObj.video2QualityLevels.length == 0){
					levels_2.forEach(function(val){
						classObj.video2QualityLevels.push(val.height);
					});
				}
				if(e.selectedIndex == levels_1.length || classObj.video2QualityLevels.indexOf(e.data.options_.sortVal) > -1){
					var menubutton = $("#video2InPlay .settings-bitrate .vjs-menu .vjs-menu-content");
					var selectedLabel = -1;
				    for (var i = 0; i < levels_2.length; i++) {
				      if (e.selectedIndex == levels_1.length) {
				        // If this is the Auto option, enable all renditions for adaptive selection
				        levels_2[i].enabled_(true);
				        selectedLabel = levels_2.length;
				      } else if (e.data.options_.sortVal == levels_2[i].height) {
				        levels_2[i].enabled_(true);
				        selectedLabel = levels_2[i].id;
				      } else {
				        levels_2[i].enabled_(false);
				      }
				    }
				    $(menubutton).find(".vjs-menu-item").removeClass("vjs-selected");
				    $(menubutton).find(".vjs-menu-item:nth-child("+(levels_2.length-selectedLabel+1)+")").addClass("vjs-selected");	
				}
			});
			videojs(this.video2InPlay).qualityLevels().on('qualityChange', function(e){
				var classObj = LvClass.getObj();
				var levels_1 = videojs(classObj.video1InPlay).qualityLevels().levels_;
				var levels_2 = videojs(classObj.video2InPlay).qualityLevels().levels_;
				if(classObj.video1QualityLevels.length == 0){
					levels_1.forEach(function(val){
						classObj.video1QualityLevels.push(val.height);
					});
				}
				if(e.selectedIndex == levels_2.length || classObj.video1QualityLevels.indexOf(e.data.options_.sortVal) > -1){
					var menubutton = $("#video1InPlay .settings-bitrate .vjs-menu .vjs-menu-content");
					var selectedLabel = -1;
				    for (var i = 0; i < levels_1.length; i++) {
				      if (e.selectedIndex == levels_2.length) {
				        // If this is the Auto option, enable all renditions for adaptive selection
				        levels_1[i].enabled_(true);
				        selectedLabel = levels_1.length;
				      } else if (e.data.options_.sortVal == levels_1[i].height) {
				        levels_1[i].enabled_(true);
				        selectedLabel = levels_1[i].id;
				      } else {
				        levels_1[i].enabled_(false);
				      }
				    }
				    $(menubutton).find(".vjs-menu-item").removeClass("vjs-selected");
				    $(menubutton).find(".vjs-menu-item:nth-child("+(levels_1.length-selectedLabel+1)+")").addClass("vjs-selected");	
				}
			});		
		}
	}
	else{
		//change the state of video to playing
		videojs(this.video1InPlay).on(['playing'], function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = true;	
			classObj.HeartBitCounter();
			if(classObj.videoType == LiveClassesType["VOD"]){
			 showPlayIcon();
			}
		});
		//change the state of video to paused
		videojs(this.video1InPlay).on(['pause'], function(){
			var classObj = LvClass.getObj();
			classObj.vedioIsPlaying = false;
			clearInterval(classObj.heartBitTimerId);
			 if(classObj.videoType == LiveClassesType["VOD"]){
				 showPlayIcon();
				}
		});
	}
	//change the state of video to paused
	videojs(this.video1InPlay).on(['waiting','ended','dispose'], function(){
		var classObj = LvClass.getObj();
		classObj.vedioIsPlaying = false;
		clearInterval(classObj.heartBitTimerId);
	});
	
	
	//Add logo for secondary
	var classObj = LvClass.getObj();								  
	if($("#"+this.video2InPlay).length != 0 && ((this.stream2 != "" && this.stream2 != null) || (this.vod2 != "" && this.vod2 != null)))
	{
		var player2 = videojs(this.video2InPlay);
		var Component = videojs.getComponent('Component');
		var logosec = new Component(player2);
		var logoDivsec = player2.addChild(logosec,{},10);
		logoDivsec.addClass("videojs-watermark");
	}
	//Add logo for primary
	var player1 = videojs(this.video1InPlay);
	var Component = videojs.getComponent('Component');
	var logo = new Component(player1);
	var logoDiv = player1.addChild(logo,{},10);
	logoDiv.addClass("videojs-watermark");
	$('<img style="max-width:50px;display:flex;" src="'+classObj.logoUrl+'">').appendTo($(".videojs-watermark"));
	
	$(window).blur(function() 
	{
		if(typeof videojs != 'undefined' && videojs.getAllPlayers().length > 0)
		{
			var classObj = LvClass.getObj();
			if(classObj.videoType == LiveClassesType["VOD"] && classObj.continueAnyWay == false)
			{			
		 		videojs(classObj.video1InPlay).pause();	 		
		 		$("#liveClassPause").modal();	 			 			 		
		 	}
	 	}
	});
	
	$(window).resize(function()
	{
		if(typeof videojs != 'undefined' && videojs.getAllPlayers().length > 0)
		{
			var classObj = LvClass.getObj();
			classObj.SetSize();
		}
	});
	this.SetSize();
	
	window.addEventListener("orientationchange", function() 
	{
		setTimeout(function() 
		{
			var classObj = LvClass.getObj();
			classObj.ValidateOrientation();		
		}, 300);
	});
	
	this.ValidateOrientation();
};
LvClass.prototype.HeartBitCounter = function()
{
	var classObj = LvClass.getObj();
	classObj.heartBitTimerId = setInterval(function(){
		classObj.heartBitTimerVal +=1;
		if(classObj.heartBitTimerVal%30 == 0){
			if(typeof videojs !== "undefined" && videojs.getAllPlayers().length > 0){
				classObj.vjsSendHeardBit();
				classObj.heartBitTimerVal = 0;
			}else{
				classObj.SendHeardBit();
				classObj.heartBitTimerVal = 0;
			}
		}
	},1000);
};
LvClass.prototype.HideSecondVideo = function(state) 
{
	if(state == undefined)
		state = true;
	if(this.orientation == null)
		this.orientation = 1;
	$(".jw-tr-hideSecondVideo").each(function(e){
		if($(this).attr("data-orientation") === undefined)
		{
			$(this).attr("data-orientation",""+this.orientation+"");
		}
	}.bind(this));
	if(state == true)
		this.orientation = (parseInt($(".topRightCornerVid").attr("data-orientation")) + 1) % 5;	
		$(".jw-tr-hideSecondVideo").attr("data-orientation",""+this.orientation+"");
		$(".topRightCornerVid").attr("data-orientation",""+this.orientation+"");
};

LvClass.prototype.vjsHideSecondVideo = function(state) 
{
	if(state == undefined)
		state = true;
	if(this.orientation == null)
		this.orientation = 1;
	$(".vjs-tr-hideSecondVideo").each(function(e){
		if($(this).attr("data-orientation") === undefined)
		{
			$(this).attr("data-orientation",""+this.orientation+"");
		}
	}.bind(this));
	if(state == true)
		this.orientation = (parseInt($(".topRightCornerVid").attr("data-orientation")) + 1) % 5;	
		$(".vjs-tr-hideSecondVideo").attr("data-orientation",""+this.orientation+"");
		$(".topRightCornerVid").attr("data-orientation",""+this.orientation+"");
		
		$('.settings-hideSecondvideo').find('.vjs-menu-content .vjs-menu-item').removeClass('vjs-selected');
		$('.settings-hideSecondvideo').find('.vjs-menu-content [video-orientation="'+this.orientation+'"]').addClass('vjs-selected');
		$('.settings-hideSecondvideo').find('.vjs-menu-content .vjs-selected').attr("data-orientation",""+this.orientation+"");
};

//fullscreen
LvClass.prototype.fullScreen = function() 
{	
	var test = $(".PlayContainer")[0];

    var state = ((typeof document.webkitIsFullScreen !== 'undefined' && document.webkitIsFullScreen) || 
    			(typeof document.isFullScreen !== 'undefined' && document.isFullScreen));

    var requestFunc = (test.requestFullScreen || test.webkitRequestFullScreen);
    var cancelFunc = (document.cancelFullScreen || document.webkitCancelFullScreen);

    if(!state)
    {
    	UrlMgmt.getObj().showLoader();
    	requestFunc.call(test);
    	UrlMgmt.getObj().removeLoader();
    	this.isfullscreen = true;
    	$(".PlayContainer").addClass("InFullScreen");
    	$(".VideoContainer").css("max-width","none");
    	//screen.orientation.lock('landscape');
    }else
    {   	
    	cancelFunc.call(document);
    	this.isfullscreen = false;
    	$(".PlayContainer").removeClass("InFullScreen");
		//screen.orientation.lock('portrait');
    }
    this.HideSecondVideo(false);
    this.SetSize();
    
};
//fullscreen for videojs
LvClass.prototype.VideoJSfullScreen = function() 
{	
	var test = $(".PlayContainer")[0];
    var state = ((typeof document.webkitIsFullScreen !== 'undefined' && document.webkitIsFullScreen) || 
    			(typeof document.isFullScreen !== 'undefined' && document.isFullScreen))||
    			(typeof document.mozFullScreen !=='undefined' && document.mozFullScreen);

    var requestFunc = (test.requestFullScreen || test.webkitRequestFullScreen || test.mozRequestFullScreen);
    var cancelFunc = (document.cancelFullScreen || document.webkitCancelFullScreen || document.mozCancelFullScreen);
	
    if(!state)
    {
    	UrlMgmt.getObj().showLoader();
    	requestFunc.call(test);
    	UrlMgmt.getObj().removeLoader();
    	this.isfullscreen = true;
    	$(".PlayContainer").addClass("InFullScreen");
    	$(".VideoContainer").css("max-width","none");
    	//screen.orientation.lock('landscape');
    }else
    {   	
    	cancelFunc.call(document);
    	this.isfullscreen = false;
    	$(".PlayContainer").removeClass("InFullScreen");
		//screen.orientation.lock('portrait');
    }
    this.vjsHideSecondVideo(false);
    this.SetSize();
};

LvClass.prototype.SetSize = function()
{
	var wWidth = $( window ).width();
	var height = $( window ).height();
	var HbyW = 9/16.0;
	var vMaxHeight = HbyW * wWidth;
	var vMaxWidth = wWidth;	
	
	if(screen.orientation.type == "landscape-primary" && $(".PlayContainer.InFullScreen").length == 0)
	{
		if(this.appheight == null)
		{
			this.appheight = $("#app").css("height");
		}
		$("#app").css("height", "auto");
	}
	else
	{
		if(this.appheight !=null)
			$("#app").css("height", this.appheight);
	}
	
	if($(".PlayContainer.InFullScreen").length == 0 && $(window).width() > 767) 
	{
		vMaxWidth = $( window ).width() - 330 ;
		vMaxHeight = HbyW * vMaxWidth;
		$(".VideoContainer").css("max-width",vMaxWidth+"px");
	}
	else if($(".PlayContainer.InFullScreen").length == 0) 
	{
		vMaxWidth = wWidth - 30 ;
		vMaxHeight = HbyW * vMaxWidth;
		$(".VideoContainer").css("max-width",vMaxWidth+"px");
	}	
	else if($(".PlayContainer.InFullScreen").length > 0 && vMaxHeight > height)
	{
		vMaxWidth = height / HbyW;
		vMaxHeight = height;
		$(".VideoContainer").css("max-width","none");
	}
	if($("#"+this.video1InPlay).length == 0)
	{
		return;
	}
	if(typeof videojs !== "undefined" && videojs.getAllPlayers().length > 0){
		var PVideoId = $('.wrapperLv:not(.lvVidCorner) .video-js').attr("id");
		videojs(PVideoId).dimensions(vMaxWidth, vMaxHeight);
		if($('.lvVidCorner .video-js').length > 0)
		{
			var CVideoId = $('.lvVidCorner .video-js').attr("id");
			var cheight = vMaxHeight / 100 * 30;
			var cwidth = cheight / HbyW;
			videojs(CVideoId).dimensions(cwidth, cheight);
		}
	}
	else{
		var PVideoId = $('.wrapperLv:not(.lvVidCorner) .jwplayer').attr("id");
		jwplayer(PVideoId).resize(vMaxWidth, vMaxHeight);
		if($('.lvVidCorner .jwplayer').length > 0)
		{
			var CVideoId = $('.lvVidCorner .jwplayer').attr("id");
			var cheight = vMaxHeight / 100 * 30;
			var cwidth = cheight / HbyW;
			jwplayer(CVideoId).resize(cwidth, cheight);
		}
	}
	if($(".PlayContainer.InFullScreen").length > 0){
			screen.orientation.lock('landscape');
	}
	else{
		screen.orientation.lock('portrait');
	}	
};
LvClass.prototype.ValidateOrientation = function()
{
	if('ontouchstart' in window)
		{
			if(window.matchMedia("(orientation: landscape)").matches)
			{
		  		if($('#chatHere').is(":visible"))
		  		{
		  			//$("#chatHere").toggle(300);			
		  		}
		  	}
		  	else
			{
		  		if($('#chatHere.hidechat').length == 0 && !($('#chatHere').is(":visible")))
		  		{
		  			$("#chatHere").toggle(300);
		  				var classObj = LvClass.getObj(data);
				}
		  	}
	  }	
	  var classObj = LvClass.getObj();
	  classObj.SetSize(); 
};

LvClass.prototype.BindSeek = function(isPrimery)
{
	if(isPrimery)
	{
		jwplayer(this.video1InPlay).on("seek", function(e)
		{
			var classObj = LvClass.getObj();
			if($("#"+classObj.video2InPlay).length != 0)
			{
				jwplayer(classObj.video2InPlay).off("seek");
				jwplayer(classObj.video2InPlay).seek(e.offset);
				jwplayer(classObj.video2InPlay).on("seeked", function(e){
					var classObj = LvClass.getObj();
					classObj.BindSeek(false);	
				});
			}
		});
	}else
	{
		jwplayer(this.video2InPlay).on("seek", function(e)
		{
			var classObj = LvClass.getObj();
			jwplayer(classObj.video1InPlay).off("seek");
			jwplayer(classObj.video1InPlay).seek(e.offset);
			jwplayer(classObj.video1InPlay).on("seeked", function(e){
				var classObj = LvClass.getObj();
				classObj.BindSeek(true);
			});
		});
	}
};
LvClass.prototype.vjsBindSeek = function(isPrimery)
{
	if(isPrimery)
	{		
		videojs(this.video1InPlay).on("seeked", function(e)
		{
			var classObj = LvClass.getObj();
			if($("#"+classObj.video2InPlay).length != 0)
			{							
				videojs(classObj.video2InPlay).off("seeked");				
				videojs(classObj.video2InPlay).currentTime(videojs(classObj.video1InPlay).currentTime());
				videojs(classObj.video2InPlay).on("seeked", function(e){
					var classObj = LvClass.getObj();
					classObj.vjsBindSeek(false);	
				});					
			}
		});
	}else
	{		
		videojs(this.video2InPlay).on("seeked", function(e)
		{
			var classObj = LvClass.getObj();												
			videojs(classObj.video1InPlay).off("seeked");			
			videojs(classObj.video1InPlay).currentTime(videojs(classObj.video2InPlay).currentTime());
			videojs(classObj.video1InPlay).on("seeked", function(e){
				var classObj = LvClass.getObj();
				classObj.vjsBindSeek(true);	
			});			
		});
	}
};
LvClass.prototype.SendHeardBit = function()
{
		if($("#VideoHere > #overlay .useridwatermark").length > 0)
		{
			this.showUserIdWatermark();
		}
		else{
			//var userObj = User.getObj();
			if(typeof flashcode_text != 'undefined' && flashcode_text == true)
			{
				$("#VideoHere #overlay").append("<div class='useridwatermark' style='display:none;'>User Id:"+UrlMgmt.getObj().userData['id']+"</div>");
			}
			else
			{
				$("#VideoHere #overlay").append("<div class='useridwatermark' style='display:none;'>"+UrlMgmt.getObj().userData['id']+"</div>");
			}
			this.showUserIdWatermark();
		}
		var currentTime = parseInt(jwplayer(this.video1InPlay).getPosition());
		// var maxTime = parseInt(jwplayer(this.video1InPlay).getDuration());
		currentTime = ((this.maxPlayTime - currentTime) > 30)? currentTime : 0;
		var bitrate = 480;
		if(jwplayer(this.video1InPlay).getVisualQuality() != null){
			bitrate = jwplayer(this.video1InPlay).getVisualQuality().level.height ;
		}

		if($("#"+this.video2InPlay).length != 0 && jwplayer(this.video2InPlay).getVisualQuality() != null){
			var Sbitrate = jwplayer(this.video2InPlay).getVisualQuality().level.height ;
			bitrate = (bitrate < Sbitrate)? Sbitrate : bitrate;
		}
		$.ajax({
			type : "POST",
			url : remoteServer + "/?route=common/ajax",
			data : {
				mod : "liveclasses",
				ack : "userwatchingvideo",
				videoType: this.videoType,
				classId: this.classId,
				bitrate: bitrate,
				pauseTime: currentTime,
			},
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			context: this,
			complete : function(event) {
					try
				{
					var reply = event.responseJSON;
					if(reply.result.state == "ok")
					{
						//if watchedDuration is greater than allowed duration stop playing
								if(reply.data.videoContinue == 0)
								{
										if($("#VideoHere").find("#overlay").length == 0){
											$("#VideoHere").append("<div id='overlay'><div id='overlay_text'>Multiple Login Detected<br>please logout to watch this video</div></div>");
										}else{
											$("#VideoHere #overlay").html("<div id='overlay_text'>Multiple Login Detected<br>To watch video logout from other system</div>");
										}
										$("#VideoHere #overlay").css({
											"background-color":"rgba(0,0,0,0.7)",
											"bottom": "0",
											"z-index": "7",
											"position": "absolute",
										    "top": "0",
										    "width": "100%",
										    "display": "flex",
    										"align-items": "center",
										});
								
										
										$("#VideoHere #overlay #overlay_text").css({
											'color': 'rgb(248, 50, 50)',
										    'width': '78%',
										    'position': 'relative',
										    'border-radius': '16px',
										    'background-color': 'white',
										    'padding': '27px 0px',
										    'font-size': '1.4em',
										    'margin': '0 auto',
										});
										var classObj = LvClass.getObj();
										jwplayer(classObj.video1InPlay).pause();
								}
								 else if(reply.data.remainingTime <= 0)
								 {
										var classObj = LvClass.getObj();
										jwplayer(classObj.video1InPlay).stop();
										if($("#"+classObj.video2InPlay).length != 0){
											jwplayer(classObj.video2InPlay).stop();
										}	
										alert("Watch Duration Quota for this Video Exhausted");
										UrlMgmt.getObj().PopView(function(){
											UrlMgmt.getObj().Route({route:'item/liveclasses&id='+this.id, needData: true, offlineAllowed: false});
										}.bind(this));
									}
					}
					else
					{
						alert("Please Login to Update Status");
					}
				}
				catch(e)
				{
					console.log("error", e);
				}
			},
		});				
};
LvClass.prototype.vjsSendHeardBit = function()
{
	var classObj = LvClass.getObj();
	if($("#VideoHere .useridwatermark").length > 0)
	{
		this.showVjsUserIdWatermark();
	}
	else{
		//var userObj = User.getObj();
		$("#VideoHere").append("<div id='vjsUseridOverlay'><div class='useridwatermark' style='display:none;'>"+UrlMgmt.getObj().userData['id']+"</div></div>");
		this.showVjsUserIdWatermark();
	}
	
	var currentTime = parseInt(videojs(classObj.video1InPlay).currentTime());
	var maxTime = parseInt(videojs(classObj.video1InPlay).duration());
	currentTime = ((maxTime - currentTime) > 30)? currentTime : 0;
	var bitrate = 480;
	if(videojs(classObj.video1InPlay).videoHeight() != null){
		bitrate = videojs(classObj.video1InPlay).videoHeight();
	}

	if($('#'+classObj.video2InPlay).length != 0 && videojs(classObj.video2InPlay).videoHeight() != null){
		var Sbitrate = videojs(classObj.video2InPlay).videoHeight;
		bitrate = (bitrate < Sbitrate)? Sbitrate : bitrate;
	}
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer + "/?route=common/ajax"+"/classId="+this.classId;
		var status    = "";
		var mod		  = "liveclasses";	
		var ack		  = "userwatchingvideo";
	}
	$.ajax({
		type : "POST",
		url : remoteServer + "/?route=common/ajax",
		data : {
			mod : "liveclasses",
			ack : "userwatchingvideo",
			videoType: this.videoType,
			classId: this.classId,
			pauseTime: currentTime,
			bitrate: bitrate,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context: this,
		complete : function(event) {
			try
			{
				var reply = event.responseJSON;
				if(reply.result.state == "ok")
				{
					//if watchedDuration is greater than allowed duration stop playing
					if(reply.data.videoContinue == 0){
						if($("#VideoHere").find("#vjsUseridOverlay").length == 0){
							$("#VideoHere").append("<div id='vjsUseridOverlay'><div id='overlay_text'>Multiple Login Detected<br>please logout to watch this video</div></div>");
						}else{
							$("#VideoHere #vjsUseridOverlay").html("<div id='overlay_text'>Multiple Login Detected<br>To watch video logout from other system</div>");
						}
						$("#VideoHere #vjsUseridOverlay").css({
							"background-color":"rgba(0,0,0,0.7)",
							"bottom": "0",
							"z-index": "7",
							"position": "absolute",
						    "top": "0",
						    "width": "100%",
						    "display": "flex",
							"align-items": "center",
						});
						$("#VideoHere #vjsUseridOverlay #overlay_text").css({
							'color': 'rgb(248, 50, 50)',
						    'width': '78%',
						    'position': 'relative',
						    'border-radius': '16px',
						    'background-color': 'white',
						    'padding': '27px 0px',
						    'font-size': '1.4em',
						    'margin': '0 auto',
						});
						var classObj = LvClass.getObj();
						videojs(classObj.video1InPlay).pause();
					}
					else if(reply.data.remainingTime <= 0)
					 {
						var allPlayers = videojs.getAllPlayers();
						for(var i=0;i<allPlayers.length;i++)
						{
							if($("#"+allPlayers[i].id_).length !=0)
							{
								videojs(allPlayers[i].id_).reset();
							    videojs(allPlayers[i].id_).dispose();
						   	}
						}
						alert("Watch Duration Quota for this Video Exhausted");
						UrlMgmt.getObj().PopView(function(){
							UrlMgmt.getObj().Route({route:'item/liveclasses&id='+this.id, needData: true, offlineAllowed: false});
						}.bind(this));
					}
					if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
					{
						status       = "success";
						endtime      = Date.now();
						var duration = endtime - starttime;
						PerformanceAuditHandler.addPerformanceAuditAjax({
							mod:mod,
							ack:ack,
							url:url,
							status:status,
							starttime:starttime,
							endtime:endtime,
							duration:duration
						});
					}
				}
				else
				{
					alert("Please Login to Update Status");
				}
			}
			catch(e)
			{
				console.log("error", e);
			}
		},
	});				
};
LvClass.prototype.showUserIdWatermark = function()
{
	var min=10;
    var max1=$("#overlay").width() - 100;
    var max2=$("#overlay").height();
    var random1 =Math.floor(Math.random() * (max1 - min)) + min;
    var random2 =Math.floor(Math.random() * (max2 - min)) + min;
    $("#overlay .useridwatermark").css({
    	'display':'inline',
    	'left':random1,
    	'top':random2,
    	'position':'absolute',
    	'z-index':'5',
    	'background-color':'rgba(221,221,221, 0.3)',
    	'color':'rgba(136,136,136,0.6)'
    });
    setTimeout(function(){
    	 $("#overlay .useridwatermark").css({
	    	'display':'none'
	    });
    },7000);
};
LvClass.prototype.showVjsUserIdWatermark = function()
{
	var min=10;
	var width = $(".lvVidCornerToggle:not(.lvVidCorner)").width() - 100;
	var height = $(".lvVidCornerToggle:not(.lvVidCorner)").height() - 100; 
	var randPosition1 = Math.floor(Math.random() * (width - min)) + min;
  	var randPosition2 = Math.floor(Math.random() * (height - min)) + min;
  	$("#vjsUseridOverlay .useridwatermark").css({
    	'display':'inline',
    	'left':randPosition1,
    	'top':randPosition2,
    	'position':'absolute',
    	'z-index':'5',
    	'background-color':'rgba(182, 207, 207, 0.5)',
    });
    setTimeout(function(){
    	 $("#vjsUseridOverlay .useridwatermark").css({
	    	'display':'none'
	    });
    },7000);
};
LvClass.prototype.PlayVOD = function()
{
	$("#"+this.videoContainer+" .LvClassPrview").addClass("LoadingVedio");
	liveclassesitemHelper.LoadJS("jwplayer8/jwplayer.js", function(){		
		var classObj = LvClass.getObj();
		jwplayer.key = classObj.jwPlayerLicenseKey;
		if($('#'+classObj.video1InPlay).length == 0)
		{
			$('<div class="lvVidCornerToggle topRightCornerVid wrapperLv" data-orientation="1"><div id="'+classObj.video1InPlay+'" class="switch_1"></div></div>').appendTo("#"+classObj.videoContainer);
		}
		
		tr$.ajax({
			mod : "liveclasses",
			ack : "playvod",
			additionalParams : {
				stream : classObj.vod1
			},
			successClb : function(response) {
				console.log(response);
				//var classObj = LvClass.getObj();
				jwplayer(classObj.video1InPlay).setup({
					playlist : response,
					width : "100%",
					aspectratio : "16:9",
					playbackRateControls : [0.75, 1, 1.25, 1.5, 2],
					autostart : true,
					stretching : "exactfit",
					mute : false,
					abouttext : "Ankalan Web Solutions Pvt Ltd", //TODO
					aboutlink : "https://www.toprankers.com",
					aboutlinktarget : '_blank',
					type : "hls",
					preload : "none",
					primary : "html5",
					hlshtml : true,
					withCredentials : classObj.isVod1Secure,
					image : client_logoimg_cdnurl,
					logo : {
						file : classObj.logoUrl,
						position : 'top-left',
						margin : '4'
					},
					skin : {
						name : 'toprankers',
					}
				});
				jwplayer(classObj.video1InPlay).on('error', function() {
					console.log("vod1 error");
					var classObj = LvClass.getObj();
					classObj.vedioIsPlaying = false;
					jwplayer(classObj.video1InPlay).load({
						file : "https://youtu.be/16xzzamaunk",
						title : classObj.url,
						image : "http://www.text2image.com/user_images/text2image_D19375_20171124_064135.jpg"
					});
					jwplayer(classObj.video1InPlay).play();

				});
				classObj.BindSeek(true);
				if (classObj.vod2 != "" && classObj.vod2 != null) {
					$('<div class="lvVidCornerToggle lvVidCorner topRightCornerVid wrapperLv" data-orientation="1"><div id=' + classObj.video2InPlay + ' class="switch_2"></div></div>').appendTo("#" + classObj.videoContainer);
					tr$.ajax({
						mod : "liveclasses",
						ack : "playvod",
						additionalParams : {
							stream : classObj.vod2
						},
						successClb : function(response) {
							//var classObj = LvClass.getObj();
							jwplayer(classObj.video2InPlay).setup({
								playlist : response,
								width : "100%",
								aspectratio : "16:9",
								playbackRateControls : [0.75, 1, 1.25, 1.5, 2],
								autostart : true,
								stretching : "exactfit",
								mute : true,
								abouttext : "Ankalan Web Solutions Pvt Ltd",
								aboutlink : "https://www.toprankers.com",
								aboutlinktarget : '_blank',
								type : "hls",
								preload : "none",
								primary : "html5",
								hlshtml : true,
								withCredentials : classObj.isVod2Secure,
								image : client_logoimg_cdnurl,
								logo : {
									file : classObj.logoUrl,
									position : 'top-left',
									margin : '4'
								},
								skin : {
									name : 'toprankers',
								}
							});
		
							jwplayer(classObj.video2InPlay).on('error', function() {
								console.log('vod2 error');
				
								var classObj = LvClass.getObj();
								jwplayer(classObj.video2InPlay).load({
									file : "https://youtu.be/16xzzamaunk",
									title : classObj.url,
									image : "http://www.text2image.com/user_images/text2image_D19375_20171124_064135.jpg"
								});
								jwplayer(classObj.video2InPlay).play();
				
							});
							classObj.videoType = LiveClassesType["VOD"];
							classObj.BindEventsAfterSetup();
							classObj.BindSeek(false);
						},
						errorClb : function(){
							
						}
					});
				}else{
					classObj.videoType = LiveClassesType["VOD"];
					classObj.BindEventsAfterSetup();
				}
			},
			errorClb : function() {
				console.log("Internal error!");
			}
		});
	});
};
LvClass.prototype.PlayVideoJSVOD = function()
{	
	$("#"+this.videoContainer+" .LvClassPrview").addClass("LoadingVedio");
	liveclassesitemHelper.LoadJS("videojs/video-tr.js", function()
	{
		liveclassesitemHelper.LoadJS("videojs/videojs-hlsjs-plugin.js", function()
		{
			liveclassesitemHelper.LoadJS("videojs/videojs-contrib-quality-levels.js", function()
			{
				liveclassesitemHelper.LoadJS("videojs/videojs-http-source-selector-tr-v3.js", function()
				{
					var classObj = LvClass.getObj();
					if($('#'+classObj.video1InPlay).length == 0)
					{
						$('<div class="lvVidCornerToggle topRightCornerVid wrapperLv" data-orientation="1"><video id="'+classObj.video1InPlay+'" class="switch_1 video-js vjs_video_3 vjs-videotype-vod"></div></div>').appendTo("#"+classObj.videoContainer);
					}
					videojs(classObj.video1InPlay,{
						controls: true,
						autoplay: true,			
						width: "100%",
						loop: false,
						muted: false,
						preload: "none",
						responsive: true,
						playbackRates: [0.75, 1, 1.25, 1.5, 2],	
						html5: {
								hlsjsConfig: {
				                  debug: false,
				                  xhrSetup: function(xhr, url) {
										xhr.withCredentials = classObj.vjsVod1Secure; // do send cookies
									}
				               	},
							    hls: {
							      overrideNative: !videojs.browser.IS_SAFARI,
						      	  enableLowInitialPlaylist: true,
						      	  cacheEncryptionKeys: true
							    }
							 },
						plugins: {
					      httpSourceSelector:
					      {
					        default: 'auto',
					        hlsjs: true
					      }
					    },	
						controlBar: {
						  volumePanel: {
						    inline: false,
						    vertical: true
						  }
						}			
					});
					classObj.setCookieCDN(classObj.vod1);
					tr$.ajax({
						mod : "liveclasses",
						ack : "playvideojsvod",
						additionalParams : {
							stream : classObj.vod1
					},
					successClb : function(response) {
							try
							{
								var reply = response;
								var classObj = LvClass.getObj(); 
								videojs(classObj.video1InPlay).src(reply);
							}
							catch(e)
							{
								console.log("error", e);
							}
						},
					});
					classObj.vjsBindSeek(true);
					//load secondary video
					if(classObj.vod2 !="" && classObj.vod2 != null){
						if($('#'+classObj.video2InPlay).length == 0)
						{
							$('<div class="lvVidCornerToggle lvVidCorner topRightCornerVid wrapperLv" data-orientation="1"><video id='+classObj.video2InPlay+' class="switch_2 video-js vjs_video_3 vjs-videotype-vod"></video></div>').appendTo("#"+classObj.videoContainer);
						}
						videojs(classObj.video2InPlay,{
							controls: true,
							autoplay: true,
							width: "100%",
							loop: false,
							muted: false,
							preload: "none",
							responsive: true,
							playbackRates: [0.75, 1, 1.25, 1.5, 2],
							html5: {
									hlsjsConfig: {
					                  debug: false,
					                  xhrSetup: function(xhr, url) {
											xhr.withCredentials = classObj.vjsVod2Secure; // do send cookies
										}
					               	},
								    hls: {
								      overrideNative: !videojs.browser.IS_SAFARI,
							      	  enableLowInitialPlaylist: true,
							      	  cacheEncryptionKeys: true
								    }
								 },
					 		plugins: {
					    		  		httpSourceSelector:
									    {
									        default: 'auto',
									        hlsjs: true
									    }
						    },			
							controlBar: {
							  volumePanel: {
							    inline: false,
							    vertical: true
							  }			    
							}			
						});
						classObj.setCookieCDN(classObj.vod2);
						tr$.ajax({
								mod : "liveclasses",
								ack : "playvideojsvod",
								additionalParams : {
									stream : classObj.vod2
								},
								successClb : function(response) {
								try
								{
									var reply = response;
									var classObj = LvClass.getObj(); 
									videojs(classObj.video2InPlay).src(reply);
								}
								catch(e)
								{
									console.log("error", e);
								}
							},
						});
						classObj.vjsBindSeek(false);
					}
					classObj.videoType = LiveClassesType["VOD"];
					classObj.VideoJSBindEventsAfterSetup();
				});
			});	
		});	
	});
};
LvClass.prototype.setCookieCDN = function (stream) {
  	var img = document.createElement('img');
  	var classObj = LvClass.getObj();
  	img.src = classObj.signedCookieHost + "/?route=common/ajax&mod=liveclasses&ack=getcustompolicysignedcookiecdn&stream="+encodeURIComponent(stream);
	img.style.display = "none";
	document.querySelector('body').appendChild(img);
	console.log(img.src);
};

LvClass.prototype.PlayLive = function()
{
	$("#"+this.videoContainer+" .LvClassPrview").addClass("LoadingVedio");
	liveclassesitemHelper.LoadJS("jwplayer8/jwplayer.js", function()
	{
		var classObj = LvClass.getObj();
		jwplayer.key = classObj.jwPlayerLicenseKey;
		if($('#'+classObj.video1InPlay).length == 0)
		{
			$('<div class="lvVidCornerToggle topRightCornerVid wrapperLv" data-orientation="1"><div id="'+classObj.video1InPlay+'" class="switch_1"></div></div>').appendTo("#"+classObj.videoContainer);
		}
		$.ajax({
            url: remoteServer + "/?route=common/ajax",
            type: "POST",
            data:{
                    mod: "liveclasses",
                    ack: "playlive",
                    data: {"id":classObj.stream1}
			},
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			complete: function(event)
			{
				var response = event.responseJSON;
			    if(response.result.state == "ok")
				{
					var classObj = LvClass.getObj();
					var streamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream1 + classObj.postFix;
			        
					jwplayer(classObj.video1InPlay).setup({
						file : streamUrl+"?salt="+response.data,
			            width : "100%",
			            aspectratio : "16:9",
			            autostart: "true",
			            primary: "html5",
			            hlshtml: "true",
			            mute: "false",
						image: client_logoimg_cdnurl,
						logo: {
							file: classObj.logoUrl,
							position: 'top-left',
							margin: '4'
						},
			            title: classObj.URL,
						stretching: "exactfit",
			            abouttext: "Ankalan Web Solutions Pvt Ltd",
			            aboutlink: "https://toprankers.com",
			            aboutlinktarget: '_blank',
			            skin: {
      						name: 'toprankers',
				    	}
					});
					jwplayer(classObj.video1InPlay).on('error', function(e) {
						var classObj = LvClass.getObj();
						classObj.vedioIsPlaying = false;
						jwplayer(classObj.video1InPlay).stop();
						
						//if video is not playing show status
						if(classObj.streamState == 0){
							$('[data-videoStreamStatus="live"]').css("display","table");
							$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> The class has not started yet. Please wait... <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh()'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
						}
						else if(e.message =="Cannot load M3U8: 404 Not Found" || e.message == "The live stream is either down or has ended" || e.message == "Cannot load M3U8: no level found in manifest"){
							$('[data-videoStreamStatus="live"]').css("display","table");
							if(classObj.endDate && (classObj.endDate != "0000-00-00 00:00:00" || classObj.streamState == 2)){
								$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Oops... Class is already ended at <strong>"+classObj.endDate+"</strong>. Please Wait... Video will be available soon.");
							}else{
								$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Network Instability Detected (Live Stream Down). <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh()'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
							}
						}
						else if(e.message == "Cannot load M3U8: Crossdomain access denied"){
							$('[data-videoStreamStatus="live"]').css("display","table");
							$('[data-videoStreamStatus="live"]').html("<span class='glyphicon glyphicon-alert'></span> Network Instability Detected - Please Check Your Internet Connection. <a onclick='LvClass.getObj().UpdateStreamStateAndRefresh()'>click here...<span class='glyphicon glyphicon-refresh'></span></a> to refresh");
						}
					});
					if(typeof classObj.stream2 != 'undefined' && classObj.stream2 != "" && classObj.stream2 != null)
					{
						$('<div class="lvVidCornerToggle lvVidCorner topRightCornerVid wrapperLv" data-orientation="1"><div id="'+classObj.video2InPlay+'" class="switch_2"></div></div>').appendTo("#"+classObj.videoContainer);
						$.ajax({
			              url: remoteServer + "/?route=common/ajax",
			              type: "POST",
			              data:{
			                mod: "liveclasses",
			                ack: "playlive",
			                data: {"id":classObj.stream2}
			              },
			              xhrFields : {
							 withCredentials : true
						  },
						  crossDomain : true,
			              complete: function(event)
			              {
			                response = event.responseJSON;
			                if(response.result.state == "ok")
			                {
			                	var classObj = LvClass.getObj();
			                  	var secstreamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream2 + classObj.postFix;

								jwplayer(classObj.video2InPlay).setup({
					                    file : secstreamUrl+"?salt="+response.data,
					                    width : "100%",
					                    aspectratio : "16:9",
					                    autostart: "true",
					                    primary: "html5",
					                    hlshtml: "true",
					                    mute: "true",
										image: client_logoimg_cdnurl,
										logo: {
											file: classObj.logoUrl,
											position: 'top-left',
											margin: '4'
										},		                      
					                    title: classObj.stream2,
					                    stretching: "exactfit",
					                    abouttext: "Ankalan Web Solutions Pvt Ltd",
					                    aboutlink: "https://toprankers.com",
					                    aboutlinktarget: '_blank',
					                    skin: {
				      						name: 'toprankers',
								    	}
				                  	});
				                  	jwplayer(classObj.video2InPlay).on('error', function() {
										var classObj = LvClass.getObj();
										classObj.vedioIsPlaying = false;
						 				jwplayer(classObj.video2InPlay).stop();
									});
			               		}
			               		classObj.videoType = LiveClassesType["Live"];    //
								classObj.BindEventsAfterSetup();
			          		}
			   			});
					}
					else
					{
						classObj.videoType = LiveClassesType["Live"];
						classObj.BindEventsAfterSetup();
					}
				}
			}
		});
	});
};
LvClass.prototype.PlayVideoJSLive = function()
{
	$("#"+this.videoContainer+" .LvClassPrview").addClass("LoadingVedio");
	liveclassesitemHelper.LoadJS("videojs/video-tr.js", function()
	{
		liveclassesitemHelper.LoadJS("videojs/videojs-hlsjs-plugin.js", function()
		{
			liveclassesitemHelper.LoadJS("videojs/videojs-contrib-quality-levels.js", function()
			{
				liveclassesitemHelper.LoadJS("videojs/videojs-http-source-selector-tr-v3.js",function()
				{
					var classObj = LvClass.getObj();	
					var tech ="html5";	
					if($('#'+classObj.video1InPlay).length == 0)
					{
						$('<div class="lvVidCornerToggle topRightCornerVid wrapperLv" data-orientation="1"><video id="'+classObj.video1InPlay+'" class="switch_1 video-js vjs_video_3 vjs-videotype-live"></video></div>').appendTo("#"+classObj.videoContainer);
					}
					videojs(classObj.video1InPlay,{
						controls: true,
						autoplay: true,			
						width: "100%",
						loop: false,
						muted: false,
						preload: "none",						
						responsive: true,
						techOrder: [tech],
						html5: {
							hlsjsConfig: {
			                  debug: false,
			                  xhrSetup: function(xhr, url) {
									xhr.withCredentials = classObj.secureLiveUsingCookie; // do send cookies
								}
			               	},
						    hls: {
						      overrideNative: !videojs.browser.IS_SAFARI,
					      	  enableLowInitialPlaylist: true,
					      	  cacheEncryptionKeys: true
						    }
						 },
						 plugins: {
						      httpSourceSelector:
						      {
						        default: 'auto',
						        hlsjs: true
						      }
						 },
						controlBar: {
						    volumePanel: {
						      inline: false,
						      vertical: true
						    }			    
						  }			
					});
					var livecdnurl1 = classObj.host + "/" + classObj.app + "/" + classObj.stream1 + classObj.postFix;
					if(classObj.secureLiveUsingCookie == true){
						classObj.setCookieCDN(livecdnurl1);
					}
					$.ajax({
						  url: remoteServer + "/?route=common/ajax",
						  type: "POST",
						  data:{
							mod: "liveclasses",
							ack: "playlive",
							data: {"id":classObj.stream1},
							"isLiveCDN": classObj.isLiveCDN,
							"stream": livecdnurl1,
						  },
						  xhrFields : {
							withCredentials : true
						  },
						  crossDomain : true,
						  complete: function(event)
						  {
							try
							{
								var response = event.responseJSON;
								var classObj = LvClass.getObj();
								if(classObj.isLiveCDN != "1"){
									if(response.result.state == "ok")
									{
										var streamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream1 + classObj.postFix + "?salt="+response.data;
										videojs(classObj.video1InPlay).src([{												
												src: streamUrl
										}]);
									}
								}
								else{
										videojs(classObj.video1InPlay).src(response);
									}					
							}
							catch(e)
							{
								console.log("error", e);
							}
						},
					});
					if(classObj.stream2 != "" && classObj.stream2 != null){
						$('<div class="lvVidCornerToggle lvVidCorner topRightCornerVid wrapperLv" data-orientation="1"><video id="'+classObj.video2InPlay+'" class="switch_2 video-js vjs_video_3 vjs-videotype-live"></video></div>').appendTo("#"+classObj.videoContainer);
						videojs(classObj.video2InPlay,{
							controls: true,
							autoplay: true,
							width: "100%",
							loop: false,
							muted: false,
							preload: "none",				
							responsive: true,
							techOrder: [tech],
							html5: {
								hlsjsConfig: {
				                  debug: false,
				                  xhrSetup: function(xhr, url) {
										xhr.withCredentials = classObj.secureLiveUsingCookie; // do send cookies
									}
				               	},
							    hls: {
							      overrideNative: !videojs.browser.IS_SAFARI,
						      	  enableLowInitialPlaylist: true,
						      	  cacheEncryptionKeys: true
							    }
							 },
							 plugins: {
						      httpSourceSelector:
						      {
						        default: 'auto',
						        hlsjs: true
						      }
						 },
							controlBar: {
							    volumePanel: {
							      inline: false,
							      vertical: true
							    }			    
							  }			
						});
						var livecdnurl2 = classObj.host + "/" + classObj.app + "/" + classObj.stream2 + classObj.postFix;
						if(classObj.secureLiveUsingCookie == true){
							classObj.setCookieCDN(livecdnurl2);
						}
						$.ajax({
							  url: remoteServer + "/?route=common/ajax",
							  type: "POST",
							  data:{
								mod: "liveclasses",
								ack: "playlive",
								data: {"id":classObj.stream2},
								"isLiveCDN": classObj.isLiveCDN,
								"stream": livecdnurl2,
							  },
							  xhrFields : {
								withCredentials : true
							  },
							  complete: function(event)
							  {
								try
								{
									var response = event.responseJSON;
									var classObj = LvClass.getObj();
									if(classObj.isLiveCDN != "1"){
										if(response.result.state == "ok")
										{
											var streamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream2 + classObj.postFix + "?salt="+response.data;
												videojs(classObj.video2InPlay).src([{												
													src: streamUrl
											}]);
										}
									}
									else{
									videojs(classObj.video2InPlay).src(response);
								}
								}
								catch(e)
								{
									console.log("error", e);
								}
							},
						});
					}
					var classObj = LvClass.getObj();
					classObj.videoType = LiveClassesType["Live"];
					classObj.VideoJSBindEventsAfterSetup();
				});
			});
		});
	});
};

LvClass.prototype.UpdateStreamStateAndRefresh = function(playVOD, e)
{
	var classObj = LvClass.getObj();
	var targetEl = e.target || e;
	$(targetEl).addClass('refresh');
	$('[data-videoStreamStatus="live"] a').addClass('refresh');
	$.ajax({
		type : "POST",
		url: remoteServer + "/?route=common/ajax",
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		data : {
				mod : "liveclasses",
				ack : "getVideoDatabyClassId",
				classId: classObj.classId,
			},
			complete : function(event) {
			try
			{
				var reply = event.responseJSON;
				var classObj = LvClass.getObj();
				classObj.endDate = reply.data.endDate;
				classObj.streamState = reply.data.state;
				classObj.isLiveCDN = (typeof reply.data.isLiveCDN !== "undefined")?reply.data.isLiveCDN:"0";
				classObj.secureLiveUsingCookie = (typeof reply.data.secureLiveUsingCookie !== "undefined")?reply.data.secureLiveUsingCookie:false;
				if(typeof playVOD != "undefined" && playVOD == true){
					setTimeout(function(){
						$(targetEl).removeClass('refresh');
					},500);
					if(reply.data.primPlaybackUrl != null && reply.data.primPlaybackUrl != "")
					{
						classObj.vod1 = reply.data.primPlaybackUrl;					
						classObj.vod2 = reply.data.secPlaybackUrl;
						classObj.vjsVod1Secure = reply.data.vjsVod1Secure;
						classObj.vjsVod2Secure = reply.data.vjsVod2Secure;
						classObj.PlayVideoJSVOD();
					}
				}else{
					classObj.RefreshLive();
				}
			}
			catch(e)
			{
				//console.log("error", e);
				$(targetEl).removeClass('refresh');
			}
		},
	});	
};

LvClass.prototype.RefreshLive = function()
{
	var classObj = LvClass.getObj();
	if(typeof(jwplayer) == "undefined"){ //need to remove this if condition if we remove hlsjs plugin and below code should update ad playvideojs block code
		videojs(classObj.video1InPlay).dispose();
		classObj.classInitated = false;
		$('[data-videoStreamStatus="live"] a').removeClass('refresh');
		$('[data-videoStreamStatus="live"]').css("display","none");
		classObj.PlayVideoJSLive();
		return;
	}
	$.ajax({
        url: remoteServer + "/?route=common/ajax",
        type: "POST",
        xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
        data:{
            mod: "liveclasses",
            ack: "playlive",
            data: {"id":classObj.stream1}
		},
		complete: function(event)
		{
		   try{
				var response = event.responseJSON;
			    if(response.result.state == "ok")
				{
					var classObj = LvClass.getObj();
					var streamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream1 + classObj.postFix +"?salt="+response.data;
					if(typeof(jwplayer) != "undefined"){
						jwplayer(classObj.video1InPlay).load({
							file : streamUrl
						});
					}else{
						videojs(classObj.video1InPlay).src({
							src : streamUrl
						});
					}
					$('[data-videoStreamStatus="live"] a').removeClass('refresh');
					if(classObj.stream2 != "" && classObj.stream2 != null)
					{			
						$.ajax({
			              url: remoteServer + "/?route=common/ajax",
			              type: "POST",
			              xhrFields : {
							  withCredentials : true
						  },
						  crossDomain : true,
			              data:{
			                mod: "liveclasses",
			                ack: "playlive",
							data: {"id":classObj.stream2}
			              },
			              complete: function(event)
			              {
			                response = event.responseJSON;
			                if(response.result.state == "ok")
			                {
			                	var classObj = LvClass.getObj();
			                	$('[data-videoStreamStatus="live"] a').removeClass('refresh');
			                  	var secstreamUrl = classObj.host + "/" + classObj.app + "/" + classObj.stream2 + classObj.postFix;
			                  	if(typeof(jwplayer) != "undefined"){
									jwplayer(classObj.video2InPlay).load({
					                    file : secstreamUrl+"?salt="+response.data
				                  	});
				                  	jwplayer(classObj.video1InPlay).play();
				                  }
				                  else{
				                  	videojs(classObj.video1InPlay).src({
										src : secstreamUrl
									});
									$('[data-videoStreamStatus="live"]').css("display","none");
									videojs(classObj.video1InPlay).play();
				                  }
			               	}
			          	  },
			   			});
					}
					else{
						$('[data-videoStreamStatus="live"] a').removeClass('refresh');
						if(typeof(jwplayer) != "undefined")
							jwplayer(classObj.video1InPlay).play();
						else{
							$('[data-videoStreamStatus="live"]').css("display","none");
							videojs(classObj.video1InPlay).play();
						}
					}
				}
				else{
					$('[data-videoStreamStatus="live"] a').removeClass('refresh');
				}
			}
			catch(e){
				$('[data-videoStreamStatus="live"] a').removeClass('refresh');
			}
		},
	});
};

//Helpers
function liveclassesitemHelper(){};
liveclassesitemHelper.LoadJS = function (src, callback) 
{
	var id = "JS_" + src.replace(/[^a-zA-Z0-9_]+/, "_").replace(".", "_");
	if (!document.getElementById(id)) {
    	var s = document.createElement('script');
		s.id = id;
		s.src = src;
    	s.async = "true";
		s.onreadystatechange = s.onload = function() {
			var state = s.readyState;
			if(typeof(callback) != 'undefined')
			{
				if (!callback.done && (!state || /loaded|complete/.test(state))) {
					callback.done = true;
					callback();
				}
			}
		};
		console.log(s);
		document.getElementsByTagName('head')[0].appendChild(s);
	}
	else
	{
		if(typeof callback !== 'undefined')
		{
			callback.done = true;
			callback();
		}
	}
};


function Chat()
{
	this.pinnedMsg = "Live Notes";
	this.chatInitiated = false;
	this.chat = null;
	this.adminUserIds = {1:0, 305:0, 124171:0, 101669:0, 1084392:0, 1512917:0, 1627808:0, 1538428:0, 399:0, 1970482:0, 2012286:0, 1828729:0, 1627808:0, 1984012:0,2023616:0,2048200:0,2068506:0,2327410:0,2327414:0 };
}
Chat.getObj = function()
{
	if(_chatObj == null)
	{
		_chatObj = new Chat();
		_chatObj.chatInitiated = false;
		_chatObj.chat = null;
		_chatObj.Init();
	}
	return _chatObj;
};
Chat.prototype.Init = function(){
	$.ajax({
		type : "POST",
		url : remoteServer+"/?route=common/ajax",
		data : {
				mod : "liveclasses",
				ack : "getChatConfig",
				classId: LvClass.getObj().classId,
			},
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			complete : function(event) {
			try
			{
				var reply = event.responseJSON;
				if(reply.result.state == "ok"){
					var chatObj = Chat.getObj();
					if(typeof reply.data.chatConfig.chatAdminIds != "undefined"){
						for(var id in reply.data.chatConfig.chatAdminIds){
							chatObj.adminUserIds[id] = 0;
						}
					}
					chatObj.chatChannelName = reply.data.chatConfig.chatChannelName;
					chatObj.config = reply.data.chatConfig.chatProject;
					chatObj.limitations = reply.data.chatConfig.limitations;
					chatObj.newCode = (typeof(reply.data.chatConfig.newCode) != "undefined")?reply.data.chatConfig.newCode:1;
					chatObj.InitiateChat();
				}
			}
			catch(e)
			{
				console.log("error", e);
			}
		}
	});
};
Chat.prototype.BindEvents = function()
{
	this.chatInitiated = true;
	$("#firechat-tab-content textarea").prop('maxlength', '120');
	
	this.chat.on("message-add", function(e, msg){
		var chatObj = Chat.getObj();
		if(msg.message == "Joined...")
		{
			chatObj.chat.deleteMessage(e, msg.id, function(){});
			return;
		} else if (msg.message.startsWith('note:'))
		{
			pinnedMsg = msg.message.replace('note:','');
    		$("#pinedMsg #pnMsg").replaceWith("<span id='pnMsg'>"+pinnedMsg+"</span>");
    		console.log(pinnedMsg);
		}
	});
	$('#firechat-tab-content').on('DOMNodeInserted', function(e) {
		if($(e.target).hasClass('message'))
		{
			var chatObj = Chat.getObj();
			var msgUserId = $(e.target).attr("data-user-id");
			 // user is not admin && msg not by admin && message not by self then delete
			 
			if(chatObj.adminUserIds.hasOwnProperty(UrlMgmt.getObj().userData.id) == false && chatObj.adminUserIds.hasOwnProperty(msgUserId) == false && UrlMgmt.getObj().userData.id != msgUserId)
			{
				$(e.target).remove();
			}
		}
	});
	$('#closeChat').unbind('click').bind('click', function() {
       $("#chatHere").toggle(400); 
	});
};

Chat.prototype.InitiateChat = function()
{
	var lvclass = LvClass.getObj();
	this.adminUserIds[lvclass.presenterId] = 0;
	if(UrlMgmt.getObj().userData.id <= 0 || lvclass.videoType == LiveClassesType["VOD"] && !lvclass.forceChat) 
	{
		return;
	}
	$('#chatHere').removeClass("hidechat");
	$('#chatHere .ChatLoader').removeClass("Hidden");
	liveclassesitemHelper.LoadJS("https://cdn.toprankers.net/firebase/firebase330.js", function()
	{
		liveclassesitemHelper.LoadJS("https://cdn.toprankers.net/firebase/firechat.min.js", function()
		{
			/*
			var config = {
							apiKey: "AIzaSyCoA8-JJqE6K9ZkNmy3Ka5ZB3GOOMpgp3s",
							authDomain: "testing-41544.firebaseapp.com",
							databaseURL: "https://testing-41544.firebaseio.com",
						  };*/
			var chatObj = Chat.getObj();
		   
			if (firebase.apps.length<1) {
			    firebase.initializeApp(chatObj.config);
			}
			var classObj = LvClass.getObj();
			var chatChannelName = chatObj.chatChannelName;
		    var chatUserId = "0";
		    var chatRef = firebase.database().ref(chatChannelName);
		    
		    var maxMessages = (typeof chatObj.limitations["numMaxMessages"] != "undefined")?chatObj.limitations["numMaxMessages"]:2000;  	
			var chatUI = new FirechatUI(chatRef, $('#chatHere .firechat-wrapper')[0],{ numMaxMessages: maxMessages});			
			for(var key in chatObj.limitations){
				chatUI[key] = chatObj.limitations[key];
			}
			if(chatObj.newCode != 0){
				chatObj.chat = chatUI._chat;
			}else{
				chatObj.chat = new Firechat(chatRef, { numMaxMessages: maxMessages});
			}
			
		  	firebase.auth().onAuthStateChanged(function(user) 
		  	{
		  		if(user) 
				{
					var chatUserName = UrlMgmt.getObj().userData.displayName;		
					var chatUserId = UrlMgmt.getObj().userData.id;
						
				 	if($("#chatTotalUser").length <= 0){
						$( ".firechat-dropdown-menu" ).prepend( "<div id='chatTotalUser'><span><span class='glyphicon glyphicon-user'></span>Live Users: <span id='usrCount'>0</span></span></div>" );
					}
					var chatObj = Chat.getObj();
					if(chatObj.adminUserIds.hasOwnProperty(UrlMgmt.getObj().userData.id) == true){
						chatUserName = 'Admin';
					}
					chatObj.chat.setUser(chatUserId, chatUserName, function(user1){
						
						var chatObj = Chat.getObj();
					
						chatObj.chat.getRoomList(function(e){
							var roomId = "";
							$("#firechat .firechat-dropdown .btn.full.firechat-dropdown-toggle").html("<span class='icon user-group'></span>Active Users<span class='caret'></span>");
							var chatObj = Chat.getObj();
							$("#firechat-tabs").prepend("<div id='pinedMsg'><span class='glyphicon glyphicon-pushpin'></span><span id='pnMsg'>"+chatObj.pinnedMsg+"</span></div>");
							if(chatObj.newCode == 1){
								var createdTime = 0;
								for(var i in e)
								{
									if(e[i]["name"] == chatChannelName && (createdTime == 0 || createdTime > e[i]["createdAt"]))
									{
										roomId = e[i]["id"];
										createdTime = e[i]["createdAt"];
									}
								}
							}else if(chatObj.newCode == 2){
								var createdTime = 0;
								for(var i in e)
								{
									if(e[i]["name"] == chatChannelName && (createdTime == 0 || createdTime < e[i]["createdAt"]))
									{
										roomId = e[i]["id"];
										createdTime = e[i]["createdAt"];
									}
								}
							}else{
								for(var i in e)
								{
									if(e[i]["name"] == chatChannelName)
									{
										roomId = e[i]["id"];
										break;
									}
								}
							}
							if(roomId == "")
							{
								
								chatObj.chat.createRoom(chatChannelName, "public", function(roomIdFromCaht) 
								{
									var chatObj = Chat.getObj();
									
									chatObj.chat.enterRoom(roomIdFromCaht);
									chatObj.chat.sendMessage(roomIdFromCaht, "Chat room created..", "default", function(){
										var chatObj = Chat.getObj();
										if(chatObj.newCode == 0)
											chatUI.setUser(chatUserId, chatUserName);
										$('#chatHere .firechat-wrapper').removeClass("Hidden");
										$('#chatHere .ChatLoader').addClass("Hidden");										
										chatObj.BindEvents();
									});
								});
							}
							else
							{
								
								chatObj.chat.enterRoom(roomId);
								chatObj.chat.sendMessage(roomId, "Joined...", "default", function()
								{
									var chatObj = Chat.getObj();
									if(chatObj.newCode == 0)
										chatUI.setUser(chatUserId, chatUserName);
									$('#chatHere .firechat-wrapper').removeClass("Hidden");
									$('#chatHere .ChatLoader').addClass("Hidden");
									chatObj.BindEvents();
								});
							}
						});
					});
				} 
				else 
				{
		      		firebase.auth().signInAnonymously().catch(function(error) {
		        		console.log("Error signing user in anonymously:", error);
		      		});
		    	}
		   });
		});
	});
};

/*
$(document).unbind().bind('webkitfullscreenchange', function(){
	var state = ((typeof document.webkitIsFullScreen !== 'undefined' && document.webkitIsFullScreen) || 
    			(typeof document.isFullScreen !== 'undefined' && document.isFullScreen));
	if(!state && !this.isfullscreen)
	{ 
		var cancelFunc = (document.cancelFullScreen || document.webkitCancelFullScreen);
		cancelFunc.call(document);
    	$(".PlayContainer").removeClass("InFullScreen");
	}
	else{
		this.isfullscreen = false;	 
	}

});
*/
function showPlayIcon(){
	  var classObj = LvClass.getObj();
	  classObj.show_playIcon1 = true;
	  classObj.show_playIcon2 = true;
	  $('.vjs-tr-forward').removeClass('vjs-fade-out');
	  $('.vjs-tr-playpause').removeClass('vjs-fade-out');
	  $('.vjs-tr-rewind').removeClass('vjs-fade-out');
	  $('.vjs-text-track-display').removeClass('vjs-delay-black-out');
	  $('.vjs-text-track-display').addClass('vjs-delay-black-out1');
	  $(".vjs-btnHolder-player2").removeClass('hidebtns');
	  $(".vjs-btnHolder-player1").removeClass('hidebtns');
	  $(".vjs-text-track-display").removeClass('removeopacity');
	  classObj.hidebtns = setTimeout(function()
        {
        	  clearInterval(classObj.hidebtns);
        	  $('.vjs-tr-forward').addClass('vjs-fade-out');
			  $('.vjs-tr-playpause').addClass('vjs-fade-out');
			  $('.vjs-tr-rewind').addClass('vjs-fade-out');
			  $('.vjs-text-track-display').addClass('vjs-delay-black-out');
			  $('.vjs-text-track-display').removeClass('vjs-delay-black-out1');
        }, 2.5);
}