/* Voucher Code */
function on_default_redeem_click(btn_ele)
{
	var btn = $(btn_ele); 
	if(!btn.hasClass('loading'))
	{
		btn.addClass('loading');
		CouponRedeem($('#redeemVoucher-modal input').val(),function(success,reply){
			var result = btn.parent().siblings(".modal-body");
			result.find(".result").text((success?"Congratulations! ":"Sorry! ")+reply);
			result.find(".result").removeClass('success').removeClass('fail').addClass(success?'success':'fail');
			btn.removeClass('loading');
		});
	}
}
function CouponRedeem(code,callbackc)
{	
	
	tr$.ajax({
		mod: "ecomm",
		ack: "couponredeem",
		additionalParams:{
			code : code
		},
		successClb: function(reply, obj){
           try
           {
			  	if(reply.result.state == "ok")
			   	{
					if(typeof callbackc == "function")
						callbackc.call(null,reply.data.state,reply.data.msg);
				}
			   else
			   {
					if(typeof callbackc == "function")
						callbackc.call(null,false,reply.result.meta);
				}
           }
           catch(e)
           {
				if(typeof reply == "undefined")
				{
					callbackc.call(null,false,"Please connect to network to Redeem Voucher");
				}
				else if(typeof callbackc == "function")
				{
					callbackc.call(null,false,"Unexpected system error!\n"+e.message+"\n"+JSON.stringify(event.responseJSON));
				}
					
		   }
		}
	}, this);		
}
function claimWelcomeGift(){
	tr$.ajax({
		mod : "ecomm",
		ack : "couponredeem",
		additionalParams : {
			code : "APPWELCOMEGIFT",
		},
		successClb : function(reply, obj) {
			try
			{
				var userId = 0;
				if(typeof UrlMgmt.getObj().userData.id != 'undefined' && UrlMgmt.getObj().userData.id > 0){
					userId = UrlMgmt.getObj().userData.id;	
				}
				if (reply.result.state == "ok" && reply.data.state == true) {
					tr$.alert("Welcome Gift Claimedl!");
					
					//open profile
					UrlMgmt.getObj().Route({
					    route: 'common/profile&id='+userId,
					    needData: true,
					    offlineAllowed: true
					});
				}
				else if(reply.data.user_usage_count == 1){
					tr$.alert("<p class='errorMsg'>Welcome Gift Already Claimed!<p>");
					UrlMgmt.getObj().ClearActionStack();
					UrlMgmt.getObj().Route({
					    route: 'common/profile&id='+userId,
					    needData: true,
					    offlineAllowed: true
					});
					//UrlMgmt.getObj().Route({route: "common/home", needData: true, offlineAllowed: true});
				}
				else if(typeof reply.result.meta == "string"){
					tr$.alert(reply.result.meta);
				}
			}
			catch(e) {
				if(typeof reply == "undefined")
				{
					tr$.alert("Network Error");
				}
			}
		}
	}, this);
}
function checkWelcomeGift(showWelcomeGift){
	
	tr$.ajax({
		mod : "tr2app",
		ack : "welcomegiftcheck",
		additionalParams : {
			couponcode : "APPWELCOMEGIFT",
		},
		successClb : function(reply, obj) {
			try
			{
				if(reply.data == "notclaimed" && typeof showWelcomeGift === 'function')
				{
					showWelcomeGift();
				}
			}
			catch(e) {
				console.log(e);
			}
		}
	}, this);
}