var appcurrentaffairsController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	//this.refresh = true;
	
    var today = new Date();
    this.bucketId = 1267;
    this.tags = {};
    this.yearIndex =[];
    this.selectedMonth = 0;
    this.monthHash = [];
    this.monthHashTime = [];
    this.monthHashFileError = [];
    this.monthHashAjaxError = [];
    this.topics = [];
    this.topicshFileError = [];
    this.topicsAjaxError  = [];
    this.currentIndex = 0;
    this.calView = null;
    this.listView = null;
    this.topiclist = {};
    this.lastLink = null;
    this.current_scroll_view = null;
    this.firstrun = true;
   // this.viewTitle = viewTitle;
    this.blogLang = TestLanguageType.Str[0];
   // this.domain = domain;
    this.topiclistview = {};
    this.selectedTags = [];
    this.detailsDom = null;
    this.updateTagDBTimer=null;
};
appcurrentaffairsController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'News', true, false, false);
};
appcurrentaffairsController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	if(typeof this.id != 'undefined' && this.id > 0){
		this.bucketId = this.id;
	}
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader(false);
	this.SetLayout();
	if(typeof this.viewTitle!="undefined")
	{
		$(this.dom).find(".caption").html(this.viewTitle);
	}
	  
	this.listView = this.dom;
    $(".calendarbtn").click(function(){
    	$(this).css("pointer-events","none");
    	UrlMgmt.getObj().Route({route: 'app/currentaffairscalendar', needData: false}, function(action){
    		this.calView = action.controler.dom;
    		this.renderCal();
      	}.bind(this));
        setTimeout(function(){$(this).css("pointer-events","auto");}.bind(this),300);
   }.bind(this));
    
    this.dom.find(".btn-menu").click(function(){
    	$(this).css("pointer-events","none");
        	this.listView = view;
        	monthIndex = this.yearIndex[this.selectedMonth];
        	this.renderMonthly();
        	this.LoadTopicList(monthIndex);
        setTimeout(function(){$(this).css("pointer-events","auto");}.bind(this),300);
    }.bind(this));
    
    readFromCache("ca-"+this.bucketId+"-tags",
        function(data){
            this.obj.tags=data;
        }.bind({obj:this}),
        function(fileName){/*do nothing*/});

    this.current_scroll_view = $("#ca_first");

    //Enable swiping...
    if(this.detailsDom != null){
    		this.detailsDom.swipe( {
	        swipeLeft:function(event, direction, distance, duration, fingerCount) {
	            this.switchTopic(-1);  
	        }.bind(this),
	        swipeRight:function(event, direction, distance, duration, fingerCount) {
	            this.switchTopic(+1);  
	        }.bind(this),
	        //Default is 75px, set to 0 for demo so any distance triggers swipe
	        //threshold:0
	      });
	    }
    this.loadYear();
    this.BindEvent();
    this.renderFilter();
    urlMgmt.removeLoader(); 
};
appcurrentaffairsController.prototype.Events = function()
{
	$(".calendarbtn").unbind().bind('click', function(){
    	UrlMgmt.getObj().PopView(function(){
    		UrlMgmt.getObj().Route({route: 'app/currentaffairscalendar', needData: false}, function(action){
    			this.calView = action.controler.dom;
    			this.renderCal();
      		}.bind(this));
    	}.bind(this));
    	setTimeout(function(){$(this).css("pointer-events","auto");}.bind(this),300);
    }.bind(this));
    
    this.dom.find(".btn-menu").click(function(){
    	$(this.dom).remove();
    	monthIndex = this.yearIndex[this.selectedMonth];
        $(this.listView).removeClass('left').removeClass('right');
        $(this.dom).addClass('right').addClass('right');	
    }.bind(this));
};
appcurrentaffairsController.prototype.updateTagDB = function(){
	// Delay update tags.
	if(this.updateTagDBTimer)
	{
		clearTimeout(this.updateTagDBTimer);
	}
	this.updateTagDBTimer = setTimeout(function(){
	    this.updateTagDBTimer = null;
	    readFromCache("ca-"+this.bucketId+"-tags",
	        function(data){
	        	var dirty = false;
	        	var tempDataObj = data;
	        	/* Merge Tags */
	        	for(var i in this.obj.tags)
	        	{
	        		if(!(typeof tempDataObj[i] != "undefined" && tempDataObj[i] == this.obj.tags[i]))
	        		{
		        		tempDataObj[i] = this.obj.tags[i];
	        			dirty = true;
	        		}
	        	}
	        	if(dirty)
	        	{
					writeToCache("ca-"+this.obj.bucketId+"-tags",tempDataObj,function(fileName){/*do nothing*/});
	        	}
	        }.bind({obj:this}),
	        function(fileName){
				writeToCache("ca-"+this.obj.bucketId+"-tags",this.obj.tags,function(fileName){/*do nothing*/});	        	
	        }.bind({obj:this}));		
	}.bind(this),1000);
};
appcurrentaffairsController.prototype.BindEvent = function()
{
	$("#switchTopicLang").unbind("click").bind("click", this, function(e){
		e.data.blogLang = $(this).text();
		var lang = e.data.ChangeBlogLanguage();
		$(this).text(lang);
		e.data.ChangeBlog(lang, e.data.blogLang);
	}); 
	
	if(typeof this.viewTitle!="undefined")
	{
		$(".switchLangDiv").attr("viewtitle",this.viewTitle);
	}
	this.current_scroll_view.find(".TRPrivate a").on('click',this,function(e){
  		e.preventDefault();
  		window.open($(this).attr('href'),"_system");
    });

       //Enable swiping...
       if(this.detailsDom != null){
    		this.detailsDom.swipe( {
		        swipeLeft:function(event, direction, distance, duration, fingerCount) {
		            this.switchTopic(-1);  
		        }.bind(this),
		        swipeRight:function(event, direction, distance, duration, fingerCount) {
		            this.switchTopic(+1);  
		        }.bind(this),
		        //Default is 75px, set to 0 for demo so any distance triggers swipe
		        //threshold:0
		      });
		}
      
    $('.TopicList').unbind("click").bind("click",this, function(e){
    	e.data.currentIndex =  $(this).attr('index');
    	UrlMgmt.getObj().Route({route: 'app/currentaffairsdetail', needData: false}, function(action){
    		action.controler.parent = this.data;
    		var t = e.data; 
    		t.view = action.controler.dom;
    		this.data.detailsDom = action.controler.dom;
    		t.currentIndex = e.data.currentIndex;
    		t.current_scroll_view = $("#ca_first");
    		t.loadTopic();
      	}.bind({data:e.data}));
    	
    	setTimeout(function(){$(this.listView).css("pointer-events","auto");}.bind(this),300);
		return;
    });
    $(".mthlst").unbind("click").bind("click",this, function(e){
    	$(".mthlst").find('li').removeClass("active");
    	var mInd = $(this).attr('mInd'); 
    	var monthIndex = $(this).attr('monthindex');
    	UrlMgmt.getObj().showLoader(false);
    	e.data.switchMonths(monthIndex,mInd);
    });
};
appcurrentaffairsController.prototype.ChangeBlogLanguage = function()
{
	return (this.blogLang == TestLanguageType.Str[0])?TestLanguageType.Str[1]:TestLanguageType.Str[0];
};
appcurrentaffairsController.prototype.ChangeBlog = function(oldLang, newLang)
{
	$(".ca-scroll-view").each(function(e, data){
		if($(".discription .blog").length !=0 ){
			var title = $(data).find("."+this.newLang.toLowerCase()+"-title").text();
			if(title.length){
				$(data).find("."+this.newLang.toLowerCase()+"-content").removeClass('Hidden');
				if($(data).find(".pic"+this.newLang).length != 0)
				{
					$(data).find(".pic"+this.newLang).removeClass("Hidden");
					$(data).find(".pic"+this.oldLang).addClass("Hidden");
				}
				$(data).find("."+this.oldLang.toLowerCase()+"-content").addClass('Hidden');
				$(data).find(".title").text(title);
			}
		}
	}.bind({oldLang:oldLang, newLang:newLang}));
};
appcurrentaffairsController.prototype.loadYear = function()
{
    /*this.current_scroll_view.html('<div class="Loader">'+
            '<img src="img/loader.svg">'+
            '<div class="alert alert-info">'+
                '<strong>Loading!</strong>'+
            '</div>'+
        '</div>');    
    $(".cal-loader").html('<img src="img/loader.svg"><div class="alert alert-info"><strong>Loading!</strong></div>').show();*/
   //UrlMgmt.getObj().showLoader(false);

    readFromCache("ca-"+this.bucketId+"-year-index",
        function(data){
            this.yearIndex=data.filter(function(v){return v.trim() != '' && v.trim() != '0-0';});
            this.loadRecentDate();
            this.loadMonth(0);
        }.bind(this),
        function(fileName){
        }.bind(this));
    
    $.ajax({
        url: remoteServer + "/ajax",
        type: 'POST',
        data:{
            mod: "currentaffairs",
            ack: "getyearindex",
            bucketId:this.bucketId
        },
        xhrFields: {
           withCredentials: true
        },
        crossDomain: true,
        context:this,
        timeout:20000,
        success: function(reply){
            if(reply.result.state == "ok")
            {
                if(reply.data.length == 0)
                {
                     $(this.current_scroll_view).html('<div class="alert alert-warning"><strong>No data available yet! Check again later.</strong></div>').show();
                     $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available yet! Check again later.</strong></div>').show();
                }
                else
                {
                    this.yearIndex=reply.data.filter(function(v){return v.trim() != '' && v.trim() != '0-0';});	
                    writeToCache("ca-"+this.bucketId+"-year-index",this.yearIndex);
                    this.loadRecentDate();				
					this.loadMonth(0);
                }
            }
            else
            {
                  $(this.current_scroll_view).html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
                  $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
            }
            
        },
        error : function(x,t,e){
              $(this.current_scroll_view).html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
              $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();        
        }
    });        
};
appcurrentaffairsController.prototype.loadMonth = function(n)
{
	if(this.yearIndex.length==0)
    {
        $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available yet! Check again later.</strong></div>').show();
        return;
    }
    /*this.current_scroll_view.html('<div class="Loader">'+
            '<img src="img/loader.svg">'+
            '<div class="alert alert-info">'+
                '<strong>Loading!</strong>'+
            '</div>'+
        '</div>');    
    $(".cal-loader").html('<img src="img/loader.svg"><div class="alert alert-info"><strong>Loading!</strong></div>').show();*/
   //UrlMgmt.getObj().showLoader(false);

    var monthIndex = this.yearIndex[this.selectedMonth];
    /* Cache for a min */
    if(typeof this.monthHashTime[monthIndex] == "undefined" || Date.now()-this.monthHashTime[monthIndex] > 60000 /* 60 Seconds*/)
    {
	    this.monthHashFileError[monthIndex] = false;
	    this.monthHashAjaxError[monthIndex] = false;
	    readFromCache("ca-"+this.bucketId+"-month-"+monthIndex,
	        function(data){
	            this.obj.monthHash[this.monthIndex]=data;
	            this.obj.renderMonth(this.monthIndex, this.dir);
	        }.bind({obj:this,dir:n,monthIndex:monthIndex}),
	        function(fileName){
	            this.obj.monthHashFileError[this.monthIndex]=true;
	        }.bind({obj:this,dir:n,monthIndex:monthIndex}));
    
	    $.ajax({
	        url: remoteServer + "/ajax",
	        type: 'POST',
	        data:{
	            mod: "currentaffairs",
	            ack: "getmonthindex",
	            bucketId:this.bucketId,
	            month: monthIndex
	        },
	        xhrFields: {
	           withCredentials: true
	        },
	        crossDomain: true,
	        context:{obj:this,dir:n,monthIndex:monthIndex}, 
	        success: function(reply){
	            if(reply.result.state == "ok")
	            {
	                if(reply.data.topics.length > 0)
	                {
	                    this.obj.firstrun = false;
	                    /* merge Tags */
	                    for(var n in reply.data.tags)
	                    {
		                    this.obj.tags[n] = reply.data.tags[n];
	                    }
	                    this.obj.updateTagDB();	   
	                    this.obj.monthHash[this.monthIndex] = reply.data.topics;
	                    this.obj.monthHashTime[this.monthIndex]=Date.now();
	                    delayWriteToCache("ca-"+this.obj.bucketId+"-month-"+this.monthIndex,reply.data.topics,function(fileName){/*do nothing*/});
	                    this.obj.renderMonth(this.monthIndex, this.dir);        
	                }
	            }
	            else
	            {
	                this.obj.monthHashAjaxError[this.monthIndex] = true;
	                this.obj.loadMonthError();
	            }
	            
	        },
	        error : function(x,t,e){
	            this.obj.monthHashAjaxError[this.monthIndex] = true;
	            this.obj.loadMonthError();
	        }
	    }); 	
    }
    else
    {
    	if(this.monthHashFileError[monthIndex] && this.monthHashAjaxError[monthIndex])
    	{
    		this.loadMonthError();
    	}
    	else
    	{
    		this.renderMonth(monthIndex, n);
    	}
    }
    UrlMgmt.getObj().removeLoader();
};
appcurrentaffairsController.prototype.loadRecentDate = function()
{
	this.monthHashFileError[this.yearIndex[this.selectedMonth]] = false;
    this.monthHashAjaxError[this.yearIndex[this.selectedMonth]] = false;

    readFromCache("ca-"+this.bucketId+"-recentmonth-"+this.yearIndex[this.selectedMonth],
        function(data){
        	this.obj.monthHash[this.obj.yearIndex[this.selectedMonth]]=data;
        	this.obj.renderMonth(this.obj.yearIndex[this.selectedMonth], 0);
        }.bind({obj:this,selectedMonth:this.selectedMonth}),
        function(fileName){
            this.obj.monthHashFileError[this.obj.yearIndex[this.selectedMonth]]=true;
       }.bind({obj:this,selectedMonth:this.selectedMonth}));   
	$.ajax({
        url: remoteServer + "/ajax",
        type: 'POST',
        data:{
            mod: "currentaffairs",
            ack: "getrecentdate",
            bucketId:this.bucketId
        },
        xhrFields: {
           withCredentials: true
        },
        crossDomain: true,
        context:this, 
        success: function(reply){
        	if(reply.result.state == "ok")
            {
            	if(Object.keys(reply.data).length > 0)
                {
                	this.firstrun = false;
                	this.monthHash[this.yearIndex[this.selectedMonth]] = reply.data.topics;
					delayWriteToCache("ca-"+this.bucketId+"-recentmonth-"+this.yearIndex[this.selectedMonth],this.monthHash[this.yearIndex[this.selectedMonth]]);
					this.renderMonth(this.yearIndex[this.selectedMonth], 0); 
                }
            }
            else
            {
                this.monthHashAjaxError[this.yearIndex[this.selectedMonth]] = true;
                this.loadMonthError();
            }
        },
        error : function(x,t,e){
            $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();        
        }
    });   
    monthIndex = this.yearIndex[this.selectedMonth];  	  
    this.renderMonthly();
};
appcurrentaffairsController.prototype.loadMonthError = function()
{
    if(this.monthHashAjaxError[this.yearIndex[this.selectedMonth]] && this.monthHashFileError[this.yearIndex[this.selectedMonth]])
    {
        this.renderTopicError();
        $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
    }    
};
appcurrentaffairsController.prototype.checkCurrentTopicFilter = function(){
	
	if(this.selectedTags.length > 0)
    {	// Check Tags    
    	if(
    		(typeof this.yearIndex != "undefined" ) &&
    		(typeof this.yearIndex[this.selectedMonth] != "undefined" ) &&
    		(typeof this.monthHash != "undefined" ) &&
    		(typeof this.monthHash[this.yearIndex[this.selectedMonth]] != "undefined" ) &&
    		(typeof this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex] != "undefined" ) 
    	)
    	{
	    	var topic = this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex];
			if(topic && typeof topic != "undefined" && typeof topic.tags != "undefined" && topic.tags.length>0)
			{
				for(var s in this.selectedTags)
	          	{
	          		if(topic.tags.indexOf(this.selectedTags[s])>=0)
	          		{	// Got it!
						return true;
	          		}
	          	}
			}    		
    	}
     	return false;
    }
	return true;	
};
appcurrentaffairsController.prototype.renderMonth = function(selectedMonthIndex, n)
{
	if(selectedMonthIndex != this.yearIndex[this.selectedMonth])
	{
		return;
	}
    if(this.currentIndex < 0 )
        this.currentIndex = this.monthHash[this.yearIndex[this.selectedMonth]].length - 1;
	if(n!=0)
	{
		if(!this.checkCurrentTopicFilter())
	    {	
	     	// Not Found! Keep Switching
	     	console.log("switchmonth");
	     	this.switchTopic(-n); // List is sorted in reverse
	     	return;
	    }
	}
    this.renderCal();    
    this.loadTopic();
};
appcurrentaffairsController.prototype.loadTopic = function()
{
    /*this.current_scroll_view.html('<div class="Loader">'+
            '<img src="img/loader.svg">'+
            '<div class="alert alert-info">'+
                '<strong>Loading!</strong>'+
            '</div>'+
        '</div>');*/
           
    //UrlMgmt.getObj().showLoader(false);
    var topicId=null;
    if(typeof this.monthHash[this.yearIndex[this.selectedMonth]] != "undefined" 
        && typeof this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex]!= "undefined"
        && typeof this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex].id!= "undefined"
    )
    {
        topicId=this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex].id;
    }
    
    readFromCache("ca-topic-"+topicId,
        function(data){
            this.obj.topics[this.topicId] = data;
            this.obj.renderTopic();
            this.obj.ChangeBlog(this.obj.ChangeBlogLanguage(),this.obj.blogLang);
            this.obj.BindEvent();
        }.bind({obj:this,topicId:topicId}),
        function(fileName){
            $.ajax({
                url: remoteServer + "/ajax",
                type: 'POST',
                data:{
                    mod: "currentaffairs",
                    ack: "get",
                    topicId:this.topicId
                },
                xhrFields: {
                   withCredentials: true
                },
                crossDomain: true,
                context:this, 
                success: function(reply){
                    if(reply.result.state == "ok")
                    {
                    	this.obj.topics[this.topicId] = reply.data;
                    	writeToCache("ca-topic-"+this.topicId,reply.data);
                        this.obj.renderTopic();
                        this.obj.ChangeBlog(this.obj.ChangeBlogLanguage(),this.obj.blogLang);
                        this.obj.BindEvent();
                    }
                    else
                    {
                        this.obj.renderTopicError();
                    }
                    UrlMgmt.getObj().removeLoader();
                    
                },
                error : function(x,t,e){
                     this.obj.renderTopicError();
                     UrlMgmt.getObj().removeLoader();
                }
            });       
        }.bind({obj:this,topicId:topicId}));
        this.BindEvent();  
        this.Events();
};
appcurrentaffairsController.prototype.renderTopicError = function()
{
    this.current_scroll_view.html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>');
    if(this.lastLink)
    {
        this.current_scroll_view.append("<button class='btn btn-link btn-topic-back '><span class='glyphicon glyphicon-triangle-left'></span> Back</button>");
    }
    this.current_scroll_view.find('.btn-topic-back').on('click',this,function(e){
        var t = e.data;
        t.selectedMonth = t.lastLink.selectedMonth;
        t.currentIndex = t.lastLink.currentIndex; 
        t.loadTopic();
    });
};
appcurrentaffairsController.prototype.switchMonths = function(selectedMonthIndex,mInd)
{
	this.selectedTags=[]; 
    this.renderFilter();
	this.selectedMonth = mInd;

	$(this.listView).find(".ca_listview").empty();
        this.monthHashFileError[selectedMonthIndex] = false;
	    this.monthHashAjaxError[selectedMonthIndex] = false;
	    readFromCache("ca-"+this.bucketId+"-month-"+selectedMonthIndex,
	        function(data){
	            this.obj.monthHash[this.monthIndex]=data;
	            this.obj.LoadTopicList(this.monthIndex);
	        }.bind({obj:this,monthIndex:selectedMonthIndex,selectedMonth:mInd}),
	        function(fileName){
	            this.obj.monthHashFileError[this.monthIndex]=true;
	        }.bind({obj:this,monthIndex:selectedMonthIndex,selectedMonth:mInd}));
    
	    $.ajax({
	        url: remoteServer + "/ajax",
	        type: 'POST',
	        data:{
	            mod: "currentaffairs",
	            ack: "getmonthindex",
	            bucketId:this.bucketId,
	            month: selectedMonthIndex
	        },
	        xhrFields: {
	           withCredentials: true
	        },
	        crossDomain: true,
	        context:{obj:this,monthIndex:selectedMonthIndex,selectedMonth:mInd}, 
	        success: function(reply){
	            if(reply.result.state == "ok")
	            {
	                if(reply.data.topics.length > 0)
	                {
	                    this.obj.firstrun = false;
	                    for(var n in reply.data.tags)
	                    {
		                    this.obj.tags[n] = reply.data.tags[n];
	                    }
	                    this.obj.updateTagDB();
	                    var alteredList = false;
	                    this.obj.monthHash[this.monthIndex] = reply.data.topics;
	                    
	                    for(var tt in reply.data.topics)
	                    {
	                    	var id = reply.data.topics[tt]["id"];
	            
	                    	if(!this.obj.topiclistview.hasOwnProperty(id))
							{
								this.obj.topiclistview[id] = {
										id:reply.data.topics[tt]["id"], 
										day:reply.data.topics[tt]["day"],
										tag:reply.data.topics[tt]["tags"],
									};
								alteredList = true;
							}
							
	                    }
	                    for(var n in reply.data.tags)
	                    {
		                    this.obj.tags[n] = reply.data.tags[n];
	                    }   
	                    this.obj.monthHashTime[this.monthIndex]=Date.now();
	                    delayWriteToCache("ca-"+this.obj.bucketId+"-month-"+this.monthIndex,reply.data.topics,function(fileName){/*do nothing*/});
	                    
	                    if(alteredList == true)
						{
							this.obj.listTopic(this.monthIndex);
						}
	                    else
	                    { this.obj.LoadTopicList(this.monthIndex); }
	                }
	            }
	            else
	            {
	                this.obj.monthHashAjaxError[this.monthIndex] = true;
	                $(".ca_warn").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
	            }
	            
	        },
	        error : function(x,t,e){
	            this.obj.monthHashAjaxError[this.monthIndex] = true;
	            $(".ca_warn").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
	        }
	    }); 
	    this.LoadTopicList(selectedMonthIndex);	    
};
appcurrentaffairsController.prototype.LoadTopicList  = function(monthIndex)
{
	//UrlMgmt.getObj().showLoader(false);
	readFromFile("listOftopics_1_"+this.bucketId+"_month_"+monthIndex+".json",function (data) {
		this.topiclist = data;
		if(Object.keys(this.topiclist).length == 0)
		{
			$('<div class="Loader"><p>No Topics has been loaded yet...</p></div>').appendTo($(this.listView));
		}
		else{
			UrlMgmt.getObj().removeLoader();
			this.renderTopicList();
			this.BindEvent();
		}
	}.bind(this),function (fileName, e){
		UrlMgmt.getObj().removeLoader();
		$(this.listView).find(".ca_listview").empty();
		this.listTopic(monthIndex);
    	this.BindEvent();
    	switch (e.code) {
	        case FileError.QUOTA_EXCEEDED_ERR:
	            alert('Storage quota exceeded');
	            break;
	        case FileError.SECURITY_ERR:
	            alert('Security error');
	            break;
	        case FileError.NOT_FOUND_ERR:
	        case FileError.INVALID_MODIFICATION_ERR:
	        case FileError.INVALID_STATE_ERR:       
	       		 break;
	        default:
	            alert('Unknown error');
	            break;
	    }
  }.bind(this),true);
};
appcurrentaffairsController.prototype.listTopic = function(monthIndex)
{ 
	if(!this.listView)
    {
        return;
    }
    var view = this.listView;
 	//UrlMgmt.getObj().showLoader(false);
 	$(this.listView).find(".ca_listview").empty();
    if(monthIndex == undefined)
    {
    	monthIndex = this.yearIndex[this.selectedMonth];	
    }
 	$.ajax({
	        url: remoteServer + "/ajax",
	        type: 'POST',
	        data:{
	            mod: "currentaffairs",
	            ack: "getmonthlytopic",
	            bucketId:this.bucketId,
	            month: monthIndex
	        },
	        xhrFields: {
	           withCredentials: true
	        },
	        crossDomain: true,
	        context:{obj:this,monthIndex:monthIndex}, 
	        success: function(reply){
	        	if(reply.result.state == "ok")
	            {
	            	 this.obj.topiclist = reply.data; 
	             	 this.obj.renderTopicList();
	            }
	            else
	            {
	            	$(".ca_warn").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
                    $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
	            }
	            writeToFile("listOftopics_1_"+this.obj.bucketId+"_month_"+monthIndex+".json", this.obj.topiclist, fileErrorHandler,function(){
						this.obj.LoadTopicList(monthIndex);	
				}.bind(this));
				UrlMgmt.getObj().removeLoader();
	           	this.obj.BindEvent();         
	        },
	        error : function(x,t,e){
	        	UrlMgmt.getObj().removeLoader();
				$(".ca_warn").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
				$(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
	        }
	    }); 
};
appcurrentaffairsController.prototype.renderMonthly  = function()
{    	
    $(this.listView).find(".monthlist1").empty();
    var months = ["","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
 	var monthlist = $('<div class="monthlist">'+
 					  // '<div class="navContainer prev"><x-icon class="itemNav">'+arrowWIcon+'</x-icon></div>'+
 					  '<ul class="monthtab ItemRow text-center" role="tablist"></ul>'+
 					  // '<div class="navContainer nxt"><x-icon class="itemNav">'+arrowEIcon+'</x-icon></div>'+
 					  '</div>'); 
 	for(var tt in this.yearIndex)
 	{
 		var active = '';
 		if(this.yearIndex[tt] == monthIndex)
 		{
 			active = "active";
 		}
 		if(monthIndex == undefined && tt == 0)
 		{
 			active = "active";
 		}
		var llist = $('<li role="presentation" mInd="'+tt+'" monthIndex="'+this.yearIndex[tt]+'" class="mthlst '+active+' ">'+
								'<a class="cs-lt" aria-controls="" role="tab" data-toggle="tab">'+
								'<span class="mn" style="font-size:13px;">'+months[this.yearIndex[tt].split('-')["1"]]+'</span>'+
								'<span class="yr" style="font-size:9px;">'+this.yearIndex[tt].split('-')["0"]+'</span>'+
								'</a>'+
								'</li>');
								 	  
		$(monthlist).find(".monthtab").append(llist);						
 	}
         
 	$(this.listView).find(".monthlist1").append(monthlist);
 	this.ValidateNavigator($(monthlist).find(".monthtab")[0]); 
 	this.BindNavEvents();
   
 	this.LoadTopicList(monthIndex);
};
appcurrentaffairsController.prototype.renderTopic = function()
{
	if(
        (typeof this.currentIndex == "undefined") ||
        (typeof this.monthHash[this.yearIndex[this.selectedMonth]] == "undefined") ||
        (typeof this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex] == "undefined") ||
        (typeof this.topics[this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex].id] == "undefined") 
    )
    {
        //console.log('Unexpected Error; please contact the support team.');
        return;
    }
    this.lastLink = {selectedMonth:this.selectedMonth,currentIndex:this.currentIndex};

	var hashItem = this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex];
    var topicId = hashItem.id;
    var data = this.topics[topicId];
    var topicDate = new Date(data.createdon * 1000);
    var date = $("<div class='date'>"+topicDate.toDateString()+"</div>");
    var title = $("<div class='title'>"+data.title+"</div>");
    
    var content = "";
    
    if(typeof data.content == "string")
    {
		content = data.content.replace("&nbsp;"," ").trim();
    }
    var discription = $("<div class='discription'></div>").html(content);
    var englishContent = $(discription).find(".english-content");
    var hindiContent = $(discription).find(".hindi-content");
    
    if($(englishContent).html() != "")
    {
    	i = englishContent.find("img");
    	if(i.length > 0)
    	{
    		if(i.eq(0).parent('a').length == 0)
    		{
    			var picEnglish = this.setBlogImage(i.eq(0),"picEnglish");	
    		}
    	}	
    }
    if($(hindiContent).html() != "")
    {
    	i = hindiContent.find("img");
    	if(i.length > 0)
    	{
    	  if(i.eq(0).parent('a').length == 0)
    	  {
    		 var picHindi = this.setBlogImage(i.eq(0),"picHindi");
    	  }	
    	}
    }
    if($(englishContent).length == 0 && $(hindiContent).length == 0)
    {
    	i = discription.find("img");
    	if(i.length > 0)
    	{
    		if(i.eq(0).parent('a').length == 0)
    	  	{
    			var pic = this.setBlogImage(i.eq(0));		
    	    }	
    	}
    } 
        
    var header = $("<div class='header'></div>");
    var navBtn = $("<div class='topic-nav pull-right'></div>");
    var prev = !(parseInt(this.currentIndex) + 1 >= this.monthHash[this.yearIndex[this.selectedMonth]].length && this.selectedMonth >= (this.yearIndex.length-1)); 
    var nex =  !(parseInt(this.currentIndex) - 1 < 0 && this.selectedMonth == 0);

    header.append(navBtn);
    if(prev)navBtn.append("<button class='btn btn-link btn-topic-prev '><span class='glyphicon glyphicon-triangle-left'></span> Previous</button>");
    if(prev && nex)navBtn.append(" | ");
    if(nex)navBtn.append("<button class='btn btn-link btn-topic-next'>Next <span class='glyphicon glyphicon-triangle-right'></span></button>");
    header.append(date);
    // Remove old Node
    var prev = $('#'+'ca_topic_'+topicId);
    if(prev.length > 0 && prev[0] != this.current_scroll_view[0])
    {
        prev.remove();
    }
    this.current_scroll_view.attr('id','ca_topic_'+topicId);
    this.current_scroll_view.html("").append(header).append(title);
    if(typeof picEnglish!= "undefined")
    	this.current_scroll_view.append(picEnglish);
    if(typeof picHindi!= "undefined")
   		this.current_scroll_view.append(picHindi);
   	if(typeof picEnglish== "undefined" && typeof picHindi== "undefined" && typeof pic!= "undefined")
   		this.current_scroll_view.append(pic);
   	   
    this.current_scroll_view.append(discription).append("<hr />");
    
	if(typeof hashItem.tags != "undefined" && hashItem.tags.length > 0)
	{
	    var strTags = [];
	    for(var n in hashItem.tags)
	    {
	    	strTags.push(this.tags[hashItem.tags[n]]);
	    }
	    var tags = $("<div class='article-tags'><span class='glyphicon glyphicon-pushpin'></span> "+strTags.join(', ')+"</div>");
	    tags.insertAfter(title);	
	}    
    
    this.dom.find(".btn-topic-prev").unbind('click').on('click',this,function(e){e.data.switchTopic(+1);});
    this.dom.find(".btn-topic-next").unbind('click').on('click',this,function(e){e.data.switchTopic(-1);});
    
    this.renderFilter(this.current_scroll_view);

    setTimeout(function(){
    		$('#'+this.viewId).removeClass('left').removeClass('right');
    	}.bind({viewId:this.current_scroll_view.attr('id')}),100);    
    
};
appcurrentaffairsController.prototype.renderTopicList = function()
{
	$(this.listView).find(".ca_warn").empty();
 	$(this.listView).find(".ca_listview").empty();
 	for(var t in this.topiclist)
 	{
 		var content = "";
    
	    if(typeof this.topiclist[t].content == "string")
	    {
			content = this.topiclist[t].content.replace("&nbsp;"," ").trim();
	    }
	    contents = content.replace(/(<style\b[^>]*>)[^<>]*(<\/style>)/i,' ');
	    
    	var discrip = $("<div class='discript'></div>").html(contents);
    	var englishCont = $(discrip).find(".english-content");
    	var hindiCont = $(discrip).find(".hindi-content");
    
    	var lin = englishCont.text().replace(/\s+/g,' ').trim();
    	if(lin.length > 80)
		{
		 	lin = lin.substr(0, 150) + "...";
		}
		
    	
 		var topicDate = new Date(this.topiclist[t].createdon * 1000);
 		var topiclistdiv = $('<div class="TopicList col-xs-12 col-sm-12 col-md-12 col-lg-12" index="'+t+'" topicId= "'+this.topiclist[t].id+'" LoginRequired="true">'+
 							 	'<div class="row topiclrow">'+
 							 		'<div class="topictitle col-xs-12 col-sm-12 col-md-12 col-lg-12">'+
 							 			'<div class="topictit">'+this.topiclist[t].title+'</div>'+
 							 			'<div class="cretddte">'+topicDate.toDateString()+'</div>'+
 							 		'</div>'+
 							 		'<div class="topivImg col-xs-12 col-sm-12 col-md-12 col-lg-12 ">'+lin+'</div>'+
 								'</div>'+
 							 '</div>');
		$(this.listView).find(".ca_listview").append(topiclistdiv);
		$(this.listView).find(".ca_listview").find(".TopicList").css({"margin": "3px 0px", "box-shadow": "0px 0px 10px rgba(0,0,0,0.25)"});						 	
 	}           	 
};
appcurrentaffairsController.prototype.BindNavEvents = function()
{
	$(".navContainer").unbind().bind('click',this,function(e){
		// console.log("hey===");
		// if($(this).hasClass("disable"))
			// return;
		e.data.NavigateItems(this);
	});
};
appcurrentaffairsController.prototype.NavigateItems = function(btn)
{
	var dom = $(btn).siblings(".ItemRow")[0];
	var MAXSHIFT = 1;
	var w = $(dom).find(".mthlst").width();
	var shift = $(btn).hasClass("prev")? dom.scrollLeft - MAXSHIFT * w : dom.scrollLeft + MAXSHIFT * w;
	$(dom).animate({scrollLeft: shift}, 400, function(){
		this.obj.ValidateNavigator(this.dom);
	}.bind({obj:this,dom:dom}));
	
};
appcurrentaffairsController.prototype.ValidateNavigator = function(dom)
{
	// var maxScrollLeft = dom.scrollWidth - dom.clientWidth;
	// console.log('dom.scrollWidth='+dom.scrollWidth);
	// console.log('dom.clientWidth'+dom.clientWidth);
	// if(dom.scrollLeft == 0)
		// $(dom).siblings(".navContainer.prev").addClass("disable");
	// else	
		// $(dom).siblings(".navContainer.prev").removeClass("disable");
// 	
	// if(maxScrollLeft <= dom.scrollLeft + 1)	
		// $(dom).siblings(".navContainer.nxt").addClass("disable");
	// else
		// $(dom).siblings(".navContainer.nxt").removeClass("disable");
};
appcurrentaffairsController.prototype.renderTopic = function()
{
	if(
        (typeof this.currentIndex == "undefined") ||
        (typeof this.monthHash[this.yearIndex[this.selectedMonth]] == "undefined") ||
        (typeof this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex] == "undefined") ||
        (typeof this.topics[this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex].id] == "undefined") 
    )
    {
        //console.log('Unexpected Error; please contact the support team.');
        return;
    }
    this.lastLink = {selectedMonth:this.selectedMonth,currentIndex:this.currentIndex};

	var hashItem = this.monthHash[this.yearIndex[this.selectedMonth]][this.currentIndex];
    var topicId = hashItem.id;
    var data = this.topics[topicId];
    var topicDate = new Date(data.createdon * 1000);
    var date = $("<div class='date'>"+topicDate.toDateString()+"</div>");
    var title = $("<div class='title'>"+data.title+"</div>");
    
    var content = "";
    
    if(typeof data.content == "string")
    {
		content = data.content.replace("&nbsp;"," ").trim();
    }
    
    var discription = $("<div class='discription'></div>").html(content);
    var englishContent = $(discription).find(".english-content");
    var hindiContent = $(discription).find(".hindi-content");
    
    if($(englishContent).html() != "")
    {
    	i = englishContent.find("img");
    	if(i.length > 0)
    	{
    		if(i.eq(0).parent('a').length == 0)
    		{
    			var picEnglish = this.setBlogImage(i.eq(0),"picEnglish");	
    		}
    	}	
    }
    if($(hindiContent).html() != "")
    {
    	i = hindiContent.find("img");
    	if(i.length > 0)
    	{
    	  if(i.eq(0).parent('a').length == 0)
    	  {
    		 var picHindi = this.setBlogImage(i.eq(0),"picHindi");
    	  }	
    	}
    }
    if($(englishContent).length == 0 && $(hindiContent).length == 0)
    {
    	i = discription.find("img");
    	if(i.length > 0)
    	{
    		if(i.eq(0).parent('a').length == 0)
    	  	{
    			var pic = this.setBlogImage(i.eq(0));		
    	    }	
    	}
    } 
        
    var header = $("<div class='header'></div>");
    var navBtn = $("<div class='topic-nav pull-right'></div>");
    var prev = !(parseInt(this.currentIndex) + 1 >= this.monthHash[this.yearIndex[this.selectedMonth]].length && this.selectedMonth >= (this.yearIndex.length-1)); 
    var nex =  !(parseInt(this.currentIndex) - 1 < 0 && this.selectedMonth == 0);

    header.append(navBtn);
    if(prev)navBtn.append("<button class='btn btn-link btn-topic-prev '><span class='glyphicon glyphicon-triangle-left'></span> Previous</button>");
    if(prev && nex)navBtn.append(" | ");
    if(nex)navBtn.append("<button class='btn btn-link btn-topic-next'>Next <span class='glyphicon glyphicon-triangle-right'></span></button>");
    header.append(date);
    // Remove old Node
    var prev = $('#'+'ca_topic_'+topicId);
    if(prev.length > 0 && prev[0] != this.current_scroll_view[0])
    {
        prev.remove();
    }
    this.current_scroll_view.attr('id','ca_topic_'+topicId);
    this.current_scroll_view.html("").append(header).append(title);
    if(typeof picEnglish!= "undefined")
    	this.current_scroll_view.append(picEnglish);
    if(typeof picHindi!= "undefined")
   		this.current_scroll_view.append(picHindi);
   	if(typeof picEnglish== "undefined" && typeof picHindi== "undefined" && typeof pic!= "undefined")
   		this.current_scroll_view.append(pic);
   	   
    this.current_scroll_view.append(discription).append("<hr />");
    
	if(typeof hashItem.tags != "undefined" && hashItem.tags.length > 0)
	{
	    var strTags = [];
	    for(var n in hashItem.tags)
	    {
	    	strTags.push(this.tags[hashItem.tags[n]]);
	    }
	    var tags = $("<div class='article-tags'><span class='glyphicon glyphicon-pushpin'></span> "+strTags.join(', ')+"</div>");
	    tags.insertAfter(title);	
	}    
    
    $(".btn-topic-prev").unbind('click').on('click',this,function(e){e.data.switchTopic(+1);});
    $(".btn-topic-next").unbind('click').on('click',this,function(e){e.data.switchTopic(-1);});
    
    this.renderFilter(this.current_scroll_view);

    setTimeout(function(){
    		$('#'+this.viewId).removeClass('left').removeClass('right');
    	}.bind({viewId:this.current_scroll_view.attr('id')}),100);    
    
};
appcurrentaffairsController.prototype.setBlogImage = function(img,className)
{
	var pic = $("<img class='pic' />");
	if(typeof className!= "undefined")
		$(pic).addClass(className);
	
	pic.attr("error-count",'0');
	pic.bind("error",function(event){
    	if($(this).attr("x-url") && $(this).attr("error-count")=='0')
    	{
    		$(this).attr("error-count",'1');
        	$(this).attr("src",$(this).attr("x-url")); 
    	}        	
    	else
    	{
    		$(this).remove();
    	}
    });
    pic.attr("src",img.attr("src"));
    pic.attr("x-url",img.attr("x-url"));
    img.remove();
    return pic;   
};
appcurrentaffairsController.prototype.switchTopic = function(n)
{
	var nextIndex = parseInt(this.currentIndex) + n;
	var monthHash = this.monthHash[this.yearIndex[this.selectedMonth]];
    if(nextIndex < 0 && this.selectedMonth <= 0)
    {
	    this.selectedMonth = 0;
	    this.currentIndex = -1;
	    
	    this.current_scroll_view.html('<div class="no-data"> \
            <h1>The End!</h1> \
            <div class="alert alert-info"> \
              <strong>-- No more data here. --</strong> \
            </div> \
            <div>Click <a href="#">here</a> to go back.</div> \
        </div>').find('a').bind('click',this,function(e){
        	e.data.switchTopic(1);
        });
        return;
    }
    
    if(nextIndex >= monthHash.length && this.selectedMonth >= (this.yearIndex.length-1))
    {
	    this.selectedMonth = (this.yearIndex.length-1);
	    this.currentIndex = this.monthHash[this.yearIndex[this.selectedMonth]].length;

	    this.current_scroll_view.html('<div class="no-data"> \
            <h1>The End!</h1> \
            <div class="alert alert-info"> \
              <strong>-- No more data here. --</strong> \
            </div> \
            <div>Click <a href="#">here</a> to go back.</div> \
        </div>').find('a').bind('click',this,function(e){
        	e.data.switchTopic(-1);
        });
        return;
    }
    if(this.current_scroll_view.find('.Loader').length==0)
    {
	    this.switchScreen(n);
	    /*this.current_scroll_view.html('<div class="Loader"> \
	            <img src="img/loader.svg"> \
	            <div class="alert alert-info"> \
	              <strong>Loading!</strong> \
	            </div> \
	        </div>');*/    	
    }
    this.currentIndex = nextIndex;
    if(this.currentIndex >= monthHash.length)
    {
        this.currentIndex = 0;
        this.switchMonth(-1);   // Items are sorted in reverse list
    }
    else if(this.currentIndex < 0)
    {
        this.switchMonth(+1);  // Items are sorted in reverse list
    }
    else
    {
		if(!this.checkCurrentTopicFilter())
	    {
	     	// Not Found! Keep Switching
	     	this.switchTopic(n);
	    }
	    else
	    {
	        this.loadTopic();
	    }
    }
};
appcurrentaffairsController.prototype.switchScreen = function(n)
{
    var x = new Date();
    var screen = $('<div id="ca_new_'+x.valueOf()+'" class="ca-scroll-view page transition ">'+
        '<div class="Loader Freez">'+
            '<img src="img/loader.svg">'+
        '</div>'+
    '</div>');
    
    var ca_content = $(".ca-scroll-container").find("div.ca-scroll-view");
  	if(ca_content.length > 10)
  	{
  		$(this.dom).find('.ca-scroll-container > div.left,.ca-scroll-container > div.right').remove();
  	}
  	
    var oldClass = '';
    if(n<0)
    {
        this.current_scroll_view.after(screen);
        screen.addClass('right');
        oldClass = 'left';
    }
    else
    {
        this.current_scroll_view.before(screen);
        screen.addClass('left');
        oldClass = 'right';
    }
    var prevScreen = this.current_scroll_view; 
    this.current_scroll_view = screen;
   
    setTimeout(function(){
    		$('#'+this.prevScreen).addClass(this.oldClass);
    		$('#'+this.currentScreen).removeClass('left').removeClass('right');
    	}.bind({prevScreen:prevScreen.attr('id'),currentScreen:this.current_scroll_view.attr('id'),oldClass:oldClass}),100);    

};
appcurrentaffairsController.prototype.switchMonth = function(n)
{
    if(0 <= this.selectedMonth-n && this.selectedMonth-n < this.yearIndex.length)
    {
        this.selectedMonth -= n;
        this.loadMonth(n);
    }
};
appcurrentaffairsController.prototype.renderCal = function()
{
    if(!this.calView)
    {
        return;
    }
    var view = this.calView;
    var monthHash = this.monthHash[this.yearIndex[this.selectedMonth]];
    
    if(!monthHash)
    {
        this.renderTopicError();
        $(".cal-loader").html('<div class="alert alert-warning"><strong>No data available! connect to internet to sync.</strong></div>').show();
        return false;
    }

    $(".cal-loader").hide();
    
    var lastlastDate = new Date();
    var parts = this.yearIndex[this.selectedMonth].split('-');
    var selectedYear = parseInt(parts[0]);
    var selectedMonth = parseInt(parts[1]);
    lastlastDate.setFullYear(selectedYear, selectedMonth-1, 0);
    lastlastDate = lastlastDate.getDate();
    var firstDate = new Date();
    firstDate.setFullYear(selectedYear, selectedMonth-1, 1);
    var lastDate = new Date();
    lastDate.setFullYear(selectedYear, selectedMonth, 0);
    lastDate = lastDate.getDate();
    
    var weekDay = firstDate.getDay();
    var months = ["January","February","March","April","May","June","July","August","September","October","November","December"];
    var calview = view.find(".cal-view");    
    var cal = $("<div class='cal'></div>");
    var title = $("<div class='title'></div>");
    cal.append(title);

    var prev = !(this.selectedMonth+1 >= this.yearIndex.length);
    var nex = !(this.selectedMonth-1 < 0);

    if(prev)title.append("<button class='btn btn-link btn-mnt-prev '><span class='glyphicon glyphicon-triangle-left'></span></button>");
    title.append("<span class='caption'>"+months[selectedMonth-1]+" "+selectedYear+"</span>");
    if(nex)title.append("<button class='btn btn-link btn-mnt-next'><span class='glyphicon glyphicon-triangle-right'></span></button>");
    
    var calGridHtml = "<table class='calgrid'>";
    calGridHtml += "<tr>"+
                        "<th week='0'>Sun</th>"+
                        "<th week='1'>Mon</th>"+
                        "<th week='2'>Tue</th>"+
                        "<th week='3'>Wed</th>"+
                        "<th week='4'>Thu</th>"+
                        "<th week='5'>Fri</th>"+
                        "<th week='6'>Sat</th>"+
                        "</tr>";
    var n = 0;
    for(var y=0;y<6;y++)
    {
        calGridHtml += "<tr>";
        for(var x=0;x<7;x++)
        {
            var d = 0;
            var month = "0";
            if(n < weekDay)
            {
                d = (lastlastDate - (weekDay-1))+n;
                month = "-1";
            }
            else
            {
                d = (n - weekDay) + 1;
                if(d>lastDate)
                {
                    d = n - lastDate;
                    month = "+1";
                }
            }

            calGridHtml += "<td week='"+(n%7)+"' month='"+month+"' day='"+d+"' ><b>";
            calGridHtml += d;
            calGridHtml += "</b><u></u></td>";
            n++;
        }
        calGridHtml += "</tr>";
    }
    calGridHtml += "</table>";
    var calgrid = $(calGridHtml);
    cal.find(".title").append(calgrid);
    var tagfilters = '<div class="title"><ul class="pagination pagination-sm">'+
                        '<li class="active"><a href="#">All Tags</a></li><li><a href="#">!</a></li>';
    for(var c=0;c<26;c++)
    {
        tagfilters += '<li><a href="#">'+ String.fromCharCode('A'.charCodeAt(0)+c); +'</a></li>';
    }            

    tagfilters += "</ul>";
    tagfilters += '<button class="btn-clear-filter" style="display: none">Clear</button>';
    tagfilters += "</div>";

    var tagsHtml = '<div class="container-fluid"><div class="row">';
    var tags = [];
    for(var t in this.tags)
    {
    	tags.push({id:t,text:this.tags[t],utext:this.tags[t].toUpperCase()});
 	}
    tags = tags.sort(function(a,b){return (a.utext<b.utext)?-1:(a.utext>b.utext)?1:0;});
 
    for(var t in tags)
    {
        tagsHtml += '<button type="button" class="tag btn btn-default col-xs-3 col-sm-3 col-md-3'+
        				((this.selectedTags.indexOf(parseInt(tags[t].id))>=0)?' active':'')+'" tag-id="'+tags[t].id+'">'+tags[t].text+'</button>';
    }
    tagsHtml += '</div></div>'; 

    var tagsPanel = $("<div class='tags'>"+
                    tagfilters +
                 "</div>");
    
    tagsPanel.append(tagsHtml);
                 
    calview.html("").append(cal).append(tagsPanel);
    
    cal.find(".btn-mnt-prev, table.calgrid td[month='-1']").unbind("click").on("click",this,function(e){
	    /* TODO: Fix: Clear Tag Selection for Now; Fix it later */
    	e.data.selectedTags=[]; 
    	e.data.renderFilter();
    	e.data.switchMonth(-1);});
    cal.find(".btn-mnt-next, table.calgrid td[month='+1']").unbind("click").on("click",this,function(e){
    	/* TODO: Fix: Clear Tag Selection for Now; Fix it later */
    	e.data.selectedTags=[]; 
    	e.data.renderFilter();
    	e.data.switchMonth(+1);});

    cal.find("table.calgrid td[month='0']").unbind("click").on("click",this,function(e){
    	if(parseInt($(this).find('u').text())>0)e.data.switchDate($(this).find('b').text());
    	});
    
    this.calView.find(".tags .pagination a").unbind().bind("click",this,this.tagPageClick);    
    this.calView.find(".tags button.tag").unbind().bind("click",this,this.tagClick);    
    this.calView.find(".tags button.btn-clear-filter").unbind().bind("click",this,this.tagClear);    

    if(this.selectedTags.length==0)
    {
    	this.calView.find(".tags button.btn-clear-filter").hide();
    }
    else
    {
    	this.calView.find(".tags button.btn-clear-filter").show();
    }
	this.updateDateTopicCount();
};
appcurrentaffairsController.prototype.updateDateTopicCount = function(day){
    var monthHash = this.monthHash[this.yearIndex[this.selectedMonth]];
    
    if(!monthHash)
    {
        return false;
    }
    var datecount = {};     
    for(var i in monthHash)
    {
       if(!datecount[monthHash[i].day])
            datecount[monthHash[i].day]=0;
       if(this.selectedTags.length > 0)
       {
       	  if(typeof monthHash[i].tags != "undefined" && monthHash[i].tags.length > 0)
       	  {
			for(var s in this.selectedTags)
          	{
          		if(monthHash[i].tags.indexOf(this.selectedTags[s])>=0)
          		{
          			datecount[monthHash[i].day]++;
					break;
          		}
          	}
       	  }
       }
       else
       {
	       datecount[monthHash[i].day]++;
       }
    }
    for(var d in datecount)
    {
    	this.calView.find(".calgrid td[month='0'][day='"+d+"'] u").text(datecount[d]>0?datecount[d]:'');
    }
};
appcurrentaffairsController.prototype.switchDate = function(day){
    for(var i in this.monthHash[this.yearIndex[this.selectedMonth]])
    {
        var dayItem = this.monthHash[this.yearIndex[this.selectedMonth]][i]; 
        if(dayItem.day == day)
        {
	       if(this.selectedTags.length > 0)
	       {
	       	  if(typeof dayItem.tags != "undefined" && dayItem.tags.length > 0)
	       	  {
				for(var s in this.selectedTags)
	          	{
	          		if(dayItem.tags.indexOf(this.selectedTags[s])>=0)
	          		{
	          			
			            this.currentIndex = parseInt(i);
			           /*
						UrlMgmt.getObj().PopView(function(){
												   UrlMgmt.getObj().PopView(function(){
													   UrlMgmt.getObj().Route({route: 'app/currentaffairsdetail', needData: false}, function(action){
														   action.controler.parent = this;
														   var t = this; 
														   t.view = action.controler.dom;
														   t.current_scroll_view = $("#ca_first");
														   t.loadTopic();
														 }.bind(this));
												   }.bind(this));
											   }.bind(this));
											   */
					   UrlMgmt.getObj().PopView();
			         		UrlMgmt.getObj().Route({route: 'app/currentaffairsdetail', needData: false}, function(action){
						    		action.controler.parent = this;
						    		var t = this;
						    		this.detailsDom = action.controler.dom;
					    			t.view = action.controler.dom;
					    			t.current_scroll_view = $("#ca_first");
					    			t.loadTopic();
						      	}.bind(this));
			        	return;
	          		}
	          	}
	       	  }
	       }
	       else
	       {
				this.currentIndex = parseInt(i);
				/*
				UrlMgmt.getObj().PopView(function(){
								   UrlMgmt.getObj().PopView(function(){
										UrlMgmt.getObj().Route({route: 'app/currentaffairsdetail', needData: false}, function(action){
											action.controler.parent = this;
											var t = this;
											t.view = action.controler.dom;
											t.current_scroll_view = $("#ca_first");
											t.loadTopic();
										}.bind(this));
									}.bind(this));
								}.bind(this));*/
				UrlMgmt.getObj().PopView();
			       	UrlMgmt.getObj().Route({route: 'app/currentaffairsdetail', needData: false}, function(action){
						    action.controler.parent = this;
						    var t = this;
						    this.detailsDom = action.controler.dom;
			    			t.view = action.controler.dom;
			    			t.current_scroll_view = $("#ca_first");
			    			t.loadTopic();
					    }.bind(this));
					
				return;
           }
        }
    }    
};
appcurrentaffairsController.prototype.renderFilter = function(obj)
{
	if(!obj)
    {
        obj = this.dom; 
    }
    obj = this.dom; 
    var div_selTags = $('.selected-filters');

    div_selTags.hide();
    div_selTags.find('.tag').remove();
 
    for(var i in this.selectedTags)
    {
    	ix = this.selectedTags[i];
    	div_selTags.append($('<span class="tag"></span>').attr('tag-id',ix).text(this.tags[ix]));
    }
    if(div_selTags.find('.tag').length > 0)
    {
    	div_selTags.show();
    }    
};
appcurrentaffairsController.prototype.tagPageClick = function(e)
{
	
	var button = $(this);

	e.data.calView.find(".tags .pagination .active").removeClass("active");
    e.data.tagFilter = 0;
    e.data.tagFilterText = "";

    e.data.renderFilter();

    button.parents("li").addClass("active");
    e.data.calView.find(".tag:not(.active)").each(function(index,element){
        if(this.length > 1)
        {
            $(element).show();
        }
        else
        {
        	var ch = $(element).text().charAt(0).toLowerCase(); 
        	if(this == "!" && !(ch.charCodeAt(0) >= 'a'.charCodeAt(0) && ch.charCodeAt(0) <= 'z'.charCodeAt(0)))
        	{
                $(element).show();        		
        	}
            else if(ch==this)
            {
                $(element).show();
            }
            else
            {
                $(element).hide();
            }
        }
    }.bind(button.text().toLowerCase()));
};
appcurrentaffairsController.prototype.tagClick = function(e)
{
    var button = $(this);
    button.toggleClass("active");
    e.data.selectedTags = e.data.calView.find(".tags button.tag.active").map(function(){return parseInt($(this).attr('tag-id'));}).get();
    e.data.renderFilter();
    e.data.updateDateTopicCount();
    if(e.data.selectedTags.length==0)
    {
    	e.data.calView.find(".tags button.btn-clear-filter").hide();
    }
    else
    {
    	e.data.calView.find(".tags button.btn-clear-filter").show();
    }

};
appcurrentaffairsController.prototype.tagClear = function(e)
{
    var button = $(this);
    e.data.calView.find(".tags button.tag.active").removeClass('active');
    button.hide();
    e.data.selectedTags = [];
    e.data.renderFilter();
    e.data.updateDateTopicCount();
};
