var QuestionType = {
	MCQ : 0,
	Upload : 1,
	COMP : 2,
	CBQ : 3,
	BLANK : 4,
	NIQ : 5,
	MMQ : 7,
	Str : ['Multiple Choice Question', '.otd file', 'COMP', 'Competency Based Question', 'Fill in the blanks', 'Numeric input quesion','Matrix Match Question'],
	Seq : {
		0 : 'MCQ',
		1 : '.otd file',
		2 : 'COMP',
		3 : 'Competency Based Question',
		4 : 'Fill in the blanks',
		5 : 'Numeric input quesion',
		7 : 'Matrix Match Question'
	}
};
var glyheight = 131;
var QuesTimeSpentTimerVar = null;
var QesNo = ['A','B','C','D','E','F','G','H','I','J'];
var appibpstestController = function() {

	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	
	this.meta = [];
	this.sessionID = -1;
	this.questionOrder = [];
	this.userActivity = [];
	this.ansOrder = [];
	this.sectionName = [];
	this.startNewQuestionAt = "";
	this.ShowingQuestionNo = -1;
	this.submited = false;
	this.startedAt = "";
	this.pauseTime = "";
	if (this.totalTime == undefined)
		this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	this.pandingForSave = {};
	this.paused = false;
	this.testId = null;
	this.tr2TestId = null;
	this.testState = null;
	this.parent = null;
	this.languageOptions = null;
	this.language = null;
	this.pauseDuration = 0;
	this.timeNotedAt = new Date().getTime();
	this.passedTime = 0;
	this.testAttribute = {};
	this.pausedtimdetl = {};
	this.pausedQue = -1;
	this.pauseLeft = -1;
	this.lastpausedId = -1;
	this.lastresumetim = {};
	this.lastRes = -1;
	this.testAttributes = null;
	this.suffleInterSection = false;
	this.testTheme = 4;
	this.showsectional = true;
	this.questionContinue = false;
	this.timespentincurrentquestion = 0;
	
	//for psyco test
	this.isPsycoTest = false;
	this.psycoTestState = undefined;
	this.currentSectionId = 0;
	this.stopSectionTimer = false;
	
	this.sectionalTimeBound = false;
};

appibpstestController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	UrlMgmt.getObj().viewRefreshrequired = true;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.view.hide();//controler.DisplayHeader(this.dom, 'HOME', true, false, true);
};
appibpstestController.prototype.LoadTest = function() {	

	if((typeof this.testAttributes != "undefined") && (this.testAttributes != null) &&(typeof this.testAttributes['shuffleInterSection'] != "undefined") && (this.testAttributes['shuffleInterSection'] != null))
	{
		this.suffleInterSection = (parseInt(this.testAttributes['shuffleInterSection']) == 1)?this.testAttributes['shuffleInterSection']:false;
		if(this.suffleInterSection)
		{
			this.showsectional = false;
		}
	}
	
	//psyco test
	if(this.testAttributes && typeof this.testAttributes.isPsycoTest !== 'undefined' && this.testAttributes.isPsycoTest == 1)
	{
		this.isPsycoTest = true;
	}
	//TCS->TBSE test
	else if(this.testAttributes && typeof this.testAttributes.sectionalTimeBound !== 'undefined' && this.testAttributes.sectionalTimeBound == 1)
	{
		this.sectionalTimeBound = true;	
	}
	//TBSE test
	else if(this.testTheme == Theme.TBSENTRANCE)
	{
		this.sectionalTimeBound = true;
	}
	//SSC theme
	else if(this.testTheme == Theme.SSCTHEME || this.testTheme == Theme.NEETTHEME)
	{
		this.showsectional = false;
		
		// this.suffleInterSection = true;
	}	
	
	this.testAttribute = JSON.parse(this.parent["tests"][this.testId].meta);
	
	if (this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"] == 1) {
		var saveLimit = this.testAttribute.hasOwnProperty("SaveLimit") ? this.testAttribute["SaveLimit"] : -1;
		this.pauseLeft = saveLimit;
	}
	loadExistingData({entity: "downloadtestdata", recordId:this.testId}, function(data) {
		$('#testData').html($(data));
		//Load meta
		loadExistingData({entity: "testmeta", recordId: this.testId, fileErrorHandling: false}, function(data) {
			loadExistingData({entity: "passedTime", recordId:this.testId}, function(result) {
				this.meta = data;
				if (result.passedTime > -1) {
					//means the test is resumed
					this.passedTime = result.passedTime;
					this.lastRes = this.passedTime;
					this.meta["startedAt"] = new Date(Date.now() - this.passedTime * 1000);
				}

				if (this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"] == 1) {
					if (this.testState == testState.Paused || this.testState == testState.Started) {
						if (this.meta["pausedetail"] != undefined) {
							this.lastpausedId = this.meta["pausedetail"]["id"];
							this.pauseLeft = this.meta["pausedetail"]["pauseLeft"];
							if (this.testState == testState.Started) {
								var tim = Math.floor(Date.now() / 1000) - this.meta["pausedetail"]["pauseBreakedAt"];
								this.passedTime = tim + parseInt(this.meta["pausedetail"]["usedTime"]);
								this.lastRes = tim + parseInt(this.meta["pausedetail"]["usedTime"]);
								;
							} else {
								this.passedTime = this.meta["pausedetail"]["usedTime"];
								this.parent.SetState(this.testId, testState.Started);
								this.UpdateTestHistry(this.lastpausedId, testState.Paused, this.meta.sessionId);
							}
						}
					}

					if (this.testState == testState.Started && this.meta["userLastactivetime"] != undefined && this.meta["userLastactivetime"] != -1) {
						var duration = Math.floor(Date.now() / 1000) - this.meta["userLastactivetime"]["lastactive"];
						var tt = $("#_totalTime_").text() * 60;
						var remaintim = tt - this.meta["userLastactivetime"]["usedTime"];
						if (duration > 120 && remaintim > 120) {
							this.passedTime = this.meta ["userLastactivetime"]["usedTime"];
							this.UpdateTestPause(this.passedTime, this.meta.sessionId);
						}
					}
				}
				if (this.testState == testState.Loaded) {
					this.meta["startedAt"] = new Date();
					this.meta["endAt"] = null;
					this.meta["language"] = this.language;
					this.testState = testState.Started;
					this.parent.SetState(this.testId, this.testState);
					this.SaveQuestion(-1);
				}
				if (this.meta["endAt"] != null) {
					alert("This test has been already taken");
					this.submited = true;
					this.testState = testState.Submitted;
					this.parent.SetState(this.testId, this.testState);
					$('.btn-back.BackFromTest').click();
				}
				this.totalTime = $("#_totalTime_").text() * 60 * 1000;
				this.paused = false;
				this.sessionID = this.meta.sessionId;
				
				loadExistingData({entity: "testpauseque", recordId: this.meta.sessionId}, function(data) {
					this.pausedQue = data;
					this.PopulateTestUI();
				}.bind(this), function(){
					this.PopulateTestUI();
				}.bind(this));
				}.bind(this));
    	}.bind(this));
    }.bind(this));
};
appibpstestController.prototype.PopulateTestUI = function() {
	this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	this.PopulateHeader();

	if (this.testState == testState.Started && this.meta["userLastactivetime"] != undefined && this.meta["userLastactivetime"] != -1) {
		var duration = Math.floor(Date.now() / 1000) - this.meta["userLastactivetime"]["lastactive"];
		if (duration > 300) {
			this.pausedtimdetl["id"] = this.lastpausedId;
			this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now() / 1000);
			this.pausedtimdetl["pauseLeft"] = -1;
			this.pausedtimdetl["usedTime"] = this.meta["userLastactivetime"]["usedTime"];
			if (this.meta.pauseLeft != -1) {
				this.pausedtimdetl["pauseLeft"] = this.meta.pauseLeft;
			}
			this.meta["pausedetail"] = this.pausedtimdetl;
			writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
			});
		}
	}
	this.PopulateQuestionPalette();
	//this.ShowQuestion(this.pausedQue);
	var lastSavedQues = this.lastSavedQues();
	
	this.StartTimer();
	
	if(this.sectionalTimeBound)
	{	
		//start section after show question is executed
		lastSavedQues.then(function(){this.StartSectionTimer();}.bind(this));
	}
	
	this.BindEvents();
	this.QuestionPaper(this.language);
	UrlMgmt.getObj().removeLoader();
	$("#IBPSTest").show();
	this.ResizeTestScreen();
	setTimeout(function() {
		$(".QPalleteBtn").click();
	}, 1000);
	slider($('.testsectionDiv'), 'testsectioncontent', "sectionNav");
	if(typeof this.language == "undefined" && typeof this.languageOptions != "undefined" && this.languageOptions != null)
	{
		
		 this.language = 0;
	}
	if(typeof this.language != "undefined" && this.language == 0) 
	{	
		$(".js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
		
	}
	else if(typeof this.language != "undefined" && this.language == 1)
	{
		$(".js-SelectTestLanguageWithin").find('img').attr('src', "img/hindi-eng.png");
		
	}
	if(typeof this.language == "undefined" || this.languageOptions.length == 1)
	{
		$(".js-SelectTestLanguageWithin").hide();
	}
	this.ValidateNavigator($(".fieldset")[0]);
	$('#sectionPanel .fieldset.testsectioncontent').swipe({
		swipe:function(event, direction, distance, duration, fingerCount) {
			if($(this).find('span.scroll-x')){
				if($(event.srcElement).is('[class^=MathJax]') || $(event.srcElement).is('[class^=MJXc]')) {
					return false;
				}
			}
			if(direction == 'left'){
				$('.text-center.sectionNavIcon.next.sectionNavbtnright').click();
			}
			if(direction == 'right'){
				$('.text-center.sectionNavIcon.prev.sectionNavbtnleft').click();
			}
		},
		threshold: 70,
		allowPageScroll:"auto"
	});
};
appibpstestController.prototype.lastSavedQues = function()
{
	var deferred = $.Deferred();
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var lsqstarttime  = Date.now();
		var lsqendtime    = null;
		var lsqurl 	  	  = remoteServer+"/ajax"+"/session="+this.meta.sessionId+"/testId="+this.testId+"";
		var lsqstatus     = "";
		var lsqmod		  = "test";	
		var lsqack		  = "lastsavedques";
	}		
	$.ajax({	
		type: "POST",
		data:{
				mod: "test",
				ack: "lastsavedques",
				session:this.meta.sessionId,
				testId:this.testId,
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
		complete: function( event){
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				lsqstatus      		= "success";
				lsqendtime     		= Date.now();
				var lsqduration 	= lsqendtime - lsqstarttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:lsqmod,
					ack			:lsqack,
					url			:lsqurl,
					status		:lsqstatus,
					starttime	:lsqstarttime,
					endtime		:lsqendtime,
					duration	:lsqduration
				});
			}			
			var reply = event.responseJSON;
		   	try
		   	{
		   		var qno = reply.data;
		   		this.ShowQuestion(qno);
		   		deferred.resolve(1);
		   	}
		   catch(e)
		   {
		   	  this.ShowQuestion(1);
		   	   deferred.resolve(1);
		   }		   
		}.bind(this),
		url: remoteServer+"/ajax"
	});
	
	return deferred;
};
appibpstestController.prototype.BindEvents = function() {
	var self = this;
	$(".qIndicator").unbind().click(function() {
		self.SaveQuestion(parseInt($("#Question").attr("qNo")));
		self.ShowQuestion($(this).attr("qNo"));
		this.questionContinue = false;
		this.timespentincurrentquestion = 0;
		$(".QPalleteBtn").click();
	});
	
	$("#IBPSTest #QPart .testFlag").unbind().click( function() {
		if(typeof(this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged) != undefined )
		{   
			if( this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged == "true")
			{
				   $("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-review-normal.png");
			this.SavePrevQuestion(false);
			} 
			 else
			{
				$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-for-review.png");
		     	this.SavePrevQuestion(true);
			}
					 
		} 
		 else
		{   
            $("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-for-review.png");
		    this.SavePrevQuestion(true);
		}	
	}.bind(this));
	
	$("#ClearResponseBtn").unbind().click( function() {
		$('.Answer input').prop('checked', false);
		$(".Answer").removeClass("selectedAns");
	}.bind(this));
	
	// $("#SaveNextBtn").unbind().click( function() {
		// this.SavePrevQuestion(false);
		   // //this.SaveQuestion(parseInt($("#Question").attr("qNo")));
		// if(this.sectionalTimeBound && this.isLastSectionQuestion())
		// {
			// return this.showSubmitSectionModal();
		// }
		// var qNo = (this.ShowingQuestionNo % this.userActivity.length) + 1;
		// self.ShowQuestion(qNo);
	// }.bind(this));
				
	$(".BottomPart .RightHandIcon").unbind().click( function() {
	
		if(this.sectionalTimeBound && this.isLastSectionQuestion())
		{
			return this.showSubmitSectionModal();
		}
		$(".BottomPart .RightHandIcon").addClass("Selected");
		var qNo = (this.ShowingQuestionNo % this.userActivity.length) + 1;
		this.AnswerUpdate();
		self.ShowQuestion(qNo);
		this.questionContinue = false;
		this.timespentincurrentquestion = 0;
	}.bind(this));
	
	$(".BottomPart .LeftHandIcon").unbind().click( function() {
	
		var qNo = (this.ShowingQuestionNo % this.userActivity.length) - 1;
		if(qNo > 0 && !($(".BottomPart .LeftHandIcon").hasClass("disabled")))
		{
			$(".BottomPart .LeftHandIcon").addClass("Selected");
			this.AnswerUpdate();
			self.ShowQuestion(qNo);
		}
		else if (qNo == -1 && this.ShowingQuestionNo == this.userActivity.length)
		{
			$(".BottomPart .LeftHandIcon").addClass("Selected");
			this.AnswerUpdate();
			self.ShowQuestion(--this.ShowingQuestionNo);
		}
		this.questionContinue = false;
		this.timespentincurrentquestion = 0;
		
	}.bind(this));
	
			$('#IBPSTest #Question').swipe({
			swipe:function(event, direction, distance, duration, fingerCount) {
				if($(this).find('span.scroll-x')){
					if($(event.srcElement).is('[class^=MathJax]') || $(event.srcElement).is('[class^=MJXc]')) {
						return false;
					}
				}
				if(direction == 'left'){
					$(".BottomPart .RightHandIcon").click();
				}
				if(direction == 'right'){
					
					$(".BottomPart .LeftHandIcon").click();
				}
			},
			threshold: 70,
			allowPageScroll:"auto"
		});
		
	$("#MarkForReviewBtn").unbind().click( function() {
		this.SavePrevQuestion(true);
		this.SaveQuestion(parseInt($("#Question").attr("qNo")));
		if(this.sectionalTimeBound && this.isLastSectionQuestion())
		{
			return this.showSubmitSectionModal();
		}
		var qNo = (this.ShowingQuestionNo % this.userActivity.length) + 1;
		self.ShowQuestion(qNo);
	}.bind(this));
	$("#confirmSubmit").unbind().click( function() {
			var prevQuestion = parseInt($("#Question").attr("qNo"));
		if (prevQuestion > 0) 
		{
			if (this.userActivity[prevQuestion - 1].questionNo == 0) {
				this.userActivity[prevQuestion - 1].questionNo = $("#QuestionBody .Question").attr("qId");
				this.userActivity[prevQuestion - 1].sQId = $("#QuestionBody .Question").attr("sQId");
			}
			
			var prevState = this.userActivity[prevQuestion - 1].state;
			var prevAns = JSON.stringify(this.userActivity[prevQuestion - 1].ans);
			var prevFlag = this.userActivity[prevQuestion - 1].flaged;
			// this.userActivity[prevQuestion - 1].flaged = true;
			var state = AnswerStatus.SKIPED;
	
			var answered = false;
			var self = this;
			var counter = 0;
			var qType = parseInt($("#Question").attr("qtype"));
			if (qType == QuestionType.BLANK) {
				$(".Answers select").each(function() {
					var selectVal = $(this).val();
					self.userActivity[prevQuestion - 1].ans[counter] = selectVal;
					if (selectVal > -1) {
						answered = true;
					}
					counter++;
				});
			} else if (qType == QuestionType.NIQ) {
				this.userActivity[prevQuestion - 1].ans[0] = $("#Question").find(".keyboardwrite").val();
				if ($("#Question").find(".keyboardwrite").val()) {
					answered = true;
				}
			} else {
				$(".Answers .Answer").each(function() {
					hasSelectedAns = $(this).hasClass("selectedAns");
					self.userActivity[prevQuestion - 1].ans[counter] = hasSelectedAns;
					answered |= hasSelectedAns;
					counter++;
				});
			}
			this.userActivity[prevQuestion-1]["answeredDate"] = new Date();
			state = answered ? AnswerStatus.ANSWERED : AnswerStatus.SKIPED;
			this.ChangeQuestionState(prevQuestion, state);
	
			this.userActivity[prevQuestion - 1].state = state;
			if (this.startNewQuestionAt != "" && this.ShowingQuestionNo != -1) {
				if (this.userActivity[prevQuestion - 1].timeSpent == -1)
				{
					this.userActivity[prevQuestion - 1].timeSpent++;
					this.userActivity[prevQuestion - 1].timeSpent += parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000);
				}
				else
				{
					this.userActivity[prevQuestion - 1].timeSpent = parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000);
				}
			}
			if (!(prevAns == JSON.stringify(this.userActivity[prevQuestion - 1].ans) && prevState == this.userActivity[prevQuestion - 1].state && prevFlag == this.userActivity[prevQuestion - 1].flaged)) 
			{
				this.SaveQuestion(prevQuestion);
			}
		}
		this.SubmitTest();
		$('#preSubmissionPart-overlay').hide();
	}.bind(this));
	$("#action-btn").unbind().bind("click", this, function(e) {
		if(!e.data.suffleInterSection)
		{
			var sectionId = $('.sectionNav.Selected').attr("sectionId");
			var firstQNo = $('.qIndicator[sectionId="' + sectionId + '"]:first').attr("qNo");
			var lastQNo = $('.qIndicator[sectionId="' + sectionId + '"]:last').attr("qNo");
			var stats = [0, 0, 0, 0, 0, 0, 0];
			for (var i = (firstQNo - 1); i < lastQNo; i++) {
				if (e.data.userActivity[i].flaged && e.data.userActivity[i].state == AnswerStatus.ANSWERED) {
					stats[AnswerStatus.ANSWEREDFLAGED]++;
				} else if (e.data.userActivity[i].flaged) {
					stats[AnswerStatus.FLAGED]++;
				}
				stats[e.data.userActivity[i].state]++;
			}
			$(".SectionInfoCount .missedIcon .count").text(stats[AnswerStatus.MISSED]);
			$(".SectionInfoCount .skippedIcon .count").text(stats[AnswerStatus.SKIPED]);
			$(".SectionInfoCount .attemptedIcon .count").text(stats[AnswerStatus.ANSWERED]);
			$(".SectionInfoCount .reviewIcon .count").text(stats[AnswerStatus.FLAGED]);
			$(".SectionInfoCount .review_answeredIcon .count").text(stats[AnswerStatus.ANSWEREDFLAGED]);
			$('.SectionInfo[sectionId="' + sectionId + '"]').siblings('.SectionInfo-overlay').show();
			$('.SectionInfo[sectionId="' + sectionId + '"]').addClass("selected");			
		}
		else
		{
			var sectionId = 0;
			// var firstQNo = $('.qIndicator[sectionId="' + sectionId + '"]:first').attr("qNo");
			// var lastQNo = $('.qIndicator[sectionId="' + sectionId + '"]:last').attr("qNo");
			var stats = [0, 0, 0, 0, 0, 0, 0];
			for (var i = 0; i < e.data.userActivity.length; i++) {
				if (e.data.userActivity[i].flaged && e.data.userActivity[i].state == AnswerStatus.ANSWERED) {
					stats[AnswerStatus.ANSWEREDFLAGED]++;
				} else if (e.data.userActivity[i].flaged) {
					stats[AnswerStatus.FLAGED]++;
				}
				stats[e.data.userActivity[i].state]++;
			}
			$(".SectionInfoCount .missedIcon .count").text(stats[AnswerStatus.MISSED]);
			$(".SectionInfoCount .skippedIcon .count").text(stats[AnswerStatus.SKIPED]);
			$(".SectionInfoCount .attemptedIcon .count").text(stats[AnswerStatus.ANSWERED]);
			$(".SectionInfoCount .reviewIcon .count").text(stats[AnswerStatus.FLAGED]);
			$(".SectionInfoCount .review_answeredIcon .count").text(stats[AnswerStatus.ANSWEREDFLAGED]);
			$('.SectionInfo[sectionId="' + sectionId + '"]').siblings('.SectionInfo-overlay').show();
			$('.SectionInfo[sectionId="' + sectionId + '"]').addClass("selected");			
		}

	});
	$('.js-cancel').unbind().bind('click',function(e){
		e.stopPropagation();
		$('.SectionInfo').removeClass("selected");
		$('.SectionInfo-overlay').hide();
	});
	$('.SectionInfo-overlay').unbind().bind('click',function(e){
		e.stopPropagation();
		this.questionContinue = false;
		this.timespentincurrentquestion = 0;
		$('.SectionInfo').removeClass("selected");
		$('.SectionInfo-overlay').hide();
	});
	if(!this.isPsycoTest && !this.sectionalTimeBound)
	{
		$(".sectionNav.Selected .SectionInfoCount").unbind().bind("click",this,function(e){
				e.stopPropagation();
		});
		$(".sectionNav.Selected .SectionName").unbind().bind("click",this,function(e){
			e.stopPropagation();
		}); 
		$(".sectionNav").unbind("click").bind("click", this, function(e) {
			e.data.SaveQuestion(parseInt($("#Question").attr("qNo")));
			var sectionId = $(this).attr("sectionId");
			var firstQNo = $('.qIndicator[sectionId="' + sectionId + '"]:first').attr("qNo");
			var calculate1 = $(".testsectioncontent").scrollLeft() + 
							 $(e.currentTarget).offset().left - 
							 $(".testsectioncontent").offset().left - 
							 $(".testsectioncontent")[0].clientWidth / 
							 2 + 
							 $(e.currentTarget).outerWidth(true) / 2;
			$('.testsectioncontent').animate({
				scrollLeft : calculate1
			}, 1000);
			e.data.ShowQuestion(firstQNo);
		});
	}
	
	$("#IBPSProfileBtn").unbind().click(function() {
		$("#profileModal").show();
	});
	$("#testInstruction").unbind().click( function() {
		$('#ibpsinstruction-modal').modal('show');
		$("#ibpsInstructions").show();
		$("#ibpsTerms").show();
		$('#ibpsinstruction-modal').find('.modal-footer').hide();
		$(".instructionFooter").hide();
		$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").hide();
		$("#ibpsinstruction-modal .languageParentDiv").hide();
		if(this.testTheme == Theme.SSCTHEME || this.testTheme == Theme.NEETTHEME)
			{
	     	 $('#ibpsinstruction-modal .sections-navigating').hide();
			}else
			{
			  $('#ibpsinstruction-modal .sections-navigating').show();
			}

	}.bind(this));
	

	$("#quesPaper").unbind().click( function() {
		$("#questionPaperModal").modal("show");
	}.bind(this));
	$("#preSubmissionPart-overlay").unbind().click( function() {
		$(".preSubmissionPart").removeClass("selected");
		$(".leftPart,.BottomPart").show();
		//for psyco test
		// if(!self.isPsycoTest)
		// {
			// self.showHideQuestionPallete();
		// }
		$(".secondHeader .IBPSElem").show();
		this.ResizeTestScreen();
		$('#preSubmissionPart-overlay').hide();
	}.bind(this));
	$(".BackBtn").unbind().click( function() {
		$(".preSubmissionPart").removeClass("selected");
		$(".leftPart,.BottomPart").show();
		//for psyco test
		//if(!self.isPsycoTest)
		//{
		//	self.showHideQuestionPallete();
		//}
		$(".secondHeader .IBPSElem").show();
		this.ResizeTestScreen();
		$('#preSubmissionPart-overlay').hide();
	}.bind(this));
	
	$(".IBPSSubmitBtn").off().on('click',this,function(e){
		e.stopPropagation();
		if(self.sectionalTimeBound)
		{
			//override for sectional time bounded test
			return self.showSubmitSectionModal();
		}
		self.onSubmitButtonClick();
	});
	
	$("#SelectTestLanguageWithin option").each(function() {
		$(this).prop("selected", false);
	});

	$("#SelectTestLanguageWithin option[value='" + this.language + "']").prop("selected", true);

	$("#SelectTestLanguageWithin").bind("change", this, function(e) {
		e.data.language = e.target.value;
		e.data.ShowQuestion(e.data.ShowingQuestionNo);
	});
	$(".js-SelectTestLanguageWithin").unbind().bind("click",this,function(e){
		if(e.data.language == 0) // set Hindi
		{
			e.data.language = 1;
			$(this).find('img').attr('src', "img/hindi-eng.png");
			$('#ibpsinstruction-modal .langauge-hindi').show();
			$('#ibpsinstruction-modal .langauge-english').hide();
			
		}
		else if(e.data.language == 1) // set English language
		{
			e.data.language = 0;
			$(this).find('img').attr('src', "img/eng-hindi.png");
			$('#ibpsinstruction-modal .langauge-hindi').hide();
			$('#ibpsinstruction-modal .langauge-english').show();
		}
		e.data.ShowQuestion(e.data.ShowingQuestionNo);
	});
	$(".js-SideMenubutton").unbind().bind("click",this,function(e){
		$(".QPalleteBtn").click();
		// var questionPalleteShown = $(this).hasClass("showedPallete");
		// self.showHideQuestionPallete(questionPalleteShown);
	});
	$(".js-modalBackButton").unbind().bind("click",this,function(e){
		$(".QPalleteBtn").click();
	});
	$(".QPalleteBtn").click(function(){
		var questionPalleteShown = $(this).hasClass("showedPallete");
		self.showHideQuestionPallete(questionPalleteShown);
	});
	
	//override for psyco test
	if(this.isPsycoTest)
	{
		$(".QPalleteBtn").off().hide();
	}
	
	$(".CancelBtn").click(function() {
		$(this).parents(".modalFrame").hide();
	});
	

	
	$('.BackFromTest').unbind("click").bind("click", this, function(e) {
		if (e.data.paused == false && e.data.submited == false) {
			if (e.data.testAttribute.hasOwnProperty("SaveForLater") && e.data.testAttribute["SaveForLater"] == 1 && e.data.testTheme != Theme.TBSENTRANCE && e.data.testTheme != Theme.DEFAULT) {
				e.data.SaveQuestion();
				var saveLimit = e.data.meta.pauseLeft - 1;
				if (e.data.pausedtimdetl["pauseLeft"] != undefined && e.data.pausedtimdetl["pauseLeft"] > 0) {
					saveLimit = e.data.pausedtimdetl["pauseLeft"] - 1;
				}	
				if (saveLimit > 0)
				{
					$("#saveForLaterIBPSModal p.saveLimitInfo").html("You can save this test " + saveLimit + " more time");
				    $("#saveForLaterIBPSModal").modal('show');
				}
				else if (saveLimit == 0)
				{
					$("#saveForLaterIBPSModal p.saveLimitInfo").html("You will not be able to save this test again.This is the last chance!!");
				    $("#saveForLaterIBPSModal").modal('show');
				}
				else if (saveLimit == -1)
				{ 
					$("#saveForLaterIBPSModal p.saveLimitInfo").html('');
					$("#testbackbtnwarningModal").modal('show');
				}
				else
				{
					$("#saveForLaterIBPSModal p.saveLimitInfo").html('');
					$("#saveForLaterIBPSModal").modal('show');
				}
				
			}
			else
			{
				$("#testbackbtnwarningModal").modal('show');
			}
			e.data.pausedQue = e.data.ShowingQuestionNo;
			writeData("testpauseque_" + e.data.sessionID + ".json", "testpauseques", e.data.sessionID, e.data.pausedQue, function() {
				if ( typeof cb != 'undefined')
					cb();
			});
			e.data.testState = testState.Started;
			e.data.SaveQuestion(parseInt($("#Question").attr("qNo")));
			e.data.parent.SetState(self.testId, self.testState);
		}
		/*if (!(e.data.testAttribute.hasOwnProperty("SaveForLater") && e.data.testAttribute["SaveForLater"] == 1) || e.data.submited == true) {
			e.data.paused = true;
			UrlMgmt.getObj().PopView();
			e.data.pauseTime = new Date().getTime();
		}*/
	});
	$("#testbackbtnwarningModal .CancelBtn").unbind().click(function() {
		if (self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"] == 1) {
			var usedTime = (new Date().getTime() - self.startedAt) / 1000;
			self.meta["userLastactivetime"] = -1;
			writeData("testmeta_" + self.testId + ".json", 'testmeta', self.testId, self.meta, function() {
				if ( typeof cb != 'undefined')
					cb();
			});
		}
		if (!(self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"] == 1) || self.submited == true) {
			self.paused = true;
			$("#testbackbtnwarningModal").modal('hide');
			UrlMgmt.getObj().PopView();
			self.pauseTime = new Date().getTime();
		}
		$("#testbackbtnwarningModal").modal('hide');
		self.paused = true;
		UrlMgmt.getObj().PopView();
		self.pauseTime = new Date().getTime();
	}.bind(this));
	$("#testbackbtnwarningModal #confirmclosetest").unbind().click( function() {
		$("#testbackbtnwarningModal").modal('hide');
	}.bind(this));

	$(".sectionNavIcon").unbind().click(function() {
		if ($(this).hasClass("disable"))
			return;
		self.NavigateSectionIndex(this);
	});
	$("#saveForLaterIBPS").unbind().click(function() {
		self.SaveQuestion();
		var saveLimit = self.meta.pauseLeft - 1;
		if (self.pausedtimdetl["pauseLeft"] != undefined && self.pausedtimdetl["pauseLeft"] > 0) {
			saveLimit = self.pausedtimdetl["pauseLeft"] - 1;
		}

		if (saveLimit > 0) {
			$("#saveForLaterIBPSModal p.saveLimitInfo").html("You can save this test " + saveLimit + " more time");
		} else if (saveLimit == 0) {
			$("#saveForLaterIBPSModal p.saveLimitInfo").html("You will not be able to save this test again.This is the last chance!!");
		}
	});
	$("#saveForLaterIBPSModal .CancelBtn").click(function() {
		$("#saveForLaterIBPSModal").modal('hide');
	});
	$("#confirmSaveIBPS").unbind().bind("click",function(){
		var saveLimit = self.meta.pauseLeft;
		if (saveLimit > 0 || saveLimit == -1) {
			UrlMgmt.getObj().showLoader(false);
			self.PauseTest();
			$("#saveForLaterIBPSModal").modal('hide');
		} else {
			alert("You can not Save this test.Click OK to continue Test!!");
			$("#saveForLaterIBPSModal").modal('hide');
		}
	}.bind(this));

	document.addEventListener('pause', function() {
		if (self.testAttribute.hasOwnProperty("SaveForLater") && self.testAttribute["SaveForLater"] == 1) {
			var usedTime = (new Date().getTime() - self.startedAt) / 1000;
			self.lastresumetim["usedTime"] = Math.round(usedTime);
			self.lastresumetim["lastactive"] = Math.floor(Date.now() / 1000);
			self.meta["userLastactivetime"] = self.lastresumetim;
			writeData("testmeta_" + self.testId + ".json", 'testmeta', self.testId, self.meta, function() {
				if ( typeof cb != 'undefined')
					cb();
			});
		}
	}, false);
	
	//section submit modal events
	var $submitSectionModal = $('#ibps-confirmSectionSubmit');
	
	$submitSectionModal.find('.js-submit-section').off().on('click',function(){
		self.submitSection();
		self.switchSection(true);
		$submitSectionModal.modal('hide');
		$('.SectionInfo.selected .cancelBtn.js-cancel').click();
	});
	
	$submitSectionModal.find('.js-hide-submit').off().on('click',function(){
		$submitSectionModal.modal('hide');
	});
	
	$submitSectionModal.find('.js-show-submit-test-modal').off().on('click',function(){
		$submitSectionModal.modal('hide');
		self.onSubmitButtonClick();
	});
	var $submitSectionModal1 = $('#ibps-confirmSectionSubmit1');
	
	$submitSectionModal1.find('.js-submit-section').off().on('click',function(){
		self.submitSection();
		self.switchSection(true);
		$submitSectionModal1.modal('hide');
		$('.SectionInfo').removeClass("selected");
	  	$('.SectionInfo-overlay').hide();
	});
	
	$submitSectionModal1.find('.js-hide-submit').off().on('click',function(){
		$submitSectionModal1.modal('hide');
	});
	
	$submitSectionModal1.find('.js-show-submit-test-modal').off().on('click',function(){
		$submitSectionModal1.modal('hide');
		self.onSubmitButtonClick();
	});
};
appibpstestController.prototype.UpdateTestHistry = function(lpauseId, currentState, sessionId) {
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = "http://" + remoteServer + "/ajax"+"/testId="+this.testId;
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "updatetesthistory";
	}	
	$.ajax({
		url : "http://" + remoteServer + "/ajax",
		type : 'POST',
		data : {
			mod : "testapi",
			ack : "updatetesthistory",
			lastpauseId : lpauseId,
			testId : this.testId,
			tempUserId : tempUserId,
			testState : currentState,
			session : sessionId
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		success : function(reply) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "success";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (reply.result.state == "ok") {
				if (reply.data["id"] > 0) {
					this.meta["pausedetail"] = reply.data;
					writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
						if ( typeof cb != 'undefined')
							cb();
					});
				}
			} else {
				alert(reply.result.meta);
			}
			UrlMgmt.getObj().removeLoader();
		}.bind(this),
		error : function(jqXHR, exception) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "error";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			UrlMgmt.getObj().removeLoader();
			if (jqXHR.status === 0) {
				this.pausedtimdetl["id"] = -1;
				this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now() / 1000);
				this.pausedtimdetl["pauseLeft"] = -1;
				this.pausedtimdetl["usedTime"] = this.passedTime;
				if (this.pauseLeft != -1) {
					this.pausedtimdetl["pauseLeft"] = this.pauseLeft;
				}
				this.meta["pausedetail"] = this.pausedtimdetl;
				if (this.meta["pausehistorystored"] == undefined) {
					this.meta["pausehistorystored"] = [];
				}
				this.meta["pausehistorystored"].push({
					"UT" : this.passedTime,
					"pausebrk" : Math.floor(Date.now() / 1000)
				});
				writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
					if ( typeof cb != 'undefined')
						cb();
				});

			} else if (jqXHR.status == 404) {
				alert('Requested page not found. [404]');
			} else if (jqXHR.status == 500) {
				alert('Internal Server Error [500].');
			} else if (exception === 'parsererror') {
				alert('Requested JSON parse failed.');
			} else if (exception === 'timeout') {
				alert('Time out error.');
			} else if (exception === 'abort') {
				alert('Ajax request aborted.');
			} else {
				alert('Uncaught Error.\n' + jqXHR.responseText);
			}
		},
	});
};
appibpstestController.prototype.PauseTest = function() {
	var usedTime = (new Date().getTime() - this.startedAt) / 1000;
	usedTime = Math.round(usedTime);
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer + "/ajax"+"/testId="+this.testId+"/session="+this.sessionID+"";
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "insertPauseHistory";
	}	
	$.ajax({
		type : "POST",
		url : remoteServer + "/ajax",
		data : {
			mod : "testapi",
			ack : "insertPauseHistory",
			testId : this.testId,
			session : this.sessionID,
			usedTime : usedTime,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		success : function(reply) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "success";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (reply.result.state == "ok") {
				if (reply.data["state"] == 1) {
					this.paused = true;
					this.meta["pausedetail"] = reply.data;
					writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
						if ( typeof cb != 'undefined')
							cb();
					});

					this.testState = testState.Paused;
					this.pausedQue = this.ShowingQuestionNo;
					writeData("testpauseque_" + this.sessionID + ".json", 'testpauseque', this.sessionID, this.pausedQue, function() {
						if ( typeof cb != 'undefined')
							cb();
					});
					this.SaveQuestion();
					this.parent.SetState(this.testId, this.testState);
					UrlMgmt.getObj().PopView();
				} else {
					alert("You can not pause this Test!!");
					UrlMgmt.getObj().removeLoader();
				}
			} else {
				alert(reply.result.meta);
			}
			UrlMgmt.getObj().removeLoader();
		}.bind(this),
		error : function(jqXHR, exception) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "error";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (jqXHR.status === 0) {
				this.paused = true;
				this.pausedtimdetl["id"] = -1;
				this.pausedtimdetl["usedTime"] = usedTime;
				this.pausedtimdetl["pauseBreakedAt"] = Math.floor(Date.now() / 1000);
				this.pausedtimdetl["pauseLeft"] = -1;
				if (this.testAttribute["SaveLimit"] != undefined) {
					this.pausedtimdetl["pauseLeft"] = this.pauseLeft - 1;
				}
				this.meta["pausedetail"] = this.pausedtimdetl;
				writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
					if ( typeof cb != 'undefined')
						cb();
				});

				this.testState = testState.Paused;
				this.pausedQue = this.ShowingQuestionNo;
				writeData("testpauseque_" + this.sessionID + ".json", 'testpauseque', this.sessionID, this.pausedQue, function() {
					if ( typeof cb != 'undefined')
						cb();
				});
				this.SaveQuestion();
				this.parent.SetState(this.testId, this.testState);
				UrlMgmt.getObj().PopView();
				UrlMgmt.getObj().removeLoader();
			} else if (jqXHR.status == 404) {
				alert('Requested page not found. [404]');
			} else if (jqXHR.status == 500) {
				alert('Internal Server Error [500].');
			} else if (exception === 'parsererror') {
				alert('Requested JSON parse failed.');
			} else if (exception === 'timeout') {
				alert('Time out error.');
			} else if (exception === 'abort') {
				alert('Ajax request aborted.');
			} else {
				alert('Uncaught Error.\n' + jqXHR.responseText);
			}
		},
	});
};
appibpstestController.prototype.SavePrevQuestion = function(flaged) {
	var prevQuestion = parseInt($("#Question").attr("qNo"));
	if (prevQuestion > 0) {
		if (this.userActivity[prevQuestion - 1].questionNo == 0) {
			this.userActivity[prevQuestion - 1].questionNo = $("#QuestionBody .Question").attr("qId");
			this.userActivity[prevQuestion - 1].sQId = $("#QuestionBody .Question").attr("sQId");
		}
		
		var prevState = this.userActivity[prevQuestion - 1].state;
		var prevAns = JSON.stringify(this.userActivity[prevQuestion - 1].ans);
		var prevFlag = this.userActivity[prevQuestion - 1].flaged;
		this.userActivity[prevQuestion - 1].flaged = flaged;
		var state = AnswerStatus.SKIPED;

		var answered = false;
		var self = this;
		var counter = 0;
		var qType = parseInt($("#Question").attr("qtype"));
		if (qType == QuestionType.BLANK) {
			$(".Answers select").each(function() {
				var selectVal = $(this).val();
				self.userActivity[prevQuestion - 1].ans[counter] = selectVal;
				if (selectVal > -1) {
					answered = true;
				}
				counter++;
			});
		} else if (qType == QuestionType.NIQ) {
			this.userActivity[prevQuestion - 1].ans[0] = $("#Question").find(".keyboardwrite").val();
			if ($("#Question").find(".keyboardwrite").val()) {
				answered = true;
			}
		} else {
			$(".Answers .Answer").each(function() {
				hasSelectedAns = $(this).hasClass("selectedAns");
				self.userActivity[prevQuestion - 1].ans[counter] = hasSelectedAns;
				answered |= hasSelectedAns;
				counter++;
			});
		}
		this.userActivity[prevQuestion-1]["answeredDate"] = new Date();
		state = answered ? AnswerStatus.ANSWERED : AnswerStatus.SKIPED;
		this.ChangeQuestionState(prevQuestion, state);

		this.userActivity[prevQuestion - 1].state = state;
		if (this.startNewQuestionAt != "" && this.ShowingQuestionNo != -1) {
			
			if (this.userActivity[prevQuestion - 1].timeSpent == -1)
			{
				this.userActivity[prevQuestion - 1].timeSpent++;
				this.userActivity[prevQuestion - 1].timeSpent += parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000);
				this.questionContinue = true;
				this.timespentincurrentquestion = this.userActivity[prevQuestion - 1].timeSpent;
			}
			else
			{
				if(UrlMgmt.getObj().App.isOnline)
				{
					if(this.questionContinue)
					{
						 if (!(prevAns == JSON.stringify(this.userActivity[prevQuestion - 1].ans) && prevState == this.userActivity[prevQuestion - 1].state && prevFlag == this.userActivity[prevQuestion - 1].flaged)) 
						 {					 	
							this.userActivity[prevQuestion - 1].timeSpent = Math.abs(parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000) - this.timespentincurrentquestion);	
						 }
						 else
						 {
						 	this.userActivity[prevQuestion - 1].timeSpent = Math.abs(parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000) - this.timespentincurrentquestion);	
						 }	
						 this.timespentincurrentquestion += this.userActivity[prevQuestion - 1].timeSpent;
					}
					else
					{	
						this.userActivity[prevQuestion - 1].timeSpent = Math.abs(parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000) - this.timespentincurrentquestion);	
						this.timespentincurrentquestion += this.userActivity[prevQuestion - 1].timeSpent;
						this.questionContinue = true;
					}
				}
				else
				{
					this.userActivity[prevQuestion - 1].timeSpent = parseInt((new Date().getTime() - this.startNewQuestionAt) / 1000);
				}
				
			}
		}
		// if (!(prevAns == JSON.stringify(this.userActivity[prevQuestion - 1].ans) && prevState == this.userActivity[prevQuestion - 1].state && prevFlag == this.userActivity[prevQuestion - 1].flaged)) {
			this.SaveQuestion(prevQuestion);
		// }
	}
};

appibpstestController.prototype.PopulateHeader = function() {
	$(".header").text($('._test_').text());
	this.totalTime = $("#_totalTime_").text() * 60 * 1000;

	if (this.meta["startedAt"] == undefined || typeof this.meta["startedAt"] == "string") {
		this.startedAt = new Date().getTime() - this.passedTime * 1000;
	} else {
		this.startedAt = this.meta["startedAt"].getTime();
	}
	this.remainingTime = this.totalTime - this.passedTime * 1000;

	for (key in this.languageOptions) {
		var option = $('<option value="' + this.languageOptions[key] + '">' + TestLanguageType.Str[this.languageOptions[key]] + '</option>');
		if (option.val() == this.language)
			option.attr("selected", "selected");
		$("#SelectTestLanguageWithin").append(option);
	}
	$('#SelectTestLanguageWithin').change( function(e) {
		this.obj.language = e.target.value;
		selectedQuestion = parseInt($("#Question").attr("qNo"));
		this.obj.ShowQuestion(selectedQuestion, this.obj.language);
	}.bind({      
		obj : this
	}));
	if(this.testTheme == Theme.SSCTHEME)
	{
		// $(this.dom).find(".ChooseLanguageWithinTest").hide();
	}	
};

appibpstestController.prototype.PopulateQuestionPalette = function() {

    
    	if (this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"] == 1) {
		// $('#rightfoot').find(".SavL").append('<div class="Saved"><button id="saveForLaterIBPS" class="saveL" ' + 'savelimit=' + this.pauseLeft + ' canpause="false">Save For Later</button></div>');
	       $('#leftFooter').find(".SaveNSaveL").append('<div class="Saved"><button id="saveForLaterIBPS" class="Next" ' + 'savelimit=' + this.meta.pauseLeft + ' canpause="false">Save For Later</button></div>');
	    } 

	$("#IBPSQuestionPaperBtn").append('<x-icon src="icon_question-paper" class="qtionPaperIcon">' + questionpaperIcon + '</x-icon>Question Paper');
	$("#IBPSInstructionsBtn").append('<x-icon src="icon_instruction" class="instructionIcon">' + instructionIcon + '</x-icon>Instructions');
	var hideLeft = $('.QPalleteBtn');
	hideLeft.append('<x-icon class="leftHideShowBtn open shownIcon">' + arrowEIcon + '</x-icon><x-icon class="leftHideShowBtn closed">' + arrowWIcon + '</x-icon>');

	this.questionOrder = JSON.parse($("#_questionOrder_").text());
	// $(".scroll-left").append(arrowWIcon);
	// $(".scroll-right").append(arrowEIcon);
	
	//override for psyco test
	if(this.isPsycoTest || this.sectionalTimeBound )
	{
		for(s in this.questionOrder)
		{
			this.meta["sections"][s].allotedTime = this.questionOrder[s].allotedTime;
			this.meta["sections"][s].breakTime = this.questionOrder[s].breakTime;
			this.meta["sections"][s]["submitted"] = 0; 
			this.meta["sections"][s]["breakEnded"] = (this.meta["sections"][s].breakTime > 0) ? 0 : 1;
			if(this.meta["sections"][s]["sectionMeta"]=="")
			{
				if(s==0)
				{
					this.meta["sections"][s]["startedAt"] = new Date().getTime();
				}
				else
				{
					this.meta["sections"][s]["startedAt"] = this.meta["sections"][s-1]["breakStartTime"] + this.meta["sections"][s-1].breakTime * 60 * 1000; 
				}
				this.meta["sections"][s]["breakStartTime"] = this.meta["sections"][s]["startedAt"] + this.meta["sections"][s].allotedTime * 60 * 1000; 
				var obj  = {
					"startedAt":this.meta["sections"][s]["startedAt"],
					"submitted":this.meta["sections"][s]["submitted"],
					"breakStartTime":this.meta["sections"][s]["breakStartTime"],
					"breakEnded":this.meta["sections"][s]["breakEnded"],
					"allotedTime":this.meta["sections"][s]["allotedTime"]
					};
				this.UpdateSectionMeta(s,obj);
			}
			else
			{
				var sectionMeta = JSON.parse(this.meta["sections"][s]["sectionMeta"]);
				this.meta["sections"][s]["startedAt"] = sectionMeta["startedAt"];
				this.meta["sections"][s]["submitted"] = sectionMeta["submitted"];
				this.meta["sections"][s]["breakStartTime"] = sectionMeta["breakStartTime"];
				this.meta["sections"][s]["breakEnded"] = sectionMeta["breakEnded"];
				this.meta["sections"][s]["allotedTime"] = sectionMeta["allotedTime"];
			}
			
			this.sectionName[s] = this.questionOrder[s].name;
			
			if(this.isPsycoTest && this.questionOrder[s].sectionMeta && typeof this.questionOrder[s].sectionMeta.instructionTime !== 'undefinded' && this.questionOrder[s].sectionMeta.instructionTime > 0)
			{
				var sBtn = $('<span class="sectionNav PIns" sectionId="'+s+'">'+
								'<div class="SectionBtn font" sectionId="'+s+'" submitted="'+this.meta["sections"][s]["submitted"]+'">'+this.questionOrder[s].name+' Instructions</div>'+
							'</span>').appendTo($("#sectionPanel .fieldset"));
			}
						
			sBtn = $('<li class="sectionNav PQues" sectionId="'+s+'">'+
							'<div class="SectionBtn font" sectionId="'+s+'" submitted="'+this.meta["sections"][s]["submitted"]+'">'+this.questionOrder[s].name+'</div>'+
							// '<x-icon src="icon_instruction"></x-icon>'+
							'<div class="SectionInfo-overlay"></div>'+
							'<div class="SectionInfo" sectionId="'+s+'">'+
								'<div class="SectionName">'+this.questionOrder[s].name+'</div>'+
								'<div class="SectionInfoCount">'+
									'<div class="SectionInfoLeft">'+
										'<div class="attemptedIcon Icon">'+
											'Answered'+
											'<span>(<span class="count"></span>)</span>'+
										'</div>'+
										'<div class="skippedIcon Icon">'+
											'Not Answered'+
											'<span>(<span class="count"></span>)</span>'+
										'</div>'+
										'<div class="missedIcon Icon">'+
											'Not Visited'+
											'<span>(<span class="count"></span>)</span>'+
										'</div>'+
									'</div>'+
									'<div class="SectionInfoRight">'+
										'<div class="review_answeredIcon Icon">'+
											'Ans & Flagged'+
											'<span>(<span class="count"></span>)</span>'+
										'</div>'+
										'<div class="reviewIcon Icon">'+
											'Flagged'+
											'<span>(<span class="count"></span>)</span>'+
										'</div>'+
									'</div>'+
								'</div>'+
								'<div class="operation-btns">'+
									'<button class="cancelBtn js-cancel"><img src="https://cdn.toprankers.net/images/modalclose-02495aa68192e.png" alt="Cancel">CANCEL</button>'+
									'<button class="IBPSSubmitBtn">SUBMIT TEST<img src="https://cdn.toprankers.net/images/submit-024949d2ed4b5.png" alt="Submit Test"></button>'+
								'</div>'+
							'</div>'+	
						'</li>').appendTo($("#sectionPanel .fieldset"));
		}
	}
	else
	{
		if(this.showsectional)
		{
			if (this.suffleInterSection)
			{
				for (s in this.questionOrder)
				{
					this.sectionName[s] = this.questionOrder[s].name;
					var sBtn = $('<li class="sectionNav" sectionId="' + s + '">' +
									'<div class="SectionBtn font" sectionId="' + s + '">' + this.questionOrder[s].name + '</div>' +
									// '<x-icon src="icon_instruction">' + instructionIcon + '</x-icon>'+
									'<div class="SectionInfo-overlay"></div>'+
									'<div class="SectionInfo" sectionId="' + s + '">' +
										'<div class="SectionName">' + this.questionOrder[s].name + '</div>'+
										'<div class="SectionInfoCount">' +
											'<div class="SectionInfoLeft">'+
											'<div class="attemptedIcon Icon">'+
												'Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="skippedIcon Icon">'+
												'Not Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="missedIcon Icon">'+
												'Not Visited'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'<div class="SectionInfoRight">'+
											'<div class="review_answeredIcon Icon">'+
												'Ans & Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="reviewIcon Icon">'+
												'Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'</div>'+
										'<div class="operation-btns">'+
											'<button class="cancelBtn js-cancel"><img src="https://cdn.toprankers.net/images/modalclose-02495aa68192e.png" alt="Cancel">CANCEL</button>'+
											'<button class="IBPSSubmitBtn">SUBMIT TEST<img src="https://cdn.toprankers.net/images/submit-024949d2ed4b5.png" alt="Submit Test"></button>'+
										'</div>'+
									'</div>'+	
								'</li>').appendTo($("#IBPSTest .ibpsContainer .leftPart"));
								
				}
			}
			else
			{
				for (s in this.questionOrder)
				{
					this.sectionName[s] = this.questionOrder[s].name;
					var sBtn = $('<li class="sectionNav" sectionId="' + s + '">' +
									'<div class="SectionBtn font" sectionId="' + s + '">' + this.questionOrder[s].name + '</div>' +
									// '<x-icon src="icon_instruction">' + instructionIcon + '</x-icon>'+
									'<div class="SectionInfo-overlay"></div>'+
									'<div class="SectionInfo" sectionId="' + s + '">' +
										'<div class="SectionName">' + this.questionOrder[s].name + '</div>'+
										'<div class="SectionInfoCount">' +
											'<div class="SectionInfoLeft">'+
											'<div class="attemptedIcon Icon">'+
												'Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="skippedIcon Icon">'+
												'Not Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="missedIcon Icon">'+
												'Not Visited'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'<div class="SectionInfoRight">'+
											'<div class="review_answeredIcon Icon">'+
												'Ans & Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="reviewIcon Icon">'+
												'Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'</div>'+
										'<div class="operation-btns">'+
											'<button class="cancelBtn js-cancel"><img src="https://cdn.toprankers.net/images/modalclose-02495aa68192e.png" alt="Cancel">CANCEL</button>'+
											'<button class="IBPSSubmitBtn">SUBMIT TEST<img src="https://cdn.toprankers.net/images/submit-024949d2ed4b5.png" alt="Submit Test"></button>'+
										'</div>'+
									'</div>'+	
								'</li>').appendTo($("#sectionPanel .fieldset"));
				}
			}			
		}
		else if (this.suffleInterSection || this.testTheme == Theme.SSCTHEME || this.testTheme == Theme.NEETTHEME)
			{
				for (s in this.questionOrder)
				{
					this.sectionName[s] = this.questionOrder[s].name;
					var sBtn = $('<li class="sectionNav" sectionId="' + s + '">' +
									'<div class="SectionBtn font" sectionId="' + s + '">' + this.questionOrder[s].name + '</div>' +
									// '<x-icon src="icon_instruction">' + instructionIcon + '</x-icon>'+
									'<div class="SectionInfo-overlay"></div>'+
									'<div class="SectionInfo" sectionId="' + s + '">' +
										'<div class="SectionName">Test Information</div>'+ //  '+ this.questionOrder[s].name +' 
										'<div class="SectionInfoCount">' +
											'<div class="SectionInfoLeft">'+
											'<div class="attemptedIcon Icon">'+
												'Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="skippedIcon Icon">'+
												'Not Answered'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="missedIcon Icon">'+
												'Not Visited'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'<div class="SectionInfoRight">'+
											'<div class="review_answeredIcon Icon">'+
												'Ans & Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
											'<div class="reviewIcon Icon">'+
												'Flagged'+
												'<span>(<span class="count"></span>)</span>'+
											'</div>'+
										'</div>'+
										'</div>'+
										'<div class="operation-btns">'+
											'<button class="cancelBtn js-cancel"><img src="https://cdn.toprankers.net/images/modalclose-02495aa68192e.png" alt="Cancel">CANCEL</button>'+
											'<button class="IBPSSubmitBtn">SUBMIT TEST<img src="https://cdn.toprankers.net/images/submit-024949d2ed4b5.png" alt="Submit Test"></button>'+
										'</div>'+
									'</div>'+	
								'</li>').appendTo($("#IBPSTest .ibpsContainer .leftPart "));
								
								
				}
				$("#IBPSTest #sectionPanel").hide();
			}
		else{
			var sBtn = '';
			
		}

	}
	
	
	if(this.showsectional)
	{
		var qNoInSection = 1;
		var currentSectionId = 0;
		for (var qNo in this.meta.questions) {
			var q = this.meta.questions[qNo];
			var qId = q.questionId;
			var sQId = q.subQuestionId;
			var sectionId = q.sectionId;
			if (sectionId != currentSectionId && !this.suffleInterSection) {
				currentSectionId = sectionId;
				qNoInSection = 1;
			}
			var className = "Icon qIndicator";
	
			if (this.sessionID > 0) {
				this.userActivity[qNo - 1] = {
					ans : [],
					state : AnswerStatus.MISSED,
					questionNo : qId,
					sQId : sQId,
					timeSpent : -1,
					flaged : false
				};
				if (q.hasOwnProperty("answer") && q.answer.hasOwnProperty("ans")) {
					this.userActivity[qNo - 1] = {
						ans : q.answer.ans,
						state : q.answer.state,
						questionNo : qId,
						sQId : sQId,
						timeSpent : -1,
						flaged : (q.flag == 1)
					};
	
					if (q.flag == 1 && q.answer.state == AnswerStatus.ANSWERED)
						className += " review_answeredIcon";
					else if (q.flag == 1 && q.answer.state == AnswerStatus.SKIPED)
						className += " reviewIcon";
					else if (q.answer.state == AnswerStatus.ANSWERED)
						className += " attemptedIcon";
					else
						className += " skippedIcon";
				} else {
					className += " missedIcon";
				}
				this.ansOrder[qNo - 1] = q.meta;
			}
	
			var icon = '<div class="' + className + '" qNo="' + qNo + '" qId="' + qId + '" sQId="' + sQId + '" ' + 'sectionId="' + sectionId + '" qNoInSection="' + qNoInSection + '">' + qNoInSection + '</div>';
			$("#QuestionPalette .QNavigator").append(icon);
			qNoInSection++;
		}
	
	}
	else
	{
		var qNoInSection = 1;
		var currentSectionId = 0;
		for (var qNo in this.meta.questions) {
			var q = this.meta.questions[qNo];
			var qId = q.questionId;
			var sQId = q.subQuestionId;
			var sectionId = q.sectionId;
			if (sectionId != currentSectionId && !this.suffleInterSection) {
				currentSectionId = sectionId;
				qNoInSection = 1;
			}
			var className = "Icon qIndicator";
	
			if (this.sessionID > 0) {
				this.userActivity[qNo - 1] = {
					ans : [],
					state : AnswerStatus.MISSED,
					questionNo : qId,
					sQId : sQId,
					timeSpent : -1,
					flaged : false
				};
				if (q.hasOwnProperty("answer") && q.answer.hasOwnProperty("ans")) {
					this.userActivity[qNo - 1] = {
						ans : q.answer.ans,
						state : q.answer.state,
						questionNo : qId,
						sQId : sQId,
						timeSpent : -1,
						flaged : (q.flag == 1)
					};
	
					if (q.flag == 1 && q.answer.state == AnswerStatus.ANSWERED)
						className += " review_answeredIcon";
					else if (q.flag == 1 && q.answer.state == AnswerStatus.SKIPED)
						className += " reviewIcon";
					else if (q.answer.state == AnswerStatus.ANSWERED)
						className += " attemptedIcon";
					else
						className += " skippedIcon";
				} else {
					className += " missedIcon";
				}
				this.ansOrder[qNo - 1] = q.meta;
			}
	
			var icon = '<div class="' + className + '" qNo="' + qNo + '" qId="' + qId + '" sQId="' + sQId + '" ' + 'sectionId="' + 0 + '" qNoInSection="' + qNoInSection + '">' + qNo + '</div>';
			$("#QuestionPalette .QNavigator").append(icon);
			qNoInSection++;
		}		
	}
	
	
	$(".SectionBtn[sectionId='0']").parent().addClass("Selected");
	if(this.suffleInterSection || this.testTheme == Theme.SSCTHEME || this.testTheme == Theme.NEETTHEME)
	{
		/* hide section*/
		$('#sectionPanel, #sectionPanel-2, #viewingSection').hide();
		
	}
	else
	{
		$(".qIndicator:not([sectionId='0'])").css("display", "none");
	}
	
	//for psyco test
	if(this.isPsycoTest)
    {
    	//Hide Question Pallete
    	this.showHideQuestionPallete(true);
    	
    	//add section timer
    	var $sectionTimer = $('<span class="SectionTimeLeft">00:00:00</span>');
    	$('#TimeLeft').after($sectionTimer);
    	
    	var QuePaletteSectionTimer = $('<span>Section:&nbsp;<span data-action="total-testsection-time">00:00:00</span></span>');
    	$('#timeSection').append(QuePaletteSectionTimer);
    	
    	//hide test timer
    	$('#TimeLeft').hide();
    }
    
    if(this.sectionalTimeBound)
    {
    	$('<div class="timerPanel font" style="height:23px;">'+
			'<div class="col-xs-6 col-sm-6 col-md-6 testTimeLeft">Section Time Left: <span class="SectionTimeLeft">00:00:15</span></div>'+
		'</div>').insertBefore($('.timerPanel.font'));
		var QuePaletteSectionTimer = $('<span>Section:&nbsp;<span data-action="total-testsection-time">00:00:00</span></span>');
    	$('#timeSection').append(QuePaletteSectionTimer);
    }
    else{
    	$('[data-action=total-testsection-time-outerdiv]').remove();
    }
};
appibpstestController.prototype.NavigateSectionIndex = function(btn) {
	$(btn).addClass("disable");
	$($(btn).siblings(".sectionNavIcon")).addClass("disable");
	var dom = $(btn).siblings(".fieldset")[0];
	var w = $(".sectionNav.Selected").width();
	var shift = $(btn).hasClass("prev") ? dom.scrollLeft - w : dom.scrollLeft + w;
	$(dom).animate({
		scrollLeft : shift
	}, 400, function() {
		this.obj.ValidateNavigator(this.dom);
	}.bind({
		obj : this,
		dom : dom
	}));
};
appibpstestController.prototype.ValidateNavigator = function(dom) {
	var maxScrollLeft = dom.scrollWidth - dom.clientWidth;
	/*
	if (dom.scrollLeft == 0)
		// $(dom).siblings(".sectionNavIcon.prev").addClass("disable");
	else
		// $(dom).siblings(".sectionNavIcon.prev").removeClass("disable");

	if (maxScrollLeft <= dom.scrollLeft + 1)
		// $(dom).siblings(".sectionNavIcon.next").addClass("disable");
	else
		// $(dom).siblings(".sectionNavIcon.next").removeClass("disable");
		*/
};
appibpstestController.prototype.ShowQuestion = function(qNo) {
	
	
	$("#QPart").addClass("animatepanel");
	setTimeout(function(){
		$("#QPart").removeClass("animatepanel");
   $(".BottomPart .RightHandIcon").removeClass("Selected");	
   $(".BottomPart .LeftHandIcon").removeClass("Selected");	
	},200);
	if(this.isPsycoTest)
	{
		return this.StartSectionTimer();
	}
	
	writeData("testpauseque_" + this.sessionID + ".json", 'testpauseque', this.sessionID, qNo, function() {
		if ( typeof cb != 'undefined')
			cb();
	});
	//Clean Floating right box
	$('.floated-answerBox').html('');

	qNo = parseInt(qNo);
	this.startNewQuestionAt = new Date().getTime();
	this.ShowingQuestionNo = qNo;
	var q = $('.qIndicator[qNo="' + qNo + '"]');
	var state = AnswerStatus.MISSED;
	if (this.userActivity[qNo - 1] != null) {
		state = this.userActivity[qNo - 1].state;
	}
	if (state == AnswerStatus.MISSED) {
		q.removeClass("missedIcon");
		q.addClass("skippedIcon");
		this.userActivity[qNo - 1].state = AnswerStatus.SKIPED;
	}

	var sectionId = q.attr("sectionId");
	this.currentSectionId = sectionId;
	//var calculate1 = (typeof $(".testsectioncontent").scrollLeft() != "undefined" ?$(".testsectioncontent").scrollLeft(): 0 ) + (typeof $('.sectionNav[sectionid="' + (sectionId) + '"]').offset().left != "undefined" ? $('.sectionNav[sectionid="' + (sectionId) + '"]').offset().left:0) - (typeof $(".testsectioncontent").offset().left !="undefined" ? 1:0) - $(".testsectioncontent")[0].clientWidth / 2 + $('.sectionNav[sectionid="' + (sectionId) + '"]').outerWidth(true) / 2;
	var calculate1 = (typeof $(".testsectioncontent").scrollLeft() != "undefined" ?$(".testsectioncontent").scrollLeft(): 0 )+ 
					 (typeof $('.sectionNav[sectionid="' + (sectionId) + '"]').offset() != "undefined" ? $('.sectionNav[sectionid="' + (sectionId) + '"]').offset().left:0 )- 
					 (typeof $(".testsectioncontent").offset().left != "undefined"  ? $(".testsectioncontent").offset().left: 0 ) - 
					 (typeof $(".testsectioncontent")[0].clientWidth !="undefined" ? $(".testsectioncontent")[0].clientWidth : 0 ) / 2 + 
					 (typeof $('.sectionNav[sectionid="' + (sectionId) + '"]').outerWidth(true) ? $('.sectionNav[sectionid="' + (sectionId) + '"]').outerWidth(true) : 0) / 2;

	
	$('.testsectioncontent').animate({
		scrollLeft : calculate1
	}, 1000);
	if (sectionId != $(".SectionBtn.Selected").attr("sectionId")) {
		$(".qIndicator").css("display", "inline-block");
		$(".SectionBtn,.sectionNav").removeClass("Selected");
		if(!this.suffleInterSection)
		{
			$(".qIndicator:not([sectionId='"+sectionId+"'])").css("display", "none");
			$(".qIndicator:not([sectionId='" + sectionId + "'])").css("display", "none");
		}
		
		$(".SectionBtn[sectionId='" + sectionId + "'],.sectionNav[sectionId='" + sectionId + "']").addClass("Selected");
	}
	
	$("#viewingSection").text(this.sectionName[sectionId]);
	var qNoInSection = q.attr("qNoInSection");
	if(!this.showsectional)
	{
		$("#QuestionNo").text(qNo);
	}
	else{
		$("#QuestionNo").text(qNoInSection);
	}
	
	var qId = q.attr("qId");
	var sQId = q.attr("sQId");
	var qDiv = $("._question_[qId='" + qId + "'][sQId='" + sQId + "'][language='" + TestLanguageType.Str[this.language] + "']");
	if (!qDiv.length) {
		qDiv = $("._question_[qId='" + qId + "'][sQId='" + sQId + "']:eq(0)");
	}
	$("#Question").attr("qNo", qNo);
	$("#Question").attr("qId", qId);
	$("#Question").attr("sQId", sQId);

	var qtype = qDiv.attr("qType");
	$(".questionTypePanel #QuestionType").text(QuestionType.Str[qtype]);
	$("#QPart > .Question").attr("qactualtype", qtype);
	loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data) {
		if ( typeof qtype != undefined && parseInt(qtype) == QuestionType.BLANK) {
			this.ShowFillInTheBankQuestion(qDiv, qNo, data);
		} else if ( typeof qtype != undefined && parseInt(qtype) == QuestionType.NIQ) {
			this.ShowNIQQuestion(qDiv, qNo, data);
		} else {
			this.ShowMCQQuestion(qDiv, qNo, qId, sQId, parseInt(qtype), data);
		}

		MathJax.Hub.Queue(["Typeset", MathJax.Hub, $("#Question").get(0)], function() {
			var cWidth = $('#IBPSTest #Question').width();
			var wWidth = $(window).width();
			if (cWidth < (wWidth / 2) || cWidth > (wWidth - 40)) {
				cWidth = wWidth - 40;
			}
			$("#IBPSTest #Question span.MathJax_CHTML").each(function() {
				if ($(this).width() > cWidth) {
					$(this).css({
						'max-width' : cWidth + 'px'
					});
					$(this).addClass("scroll-x");
				}
			});
			$("#IBPSTest #Question .questionText,  #IBPSTest #Question .AnswerText").html(function(i, h) {
				return h.replace(/&nbsp;/g, ' ');
			});
		});
		var scrollheight = $(".questionTextData").outerHeight();
		var flag = false;   
		if(scrollheight > glyheight){
		   	  $('.questionTextData').css("height",glyheight); 
		   	  $("#Question").find(".js-explore-qtn").show();
		   	  $('.glyphicon.glyphicon-chevron-down').css("color","#30B8E2");
		}
		else if(scrollheight <= glyheight) {
		   	  $('.questionTextData').css("height","auto");  
		   	  $("#Question").find(".js-explore-qtn").hide();
		}
		$("#Question").find(".js-explore-qtn").unbind().bind("click", this, function(e) 
		{
			if(flag == true)       
			{   
				$('.questionTextData').css("height",glyheight+"px"); 
				$('.glyphicon.glyphicon-chevron-down').css("transform","rotate(0deg)");
				$('.glyphicon.glyphicon-chevron-down').css("color","#30B8E2");
				flag = false;   
			}
			else
			{   
				$('.questionTextData').css("height",scrollheight+"px");
			    $('.glyphicon.glyphicon-chevron-down').css("transform","rotate(180deg)");
			    $('.glyphicon.glyphicon-chevron-down').css("color","#FFAB0B");
			    flag = true;
			}
		});	
		$(".questionTextData").unbind().bind("click",this,function(e)
		{

			if(scrollheight > glyheight)
			{
				if(flag == false)       
				{ 
					$('.questionTextData').css("height",scrollheight+"px");
					$('.glyphicon.glyphicon-chevron-down').css("transform","rotate(180deg)");
				    $('.glyphicon.glyphicon-chevron-down').css("color","#FFAB0B");
				    flag = true;
				}
				else{
					$('.questionTextData').css("height",glyheight+"px");
					$('.glyphicon.glyphicon-chevron-down').css("transform","rotate(0deg)");
					$('.glyphicon.glyphicon-chevron-down').css("color","#30B8E2"); 
				    flag = false;
				}
			}
		});
		if(typeof(this.userActivity[parseInt($("#Question").attr("qNo")) -1].flaged) != undefined)
		{
			if(this.userActivity[parseInt($("#Question").attr("qNo")) -1].flaged)
			{
				$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-for-review.png");
				this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged = true;
			}
			else
			{
				$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-review-normal.png");
			}
			
		}
		this.ResizeTestScreen();
		var scrollPos = (typeof q.position() != "undefined"?(typeof q.position().top != "undefined" ? q.position().top != "undefined":0):0 ) - 
						(typeof $('.qIndicator[sectionId="' + sectionId + '"][qNoInSection="1"]').position() != "undefined"? (typeof $('.qIndicator[sectionId="' + sectionId + '"][qNoInSection="1"]').position().top != "undefined" ? $('.qIndicator[sectionId="' + sectionId + '"][qNoInSection="1"]').position().top : 0 ):0) - 
						$(".QNavigator").height() / 2.0;
		$(".QNavigator").scrollTop(scrollPos);
		this.UpdateIndicators();
	
		if (this.testAttribute.hasOwnProperty("SaveForLater") && this.testAttribute["SaveForLater"] == 1) {
			var usedTime = (new Date().getTime() - this.startedAt) / 1000;
			this.lastresumetim["usedTime"] = Math.round(usedTime);
			this.lastresumetim["lastactive"] = Math.floor(Date.now() / 1000);
			this.meta["userLastactivetime"] = this.lastresumetim;
			writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
				if ( typeof cb != 'undefined')
					cb();
			});
		}
		
	}.bind(this));	
	if(typeof this.sectionalTimeBound !== 'undefined' && this.sectionalTimeBound == 1)
	{
	  if(qNoInSection == 1)
		  {
		  	$(".BottomPart .LeftHandIcon").css("opacity","0.5");
		  	$(".BottomPart .LeftHandIcon").addClass("disabled");
		  }
		  else
		  {
		  	$(".BottomPart .LeftHandIcon").css("opacity","unset");
		  	$(".BottomPart .LeftHandIcon").removeClass("disabled");
		  }  	
	}
	 else
	{
	  if(sectionId == 0 && qNo == 1)
		  {
		  	$(".BottomPart .LeftHandIcon").css("opacity","0.5");
		  }
		  else
		  {
		  	$(".BottomPart .LeftHandIcon").css("opacity","unset");
		  }  
	}
		
	$(".sectionNav.Selected .SectionInfoCount").unbind().bind("click",this,function(e){
			e.stopPropagation();
	});
	$(".sectionNav.Selected .SectionName").unbind().bind("click",this,function(e){
		e.stopPropagation();
	});   

};
appibpstestController.prototype.UpdateIndicators = function() {
	var stats = [0, 0, 0, 0, 0, 0, 0];
	var currentSection = -1;
	for (var qNo in this.meta.questions) {
		if (this.userActivity[qNo - 1].flaged && this.userActivity[qNo - 1].state == AnswerStatus.ANSWERED) {
			stats[AnswerStatus.ANSWEREDFLAGED]++;
		} else if (this.userActivity[qNo - 1].flaged) {
			stats[AnswerStatus.FLAGED]++;
		}
		stats[this.userActivity[qNo - 1].state]++;
	}
	//$("#IBPSTest .Legend").find(".skippedIcon").html(stats[AnswerStatus.SKIPED]);
	//$("#IBPSTest .Legend").find(".reviewIcon").html(stats[AnswerStatus.FLAGED]);
	//$("#IBPSTest .Legend").find(".missedIcon").html(stats[AnswerStatus.MISSED]);
	//$("#IBPSTest .Legend").find(".review_answeredIcon").html(stats[AnswerStatus.ANSWEREDFLAGED]);
	//$("#IBPSTest .Legend").find(".attemptedIcon").html(stats[AnswerStatus.ANSWERED]);
};
appibpstestController.prototype.ShowMCQQuestion = function(qDiv, qNo, qNumber, sQId, qtype, data) {
	var serveransweredDate = 0;
	var localansweredDate = 0;
	//loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data) {
		var answerData = data;
        $(".ibpsContainer").find("#QPart .Question .QuestionNonDetails .QuesTimeSpent #TimeSpent").text("00:00");
		$("#Question").attr("qType", QuestionType.MCQ);
		var answer = "<div class=\"Answers\" choiceMode=\"" + qDiv.attr("choicemode") + "\" >";
		var ans = qDiv.find("._answer_");
		var inputType = "radio";
		if (qDiv.attr("choicemode") > 0) {
			inputType = "checkbox";
		}
		var choice = 0;
		for (var i = 0; i < this.ansOrder[qNo - 1].length; i++) {
			var ansClass = "Answer";
			var checked = "";
			//Check which activity is latest (server or file)
			serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
			localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

			if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo - 1].ans != undefined && answerData[qNo-1].ans[choice]) {
				ansClass = "Answer selectedAns";
			} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice]) {
				ansClass = "Answer selectedAns";
			}
			answer += "<div class=\"" + ansClass + "\">" + 
						"<span>" + 
						"<label class='QuesNo'>"+QesNo[i]+"</label>"+
							'<input type="' + inputType + '" name="ansOption" id="option' + qNo + '-' + i + '"' + checked + '>' + 
								"<label for=\"option" + qNo + "-" + i + "\" class=\"AnswerText\">" + 
									$(ans[this.ansOrder[qNo-1][i]]).html() + 
								"</label>"+
						"</span>" + 
					   "</div>";
			choice++;
		}
		answer += "</div>";
		var qText = qDiv.find("._text_").html();
		$("#Question").html('<div class="questionText"><div class="questionTextData">' + qText + '</div>' + 
							'<span class="glyphicon glyphicon-chevron-down js-explore-qtn" aria-hidden="true"></span>'+
							'</div>'
							+answer);
		
		/* Update Answer options with saved values */
		var choice = 0;
		for (var i = 0; i < this.ansOrder[qNo - 1].length; i++) {
			if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo - 1].ans != undefined && answerData[qNo-1].ans[choice]) {
				$("#option" + qNo + "-" + i).prop("checked", true);
			} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice]) {
				$("#option" + qNo + "-" + i).prop("checked", true);
			}
			choice++;
		}

		$(".Answer").unbind("click").bind("click", this, function(e) {
			
	
			if(this.className == 'Answer selectedAns'){
				$('.Answer input').prop('checked', false);
	        	$(".Answer").removeClass("selectedAns");
	        	e.data.AnswerUpdate();
			}else{
				e.data.AnswerClicked(this);
			}
 
		});

		// Move SubQuestion & Answers to right
		var node = $('.floated-answerBox');
		if (node.length == 0) {
			node = $("<div class='floated-answerBox'></div>");
			node.insertAfter($("#Question"));
		}
		node.html('');

		if (qtype == QuestionType.COMP && $(window).width() > 540) {
			node.append($("#QPart ._subQText_"));
			node.append($(".Answers"));
		}
	//}.bind(this));

		if(QuesTimeSpentTimerVar != null)
		{
			 clearInterval(QuesTimeSpentTimerVar);
		}
		
		if(typeof(this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged) != undefined)
		{   
			if( this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged == "true")
			{
				$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-for-review.png");	
			} 
			 else
			{
				$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-review-normal.png");	
					    
			}
					 
		} 
		 else
		{ 
			if(typeof(this.userActivity[parseInt($("#Question").attr("qNo"))-1].flaged) != undefined)
			{
				if(this.userActivity[parseInt($("#Question").attr("qNo"))-1].flaged)
				{
					$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-for-review.png");
					this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged = true;
				}
				else
				{
					$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-review-normal.png");
				}
				
			}
			else
			{  
		    	$("#IBPSTest #QPart .testFlag").find('img').attr('src', "img/mark-review-normal.png");		    
			}
		}
		
		var TimeSpentLabel = $(".ibpsContainer").find("#QPart .Question .QuestionNonDetails .QuesTimeSpent #TimeSpent");
		var totalSeconds = 0;
		if(this.userActivity[qNo - 1].timeSpent != -1 && typeof(this.userActivity[qNo - 1].timeSpent) != undefined ){
			totalSeconds = this.userActivity[qNo - 1].timeSpent;
		}
			QuesTimeSpentTimerVar = setInterval(setTime, 1000);
		
		function setTime() {
		  ++totalSeconds;
		  TimeSpentLabel.text(pad(parseInt(totalSeconds / 60))+":"+ pad(totalSeconds % 60));
		}
		
		function pad(val) {
		  var valString = val + "";
		  if (valString.length < 2) {
		    return "0" + valString;
		  } else {
		    return valString;
		  }
		}
		
};
appibpstestController.prototype.ShowNIQQuestion = function(qDiv, qNo, data) {
	//loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data) {
		var answerData = data;
		
		$("#Question").attr("qType", QuestionType.NIQ);
		var answer = "<div class=\"Answers\" choiceMode=\"" + qDiv.attr("choicemode") + "\">";
		var ans = qDiv.find("._answer_");
		answer += this.KeyBoardHtml();
		answer += "</div>";
		var upToDecimalHtml = '';
		if (qDiv.attr("upToDecimal") != undefined) {
			if (parseInt(qDiv.attr("upToDecimal")) != 0) {
				upToDecimalHtml = '<div class="upToDecimal"><b>up to ' + qDiv.attr("upToDecimal") + ' decimal place</b></div>';
			}
		}
		var qText = qDiv.find("._text_").html();
		$("#Question").html('<div class="questionText"><div class="questionTextData">' + qText + upToDecimalHtml + '</div>' + 
							'<span class="glyphicon glyphicon-chevron-down js-explore-qtn" aria-hidden="true"></span>'+
							'</div>'+
							answer);

		$("#Question").find(".keyboardwrite").prop("disabled", true);
		$("#Question").find(".keyboard li").bind("click", this.CreateAnsKeyBoardHtml.bind(this));
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo-1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(answerData[qNo - 1].ans[0]);
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(this.userActivity[qNo - 1].ans[0]);
		}

	//}.bind(this));
};
appibpstestController.prototype.ShowFillInTheBankQuestion = function(qDiv, qNo, data) {
	//loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data) {
		var answerData = data;
		
		$("#Question").attr("qType", QuestionType.BLANK);

		var parts = qDiv.find("._text_").html().split("{BLANK}");
		var qText = "";
		for (var i = 0; i < parts.length; i++) {
			qText += parts[i];
			if (i < parts.length - 1) {
				qText += '<span><u><b><i>&nbsp;&nbsp;blank-' + (i + 1) + '&nbsp;&nbsp;</i></b></u></span>';
			}
		}
		var answer = "<div class=\"Answers\">";
		var ans = qDiv.find("._answer_");
		for (var i = 0; i < ans.length; i++) {
			ansClass = "AnswerSelect";
			answer += "<div class=\"" + ansClass + "\">" + '<div class="BlankNumber">blank-' + (i + 1) + '</div>' + $(ans[i]).html() + "</div>";
		}
		answer += "</div>";

		$("#Question").html('<div class="questionText"><div class="questionTextData">' + qText + '</div>' + 
							 '<span class="glyphicon glyphicon-chevron-down js-explore-qtn" aria-hidden="true"></span>'+
							 '</div>'+
							 answer);

		var ques = $("#Question .Answers select");
		ques.val("-1");
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null) {
			for (var i = 0; i < answerData[qNo - 1].ans.length; i++) {
				$(ques[i]).val(answerData[qNo - 1].ans[i]);
			}
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null) {
			for (var i = 0; i < this.userActivity[qNo - 1].ans.length; i++) {
				$(ques[i]).val(this.userActivity[qNo - 1].ans[i]);
			}
		}


};
appibpstestController.prototype.AnswerClicked = function(ans) {
	var qNumber = parseInt($("#Question").attr("qNo"));
	if ($(ans).hasClass("selectedAns") && $(ans).parent().attr("choiceMode") != 0) {
		$(ans).removeClass("selectedAns");
	} else {
		if ($(ans).parent().attr("choiceMode") == 0) {
			$(ans).siblings().removeClass("selectedAns");
		}
		$(ans).addClass("selectedAns");
	}
	
     this.AnswerUpdate();
};

appibpstestController.prototype.AnswerUpdate = function() {
	
	if(typeof(this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged) != undefined )
    {
		if( this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged == "true" || this.meta.questions[parseInt($("#Question").attr("qNo"))].flaged == true)
		{				  
			this.SavePrevQuestion(true);
		} 
		 else
		{
	     	this.SavePrevQuestion(false);
		}
	}
	 else
	{
		 this.SavePrevQuestion(false);
	}	
};

appibpstestController.prototype.ChangeQuestionState = function(qNo, toState) {
	flaged = this.userActivity[qNo - 1].flaged;
	this.userActivity[qNo - 1].state = toState;
	if (toState == AnswerStatus.ANSWERED) {
		answered = true;
	}
	var q = $('.qIndicator[qNo="' + qNo + '"]');

	if (toState == AnswerStatus.SKIPED) {
		q.removeClass("missedIcon attemptedIcon review_answeredIcon reviewIcon");
		q.addClass("skippedIcon");
	}
	if (flaged && toState == AnswerStatus.ANSWERED) {
		q.removeClass("skippedIcon reviewIcon");
		q.addClass("attemptedIcon review_answeredIcon");
	} else if (flaged) {
		q.removeClass("skippedIcon review_answeredIcon attemptedIcon");
		q.addClass("reviewIcon");
	} else if (toState == AnswerStatus.ANSWERED) {
		q.removeClass("skippedIcon reviewIcon review_answeredIcon");
		q.addClass("attemptedIcon");
	}
};
appibpstestController.prototype.GetCurrentState = function(qNo) {
	return $('#QuestionPanel .qTitle[qNo="' + qNo + '"] .qState.ShowedIcon').attr("state");
};

appibpstestController.prototype.SaveQuestion = function(qNumber, cb) {
	if (this.submited == false) {
		if (qNumber > 0) {
			if (this.meta["questions"][qNumber]["answer"] == undefined) {
				this.meta["questions"][qNumber]["answer"] = {};
			}
			this.meta["questions"][qNumber]["answer"]["ans"] = this.userActivity[qNumber-1]["ans"];
			this.meta["questions"][qNumber]["answer"]["state"] = this.userActivity[qNumber-1]["state"];
			this.meta["questions"][qNumber].flaged = this.userActivity[qNumber-1]["flaged"] ? "true" : "false";
			this.meta["questions"][qNumber]["timeSpent"] = this.userActivity[qNumber-1]["timeSpent"];
			if(!UrlMgmt.getObj().App.isOnline){
				if(!this.meta.hasOwnProperty('questionsSubmit'))
					this.meta["questionsSubmit"] = false;
			}
			else{
				if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
				{
					var saveteststarttime = Date.now();
					var savetestendtime   = null;
					var savetesturl 	  = remoteServer + "/ajax"+"/session="+this.meta["sessionId"]+"&qid="+this.meta["questions"][this.ShowingQuestionNo]["questionId"]+"";
					var saveteststatus    = "";
					var savetestmod		  = "test";	
					var savetestack		  = "save";
				}
				$.ajax({
					url : remoteServer + "/ajax",
					type : 'POST',
					data : {
						mod : "test",
						ack : "save",
						answer: JSON.stringify(this.meta["questions"][this.ShowingQuestionNo]["answer"]),
						flaged: this.meta["questions"][this.ShowingQuestionNo]["flaged"],
						qid: this.meta["questions"][this.ShowingQuestionNo]["questionId"],
						sqid: this.meta["questions"][this.ShowingQuestionNo]["subQuestionId"],
						session: this.meta["sessionId"],
						tempUserId: this.meta["tempUserId"],
						timespent: this.meta["questions"][this.ShowingQuestionNo]["timeSpent"],

					},
					xhrFields : {
						withCredentials : true
					},
					crossDomain : true,
					context : this,
					success : function(reply) {
						if (reply.result.state == "ok") {
							
						}
						if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
						{
							saveteststatus      		= "success";
							savetestendtime     		= Date.now();
							var savetestduration 		= savetestendtime - saveteststarttime;
							PerformanceAuditHandler.addPerformanceAuditAjax({
								mod			:savetestmod,
								ack			:savetestack,
								url			:savetesturl,
								status		:saveteststatus,
								starttime	:saveteststarttime,
								endtime		:savetestendtime,
								duration	:savetestduration
							});
						}						
					}.bind(this),
					error : function(jqXHR, exception) {
						if (jqXHR.status === 0) {
							//alert("Connect to Internet");
						} else if (jqXHR.status == 404) {
							alert('Requested page not found. [404]');
						} else if (jqXHR.status == 500) {
							alert('Internal Server Error [500].');
						} else if (exception === 'parsererror') {
							alert('Requested JSON parse failed.');
						} else if (exception === 'timeout') {
							alert('Time out error.');
						} else if (exception === 'abort') {
							alert('Ajax request aborted.');
						} else {
							alert('Uncaught Error.\n' + jqXHR.responseText);
						}
					}
				});
				
				if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
				{
					var lqstarttime = Date.now();
					var lqendtime   = null;
					var lqurl 	    = remoteServer + "/?route=common/ajax"+"/session="+this.meta["sessionId"]+"";
					var lqstatus    = "";
					var lqmod		= "test";	
					var lqack		= "lastquestionsave";
				}			
				//last question number save in redis
				$.ajax({
					url : remoteServer + "/ajax",
					type : 'POST',
					data : {
						mod : "test",
						ack : "lastquestionsave",
						session : this.meta["sessionId"],
						qno : qNumber,
						testId : this.testId
					},
					xhrFields : {
						withCredentials : true
					},
					crossDomain : true,
					context : this,
					success : function(reply) {
						if (reply.result.state == "ok") {
	
						}
						if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
						{
							lqstatus       = "success";
							lqendtime      = Date.now();
							var lqduration = lqendtime - lqstarttime;
							PerformanceAuditHandler.addPerformanceAuditAjax({
								mod			:lqmod,
								ack			:lqack,
								url			:lqurl,
								status		:lqstatus,
								starttime	:lqstarttime,
								endtime		:lqendtime,
								duration	:lqduration
							});
						}						
					}.bind(this),
					error : function(jqXHR, exception) {
						if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
						{
							lqstatus       = "error";
							lqendtime      = Date.now();
							var lqduration = lqendtime - lqstarttime;
							PerformanceAuditHandler.addPerformanceAuditAjax({
								mod			:lqmod,
								ack			:lqack,
								url			:lqurl,
								status		:lqstatus,
								starttime	:lqstarttime,
								endtime		:lqendtime,
								duration	:lqduration
							});
						}						
						if (jqXHR.status === 0) {
							var alerted = localStorage.getItem('alerted') || '';
	   		 				 if (alerted != 'yes') {
	     						alert("Data will be saved temporarily as you are not connected to Internet");
	     						localStorage.setItem('alerted','yes');
	    					 }
						} else if (jqXHR.status == 404) {
							alert('Requested page not found. [404]');
						} else if (jqXHR.status == 500) {
							alert('Internal Server Error [500].');
						} else if (exception === 'parsererror') {
							alert('Requested JSON parse failed.');
						} else if (exception === 'timeout') {
							alert('Time out error.');
						} else if (exception === 'abort') {
							alert('Ajax request aborted.');
						} else {
							alert('Uncaught Error.\n' + jqXHR.responseText);
						}
					}
				});
			}
		}
		writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
		});
	}
};
appibpstestController.prototype.SubmitTest = function(timeFinished) {
	if(typeof this.submittingTest !== 'undefined' && this.submittingTest)
	{
		return;
	}
	this.submittingTest = true;
	this.stopSectionTimer = true;
	if(this.isPsycoTest || this.sectionalTimeBound)
	{
		if(!this.meta["sections"][this.currentSectionId].submitted)
		{
			this.submitSection();
		}
		
		var sections = this.isPsycoTest ? $("#sectionPanel .PQues .SectionBtn") : $("#sectionPanel .SectionBtn");
		if(sections.length > 0)
		{
			for(var i=0; i < sections.length; i++)
			{
				var sectionId = $(sections[i]).attr("sectionid");
				if(sectionId <= this.currentSectionId)
				{
					if(!timeFinished && sectionId == this.currentSectionId)
					{
						this.meta["sections"][sectionId]["breakStartTime"] = Date.now();
					}
					this.meta["sections"][sectionId]["submitted"] = 1;
					this.meta["sections"][sectionId]["sectionMeta"] = JSON.stringify({
						"startedAt":this.meta["sections"][sectionId]["startedAt"],
						"submitted":this.meta["sections"][sectionId]["submitted"],
						"breakStartTime":this.meta["sections"][sectionId]["breakStartTime"],
						"breakEnded":this.meta["sections"][sectionId]["breakEnded"],
						"allotedTime":this.meta["sections"][sectionId]["allotedTime"]
					});
				}
			}
		}
		this.meta["sectionMeta"] = this.meta["sections"];
	}
	
	if (this.submited == false) {
		this.meta["endAt"] = new Date();
		if(!UrlMgmt.getObj().App.isOnline){
			this.meta["submitted"] = false;
		}
		writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
			this.submited = true;
			this.submittingTest = false;
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().PopView();
				alert("Test will be auto saved whenever you connect to internet");
			}
			else{
				this.testState = testState.Submitted;
				this.parent.SetState(this.testId, this.testState);
				this.parent.UploadTest(this.testId, this.tr2TestId, this.testState);
				this.testState = testState.Loaded;
				if(timeFinished){
					alert("Your test time is finished. So saving the test.");
				}
				else{
					alert("Your test has been submited.");
				}
			}
		}.bind(this));
	}
	else {
		this.submittingTest = false;
	}
};
appibpstestController.prototype.StartTimer = function(dom) {
	if (this.submited == true || this.paused == true)
		return;

	var milisecond = this.remainingTime - new Date().getTime() + this.timeNotedAt;
	if(typeof dom != 'undefined')
		this.SetTime(milisecond, dom);
	else
		this.SetTime(milisecond);

	if (milisecond >= 0) {
		var t = setTimeout( function() {
			if(typeof dom != 'undefined')
				this.StartTimer(dom);
			else
				this.StartTimer();
			//this.StartTimer();
		}.bind(this), 500);
	} else {
		this.SubmitTest(true);
	}
};
appibpstestController.prototype.SetTime = function(millisecond,$elem) {
	if(!$elem)
	{
		$elem = $("#TimeLeft");
		var radius = 10;
		  var correctPercent =  ((this.totalTime - millisecond)/this.totalTime)*100; //(data.dquiz.attemptInfo.correctAttempt * 100) // data.dquiz.attemptInfo.lastQuestion %}
		  var correctFill = parseInt((2*22*radius*correctPercent)/(7*100));
		  var d ="M18 "+parseInt((36-(2*radius))/2)+" a "+radius+" "+radius+" 0 0 1 0 "+2*radius+" a "+radius+" "+radius+" 0 0 1 0 -"+2*radius+"";
		  $(".totaltimeloader_div .svgholder").find("path").attr("d",d);
		  $(".totaltimeloader_div .svgholder").find(".progress-loader path").attr("stroke-dasharray",""+correctFill+",100");
	}
	
	millisecond /= 1000;
	var s = parseInt(millisecond % 60);
	var m = parseInt((millisecond / 60 ) % 60);
	var h = parseInt((millisecond / (60 * 60) ) % 60);
	if(s < 0 || m < 0 || h < 0)
	{ 
	  h = 0;
	  m = 0;
	  s = 0; 
	}
	$elem.text(this.TimeStr(h) + ":" + this.TimeStr(m) + ":" + this.TimeStr(s));
};
appibpstestController.prototype.TimeStr = function(i) {
	if (i < 10) {
		i = "0" + i;
	}// add zero in front of numbers < 10
	return i;
};
appibpstestController.prototype.QuestionPaper = function(viewLanguage) {
	var currentSection = -1;
	$("#QuestionPaper").empty();
	for (var qNo in this.meta.questions) {
		if (currentSection != this.meta.questions[qNo].sectionId) {
			currentSection = this.meta.questions[qNo].sectionId;
			$("#QuestionPaper").append('<h4 class="sectionNameInQPaper">Section : ' + this.sectionName[currentSection] + '</h4>');
		}

		var qId = this.meta.questions[qNo].questionId;
		var sQId = this.meta.questions[qNo].subQuestionId;
		var sectionId = this.meta.questions[qNo].sectionId;

		var q = this.meta.questions[qNo];
		var qDiv = $("._question_[qId='" + qId + "'][sQId='" + sQId + "'][language='" + TestLanguageType.Str[viewLanguage] + "']");
		if (!qDiv.length) {
			qDiv = $("._question_[qId='" + qId + "'][sQId='" + sQId + "']:eq(0)");
		}

		var questionText = qDiv.find("._text_").html();
		var qtype = qDiv.attr("qType");
		var qText = '<div class="QuestionInPaper"><div><span>'+ qNo +'.</span><div>' + questionText + '</div></div><div class="questiontype">' + QuestionType.Str[qtype] + '</div>  <hr class="endline">';
		$("#QuestionPaper").append(qText);
	}
	MathJax.Hub.Queue(["Typeset", MathJax.Hub, $("#QuestionPaper").get(0)], function() {
		var cWidth = $('#QuestionPaper').width();
		var wWidth = $(window).width();
		if (cWidth < (wWidth / 2) || cWidth > (wWidth - 40)) {
			cWidth = wWidth - 40;
		}
		$("#QuestionPaper span.MathJax_CHTML").each(function() {
			if ($(this).width() > cWidth) {
				$(this).css({
					'max-width' : cWidth + 'px'
				});
				$(this).addClass("scroll-x");
			}
		});
		$("#QuestionPaper").html(function(i, h) {
			return h.replace(/&nbsp;/g, ' ');
		});
	});
};
appibpstestController.prototype.PopulatePreSubmissionInfo = function() {
	$("#preSubmissionPart .IBPSTable .IBPSRow, #preSubmissionPart .skipRow").remove();
	$('#preSubmissionPart h2').text('Exam Summary');
	if(this.isPsycoTest)
	{
		$('.not-for-psyco').remove();
	}
	var stats = [0, 0, 0, 0, 0, 0];
	var currentSection = -1;
	var entry = 0;
	var qCount = 0;
	
	if(this.suffleInterSection)
	{
		for(var qNo in this.meta.questions)
		{
			if(this.userActivity[qNo-1].flaged)
			{
				stats[AnswerStatus.FLAGED]++;
			}
			stats[this.userActivity[qNo-1].state]++;
			qCount++;
		}
		entry = '<div class="IBPSRow">';
		entry += '<div class="IBPSCell">'+qCount+'</div>';
		entry += '<div class="IBPSCell">'+stats[AnswerStatus.ANSWERED]+'</div>';
		entry += '<div class="IBPSCell">'+stats[AnswerStatus.SKIPED]+'</div>';
		if(!this.isPsycoTest)
		{
			entry += '<div class="IBPSCell">'+stats[AnswerStatus.FLAGED]+'</div>';
			entry += '<div class="IBPSCell">'+stats[AnswerStatus.MISSED]+'</div>';
		}
		entry += '</div>';
		$(".IBPSHeaderRow .IBPSCell.sectionName").remove();
		return $("#preSubmissionPart .IBPSTable").append(entry);
	}
	for (var qNo in this.meta.questions) {
		var section = this.meta.questions[qNo].sectionId;
		if (currentSection != section) {
			if (currentSection >= 0) {
				entry += '<div class="IBPSCell">' + qCount + '</div>';
				entry += '<div class="IBPSCell">' + stats[AnswerStatus.ANSWERED] + '</div>';
				entry += '<div class="IBPSCell">' + stats[AnswerStatus.SKIPED] + '</div>';
				if(!this.isPsycoTest)
				{
					entry += '<div class="IBPSCell">' + stats[AnswerStatus.FLAGED] + '</div>';
					entry += '<div class="IBPSCell">' + stats[AnswerStatus.MISSED] + '</div>';
				}
				entry += '</div>';
				$("#preSubmissionPart .IBPSTable").append(entry);
			}
			entry = '<div class="IBPSRow"><div class="IBPSCell">' + this.sectionName[section] + '</div>';
			currentSection = section;
			qCount = 0;
			stats = [0, 0, 0, 0, 0, 0];
		}
		if (this.userActivity[qNo - 1].flaged) {
			stats[AnswerStatus.FLAGED]++;
		}
		stats[this.userActivity[qNo - 1].state]++;
		qCount++;
	}
	if (currentSection >= 0) {
		entry += '<div class="IBPSCell">' + qCount + '</div>';
		entry += '<div class="IBPSCell">' + stats[AnswerStatus.ANSWERED] + '</div>';
		entry += '<div class="IBPSCell">' + stats[AnswerStatus.SKIPED] + '</div>';
		if(!this.isPsycoTest)
		{
			entry += '<div class="IBPSCell">' + stats[AnswerStatus.FLAGED] + '</div>';
			entry += '<div class="IBPSCell">' + stats[AnswerStatus.MISSED] + '</div>';
		}
		entry += '</div>';
		$("#preSubmissionPart .IBPSTable").append(entry);
	}
	
	$(".preSubmissionFooter").show();
	
};
appibpstestController.prototype.ResizeTestScreen = function() {
	var headerFooter = $(".header").outerHeight() + $(".secondHeader").outerHeight() + $(".BottomPart").outerHeight();
	$("#QuestionPalette").outerHeight($(window).height() - headerFooter - $(".ibpsProfileTest").height());
	if ($(window).width() <= 540) {
		headerFooter -= $(".header").outerHeight();
		$("#QuestionPalette").outerHeight($(window).height() - $(".secondHeader").outerHeight() - $(".ibpsProfileTest").height());
	}

	$(".Question").outerHeight($(window).height() - headerFooter - $(".leftTopPart").height() - $(".langHeader").outerHeight() - 5);
	$(".QNavigator_div").outerHeight($("#QuestionPalette").outerHeight() - $(".Legend").outerHeight() - $(".viewingSection").outerHeight() - 65 - 200 + (this.suffleInterSection?30:0));
	$("#Question").outerHeight($(".Question").outerHeight() - $(".QuestionNo").outerHeight() - 13);
	$(".Question[qactualtype='2'] .floated-answerBox").outerHeight($(".Question").outerHeight() - $(".QuestionNo").outerHeight() - 13);
	$("#QuestionPaper,#InstructionPart").outerHeight($(window).height() - 170);   
	$(".QPalleteBtn").css("right", "0px");
	if ($(".QPalleteBtn").hasClass("showedPallete"))
		$(".QPalleteBtn").css("right", $(".rightPart").width());
};
appibpstestController.prototype.KeyBoardHtml = function() {
	keyBoardHtmlDis = '<div class="containerkeyboard">' + '<textarea class="keyboardwrite" rows="1"></textarea>' + '<ul class="keyboard">' + '<li class="symbol"><span class="off">1</span></li>' + '<li class="symbol"><span class="off">2</span></li>' + '<li class="symbol"><span class="off">3</span></li>' + '<li class="symbol"><span class="off">4</span></li>' + '<li class="symbol"><span class="off">5</span></li>' + '<li class="symbol"><span class="off">6</span></li>' + '<li class="symbol"><span class="off">7</span></li>' + '<li class="symbol"><span class="off">8</span></li>' + '<li class="symbol"><span class="off">9</span></li>' + '<li class="symbol"><span class="off">0</span></li>' + '<li class="symbol"><span class="off">.</span></li>' + '<li class="symbol"><span class="off">-</span></li>' + '<li class="delete lastitem">delete</li>' + '</ul>' + '</div>';
	return keyBoardHtmlDis;
};
appibpstestController.prototype.CreateAnsKeyBoardHtml = function(event) {
	var Data = event.currentTarget;
	var character = $(Data).html();
	qNumber = $("#test_Question_Number").text();
	if ($(Data).hasClass('delete')) {
		var html = $("#Question").find(".keyboardwrite").val();
		$("#Question").find(".keyboardwrite").val(html.substr(0, html.length - 1));
		return false;
	}
	if ($(Data).hasClass('symbol'))
		character = $('span:visible', $(Data)).html();
	$("#Question").find(".keyboardwrite").val($("#Question").find(".keyboardwrite").val() + character);
	if ($("#Question").find(".keyboardwrite").val().length > 1) {
		if (!$.isNumeric($("#Question").find(".keyboardwrite").val())) {
			alert("Notice:- answer should be numeric");
		}
	}
};
appibpstestController.prototype.UpdateTestPause = function(usedTime, sessionId) {
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer + "/ajax"+"/testId="+this.testId+"/session="+sessionId+"";
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "insertPauseHistory";
	}	
	$.ajax({
		type : "POST",
		url : remoteServer + "/ajax",
		data : {
			mod : "testapi",
			ack : "insertPauseHistory",
			testId : this.testId,
			session : sessionId,
			usedTime : usedTime,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		success : function(reply) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "success";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (reply.result.state == "ok") {
				if (reply.data["state"] == 1) {
					this.UpdateTestUpdateH(reply.data["id"], testState.Paused, sessionId);
				}
			} else {
				console.log(reply.result.meta);
			}
			UrlMgmt.getObj().removeLoader();
		}.bind(this),
		error : function(jqXHR, exception) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "error";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (jqXHR.status === 0) {
				if (this.meta["pausehistorystored"] == undefined) {
					this.meta["pausehistorystored"] = [];
				}
				this.meta["pausehistorystored"].push({
					"UT" : usedTime,
					"pausebrk" : Math.floor(Date.now() / 1000)
				});
				writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
					if ( typeof cb != 'undefined')
						cb();
				});
			}
		},
	});
};
appibpstestController.prototype.UpdateTestUpdateH = function(lpauseId, currentState, sessionId) {
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer + "/ajax"+"/sessionId="+sessionId+"/testId="+testId+"";
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "updatetesthistory";
	}	
	$.ajax({
		url : remoteServer + "/ajax",
		type : 'POST',
		data : {
			mod : "testapi",
			ack : "updatetesthistory",
			lastpauseId : lpauseId,
			testId : this.testId,
			tempUserId : tempUserId,
			testState : currentState,
			session : sessionId
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		success : function(reply) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "success";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
			if (reply.result.state == "ok") {
				console.log("update", reply.data);
			} else {
				console.log(reply.result.meta);
			}
			UrlMgmt.getObj().removeLoader();
		}.bind(this),
		error : function(jqXHR, exception) {
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status      		= "error";
				endtime     		= Date.now();
				var duration 		= endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod			:mod,
					ack			:ack,
					url			:url,
					status		:status,
					starttime	:starttime,
					endtime		:endtime,
					duration	:duration
				});
			}			
		},
	});
};


appibpstestController.prototype.showHideQuestionPallete = function(hide)
{	
	var $QPalleteBtn = $('.QPalleteBtn');
	var width = "100%";
	
	if(hide)
	{
		$(".rightPart").removeClass("opened");
		$(".leftPart").css("width",width);
		$QPalleteBtn.removeClass("showedPallete");
		$QPalleteBtn.find(".open").removeClass("shownIcon");
		$QPalleteBtn.find(".closed").addClass("shownIcon");
	}
	else
	{
		$(".rightPart").addClass("opened");
		if($(window).width() > 900)
			width = "80%";
		$(".leftPart").css("width",width);
		$QPalleteBtn.addClass("showedPallete");
		$QPalleteBtn.find(".closed").removeClass("shownIcon");
		$QPalleteBtn.find(".open").addClass("shownIcon");
	}
	this.StartTimer($('[data-action="total-test-time"]'));
	this.ResizeTestScreen();
};
appibpstestController.prototype.showPsycoQuestions = function(step)
{
	var self = this;
	
	$('.IBPSSubmitBtn').removeClass('disable');
	$(".sectionNav").off();
	$('#TimeLeft').closest('.TestTimer').hide();
	$('#QPart .QuestionNo, .questionTypePanel, .IBPSElem, .ibpsContainer .ChooseLanguageWithinTest font, #MarkForReviewBtn, #ClearResponseBtn').hide();
	$(".leftPart,.BottomPart,.secondHeaders .IBPSElem,#IBPSQuestionPaperBtn,#IBPSInstructionsBtn").show();
	
	//override save button
	$('#SaveNextBtn').addClass('disable').val('Save').off().on('click',function(){
		var $thisBtn = $(this);
		$thisBtn.val('Saved').addClass('disable');
		self.savePsycoQuestions();
		setTimeout(function(){
			$thisBtn.removeClass('disable').val('Save');
		},1000);
	});
	
	this.ResizeTestScreen();
	
	if($('#skipBtn').length === 0)
	{
		$('<input type="button" id="skipBtn" class="Next" value="Skip">').insertAfter($('#ClearResponseBtn'));
	}
	
	this.currentSectionId =  parseInt(this.currentSectionId);
	
	$qContainer = $("#Question");
	$qContainer.empty();
	
	$qContainer.css('overflow-y','auto');
	
	//remove all sections selection
	$('.sectionNav, .sectionNav .SectionBtn').removeClass("Selected");
	
	//Show Instruction
	if(typeof step === 'undefined' || step == 1)
	{	
		var instructionHTML = this.questionOrder[this.currentSectionId].questionInstuction[0].instruction;
		if(instructionHTML)
		{
			$('<div class="PInstruction">'+instructionHTML+'</div>').appendTo($qContainer);
		
			//show section selected
			$('.sectionNav.PIns[sectionid="'+this.currentSectionId+'"], .sectionNav.PIns[sectionid="'+this.currentSectionId+'"] .SectionBtn').addClass("Selected");
		}
		
		//skip section
		$('#skipBtn').off().removeClass('disable').on('click',function(){
			$(this).off().addClass('disable');
			self.meta.sections[self.currentSectionId].instructionSkipped = true;
			self.meta.sections[self.currentSectionId].instructionTimeSpent = Date.now() - self.meta.sections[self.currentSectionId].startedAt;
		});
	}
	//Show Questions
	else
	{
		$('.PQuestions, .psycoQuestion, .psyFloatQues, .psyFloatAns').css('height','auto');
		
		//show 'save and next' btn
		$('#SaveNextBtn').removeClass('disable');
		
		$('.sectionNav.PQues[sectionid="'+this.currentSectionId+'"], .sectionNav.PQues[sectionid="'+this.currentSectionId+'"] .SectionBtn').addClass("Selected");
		
		var sectionQNos = [];
		
		$('.QNavigator .qIndicator[sectionid="'+this.currentSectionId+'"]').toArray().forEach(function(qIndicator){
			var qNo = parseInt($(qIndicator).attr('qno'));
			sectionQNos.push(qNo);
		});
		
		var $psyQuestions = $('<div class="PQuestions"></div>').appendTo($qContainer);
		
		loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data){
			var answerData = data;
			var lastQid, lastSQid;
			for(var i in sectionQNos)
			{
				var qNo = parseInt(sectionQNos[i]);
				writeData("testpauseque_" + this.sessionID + ".json", 'testpauseque', this.sessionID, qNo, function() {
					if ( typeof cb != 'undefined')
						cb();
				});
				var $psycoQuestion = $('<div class="psycoQuestion"></div>').appendTo($psyQuestions);
				var q = $('.qIndicator[qNo="'+qNo+'"]');
				var qId = q.attr("qId");
				var sQId = q.attr("sQId");
				var qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[this.language]+"']");
				
				if(!qDiv.length){
					qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"']:eq(0)");
				}
				$psycoQuestion.attr("qNo", qNo);
				$psycoQuestion.attr("qId", qId);
				$psycoQuestion.attr("sQId", sQId);
				
				var qtype = qDiv.attr("qType");
			
				$psycoQuestion.attr("qType", QuestionType.MCQ);
				var answer = "<div class=\"Answers\"  qNo = \""+qNo+"\" choiceMode=\"" + qDiv.attr("choicemode") + "\">";
				
				var ans = qDiv.find("._answer_");
				var inputType = "radio";
				if(qDiv.attr("choicemode") > 0)
				{
					inputType = "checkbox";
				}
				var choice = 0;
				for (var i = 0; i < this.ansOrder[qNo-1].length; i++) 
				{	
					var ansClass = 	"Answer";
					var checked ="";
					//Check which activity is latest (server or file)
					serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
					localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;
					
					if ((serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo - 1].ans != undefined && answerData[qNo-1].ans[choice])
					||(serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice]))
					{
						checked = 'checked="checked"';
					}
					
					answer += 	"<div class=\""+ansClass+"\">"+
							"<span>"+'<input type="'+inputType+'" name="ansOption-'+qNo+'" '+ checked +'>'+"</span>"+
							"<span class=\"AnswerText\"><span>" + $(ans[this.ansOrder[qNo-1][i]]).html() + "</span></span>"+ 
							"</div>";
					choice++;			
				}
				answer += "</div>";
				var qText = qDiv.find("._text_").html();
				
				$psycoQuestion.html('<div class="questionText"><div class="questionTextData">' + 
										qText + 
									 '</div>' + 
									 '<span class="glyphicon glyphicon-chevron-down js-explore-qtn" aria-hidden="true"></span>'+
									 '</div>'+
									 answer);

				
				if(qtype == QuestionType.COMP)
				{
					if(typeof lastQid !== 'undefined' && typeof lastSQid !== 'undefined'
					&& lastQid == qId && lastSQid != sQId)
					{
						$floatAns = $('.psycoQuestion[qid="'+lastQid+'"] .psyFloatAns');
						$floatAns.append($psycoQuestion.find("._subQText_"));
						$floatAns.append($psycoQuestion.find(".Answers"));
						$psycoQuestion.remove();
					}
					else
					{
						var $floatQues = $('<div class="psyFloatQues"></div>');
						var $floatAns = $('<div class="psyFloatAns"></div>');
						$floatQues.html($psycoQuestion.html());
						
						$psycoQuestion.empty();
						$psycoQuestion.append($floatQues);
						$psycoQuestion.append($floatAns);
						$floatAns.append($psycoQuestion.find("._subQText_"));
						$floatAns.append($psycoQuestion.find(".Answers"));
					}
				}
				
				lastQid = qId;
				lastSQid = sQId;
			}
			
			$('.AnswerText').off().on('click',function(){
				var $input = $(this).closest('.Answer').find('input');
				$input.prop('checked') ? $input.prop('checked',false) :$input.prop('checked',true);
			});
			
			$('.Answer input').unbind().bind("click",this, function(e){
				if(e.target.tagName.toUpperCase() != "INPUT")
				{
					$(this).parents('.Answer').find("input").click();
				}
				if($(this).parents('.Answer').find("input").attr('type')!='checkbox'){
					$('.Answer').not($(this).parents('.Answer')).removeClass('checkedInput');
				}
				$(this).parents('.Answer').toggleClass('checkedInput');
				
				if($(this).parents('.Answer').hasClass('checkedInput')  && $(this).parents('.Answer').find("input").attr('type') == "radio")
				{
					$(this).parents('.Answer').find("input").prop('checked', true);
				}
				if(!$(this).parents('.Answer').hasClass('checkedInput') && $(this).parents('.Answer').find("input").attr('type') == "radio")
				{
					$(this).parents('.Answer').find("input").prop('checked', false);
				}
				e.data.AnswerClicked({currentTarget:this});
			});
			
			MathJax.Hub.Queue(["Typeset", MathJax.Hub, $("#Question").get(0)], function() {
				var cWidth = $('#IBPSTest #Question').width();
				var wWidth = $(window).width();
				if (cWidth < (wWidth / 2) || cWidth > (wWidth - 40)) {
					cWidth = wWidth - 40;
				}
				$("#IBPSTest #Question span.MathJax_CHTML").each(function() {
					if ($(this).width() > cWidth) {
						$(this).css({
							'max-width' : cWidth + 'px'
						});
						$(this).addClass("scroll-x");
					}
				});
				$("#IBPSTest #Question .questionText,  #IBPSTest #Question .AnswerText").html(function(i, h) {
					return h.replace(/&nbsp;/g, ' ');
				});
			});
	
			this.ResizeTestScreen();
			this.UpdateIndicators();
		}.bind(this));
		
		$('#skipBtn').off().removeClass('disable').on('click',function(){
			$(this).off().addClass('disable');
			self.stopSectionTimer = true;
			var startedAt = Date.now();
			var stopTimerFunction = false;
			var summaryTime = 0;
			
			if(self.questionOrder[self.currentSectionId].sectionMeta && typeof self.questionOrder[self.currentSectionId].sectionMeta.summaryTime !== 'undefined')
			{
				self.psycoSectionSummary();
				summaryTime = self.questionOrder[self.currentSectionId].sectionMeta.summaryTime * 60 * 1000;
			}
			
			var timerFunction = function(){
				var timeleft = startedAt + summaryTime - Date.now();
				if(summaryTime > 0 && timeleft >= 0 && !stopTimerFunction)
				{
					setTimeout(timerFunction,500);
					return self.SetTime(timeleft, $('[data-action="total-testsection-time"]'));
				}
				self.stopSectionTimer = false;
				self.submitSection();
				self.switchSection(true);
			};
			timerFunction();
			
			//skip summary button
			$('#skipSummary').off().on('click',function(){stopTimerFunction = true;});
		});
	}
	this.ResizeTestScreen();
};
appibpstestController.prototype.StartSectionTimer = function()
{
	if(this.stopSectionTimer || this.submited || this.paused || (typeof this.submittingTest !== 'undefined' && this.submittingTest))
	{
		return;
	}
	//if section is submitted, switch section
	if(this.meta["sections"][this.currentSectionId].submitted == true && this.psycoTestState != 'psycoSectionSummary-'+this.currentSectionId)
	{
		return this.switchSection();
	}
	
	var allotedTime = this.questionOrder[this.currentSectionId].allotedTime * 60 * 1000 ;
	var sectionTime =  allotedTime - Date.now() + this.meta["sections"][this.currentSectionId].startedAt;
	var $timer = $('[data-action="total-testsection-time"]');
	
	//sync total timer -> update total time
	var totalTime = 0;
	//remaining sections excluding current section
	var sections = this.isPsycoTest ? $("#sectionPanel .PQues .SectionBtn[submitted='0']:not([sectionid='"+this.currentSectionId+"'])") : $("#sectionPanel .SectionBtn[submitted='0']:not([sectionid='"+this.currentSectionId+"'])");
	for(var i=0; i<sections.length; i++)
	{
		var sectionId = $(sections[i]).attr("sectionid");
		totalTime += this.meta["sections"][sectionId].allotedTime;
	}
	totalTimeInMiliSeconds = totalTime * 60 *1000;
	
	this.timeNotedAt = Date.now();
	this.remainingTime = totalTimeInMiliSeconds + Math.max(sectionTime,0);
	
	if(this.isPsycoTest)
	{
		var instructionTime = 0;
		var summaryTime = 0;
		var intructionSkipped = false;
		
		if(this.questionOrder[this.currentSectionId].sectionMeta)
		{
			if(typeof this.questionOrder[this.currentSectionId].sectionMeta.instructionTime !== 'undefined')
			{
				instructionTime = this.questionOrder[this.currentSectionId].sectionMeta.instructionTime * 60 * 1000;
			}
			if(typeof this.questionOrder[this.currentSectionId].sectionMeta.summaryTime !== 'undefined')
			{
				summaryTime = this.questionOrder[this.currentSectionId].sectionMeta.summaryTime * 60 * 1000;
			}
		}
		if(instructionTime > 0 && typeof this.meta.sections[this.currentSectionId].instructionSkipped !== 'undefined'
		&& this.meta.sections[this.currentSectionId].instructionSkipped)
		{
			intructionSkipped = true;
			sectionTime -= Math.max((instructionTime - this.meta.sections[this.currentSectionId].instructionTimeSpent),0);
		}
		
		//elseif section time more than section - intruction time show instructions
		if(!intructionSkipped && instructionTime > 0 && sectionTime >= (allotedTime - instructionTime))
		{
			//update section timer
			var timeLeft = sectionTime - (allotedTime - instructionTime);
			this.SetTime(timeLeft,$timer);
			
			var state = 'showPsycoInstructions-'+this.currentSectionId;
			if(this.psycoTestState != state)
			{
				this.psycoTestState = state;
				this.showPsycoQuestions(1);
			}
		}
		//elseif section time is more than summary time show sections
		else if(sectionTime >= summaryTime)
		{
			//update section timer
			var timeLeft = sectionTime - summaryTime;
			this.SetTime(timeLeft,$timer);
			
			var state = 'showPsycoQuestions-'+this.currentSectionId;
			if(this.psycoTestState != state)
			{
				this.psycoTestState = state;
				this.showPsycoQuestions(2);
			}
		}
		//elseif section time > 0 show summary
		else if(sectionTime > 0)
		{
			//update section timer
			this.SetTime(sectionTime,$timer);
			
			var state = 'psycoSectionSummary-'+this.currentSectionId;
			if(this.psycoTestState != state)
			{
				this.psycoTestState = state;
				this.psycoSectionSummary();
			}
		}
		//else submit section
		else
		{	
			//update section timer
			this.SetTime(0,$timer);
			
			if(!this.meta["sections"][this.currentSectionId].submitted)
			{
				this.submitSection();
			}
			
			this.switchSection();
		}
	}
	else
	{
		if(sectionTime > 0)
		{
			this.SetTime(sectionTime,$timer);
		}
		else
		{
			this.SetTime(0,$timer);
			this.submitSection();
			this.switchSection();
		}
	}
	if(sectionTime > 0)
	{
		setTimeout(function(){this.StartSectionTimer();}.bind(this),500);
	}
};
appibpstestController.prototype.submitSection = function(skipSection)
{
	if(this.submited || this.sessionID == -1)
	{
		return;
	}
	
	if(this.isPsycoTest && !skipSection)
	{
		this.savePsycoQuestions();
	}
	
	this.meta["sections"][this.currentSectionId]["submitted"] = 1;
	this.meta["sections"][this.currentSectionId]["breakStartTime"] = Date.now();
	
	$(".SectionBtn[sectionid='"+this.currentSectionId+"']").attr("submitted",this.meta["sections"][this.currentSectionId]["submitted"]);
	
	var sectionMeta = {
		"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
		"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
		"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
		"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
		"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
	};
	this.UpdateSectionMeta(this.currentSectionId,sectionMeta);
};
appibpstestController.prototype.savePsycoQuestions = function()
{
	var noOfQs = $('#Question .Answers').length;
	
	if(noOfQs > 0)
	{
		var self = this;
		var testData = {
			sessionId : this.sessionID,
			questions : []
		};
		
		var sectionTimeSpent = Date.now() - self.meta["sections"][this.currentSectionId]["startedAt"];
		var timeSpentPerQtn = Math.floor(sectionTimeSpent/(noOfQs*1000));
		
		$('#Question .Answers').toArray().forEach(function(answer){
			var qNo = parseInt($(answer).attr('qNo'));
			var answered = false;
			var counter = 0;
			var ansArr = [];
			
			if(typeof self.userActivity[qNo - 1].ans === 'undefined')
			{
				self.userActivity[qNo - 1].ans = [];
			}
			
			$(answer).find("input").each(function(){
				var hasSelectedAns =  $(this).prop("checked");
				self.userActivity[qNo - 1].ans[counter] = hasSelectedAns;
				ansArr[counter] = hasSelectedAns;
				answered |= hasSelectedAns;
				counter++;
			});
			
			var state = answered ? AnswerStatus.ANSWERED : AnswerStatus.SKIPED;
			
			self.userActivity[qNo - 1].state = state;
			
			var questionData = {
				questionId:self.userActivity[qNo-1].questionNo,
				subQuestionId:self.userActivity[qNo-1].sQId,
				answer:{ans:ansArr, state:state},
				flag:false,
				timeSpent:timeSpentPerQtn
			};
			
			testData.questions.push(questionData);
			
			//for storing data offline
			if (self.meta["questions"][qNo]["answer"] == undefined) {
				self.meta["questions"][qNo]["answer"] = {};
			}
			self.meta["questions"][qNo]["answer"]["ans"] = self.userActivity[qNo-1]["ans"];
			self.meta["questions"][qNo]["answer"]["state"] = self.userActivity[qNo-1]["state"];
			self.meta["questions"][qNo].flaged = self.userActivity[qNo-1]["flaged"] ? "true" : "false";
			self.meta["questions"][qNo]["timeSpent"] = self.userActivity[qNo-1]["timeSpent"];
			
			if(!UrlMgmt.getObj().App.isOnline){
				if(!self.meta.hasOwnProperty('questionsSubmit'))
					self.meta["questionsSubmit"] = false;
			}
			
		});
		
		//store data offline
		writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function(){});
		
		if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
		{
			var starttime = Date.now();
			var endtime   = null;
			var url 	  = remoteServer + "/ajax" + "/testId=" + this.meta.testId + "";
			var status    = "";
			var mod		  = "testapi";	
			var ack		  = "submit";
		}		
		var data = {
			mod: "testapi",
			ack: "submit",
			testData : JSON.stringify(testData),
			testId : this.meta.testId,
			tempUserId : this.meta["tempUserId"],
			saveOnlyQuestions: true
		};
		
		$.ajax({
			type: "POST",
			timeout:10000,
			data:data,
			complete: function( event){
				if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
				{
					status      		= "success";
					endtime     		= Date.now();
					var duration 		= endtime - starttime;
					PerformanceAuditHandler.addPerformanceAuditAjax({
						mod			:mod,
						ack			:ack,
						url			:url,
						status		:status,
						starttime	:starttime,
						endtime		:endtime,
						duration	:duration
					});
				}				
				var reply = event.responseJSON;
				try
				{
					if(reply.result.state == "ok")
					{
						if(reply.data && reply.data["remainingTime"] != undefined)
						{
							this.timeNotedAt = new Date().getTime();
							this.remainingTime = reply.data.remainingTime * 1000;
						}
					}
					else if(reply.result.state == "time_over")
					{
						this.SubmitTest(true);
					}
					else if(reply.result.state == "auth_error")
					{
						alert("Please login to take test!");
					}
					else
					{
						console.log("error");
					}
				}
				catch(e)
				{
					console.error(e);	
				}		   
			}.bind(this),
			xhrFields : {
				withCredentials : true
			},
			crossDomain : true,
			context : this,
			error : function(jqXHR, exception) {
				if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
				{
					status      		= "error";
					endtime     		= Date.now();
					var duration 		= endtime - starttime;
					PerformanceAuditHandler.addPerformanceAuditAjax({
						mod			:mod,
						ack			:ack,
						url			:url,
						status		:status,
						starttime	:starttime,
						endtime		:endtime,
						duration	:duration
					});
				}				
				if (jqXHR.status === 0) {
					var alerted = localStorage.getItem('alerted') || '';
	 				 if (alerted != 'yes') {
						alert("Data will be saved temporarily as you are not connected to Internet");
						localStorage.setItem('alerted','yes');
					 }
				} else if (jqXHR.status == 404) {
					alert('Requested page not found. [404]');
				} else if (jqXHR.status == 500) {
					alert('Internal Server Error [500].');
				} else if (exception === 'parsererror') {
					alert('Requested JSON parse failed.');
				} else if (exception === 'timeout') {
					alert('Time out error.');
				} else if (exception === 'abort') {
					alert('Ajax request aborted.');
				} else {
					alert('Uncaught Error.\n' + jqXHR.responseText);
				}
			},
			url: remoteServer + "/ajax"
		});
	}
};
appibpstestController.prototype.updatePsycoSectionUserActivity = function()
{
	if($('#Question .Answers').length === 0)
	{
		return;
	}
	var self = this;
	$('#Question .Answers').toArray().forEach(function(answer){
		var qNo = parseInt($(answer).attr('qNo'));
		var answered = false;
		var counter = 0;
		var ansArr = [];
		if(typeof self.userActivity[qNo - 1].ans === 'undefined')
		{
			self.userActivity[qNo - 1].ans = [];
		}
		$(answer).find("input").each(function(){
			var hasSelectedAns =  $(this).prop("checked");
			self.userActivity[qNo - 1].ans[counter] = hasSelectedAns;
			ansArr[counter] = hasSelectedAns;
			answered |= hasSelectedAns;
			counter++;
		});
		var state = answered ? AnswerStatus.ANSWERED : AnswerStatus.SKIPED;
		self.userActivity[qNo - 1].state = state;
	});
};
appibpstestController.prototype.switchSection = function(updateTime,skipSection)
{
	if(this.submited || this.paused || (typeof this.submittingTest !== 'undefined' && this.submittingTest))
	{
		return;
	}
	
	var sections = this.isPsycoTest ? $("#sectionPanel .PQues .SectionBtn[submitted='0']") : $("#sectionPanel .SectionBtn[submitted='0']");
	
	if(sections.length > 0)
	{
		this.currentSectionId = $(".SectionBtn[submitted='0']").first().attr("sectionId");
		if(updateTime || this.meta["sections"][this.currentSectionId]["startedAt"] > Date.now())
		{
			this.meta["sections"][this.currentSectionId]["startedAt"] = Date.now();
			this.meta["sections"][this.currentSectionId]["breakStartTime"] = this.meta["sections"][this.currentSectionId]["startedAt"] + this.meta["sections"][this.currentSectionId].allotedTime * 60 * 1000;
		}
		var sectionMeta = {
			"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
			"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
			"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
		};
		this.UpdateSectionMeta(this.currentSectionId,sectionMeta);
		
		//for sectionTimeBound test
		if(!this.isPsycoTest)
		{
			//show next question
			var showquestion = true,Itratedquestions = 0,updatedsection = parseInt(this.currentSectionId),groupscount = 0,subquestion = 0;
			var qNo = this.ShowingQuestionNo + 1;
			
			while(updatedsection > 0){
				groupscount = 0;
				
				while(this.questionOrder[updatedsection - 1 ].groups.length > groupscount)
				{
					
					for(question in this.questionOrder[updatedsection - 1 ].groups[groupscount])
					{
						subquestion = 0;
						if(typeof this.questionOrder[updatedsection - 1 ].groups[groupscount][question].subQuestions != "undefined")
						{
							if(typeof this.questionOrder[updatedsection - 1 ].groups[groupscount][question].subQuestions.length != "undefined")
							{
								if(parseInt(this.questionOrder[updatedsection - 1 ].groups[groupscount][question].subQuestions.length)>1)
								{
									Itratedquestions += (this.questionOrder[updatedsection - 1 ].groups[groupscount][question].subQuestions.length - 1);
								}	
							}
						}
						else if(typeof this.questionOrder[updatedsection - 1 ].groups[groupscount][question].noOfSubQuestion != "undefined")
						{
							if(parseInt(this.questionOrder[updatedsection - 1 ].groups[groupscount][question].noOfSubQuestion)>1)
							{
								Itratedquestions += (this.questionOrder[updatedsection - 1 ].groups[groupscount][question].noOfSubQuestion - 1);
							}	
						}
					}
	
					Itratedquestions += this.questionOrder[updatedsection - 1 ].groups[groupscount].length;
					groupscount++;
				}
				
				updatedsection--;
			}
			qNo = Itratedquestions + 1;   
			if($('.qIndicator[qNo="'+qNo+'"]').length > 0)
			{
				if(showquestion)
				{
					this.ShowQuestion(qNo);
				}
			}
		}
		
		if(!skipSection)
		{
			this.StartSectionTimer();
		}
		return;
	}
	$("#SubmitSectionBtn").addClass("Submited");	
	this.SubmitTest(true);
};
appibpstestController.prototype.UpdateSectionMeta = function(sectionId,sectionMeta)
{
	if(typeof sectionId === 'undefined')
	{
		sectionId = this.currentSectionId;
	}
	if(typeof sectionMeta === 'undefined')
	{
		sectionMeta = {
			"startedAt":this.meta["sections"][sectionId]["startedAt"],
			"submitted":this.meta["sections"][sectionId]["submitted"],
			"breakStartTime":this.meta["sections"][sectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][sectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][sectionId]["allotedTime"]
		};
	}
	return $.ajax({
		type : "POST",
		url : remoteServer + "/ajax",
		data: { 
			mod : "test",
			ack : "updateSectionMeta",
			session : this.sessionID,
			sectionId : sectionId,
			meta : JSON.stringify(sectionMeta)
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		error : function(jqXHR, exception) {
			if (jqXHR.status === 0) {
				var alerted = localStorage.getItem('alerted') || '';
 				 if (alerted != 'yes') {
					alert("Data will be saved temporarily as you are not connected to Internet");
					localStorage.setItem('alerted','yes');
				 }
			} else if (jqXHR.status == 404) {
				alert('Requested page not found. [404]');
			} else if (jqXHR.status == 500) {
				alert('Internal Server Error [500].');
			} else if (exception === 'parsererror') {
				alert('Requested JSON parse failed.');
			} else if (exception === 'timeout') {
				alert('Time out error.');
			} else if (exception === 'abort') {
				alert('Ajax request aborted.');
			} else {
				alert('Uncaught Error.\n' + jqXHR.responseText);
			}
		}
	});
};
appibpstestController.prototype.psycoSectionSummary = function(sectionId)
{
	$('.not-for-psyco').remove();
	$("#preSubmissionPart .IBPSTable .IBPSRow").remove();
	var stats = [0,0,0,0,0,0];
	var sectionId = (typeof sectionId !== 'undefined') ? sectionId : this.currentSectionId;
	var entry = '';
	var qCount = 0;
	
	for(var qNo in this.meta.questions)
	{
		if(this.meta.questions[qNo].sectionId == sectionId)
		{
			if(this.userActivity[qNo-1].flaged)
			{
				stats[AnswerStatus.FLAGED]++;
			}
			stats[this.userActivity[qNo-1].state]++;
			qCount++;
		}
	}
	entry = '<div class="IBPSRow">';
	entry += '<div class="IBPSCell">'+this.sectionName[sectionId]+'</div>';
	entry += '<div class="IBPSCell">'+qCount+'</div>';
	entry += '<div class="IBPSCell">'+stats[AnswerStatus.ANSWERED]+'</div>';
	entry += '<div class="IBPSCell">'+stats[AnswerStatus.SKIPED]+'</div>';
	entry += '</div>';
	
	$("#preSubmissionPart .IBPSTable").append(entry);
	$('#preSubmissionPart h2').text('Summary ');
	
	$('#preSubmissionPart h2').append('<span class="TestTimer"><span class="TimerLevel">(Time Left: </span><span class="SectionTimeLeft">00:00:00</span>)</span>');
	
	if($('#preSubmissionPart .skipRow').length === 0)
	{
		var skip =
			'<div class="skipRow">'+
				'<div>'+
					'<a id="skipSummary" class="Next">Skip</a>'+
				'</div>'+
			'</div>';
		$('#preSubmissionPart').append(skip);
	}
	
	$('#skipSummary').off().show().on('click',this,function(e){
		e.data.submitSection();
		e.data.psycoTestState = undefined;
		$(this).hide();
	});
	//reset state, section will be automatically switched
	
	$('#preSubmissionPart .skipRow').show();
	
	$(".IBPSElem,#_SciCalculator_, .preSubmissionFooter").hide();
	$(".profileHeader").show();
	$(".preSubmissionPart").addClass("selected");
	this.ResizeTestScreen();
};
appibpstestController.prototype.isLastSectionQuestion = function()
{
	var curQuesSectionId = $('.qIndicator[qNo="'+this.ShowingQuestionNo+'"]').attr("sectionId");
	var nextQuestion = (this.ShowingQuestionNo%this.userActivity.length) + 1;
	var nextQuesSectionId = $('.qIndicator[qNo="'+nextQuestion+'"]').attr("sectionId");
	return curQuesSectionId != nextQuesSectionId;
};
appibpstestController.prototype.showSubmitSectionModal = function()
{
	
	if(this.testTheme == Theme.IBPSTHEME && this.testAttributes && typeof this.testAttributes.sectionalTimeBound !== 'undefined' && this.testAttributes.sectionalTimeBound == 1)
	{
		$('#ibps-confirmSectionSubmit1').modal('show');	
	}
	else
	{		 
		$('#ibps-confirmSectionSubmit').modal('show');
	}
};
appibpstestController.prototype.onSubmitButtonClick = function()
{
    // this.AnswerUpdate();	
	//override for psyco test
	if(this.isPsycoTest)
	{
		this.updatePsycoSectionUserActivity();
	}
	$("#_SciCalculator_").hide();
	this.PopulatePreSubmissionInfo();
	$(".profileHeader").show();
	$(".preSubmissionPart").addClass("selected");
	this.ResizeTestScreen();
	$('#preSubmissionPart-overlay').show();
};