var appquizreviewController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.id = 0;
	this.data = null;
	this.click = true;
	this.QuestionPosition = 0;
	this.questionincrement = true;
	this.questionanswer = {};
	this.useranswer = {};
	this.timedata = {};
	this.solution = {};
	//new code start
	this.hindiSolution = {};
	//new code end
};
appquizreviewController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if (!UrlMgmt.getObj().App.isOnline) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
appquizreviewController.prototype.SetLayout = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.view.hide();
};
appquizreviewController.prototype.OfflineInit = function() {
	Factory.getObj().LoadViewForOffline(this);
};
appquizreviewController.prototype.OnlineInit = function() {
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	this.GetReviewdata();
};

appquizreviewController.prototype.GetReviewdata = function()
{
	$.ajax({
		type : "POST",
		url : remoteServer + "/?route=common/ajax",
		data : {
			mod : "tr2dquiz",
			ack : "getReportData",
			quizid : this.id,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete : function(reply) {
			var response = reply.responseJSON;
			this.data = response.data;
			this.PopulateView();
		}.bind(this)
	});
};
appquizreviewController.prototype.Quizpatti = function(quizId, quizques, quizmarks, resumefetch) {
	if (resumefetch == undefined) {
		resumefetch = 0;
	}
	resumefetch = 0;
	//var quizHTML = '<div class="quiz-patti " quiz-id="' + quizId + '">' + '<div class="description">' + '<table><tr><td><div class="ongoingQues">' + '<span class="quizquestnno">' + (parseInt(resumefetch) + 1) + '</span>/<span class="marks">' + (quizques) + '</span>' + '</div></td>' + '<td><div class="marks "><span>' + quizques + '</span> QUES</div></td>' + '<td><div class="marks "><span>' + quizmarks + '</span> MARKS</div></td><td><div class="timer marks">' + '<img src="img/time_spent.png">' + '<span class="questionTimer">0</span>' + '</div></td></tr></table>' + '</div>' + '</div>';
	var quizHTML = '<div class="quiz-patti " quiz-id="' + quizId + '">' + '<div class="description">' + '<table><tr><td><div class="ongoingQues">' + '<span class="quizquestnno">' + (parseInt(resumefetch) + 1) + '</span>/<span class="marks">' + (quizques) + '</span>' + '</div></td>' + '<td><div class="marks "><span>' + quizques + '</span> QUES</div></td>' + '<td><div class="marks "><span>' + quizmarks + '</span> MARKS</div></td><td><div class="timer marks">' + '<img src="img/time_spent.png">' + '<span class="questionTimer">0</span>' + '</div></td></tr></table>';	
	var languages = (typeof this.data.quizInfo.info.languages != "undefined")?this.data.quizInfo.info.languages:[];	
	if(languages.length > 1)	
		quizHTML  += '<span class="quizlanguage js-SelectQuizLanguage" data-languageselected="' + TestLanguageType.English + '">' +	
					 '<img src="img/eng-hindi.png"></span>';	
	quizHTML += '</div></div>';
	
	$(this.dom).find('.allQuiz').append(quizHTML);
	if(this.data.quizInfo.info.totalQuestions == 1){
		$(this.dom).find('.questionNavigation').find(".prevQuestion").hide();
		$(this.dom).find('.questionNavigation').find(".nextQuestion").hide();
		$(this.dom).find('.questionNavigation').find(".finish").show();
	}
};
appquizreviewController.prototype.PopulateQuizData = function(res, quizId) {
	var qno = 0;
	var qdata,
	    myQuiz = 'active';
	var questionNo = 0,
	    valueClass = '',
	    questionOption = 0;
	var html = 	"<div class='question-status-info'>"+
					"<p class='correct-status'>CORRECT</p>"+
					"<p class='incorrect-status'>INCORRECT</p>"+
					"<p class='unattempted-status'>UNATTEMPTED</p>"+
				"</div>"+
				"<div class='question-status'>"+
				"<div class='questionsholder'>"+
				'<span class="glyphicon glyphicon-menu-left question-numberbtnleft"></span>'+
				"<div class='questionsslider'>";
	for (var i in res.questionData) {

		if (res.questionData[i].subtypeId == "0") {
			questionOption = 0;
			var qquestion = res.questionData[i].question.question;
			qquestion = qquestion.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
			qno++;
			var state = "notvisited";
			if(typeof res.questionData[i].correct != 'undefined'){
				if(res.questionData[i].correct == '1'){
					state = "correct";
				}
				else if(res.questionData[i].correct == '0'){
					state = "incorrect";
				}
				else if(res.questionData[i].correct == '-1'){
					state = "unattempted";
				}
			}
			html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+qno+"'>"+qno+"</p>";
			
			//qdata = '<div class="eachQuestion  quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '">' + '<div class="ques-outer"><div class="ques-title"><span class="questnNo" data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qquestion + '</div></div>';
			//qdata += '<div>';
			var englishQData = '<div class="selectQuesLang"';	
			var qInHindi = (typeof res.questionData[i].questionHindi != "undefined")?true:false;	
			if(qInHindi)	
				englishQData += ' language="english"';	
			englishQData += '>' + '<div class="ques-outer"><div class="ques-title"><span class="questnNo" data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qquestion + '</div></div>';	
				
			englishQData += '<div>';
			
			for (var j in res.questionData[i].question.answers) {
				valueClass = '';
				
				var str = ""+res.questionData[i].question.answers[j].text;
				str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
				//qdata = qdata + '<label class="quizlabel">' + 
				englishQData = englishQData + '<label class="quizlabel">' +
									'<input type="radio" class="radioButton" name="' + quizId + '+' + i + '" ques-no="' + qno + '" value="' + j + '"/>' + 
									'<div class="labelDiv container ' + valueClass + '">' + 
										'<div class="indexpadding">' + String.fromCharCode(65 + parseInt(j)) + 
										'</div>' + 
										'<div class="option_msg">' + 
											'<div class="radioText">' + 
												str + 
											'</div>' + 
											'<div class="indicator"></div>' +
										'</div>' + 
									'</div>' + 
								'</label>';
				questionOption++;
			}
			//qdata += '</div>';
			//qdata = qdata + '<div class="solutionTab">' +
			//				'</div><div class="CheckAnsspacing"></div>' + '</div>';
			
			
			
			
			englishQData += '</div>';	
			englishQData = englishQData + '<div class="solutionTab english">' +	
							'</div><div class="CheckAnsspacing"></div>' + '</div>';	
			var hindiQData = '';	
			if(qInHindi)	
			{	
				qquestion = res.questionData[i].questionHindi.question;	
				qquestion = qquestion.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
				hindiQData = '<div class="selectQuesLang" language="hindi">' +	
					'<div class="ques-outer"><div class="ques-title"><span class="questnNo" data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qquestion + '</div></div>';	
					
				hindiQData += '<div>';	
				for (var j in res.questionData[i].questionHindi.answers) {	
					valueClass = '';	
						
					var str = ""+res.questionData[i].questionHindi.answers[j].text;	
					str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					hindiQData = hindiQData + '<label class="quizlabel">' + 	
										'<input type="radio" class="radioButton" name="' + quizId + '+' + i + '" ques-no="' + qno + '" value="' + j + '"/>' + 	
										'<div class="labelDiv container ' + valueClass + '">' + 	
											'<div class="indexpadding">' + String.fromCharCode(65 + parseInt(j)) + 	
											'</div>' + 	
											'<div class="option_msg">' + 	
												'<div class="radioText">' + 	
													str + 	
												'</div>' + 	
												'<div class="indicator"></div>' +	
											'</div>' + 	
										'</div>' + 	
									'</label>';	
				}	
				hindiQData += '</div>';	
				hindiQData = hindiQData + '<div class="solutionTab hindi">' +	
								'</div><div class="CheckAnsspacing"></div>' + '</div>';	
			}	
			qdata = '<div class="eachQuestion  quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '">' +	
					englishQData + hindiQData + '</div>';	


			$(qdata).appendTo('.quiz_content');
			if (myQuiz == 'active') {
				this.QuestionPosition = 0;
				this.questionincrement = true;
				myQuiz = '';
			}
		} else {

			for (var j in res.questionData[i].question.subQuestion) {

				this.questionincrement = false;
				qno++;
				var state = "notvisited";
				if(typeof res.questionData[i].question.subQuestion[j].correct != 'undefined'){
					if(res.questionData[i].question.subQuestion[j].correct == '1'){
						state = "correct";
					}
					else if(res.questionData[i].question.subQuestion[j].correct == '0'){
						state = "incorrect";
					}
					else if(res.questionData[i].question.subQuestion[j].correct == '-1'){
						state = "unattempted";
					}
				}
				html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+qno+"'>"+qno+"</p>";	
				questionOption = 0;
				var qcommonText = res.questionData[i].question.commonText;
				qcommonText = qcommonText.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
				var sqquestion = res.questionData[i].question.subQuestion[j].question;
				sqquestion = sqquestion.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");

				//qdata = '<div class="eachQuestion  quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '" subques-no="' + j + '">' + '<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qcommonText + '</div></div>' + '<div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';
				//qdata += '<div>';
				
				englishQData = '<div class="selectQuesLang"';	
				qInHindi = (typeof res.questionData[i].questionHindi != "undefined" && typeof res.questionData[i].questionHindi.commonText != "undefined")?true:false;	
				if(qInHindi)	
					englishQData += ' language="english"';	
				englishQData += '>' + 	
						'<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qcommonText + '</div></div><div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';	
				englishQData += '<div>';
				
				for (var k in res.questionData[i].question.subQuestion[j].answers) {
					valueClass = '';
					
					var str = ""+res.questionData[i].question.subQuestion[j].answers[k].text;
					str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
					//qdata = qdata + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container ' + valueClass + '">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';
					
					englishQData = englishQData + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container ' + valueClass + '">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';
					questionOption++;
				}
				//qdata += '</div>';
				//qdata = qdata + '<div class="solutionTab">' +
				//				'</div><div class="CheckAnsspacing"></div>' + '</div>';
				
				
				englishQData += '</div>';	
				englishQData = englishQData + '<div class="solutionTab english">' +	
								'</div><div class="CheckAnsspacing"></div>' + '</div>';	
				var hindiQData = '';	
				if(qInHindi)	
				{	
					qcommonText = res.questionData[i].questionHindi.commonText;	
					qcommonText = qcommonText.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					sqquestion = res.questionData[i].questionHindi.subQuestion[j].question;	
					sqquestion = sqquestion.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
		
					hindiQData = '<div class="selectQuesLang" language="hindi">' +	
							'<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qcommonText + '</div>' +	
							'</div><div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';	
						
					hindiQData += '<div>';	
					for (var k in res.questionData[i].questionHindi.subQuestion[j].answers) {	
						valueClass = '';	
							
						var str = ""+res.questionData[i].questionHindi.subQuestion[j].answers[k].text;	
						str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
						hindiQData = hindiQData + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container ' + valueClass + '">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';	
					}	
					hindiQData += '</div>';	
					hindiQData = hindiQData + '<div class="solutionTab hindi">' +	
									'</div><div class="CheckAnsspacing"></div>' + '</div>';	
				}	
				qdata = '<div class="eachQuestion  quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '" subques-no="' + j + '">' + 	
					englishQData + hindiQData + '</div>';	
					
				$(qdata).appendTo('.quiz_content');

				if (myQuiz == 'active') {
					myQuiz = '';
				}
				questionNo++;
			}
		}
		if (this.questionincrement == true) {
			questionNo++;
		} else {
			this.questionincrement = true;
		}
	}
	html += "</div>"+
			'<span class="glyphicon glyphicon-menu-right question-numberbtnright"></span>'+
			"</div>";
	html +=	"<div class='submitBtn'><button class='submit quiz-report btn btn-default' data-action='app/quizreport&id="+quizId+"'>Quiz Score</button></div>";
	$("#quiz-status-modal").find('.modal-body').html(html);
	MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
	tr$.appendRemoteHost($('#myQuiz'));
	var totalQuestions = this.data.quizInfo.info.totalQuestions;
	$(this.dom).find('.eachQuestion').swipe({
		swipe:function(event, direction, distance, duration, fingerCount) {
			if(direction == 'left'){
				$('.nextQuestion').click();
			}
			if(direction == 'right'){
				$('.prevQuestion').click();
			}
		}.bind(this),
		threshold: 70,
		allowPageScroll:"auto"
	});
	this.HandleQuestionStatus();
	this.ReviewQuestion();
	this.BindView();
};
appquizreviewController.prototype.HandleQuestionStatus = function()
{
	$('#quiz-status-modal').find('.statusbody').find('.quiz-report').unbind().bind('click', this, function(e){
		$('#quiz-status-modal').modal('hide');
		if(e.data.click == true) 
		{
			e.data.QuestionPosition = 0;
			UrlMgmt.getObj().PopView();
		}
	});
	var start = $(this.dom).find(".item");
	var len = start.length;
	$('#quiz-status-modal').find('.statusbody').find('p[data-quesno]').css('cursor', 'pointer');
	$('#quiz-status-modal').find('.statusbody').find('p[data-quesno]').unbind().bind("click", this, function(e) {
		$('#quiz-status-modal').modal('hide');
		var quesno = $(this).attr('data-quesno');
		
		e.data.QuestionPosition = parseInt(quesno) - 1;
		$(e.data.dom).carousel(parseInt(e.data.QuestionPosition));
		$(e.data.dom).carousel("pause");
		if (e.data.QuestionPosition == len-1) {
			$(e.data.dom).find('.questionNavigation').find(".prevQuestion").show();
			$(e.data.dom).find('.questionNavigation').find(".nextQuestion").hide();
			$(e.data.dom).find('.questionNavigation').find(".finish").show();
			if(len == 1){
				$(e.data.dom).find('.questionNavigation').find(".prevQuestion").hide();
				$(e.data.dom).find('.questionNavigation').find(".nextQuestion").hide();
			}
		}
		else if (e.data.QuestionPosition == 0) {
			$(e.data.dom).find('.questionNavigation').find(".prevQuestion").hide();
			$(e.data.dom).find('.questionNavigation').find(".nextQuestion").show();
			$(e.data.dom).find('.questionNavigation').find(".finish").hide();
		}
		else{
			$(e.data.dom).find('.questionNavigation').find(".prevQuestion").show();
			$(e.data.dom).find('.questionNavigation').find(".nextQuestion").show();
			$(e.data.dom).find('.questionNavigation').find(".finish").hide();
		}
		$(e.data.dom).find(".quizquestnno").text(parseInt(e.data.QuestionPosition) + 1);
		$(e.data.dom).find(".timer .questionTimer").text(e.data.timedata[parseInt(e.data.QuestionPosition)] + ' SECS');
	});
};
appquizreviewController.prototype.ReviewQuestion = function()
{
	var count = 0;
	var correct = 0;
	
	var total = 0;
	for (var i in this.data.reportAnswer) 
	{
		for (var j in this.data.reportAnswer[i])
		{
			this.useranswer[total] = -1;
			if(Array.isArray(JSON.parse(this.data.reportAnswer[i][j].answer))){
				this.useranswer[total] = JSON.parse(this.data.reportAnswer[i][j].answer).indexOf(true);
			}
			this.questionanswer[total] = -1;
			if(Array.isArray(this.data.resultData[i].answer[j])){
				this.questionanswer[total] = this.data.resultData[i].answer[j].indexOf(true);
			}
			this.timedata[total] = 0;
			if(this.data.reportAnswer[i][j].timeConsumed != null){
				this.timedata[total] = (parseInt(this.data.reportAnswer[i][j].timeConsumed));
			}
			this.solution[total] = this.data.resultData[i].solution[j];
			//new code start
			if(typeof this.data.resultData[i].solutionHindi != "undefined")	
				this.hindiSolution[total] = this.data.resultData[i].solutionHindi[j];	
			else	
				 this.hindiSolution[total] = "";
			//new code end
			
			total++;
		}
	}
	var questionanswer = this.questionanswer;
	var useranswer = this.useranswer;
	var solution = this.solution;
	//new code start
	var hindiSolution = this.hindiSolution;	
	//new code end
	
	$('.quizSection').find('.item').each(function() {
		var index = questionanswer[count];
		var userindex = useranswer[count];
		if (index == userindex) {
			$(this).find("label").addClass("no_hover");
			$(this).find("input[value='" + index + "'] ~ .labelDiv").addClass("correct");
			$(this).find(".labelDiv.correct").find(".indicator").addClass("glyphicon glyphicon-ok");
			correct++;
		} else {
			$(this).find("label").addClass("no_hover");
			$(this).find("input[value='" + userindex + "'] ~ .labelDiv").addClass("wrong");
			$(this).find("input[value='" + index + "'] ~ .labelDiv").addClass("correct");
			$(this).find(".correct").find(".indicator").addClass("glyphicon glyphicon-ok");
			$(this).find(".wrong").find(".indicator").addClass("glyphicon glyphicon-remove");
		}
		$(this).find("label").unbind('click');
		
		
		
		// var str = solution[count];
		// if ( typeof str == "object")
			// str = str[0];
		// str = ""+str;
		// str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
		// if (str != "")
			// $(this).find(".solutionTab").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + str + "<hr>");
		// else
			// $(this).find(".solutionTab").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>No Solution Available<hr>");
		
		var englishSolutionStr = solution[count];	
		var hindiSolutionStr = hindiSolution[count];	
		if ( typeof englishSolutionStr == "object")	
			englishSolutionStr = englishSolutionStr[0];	
		englishSolutionStr = ""+englishSolutionStr;	
		englishSolutionStr = englishSolutionStr.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
		hindiSolutionStr = hindiSolutionStr.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
		if (englishSolutionStr != "")	
			$(this).find(".solutionTab.english").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + englishSolutionStr + "<hr>");	
		else	
			$(this).find(".solutionTab.english").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>No Solution Available<hr>");	
		if (hindiSolutionStr != "")	
			$(this).find(".solutionTab.hindi").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + hindiSolutionStr + "<hr>");	
		else	
			$(this).find(".solutionTab.hindi").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>No Solution Available<hr>");	

		
		$(this).find("img").addClass("img-responsive");
		count++;
	});
	tr$.appendRemoteHost($('.solutionTab'));
	MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
};
appquizreviewController.prototype.PopulateView = function() {
	Total_questions = parseInt(this.data.quizInfo.info.totalQuestions);
	//TODO no need to pass parameters
	this.Quizpatti(this.data.quizInfo.id, this.data.quizInfo.info.totalQuestions, this.data.quizInfo.info.totalmarks);
	$(".quiz-patti").show();
	$(this.dom).find('.quiz-header').find('.quiz-title').text(this.data.quizInfo.title);
	this.PopulateQuizData(this.data, this.data.quizInfo.id);
};
appquizreviewController.prototype.Timecalculating = function(time) {
	if(time < 0){
		time = 0;
	}
	if (time < 60) {
		return (time + " SECS");
	} else if (time / 60 < 60) {
		return (parseInt(time / 60) + " MINS " + time % 60 + " SECS");
	} else {
		return (parseInt(time / (60 * 60)) + " HRS " + time(time / 60) + " MINS " + time % 60 + " SECS");
	}
};
appquizreviewController.prototype.ClickGuard = function(){  
	this.click = false;  
	setTimeout(function(){   this.click = true;  }.bind(this),750);
};
appquizreviewController.prototype.BindView = function() {

	var totalQuestions = this.data.quizInfo.info.totalQuestions;
	$('.quiz-patti .description .timer .questionTimer').html(this.Timecalculating(this.timedata[this.QuestionPosition]));
	$('.quiz-patti .description .quizquestnno').html(this.QuestionPosition + 1);
	
	$('.nextQuestion').unbind().bind('click', function() {
		if (this.click == true) {
			if (this.QuestionPosition == totalQuestions - 1) {
				return;
			}
			this.QuestionPosition++;
			$('.quiz-patti .description .quizquestnno').html(this.QuestionPosition + 1);
			$('.quiz-patti .description .timer .questionTimer').html(this.Timecalculating(this.timedata[this.QuestionPosition]));
			$('#myQuiz').carousel('next');
			$('#myQuiz').carousel('pause');

			if (this.QuestionPosition == (totalQuestions - 1)) {
				$('.nextQuestion').hide();
				$('.finish').show();
			} else if (this.QuestionPosition == 1) {
				$('.prevQuestion').show();
			}
			this.ClickGuard();
		} else {

		}
	}.bind(this)); 

	$('.prevQuestion').unbind().bind('click', function() {
		if(this.click == true) 
		{  
			if(this.QuestionPosition == 0){
				return;
			}
			this.QuestionPosition--;
			$('.quiz-patti .description .quizquestnno').html(this.QuestionPosition + 1);
			$('.quiz-patti .description .timer .questionTimer').html(this.Timecalculating(this.timedata[this.QuestionPosition]));
			$('#myQuiz').carousel('prev');
			$('#myQuiz').carousel('pause');
			if (this.QuestionPosition == 0) {
				$('.prevQuestion').hide();
			} else if (this.QuestionPosition == (totalQuestions - 2)) {
				$('.nextQuestion').show();
				$('.finish').hide();
			}
		 
			this.ClickGuard();  
		}  
		else {   
			 
			}
	}.bind(this));

	$('.finish').unbind().bind('click', function() {
		if(this.click == true) 
		{
			this.QuestionPosition = 0;
			UrlMgmt.getObj().PopView();
		}
	}.bind(this));
	this.dom.find(".btn-back").unbind().bind("click", this, function(e) {
		this.QuestionPosition = 0;
		if (viewFromNotification && UrlMgmt.getObj().actionStack.length == 1){
			viewFromNotification = false;
			UrlMgmt.getObj().PopView(function(){
				UrlMgmt.getObj().Route({route: 'common/home', needData: true, offlineAllowed: true});
			});
		}
		else{
			UrlMgmt.getObj().PopView();
		}
	});
	$(this.dom).find('.quiz-header').find('.closeBtn').unbind().bind("click", this, function(e){
		UrlMgmt.getObj().PopView();
	});
	
	$(this.dom).find('.quiz-patti ').find('.js-SelectQuizLanguage').unbind().bind("click", this, function(e){	
		var selectedLanguage = $(this).attr("data-languageselected");	
		if(selectedLanguage == TestLanguageType.English)	
		{	
			$(this).attr("data-languageselected", TestLanguageType.Hindi);	
			$(this).find("img").attr('src', "img/hindi-eng.png");	
			$(e.data.dom).find('.eachQuestion [language="english"]').hide();	
			$(e.data.dom).find('.eachQuestion [language="hindi"]').show();	
		}	
		else	
		{	
			$(this).attr("data-languageselected", TestLanguageType.English);	
			$(this).find("img").attr('src', "img/eng-hindi.png");	
			$(e.data.dom).find('.eachQuestion [language="english"]').show();	
			$(e.data.dom).find('.eachQuestion [language="hindi"]').hide();	
		}	
	});
	
	$(this.dom).find('.showQuesStatus').unbind().bind('click', function(){
		$('#quiz-status-modal').modal('show');
		if($('#quiz-status-modal').find('.statusbody').find(".questionsholder").length > 0){
			setTimeout(function(){
				slider("questionsholder","questionsslider","question-number");
			},200);
		}
	});
}; 