/******* Rate App *******/
var _appRate = null;
function AppRate()
{
	this.appRated = false;
	this.modalDom  = $("#rate-app-modal");
	this.modalShownCount = 0;
};

AppRate.getObj = function()
{
	if(_appRate === null)
	{
		_appRate = new AppRate();
		_appRate.BindEvents();
	}
	return _appRate;
};
AppRate.prototype.BindEvents = function()
{
	this.modalDom.find('.js-rate-app').unbind().bind('click',this,function(e){e.data.RateApp();});
};
AppRate.prototype.CheckIfRated = function()
{
	var recordId  = 0;
	var userinfo = UrlMgmt.getObj().userData;
	if(userinfo && typeof userinfo.id != 'undefined'){
		recordId = userinfo.id;
	} 
	if(!this.appRated && this.modalShownCount < 2)
	{
		loadExistingData({entity: "apprated", recordId: recordId, fileErrorHandling: false}, function(data){
			this.appRated = true;
		}.bind(this), function(){
			this.ShowModal();
			this.modalShownCount++;
		}.bind(this));
	}
};

AppRate.prototype.ShowModal = function()
{
	this.modalDom.modal('show');
	$(this.modalDom).find('.rate-msg').find('span.appName').html(Application_name);
};

AppRate.prototype.RateApp = function()
{
	this.modalDom.modal('hide');
	cordova.plugins.market.open(UrlMgmt.getObj().App.appId);
	this.StoreAppRated();
};
AppRate.prototype.StoreAppRated = function()
{
	var recordId  = 0;
	var userinfo = UrlMgmt.getObj().userData;
	if(userinfo && typeof userinfo.id != 'undefined'){
		recordId = userinfo.id;
	}
	writeData("apprated.json", "apprated", recordId, {"success": "true"}, function(){
		this.appRated = true;
	}.bind(this));
};
AppRate.prototype.PopulateCard = function(parentDom)
{
	var card =
		'<div class="rate-app">'+
			'<div>'+
				'<div class="rate-msg">'+
					'<span>If you enjoy using <span class="text-blue">'+Application_name+'</span>, would you mind taking a moment to rate it?'+
					 ' It won\'t take more than a minute.</span>'+
				'</div>'+
				'<div>'+
					 '<span class="btn btn-default js-rate-app">RATE US NOW</span>'+
				'</div>'+
			'</div>'+
		'</div>';
	parentDom.html(card);
	parentDom.find('.js-rate-app').unbind().bind('click',this,function(e){e.data.RateApp();});
};