var commonhomeController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.refresh = true;
	
};
commonhomeController.prototype.Init = function(viewDom)
{

	this.dom = viewDom;
	this.dom.addClass('refreshMe');
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	this.data.header = urlMgmt.menuData;
	// 
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){		
		this.OfflineInit();
	}
	else
	{
		
		if(this.data.oldapphomeview != undefined && this.data.oldapphomeview == 1)
		{
			
		 	this.OnlineInit();
		}else{
			
			this.HomeBatchViewInit();
		}	
	}
	urlMgmt.removeLoader();
};
commonhomeController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'HOME', true, false, true);
};
commonhomeController.prototype.OfflineInit = function()
{
	$(this.dom).find('.dailyquiz').hide();
	if(this.data.oldapphomeview != undefined && this.data.oldapphomeview == 1)
	{
		Factory.getObj().LoadViewForOffline(this);
	}	
};
commonhomeController.prototype.OnlineInit = function() {
	if(!(this.data.oldapphomeview != undefined && this.data.oldapphomeview == 1))
	{
		this.HomeBatchViewInit();
	}
	else{	
		if($(this.dom).find(".tryagain").length != 0)
			$(this.dom).find(".tryagain").remove();
		if(typeof vidu != 'undefined' && vidu == 1){
			this.OnlineViduInit();
		}
		else{
			this.OnlineNonViduInit();
		}
	}
	
};
commonhomeController.prototype.HomeBatchViewInit = function()
{
	$(this.dom).find('.alert-container').hide();
	$(this.dom).find('.dailyquiz').hide();
	$(this.dom).find('.customer_banner').hide();
	$(this.dom).find('.rate-app-card').hide();
	$(this.dom).find('.YoutubeVideosList').hide();
	$(this.dom).find('.youtubevideoTitle').hide();
	$(this.dom).find('.LiveClassesList').hide();
	$(this.dom).find('.liveclassTitle').hide();
	$(this.dom).find('.home-featured-articles').hide();
	$(this.dom).find('.categoryDiv').hide();					
	$(this.dom).find('.categories-msg').hide();
	
	Factory.getObj().ShowNotifyUpdate();
	tr$.touchScrollAnimation(this.dom);
	if($('.packageContainer').length)
	{
		$('.packageContainer').empty();
	}
    this.LoadCardViewPackages();

	$(this.dom).find(".customer_banner").hide();
	this.BindEvents();
	if(!UrlMgmt.getObj().App.isOnline){
		// populateOfflineImages(this.dom);
	}
};
commonhomeController.prototype.OnlineViduInit = function()
{
	$(this.dom).find('.alert-container').hide();
	$(this.dom).find('.dailyquiz').hide();
	Factory.getObj().ShowNotifyUpdate();
	tr$.touchScrollAnimation(this.dom);
	
	this.LoadBanner();
	this.LoadHeadings();
	this.LoadPackages();
	this.LoadDemoVideosVidu();
	//Rate App Card
	AppRate.getObj().PopulateCard(this.dom.find('.rate-app-card'));
	this.BindEvents();
	//tr$.StoreImagesInBase64(this.dom);
	if(!UrlMgmt.getObj().App.isOnline){
		populateOfflineImages(this.dom);
	}
};

commonhomeController.prototype.LoadCardViewPackages = function()
{
		
		var coursesHTML = '' +Factory.getObj().ActiveCourseCard(sortObjectOnListIndex(this.data.packages))+' ';
		if(!UrlMgmt.getObj().pulltorefresh)
		{
			
			$(this.dom).find('.courselist').find('.mpackageholder').find('.packageContainer').append(coursesHTML);
		}
		else{
			UrlMgmt.getObj().pulltorefresh = 0;
			$(this.dom).find('.courselist').find('.mpackageholder').find('.packageContainer').html(coursesHTML);
		}
		
	
};
commonhomeController.prototype.OnlineNonViduInit = function()
{
	$(this.dom).find('.dailyquiz').show();
	Factory.getObj().ShowNotifyUpdate();
	tr$.touchScrollAnimation(this.dom);
	this.LoadSubscriptionAlert();
	
	this.LoadBanner();
	this.LoadHeadings();
	this.LoadDailyQuiz();
	if(typeof loadOnHome != 'undefined' && loadOnHome == "exam"){
		this.LoadAllExams();
	}
	else{
		this.LoadAllBatches();
	}
	this.LoadFeaturedArticles();
	this.LoadYouTubeVideos();
	this.LoadDemoVideos();
	if(UrlMgmt.getObj().subscription == "1")
		this.LoadFloatingBtn();
	//Rate App Card
	AppRate.getObj().PopulateCard(this.dom.find('.rate-app-card'));
		
	this.BindEvents();
	//tr$.StoreImagesInBase64(this.dom);
	if(!UrlMgmt.getObj().App.isOnline){
		populateOfflineImages(this.dom);
	}
	//header is required for featured articles -- routing back in app
	if(AppBrowser.getObj().data == null && typeof this.data.header !== 'undefined' && tr$.length(this.data.header))
	{
		AppBrowser.getObj().data = this.data.header;
	}
};
commonhomeController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data.header = urlMgmt.menuData;
	this.OnlineInit();
	urlMgmt.removeLoader();
};
commonhomeController.prototype.BindEvents = function()
{
	if(this.data.oldapphomeview != undefined && this.data.oldapphomeview == 1)
	{
		 $(this.dom).find('.batch-label').hide();
		 $(this.dom).find(".customer_banner").show();
	}
	else
	{
		$(this.dom).find(".customer_banner").hide();
		 $(this.dom).find('.batch-label').show();		
	} 
	$('.subscribe-alert-close').unbind().bind('click', this, function() {
		$('.alert-container').css("display", "none");
	});
	$('.btnExamSubscribe').unbind().bind('click', this, function() {
		if(LoggedInUser.Auth())
		{
			console.log(LoggedInUser.Auth());
			UrlMgmt.getObj().Route({route:'common/tr2subscription', needData: false});
		}
		else
		{
			LoggedInUser.onLoginSuccess = function(){
				UrlMgmt.getObj().PopView(function(){
					UrlMgmt.getObj().Route({route:'common/tr2subscription', needData: false});
				});
			};
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
		}
	});
   if( !(this.data.oldapphomeview != undefined && this.data.oldapphomeview == 1))
	{
		
	   if(this.data.nextPage)
			$(this.dom).bind('scroll',this,function(e){
		
			            if($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight) {
			             e.data.LoadMoreData();
			             $(this).unbind('scroll');
		                 
			        	}	    
			});
	}	
		
   	if(typeof payment_policy != "undefined" && parseInt(payment_policy) == 2){
		this.dom.find('.js-checkout').unbind().bind('click', this, function(e) {
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	
			this.dom.find('.js-checkout').html("More");
			
	}else{
	
		this.dom.find('.js-checkout').unbind().bind('click', this, function(e) {
			e.stopPropagation();
			UrlMgmt.getObj().Route({
				route : $(this).data('action'),
				needData : true,
				offlineAllowed : false
			});
		});			
	}

		this.dom.find('.mpackage').unbind().bind('click', this, function(e) {
			e.stopPropagation();
		UrlMgmt.getObj().Route({
			route : "item/package&id="+$(this).data('deliveryid')+"",
			needData : true,
			offlineAllowed : false
		});
	});	
			
};

commonhomeController.prototype.LoadMoreData = function(e){

	var buttonhtml = "<div class='loadBatches ' style='text-align: center;'><img src='img/loader.svg' alt='refreshing' style='height:45px;width:45px;background-color:white;border-radius:50%;'/></div>";
	$(this.dom).find('.packageContainer').append(buttonhtml);
	
	tr$.ajax({
				mod : "tr2package",
				ack : "getActivePackages",
				additionalParams : {
					currentPage : parseInt(this.data.currentPage) + 1,
					pkgsPerPage : this.data.pkgsPerPage
				},
				successClb : function(response) {
					try {
						if (response.result.state == "ok") {
							$(this.dom).find('.packageContainer').find('.loadBatches').remove();
							this.data.currentPage = response.data.currentPage;
							this.data.nextPage = response.data.nextPage;
							this.data.packages = response.data.packages;
							this.LoadCardViewPackages();
							this.BindEvents();
							UrlMgmt.getObj().lazyload.update();
						}
					} catch(e) {
						console.log(response.data);
						console.log("error=" + e);
						this.BindEvents();
					}
				}.bind(this),
				errorClb : function() {
					// this.BindEvents();
					//TODO show some relavent msg
				}
			});
	
	
};
commonhomeController.prototype.LoadBanner = function(){
	if(homepageBannerRequired == true){
		$(this.dom).find('.customer_banner').show();
		if(typeof this.data.bannerImghtml != 'undefined' && this.data.bannerImghtml != null && this.data.bannerImghtml.length > 0){
			$(this.dom).find('.customer_banner').html(this.data.bannerImghtml);
		}
		if($('#myCarousel').length > 0){
			$('#myCarousel').swipe({
		        swipeLeft:function(event, direction, distance, duration, fingerCount) {
		             $(this).carousel('next');  
		        },
		        swipeRight:function(event, direction, distance, duration, fingerCount) {
		             $(this).carousel('prev');
		        }
			});
		}
	}
	else if(homepageBannerRequired == false){
		$(this.dom).find('.customer_banner').hide();
	}
};
commonhomeController.prototype.LoadSubscriptionAlert = function(){
	if(tr$.length(this.data.header.myExams) == 0)
	{
  	//	subscribe cointainer commented as per requirement 
  /* this.dom.find('.alert-container').html(
		'<div class="exam-subscribe-alert">'+
			'<div class="alert-img">'+
				'<img src="img/dangerping.png" alt="subscribe-exam-alert"/>'+
			'</div>'+
			'<div class="alert-message">'+
				'<span>It seems you have not subscribed any exams yet</span>'+
			'</div>'+
			'<div class="alert-button">'+
				'<button class="btn btn-primary btnExamSubscribe">SUBSCRIBE EXAMS</button>'+
			'</div>'+
		'</div>'+
		'<div class="subscribe-alert-close"><img src="img/closebtn.png"/></div>'
		);*/
	}
};
commonhomeController.prototype.LoadHeadings = function(){
	if(typeof vidu != 'undefined' && vidu == 1){
		this.dom.find('.categories-msg').text('Package Details');
	}
	else if(typeof loadOnHome != 'undefined' && loadOnHome == "exam"){
		this.dom.find('.categories-msg').text('Mock Tests');
	}
	else{
		this.dom.find('.categories-msg').text('Online Class Details');
	}
};
commonhomeController.prototype.LoadDailyQuiz = function()
{
	var counter = 0;
	if(typeof this.data.OfferLinksDescription == 'undefined'){
		$(this.dom).find('.dailyquiz').hide();
		return;
	}
	$(this.dom).find('.quizPatty').html(this.data.OfferLinksDescription);
	var urls = [];
	var listline = "";
	$(this.dom).find('.quizPatty > a').each(function(index,elem){
		$(elem).attr("data-action","");
		var href = $(elem).attr("href");
		var str = href.split('#')[0];
		if(str.length > 0)
		{
			urls.push(href);
		}
		$(this).wrap('<div class="item"></div>');
		listline += "<li class='quizPatty-dot' data-target='#quizpos-Carousel' data-slide-to='"+(counter++)+"'></li>";
	});
	$('#quizpos-Carousel').find('.carousel-indicators').html(listline);
	if(urls.length > 0)
	{
		tr$.ajax({
			mod: "tr2app",
			ack: "geturlaction",
			additionalParams:{
				urls: urls
			},
			successClb: function(response, obj){
				var data = response.data;
				if(Object.keys(data).length > 0)
				{
					for(var i in data)
					{
						$('.quizPatty').find('a[href="'+i+'"]').attr("data-action",data[i]["action"]+"&response-type=2&fromapp=1");
						if (!(typeof window.sqlitePlugin == 'undefined' || SQLiteOps.getObj().databaseOpen == false)) {
							SQLiteOps.getObj().WriteTable("urlaction",data[i].urlKey, data[i]["action"]);
						}
					}
					$(obj.dom).find(".QuizePatti").unbind().bind("click", function(e) {
						e.preventDefault();
						if ($(e.currentTarget).attr("accesstype") == TR2AccessType.LOGIN_REQUIRED && !LoggedInUser.Auth()) {
							UrlMgmt.getObj().Route({
								route : 'common/tr2login',
								needData : false
							});
							return false;
						}
						URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
					});
				}
			},
			errorClb: function(msg, obj){
				$(obj.dom).find(".QuizePatti").unbind().bind("click", function(e) {
						e.preventDefault();
						if ($(e.currentTarget).attr("accesstype") == TR2AccessType.LOGIN_REQUIRED && !LoggedInUser.Auth()) {
							UrlMgmt.getObj().Route({
								route : 'common/tr2login',
								needData : false
							});
							return false;
						}
						URLRedirection($(e.currentTarget).attr('href'), $(e.currentTarget).attr('data-action'));
					});
			}
		}, this);

	}

	var firstcard = $(this.dom).find('.quizPatty').find(".item");
	var firstdot = $(this.dom).find(".quizPatty-dot");
	if(firstcard != undefined && firstcard[0] != undefined)
		firstcard[0].classList.add("active");
	if(firstdot != undefined && firstdot[0] != undefined)
		firstdot[0].classList.add("active");

	var trendingnow = "<div class='daily-quiz-msg'><p>TRENDING NOW</p></div>";

	var xyz = $(this.dom).find("#quizpos-Carousel");
	$(xyz).find(".item").prepend(trendingnow);

	$(this.dom).find(".QuizePatti").prepend("<div><img src='img/trending-card-timer.png'></div>");

	var carouselDom = this.dom.find('#quizpos-Carousel');
	tr$.carouselSet(carouselDom,this.dom);
};
commonhomeController.prototype.LoadAllBatches = function()
{
	var allExams = this.data.header.exams;
	var categoriesCard = "";
	categoriesCard = "";
	for (var category in this.data.header.categories) {
		var allCategories = this.data.header.categories;
		var categoriesCardContent = "";
		for (var categoryBatch in allCategories[category].batches) {
			var Batch = allCategories[category].batches[categoryBatch];
			categoriesCardContent += '<div><a class="_eventListener examlist testlist" data-action="item/batch&id=' + Batch["id"] + '&loadall=1">' + Batch["title"] + '</a></div>';
		}
		if(categoriesCardContent != "")
		{
			categoriesCard += '<div class="categoryCard">' + '<div class="categoryHead">' +
		'<h4>' + allCategories[category]["title"] + '</h4>' + '</div>' + '<div class="examData">' + '<span class="examlistbtnup"><img src="img/examup.png"/></span>' + '<div class="examContent">';
		
			categoriesCard += (categoriesCardContent + '</div>' + '<span class="examlistbtndown"><img src="img/examdown.png"/></span>' + '</div>' + '</div>');
		}
	}
	$('.categoryposition').html(categoriesCard);

	var categoryVerticalslide = new Array();
	for ( c = 0; c < $('.categoryCard').length; c++) {
		categoryVerticalslide[c] = new slideVertical();
		categoryVerticalslide[c].Init("categoryCard", "examContent", "examlist", c);
	}

	$('.examData').find('._eventListener').unbind().bind('click', function(e) {
		var action = $(e.currentTarget).attr('data-action');
		UrlMgmt.getObj().Route({route: action, needData: true, offlineAllowed: true});
	}.bind(this));
};
commonhomeController.prototype.LoadAllExams = function()
{
	var allExams = this.data.header.exams;
	var categoriesCard = "";
	var categoriesCard_loop_cnt = 0;
	//My subscribed Exams Card
	if(this.data.header.myExams.length > 0){
		categoriesCard += '<div class="categoryCard">' + '<div class="categoryHead">' +
			'<h4> My Exams </h4>' + '</div>' + '<div class="examData">' + '<span class="examlistbtnup"><img src="img/examup.png"/></span>' + '<div class="examContent">';
		for(var myExam in this.data.header.myExams){
			var examData = getMatchingValue(this.data.header.exams, "id", this.data.header.myExams[myExam]);
			//Get the testListId for selected index with lowest index
			if(typeof examData != "undefined"){
				categoriesCard_loop_cnt ++;
				var testListId = examData["testListId"][0];
				categoriesCard += '<div><a exam-id="'+ examData["id"] +'" class="_eventListener examlist testlist myexams" data-action="lists/test&id='+ testListId +'&loadall=1">' + examData["title"] + '</a></div>';
			}
		}
		if(categoriesCard_loop_cnt == 0){
			categoriesCard = "";
		} else {
			categoriesCard += '</div>' + '<span class="examlistbtndown"><img src="img/examdown.png"/></span>' + '</div>' + '</div>';

		}
		
			}
	var trackTestList = [];
	for (var category in this.data.header.categories) {
		var allCategories = this.data.header.categories;
		var categoriesCardContent = "";
		for (var categoryExam in allCategories[category].exams) {
			var examId = allCategories[category].exams[categoryExam];
			var testListIds = (getMatchingValue(allExams, "id", examId)).testListId;
			for(var testList in testListIds){
				var testListData = getMatchingValue(this.data.header.testLists, "testListId", testListIds[testList]);
				if(trackTestList.indexOf(testListData["testListId"]) == -1){
					categoriesCardContent += '<div><a class="_eventListener examlist testlist" data-action="lists/test&id=' + testListData["testListId"] + '&loadall=1">' + testListData["title"] + '</a></div>';
					trackTestList.push(testListData["testListId"]);
				}
			}
		}
		if(categoriesCardContent != "")
		{
			categoriesCard += '<div class="categoryCard">' + '<div class="categoryHead">' +
		'<h4>' + allCategories[category]["title"] + '</h4>' + '</div>' + '<div class="examData">' + '<span class="examlistbtnup"><img src="img/examup.png"/></span>' + '<div class="examContent">';
		
			categoriesCard += (categoriesCardContent + '</div>' + '<span class="examlistbtndown"><img src="img/examdown.png"/></span>' + '</div>' + '</div>');
		}
	}
	$('.categoryposition').html(categoriesCard);

	var categoryVerticalslide = new Array();
	for ( c = 0; c < $('.categoryCard').length; c++) {
		categoryVerticalslide[c] = new slideVertical();
		categoryVerticalslide[c].Init("categoryCard", "examContent", "examlist", c);
	}

	$('.examData').find('._eventListener').unbind().bind('click', function(e) {
		var action = $(e.currentTarget).attr('data-action');
		UrlMgmt.getObj().Route({route: action, needData: true, offlineAllowed: true});
	}.bind(this));
};
commonhomeController.prototype.LoadFeaturedArticles = function()
{
	if(typeof this.data.wpArticleList !== 'undefined'
	&& tr$.length(this.data.wpArticleList) > 0 )
	{
		$(this.dom).find('.featured-article-msg').text('Featured Articles');
		var fArticlesHTML = Factory.getObj().LoadFeaturedArticles(this.data.wpArticleList);
			parentDom = this.dom.find('.home-featured-articles').html(fArticlesHTML);
			carouselDom = parentDom.find('.carousel');
		tr$.carouselSet(carouselDom,this.dom);
		tr$.OpenAllLinksInAppBrowser(parentDom);
	}
};
commonhomeController.prototype.LoadYouTubeVideos = function()
{
	if(UrlMgmt.getObj().App.isOnline && typeof this.data.mode == 'undefined'){
		var youtubeDiv = $(this.dom).find('.YoutubeVideosList');
		var youtubeVideos = "";
		for(var key in this.data.youtubeVideosList){
			if(this.data.youtubeVideosList[key].data.preDescription != "")
			{
				youtubeVideos += '<div class="youtubeVideos col-xs-12 col-sm-6"><div class="demoShadow">'+this.data.youtubeVideosList[key].data.preDescription+'</div></div>';
			}
		}
		if(youtubeVideos != "") //Checking weather the youtubeVideos exist or not to display Heading
		{
			$(this.dom).find('.youtubevideoTitle').text('Latest Youtube Videos');
		}
		$(youtubeDiv).html(youtubeVideos);
	}
	document.addEventListener('webkitfullscreenchange', function(){
		var action = UrlMgmt.getObj().actionStack;
		var currentAction = $(action[action.length - 1].controler.dom).attr('id');

    	var state = ((typeof document.webkitIsFullScreen !== 'undefined' && document.webkitIsFullScreen) ||
    			(typeof document.isFullScreen !== 'undefined' && document.isFullScreen));
    	if (state){
     		screen.orientation.lock('landscape');
     	}
	    else
	      screen.orientation.lock('portrait');
	}, false);

   	document.addEventListener("backbutton", function(e){
   		screen.orientation.lock('portrait');
   	}, false);
};
//Load the Packages which are marked in custom Header to be displayed on Homepage
commonhomeController.prototype.LoadPackages = function()
{
	var customHeader = this.data.customHeader;
	var cardHtml = "";
	if(typeof customHeader != 'undefined' && customHeader != null){
		for(var menuItem in customHeader){
			if(customHeader[menuItem].attributes.indexOf('data-home-item=true') > -1){
				//Header item to be displayed in homepage
				var headerItem = customHeader[menuItem];
				//Check the levels of data present
				var levels = 1;
				for(var child in headerItem.children)
				{
					if(headerItem.children[child].children.length > 0){
						levels = 2;
						break;
					}
				}
				
				if(levels == 2){
					for(var child in headerItem.children){
						cardHtml += '<div class="categoryCard">'+
										'<div class="categoryHead">'+
											'<h4>'+headerItem.children[child].title+'</h4>'+
										'</div>'+
										'<div class="examData">'+
											'<span class="examlistbtnup">'+
												'<img src="img/examup.png"/>'+
											'</span>'+
											'<div class="examContent">';
						if(headerItem.children[child].children.length > 0){
							for(var item in headerItem.children[child].children){
								cardHtml += '<div class="homeSubItem" style="order:'+headerItem.children[child].children[item].index+';"><a data-url="'+ headerItem.children[child].children[item].url +'" '+headerItem.children[child].attributes+' class="_eventListener examlist testlist myexams">' + headerItem.children[child].children[item].title + '</a></div>';
							}
						}
						else{
							cardHtml += '<div class="homeSubItem" style="order:'+headerItem.children[child].index+';"><a data-url="'+ headerItem.children[child].url +'" '+headerItem.children[child].attributes+' class="_eventListener examlist testlist myexams">' + headerItem.children[child].title + '</a></div>';
						}
						cardHtml += '</div>' + '<span class="examlistbtndown"><img src="img/examdown.png"/></span>' + '</div>' + '</div>';
						
					}
				}
				else if(levels == 1){
					if(headerItem.children.length > 0){
						cardHtml += '<div class="categoryCard">'+
										'<div class="categoryHead">'+
											'<h4>'+headerItem.title+'</h4>'+
										'</div>'+
										'<div class="examData">'+
											'<span class="examlistbtnup">'+
												'<img src="img/examup.png"/>'+
											'</span>'+
											'<div class="examContent">';
						for(var child in headerItem.children){
							cardHtml += '<div class="homeSubItem" style="order:'+headerItem.children[child].index+';"><a data-url="'+ headerItem.children[child].url +'" '+headerItem.children[child].attributes+' class="_eventListener examlist testlist myexams">' + headerItem.children[child].title + '</a></div>';
						}
						cardHtml += '</div>' + '<span class="examlistbtndown"><img src="img/examdown.png"/></span>' + '</div>' + '</div>';
					}	
				}
			}
		}
	}
	
	$('.categoryposition').html(cardHtml);

	var categoryVerticalslide = new Array();
	for ( c = 0; c < $('.categoryCard').length; c++) {
		categoryVerticalslide[c] = new slideVertical();
		categoryVerticalslide[c].Init("categoryCard", "examContent", "examlist", c);
	}

	$('.examData').find('._eventListener').unbind().bind('click', function(e) {
		var url = $(e.currentTarget).attr('data-url');
		if(typeof url == 'undefined' || url.length == 0){
			var action = $(e.currentTarget).attr('data-action');
			if(typeof action != 'undefined' && action.length > 0){
				UrlMgmt.getObj().Route({route: action, needData: true, emptyStack: true});
			}
		}
		else{
			URLRedirection(url);
		}
	}.bind(this));
};
commonhomeController.prototype.LoadDemoVideosVidu = function()
{
	var liveClassesDiv = $(this.dom).find('.LiveClassesList');
	var liveClassesList = {};
	var liveClassEcommData = {};
	for(var index in this.data.segment){
		if(this.data.segment[index].type == 2){
			liveClassesList = this.data.segment[index].liveClassesList;
			liveClassEcommData = this.data.segment[index].liveClassesEcomData;
		}
	}
	if(Object.keys(liveClassesList).length > 0){
		liveClassesList = sortObject(liveClassesList);
	}
	
	var html = "";
	for(var key in liveClassesList){
		var value = liveClassesList[key];
		var data = value[0];
		
		html += Factory.getObj().VideoCard(data, liveClassEcommData[data["itemId"]]);
	}
	if(html != "") // Load heading only if the data exist
	{
		this.dom.find('.liveclassTitle').text('Demo Online Classes');
	}
	$(liveClassesDiv).html(html);
	$(liveClassesDiv).find('._eventListener').unbind().bind('click',this,function(e){
		var urlMgmt = UrlMgmt.getObj();
		var action = (urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route).split('&')[0];
		if(action == $(this).data('action').split('&')[0]){
			urlMgmt.RemoveView();
		}
		UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true, offlineAllowed: true});
	});
	
	//checkout page
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		$(liveClassesDiv).find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    $(liveClassesDiv).find('.js-checkout').html("More");    
	}
	else
	{
		$(liveClassesDiv).find('.js-checkout').unbind().bind('click',this,function(e){
			UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true, offlineAllowed: false});
		});
	}		
	
	$(liveClassesDiv).find('._eventListener').unbind().bind('click', function(e){
		e.preventDefault();
		UrlMgmt.getObj().Route({route:$(e.currentTarget).attr('data-action'), needdata: true, offlineAllowed: false});
	});
};
commonhomeController.prototype.LoadDemoVideos = function()
{
	var liveClassesDiv = $(this.dom).find('.LiveClassesList');
	this.data.liveClassesList = sortObject(this.data.liveClassesList);

	var demoVideos = "";
	for(var key in this.data.liveClassesList){
		var value = this.data.liveClassesList[key];
			data = value[0];
			demoImageUrl = (data.tr1Data.priviewImageUrl ==="")?"img/client_images/defaultlv_class.jpg":data.tr1Data.priviewImageUrl;
		demoVideos += '<div class="demovideohold col-xs-12 col-sm-6" data-action="item/liveclasses&id='+data.id + '">'+
				'<div class="demoShadow">'+
					'<div class="demoVideos"> '+
						'<img class="VideoThumnail lazy" data-src= "'+demoImageUrl+'"/><img class="playBtn" src="img/play-btn.png"/>'+
					'</div>'+
						'<p class="title">'+data.title+'</p>'+
					'<div class="start-date">'+
						'<span><img src = "img/timer.png"/></span>'+
						((new Date(data.tr1Data.startDate) > new Date())?'<span>Scheduled On : </span>':'<span>Conducted On : </span>')+
						tr$.dateAndTimeFormat(data.tr1Data.startDate)+
					'</div>'+
				'</div>'+
			'</div>';
	}
	if(demoVideos != "") // Load heading only if the data exist
	{
		this.dom.find('.liveclassTitle').text('Demo Online Classes');
	}
	$(liveClassesDiv).html(demoVideos);
	$(liveClassesDiv).find('.demovideohold').unbind().bind('click', function(e){
		e.preventDefault();
		UrlMgmt.getObj().Route({route:$(e.currentTarget).attr('data-action'), needdata: true, offlineAllowed: false});
	});
};
commonhomeController.prototype.LoadFloatingBtn = function()
{
	var fab =
		'<div class="btnExamSubscribe btn-fab">'+
			'<img src="img/subscribe_btn.png">'+
		'</div>';
	this.dom.find('#view-dashboard').find('.btn-fab').remove();
	this.dom.find('#view-dashboard').append(fab);
};
commonhomeController.prototype.showBookmarks = function() {
	tr$.ajax({
		mod : "user",
		ack : "getBookmarkLink",
		callback : function(reply) {
			var serverAddress = remoteServer;
			if(typeof UrlMgmt.getObj().menuData != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta.homeUrl != 'undefined'&& UrlMgmt.getObj().menuData.domainmeta.homeUrl.length > 0){
				serverAddress = 'http://'+UrlMgmt.getObj().menuData.domainmeta.homeUrl;
			}
			window.open(serverAddress + reply.data, '_system');
		}
	});
};

commonhomeController.prototype.LoadWelcomeGift = function()
{
	checkWelcomeGift(function(){
		var welcomeGift = '';
		if(LoggedInUser.Auth())
		{
			welcomeGift +=
				'<div class="giftalert-container">'+
					'<div class="gift-alert">'+
						'<div class="giftMsg">'+
							'<img src="img/gift-box.png"/>'+
							'<span>CLAIM YOUR WELCOME GIFT</span>'+
						'</div>'+
					'</div>'+
				'</div>';
			this.dom.find(".welcome-gift").html(welcomeGift);
			this.dom.find(".welcome-gift").find(".gift-alert").height(100);
			this.dom.find(".welcome-gift").find(".giftMsg").unbind().bind("click",claimWelcomeGift);

		}
		else
		{
			welcomeGift +=
			'<div class="giftalert-container">'+
				'<div class="gift-alert">'+
					'<div class="Giftimg">'+
						'<img src="img/dangerping.png">'+
					'</div>'+
					'<div class="alert-message">'+
						'<span>It seems you have not Logged in.'+
						'Please <b>LOGIN/REGISTER</b> to Claim your <b>Welcome Gift</b>'+
						'</span>'+
					'</div>'+
					'<div class="giftMsg">'+
						'<img src="img/gift-box.png"/>'+
						'<span>CLAIM YOUR WELCOME GIFT</span>'+
					'</div>'+
				'</div>'+
			'</div>';
			this.dom.find(".welcome-gift").html(welcomeGift);
			this.dom.find(".welcome-gift").find(".giftMsg").unbind().bind("click",function(){
				LoggedInUser.onLoginSuccess = function(){
					UrlMgmt.getObj().PopView();
					claimWelcomeGift();
	    		};
				UrlMgmt.getObj().Route({route: "common/tr2login", needData: false});
			});
		}
	}.bind(this));
};
