/**	Handling the test listing, Running test, Submitting Test,.. **/
var testInstances = null;
//id can be testListId, examId, or packageId
//type will be a string- testlist, exam - for filename or sqlite table name
var commontestlistingController = function()
{
	this.terminate = true;
	
	this.view = null;
	this.id = 0;
	this.parent = null;
	this.tests = null;
	this.type = null;
	this.testReport = {};
	this.bucketId = 0;
	this.testResponse = null;
	this.testShortReport = null;
	this.testAttributes = null;
	this.data = null;
};
commontestlistingController.prototype.Init = function()
{
	this.testResponse = this.tests;
	this.LoadAvailableTests();
};

commontestlistingController.prototype.BindEvents= function()
{
	$('.TSButtons').unbind("click").bind("click", this, function(e){
		if(parseInt($(e.currentTarget).parents('.TStest').attr("typeid")) == 4)
		{
			if(typeof this.data == "undefined")
			{
				// this.parent.urlForMenu
				if(typeof this.parent.data != "undefined")
				{
					// console.log(remoteServer+"/"+this.parent.data.urlKey+"/"+$(e.currentTarget).parents('.TStest').attr("urlkey"));
					UrlMgmt.getObj().Route({route: "item/descriptivetest&id="+remoteServer+"/"+this.parent.data.urlKey+"/"+$(e.currentTarget).parents('.TStest').attr("urlkey"), needData: false, offlineAllowed: true, emptyStack: false});
					return;
				}
			}
			console.log(remoteServer+this.data.examUrlKey+this.data.urlKey+$(e.currentTarget).parents('.TStest').attr("urlkey"));
			UrlMgmt.getObj().Route({route: "item/descriptivetest&id="+remoteServer+"/"+this.data.examUrlKey+"/"+this.data.urlKey+"/"+$(e.currentTarget).parents('.TStest').attr("urlkey"), needData: false, offlineAllowed: true, emptyStack: false});
			return;
		}
		this.parent.refresh = true;
		var parent = $(e.currentTarget).parents('.TStest');
		var testId = parent.attr('data-item');
		var tr2TestId = parent.attr('tr2TestId');
		var bucketId = parent.attr('bucket');
		var currentState = this.tests[testId]["state"];
		console.log("current state: "+currentState);
		var LoginRequired = false;
		if($(e.currentTarget).hasClass('loginRequired')){
			LoginRequired = true;
		}
		if(LoginRequired){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
		}
		else{
			this.TakeTest(e, parent, testId, tr2TestId, bucketId, currentState);
		}
	}.bind(this));
	$('.test-report').unbind().bind('click',function(e){
		if(parseInt($(e.currentTarget).parents('.TStest').attr("typeid")) == 4)
		{
			console.log(remoteServer+this.data.examUrlKey+this.data.urlKey+$(e.currentTarget).parents('.TStest').attr("urlkey"));
			UrlMgmt.getObj().Route({route: "item/descriptivetest&id="+remoteServer+"/"+this.data.examUrlKey+"/"+this.data.urlKey+"/"+$(e.currentTarget).parents('.TStest').attr("urlkey")+"&report=1", needData: false, offlineAllowed: true, emptyStack: false});
			return;
		}
		this.parent.refresh = false;
		UrlMgmt.getObj().Route({route: $(e.currentTarget).data('action'), needData: true, offlineAllowed: true});
	}.bind(this));
	// this.toucheventforTaketestbutton();
};
commontestlistingController.prototype.toucheventforTaketestbutton = function() {
	var flag = true;
	var interval = null;
	$('#ibpsinstruction-modal .modal-body').swipe({
		swipeUp : function(event, direction, distance, duration, fingerCount) {
			if(flag == true)
			{
				$('#ibpsinstruction-modal .termsFooter.themeCol-12.btnDiv').addClass("hide");
				interval = setTimeout(function(){
					$('#ibpsinstruction-modal .termsFooter.themeCol-12.btnDiv').removeClass("hide");
					flag = true;
				},3000);
				flag = false;
			}
		},
		swipeDown : function(event, direction, distance, duration, fingerCount) {
			if(flag == false)
			{
				clearTimeout(interval);
				$('#ibpsinstruction-modal .termsFooter.themeCol-12.btnDiv').removeClass("hide");
				flag = true;
			}
		},
		swipeLeft : function(event, direction, distance, duration, fingerCount) {
			//event.preventDefault();
		},
		swipeRight : function(event, direction, distance, duration, fingerCount) {
			//event.preventDefault();
		},
		allowPageScroll : "vertical",
		threshold : 10,
		fingerReleaseThreshold : 100,
		preventDefaultEvents: false,
	});

};
commontestlistingController.prototype.TakeTest = function(e, parent, testId, tr2TestId, bucketId, currentState)
{
	if(typeof this.tests[testId]["meta"] == 'undefined'){
		alert("Test is closed");
		return false;
	}
			var meta = JSON.parse(this.tests[testId]["meta"]);
				if(typeof meta.isPsycoTest != "undifined" && meta.isPsycoTest == 1){
					alert("This test is available in web only.");
		            return false;
				}
			var languageOptions = meta.hasOwnProperty("languages")?meta["languages"]:[0];
			switch(currentState)
			{
				case testState.NotLoaded:
				case testState.Loaded:
				//For Re Take Test
				case testState.Submitted:
						UrlMgmt.getObj().removeLoader();
						if(!UrlMgmt.getObj().App.isOnline){
							alert("Connect to Internet");
							return;
						}
						switch(Number(e.data.tests[testId]["theme"])){
							case Theme.SSCTHEME:
							case Theme.NEETTHEME:
								var elem1 = $('#ibpsinstruction-modal #testLanguage1');
								elem1.empty();
								for(key in languageOptions)
								{
									elem1.append('<option value="' + languageOptions[key] + '">' + TestLanguageType.Str[languageOptions[key]] + '</option>');
								}
								if(typeof meta.time !== undefined)
								$('#ibpsinstruction-modal .testTime').html(meta.time);
								$('#ibpsinstruction-modal').find('.modal-footer').show();
								$("#ibpsinstruction-modal .languageParentDiv").show();
								$('#ibpsinstruction-modal .langauge-hindi').hide();
								$('#ibpsinstruction-modal .langauge-english').show();
								$('#ibpsinstruction-modal').modal('show');
								$('#ibpsinstruction-modal .sections-navigating').hide();
								
								
								if(languageOptions.length > 1)
								{   
									$(".termsFooter .languageDiv").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
								}
								else
								{
									$(".termsFooter .languageDiv").hide();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").hide();
								}
								$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").unbind().bind("click",this,function(e){
									if($('#ibpsinstruction-modal #testLanguage1').val() == 0) // set Hindi
									{
										$(this).find('img').attr('src', "img/hindi-eng.png");
										$('#ibpsinstruction-modal #testLanguage1').val("1");
										$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									}
									else if($('#ibpsinstruction-modal #testLanguage1').val() == 1) // set English language
									{
										$(this).find('img').attr('src', "img/eng-hindi.png");
										$('#ibpsinstruction-modal #testLanguage1').val("0");
										$('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									}
								});
													
								$('#ibpsinstruction-modal #testLanguage1').change(function(){
									  if($('#ibpsinstruction-modal #testLanguage1').val() == 0){
									  	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
									    $('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									  }
									  else if($('#ibpsinstruction-modal #testLanguage1').val() == 1){
									 	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/hindi-eng.png");
									 	$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									  }
								});
								
								$('#ibpsinstruction-modal #IamReady').unbind("click").bind("click", {obj:e.data,testId:testId,languageOptions:languageOptions}, function(e){
									e.data.obj.tests[e.data.testId]["choosedLang"] = $(elem1).val();
										$('#ibpsinstruction-modal').modal('hide');
										e.data.obj.DownloadTest(testId, bucketId, currentState, false, function(){
											e.data.obj.StartTest(e.data.testId, tr2TestId, testState.Loaded,e.data.obj.tests[e.data.testId]["choosedLang"],e.data.languageOptions);
										});
								});
								
								
							break;
							case Theme.TBSENTRANCE:
                                var elem1 = $('#ibpsinstruction-modal #testLanguage1');
								elem1.empty();
								for(key in languageOptions)
								{
									elem1.append('<option value="' + languageOptions[key] + '">' + TestLanguageType.Str[languageOptions[key]] + '</option>');
								}
								if(typeof meta.time !== undefined)
									$('#ibpsinstruction-modal .testTime').html(meta.time);
								$('#ibpsinstruction-modal').find('.modal-footer').show();
								$("#ibpsinstruction-modal .languageParentDiv").show();
								$('#ibpsinstruction-modal .langauge-hindi').hide();
								$('#ibpsinstruction-modal .langauge-english').show();
								$('#ibpsinstruction-modal').modal('show');
								$('#ibpsinstruction-modal .sections-navigating').show();
								
								if(languageOptions.length > 1)
								{   
									$(".termsFooter .languageDiv").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
								}
								else
								{
									$(".termsFooter .languageDiv").hide();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").hide();
								}
								$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").unbind().bind("click",this,function(e){
									if($('#ibpsinstruction-modal #testLanguage1').val() == 0) // set Hindi
									{
										$(this).find('img').attr('src', "img/hindi-eng.png");
										$('#ibpsinstruction-modal #testLanguage1').val("1");
										$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									}
									else if($('#ibpsinstruction-modal #testLanguage1').val() == 1) // set English language
									{
										$(this).find('img').attr('src', "img/eng-hindi.png");
										$('#ibpsinstruction-modal #testLanguage1').val("0");
										$('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									}
								});
													
								$('#ibpsinstruction-modal #testLanguage1').change(function(){
									  if($('#ibpsinstruction-modal #testLanguage1').val() == 0){
									  	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
									    $('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									  }
									  else if($('#ibpsinstruction-modal #testLanguage1').val() == 1){
									 	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/hindi-eng.png");
									 	$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									  }
								});
								
								$('#ibpsinstruction-modal #IamReady').unbind("click").bind("click", {obj:e.data,testId:testId,languageOptions:languageOptions}, function(e){
									e.data.obj.tests[e.data.testId]["choosedLang"] = $(elem1).val();
										$('#ibpsinstruction-modal').modal('hide');
										e.data.obj.DownloadTest(testId, bucketId, currentState, false, function(){
											e.data.obj.StartTest(e.data.testId, tr2TestId, testState.Loaded,e.data.obj.tests[e.data.testId]["choosedLang"],e.data.languageOptions);
										});
								});
							default:
                                var elem1 = $('#ibpsinstruction-modal #testLanguage1');
								elem1.empty();
								for(key in languageOptions)
								{
									elem1.append('<option value="' + languageOptions[key] + '">' + TestLanguageType.Str[languageOptions[key]] + '</option>');
								}
								if(typeof meta.time !== undefined)
									$('#ibpsinstruction-modal .testTime').html(meta.time);
								$('#ibpsinstruction-modal').find('.modal-footer').show();
								$("#ibpsinstruction-modal .languageParentDiv").show();
								$('#ibpsinstruction-modal .langauge-hindi').hide();
								$('#ibpsinstruction-modal .langauge-english').show();
								$('#ibpsinstruction-modal').modal('show');
								$('#ibpsinstruction-modal .sections-navigating').show();
								
								if(languageOptions.length > 1)
								{   
									$(".termsFooter .languageDiv").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").show();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
								}
								else
								{
									$(".termsFooter .languageDiv").hide();
									$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").hide();
								}
								$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").unbind().bind("click",this,function(e){
									if($('#ibpsinstruction-modal #testLanguage1').val() == 0) // set Hindi
									{
										$(this).find('img').attr('src', "img/hindi-eng.png");
										$('#ibpsinstruction-modal #testLanguage1').val("1");
										$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									}
									else if($('#ibpsinstruction-modal #testLanguage1').val() == 1) // set English language
									{
										$(this).find('img').attr('src', "img/eng-hindi.png");
										$('#ibpsinstruction-modal #testLanguage1').val("0");
										$('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									}
								});
													
								$('#ibpsinstruction-modal #testLanguage1').change(function(){
									  if($('#ibpsinstruction-modal #testLanguage1').val() == 0){
									  	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/eng-hindi.png");
									    $('#ibpsinstruction-modal .langauge-hindi').hide();
										$('#ibpsinstruction-modal .langauge-english').show();
									  }
									  else if($('#ibpsinstruction-modal #testLanguage1').val() == 1){
									 	$("#ibpsinstruction-modal .js-SelectTestLanguageWithin").find('img').attr('src', "img/hindi-eng.png");
									 	$('#ibpsinstruction-modal .langauge-hindi').show();
										$('#ibpsinstruction-modal .langauge-english').hide();
									  }
								});
								
								$('#ibpsinstruction-modal #IamReady').unbind("click").bind("click", {obj:e.data,testId:testId,languageOptions:languageOptions}, function(e){
									e.data.obj.tests[e.data.testId]["choosedLang"] = $(elem1).val();
										$('#ibpsinstruction-modal').modal('hide');
										e.data.obj.DownloadTest(testId, bucketId, currentState, false, function(){
											e.data.obj.StartTest(e.data.testId, tr2TestId, testState.Loaded,e.data.obj.tests[e.data.testId]["choosedLang"],e.data.languageOptions);
										});
								});
								break;
							}
						break;
				case testState.Started:
					if(UrlMgmt.getObj().App.isOnline){
						e.data.DownloadTest(testId, bucketId, currentState, false, function(){
							UrlMgmt.getObj().removeLoader();
							e.data.StartTest(testId, tr2TestId, currentState,e.data.tests[testId]["choosedLang"],languageOptions);
						});
					}
					else{
						checkIfDataExists('downloadtestdata', testId, function(response, recordId){
							if(response == 0){
								//Offline data doesn't exist (loggedout or attempted test from web earlier)
								alert("Connect to Internet");
							}
							else{
								e.data.StartTest(testId, tr2TestId, currentState,e.data.tests[testId]["choosedLang"],languageOptions);
							}
						});
					}
					
					
					break;
					case testState.Paused:
						  	e.data.DownloadTest(testId, bucketId, currentState, false, function(){
								e.data.StartTest(testId, tr2TestId, testState.Paused,e.data.tests[testId]["choosedLang"],languageOptions);
							});

					break;
				default:
					alert("Internal Error");
					break;
			}
};
commontestlistingController.prototype.LoadTestSeries = function()
{
	console.log("Inside load test series");
	var redata = {};
	loadExistingData({entity: "teststate", recordId: 1, fileErrorHandling: false}, function(response){
		redata = response;
		for(var testIdState in  redata)
		{
			for(var testData in this.tests)
			{
				if(testIdState == testData)
				{
					this.tests[testData]["state"] = redata[testIdState]["state"];
				}
			}
		}
		if(Object.keys(this.tests).length > 0)
		{	
			 this.BindEvents();
		}
		else{
			UrlMgmt.getObj().removeLoader();
		    $('<div class="Loader Freez"><h4>No test has been loaded yet...</h4></div>').appendTo(this.view);
		}
	}.bind(this), function(response){
		if(Object.keys(this.tests).length > 0)
		{	
			console.log("Inside if");
			this.BindEvents();
		}
		else{
			UrlMgmt.getObj().removeLoader();
		    $('<div class="Loader Freez"><h4>No test has been loaded yet...</h4></div>').appendTo(this.view);
		}
	}.bind(this));
};
commontestlistingController.prototype.DownloadTest = function(testId, bucketId, currentState, offline, callback)
{
	UrlMgmt.getObj().showLoader(false);
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer+"/ajax"+"/testId="+testId+"&bucketId="+bucketId+"";
		var status    = "";
		var mod		  = "tr2app";	
		var ack		  = "downloadTest";
	}	
	$.ajax({
		url: remoteServer+"/ajax",
		type: 'POST',
	 	data:{
	 		mod: "tr2app",
			ack: "downloadTest",
			testId: testId,
			//tempUserId: tempUserId,
			bucketId: bucketId,
			fromApp: 1
		},
	 	xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	    timeout: 30000,
	 	success: function(reply){
	 		if(reply.result.state == "ok")
			{
				if(reply.data == "error")
				{
					UrlMgmt.getObj().removeLoader();
					alert("Typing Test will be available on web only!");
					if(this.currentState == testState.Loaded){}
				}
				else if(reply.data.hasOwnProperty("msg") && reply.data["msg"] == "error")
				{
					UrlMgmt.getObj().removeLoader();
					alert("Test is closed");
						//TODO
					if(this.currentState == testState.Submitted){}
				}
				else
				{
					var testAnswers = [];
					var startedFromApp = reply.data.meta.startedFromApp;
					this.obj.testAttributes = reply.data.testAttributes;
					writeData("downloadtestdata_"+this.testId+".json", 'downloadtestdata', this.testId, reply.data.data, function(){
						reply.data.meta = jQuery.parseJSON(reply.data.meta);
						var oldTestMeta = {};
						writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, reply.data.meta, function(){
							writeData("passedTime_"+this.testId+".json", 'passedTime', this.testId, {"passedTime":reply.data.passedTime}, function(){
								loadExistingData({entity: "testmeta", recordId: this.testId, fileErrorHandling: false}, function(oldMeta){
									for(var qNo in reply.data.meta.questions){
										var flag = false;
										var ansOldIndex = -1;
										var ansNewIndex = -1;
										var ansFillOld = [];
										var ansFillNew = [];
										var questionData = reply.data.meta.questions[qNo];
										testAnswers[qNo-1] = {};
										testAnswers[qNo-1]["ans"] = [];
										if(questionData["answer"] != undefined && questionData["answer"]["ans"] != undefined){
											if(questionData["answer"]["ans"].length == 1){
												//NIQ
												ansNewIndex = questionData["answer"]["ans"][0];
											}
											else if(questionData["answer"]["ans"].indexOf(false) == -1){
												//Fill In the Blank
												ansFillNew = questionData["answer"]["ans"];
											}
											else{
												//MCQ
												ansNewIndex = questionData["answer"]["ans"].indexOf(true);	
											}
										}
										if(currentState == testState.Started && startedFromApp == 1 && oldMeta != undefined){
											oldTestMeta = oldMeta;
										}
										if(oldTestMeta != undefined && oldTestMeta["questions"] != undefined && oldTestMeta["questions"][qNo] != undefined && oldTestMeta["questions"][qNo]["answer"] != undefined && oldTestMeta["questions"][qNo]["answer"]["ans"] != undefined){
											if(oldTestMeta["questions"][qNo]["answer"]["ans"].length == 1){
												//NIQ
												ansOldIndex = oldTestMeta["questions"][qNo]["answer"]["ans"][0];
											}
											else if(oldTestMeta["questions"][qNo]["answer"]["ans"].indexOf(false) == -1){
												//Fill In the Blank
												ansFillOld = oldTestMeta["questions"][qNo]["answer"]["ans"];
											}
											else{
												//MCQ
												ansOldIndex = oldTestMeta["questions"][qNo]["answer"]["ans"].indexOf(true);
											}
										}
										//flag true means get the old data
										if(ansOldIndex !== ansNewIndex){
											flag = true;
										}
										for (var i = 0; i < ansFillNew.length; i++) {
											if (ansFillNew[i] !== ansFillOld[i]){
												flag = true;
												break;
											}
										}
								
										if(flag){
											//Get the old index
											if((ansOldIndex !== -1 || ansFillOld.length !== 0) && oldTestMeta != undefined && oldTestMeta["questions"] != undefined && oldTestMeta["questions"][qNo] != undefined && oldTestMeta["questions"][qNo]["answer"] != undefined){
												testAnswers[qNo-1]["ans"] = oldTestMeta["questions"][qNo]["answer"]["ans"];
												testAnswers[qNo-1]["state"] = oldTestMeta["questions"][qNo]["answer"]["state"];
											}
											else if(questionData["answer"] != undefined){
												testAnswers[qNo-1]["ans"] = questionData["answer"]["ans"];
												testAnswers[qNo-1]["state"] = questionData["answer"]["state"];	
											}
										}
										else if(questionData["answer"] != undefined){
											testAnswers[qNo-1]["ans"] = questionData["answer"]["ans"];
											testAnswers[qNo-1]["state"] = questionData["answer"]["state"];	
										}
										if(questionData["questionId"] != undefined){
											testAnswers[qNo-1]["questionNo"] = questionData["questionId"];
										}
										if(questionData["subQuestionId"] != undefined){
											testAnswers[qNo-1]["sQId"] = questionData["subQuestionId"];
										}
										if(questionData["flag"] != undefined){
											testAnswers[qNo-1]["flaged"] = questionData["flag"];
										}
										testAnswers[qNo-1]["answeredDate"] = new Date();
									}
									writeData("testanswers_"+reply.data.meta["sessionId"]+".json", 'testanswers', reply.data.meta["sessionId"], testAnswers, function(){
										if(this.obj.tests[this.testId]["theme"] == Theme.SSCTHEME || this.obj.tests[this.testId]["theme"] == Theme.IBPSTHEME)
										{
											writeData("testpauseque_"+reply.data.meta["sessionId"]+".json", 'testpauseque', reply.data.meta["sessionId"], 1, function(){
												callback();
											}.bind(this));
										}	
										else{
											callback();
										}	
									}.bind(this));
								}.bind(this), function(response){
									//Error callback, old test meta doesn't exist, so get the testAnswers from new meta
									for(var qNo in reply.data.meta.questions){
										var questionData = reply.data.meta.questions[qNo];
										testAnswers[qNo-1] = {};
										testAnswers[qNo-1]["ans"] = [];
										
										if(questionData["answer"] != undefined){
											testAnswers[qNo-1]["ans"] = questionData["answer"]["ans"];
											testAnswers[qNo-1]["state"] = questionData["answer"]["state"];	
										}
										if(questionData["questionId"] != undefined){
											testAnswers[qNo-1]["questionNo"] = questionData["questionId"];
										}
										if(questionData["subQuestionId"] != undefined){
											testAnswers[qNo-1]["sQId"] = questionData["subQuestionId"];
										}
										if(questionData["flag"] != undefined){
											testAnswers[qNo-1]["flaged"] = questionData["flag"];
										}
										testAnswers[qNo-1]["answeredDate"] = new Date();
									}
									writeData("testanswers_"+reply.data.meta["sessionId"]+".json", 'testanswers', reply.data.meta["sessionId"], testAnswers, function(){
										if(this.obj.tests[this.testId]["theme"] == Theme.SSCTHEME || this.obj.tests[this.testId]["theme"] == Theme.IBPSTHEME)
										{
											writeData("testpauseque_"+reply.data.meta["sessionId"]+".json", 'testpauseque', reply.data.meta["sessionId"], 1, function(){
												callback();
											}.bind(this));
										}	
										else{
											callback();
										}	
									}.bind(this));
								}.bind(this));
							}.bind(this));		
						}.bind(this));
					}.bind(this));
				}
			}
			else
			{
				alert(reply.result.meta);
			}
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status       = "success";
				endtime      = Date.now();
				var duration = endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod:mod,
					ack:ack,
					url:url,
					status:status,
					starttime:starttime,
					endtime:endtime,
					duration:duration
				});
			}			
		}.bind({testId:testId, obj:this, currentState:currentState}),
		error: function(jqXHR, exception) {
		    if (jqXHR.status === 0) {
		    	if(offline){
		    		callback();	
		    	}
		    	else{
		        	alert('Not connected to Network.');
		        }
		        UrlMgmt.getObj().removeLoader();
		    } else if (jqXHR.status == 404) {
		        alert('Requested page not found. [404]');
		    } else if (jqXHR.status == 500) {
		        alert('Internal Server Error [500].');
		    } else if (exception === 'parsererror') {
		        alert('Requested JSON parse failed.');
		    } else if (exception === 'timeout') {
		        alert('Time out error.');
		    } else if (exception === 'abort') {
		        alert('Ajax request aborted.');
		    } else {
		        alert('Uncaught Error.\n' + jqXHR.responseText);
		    }
		    UrlMgmt.getObj().removeLoader();
		    $('.TStest[testId="'+this.testId+'"] .TSButtons').attr('inProgress', '0');
		}.bind({testId:testId,currentState:currentState}),
	});
};

commontestlistingController.prototype.StartTest = function(testId, tr2TestId, state, lang, languageOptions)
{
	//refreshUserActivity();
	if(!UrlMgmt.getObj().App.isOnline){
			var oldTestMeta = {};
			loadExistingData({entity: "testmeta", recordId: testId}, function(oldMeta){
				if(state == testState.Started && oldMeta != undefined){
					oldTestMeta = oldMeta;
				}
			
				var testAnswers = [];
				
				for(var qNo in oldTestMeta.questions){
					var flag = false;
					var ansIndex = -1;
					var ansFill = [];
					var questionData = oldTestMeta.questions[qNo];
					testAnswers[qNo-1] = {};
					testAnswers[qNo-1]["ans"] = [];
					if(oldTestMeta != undefined && oldTestMeta["questions"] != undefined && oldTestMeta["questions"][qNo] != undefined && oldTestMeta["questions"][qNo]["answer"] != undefined && oldTestMeta["questions"][qNo]["answer"]["ans"] != undefined){
						if(oldTestMeta["questions"][qNo]["answer"]["ans"].length == 1){
							//NIQ
							ansIndex = oldTestMeta["questions"][qNo]["answer"]["ans"][0];
						}
						else if(oldTestMeta["questions"][qNo]["answer"]["ans"].indexOf(false) == -1){
							//Fill In the Blank
							ansFill = oldTestMeta["questions"][qNo]["answer"]["ans"];
						}
						else{
							//MCQ
							ansIndex = oldTestMeta["questions"][qNo]["answer"]["ans"].indexOf(true);
						}
						testAnswers[qNo-1]["ans"] = oldTestMeta["questions"][qNo]["answer"]["ans"];
					testAnswers[qNo-1]["state"] = oldTestMeta["questions"][qNo]["answer"]["state"];
					testAnswers[qNo-1]["questionNo"] = questionData["questionId"];
					testAnswers[qNo-1]["sQId"] = questionData["subQuestionId"];
					testAnswers[qNo-1]["flaged"] = questionData["flag"];
					testAnswers[qNo-1]["answeredDate"] = new Date();
					}
					
				}
					
				writeData("testanswers_"+oldMeta["sessionId"]+".json", 'testanswers', oldMeta["sessionId"], testAnswers, function(){
					if(this.obj.tests[this.testId]["theme"] == Theme.SSCTHEME || this.obj.tests[this.testId]["theme"] == Theme.IBPSTHEME)
					{
						writeData("testpauseque_"+oldMeta["sessionId"]+".json", 'testpauseque', oldMeta["sessionId"], 1, function(){
							callback();
						}.bind(this));
					}	
					else{
						callback();
					}	
				}.bind(this));
			}.bind(this));		
	}
	UrlMgmt.getObj().Route({route: 'app/ibpstest', needData: false}, function(action){
				action.controler.testId = testId;
				action.controler.tr2TestId = tr2TestId;
				action.controler.testState = state;
				action.controler.parent = this;
				if(typeof languageOptions != "undefined")
				{
					action.controler.languageOptions = languageOptions;
				}
				action.controler.language = lang;
				action.controler.testTheme = Number(this.tests[testId]["theme"]);
				action.controler.testAttributes = this.testAttributes;
				action.controler.LoadTest();
	}.bind(this));	
	
};
commontestlistingController.prototype.SetState = function(testId, state)
{
	if(this.tests[testId]["state"] !=  state)
	{
		this.tests[testId]["state"] =  state;
		writeData(this.type+'_testdata_'+this.id+'.json', this.type+'_testdata', this.id, this.tests, function(){
			writeData('teststate.json', 'teststate', 1, this.tests, function(){
			}.bind(this));
		}.bind(this));
	}
};
commontestlistingController.prototype.UpdateTestPause = function(data,sessionId,testId, tr2TestId, currentState)
{
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer+"/ajax"+"/testId="+testId+"&sessionId="+sessionId+"";
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "insertPauseHist";
	}	
	$.ajax({
		type:"POST",
		url: remoteServer+"/ajax",
		data:{ 
				mod:"testapi",
				ack:"insertPauseHist",
				testId:testId,
				session:sessionId,
				data:JSON.stringify(data)
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	    success: function(reply){
			if(reply.result.state == "ok")
			{
				this.SubmitTest(testId, tr2TestId, currentState);		
			}	   
			else
			{
				console.log(reply.result.meta);
			}
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status       = "success";
				endtime      = Date.now();
				var duration = endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod:mod,
					ack:ack,
					url:url,
					status:status,
					starttime:starttime,
					endtime:endtime,
					duration:duration
				});
			}			
		}.bind(this),
		error: function(jqXHR, exception) {
			},
	});
};
commontestlistingController.prototype.UploadTest = function(testId, tr2TestId, currentState)
{
	//refreshUserActivity();
	loadExistingData({entity: "testmeta", recordId: testId}, function(data){
		if(data["pausehistorystored"] != undefined && Object.keys(data["pausehistorystored"]).length > 0)
		{
			if(this.tests[testId]["theme"] == Theme.IBPSTHEME || this.tests[testId]["theme"] == Theme.SSCTHEME)
			{
			    this.UpdateTestPause(data["pausehistorystored"],data["sessionId"],testId, tr2TestId, currentState);
			}	
		}
		else
		{
			this.SubmitTest(testId, tr2TestId, currentState);
		}
	}.bind(this));
};
commontestlistingController.prototype.SubmitTest = function(testId, tr2TestId, currentState)
{
	UrlMgmt.getObj().showLoader(false);
	loadExistingData({entity: "testmeta", recordId: testId}, function(data){
		var sessionId = data.sessionId;
		var app = 0;
		var meta = this.tests[testId]["meta"];
		if(meta.hasOwnProperty("SaveForLater") && meta["SaveForLater"]!="")
		{
			app = 1;
		}
		if(data.hasOwnProperty("theme") && data["theme"] == Theme.TBSENTRANCE)
		{	
			if(data["endAt"] == null && data.hasOwnProperty("date"))
			{
				data["endAt"] = data["date"];
				console.log(data,"mt");
			}
			
		}		
		if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
		{
			var starttime = Date.now();
			var endtime   = null;
			var url 	  = remoteServer+"/ajax"+"/testId="+testId+"";
			var status    = "";
			var mod		  = "testapi";	
			var ack		  = "submit";
		}		
		$.ajax({
			url: remoteServer+"/ajax",
			type: 'POST',
		 	data:{
		 		mod: "testapi",
				ack: "submit",
				testData:JSON.stringify(data),
				testId:testId,
				app:app,
				submitOnly: true,
				getNewmodalview: 1
			},
		 	xhrFields: {
		       withCredentials: true
		    },
		    crossDomain: true,
		    context:this, 
		 	success: function(reply){
		 		if(reply.result.state == "ok")
				{
					var reportExist = false;
					if(reply.data.hasOwnProperty("msg") && reply.data["msg"] == "error")
					{
						alert("Test is expired");
					}
					else
					{
						this.SetState(testId,testState.Submitted);
						// update report only if allow
						meta = JSON.parse(this.tests[testId]["meta"]);
						if(meta.hasOwnProperty("canSeeReport") && meta["canSeeReport"] == TestAtributeOptions.YES)
						{
							this.bucketId = $(this.view).find('div[data-item='+testId+']').attr("bucket");
							tr$.testListingObj = this;
							$(".TStest[testId='"+testId+"'] .TSreport").attr("disable","false");
							UrlMgmt.getObj().PopView(function(){
								$('#test-submitted-model').find('.btn-close').unbind().bind('click',function(){
									$('#test-submitted-model').modal("hide");
								});
								$('#test-submitted-model').find('.btn-report').unbind().bind('click',function(){
									$('#test-submitted-model').modal("hide");
									UrlMgmt.getObj().Route({route: 'item/test&id='+tr2TestId+'&session='+sessionId+'&report=1&refresh=1', needData: true, offlineAllowed: true});
								});
								var shortreportdiv = 	'<div class="shortreportdiv">'+
															'<div class="table-header">'+
																'<div class="section-name">Section Name</div>'+
																'<div class="attr-name">Total</div>'+
																'<div class="attr-name">Score</div>'+
																'<div class="attr-name">Correct</div>'+
																'<div class="attr-name">Incorrect</div>'+
															'</div>';
								for(section in reply.data)
								{
									reportExist = true;
									if(section == -1)
								    {
										shortreportdiv+=		'<div class="table-body overall">';
									}	
									else 
									{
										shortreportdiv+=		'<div class="table-body">';
									}
								
										shortreportdiv+=		'<div class="section-name">'+reply.data[section].sectionName+'</div>'+
																'<div class="attr-name">'+reply.data[section].totalScore+'</div>'+
																'<div class="attr-name">'+reply.data[section].score+'</div>'+
																'<div class="attr-name">'+reply.data[section].correctCount+'</div>'+
																'<div class="attr-name">'+reply.data[section].incorrectCount+'</div>'+
															'</div>';	
																		
								}
								shortreportdiv+=		'</div>';
								if(typeof reply.data && reportExist)
								{
									$('#test-submitted-model').find('.ReportDiv').html(shortreportdiv);
								}
								
								$('#test-submitted-model').modal("show");
							});
						}
						else
						{
							if(typeof meta["afterSubmissionMesage"] != "undefined" && meta["afterSubmissionMesage"] != "" )
							{
								alert(meta["afterSubmissionMesage"]);
							}
							else
							{
								alert("Test Report/Solutions will be Available Soon. Please be with us.");	
							}
							UrlMgmt.getObj().PopView(function(){
								this.parent.RefreshView();
							}.bind(this));
						}
						// var instance;
						// var attemptLeft;
						// switch(Number(this.tests[i]["theme"])){
							// case Theme.IBPSTHEME:
								// var IBPStestInstance = meta.hasOwnProperty("testInstance")?meta["testInstance"]:-1;
								// instance = IBPStestInstance;
							// break;
							// default:
								// var testInstance = meta.hasOwnProperty("testInstance")?meta["testInstance"]:-1;
								// instance = testInstance;
						// }
						// //var testInstance = meta.hasOwnProperty("testInstance")?meta["testInstance"]:-1;
						// var attemptLeft = "unlimited";
						// if(instance != -1)
						// {
							// attemptLeft = instance - this.testReport[i]["testAttempted"];
							// if(attemptLeft <= 0)
							// {
								// $('.TStest[testId="'+testId+'"] .attemptLeft').hide();
								// $('.TStest[testId="'+testId+'"] .TSButtons').attr('disable', 'true');
							// }
							// else
							// {
								// $('.TStest[testId="'+testId+'"] .attemptLeft span').html(attemptLeft);
							// }	
						// }
						// $('.TStest[testId="'+i+'"] .TSButtons').attr('inProgress', '0');
					}
				}
				else if(reply.result.state == "time_over"){
					console.log("Inside time_over");
					UrlMgmt.getObj().PopView(function(){
						this.parent.RefreshView();
					}.bind(this));
				}
				UrlMgmt.getObj().removeLoader();
				if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
				{
					status       = "success";
					endtime      = Date.now();
					var duration = endtime - starttime;
					PerformanceAuditHandler.addPerformanceAuditAjax({
						mod:mod,
						ack:ack,
						url:url,
						status:status,
						starttime:starttime,
						endtime:endtime,
						duration:duration
					});
				}				
		 	}.bind(this),
		 	error: function(jqXHR, exception) {
			    if (jqXHR.status === 0) {
			        alert('Not connected to Network.');
			    } else if (jqXHR.status == 404) {
			        alert('Requested page not found. [404]');
			    } else if (jqXHR.status == 500) {
			        alert('Internal Server Error [500].');
			    } else if (exception === 'parsererror') {
			        alert('Requested JSON parse failed.');
			    } else if (exception === 'timeout') {
			        alert('Time out error.');
			    } else if (exception === 'abort') {
			        alert('Ajax request aborted.');
			    } else {
			        alert('Uncaught Error.\n' + jqXHR.responseText);
			    }
			    $('.TStest[testId="'+this.testId+'"] .TSButtons').attr('inProgress', '0');
			    $('.TStest[testId="'+this.testId+'"] .TSButtons').text("Upload");
			   UrlMgmt.getObj().removeLoader();
		 	}.bind({testId:testId}),
		 });
	 }.bind(this));
};
commontestlistingController.prototype.LoadAvailableTests = function()
{
	var metadata = {};
	var testIds = [];
    var data = this.testResponse;
    if(data == undefined){
    	this.LoadTestSeries();
    }
   	var testIds = Object.keys(this.tests);
    if(testIds.length > 0){	
		this.GetTestMetadata(testIds, function(meta){
			try{
	    	metadata = meta;
	    	for(var test in this.tests){
				var testData = this.tests[test];
				var id = test;
				if(this.testShortReport[id] && this.testShortReport[id]["1"]){
					this.tests[id]["state"] = testState.Started;
				}
				else{
					this.tests[id]["state"] = testState.NotLoaded;
				}
				if(typeof metadata[id] != 'undefined'){
					if(typeof metadata[id]["access"] != 'undefined')
						this.tests[id]["access"] = metadata[id]["access"];
					if(typeof metadata[id]["canAttempt"] != 'undefined')
						this.tests[id]["canAttempt"] = metadata[id]["canAttempt"];
					if(typeof metadata[id]["metadata"] != 'undefined')
						this.tests[id]["meta"] = metadata[id]["metadata"];
					if(typeof metadata[id]["themeId"] != 'undefined')
						this.tests[id]["theme"] = metadata[id]["themeId"];
					if(typeof metadata[id]["orderIndex"] != 'undefined')
						this.tests[id]["orderIndex"] = metadata[id]["orderIndex"];
				}
			};	
			
			writeData(this.type+"_testdata_"+this.id+".json", this.type+'_testdata', this.id, this.tests, function(){
				
			}.bind(this));
		}
		catch(e){
			console.error(e);
		}
		finally{
			this.LoadTestSeries();
		}
		}.bind(this));
		
	}
	else{
	}
};
commontestlistingController.prototype.GetTestMetadata = function(testIds, callback)
{
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer+"/ajax"+"/testIds="+"";
		var status    = "";
		var mod		  = "tr2app";	
		var ack		  = "getTestsMeta";
	}	
	$.ajax({
		url: remoteServer+"/ajax",
		type: 'POST',
	 	data:{
	 		mod: "tr2app",
			ack: "getTestsMeta",
			testIds: testIds
		},
	 	xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this,
	    timeout: 30000,
	 	success: function(reply){
	 		if(reply.result.state == "ok")
			{
				writeData(this.type+"_testsmetadata_"+this.id+".json", this.type+'_testsmetadata', this.id, reply.data, function(){
					callback(reply.data);
				}.bind(this));
			}
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status       = "success";
				endtime      = Date.now();
				var duration = endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod:mod,
					ack:ack,
					url:url,
					status:status,
					starttime:starttime,
					endtime:endtime,
					duration:duration
				});
			}			
		}.bind(this),
		error: function(jqXHR, exception) {
			if (jqXHR.status === 0) {
				loadExistingData({entity: this.type+"_testsmetadata", recordId: this.id}, function(data){
					callback(data);
				}.bind(this), function(){
					callback();
				}.bind(this));
			} else if (jqXHR.status == 404) {
			    alert('Requested page not found. [404]');
			} else if (jqXHR.status == 500) {
			    alert('Internal Server Error [500].');
			} else if (exception === 'parsererror') {
			    alert('Requested JSON parse failed.');
			} else if (exception === 'timeout') {
			    alert('Time out error.');
			} else if (exception === 'abort') {
			    alert('Ajax request aborted.');
			} else {
			    alert('Uncaught Error.\n' + jqXHR.responseText);
			}
		},
	});
};

/*Auto submit the test data when user comes online if user attempted in offline mode*/
function submitOfflineTestData(){
	new SQLiteOps().GetAllRecords('testmeta', function(count, response){
		console.log(count);
		if(count > 0){
			for(var i=0; i<count; i++){
				var testData = JSON.parse(response.item(i).data);
				if(testData.submitted != undefined && testData.submitted == false){
					//user tried to submit the test in offline mode, so now submit the test
					submitOfflineTest(testData.testId, testState.Submitted, testData, false);
				}
				else{
					//user didn't submit the test in offline mode
					if(testData.questionsSubmit != undefined && testData.questionsSubmit == false){
						//user attempted atleast one question in offline mode
						//submit the test, but with a flag such that only questions should be submitted
						submitOfflineTest(testData.testId, testState.Submitted, testData, true);
					}
					else{
						//User didn't attempt anything in offline mode
					}
				}
			}
		}
	});
};
function submitOfflineTest(testId, state, data, onlyQuestions)
{
	var app = 0;
	/*var meta = this.tests[testId]["meta"];
	if(meta.hasOwnProperty("SaveForLater") && meta["SaveForLater"]!="")
	{
		app = 1;
	}*/
	data["endAt"] = new Date();
	if(data.hasOwnProperty("theme") && data["theme"] == Theme.TBSENTRANCE)
	{	
		if(data["endAt"] == null && data.hasOwnProperty("date"))
		{
			data["endAt"] = data["date"];
			console.log(data,"mt");
		}
	}
	var saveOnlyQuestions = false;
	if(onlyQuestions != undefined && onlyQuestions == true){
		saveOnlyQuestions = true;
	}
	var ajaxData = {
	 		mod: "testapi",
			ack: "submit",
			testData:JSON.stringify(data),
			testId:testId,
			//tempUserId:data.tempUserId,
			app:app
	};
	if(saveOnlyQuestions == true){
		ajaxData.saveOnlyQuestions = saveOnlyQuestions;
	}
	if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
	{
		var starttime = Date.now();
		var endtime   = null;
		var url 	  = remoteServer+"/ajax"+"/testid="+testId+"";
		var status    = "";
		var mod		  = "testapi";	
		var ack		  = "submit";
	}	
	$.ajax({
		url: remoteServer+"/ajax",
		type: 'POST',
	 	data: ajaxData,
	 	xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
	 	success: function(reply){
	 		if(reply.result.state == "ok")
			{
				console.log("Test submission successful in offline mode");
				if(data.hasOwnProperty("submitted"))
					delete data["submitted"];
				if(data.hasOwnProperty("questionsSubmit"))
					delete data["questionsSubmit"];
				writeData('testmeta_'+testId+'.json', 'testmeta', testId, data);
			}
			if(typeof performanceAuditEnabled != "undefined" && performanceAuditEnabled)
			{
				status       = "success";
				endtime      = Date.now();
				var duration = endtime - starttime;
				PerformanceAuditHandler.addPerformanceAuditAjax({
					mod:mod,
					ack:ack,
					url:url,
					status:status,
					starttime:starttime,
					endtime:endtime,
					duration:duration
				});
			}			
	 	}.bind(this),
	 	error: function(jqXHR, exception) {
		    if (jqXHR.status === 0) {
		        alert('Not connected to Network.');
		    } else if (jqXHR.status == 404) {
		        alert('Requested page not found. [404]');
		    } else if (jqXHR.status == 500) {
		        alert('Internal Server Error [500].');
		    } else if (exception === 'parsererror') {
		        alert('Requested JSON parse failed.');
		    } else if (exception === 'timeout') {
		        alert('Time out error.');
		    } else if (exception === 'abort') {
		        alert('Ajax request aborted.');
		    } else {
		        alert('Uncaught Error.\n' + jqXHR.responseText);
		    }
		   UrlMgmt.getObj().removeLoader();
	 	}.bind({testId:testId}),
	 });
}
/*Auto submit the test data when user comes online if user attempted in offline mode ends*/