var commontr2headerController = function(data)
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
};
commontr2headerController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
};
commontr2headerController.prototype.DisplayHeader = function(pageView, title, sideMenu, backBtn, brandLogo)
{
	this.dom.show();
	this.dom.removeClass('slide-view');
	//$(this.dom).css('margin-left', '1px');
	//$(this.dom).css('margin-left', '0px');
	this.dom.find('.page-head').find('.pageHeading').find('.pageHead-option').html('');
	this.dom.find('.page-head').find('.pageHeading').find('.pageHead-option').hide();
	var urlMgmt = UrlMgmt.getObj();
	this.dom.show();
	this.dom.find('.page-head').find('.pageHeading').find('h4').html(title);
	$('#app').find('#touchablehighlight').remove();
	if(sideMenu){
		pageView.append('<div id="touchablehighlight"></div>');
		urlMgmt.sideMenuAction.controler.forView = pageView;
		this.dom.find('.page-head').find('.header-menu-btn').unbind().bind('click', function(){
			console.log('Open side menu');
			urlMgmt.sideMenuAction.controler.OpenView();
		}.bind(this));
		this.dom.find('.page-head').find('.header-back-btn').hide();
		this.dom.find('.page-head').find('.header-menu-btn').show();
		this.TouchableHighlight();
	}
	if(backBtn){
		this.dom.find('.page-head').find('.header-back-btn').unbind().bind('click', function(){
			console.log('Clicked Back btn');
			UrlMgmt.getObj().PopView();
		}.bind(this));
		this.dom.find('.page-head').find('.header-menu-btn').hide();
		this.dom.find('.page-head').find('.header-back-btn').show();
	}
	if(!brandLogo){
		this.dom.find('.page-head').find('.pageHeading').find('.trbrand').hide();
	}
	else{
		this.dom.find('.page-head').find('.pageHeading').find('.trbrand').show();
	}
};
commontr2headerController.prototype.ChangeHeaderTitle = function(title)
{
	this.dom.find('.page-head').find('.pageHeading').find('h4').html(title);
};
commontr2headerController.prototype.AddHeaderOptions = function(options)
{
	this.dom.find('.page-head').find('.pageHeading').find('.pageHead-option').html(options);
	this.dom.find('.page-head').find('.pageHeading').find('.pageHead-option').show();
};
commontr2headerController.prototype.SideMenuOpen = function()
{
	this.dom.find('.header-menu-btn').addClass('blocked');
	this.dom.addClass('slide-view');
};
commontr2headerController.prototype.SideMenuClose = function()
{
	this.dom.find('.header-menu-btn').removeClass('blocked');
	this.dom.removeClass('slide-view');
};
commontr2headerController.prototype.TouchableHighlight = function()
{
	var headerHeight = this.dom.outerHeight(true);
		menuHeight = $('#menu-bar').outerHeight(true);
	$('#touchablehighlight').css('top',headerHeight);
	$('#touchablehighlight').width(screen.width/16).height((screen.height-headerHeight-menuHeight));
	
	$('#touchablehighlight').swipe({
   		swipeLeft: function(event, direction, distance, duration, fingerCount){
   			UrlMgmt.getObj().sideMenuAction.controler.CloseView();
   		}.bind(this),
   		swipeRight: function(event, direction, distance, duration, fingerCount){
   			UrlMgmt.getObj().sideMenuAction.controler.OpenView();
   		}.bind(this)
   	});
};
