/**** Intro ****/
var commontr2introController = function(data)
{
	UrlMgmt.getObj().removeLoader();
    this.view = "default";
	this.style = "default";
	this.dom = null;
	
	this.introCount = 3;
};
commontr2introController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	UrlMgmt.getObj().lockRotation();

	this.ConfigureApp();
    var introCount = 3;//No. of intro views
    $('[data-trigger="skipIntro"]').unbind().bind("click", this, function(e){
    	e.data.Completed();
    });
    $('[data-trigger="nextIntro"]').unbind().bind("click",this,function(e){
        $('#introCarousel').carousel('next');
        --introCount;
        if(introCount == 1){
            var html ='<a class="btn btn-primary btn-block btn-large js-start">LET\'S START</a>';
            e.data.dom.find(".btns").html(html);
            e.data.dom.find(".js-start").unbind().bind("click", this, function(){
            	e.data.Completed();
            });
        }
    });

	var swipeIntro = $(this.dom).find("#introCarousel");
	var swipestart = null;
	var introswipeflag = true;

	swipeIntro[0].addEventListener("touchstart", function(e) {
		swipestart = e.changedTouches[0].pageX;
	}, false);

	swipeIntro[0].addEventListener("touchmove", function(e) {
		var swipestop = e.changedTouches[0].pageX;
		if (swipestop < swipestart + 5) {
			if (introswipeflag == true) {
				introswipeflag = false;
				$('#introCarousel').carousel('next'); 
				--introCount;
				if (introCount == 1) {
					var html = '<a class="btn btn-primary btn-block btn-large js-start">LET\'S START</a>';
					$(this.dom).find(".btns").html(html);
					$(this.dom).find(".js-start").unbind().bind("click", function(){
						this.Completed();
					}.bind(this));
				}
			}
		}
		if(swipestop > swipestart - 5 && introCount <= 1)
		{
			if (introswipeflag == true) {
				introswipeflag = false;
				$('#introCarousel').carousel('prev');
			}
		}
	}.bind(this), false);

	swipeIntro[0].addEventListener("touchend", function(e) {
		introswipeflag = true;
	}, false);
};
commontr2introController.prototype.Completed = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.PopView();
	urlMgmt.Route({route:"common/tr2login", needData:false}, function(action){
		action.controler.canskip = 1;
		action.controler.SkipDecision();
	});
};
commontr2introController.prototype.ConfigureApp = function()
{
	var data = {'appConfigured': true};
	DataMgmt.SaveData('config/userinfo', 1, data);
};
