/************ LOGIN ***************/
var commontr2loginController = function(data)
{
	UrlMgmt.getObj().removeLoader();
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.canskip = 0;
	this.sessionauthkey = null;
	this.data = null;
};
commontr2loginController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	if(typeof hideRegistration != 'undefined' && hideRegistration == true){
		$('#login-form-tab').find('#regtab').hide();
		$('#login-form-tab').find('#logintab').css('width', '100%');
	}
	var urlMgmt = UrlMgmt.getObj();
	this.SetLayout();
	urlMgmt.menuAction.controler.RefreshMenuData();
	urlMgmt.tempUserId = localStorage.getItem('tempUserId');
  	if(urlMgmt.tempUserId == null){
  		urlMgmt.tempUserId = guid();
  		localStorage.setItem('tempUserId', urlMgmt.tempUserId);
  	}
  		
	if(fromNotification){
		fromNotification = false;
		LoggedInUser.onLoginSuccess = null;
		if(urlMgmt.userData != null && urlMgmt.userData.hasOwnProperty('id')){
			HOME_silentLogin();
		}
		urlMgmt.PopView();
	}
	else if(urlMgmt.userData != null && urlMgmt.userData.hasOwnProperty('id')){
		HOME_silentLogin();
		urlMgmt.PopView();
		urlMgmt.ClearActionStack();
		urlMgmt.Route({route: 'common/home', needData: true, offlineAllowed: true});
		return;
	}
	if(typeof loginSkipRequired != 'undefined' && loginSkipRequired == true){
		if(this.canskip == 1){
			this.dom.find('.login-skip').show();	
		}
		else{
			this.dom.find('.imgclose').show();
		}
	}
	
	this.dom.find('.call-number').attr('href', 'tel:'+contactNumber);
	this.dom.find('.helplinecontactnumber').html(contactNumber);
	if(contactNumber.length == 0)
		this.dom.find('.login_help').hide();
	analytics_trackView('Login');
	analytics_trackEvent('Login','/login');
	this.BindEvents();
};
commontr2loginController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.view.hide();
};
commontr2loginController.prototype.SkipDecision = function()
{
	if(typeof loginSkipRequired != 'undefined' && loginSkipRequired == true){
		if(this.canskip == 1){
			this.dom.find('.login-skip').show();
			this.dom.find('.imgclose').hide();	
		}
		else{
			this.dom.find('.login-skip').hide();
			this.dom.find('.imgclose').show();
		}
	}
};
commontr2loginController.prototype.BindEvents = function(){
	if(googleLoginRequired == false){
		$(".GoogleLoginBtn").hide();
	}
	if(facebookLoginRequired == false){
		$(".FBLoginBtn").hide();
	}
	if(googleLoginRequired == false && facebookLoginRequired == false){
		$('.login2').hide();
	}
	//temp hack
	if(window.cordova.platformId == 'ios')
	{
		$(".FBLoginBtn,.GoogleLoginBtn,.signOR").hide();
	}
    
	$('.alert').html('').attr('class','alert');
	
	if(typeof(preRegisteredRequired) == "undefined")
	{
		preRegisteredRequired = 0;
	}	
	
	if(preRegisteredRequired == 1)
	{
		$('.row:has(input[preRegisteredRequired="false"])').hide();
		$('div[preRegisteredRequired="false"]').hide();
		$('#sign-in-email').attr("placeholder", "Email/Registration Code");
	}
	else
	{
		$('.row:has(input[preRegisteredRequired="true"])').hide();
	}
	$('#btn_login').unbind().click(function(){
		if(!UrlMgmt.getObj().App.isOnline){
			alert('Connect to internet');
			return;
		}
		var loginId = $("#sign-in-email").val().trim();
		var passwd = $("#sign-in-pwd").val();
		if(loginId.length == 0)
		{
			$('#sign-in .alert').html('Email ID cannot be empty!').attr('class','alert alert-danger');
		}
		var validate = validEmail(loginId);
		if(!validate)
		{
			$('#sign-in .alert').html("Please enter valid email!").attr('class','alert alert-danger');
			return;
		}
		else if(passwd.length == 0)
		{
			$('#sign-in .alert').html('Password cannot be empty!').attr('class','alert alert-danger');
		}
		else
		{
			
			if(typeof UrlMgmt.getObj().menuData.domainmeta     				   != "undefined" && 
			   typeof UrlMgmt.getObj().menuData.domainmeta.sso 				   != "undefined" &&
			   typeof UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl != "undefined")
			   {
			   		// URLRedirection(UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl);
			   		LoggedInUser.ssologin(loginId, passwd);
			   		return;
			   }
			LoggedInUser.login(loginId, passwd);   	
		}
	});
	$('.imgclose').unbind().bind('click',function(){
		LoggedInUser.onLoginSuccess = null;
		UrlMgmt.getObj().PopView();
	});
	
	$(".login-skip").unbind().bind("click",function(){
		LoggedInUser.onLoginSuccess = null;
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.PopView();
		urlMgmt.ClearActionStack();
		urlMgmt.Route({route:"common/home", needData:true, offlineAllowed: true});
	});
	$(".FBLoginBtn").unbind().click(LoggedInUser.FBLogin);
	$(".GoogleLoginBtn").unbind().click(LoggedInUser.GoogleLogin);
	$("#btn_signup").unbind().click(function(){	
		if(typeof UrlMgmt.getObj().menuData.domainmeta     				   != "undefined" && 
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso 				   != "undefined" &&
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl != "undefined")
		   {
		   		URLRedirection(UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl);
		   		return;
		   }
			LoggedInUser.onCreateAccountButtonClick();
	});
	$("#btn_forgotpswd").unbind().click(function(){
		if(typeof UrlMgmt.getObj().menuData.domainmeta     				   != "undefined" && 
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso 				   != "undefined" &&
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl != "undefined")
		   {
		   		URLRedirection(UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl);
		   		return;
		   }		
		LoggedInUser.onForgotPasswdClick();	
	});   
	$("#btn_poplogin").unbind().click(LoggedInUser.onSwitchToLoginButtonClick);
	$(".afterregister .dailgclose").click(function(){
		$(".container.dailogreg").hide();
	});
	$("#regtab").unbind().bind('click',function(e){
		if(typeof UrlMgmt.getObj().menuData.domainmeta     				   != "undefined" && 
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso 				   != "undefined" &&
		   typeof UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl != "undefined")
	    {	
	    	    $("#sign-up").find("form .form-inputs").hide();
	    		e.preventDefault();
	    		URLRedirection(UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl);
	    }
 	});
	
};