var commontr2myassignmentsController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.refresh = true;
	
	this.exams = {};
	this.categories = {};
	this.myExams = {};
	this.testLists = {};
	this.assignmentList = {};
	this.categoryObj = new Object();
};
commontr2myassignmentsController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.categories = this.data.categories;
	this.exams = this.data.exams;
	this.myExams = this.data.myExams;
	this.testLists = this.data.testLists;
	this.assignmentLists = this.data.assignmentList;
	this.SetLayout();
	this.LoadData();
	// analytics_trackView("my_exams");
	// analytics_trackEvent("my_exams" , '/my-exams');
	
	urlMgmt.removeLoader();	
};
commontr2myassignmentsController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Assignments', false, true, false);
};
commontr2myassignmentsController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.Init();
	urlMgmt.removeLoader();
};
commontr2myassignmentsController.prototype.LoadData = function()
{
	this.LoadMyObject();
	this.LoadMyCategories();
	this.BindEvents();
};
commontr2myassignmentsController.prototype.BindEvents = function()
{
	$(this.dom).find('.myexam-subscribe-btn').unbind().bind('click', this, function() {
		UrlMgmt.getObj().Route({route: 'common/tr2subscription', needData: false});
	});
};
commontr2myassignmentsController.prototype.LoadMyObject = function()
{
	
	for (var i in this.exams) {
		
		var examTemp = getMatchingValue(this.exams, "id", this.myExams[i]);
		var tempid = this.exams[i].categoryId;
		
		if (!this.categoryObj.hasOwnProperty(tempid)) {
			this.categoryObj[tempid] = new Object();
			this.categoryObj[tempid].title = getMatchingValue(this.categories, "id", tempid).title;
		}
		if (!this.categoryObj[tempid].hasOwnProperty('assignmentList')) {
			this.categoryObj[tempid].assignmentList = [];
		}
		for (var assignmentList in this.exams[i].assignmentListId) {
			this.categoryObj[tempid]["assignmentList"].push(new Object());
			var len = this.categoryObj[tempid]["assignmentList"].length;
			var assignmentlistdata = this.exams[i].assignmentListId[assignmentList];
			this.categoryObj[tempid]["assignmentList"][len - 1].id = assignmentlistdata;
			for(x in this.assignmentLists)
			{
				if(x == assignmentlistdata)
				{
					var assignmentListObj = this.assignmentLists[x];
					console.log("assignmentListObj",assignmentListObj);
				}
			}

			//var assignmentListObj = getMatchingValue(this.assignmentLists, "testListId", assignmentlistdata);
			
			this.categoryObj[tempid]["assignmentList"][len - 1].title = assignmentListObj.title;
		}
	}
	
	
	// for (var i in this.exams) {
// 		
		// //var examTemp = getMatchingValue(this.exams, "id", this.myExams[i]);
		// var tempid = this.exams[i].categoryId;
// 		
		// if (!this.categoryObj.hasOwnProperty(tempid)) {
			// this.categoryObj[tempid] = new Object();
			// this.categoryObj[tempid].title = getMatchingValue(this.categories, "id", tempid).title;
		// }
		// if (!this.categoryObj[tempid].hasOwnProperty('assignmentList')) {
			// this.categoryObj[tempid].assignmentList = [];
		// }
		// for (var assignmentList in this.assignmentLists) {
			// this.categoryObj[tempid]["assignmentList"].push(new Object());
			// var len = this.categoryObj[tempid]["assignmentList"].length;
			// var assignmentlistdata = this.assignmentLists[assignmentList].testListId;
			// this.categoryObj[tempid]["assignmentList"][len - 1].id = assignmentlistdata;
			// for(x in this.assignmentLists)
			// {
				// if(x == assignmentlistdata)
				// {
					// var assignmentListObj = this.assignmentLists[x];
					// console.log("assignmentListObj",assignmentListObj);
				// }
			// }
// 
			// //var assignmentListObj = getMatchingValue(this.assignmentLists, "testListId", assignmentlistdata);
// 			
			// this.categoryObj[tempid]["assignmentList"][len - 1].title = assignmentListObj.title;
		// }
	// }
	
	// for(var i in this.categories)
	// {
		// for(var examitem in this.categories.exams)
		// {
			// for(var assignmentList in this.assignmentLists)
			// {
				// if(this.assignmentLists[assignmentList].examId == this.categories.exams[examitem])
				// {
					// //this.categoryObj[this.categories[i].id] = new Object();
					// //this.categoryObj[this.categories[i].id].title =  this.categories[i].title;
					// this.categoryObj[this.categories[i].id]["assignmentList"].push(new Object());
					// var len = this.categoryObj[tempid]["assignmentList"].length;
					// this.categoryObj[this.categories[i].id]["assignmentList"][len - 1].id = this.assignmentLists[assignmentList].testListId;
					// var assignmentListObj = this.assignmentLists[assignmentList];
					// this.categoryObj[this.categories[i].id]["assignmentList"][len - 1].title = assignmentListObj.title;
				// }
			// }
		// }
	// }
	
	// for(var i in this.exams)
	// {
// 		
		// for(var assignmentList in this.assignmentLists)
		// {
			// if(this.assignmentLists[assignmentList].examId == this.exams[i].id )
			// {
				// this.categoryObj[this.exams[i].categoryId] = new Object();
				// for(var categoriesItem in this.categories)
				// {
					// if(this.categories[categoriesItem].id == this.exams[i].categoryId)
					// {
						// this.categoryObj[this.exams[i].categoryId].title = this.categories[categoriesItem].title;
					// }
				// }
				// this.categoryObj[this.exams[i].categoryId]["assignmentList"] = [];
				// this.categoryObj[this.exams[i].categoryId]["assignmentList"][assignmentList].title = this.assignmentLists[assignmentList].title;
			// }
		// }
// 		
	// }
};

commontr2myassignmentsController.prototype.LoadMyCategories = function()
{
	var container = $(this.dom).find('.nav-tabs');
	var tabcontainer = $(this.dom).find('.tab-content');
	if (Object.keys(this.categoryObj).length) {
		var catnamex = 'All exams';
		var catname = catnamex.replace(/ /g, '');
		var tab = '<li class="myCategory active" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + 'All Assignments'+ ' </a>' + '</li>';
		$(tab).appendTo(container);
		var tabcontent = '<div role="tabpanel" class="tab-pane active" id="' + catname + '">' + '</div>';
		$(tabcontent).appendTo(tabcontainer);
		console.log("this.categoryObj",this.categoryObj);
		for (var i in this.categoryObj) {
			if(this.categoryObj[i].assignmentList.length <= 0)
			{
				continue;
			}
			var catnamex = getMatchingValue(this.categories, "id", i).title;
			var catname = catnamex.replace(/ /g, '').replace(/\./g, '');
			var tab = '<li class="myCategory" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + catnamex + ' </a>' + '</li>';
			$(tab).appendTo(container);
			var tabcontent = '<div role="tabpanel" class="tab-pane" id="' + catname + '">' + '</div>';
			$(tabcontent).appendTo(tabcontainer);
			this.LoadMyExams(this.categoryObj[i], catname, tabcontainer);
		}
		$(".myCategory").unbind().bind('click', function(e){
			var calculate1 = $(".mytabList").scrollLeft() + $(e.currentTarget).offset().left-$(".mytabList").offset().left-$(".mytabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
			$('.mytabList').animate({
	        scrollLeft: calculate1
	    	}, 1000);
	    });    
		slider("myTests", 'mytabList', "myCategory");	
		var emptybottom = '<div class="emptygap"></div>';
		$(emptybottom).appendTo($(tabcontainer).find('#Allexams'));
		$(this.dom).find('.emptygap').height('79px');
	}
	else {
		alert("No exams subscribed");
	}
	$(this.dom).find('[role="tab"]').on('click', function(e) {
		var categoryTabId = $(e.currentTarget).attr('class');
		var length = this.ExamsTotalLength(categoryTabId);
		// $('.exam-patti').find("p").text("Total " + length + " exams subscribed");
		$(this.dom).scrollTop(0);
	}.bind(this));
	// $('.exam-patti').find("p").text("Total " + this.ExamsTotalLength('Allexams') + " exams subscribed");
};

commontr2myassignmentsController.prototype.LoadMyExams = function(objectid, catname, tabcontainer)
{
	var tabpopulate = $(tabcontainer).find('#' + catname);
	var tabpopulateAll = $(tabcontainer).find('#Allexams');
	var addedTestLists = [];
	// console.log("objectid",objectid);
	for (var x in objectid.assignmentList) {
		if(addedTestLists.indexOf(objectid.assignmentList[x].id) == -1){
			var testname = "<div class='examDiv' data-action='lists/test&id=" + objectid.assignmentList[x].id + "'>" + "<p>" + objectid.assignmentList[x].title + "</p>" + "<img src='img/right-nav-blue.png'" + "</div>";
			$(testname).appendTo(tabpopulate);
			$(testname).appendTo(tabpopulateAll);
			addedTestLists.push(objectid.assignmentList[x].id);
		}
	}
	var emptybottom = '<div class="emptygap"></div>';
	$(emptybottom).appendTo(tabpopulate);

	$(this.dom).find('.examDiv').unbind().bind('click', function(e) {
		var testlistAction = $(e.currentTarget).attr('data-action');
		UrlMgmt.getObj().Route({route: testlistAction, needData: true, offlineAllowed: true, emptyStack: true});
	}.bind(this));

};

commontr2myassignmentsController.prototype.ExamsTotalLength = function(listview)
{
	var content = $(this.dom).find(".tab-content");
	var current = $(content).find('#' + listview);
	var length = $(current).find('.examDiv').length;
	return length;
};
commontr2myassignmentsController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.LoadData();
	urlMgmt.removeLoader();
};