var commontr2sidemenuController = function(data)
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.forView = null;
};
commontr2sidemenuController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	this.dom.find('.view-blocker').unbind().bind('click',function(){
		UrlMgmt.getObj().sideMenuAction.controler.CloseView();
	});
};
commontr2sidemenuController.prototype.LoadSideMenu = function()
{
	var urlMgmt = UrlMgmt.getObj();
	this.dom.find('.smenu-content').find('.smenu-options').find('ul').html(sideMenu);
	this.dom.find('.js-callus').find('a').attr('href', 'tel:'+contactNumber);
	if(contactNumber.length == 0){
		this.dom.find('.js-callus').remove();
	}
	this.dom.find('.social-icons').html(socialLinks);
	this.dom.find('.tr-picture').attr('alt', Application_name);
	this.dom.find('.js-aboutus').unbind().bind('click',this,function(e){
		urlMgmt.sideMenuAction.controler.CloseView();
		setTimeout(function(){
			urlMgmt.Route({route: 'app/about', needData: false});
		}, 10);
	});
	this.dom.find('.js-social-link').unbind().bind('click',function(){
		var url = $(this).data('url');
		window.open(url, '_system');
	});
    this.dom.find('.js-rate-app').unbind().bind('click',function(){
		AppRate.getObj().RateApp();
	});
    $(".nav-swipe").swipe( {
        swipeLeft:function(event, direction, distance, duration, fingerCount) {
            this.CloseView();
        }.bind(this),
        swipeRight:function(event, direction, distance, duration, fingerCount) {
            this.OpenView();
        }.bind(this)
    });
     
	if(LoggedInUser.Auth()){
		showSideMenuWithLogin(this);
	}
	else{
		showSideMenuWithoutLogin(this);
	}
	
	function showSideMenuWithLogin(e){
		if(document.getElementById("sideSubscribe"))
		{
			document.getElementById("sideSubscribe").style.display = "block";
		}
		if(document.getElementById("sideBookmarks"))
		{
			document.getElementById("sideBookmarks").style.display = "block";
		}
		if(document.getElementById('sidemyExams'))
		{
			document.getElementById('sidemyExams').style.display = "block";
		}
		if(document.getElementById('sidemyDashboard'))
		{
			document.getElementById('sidemyDashboard').style.display = "none";
		}
		if(urlMgmt.subscription == "0"){
			if(document.getElementById("sideSubscribe"))
			{
				document.getElementById("sideSubscribe").style.display = "none";
			}
			if(document.getElementById('sidemyExams'))
			{
				document.getElementById('sidemyExams').style.display = "none";
			}
		}
		document.getElementById('sideLogout').style.display = "block";
		e.dom.find('.js-examSubscribe').unbind().bind('click',this,function(e){
			urlMgmt.sideMenuAction.controler.CloseView();
			urlMgmt.Route({route: 'common/tr2subscription', needData: false});
		});
		e.dom.find('.js-myExamsidmenu').unbind().bind('click',this,function(e){
			urlMgmt.sideMenuAction.controler.CloseView();
			setTimeout(function(){
				new commontr2menuController().getMyTestAction();
			}, 10);
		});
		e.dom.find('.js-myDashboardsidmenu').unbind().bind('click',this,function(e){
			urlMgmt.sideMenuAction.controler.CloseView();
			setTimeout(function(){
				urlMgmt.Route({route: 'common/profile&id='+UrlMgmt.getObj().userData.id, needData: true, offlineAllowed: true, emptyStack: true});
			}, 10);
		});
		e.dom.find('.js-bookmarks').unbind().bind('click',this,function(e){
			urlMgmt.sideMenuAction.controler.CloseView();
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().App.onOffline();
				return false;
			}
			urlMgmt.Route({route: "common/bookmark", needData: true, offlineAllowed: true,  emptyStack: true}); 
			//Factory.getObj().showBookmarks();
		});
		e.dom.find(".js-logout").unbind().click(function(){
			urlMgmt.sideMenuAction.controler.CloseView();
			var urlmgmt = UrlMgmt.getObj();
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().App.onOffline();
				return false;
			}
			LoggedInUser.canSkip = false;
			LoggedInUser.logout();
		});
		if(typeof urlMgmt.userData.id !== 'undefined')
		{
			if(typeof urlMgmt.userData.emailId !== "string")
			{
				urlMgmt.userData.emailId = "";
			}
			var profileDiv =
				'<div class="profile-div">'+
					'<div class="profile-pic" style="background-image: url('+remoteServer+'/attachment/profile-thumbnail/'+urlMgmt.userData.id+'/'+(new Date().getTime())+');"></div>'+
					'<div class="user-details">'+
						'<div>'+
								'<div class="pname-x">'+
									urlMgmt.userData.displayName+
								'</div>'+
								'<div class="text-grey">'+
									urlMgmt.userData.emailId+
								'</div>'+
						'</div>'+
					'</div>'+
					'<div class="profilesidearrow">'+
					'<img src="img/right-nav-reverse.png">'+
						'>'+
					'</div>'+
					'</div>'+
				'</div>';
			e.dom.find('.smenu-head').html(profileDiv);
			e.dom.find('.smenu-head').unbind().bind('click',function(){
				urlMgmt.sideMenuAction.controler.CloseView();
				setTimeout(function(){
					urlMgmt.Route({route: 'common/profile&id='+UrlMgmt.getObj().userData.id, needData: true, offlineAllowed: true, emptyStack: true});
				}, 10);
			});
		}
		else{
			showSideMenuWithoutLogin(e);
		}
	}
	function showSideMenuWithoutLogin(e)
	{
		console.log(e);
		var urlMgmt = UrlMgmt.getObj();
		if(document.getElementById("sideSubscribe"))
		{
			document.getElementById("sideSubscribe").style.display = "none";
		}
		if(document.getElementById("sideBookmarks"))
		{
			document.getElementById("sideBookmarks").style.display = "none";
		}
		if(document.getElementById('sidemyExams'))
		{
			document.getElementById('sidemyExams').style.display = "none";
		}
		if(document.getElementById('sidemyDashboard'))
		{
			document.getElementById('sidemyDashboard').style.display = "none";
		}
		if(document.getElementById('sideLogout'))
		{
			document.getElementById('sideLogout').style.display = "none";
		}
		var welcomeDiv =
			'<div class="welcome-div">'+
				'<div>'+
					'Welcome Guest!'+
				'</div>'+
				'<div class="text-grey_nouser">'+
					'It seems you have not logged in'+
				'</div>'+
				'<div>'+
					'<span><button class="btn btn-default js-open-login">Login</button></span>'+
					'<span><button class="btn btn-default js-open-register">Register</button></span>'+
				'</div>'+
			'</div>';
		e.dom.find('.smenu-head').html(welcomeDiv);
		e.dom.find('.smenu-head').unbind();
		
		e.dom.find('.js-open-login').unbind().bind('click',function(){
			urlMgmt.sideMenuAction.controler.CloseView();
			urlMgmt.Route({route: 'common/tr2login', needData: false}, function(action){
				action.view.find('#logintab').find('a').click();
			});
		}.bind(this));
		e.dom.find('.js-open-register').unbind().bind('click',function(){
			urlMgmt.sideMenuAction.controler.CloseView();
			if(typeof UrlMgmt.getObj().menuData.domainmeta     				   != "undefined" && 
			   typeof UrlMgmt.getObj().menuData.domainmeta.sso 				   != "undefined" &&
			   typeof UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl != "undefined")
			   {
			   		URLRedirection(UrlMgmt.getObj().menuData.domainmeta.sso.registrationUrl);
			   		return;
			   }			
			urlMgmt.Route({route: 'common/tr2login', needData: false}, function(action){
				action.view.find('#regtab').find('a').click();
			});
		}.bind(this));
	};
};
commontr2sidemenuController.prototype.OpenView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	this.dom.show();
	this.LoadSideMenu();
	urlMgmt.headerAction.controler.SideMenuOpen();
	urlMgmt.menuAction.controler.SideMenuOpen();
	this.forView.addClass('slide-view');
	$('.view-blocker').show();
};
commontr2sidemenuController.prototype.CloseView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	this.dom.hide();
	urlMgmt.headerAction.controler.SideMenuClose();
	urlMgmt.menuAction.controler.SideMenuClose();
	if(this.forView != null)
		this.forView.removeClass('slide-view');
	$('.view-blocker').hide();	
};