/************ LoggedInUser Starts***************/
var LoggedInUser = {
	subscribedExams: {},
	//onLoginSuccess : null,
};
var from_profile;
//Check if loggedin
LoggedInUser.Auth = function(callback){
	return (UrlMgmt.getObj().userData !== null && typeof UrlMgmt.getObj().userData.id !== 'undefined');
};
LoggedInUser.FBLogin = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	try{
		facebookConnectPlugin.login(
	        ["public_profile", "email"],
	        function (response) {
	        	var OAuthToken = response.authResponse.accessToken;
	            var OAuthAccessToken = response.authResponse.userID;
	            if (response.authResponse) {
	            	LoggedInUser.onFBLoginSuccess(response);
	            }
	            urlMgmt.removeLoader();
	        },
	        function (response) { 
	        	urlMgmt.removeLoader();               
	            alert(response.errorMessage);
	        }
	    );
	  }
	  catch(e){
	  	removeLoader();
	  }
};
LoggedInUser.GoogleLogin = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	try{
		window.plugins.googleplus.login(
		    {
		      'scopes': '', // optional, space-separated list of scopes, If not included or empty, defaults to `profile` and `email`.
		      'webClientId': googleClientId, // optional clientId of your Web application from Credentials settings of your project - On Android, this MUST be included to get an idToken. On iOS, it is not required.
		      //'offline': true, // optional, but requires the webClientId - if set to true the plugin will also return a serverAuthCode, which can be used to grant offline access to a non-Google server
		    },
		    function (obj) {
		    	var OAuthToken = obj.accessToken;
				LoggedInUser.onGoogleLoginSuccess(obj);
				urlMgmt.removeLoader();
		    },
		    function (msg) {
		    	urlMgmt.removeLoader();
		        if(msg === "Trouble obtaining result, error: NetworkError" || msg === 7){
		    		alert("Check Your Internet connection");
		    	}
		    	else if(msg === 13){
		    		alert("User cancelled dialog");
		    	}
		    	else{
		    		alert("Please, Try again");  //signInResult null
		    	}
		    }
		);
	}
	catch(e){
		urlMgmt.removeLoader();		
	}
};
LoggedInUser.onGoogleLoginSuccess = function(obj)
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	var data = {
	    mod: "user",
	    ack: "googlelogin",
	    id_token : obj.idToken,
	    platform: window.cordova.platformId
	};

	tr$.ajax({
	    mod: "user",
	    ack: "googlelogin",
	    additionalParams: {
	        id_token : obj.idToken,
	        platform: window.cordova.platformId
	    },
	    successClb: function (reply, obj) {
	        try
	        {
	            switch(reply.result.state)
	            {
	                 case "ok":
	                     sessionauthkey = reply.data.sessionAuthKey;
	                     data["sessionAuthKey"] = sessionauthkey;
	                     data["Auth"] = reply.data.Auth;
	                     writeData("userLoginInfo.json", "userLoginInfo", 1, data, function(){});
	                     urlMgmt.userData = reply.data;
	                     var newUser = reply.data.newUser;
						 if(typeof newUser != "undefined" && newUser)
						 {
							 if(typeof webengage != 'undefined' && webengage == true){
							 	TRTracker.getObj().TrackWEEvent("Registration");
							 }
						 }
	                     LoggedInUser.CompleteSessionAuth(reply.data);
	                    break;
	                 case "auth_needPermission":
	                     $('#sign-in .alert').html('<strong>Error: </strong>You are not part of this Domain yet!').attr('class','alert alert-danger');                    
	                     break;
	                 case "invalid_request":
	                 case "Login_auth_error":
	                     $('#sign-in .alert').html('<strong>Error: </strong>'+reply.result.meta).attr('class','alert alert-danger');                    
	                     break;
	                 default:
	                     $('#sign-in .alert').html('<strong>'+reply.result.state+': </strong>'+reply.result.meta).attr('class','alert alert-danger');                    
	                     break;
	             }
	        }
	        catch(e)
	        {
	             $('#sign-in .alert').html('<strong>Internal System Error: </strong>'+JSON.stringify(e)).attr('class','alert alert-danger');                    
	        } 
	        $(".Loader").remove();
	    }
	}, this);
};
LoggedInUser.onFBLoginSuccess = function(response)
{
	UrlMgmt.getObj().showLoader(); 
	var data = {
	    mod: "user",
	    ack: "fblogin",
	    response: response,
	    platform: window.cordova.platformId
	};

	tr$.ajax({
	    mod: "user",
	    ack: "fblogin",
	    additionalParams: {
	        response: response,
	        platform: window.cordova.platformId
	    },
	    successClb: function (reply, obj) {
	        try {
	            switch (reply.result.state) {
	                case "ok":
	                    sessionauthkey = reply.data.sessionAuthKey;
	                    data["sessionAuthKey"] = sessionauthkey;
	                    data["Auth"] = reply.data.Auth;
	                    writeData("userLoginInfo.json", "userLoginInfo", 1, data, function () {});
	                    UrlMgmt.getObj().userData = reply.data;
	                    var newUser = reply.data.newUser;
						if(typeof newUser != "undefined" && newUser)
						{
							if(typeof webengage != 'undefined' && webengage == true){
								TRTracker.getObj().TrackWEEvent("Registration");
							}
						}
	                    LoggedInUser.CompleteSessionAuth(reply.data);
	                    break;
	                case "auth_needPermission":
	                    $('#sign-in .alert').html('<strong>Error: </strong>You are not part of this Domain yet!').attr('class', 'alert alert-danger');
	                    break;
	                case "invalid_request":
	                case "Login_auth_error":
	                    $('#sign-in .alert').html('<strong>Error: </strong>' + reply.result.meta).attr('class', 'alert alert-danger');
	                    break;
	                default:
	                    $('#sign-in .alert').html('<strong>' + reply.result.state + ': </strong>' + reply.result.meta).attr('class', 'alert alert-danger');
	                    break;
	            }
	        } catch (e) {
	            $('#sign-in .alert').html('<strong>Internal System Error: </strong>' + JSON.stringify(e)).attr('class', 'alert alert-danger');
	        }
	        $(".Loader").remove();
	    }
	}, this);
};
LoggedInUser.CompleteSessionAuth = function(data)
{
	var urlMgmt = UrlMgmt.getObj();
    if((!urlMgmt.userData || urlMgmt.userData == null) || (urlMgmt.userData.hasOwnProperty("id") && urlMgmt.userData.id != data.id))
    {
    	scanDir(cordova.file.dataDirectory,"",null,function(entries, directoryEntity){
			for(var i in entries)
			{
				if(entries[i].isFile && entries[i].name!="userLoginInfo.json")
				{
					directoryEntity.getFile(entries[i].name, {}, function(file){
						file.remove(function(){}, fail);
					});
				}			
			}
		});
    }
    urlMgmt.userData = data;
    urlMgmt.menuAction.controler.RefreshMenuData(function(){
    	urlMgmt.menuAction.controler.PopulateMenu();
		urlMgmt.menuAction.controler.MaintainMenuUrlMapping();
		urlMgmt.menuAction.controler.BindEvents();
    	DataMgmt.SaveData('config/userinfo', 1, data, function(){
	    	if(typeof UrlMgmt.getObj().verifyOtp != 'undefined' && UrlMgmt.getObj().verifyOtp == 1){
	    		this.ShowVerifyMobileNumberDlg();
	    	}
	    	
	    	if(this.onLoginSuccess == null){
	    		console.log('I am null');
	    	}
			if(this.onLoginSuccess != null && typeof this.onLoginSuccess === 'function')
			{
				this.onLoginSuccess();
				this.onLoginSuccess = null;
			}
			else
			{
				UrlMgmt.getObj().PopView();
			}
	    }.bind(this),
	    function(e){
	    	console.log("Error: "+e);
	    }.bind(this));
    }.bind(this));
    if(typeof webengage != 'undefined' && webengage == true){
	    TRTracker.getObj().TrackWEEvent("Login");
	}
};
LoggedInUser.login = function(loginId,passwd)
{
    $('#sign-in .alert').html('').attr('class','alert');
    $('#btn_login').attr('disabled','disabled');
    $('#btn_login').html('<p style="display: flex;justify-content: center;">LOGGING IN <img src="img/splashspinner.svg"/></p>');
    var data = {
	    mod: "user",
		ack: "auth",
		preRegisteredRequired:preRegisteredRequired,
		loginId : loginId,
		domiangroupId : domaingroupId,
		passwd: passwd,
		rememberMe: false,
		platform: window.cordova.platformId
	};

	tr$.ajax({
	    mod: "user",
	    ack: "auth",
	    additionalParams: {
	        preRegisteredRequired: preRegisteredRequired,
	        loginId: loginId,
	        domiangroupId: domaingroupId,
	        passwd: passwd,
	        rememberMe: false,
	        platform: window.cordova.platformId
	    },
	    successClb: function (reply, obj) {
	       
	        try
	        {
	            switch(reply.result.state)
	            {
	                 case "ok":
	                     sessionauthkey = reply.data.sessionAuthKey;
	                     data["sessionAuthKey"] = sessionauthkey;
	                     writeData("userLoginInfo.json", "userLoginInfo", 1, data, function(){});
	                     UrlMgmt.getObj().userData = reply.data;
	                     LoggedInUser.CompleteSessionAuth(reply.data);
	                     break;
	                 case "auth_needPermission":
	                     $('#sign-in .alert').html('<strong>Error: </strong>You are not part of this Domain yet!').attr('class','alert alert-danger');
	                     $('#btn_login').removeAttr('disabled');
	        			 $('#btn_login').html('LOGIN');                    
	                     break;
	                 case "invalid_request":
	                 case "Login_auth_error":
	                     $('#sign-in .alert').html('<strong>Error: </strong>'+reply.result.meta).attr('class','alert alert-danger');
	                     $('#btn_login').removeAttr('disabled');
	        			 $('#btn_login').html('LOGIN');                    
	                     break;
	                 default:
	                     $('#sign-in .alert').html('<strong>'+reply.result.state+': </strong>'+reply.result.meta).attr('class','alert alert-danger');
	                     $('#btn_login').removeAttr('disabled');
	        			 $('#btn_login').html('LOGIN');                    
	                     break;
	             }
	        }
	        catch(e)
	        {
	             $('#sign-in .alert').html('<strong>Please Check your Internet Connection !</strong>').attr('class','alert alert-danger');
	             $('#btn_login').removeAttr('disabled');
	        	 $('#btn_login').html('LOGIN');                    
	        }
	        finally{
	         	 setTimeout(function(){
	             	$('#btn_login').removeAttr('disabled');
	        	 	$('#btn_login').html('LOGIN');   
	             }, 3500);
	        }
	    },
	    errorClb: function(){
	    	$('#btn_login').removeAttr('disabled');
	        $('#btn_login').html('LOGIN');
	    }
	}, this);
};
LoggedInUser.ssologin = function(loginId,passwd)
{
	$('#sign-in .alert').html('').attr('class','alert');
    $('#btn_login').attr('disabled','disabled');
    $('#btn_login').html('<p style="display: flex;justify-content: center;">LOGGING IN <img src="img/splashspinner.svg"/></p>');	

	var fields = {};
	 
	$('#sign-in .form-inputs div').each(function(e){
		if($(this).find('.inp input').attr("id") == "sign-in-email")
		{
			fields["LoginID"] = $(this).find('.inp input').val();
		}
		if($(this).find('.inp input').attr("id") == "sign-in-email")
		{
			fields["Password"] = $(this).find('.inp input').val();
		}
	});

	tr$.ajax({
	    mod: "user",
	    ack: "auth",
	    additionalParams: {
	        sso : 1,
			platform : window.cordova.platformId,
			fields : fields
	    },
	    successClb: function (reply, obj) {
	        // var reply = reply.responseJSON;
	        try
	        {
				if(reply.result.state=='ok') 
				{
					  var userData = reply.data;
					  UrlMgmt.getObj().userData['userName'] = userData.displayName;
					  UrlMgmt.getObj().userData['emailId'] = userData.emailId;
					  UrlMgmt.getObj().userData['tr2exams'] = userData.tr2exams;
					  UrlMgmt.getObj().userData['settings'] = userData.settings[0];
					  writeData("userLoginInfo.json", "userLoginInfo", 1, fields, function(){});
		              // UrlMgmt.getObj().userData = reply.data;
		              LoggedInUser.CompleteSessionAuth(reply.data);
					  
					  
				}
				else{
					$('#sign-in .alert').html('<strong>Error: </strong>'+ reply.result.meta +'!').attr('class','alert alert-danger');
				}	
	        }
	        catch(e)
	        {
	             $('#sign-in .alert').html('<strong>Please Check your Internet Connection !</strong>').attr('class','alert alert-danger');
	             $('#btn_login').removeAttr('disabled');
	        	 $('#btn_login').html('LOGIN');                    
	        }
	        finally{
	         	 setTimeout(function(){
	             	$('#btn_login').removeAttr('disabled');
	        	 	$('#btn_login').html('LOGIN');   
	             }, 3500);
	        }
	    },
	    errorClb: function(){
	    	$('#btn_login').removeAttr('disabled');
	        $('#btn_login').html('LOGIN');
	    }
	}, this);
	
};
LoggedInUser.logout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	tr$.ajax({
	    mod: "user",
	    ack: "logout",
	    successClb: function (reply, obj) {
	    	urlMgmt.removeLoader(2000);
	        try
		    {
				if(urlMgmt.userData.hasOwnProperty("Auth"))
				{
					if(urlMgmt.userData.Auth == "Facebook"){
						facebookConnectPlugin.logout(
							function () {
								console.log("facebook logout success");              
							},
							function () {                
							   console.log("facebook logout fail");     
							}
						);
					}
					if(urlMgmt.userData.Auth == "Google"){
						window.plugins.googleplus.logout(
							function (msg) {
							  console.log(msg); 
							}
						);
					}
				}
				if(typeof webengage != 'undefined' && webengage == true){
					TRTracker.getObj().TrackWEEvent("Logout");
				}
				urlMgmt.userData = null;
				UrlMgmt.getObj().ClearActionStack();
				LoggedInUser.onLoginSuccess = function(){
	    			urlMgmt.PopView();
	    			//urlMgmt.ClearActionStack();
					urlMgmt.Route({route:"common/home", needData:true, offlineAllowed: true});
	    		};
	    		DataMgmt.SaveData('config/userinfo', 1, {'appConfigure': true}, function(){
	    			urlMgmt.Route({route:'common/tr2login', needData:false}, function(action){
	    				action.controler.canskip = 1;
	    				action.controler.SkipDecision();
	    			});	
	    		});
		   }
		   catch(e)
		   {
				$('#sign-in .alert').html('<strong>Internal System Error: </strong>'+JSON.stringify(e)).attr('class','alert alert-danger');                    
		   } 
	    }
}, this);
	scanDir(cordova.file.dataDirectory,"",null,function(entries, directoryEntity){
		for(var i in entries)
		{
			if(entries[i].isFile)
			{
				directoryEntity.getFile(entries[i].name, {}, function(file){
					file.remove(function(){}, fail);
				});
			}			
		}
	});
	if (!(typeof window.sqlitePlugin == 'undefined' || SQLiteOps.getObj().databaseOpen == false)) {
		SQLiteOps.getObj().RemoveAllTables();
	}
	AppRate.getObj().appRated = false;
	AppRate.getObj().modalShownCount = 0;
};

LoggedInUser.onForgotPasswdClick = function(){
	$('#forgotPassword-modal').modal('show');
	$('#forgotPassword-modal').find('.forgetPassInput').show();
	$('#forgotPassword-modal').find("#btn_submit").text('RESET PASSWORD');
	$('#forgotPassword-modal').find("#btn_submit").attr('data-dismiss', '');
	$('#forgotPassword-modal').find("#sign-in-frgtpsd").val('');
	$('#forgotPassword-modal').find('.msgForgetPwd').text('');
	$('#forgotPassword-modal').find("#btn_submit").unbind().click(LoggedInUser.onForgotPasswdSubmit);
};
LoggedInUser.onForgotPasswdSubmit = function(){

	var loginId = $("#sign-in-frgtpsd").val();
    tr$.ajax({
    	mod: "user",
	    ack: "forgetpassword",
	    additionalParams: {
	        loginId: loginId,
	    },
	    successClb: function (reply, obj) {
	        try {
	            if (reply.result.state == "ok") {
	                $(".msgForgetPwd").html("<div>New password has been emailed to " + loginId + "!</div>");
	                $('#forgotPassword-modal').find('.forgetPassInput').hide();
	                $('#forgotPassword-modal').find("#btn_submit").text('LOGIN');
	                $('#forgotPassword-modal').find("#btn_submit").unbind();
	                $('#forgotPassword-modal').find("#btn_submit").attr('data-dismiss', 'modal');
	            } else {
	                $(".msgForgetPwd").html("<div class='error'>Error: " + reply.result.meta + "!</div>");
	            }
	        } catch (e) {
	            $(".msgForgetPwd").html("<div class='error'>Please Check your Internet Connection!</div>");
	        }
	    }
	}, this);
};
LoggedInUser.onCreateAccountButtonClick = function()
{	
	var urlMgmt = UrlMgmt.getObj();
	if(!urlMgmt.App.isOnline){
		alert('Connect to internet');
		return;
	}
	$(".errormsg").empty();
	var registrationCode = $("#txt_registration_code").val();
	
	if(preRegisteredRequired == 1 && registrationCode == "")
	{
		$(".errormsg").html("<div class='alert alert-danger'>Registration Code can not be empty!</div>");
		return;
	}
	var registrationPass = $("#txt_registration_password").val();
	if(registrationPass == "")
	{
		$(".errormsg").html("<div class='alert alert-danger'>Registration Password can not be empty!</div>");
		return;
	}
	var displayName = $("#sign-up-name").val();
	if(displayName == "")
	{
		$(".errormsg").html("<div class='alert alert-danger'>Display name can not be empty!</div>");
		return;
	}
	if(displayName.length > 42)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Display name can not be of more than 42 characters!</div>");
		return;
	}
	var emailId = $("#sign-up-email").val();
	if(emailId == "")
	{
		$(".errormsg").html("<div class='alert alert-danger'>Email Id can not be empty!</div>");
		return;
	}
	if(emailId.length > 256)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Email Id can not be of more than 256 characters!</div>");
		return;
	}
	var validate = validEmail(emailId);
	if(!validate)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Please enter valid email!</div>");
		return;
	}
	var pass = $("#txt_password").val();
	if(pass.length == 0)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Password can not be empty!</div>");
		return;
	}
	if(preRegisteredRequired == 0 && pass.length > 48)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Password can not be of more than 48 characters!</div>");
		return;
	}
	var phno = $("#sign-up-phone").val();
	if(phno.length == 0)
	{
		$(".errormsg").html("<div class='alert alert-danger'>Mobile number is mandatory!</div>");
		return;
	}
	if(phno.length > 0 && phno.length != 10 || phno.match(/[^0-9]/))
	{
		$(".errormsg").html("<div class='alert alert-danger'>Mobile number should be of 10 digits!</div>");
		return;
	}
	$('#btn_signup').attr('disabled','disabled');
    $('#btn_signup').html('<p style="display: flex;justify-content: center;">REGISTERING <img src="img/splashspinner.svg"/></p>');
   
	tr$.ajax({
	    mod: "user",
	    ack: "new",
	    additionalParams: {
	        preRegisteredRequired:preRegisteredRequired,
			registrationCode:registrationCode,
			registrationPassword:registrationPass,
			loginId : emailId,
			displayName: displayName,
			passwd: pass,
			phno: phno,
			captcha:"",
			platform: window.cordova.platformId
	    },
	    successClb: function (reply, obj) {
	        try
	        {
	            switch(reply.result.state)
	            {
					case "ok":
						urlMgmt.showLoader();
						if(typeof webengage != 'undefined' && webengage == true){
							TRTracker.getObj().TrackWEEvent("Registration");
						}
						$(".container.dailogreg").find(".aftreg").attr("id","myModal");
						$("#sign-in-email").val($("#sign-up-email").val());
						$("#sign-in .msgafterlogin").show().html("<div class='success'>User created : "+ reply.data.emailId +"!</div>");
						$("#sign-up-email").val("");
						$("#sign-up-name").val("");
						$("#sign-up-phone").val("");
   
					   //auto login after registration
					   //1s timeout for user data migration to ReadDB 
						setTimeout(function(){
							urlMgmt.removeLoader(0);
							LoggedInUser.login(emailId,pass);
						},1000);
	                 break;

	                 case "invalid_request":
	                     $(".errormsg").html("<div class='alert alert-danger'>Error: "+reply.result.meta +"!</div>");
	                     $('#btn_signup').removeAttr('disabled');
	        	 		$('#btn_signup').html('REGISTER');
	                 break;
	                 case "duplicate_parameter":
	                    if(reply.result.meta == "emailId")
	                    {
	                         $(".errormsg").html("<div class='alert alert-danger'>Error: Email ID already registered! </div>");				
	                         $("#txt_login_email").val($("#sign-up-email").val());					
	                         break;
	                    }
	                    $('#btn_signup').removeAttr('disabled');
	        	 		$('#btn_signup').html('REGISTER');
	                 default:
	                     $(".errormsg").html("<div class='alert alert-danger'>"+reply.result.state + ": "+reply.result.meta +"!</div>");
	                     $('#btn_signup').removeAttr('disabled');
	        	 		$('#btn_signup').html('REGISTER');
	             }
	        }
	        catch(e)
	        {
	            $(".errormsg").html("<div class='alert alert-danger'>Please Check your Internet Connection!</div>");
	        }
	        finally{
	         	 setTimeout(function(){
	             	$('#btn_signup').removeAttr('disabled');
	        	 	$('#btn_signup').html('REGISTER');   
	             }, 3500);
	        }
	    },
	    errorClb: function(){
	    	$('#btn_signup').removeAttr('disabled');
	        $('#btn_signup').html('REGISTER'); 
	    }
	}, this);
};
LoggedInUser.ShowVerifyMobileNumberDlg = function(phone_no, from_profileview)
{
	from_profile = from_profileview;
	var urlMgmt = UrlMgmt.getObj();
	//remove previously appended messages 
	$("#VerifyPhoneNumber-modal .msg1").html('');
	$("#VerifyPhoneNumber-modal .msg2").html('');
	
	if(typeof urlMgmt.userData["settings"] == "undefined" ||
		urlMgmt.userData["settings"].length == 0 || 
		!(typeof urlMgmt.userData["settings"][0][UserSettings.PhoneNumberVerified] != "undefined" && parseInt(urlMgmt.userData["settings"][0][UserSettings.PhoneNumberVerified]) == 1) )
    {

  		$("#VerifyPhoneNumber-modal input").val("");
       	$("#VerifyPhoneNumber-modal .result").empty();
		var phonenoValidator = /^\d{10}$/;
       	var phoneno = "";
       	if(urlMgmt.userData["settings"].length > 0 && typeof urlMgmt.userData["settings"][0][UserSettings.PhoneNumber] != "undefined" && !isNaN(urlMgmt.userData["settings"][0][UserSettings.PhoneNumber]))
       	{
       		phoneno = urlMgmt.userData["settings"][0][UserSettings.PhoneNumber];
       	}
       	if(phoneno.match(phonenoValidator))
  		{			
			//send otp
			$("#MobileNoToVerify").text(phoneno);
			this.GetNewOTP();

  		}
  		else
  		{
  			editPhoneNumber();
  		}
  		$('.edit-phone-div input').val(phoneno);
		$(".otp-to-verify .form-control").unbind().on("input",function(){
				if($(this).val().length == 1)
				{
					var number = $(this).data("otp-index");
					if(number < 5)
					$("[data-otp-index = '"+(++number)+"']").focus();
				}
			});
  		$("#GetNewOTPBtn").unbind().bind("click",LoggedInUser.GetNewOTP);
		$("#VerifyOTPBtn").unbind().bind("click",LoggedInUser.VerifyOTP);
		$(".editPhoneBtn").unbind().bind("click",editPhoneNumber);
		$(".js-submit-phno").unbind().bind("click",this,function(e){
				var enteredPhno = $('.edit-phone-div input').val().trim();
					phnoValidator = /^\d{10}$/;
				if(enteredPhno.match(phnoValidator))
				{
					$("#MobileNoToVerify").text(enteredPhno);
					$(".phone-no-div").css("display","block");
					$(".edit-phone-div").css("display", "none");
					e.data.GetNewOTP();
				}
				else
				{
					$("#VerifyPhoneNumber-modal .msg1").html('<div class="errorMsg">Please provide valid 10 digit mobile number</div>');
				}
			});
  		$("#VerifyPhoneNumber-modal").modal("show");
	}
	function editPhoneNumber()
	{
		$(".edit-phone-div").css("display", "block");
		$(".phone-no-div").css("display","none");
	}
};
LoggedInUser.GetNewOTP = function()
{
	$("#VerifyPhoneNumber-modal button#GetNewOTPBtn").prop("disabled", true);
	var phonenoValidator = /^\d{10}$/;
	var phoneno = $("#MobileNoToVerify").text().trim();
	$("#VerifyPhoneNumber-modal input[name='otp-to-verify']").val('');
	$("#VerifyPhoneNumber-modal .result").empty();
    if(phoneno.match(phonenoValidator))
  	{
		tr$.ajax({
		    mod: "user",
		    ack: "sentotp",
		    additionalParams: {
		        phone: phoneno
		    },
		    successClb: function (reply) {
		
		        try {
		            switch (reply.result.state) {
		                case "ok":
		                    if (reply.data.state == "error") {
		                        $("#VerifyPhoneNumber-modal .msg1").html('<div class="Error">' + reply.data.msg + '</div>');
		                        $("#VerifyPhoneNumber-modal button#GetNewOTPBtn").prop("disabled", true);
		                    } else {
		                        $("#VerifyPhoneNumber-modal .msg1").html('<div class="successMsg">' + reply.data.msg + '</div>');
		                    	$("#VerifyPhoneNumber-modal button#GetNewOTPBtn").prop("disabled", false);
		                    }
		                    break;
		
		                case "auth_needPermission":
		                case "invalid_request":
		                case "Login_auth_error":
		                default:
		                    // Some Login error; Probably password or permission changed.
		                    $("#VerifyPhoneNumber-modal").modal("hide");
		                    $("#loggedin-data").html("");
		                    $("#btn_home_profile,.nav-profile").hide();
		                    $("#btn_home_login,.nav-login").show();
		                    break;
		            }
		        } catch (e) {
		            // Do nothing. most probably offline
		        }
		    }
		});
  	}
  	else
  	{
  		$("#VerifyPhoneNumber-modal .result.msg1").html('<div class="Info">Error: Please provide 10 digit mobile number</div>');
  		$("#VerifyPhoneNumber-modal button#GetNewOTPBtn").prop("disabled", false);
  	}
};
LoggedInUser.VerifyOTP = function()
{
	var phonenoValidator = /^\d{10}$/;
	var phoneno = $("#MobileNoToVerify").text().trim();
	var otp = "";
	$(".otp-to-verify .form-control").each(function(i,el){
		otp += $(el).val();
	});
	$("#VerifyPhoneNumber-modal .msg1").empty();
    if(phoneno.match(phonenoValidator))
  	{
		tr$.ajax({
		    mod: "user",
		    ack: "verifyotp",
		    additionalParams: {
		        phone:phoneno,
			    otp:otp
		    },
		    successClb: function (reply) {
		
		        try
			   {
				   switch(reply.result.state)
				   {
					case "ok":
						if(reply.data.state == "error")
						{
							$("#VerifyPhoneNumber-modal .msg2").html('<div class="Error">'+reply.data.msg+'</div>');
						}
						else
						{
							$("#VerifyPhoneNumber-modal .msg1").html('');
							$("#VerifyPhoneNumber-modal .msg2").html('');
							tr$.alert(reply.data.msg);
							$("#VerifyPhoneNumber-modal").modal("hide");
							//HOME_silentLogin(function(){
								if(typeof from_profile !== 'undefined' && from_profile == true){
									UrlMgmt.getObj().PopView(function(){
										//UrlMgmt.getObj().Route({route: 'app/profile', needData: false});
										UrlMgmt.getObj().Route({route : "common/profile&id="+UrlMgmt.getObj().userData['id']+"", needData: true});
									});
								}
							//});
		                }
						break;
		
					case "auth_needPermission":
					case "invalid_request":
					case "Login_auth_error":
					default:
						// Some Login error; Probably password or permission changed.
						$("#VerifyPhoneNumber-modal").modal("hide");
						break;
				}
			   }
			   catch(e)
			   {
				// Do nothing. most probably offline
			   }
		    }
		});
  	}
  	else
  	{
  		$("#VerifyPhoneNumber-modal .result.msg1").html('<div class="Info">Error: Please provide 10 digit mobile number</div>');
  		$("#VerifyPhoneNumber-modal button#GetNewOTPBtn").prop("disabled", false);
  	}
};
function validEmail(emailId) {
  var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
  return regex.test(emailId);
}
function onSwitchToLoginButtonClick()
{
	activaTab('sign-in');
	$(".aftreg").hide();
}
function activaTab(tab){
    $('.nav-tabs a[href="#' + tab + '"]').tab('show');
};
function success(entry) {
    console.log("Removal succeeded");
}
function fail(error) {
    console.log("Error removing file: " + error.code);
}

function HOME_silentLogin(cb)
{   // Silently re-login to refresh the session; just in case it expired.
	var sessionauthkey = 0;
    DataMgmt.GetSavedData('config/userinfo', 1, function(data){
    	if(typeof data.sessionAuthKey == undefined || data.sessionAuthKey == null ||  data.sessionAuthKey == ''){
    		sessionauthkey = data.sessionAuthKey = 0;
    	}
    	else{
    		sessionauthkey = data.sessionAuthKey;
    	}
    	tr$.ajax({
			mod: "user",
			ack: "sessionAuth",
			additionalParams:{
				sessionauthkey:sessionauthkey,
                authType:(data.hasOwnProperty("Auth"))?data.Auth:""
			},
			successClb: function(response,obj){
				UrlMgmt.getObj().userData = response.data;
				DataMgmt.SaveData("config/userinfo", 1, response.data, function(){
					if(typeof cb !== 'undefined')
					{
	            		cb(1);
	            	}
	            });
			}.bind(this),
			errorClb: function(){
				//Error
				if(typeof cb !== 'undefined')
				{
					cb(0);
				}
			}
		});
   },function(){
   		console.log("file error");
   });
}
/************ LoggedInUser Ends***************/