var itembatchController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.stableDom = null;
	this.id = 0;
	this.refresh = true;
};
itembatchController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	this.stableDom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if(!urlMgmt.App.isOnline){
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
	
	
};
itembatchController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Online Coaching', true, false, true);
};
itembatchController.prototype.OfflineInit = function()
{
	$(this.dom).find(".batch").hide();
	Factory.getObj().LoadViewForOffline(this);
};
itembatchController.prototype.OnlineInit = function()
{
	$(this.dom).find(".batch").show();
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	Factory.getObj().ShowNotifyUpdate();
	tr$.touchScrollAnimation(this.dom);
	this.LoadBatchListDropdown();
	this.batchIntroVideo();
	this.LoadBatchSubmenu();
	this.batchPostBannerInfo();
	this.LoadPackageTabs();
	this.LoadvideoTabs();
	this.LoadFaqs();
	this.BindEvents();
	console.log(this.data.urlKey);
	var urlKey = typeof this.data.urlKey != 'undefined' ? this.data.urlKey : '';
	if(typeof webengage != 'undefined' && webengage == true){
		TRTracker.getObj().TrackWEEvent("PageView_BatchList", urlKey);
	}
	//Analytics
	analytics_trackView("item_batch");
	analytics_trackEvent("item_batch" , '/'+urlKey);
};
itembatchController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
itembatchController.prototype.BindEvents = function()
{
	this.dom.find('.js-checkout').removeAttr('href');
	//TODO: can be removed
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	   this.dom.find('.js-checkout').html("More");
	}
	else
	{	
		this.dom.find('.js-checkout').unbind().bind('click',this,function(e){
			e.preventDefault();
			 $('.batchIntroVideo').find('iframe[src*="https://www.youtube.com/embed/"]').addClass("youtube-iframe");
		 	 // changes the iframe src to prevent playback or stop the video playback in our case
			 $('.youtube-iframe').each(function(index) {
			   $(this).attr('src', $(this).attr('src'));
			   return false;
			 });
			 var route = $(this).data('action');
			 if(route.startsWith('route=')){
			 	route = route.substring(6);
			 }
			UrlMgmt.getObj().Route({route: route, needData: true, offlineAllowed: false});
		});	
	}
	this.dom.find('._eventListener').unbind().bind('click',this,function(e){
		$('.batchIntroVideo').find('iframe[src*="https://www.youtube.com/embed/"]').addClass("youtube-iframe");
	 	// changes the iframe src to prevent playback or stop the video playback in our case
		$('.youtube-iframe').each(function(index) {
		  $(this).attr('src', $(this).attr('src'));
		  return false;
		});
		 var route = $(this).data('action');
		 if(route.startsWith('route=')){
		 	route = route.substring(6);
		 }
		UrlMgmt.getObj().Route({route: route, needData: true, offlineAllowed: false});
	});
};
itembatchController.prototype.LoadBatchListDropdown = function()
{
	$(this.dom).find('.batchlist-dropdown > span:first-child').empty();
	$(this.dom).find('.batchlist-dropdown > span:first-child').text(this.data.title);
	$(this.dom).find('.batchlist-dropdown').unbind().bind('click', function(){
		UrlMgmt.getObj().Route({route: 'lists/batch', needData: false});
	});
};
itembatchController.prototype.batchIntroVideo = function()
{
	if(this.data.batchIntroVideo == null){
		$(this.dom).find('.batchIntroVideo').hide();
	}	
	else if(this.data.batchIntroVideo != null){
			$(this.dom).find('.batchIntroVideo').show();
			var overlay = 
			'<div class="videooverlay"></div>';	
			$(this.dom).find('.batchIntroVideo').empty();
			$(this.dom).find('.batchIntroVideo').append(this.data.batchIntroVideo.data.preDescription);
	    }
		// batch info modal starts
		 $("#batchinfobtn").click(function(){
		    $('#batchinfo-modal').modal('show');
		    var batchinfoCard ="";
	        batchinfoCard = '<div class="batchinfoCard">'+
	        					  '<div class="batchinfoeach"><a href="#description" class="eachinfo"><div>Batch Information</div></a></div>'+
	        					  '<div class="batchinfoeach"><a href="#course-hilights" class="eachinfo"><div>Course Highlights</div></a></div>'+
	        					  '<div class="batchinfoeach"><a href="#batchDate" class="eachinfo"><div>Batch Date & Time</div></a></div>'+
	        					  '<div class="batchinfoeach"><a href="#instructors" class="eachinfo"><div>Teachers</div></a></div>'+
	        					  '</div>';
	        $(".batchinfomodal").empty();
	    	$(".batchinfomodal").append(batchinfoCard);
	    	if(!UrlMgmt.getObj().App.isOnline)
			{
				$('#batchinfo-modal').find(".modal-dialog").css("margin-bottom","18px");
			}
			else{
				$('#batchinfo-modal').find(".modal-dialog").css("margin-bottom","0px");
			}
	    	$(".eachinfo").on('click', this, function(e){ 
				 $('#batchinfo-modal').modal('hide'); 
	    		 //e.preventDefault();
		         var href = $(this).attr('href').split("#")[1];
	 	         $('#course-hilights-modal').find('.course-hilights-body').empty();
	 	         $('#course-hilights-modal').find('.course-hilights-body').append('<h2>'+e.data.data.title+'</h2>');	
				 $('#course-hilights-modal').find('.course-hilights-body').append('<div id="description">'+e.data.data.description+'</div>');
				 $('#course-hilights-modal').find('.course-hilights-body').append(e.data.data.batchDescription);
				 setTimeout(function(){
			 		$('#course-hilights-modal').modal("show");
					var hash = $('.course-hilights-content').find("#"+href+"").attr('id');
					$('#course-hilights-modal').animate({
						scrollTop : $("#"+hash+"").offset().top - 65
					}, 800);
				 }, 500);  
	  	 	});
		}.bind(this));
		$(".exploreinfo").text("EXPLORE COURSE INFO");
	    $(".exploreinfo").on('click', this, function(e){ 
	    	$('#course-hilights-modal').find('.course-hilights-body').empty();
 	        $('#course-hilights-modal').find('.course-hilights-body').append('<h2>'+e.data.data.title+'</h2>');	
			$('#course-hilights-modal').find('.course-hilights-body').append('<div id="description">'+e.data.data.description+'</div>');
			$('#course-hilights-modal').find('.course-hilights-body').append(e.data.data.batchDescription);  
	  	 	$('#course-hilights-modal').modal("show");
	  	 });
};
itembatchController.prototype.batchPostBannerInfo = function()
{
	$(this.dom).find('.batchPostBannerInfo').empty();
	var patt = /faculties/i;
	var xyz = typeof this.data.postBannerDescription != 'undefined' ? this.data.postBannerDescription.search(patt) : -1;
	if(xyz != -1 )
	{
		var carouselfac = 
		$('<div id="facCarousel" class="carousel slide" data-interval="false">'+
		'<p class="facultyhead">Our Teachers - <span style="color:#30B8E2">India\'s Top Faculties</span></p>'+
		'</div>');
		$('.batchPostBannerInfo').find('._eventListener'). removeAttr("href");
		if(typeof this.data.mode != 'undefined')
		{
			$('.facultydiv').append(this.data.batchIntroVideo.data.preDescription);
		}
		$(this.dom).find('.batchPostBannerInfo').append(carouselfac);
		var desDom = $(this.data.postBannerDescription).appendTo(carouselfac);
		if(desDom.find('.AfterBannerCost'))
		{
			$(this.dom).find('.cost-info').html(desDom.find('.AfterBannerCost').html());
			desDom.find('.AfterBannerCost').remove();
		}
		$('.facultyposition').addClass("carousel-inner");
		$('.faculty').addClass("item");
		$(".faculty.item").first().addClass("active");
		var sidenav=
		'<a class="left carousel-control facultyslide" href="#facCarousel" data-slide="prev">'+
	      '<span class="facultyslider"><img src="img/right-nav-blue2left.png"/></span>'+
	      '<span class="sr-only">Previous</span>'+
	    '</a>'+
	    '<a class="right carousel-control facultyslide" href="#facCarousel" data-slide="next">'+
	      '<span class="facultyslider"><img src="img/right-nav-blue2.png"/></span>'+
	      '<span class="sr-only">Next</span>'+
	    '</a>';	 
		$(this.dom).find('.batchPostBannerInfo').append($(sidenav));
		var carouselDom = this.dom.find('#facCarousel');
		tr$.carouselSet(carouselDom,this.dom,false);	
		var explorebutton = '<button class="btn btn-primary btn-block lcb">EXPLORE COURSE INFO</button>';
		$(explorebutton).insertAfter('#facCarousel');
		
		$(".lcb").on('click', this, function(e){ 
	    	$('#course-hilights-modal').find('.course-hilights-body').empty();
 	        $('#course-hilights-modal').find('.course-hilights-body').append('<h2>'+e.data.data.title+'</h2>');	
			$('#course-hilights-modal').find('.course-hilights-body').append('<div id="description">'+e.data.data.description+'</div>');
			$('#course-hilights-modal').find('.course-hilights-body').append(e.data.data.batchDescription);  
	  	 	$('#course-hilights-modal').modal("show");
	  	});
	}
	var facultyPat = /facultylist/i;
	var facultyExist = typeof this.data.postBannerDescription != 'undefined' ? this.data.postBannerDescription.search(facultyPat) : -1;
	if(facultyExist == -1){
		//No faculty Exist
		$('#facCarousel').remove();
	}
};
itembatchController.prototype.LoadBatchSubmenu = function()
{
	Factory.getObj().LoadSubMenus(this.data.submenuList, $(this.dom).find('.submenuPosition'));
};
itembatchController.prototype.LoadPackageTabs = function()
{
	var packageTabs = Factory.getObj().PackageTabs({
		packagePlanCount: this.data.packagePlanCount,
		PackageActiveTab: this.data.PackageActiveTab,
		plansAndPackages: this.data.plansAndPackages
	});
	if(packageTabs != ""){
		this.dom.find('.plan-package-align').text('Plans & Packages');
	
		this.dom.find('.PackageContainer').empty();
		this.dom.find('.PackageContainer').append(packageTabs);
		slider("packageDiv", 'packageList', "package");
		var pkgdescriptionslide = new Array();
		var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
		for(var c = 0;c < activeTab.find('.pkgDetail').length; c++)
		{	
			 pkgdescriptionslide[c] = new slideVertical();
			 pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines",c);
		}
		$(".packageContainerTab .nav.nav-tabs").bind("click",function(){
			setTimeout(function(){
	       		var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
				for(var c = 0;c < activeTab.find('.pkgDetail').length; c++)
				{
					 pkgdescriptionslide[c] = new slideVertical();
					 pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines",c);
				}
			}, 100);
		});
	}
	$(".packageContainerTab .nav.nav-tabs").bind("click",function(){
		setTimeout(function(){
       		var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
			for(var c = 0;c < activeTab.find('.pkgDetail').length; c++)
			{
				 pkgdescriptionslide[c] = new slideVertical();
				 pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines",c);
			}
		}, 100);
	});
};

itembatchController.prototype.LoadvideoTabs = function()
{
	var videoTabs = Factory.getObj().VideoTabs({
		videoCount: this.data.videocount,
		videoActiveTab: this.data.ActiveTab,
		videoGroup: this.data.videoGroup,
		liveClassesEcomData: this.data.liveClassesEcomData,
		vodOnly: this.data.vodOnly
	});
	
	if(videoTabs != ""){
		$(this.dom).find('.LiveClassContainer ').html(videoTabs);
		
		//if active tab count = 0
		var active = 0;
		$(this.dom).find('.videotabDiv').find('ul').find('li').each(function(k, v){
			if($(v).hasClass('active')){
				active++;
			}
		});
		
		if(active == 0)
		{
			$(this.dom).find('.videotabDiv').find('ul').find('li:first-child').addClass('active');
			$(this.dom).find('.videos-container').find('.tab-content').find('.tab-pane:first-child').addClass('active');
		}
		
		//scroll tabs to center on click
		Factory.getObj().scrollToCenter('.LiveClassContainer .nav-tabs li');
		
		//nav tabs left right btns show hide on scroll
		slider(this.dom.find(".videotabDiv"), 'tabList', "videoTab");
		
		//videos show hide
		Factory.getObj().ShowHideList(this.dom);
	}
};
itembatchController.prototype.LoadFaqs = function()
{
	if(typeof this.data.faqs !== 'undefied' && tr$.length(this.data.faqs) > 0)
	{
		var faqs = Factory.getObj().Faqs(this.data.faqs);
		this.dom.find('.FaqsContainer').html(faqs.html);
		faqs.bindEvents();
	}
};