/******** Discussion Start ********/
var listsdiscussionController = function()
{
	this.view = "default";
	this.style = "default";
	
	this.threadId = 0;
	this.id = 0;
	this.node = null;
	this.isAdmin = false;
	this.dom = null;
	this.data = null;
	this.domId = null;
	this.completeDom = null;
	this.postType = undefined;
};
listsdiscussionController.prototype.Init = function(viewDom)
{
	this.completeDom = viewDom;
	this.dom = $(viewDom).find('.discussion_div');
	this.domId = $(this.completeDom).attr('id');
	if(this.domId == 'listsdiscussionController'){
		//console.log(this.data.threadId,this.postType,2);
		this.SetLayout();
		//this.PostSegregate(this.id,UrlMgmt.getObj().discussionPostType,2);
	}
	else{
		
	}
	this.LoadDiscussion();
	

};
listsdiscussionController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Discussions', false, true, false);
};
listsdiscussionController.prototype.BindEvents = function()
{
	this.threadId = $(this.completeDom).find(this.dom).find("#thread").data("threadid");	/*get threadid from html*/
	this.isAdmin = $(this.completeDom).find(this.dom).find("#thread").data("showapprove") == 1; /*get thread Admin from html*/
	
	
	if(this.domId == 'liststestController')
	{
		var r = document.querySelector('#'+$(this.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$('#liststestController .testlistouter .btnExamSubscribe').css("position", "sticky");
		$('#liststestController .testlistouter .btnExamSubscribe').css("bottom", "24px");
		
		$(this.completeDom).animate({
			scrollTop : parseInt( p.getElementsByClassName('createall')[0].offsetTop - 65) 
		}, 1000);
		setTimeout(function(){
				$('#liststestController .testlistouter .btnExamSubscribe').css("visibility", "visible"); 
		}, 1000);
		
	}
	$(this.completeDom).find(this.dom).find("#thread").find("textarea").bind('click',this, function(e) {
		e.data.autoSize($(this));
	});
	$('#shared-post-modal').modal('show');		/* show shared post modal*/
	/*create node for appending modals*/
	var div = document.createElement("div");
	document.body.appendChild(div);
	this.node = $(div);	
	
	/*bind discussion events*/
	$(this.completeDom).find(this.dom).find('.AskQuery').unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).siblings().removeClass("active");
		$(this).addClass("active");
		var $queryCard = $('.createall').find(".create-jsquery");
		$queryCard.siblings().hide();
		$queryCard.show();
		e.data.ScrolltoDiv($queryCard);
	 });
	$(this.completeDom).find(this.dom).find('.pmcq').unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).siblings().removeClass("active");
		$(this).addClass("active");
		var $mcqCard = $('.createall').find(".create-jsmcq");
		$mcqCard.siblings().hide();
		$mcqCard.show();	
		e.data.ScrolltoDiv($mcqCard);
	});
	$(this.completeDom).find(this.dom).find('.shareinfo').unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).siblings().removeClass("active");
		$(this).addClass("active");
		var $infoCard = $('.createall').find(".create-jsinfo");
		$infoCard.siblings().hide();
		$infoCard.show();
		e.data.ScrolltoDiv($infoCard);
	});
	$(this.completeDom).find(this.dom).find(".discard-post").unbind().bind("click",this, function(e) {
		$(".create-post div").removeClass("active");
		$(".common-create").hide();
		var parentDom = $(this).closest(".common-create");
		parentDom.find("textarea").val('');
		parentDom.find("input:text").val('');
		parentDom.find("textarea").trigger('keydown');
		parentDom.find(".select-correct-option").find(".active").removeClass("active");
	});
	
	/*submit query post*/
	$(this.completeDom).find(this.dom).find(".queryPost").unbind().bind("click",this, function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			var actionStack = UrlMgmt.getObj().actionStack;
			actionStack[actionStack.length - 1].controler.refresh = false;
			LoggedInUser.onLoginSuccess = function(){
				
				UrlMgmt.getObj().PopView(function(){
					var action = UrlMgmt.getObj().actionStack;
					action[action.length - 1].controler.refresh = true;
				});
			};
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			
			return false;		
		}
		var $queryCard = $(this).closest('.create-jsquery');
			postId = parseInt($(this).attr('data-postid'));
			postTitle = $queryCard.find(".query-title").val().trim();
			query = $queryCard.find(".query-description").val().trim();
			postType = TR2PostType.AskQuery;
			$msg = $queryCard.find(".errorMsg");
			attachmentId = parseInt($queryCard.find('.image-preview').attr('data-attachmentid'));
		
		if(postTitle.length > 160)
		{
			$msg.text('Title cannot be more than 160 characters!');
			return;
		}
		if(query.length == 0)
		{
			$msg.text('Query cannot be empty!');
			return;
		}
		
		var content = { 
	  			query: query,
			};
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
   	 	e.data.CreatePost(postId,postTitle, content ,postType, attachmentId);
	});
	
	/*submit mcq post*/
	$(this.completeDom).find(this.dom).find(".js-submit-mcq").unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			var actionStack = UrlMgmt.getObj().actionStack;
			actionStack[actionStack.length - 1].controler.refresh = false;
			LoggedInUser.onLoginSuccess = function(){
				UrlMgmt.getObj().PopView(function(){
					var action = UrlMgmt.getObj().actionStack;
					action[action.length - 1].controler.refresh = true;
				});
			};
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			
			return false;		
		}
		var $mcqCard = $(this).closest('.create-jsmcq');
			postId = parseInt($(this).attr('data-postid'));
			postTitle = $mcqCard.find(".mcq-title").val().trim();
			question = $mcqCard.find(".mcq-question").val().trim();
			alloptions = $mcqCard.find(".mcq-option");
			answer = $mcqCard.find(".select-correct-option").find(".active").attr("data-select");
			postType = TR2PostType.MCQ;
			options = [];
			$msg = $mcqCard.find(".errorMsg");
			attachmentId = parseInt($mcqCard.find('.image-preview').attr('data-attachmentid'));
		if(postTitle.length > 160)
		{
			$msg.text('Title cannot be more than 160 characters!');
			return;
		}
		if(question.length == 0)
		{
			$msg.text('Question cannot be empty!');
			return;
		}
		for ( i = 0; i < alloptions.length; i++)
		{
			var option = alloptions[i].value.trim();
			if(option.length == 0)
			{
				$msg.text('Options cannot be empty!');
				return;
			}
			options.push(option);
		}
		if(answer == undefined)
		{
			$msg.text('Correct Answer not selected!');
			return;
		}
		var content = {
			question : question,
			options : options,
			answer : answer
		};
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		e.data.CreatePost(postId,postTitle, content,postType, attachmentId);
	});
	
	/*submit info post*/
	$(this.completeDom).find(this.dom).find(".post-info").unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			var actionStack = UrlMgmt.getObj().actionStack;
			actionStack[actionStack.length - 1].controler.refresh = false;
			LoggedInUser.onLoginSuccess = function(){
				UrlMgmt.getObj().PopView(function(){
					var action = UrlMgmt.getObj().actionStack;
					action[action.length - 1].controler.refresh = true;
				});
			};
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			
			return false;		
		}
		var $infoCard = $(this).closest('.create-jsinfo');
			postId = parseInt($(this).attr('data-postid'));
			postTitle = $infoCard.find(".info-title").val().trim();
			postType = TR2PostType.ShareInfo;
			info = $infoCard.find(".info-description").val().trim();
			$msg = $infoCard.find(".errorMsg");
			attachmentId = parseInt($infoCard.find('.image-preview').attr('data-attachmentid'));
		if(postTitle.length > 160)
		{
			$msg.text('Title cannot be more than 160 characters!');
			return;
		}
		if(info.length == 0)
		{
			$msg.text('Info cannot be empty!');
			return;
		}
		content = { 
  			info: info,
		};
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
    	e.data.CreatePost(postId,postTitle, content ,postType, attachmentId);
	});
	
	$(this.completeDom).find(this.dom).find(".post-approve input").unbind().change(this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		var itemId = $(this).parents(".Card").attr("data-postid");
			isApproved = $(this).prop("checked")?1:0;
			msg =  isApproved == 1 ?"Approve Post?" : "Disapprove Post?";
			getConfirm = confirm(msg);
		if (getConfirm) {
		    e.data.SetApprove(isApproved,itemId,TR2DiscussionItemType.Post);
		}
		else{
			$(this).prop('checked', !isApproved);
		}
	});
	
	$(this.completeDom).find(this.dom).find(".mcqOptions").unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		if(!$(this).parents(".mcq-description").children(".mcqOptions").hasClass("correct")) //only for unattempted users
		{
			e.data.ValidateMcq($(this));
		}
	});
	
    $(this.completeDom).find(this.dom).find('.AddOption').unbind().bind("click",this, function(e) {
    	var $mcqCard = $(this).closest('.create-jsmcq');
    		optionCount = $mcqCard.attr('data-optcount');
 	
	    if(optionCount < 5)
	    {
	    	$mcqCard.attr('data-optcount',++optionCount);
	    	
	    	var optionHtml =
	    		'<div class="option">'+
	    			'<label class="mcq-option-label">'+
	    			String.fromCharCode(64+optionCount)+
	    			'</label>'+
	    			'<div>'+
	    				'<textarea class="mcq-option js-inputkeyboard" placeholder="Option '+ String.fromCharCode(64+optionCount) +'" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \''+'Option '+ String.fromCharCode(64+optionCount) +'\'"></textarea>'+
	    			'</div>'+
	    		'</div>';
	    	
	        $mcqCard.find(".mcq-options").append(optionHtml);
	         
	        $mcqCard.find(".select-correct-option").append("<a data-select="+parseInt(optionCount - 1)+">" + String.fromCharCode(64 + optionCount) +"</a>");     
	        $mcqCard.find('.optionremove').css('display','block');
	        $mcqCard.find(".mcq-options .option div").find("textarea").unbind().bind('keydown',e.data, function(e) {
				e.data.autoSize($(e.currentTarget));
			}.bind(this));
	    }
	    if(optionCount > 4)
	    {
	    	$(this).hide();
	    }
	});
	
    $(this.completeDom).find(this.dom).find('.optionremove').unbind().click(function () {
    	var $mcqCard = $(this).closest('.create-jsmcq');
    		optionCount = $mcqCard.attr('data-optcount');
    	
    	if(optionCount > 2)
	    {
			$mcqCard.find(".option").last().remove();
		    $mcqCard.find(".select-correct-option a").last().remove();
		    $mcqCard.find('.AddOption').show();
		    $mcqCard.find('.select-correct-option').css("margin", "unset");
			$mcqCard.attr('data-optcount',--optionCount);
		}
	    if(optionCount < 3)
	    {
	        $(this).hide();
	    }
	});
    
    $(this.completeDom).find(this.dom).find('.select-correct-option ').unbind().click(function(e){
		$('.select-correct-option a').removeClass("active");
		$(e.target).addClass("active");
	});
                    
	$(this.completeDom).find(this.dom).find(".submit-comment").unbind().bind("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		var itemId = $(this).data('postid');
			itemType = TR2DiscussionItemType.Post;
			query = $(this).siblings('.write-comment-text').val().trim();
			mail = 1;
		if (query.length < 1) {
			alert("Comment cannot be empty");
			return;
		}
		var content = {
			Query : query
		};
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		e.data.SubmitComment(itemId,itemType,content,mail);
	});
	
	$(this.completeDom).find(this.dom).find(".js-showcomments").unbind().one("click",this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		var itemId = $(this).closest(".Card").attr("data-postid");
		$(e.data.completeDom).find(e.data.dom).find('#post-'+itemId+'').find(".write-comment").show();
		$(e.data.completeDom).find(e.data.dom).find('#post-'+itemId+'').find('.show-comments').show();
		console.log($(e.data.completeDom));
		itemType = TR2DiscussionItemType.Post;
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		e.data.GetComment(itemId,itemType);
		var objevent = this;
		$(this).bind("click",function(){
			if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
			}
			$(this).parents().siblings(".comment_div").toggle();
			//$(e.data.completeDom).find(e.data.dom).find('#post-'+itemId+'').find('.comment_div').toggle();
		});
	});
	
	$(this.completeDom).find(this.dom).find(".js-getcomments").unbind().bind("click",this, function(e) {
		var itemId = $(this).closest(".Card").attr("data-postid");
		itemType = TR2DiscussionItemType.Post;
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		e.data.GetComment(itemId,itemType);
	});
	$(this.completeDom).find(this.dom).find(".post-upvote").unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).find("img").toggle();
		var itemId = $(this).data('postid');
		var	itemType = TR2DiscussionItemType.Post;
		var	deleted = parseInt($(this).data('upvote'));
		var	counterDom = $(e.data.completeDom).find(e.data.dom).find("#post-"+itemId).find('.upvotes-count');
		var	upvotesCount = parseInt(counterDom.text());
		if(deleted)
		{
			$(this).find("span").removeClass().addClass("like");
			$(this).find("span").text("LIKE");
			$(this).data("upvote",0);
			//$(this).find(".likeimg").attr('src','https://cdn.toprankers.net/images/liked@2x-023c6c29c5d7e.png');
			counterDom.text(--upvotesCount);
		}
		else
		{
			$(this).find("span").text("LIKED");
			$(this).find("span").removeClass().addClass("liked");
			$(this).data("upvote",1);
			counterDom.text(++upvotesCount);
		};
		e.data.Upvote(itemId,itemType,deleted);
	});
	$(this.completeDom).find(this.dom).find(".post-comment").unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).parents().siblings(".comment_div").find(".write-comment").find("textarea").val('');
		$(this).parents().siblings(".comment_div").find(".write-comment").show();
		$(this).parents().siblings(".comment_div").find(".write-comment").find("textarea").css("height","40px");
		$(this).parents().siblings(".comment_div").show();
	});
	$(this.completeDom).find(this.dom).find(".post-share").unbind().bind("click",this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		$(this).addClass('sharing');
		$(this).html('<img class= "shareloading" src="img/loader.svg"><span>SHARE</span>');
		var postId = $(this).data('postid');
		setTimeout(function(){ e.data.GetpostOgImg(postId); }, 100); 
	});
	//this.Pagination();
	$(this.completeDom).find(this.dom).find(".js-page").unbind().bind('click',this,function(e){
		var page = $(this).attr('data-page');
		var posttype =parseInt(e.data.data.discussions.postType);
		switch(posttype)
		{
			case -1:posttype = undefined;
					break;
			case 0: posttype = "query";
					break;
			case 1: posttype = "mcq";
					break;
			case 2: posttype = "info";
					break;
			case 3 :posttype = "myposts";
					break;								
		}
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		e.data.PostSegregate(e.data.data.threadId,posttype,page);
		// var scrollTop = $(e.data.completeDom).find(".discussion_div").offset().top - 74;
		// e.data.completeDom.animate({
			// scrollTop : scrollTop
		// }, 1000);
		var $createcard = $(e.data.completeDom).find(e.data.dom).find(".common-create:visible");
		var r = document.querySelector('#'+$(e.data.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$(e.data.completeDom).animate({
			scrollTop : parseInt( p.getElementsByClassName('createall')[0].offsetTop - 65)
		}, 1000);
	});
	//post segregation	
	$(this.completeDom).find(this.dom).find(".js-filter-post").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		var postType = $(this).attr('data-posttype');
		UrlMgmt.getObj().discussionPostType = postType;
		e.data.PostSegregate(e.data.threadId,postType);
		//e.data.LoadDiscussion(postType);
	});
	$(this.completeDom).find(this.dom).find(".js-clear-filter").unbind().bind('click',function(){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		urlMgmt.discussionPostType = undefined;
		this.PostSegregate(this.data.threadId);
	}.bind(this));
	$(this.completeDom).find(this.dom).find(".js-myposts").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		var urlMgmt = UrlMgmt.getObj();
		urlMgmt.showLoader();
		var myposts = $(this).data('posttype');
		urlMgmt.discussionPostType = myposts;
		e.data.PostSegregate(e.data.threadId,myposts);
	});
	$(this.completeDom).find(this.dom).find(".js-pinpost").unbind().bind('click',this,function(e){
    	var pinindex = prompt("Please enter the pin index");
    	var postId = $(this).parents(".Card").attr("data-postid");
    	if($.isNumeric(pinindex))
    	{
    		e.data.PinPost(pinindex,postId);
    	}
    	else{
    		alert("Pin unsuccesful. Enter only numbers!");
    	}
	});
	$(this.completeDom).find(this.dom).find(".js-unpin").unbind().bind('click',this,function(e){
    	var postId = $(this).parents(".Card").attr("data-postid");
    	var getConfirm = confirm("Unpin?");
		if (getConfirm) {
		    e.data.UnPinPost(postId);
		}
	});
	
	/*delete post*/
	$(this.completeDom).find(this.dom).find(".js-delete-post").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		var itemId = $(this).closest('.Card').attr('data-postid');
		var	itemType = TR2DiscussionItemType.Post;
	    var	getConfirm = confirm("Delete Post?");
		if (getConfirm) {
		    e.data.DeleteItem(itemId,itemType,e.data.threadId);
		}
	});
	
	/*edit post*/
	this.QueryClone = $('.create-jsquery').clone(true);
	this.QueryClone.find('.discard-post').unbind();
	this.QueryClone.find('.queryPost').text('Edit Query');
	
	this.MCQClone = $('.create-jsmcq').clone(true);
	this.MCQClone.find('.discard-post').unbind();
	this.MCQClone.find('.js-submit-mcq').text('Edit MCQ');
	
	this.InfoClone = $('.create-jsinfo').clone(true);
	this.InfoClone.find('.discard-post').unbind();
	this.InfoClone.find('.post-info').text('Edit Info');
	
	$(this.completeDom).find(this.dom).find(".js-edit-query").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		if($('#thread').find(e.data.QueryClone).length > 0)
		{
			e.data.QueryClone.find('.discard-post').trigger('click');
		}
		var $post = $(this).closest('.query-post');
			postId = parseInt($post.attr('data-postid'));
			postTitle = e.data.GetHtmlForEdit($post.find(".post-title"));
			query = e.data.GetHtmlForEdit($post.find(".post-questn"));
			imageId = 0;
			imageUrl = null;
		
		if($post.find(".post-img").length != 0)
		{
			imageId = parseInt($post.find(".post-img").attr('data-attachmentid'));
		}
		if($post.find(".post-img img").length != 0)
		{
			imageUrl = $post.find(".post-img img").attr('src');
		}
			
		e.data.EditQuery(postId,postTitle,query,imageId,imageUrl);
	});
	
	$(this.completeDom).find(this.dom).find(".js-edit-mcq").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		if($('#thread').find(e.data.MCQClone).length > 0)
		{
			e.data.MCQClone.find('.discard-post').trigger('click');
		}
		
		var $post = $(this).closest('.mcq-post');
			postId = parseInt($post.attr('data-postid'));
			postTitle = e.data.GetHtmlForEdit($post.find(".post-title"));
			query = e.data.GetHtmlForEdit($post.find(".post-questn"));
			$alloptions = $post.find(".mcqOptions");
			answer = $post.attr("data-ans");
			postType = TR2PostType.MCQ;
			options = [];
		
		for ( i = 0; i < $alloptions.length; i++)
		{
			var option = $alloptions[i].innerText;
			options.push(option);
		}
			
		e.data.EditMCQ(postId,postTitle,question,options,answer);
	});
	
	$(this.completeDom).find(this.dom).find(".js-edit-info").unbind().bind('click',this,function(e){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		if($('#thread').find(e.data.InfoClone).length > 0)
		{
			e.data.InfoClone.find('.discard-post').trigger('click');
		}
		var $post = $(this).closest('.info-post');
			postId = parseInt($post.attr('data-postid'));
			postTitle = e.data.GetHtmlForEdit($post.find(".post-title"));
			query = e.data.GetHtmlForEdit($post.find(".post-questn"));
			imageId = 0;
			imageUrl = null;
		
		if($post.find(".post-img").length != 0)
		{
			imageId = parseInt($post.find(".post-img").attr('data-attachmentid'));
		}
		if($post.find(".post-img img").length != 0)
		{
			imageUrl = $post.find(".post-img img").attr('src');
		}
		e.data.EditInfo(postId,postTitle,query,imageId,imageUrl);
	});
	
	$(this.completeDom).find(this.dom).find(".js-loadmore").unbind().bind('click',this,function(e){
		//$(this.completeDom).find( ".discussion_div" ).empty();
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		
		UrlMgmt.getObj().Route({route: 'lists/discussion&id='+e.data.data.threadId+'&filter='+UrlMgmt.getObj().discussionPostType+'&page=2', needData: true});
	});
	$(this.completeDom).find(this.dom).find(".js-inputkeyboard").unbind().bind('click',this,function(e){
		console.log(parseInt($(this).offset().top));
		var r = document.querySelector('#'+$(e.data.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$(e.data.completeDom).animate({
			//scrollTop : parseInt(document.getElementById('post-'+postId+'').offsetTop + document.getElementById('writecomment-'+postId+'').offsetTop -65)
			
			scrollTop : parseInt( p.getElementsByClassName('createall')[0].offsetTop - 65)
		}, 1000);
	});
	$(this.completeDom).find(this.dom).find(".js-inputkeyboardcomment").unbind().bind('click',this,function(e){
		var postcomment = $(this).parents(".write-comment").attr("id");
		var postId = postcomment.split("-")[1];
		var r = document.querySelector('#'+$(e.data.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$(e.data.completeDom).animate({
			scrollTop : parseInt(p.querySelector('#post-'+postId+'').offsetTop + p.querySelector('#writecomment-'+postId+'').offsetTop  - 65) //
		}, 1000);
	});
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.removeLoader();
	$(this.completeDom).find(this.dom).find(".js-noposts").unbind().bind('click',this,function(e){
		if($(e.data.completeDom).find(e.data.dom).find(".common-create:visible").length == 0) 
		{
			$(e.data.completeDom).find(e.data.dom).find('.create-jsquery').show();
			$(e.data.completeDom).find(e.data.dom).find('.AskQuery').addClass("active");
		}
		var $createcard = $(e.data.completeDom).find(e.data.dom).find(".common-create:visible");
		var r = document.querySelector('#'+$(e.data.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$(e.data.completeDom).animate({
			scrollTop : parseInt( p.getElementsByClassName('createall')[0].offsetTop - 65)
		}, 1000);
		//e.data.ScrolltoDiv($createcard);
	});
	this.bindImageEvents();
	$(this.completeDom).find(this.dom).find(".js-scrolltotop").unbind().bind('click',function(){
		var ofsettop = $("#thread").offset().top; 
    	$('html, body').animate({
			scrollTop : ofsettop-100
		}, 800);
	});
	if(UrlMgmt.getObj().menuAction.view.css('display') == 'block')
	{
		$(this.completeDom).find(this.dom).find('textarea').on('focus', function(){
			UrlMgmt.getObj().menuAction.view.hide();
		});
		$(this.completeDom).find(this.dom).find('textarea').on('blur', function(e){
			UrlMgmt.getObj().menuAction.view.show();
			if($(e.relatedTarget).hasClass('queryPost') || $(e.relatedTarget).hasClass('js-submit-mcq') || $(e.relatedTarget).hasClass('post-info')){
				$(e.relatedTarget).click();
			}
		});
	}
	if($("#thread").length > 0)
	{
		$(window).scroll(function() { 
			var ofsettop = $("#thread").offset().top; 
		    var currentScroll = $(window).scrollTop() - 100;
		    if (currentScroll >= ofsettop)
		    {         
		        $('.js-scrolltotop').addClass("discussscrolltop");
		    }
		    else 
		    {                                  
		        $('.js-scrolltotop').removeClass("discussscrolltop");
		    }
		});
	}
};
listsdiscussionController.prototype.bindImageEvents = function()
{
	$(this.completeDom).find(this.dom).find('.js-upload-img').unbind().bind('click',this,function(e){
        if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
        $(this).siblings('.img-file').trigger('click'); 
    });
    $(this.completeDom).find(this.dom).find('.img-file').change(this,function(e){
		$createCard = $(this).closest('.common-create');
		var file = $(this)[0].files[0];
		if(typeof file != "undefined")
		{
			e.data.UploadImage(file,$createCard);
		}
	});
	
	$(this.completeDom).find(this.dom).find('.js-delete-img').unbind().bind('click',function(){
		//$imagePreview = $(this).siblings('.image-preview').empty();
		$imagePreview = $(this).closest('.common-create').find('.image-preview').empty();
		$imagePreview.empty();
		$imagePreview.attr('data-attachmentid',0);
		$(this).closest('.common-create').find('.img-file').val('');
		$(this).hide();
	});
};
listsdiscussionController.prototype.htmlEncode = function(htmlcontent)
{
	html = $.trim(htmlcontent);
    return html.replace(/[&"'\<\>]/g, function(c) 
    {
          switch (c) 
          {
              case "&":
                return "&amp;";
              case "'":
                return "&#39;";
              case '"':
                return "&quot;";
              case "<":
                return "&lt;";
              default:
                return "&gt;";
          }
    });
};
listsdiscussionController.prototype.ScrolltoDiv = function(eleid)	
{
	//console.log(document.getElementById(eleid).offsetTop);
	$(this.completeDom).animate({
			scrollTop : parseInt(document.getElementById(eleid).offsetTop - 90)
		}, 1000);
};
listsdiscussionController.prototype.autoSize = function(dom) //textarea autosize
{
	console.log("yes");
		var el = dom;	
		setTimeout(function(){
			el.css('height','auto');
			var scrollHeight = Math.max(38,el.prop("scrollHeight"));
			el.css('height',scrollHeight+'px');
		},0);
};
listsdiscussionController.prototype.CreatePost = function(postId,postitle, query, posttype,attachmentId)
{
	tr$.ajax({
		mod : "tr2discussion",
		ack : "addtopic",
		additionalParams : {
			threadid:this.threadId,
			postid: postId,
			title: postitle,
			content: JSON.stringify(query),
			posttype:posttype,
			attachmentid:attachmentId,
		},
		successClb : function(response) {
			try
			{
				var reply = response;	
				if (reply.result.state == "ok")
				{
					if(attachmentId != 0)
					{
						alert("Your post has been submitted successfully and waiting for approval from Admin.");
					}
					this.PostSegregate(this.data.threadId,"myposts");
				}
				else if(reply.result.state == "error")
				{
					var urlMgmt = UrlMgmt.getObj();
					urlMgmt.removeLoader();
					if(reply.result.meta == "LoginRequired")
					{
						if(!LoggedInUser.Auth()){
							UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
							return false;		
						}
					}
					else if(reply.result.meta == "EMPTYCONTENT")
					{
						tr$.alert("Post cannot be empty!");
					}
					else
					{
						alert("Internal Error!");
						console.log(reply.result.meta);
					}
					console.error(reply.result.meta);
				}	
			}
			catch(e)
			{
				var urlMgmt = UrlMgmt.getObj();
				urlMgmt.removeLoader();
				alert("Internal Error!");
				console.error(e);
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});

};
listsdiscussionController.prototype.PostSegregate = function(threadId,postType,page)
{
	
	var urlrought = '';
	if(typeof postType == "undefined")
	{
		if(typeof page == "undefined")
		{
			urlrought = remoteServer+"/?route=lists/discussion&id="+threadId+"&response-type=2&fromapp=1";
		}
		else
		{
			urlrought = remoteServer+"/?route=lists/discussion&id="+threadId+"&page="+page+"&response-type=2&fromapp=1";
		}
	}
	else
	{
		if(typeof page == "undefined")
		{
			urlrought  = remoteServer+"/?route=lists/discussion&id="+threadId+"&filter="+postType+"&response-type=2&fromapp=1";
		}
		else
		{
			urlrought  = remoteServer+"/?route=lists/discussion&id="+threadId+"&filter="+postType+"&page="+page+"&response-type=2&fromapp=1";
		}
	} 
	tr$.ajax({
			url: urlrought,
			successClb : function(response) {
				try {
					this.data = response.data;
					this.LoadDiscussion();
					return;
					
				} catch(e) {
					console.log(e);
					
				}
			}.bind(this),
			errorClb : function() {
				//TODO show some relavent msg
			}
		});
};
listsdiscussionController.prototype.ValidateMcq = function($optionDom)
{
	var selectedoption = $optionDom.attr("data-option");
		$post = $optionDom.closest(".mcq-post");
 		postId = $post.attr("data-postid"); 
		itemType = TR2DiscussionItemType.Post;
		username = UrlMgmt.getObj().userData.displayName;
	
 	$post.find(".mcqOptions").unbind("click");
 	$post.find(".mcqOptions").removeClass("hover");
 	
	
	tr$.ajax({
		mod : "tr2discussion",
		ack : "mcqvalidate",
		additionalParams : {
			postId:postId,
			selectedoption :selectedoption,
		},
		successClb : function(response) {
		  try
			{
				var reply = response;
				if(reply.result.state == "ok")
				{
					var answerjson = JSON.parse(reply.data.content);
						answer = answerjson["answer"];
						query = '';
					
					if(selectedoption == answer) 
					{
						query +=''+username+' has attempted correctly';
						$optionDom.addClass("correct");
						$optionDom.find("span").addClass("glyphicon glyphicon-ok");
					} 
					else 
					{
						query +=''+username+' has attempted';
						$optionDom.addClass("wrong");
						$optionDom.find("span").addClass("glyphicon glyphicon-remove");
						$optionDom.siblings(".mcqOptions").each(function()
						 {
						 	var choosen = $(this).attr("data-option");
							if (choosen == answer) 
							{
								$(this).addClass("correct");
								$(this).find("span").addClass("glyphicon glyphicon-ok");
							}
						});
						
					}
					var attemptsCount = parseInt($post.find('.attempts-count').text());
					$post.find('.attempts-count').text(++attemptsCount);
					//auto comment
					if(query.length > 0)
					{
						var content = {
							Query : query
						};
						this.SubmitComment(postId, itemType,content,0);
					}
				}
				else
				{
					alert("Internal Error!");
					console.error(reply.result.meta);
				}
			}
			catch(e)
			{
				alert("Internal Error");
				console.error(e);	
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
listsdiscussionController.prototype.SetApprove = function(isApproved,itemId,itemType)
{
	
	tr$.ajax({
		mod : "tr2discussion",
		ack : "setapprove",
		additionalParams : {
			threadid:this.threadId,
			itemid: itemId,
			itemtype:itemType,
			isapproved:isApproved
		},
		successClb : function(response) {
			try
				{
					var reply = response;
					if(reply.result.state == "ok")
					{
						var msg = TR2DiscussionItemType.Str[itemType]+
								 (reply.data == 1 ? " approved" : " disapproved")+" successfully!";
						tr$.alert(msg);
					}
					else
					{
						alert("Internal Error!");
						console.log(reply.result.meta);
					}
				}
			catch(e)
			{
				alert("Internal Error");
				console.log(e);	
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
listsdiscussionController.prototype.PinPost = function(index,postId)	
{
	
	tr$.ajax({
		mod : "tr2discussion",
		ack : "pinpost",
		additionalParams : {
			postid: postId,
			threadid:this.threadId,
			index:index
		},
		successClb : function(response) {
			try
				{
					var reply = response;
					if(reply.result.state == "ok")
					{
						tr$.alert("Post is pinned succesfully!");
						this.PostSegregate(this.threadId);
						
					}
					else
					{
						alert("Internal Error!");
						console.log(reply.result.meta);
					}
				}
			catch(e)
			{
				alert("Internal Error");
				console.log(e);	
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});	
};
listsdiscussionController.prototype.UnPinPost = function(postId)	
{
	
	tr$.ajax({
		mod : "tr2discussion",
		ack : "unpinpost",
		additionalParams : {
			threadid:this.threadId,
			postid: postId
		},
		successClb : function(response) {
				try
				{
					var reply = response;
					if(reply.result.state == "ok")
					{
						tr$.alert("Post is unpinned successfully!");
						this.PostSegregate(this.threadId);	
					}
					else
					{
						alert("Internal Error!");
						console.log(reply.result.meta);
					}
				}
				catch(e)
				{
					alert("Internal Error");
					console.log(e);	
				}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
listsdiscussionController.prototype.Upvote = function(itemId, itemType, value)
{
	 tr$.ajax({
		mod : "tr2discussion",
		ack : "upvote",
		additionalParams : {
			itemId: itemId,
			itemType:itemType,
			deleted:value,
		},
		successClb : function(response) {
			try
					{
						var reply = response;
						if (reply.result.state == "ok")
						{
						 	console.log("success",reply.result);
					 	}
					 	else if(reply.result.state == "error")
						{
							if(reply.result.meta == "LoginRequired")
							{
								if(!LoggedInUser.Auth()){
									UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
									return false;		
								}
							}
							else
							{
								alert("Internal Error!");
								console.log(reply.result.meta);
							}
						}
					}
					catch(e)
					{
						alert("Internal Error");
						console.log(e);
					}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};

listsdiscussionController.prototype.SubmitComment = function(itemId,itemType,content,mail)
{
	
	tr$.ajax({
		mod : "tr2discussion",
		ack : "addcomment",
		additionalParams : {
			content : JSON.stringify(content),
			itemid : itemId,
			itemtype : itemType,
			threadid : this.threadId,
			mail : mail
		},
		successClb : function(response) {
			try
			{
				var reply = response;
				if (reply.result.state == "ok")
				{
					var comment = reply.data;
					comment.isApproved = 1;
					comment.updatedOn = "Just Now";
					comment.upvoteCount = 0;
					var commentArr = [comment];
					var	displayNames = {};
						displayNames[UrlMgmt.getObj().userData.id] = UrlMgmt.getObj().userData.displayName;
					this.PopulateComment(reply.data.itemId, commentArr, displayNames,0, true);
					//this.PopulateComment(reply.data.itemId, commentArr, displayNames, true);
					var $post = $(this.completeDom).find(this.dom).find('#post-' + reply.data.itemId);
					var limit = parseInt($post.attr("data-commntlimit"));
					$post.attr("data-commntlimit", ++limit);
					$post.find('.write-comment-text').val('');
					var commentsCount = parseInt($post.find('.comments-count').text());
					$post.find('.comments-count').text(++commentsCount);
					var urlMgmt = UrlMgmt.getObj();
					urlMgmt.removeLoader();
				}
				else
				{
					var urlMgmt = UrlMgmt.getObj();
					urlMgmt.removeLoader();
					if (reply.result.meta == "LoginRequired")
					{
						tr$.alert("Login Required");
						//$("body").trigger({type : "_showLoginDialogEvt",tabName : "logintab"});
					}
					else
					{
						alert("Internal Error!");
						console.error(reply.result.meta);
					}
				}
			}
			catch(e)
			{
				var urlMgmt = UrlMgmt.getObj();
				urlMgmt.removeLoader();
				alert("Internal Error");
				console.error(e);
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});

};

listsdiscussionController.prototype.GetComment = function(itemId,itemType)
{
	var postDom =$(this.completeDom).find(this.dom).find('#post-'+itemId+'');
	var	limit = parseInt(postDom.attr("data-commntlimit"));
	var	once = postDom.attr('data-cmtsloaded') == 0;
	var	count = once ? 3 : 5; //fetching 5 comments at once
	var	totalCount = parseInt($(this.completeDom).find(this.dom).find('#post-'+itemId+'').attr("data-remaincommnts"));
	
	if(totalCount > 0 || once)
	{
		tr$.ajax({
					mod : "tr2discussion",
					ack : "getcomment",
					additionalParams : {
						itemid: itemId,
						itemtype: itemType,
						limit : limit,
						count : count,
						threadid:this.threadId,
					},
					successClb : function(response) {
						try
						{
							var reply = response;	
							if (reply.result.state == "ok")
							{	
								var limitchange = limit + count ;
								var postDom = $(this.completeDom).find(this.dom).find('#post-'+itemId+'');
								postDom.attr("data-commntlimit",limitchange);
								postDom.attr("data-cmtsloaded",1);
	
								this.isAdmin = reply.data.showApprove == 1;
								//populate comment
								this.PopulateComment(itemId,reply.data.comments,reply.data.displayNames,reply.data.userComntUpvote,false);
								postDom.attr("data-remaincommnts",reply.data.remain_comments);
								var urlMgmt = UrlMgmt.getObj();
								urlMgmt.removeLoader();
								if(reply.data.remain_comments > 0)
								{
									postDom.find('.more_comments').show();
								}
							   else
								{
									postDom.find('.more_comments').hide();
								}
								
							}
							else
							{
								alert("Internal Error!");
								console.error(reply.result.meta);
							}
							var urlMgmt = UrlMgmt.getObj();
								urlMgmt.removeLoader();
							
							
						}
						catch(e)
						{
							var urlMgmt = UrlMgmt.getObj();
							urlMgmt.removeLoader();
								alert("Internal Error");
								console.error(e);
						}
					}.bind(this),
					errorClb : function(e) {
						console.error(e);
						//TODO show some relavent msg
					}
				});

	}
};

listsdiscussionController.prototype.DisplayDate = function(dateString)
{
	if(dateString == "Just Now")
	{
		return "Just Now";
	}
	var date = new Date(dateString);
	var seconds = Math.floor((new Date() - date) / 1000);

	var interval = Math.floor(seconds / 31536000);

	if (interval > 0)
	{
		if(interval == 1)
		{
			return "1 year ago";
		}
		return interval +" years ago";
	}
	interval = Math.floor(seconds / 2592000);
	if (interval > 0)
	{
		if(interval == 1)
		{
			return "1 month ago";
		}
		return interval + " months ago";
	}
	interval = Math.floor(seconds / 86400);
	if (interval > 0)
	{
		if(interval == 1)
		{
			return "1 day ago";
		}
		return interval + " days ago";
	}
	interval = Math.floor(seconds / 3600);
	if (interval > 0)
	{
		if(interval == 1)
		{
			return "1 hour ago";
		}
		return interval + " hours ago";
	}
	interval = Math.floor(seconds / 60);
	if (interval > 0)
	{
		if(interval == 1)
		{
			return "1 min ago";
		}
		return interval + " mins ago";
	}
	if (seconds > 0)
	{
		return "Just Now";
	}
	return "";
};
listsdiscussionController.prototype.PopulateComment = function(postId,commentArr,displayNames,userComntUpvote,userComment)
{
	
	var postDom = $(this.completeDom).find('.discussion_div').find('#post-'+postId);
		commentDiv = postDom.find('.show-comments');
		postDom.find('.show-comments').show();
		writeCmtDom = commentDiv.siblings('.write-comment');
		curtime=$.now();
	writeCmtDom.find("textarea").val('');
	writeCmtDom.find("textarea").css("height","40px");
	writeCmtDom.show(); 
	
	var html = '';
	
	for(var i in commentArr)
	{
	    
		var comment = commentArr[i];
		var profileImage = remoteServer + '/attachment/profile-thumbnail/'+comment.userId+'/'+curtime;
			content = JSON.parse(comment.content);
			usercomupvote  = jQuery.inArray(comment.id, userComntUpvote) !== -1 ?"1":"0";
			html += 
			'<div id="comment-'+comment.id+'" class="eachcomment" data-commentid="'+comment.id+'"  data-comreply = '+comment.commentCount+' >'+
				'<div>'+
					'<span class="userpic" style="background-image: url('+profileImage+');"></span>'+
					'<div class="usercomment">'+
						'<p id="uname-'+comment.id+'">'+displayNames[comment.userId]+'</p>'+
						'<p class="query">'+content.Query+'</p>'+
					'</div>';
		if(LoggedInUser.Auth())
		{
			if(comment.userId == UrlMgmt.getObj().userData.id || this.isAdmin)
			{
				html +=
					'<div class="btn-group moreactions">'+
				         '<a class="dropdown-toggle" data-toggle="dropdown">'+
				        	'<span class="glyphicon glyphicon-option-vertical"></span>'+
				         '</a>'+
				         '<ul class="dropdown-menu">';
				if(comment.userId == UrlMgmt.getObj().userData.id || this.isAdmin)
				{
					html +=
							'<li><a class="js-delete-comment"><span class="glyphicon glyphicon-trash"></span>Delete Comment</a></li>';
				}
				if(this.isAdmin)
				{
					html +=
							'<li>'+
								'<a class="comment-approve">'+
									'<input type="checkbox" '+(parseInt(comment.isApproved) == 1?'checked="true"':'')+'/>'+
									'Approve'+
								'</a>'+
							'</li>';
				}
				html +=
				         '</ul>'+
			        '</div>';
			}
		}
		html +=
				'</div>'+
				'<div class="comentacions">'+
					'<span class="coment-upvote" data-usercomupvote = '+usercomupvote+' data-comupvotecount = '+comment.upvoteCount+'>';
					if(usercomupvote == 1)
					{
						html+=
						'<img src="img/liked.png" alt="Comment Upvoted"/>'+
						'<img src="img/tolike.png" alt="Comment Upvote" style="display: none;"/>';
					}
					else{
						html+=
						'<img src="img/liked.png" alt="Comment Upvoted" style="display: none;"/>'+
						'<img src="img/tolike.png" alt="Comment Upvote"/>';
					}
					html+=
					'<span class="comntupvotecount"> '+comment.upvoteCount+' </span>LIKE </span>'+
					'<span class="js-reply">'+
					'<a><img src="img/reply.png" alt="Comment Reply"/>REPLY</a>'+
					'</span>'+
					'<span class="duration">'+
						this.DisplayDate(comment.updatedOn)+
					'</span>'+
				'</div>'+
			'</div>';
	}
	commentDiv.find('.query').find('a').addClass('redirect-url');
	commentDiv.find('.redirect-url').unbind().bind('click', function(e){
		e.preventDefault();
		URLRedirection($(e.currentTarget).attr('href'));
	});
	if(userComment)
	{
		commentDiv.prepend(html);
	}
	else
	{
		commentDiv.append(html);
	}
	$(this.completeDom).find(this.dom).find(".coment-upvote").unbind().bind("click",this, function(e) {
		var comId = $(this).closest(".eachcomment").attr("data-commentid");
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		$(this).find("img").toggle();
		var itemId = $(this).closest(".eachcomment").attr("data-commentid");
			itemType = TR2DiscussionItemType.Comment;
			deleted = parseInt($(this).attr('data-usercomupvote'));
			counterDom = $(this).find('.comntupvotecount');
			comupvotesCount = parseInt(counterDom.text());
		if(deleted)
		{
			$(this).attr("data-usercomupvote",0);
			counterDom.text((--comupvotesCount)+' ');
		}
		else
		{
			$(this).attr("data-usercomupvote",1);
			counterDom.text((++comupvotesCount)+' ');
		};
		e.data.Upvote(itemId,itemType,deleted);
	});
	/*bind events*/
	$(this.completeDom).find(this.dom).find(".js-reply").unbind().bind("click",this, function(e) {
		var postId = $(this).parents(".Card").attr("data-postid");
		var comId = $(this).closest(".eachcomment").attr("data-commentid");
		var username ='@'+$('#post-'+postId+'').find('#uname-'+comId+'').text()+'';
		$('#post-'+postId+'').find(".write-comment-text").show();
		$('#post-'+postId+'').find(".write-comment-text").css("height","40px");
		$('#post-'+postId+'').find(".write-comment-text").val('');
		$('#post-'+postId+'').find(".write-comment-text").val(username); 
		var r = document.querySelector('#'+$(e.data.completeDom).attr("id"));
		var p = r.querySelector('.discussion_div');
		$(e.data.completeDom).animate({
			scrollTop : parseInt(p.querySelector('#post-'+postId+'').offsetTop + p.querySelector('#writecomment-'+postId+'').offsetTop  - 65) //
		}, 1000);		
	});
	
	this.dom.find(".comment-approve input").unbind().change(this, function(e){
		
		var itemId = $(this).parents('.eachcomment').attr("data-commentid");
			isApproved = $(this).prop("checked")?1:0;
			msg =  isApproved == 1 ?"Approve Comment?" : "Disapprove Comment?";
			getConfirm = confirm(msg);
			//console.log($(this).parents('.comment_div').siblings('.post-statsaction').find('.get-comments').find('.comments-count').text());
			//console.log($(this).parents('.comment_div').siblings('.post-statsaction').find('.get-comments').find('.comments-count'));
		if (getConfirm) {
			e.data.SetApprove(isApproved,itemId,TR2DiscussionItemType.Comment);
		    var commentcount = parseInt($(this).parents('.comment_div').siblings('.post-statsaction').find('.get-comments').find('.comments-count').text());
		    if(isApproved){
		    	$(this).parents('.comment_div').siblings('.post-statsaction').find('.get-comments').find('.comments-count').html(++commentcount);
		    }
		    else{
		    	
		    	$(this).parents('.comment_div').siblings('.post-statsaction').find('.get-comments').find('.comments-count').html(--commentcount);
		    }
		}
		else
		{
		    	$(this).prop('checked', !isApproved);
		}
	});
	/*delete post*/
	this.dom.find(".js-delete-comment").unbind().bind('click',this,function(e){
		var itemId = $(this).closest('.eachcomment').attr('data-commentid');
			itemType = TR2DiscussionItemType.Comment;
			getConfirm = confirm("Delete Comment?");
		if (getConfirm) {
		    e.data.DeleteItem(itemId,itemType,e.data.threadId);
		}	
	});
};
listsdiscussionController.prototype.ShowShareDialog = function(postId,threadurlkey)
{	
	$("#share-modal-discussion").find(".modal-dialog .modal-content .modal-body .js-share").unbind().bind("click",this,function(e){
		$("#share-modal-discussion").modal('hide');
		var	url = remoteServer+'/'+threadurlkey+'?post-id='+postId+'#thread';
		var media = $(this).data("media");
		console.log();
		e.data.SharePost(url,media);
	});
	$("#share-modal-discussion").modal('show');
};
listsdiscussionController.prototype.SharePost = function(url,media)
{
	switch(media)
	{
		case "facebook":
			window.open('https://www.facebook.com/sharer/sharer.php?u=' + encodeURIComponent(url), 'facebook-popup', 'height=350,width=600').focus();
			break;
		case "twitter":
			window.open('https://twitter.com/share?url=' + encodeURIComponent(url), 'twitter-popup', 'height=350,width=600').focus();
			break;
		case "google-plus":
			window.open('https://plus.google.com/share?url=' + encodeURIComponent(url), 'gshare', 'height=450,width=600').focus();
			break;
	}
};
listsdiscussionController.prototype.DeleteItem = function(itemId,itemType,threadId)
{
	tr$.ajax({
		mod : "tr2discussion",
		ack : "deleteitem",
		additionalParams : {
			itemid: itemId,
			itemtype:itemType,
			threadid:threadId
		},
		successClb : function(response) {
			try
			{
				var reply = response;
				if(reply.result.state == "ok")
				{
					var msg = TR2DiscussionItemType.Str[reply.data.itemType]+ " deleted successfully!";
					if(itemType == TR2DiscussionItemType.Post)
					{
						$('#post-'+itemId).remove();
					}
					else if(itemType == TR2DiscussionItemType.Comment)
					{
						var commentDom = $('#comment-'+itemId);
						var postDom = commentDom.closest('.Card');
						var limit = parseInt(postDom.attr("data-commntlimit"));
						postDom.attr("data-commntlimit", --limit);
						var commentsCount = parseInt(postDom.find(".comments-count").text());
						if(typeof commentsCount === 'number' && commentsCount != NaN)
						{
							var newCount = Math.max(commentsCount-1,0);
							postDom.find(".comments-count").text(newCount);
						}
						commentDom.remove();
					}
					alert(msg);
				}
				else
				{
					alert("Internal Error!");
					console.error(reply.result.meta);
				}
			}
			catch(e)
			{
				alert("Internal Error");
				console.error(e);
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
listsdiscussionController.prototype.EditQuery = function(postId,postTitle,query,imageId,imageUrl)
{
	var $post = $('#post-'+postId);
	$post.hide();
	this.QueryClone.find('.query-title').val(postTitle);
	this.QueryClone.find('.query-description').val(query);
	this.QueryClone.find('.queryPost').attr('data-postid',postId);
	//this.QueryClone.find("textarea").trigger('keydown');
	//console.log(this.QueryClone.find("textarea")[1]); query-title
	this.autoSize(this.QueryClone.find(".query-title"));
	this.autoSize(this.QueryClone.find(".createpost-content").find("textarea"));
	var $imagePreview = this.QueryClone.find('.image-preview');
	if(imageId > 0 && typeof imageUrl === 'string')
	{
		$imagePreview.attr('data-attachmentid',imageId);
		$imagePreview.html('<img src="'+imageUrl+'" />');
		this.QueryClone.find('.js-delete-img').css('display','block');
		this.bindImageEvents();
	}
	this.QueryClone.find('.discard-post').unbind().bind('click',this,function(e){
		e.data.QueryClone.hide();
		e.data.QueryClone.find('.query-title').val('');
		e.data.QueryClone.find('.query-description').val('');
		e.data.QueryClone.find('.queryPost').attr('data-postid',0);
		$post.show();
	});	
	
	$post.after(this.QueryClone);
	$post.after(this.bindImageEvents());
	this.QueryClone.show();
};
listsdiscussionController.prototype.EditInfo= function(postId,postTitle,query,imageId,imageUrl)
{
	var $post = $('#post-'+postId);
	$post.hide();
	this.InfoClone.find('.info-title').val(postTitle);
	this.InfoClone.find('.info-description').val(query);
	this.InfoClone.find('.post-info').attr('data-postid',postId);
	// this.InfoClone.find("textarea").trigger('keydown');
	this.autoSize(this.InfoClone.find(".info-title"));
	this.autoSize(this.InfoClone.find(".createpost-content").find("textarea"));
	var $imagePreview = this.InfoClone.find('.image-preview');
	if(imageId > 0 && typeof imageUrl === 'string')
	{
		$imagePreview.attr('data-attachmentid',imageId);
		$imagePreview.html('<img src="'+imageUrl+'" />');
		this.InfoClone.find('.js-delete-img').css('display','block');
		
	}
	this.InfoClone.find('.discard-post').unbind().bind('click',this,function(e){
		e.data.InfoClone.hide();
		e.data.InfoClone.find('.info-title').val('');
		e.data.InfoClone.find('.info-description').val('');
		e.data.InfoClone.find('.post-info').attr('data-postid',0);
		$post.show();
	});
	
	$post.after(this.InfoClone);
	$post.after(this.bindImageEvents());
	this.InfoClone.show();
};
listsdiscussionController.prototype.EditMCQ = function(postId,postTitle,question,options,answer)
{
	var $post = $('#post-'+postId);
		postType = TR2PostType.MCQ;
	
	$post.hide();
	this.MCQClone.find('.mcq-title').val(postTitle);
	this.MCQClone.find('.mcq-question').val(question);
	this.MCQClone.find('.js-submit-mcq').attr('data-postid',postId);
	
	for ( i = 0; i < options.length-2; i++)
	{
		this.MCQClone.find('.AddOption').trigger('click');
	}
	
	$allOptions = this.MCQClone.find('.mcq-option');
	
	for ( i = 0; i < options.length; i++)
	{
		$allOptions[i].innerText=options[i];
	}

	this.MCQClone.find(".select-correct-option").find("[data-select='"+answer+"']").addClass("active");
	
	this.MCQClone.find("textarea").trigger('keydown');
	
	this.MCQClone.find('.discard-post').unbind().bind('click',this,function(e){
		e.data.MCQClone.hide();
		e.data.MCQClone.find('.mcq-title').val('');
		e.data.MCQClone.find('.mcq-question').val('');
		e.data.MCQClone.find('.js-submit-mcq').attr('data-postid',0);
		$post.show();
	});
	
	$post.after(this.MCQClone);
	this.MCQClone.show();
};
listsdiscussionController.prototype.GetHtmlForEdit = function($dom)
{
	var html = $dom.html();
	if(/<[a-z][\s\S]*>/i.test(html))
	{
		return html;
	}
	return $dom.text();
};
listsdiscussionController.prototype.GetpostOgImg = function(postId)
{
	var postdom = $(this.completeDom).find(this.dom).find('#post-'+postId+'');
	var hasogimage = $(postdom).attr("data-ogimg");
	var threadurlkey =  this.data.threadurlkey;
	if(hasogimage == 1)
	{
		postdom.find('.post-statsaction').find('.actions').find('.post-share').removeClass('sharing');
		postdom.find('.post-statsaction').find('.actions').find('.post-share').html('<img src="img/discussionshare.png"  alt="Post Share"/><span>SHARE</span>');
		this.ShowShareDialog(postId,threadurlkey);
	}
	else
	{
		var domobj = this;
	   	var postofsettop = $(postdom).offset().top; 
    	$('html, body').animate({
			scrollTop : postofsettop-100
		}, 0);
		
		var options = {useCORS: true};
			html2canvas($(postdom)[0], options).then(function(canvas) {
				try
				{
			   		var dataURL = canvas.toDataURL("image/jpeg");
			   		/////////////////////////////////////////////////
			   			tr$.ajax({
									mod : "tr2discussion",
									ack : "ogimage",
									additionalParams : {
										dataurl:dataURL,
										postid:postId
									},
									successClb : function(response) {
										try
										{
											var reply = response;
											if(reply.result.state == "ok")
											{
												$(postdom).attr("data-ogimg","1");
											}
											else
											{
												alert("Internal Error!");
												console.log(reply.result.meta);
											}
										}
										catch(e)
										{
											alert("Internal Error"+e);
											console.log(e);	
										}
										finally
										{	
											// var urlMgmt = UrlMgmt.getObj();
											// urlMgmt.removeLoader();
											postdom.find('.post-statsaction').find('.actions').find('.post-share').removeClass('sharing');
											postdom.find('.post-statsaction').find('.actions').find('.post-share').html('<img src="img/discussionshare.png"  alt="Post Share"/><span>SHARE</span>');
											domobj.ShowShareDialog(postId,threadurlkey); 
										} 
									}.bind(this),
									errorClb : function() {
										//TODO show some relavent msg
										// var urlMgmt = UrlMgmt.getObj();
											// urlMgmt.removeLoader();
									}
								});
					}
					catch (e)
					{
						this.ShowShareDialog(postId,threadurlkey); 
					}
			 	});
	}
};
listsdiscussionController.prototype.UploadImage = function(file, $createCard)
{	
	if(typeof file != 'undefined')
    {
    	if(file.size > 8e+6)
    	{
    		alert("Image too large, image cannot be more than 8mb!");
    		return;
    	}
    	var formData = new FormData();
 		formData.append("image",file);
 		formData.append("mod", "tr2discussion");
        formData.append("ack", "imgupload");
        formData.append("resize", 1);

 		return $.ajax({
	        url: remoteServer+'/route?route=common/ajax',
	        type: 'POST',
	        data: formData,
	        xhrFields: {
			   withCredentials: true
			},
			crossDomain: true,
	        enctype:"multipart/form-data",        
	        cache: false,
	        processData: false, 
	        contentType: false,
			xhr: function() {  
	            var myXhr = $.ajaxSettings.xhr();
	            if(myXhr.upload){ 
	                myXhr.upload.addEventListener('progress',
						function(e)
						{
							var percent = Math.round(e.loaded * 100 / e.total);
							if(percent < 100)
							{
								$createCard.find(".upload-progress").html('<div class="successMsg">Uploading '+ percent + '%</div>');
							}
							else
							{
								$createCard.find(".upload-progress").html('');
							}
						}, false); 
	            }
	            return myXhr;
	        }.bind(this),
	        complete: function(event)
	        {
	        	try
				{
					var reply = event.responseJSON;
					if(reply.result.state == "ok")
					{
						var url = reply.data.url;
						var $imagePreview = $createCard.find('.image-preview');
						$imagePreview.html('<img src="'+url+'" />');
						$imagePreview.attr('data-attachmentid', reply.data.attachmentId);
						$createCard.find('.js-delete-img').css('display','block');
					}
					else if (reply.result.meta == "ERR_LOGIN_REQUIRED")
					{
						$("body").trigger({type : "_showLoginDialogEvt",tabName : "logintab"});
					}
					else if (reply.result.meta == "ERR_IMG_SIZE")
					{
						alert("Image too large, image cannot be more than 8mb!");
						console.error(reply.result.meta);
					}
					else if (reply.result.meta == "ERR_IMG_HEIGHT")
					{
						alert("Image height cannot be more than double of width!");
						console.error(reply.result.meta);
					}
					else
					{
						alert("Internal Error! inside try");
						console.error(reply.result.meta);
					}
				}
				catch(e)
				{
					alert("Internal Error! inside catch");
					console.error(e);
				}              				
			}
		});
      }	
};
listsdiscussionController.prototype.LoadDiscussion = function(posttype)
{
	if(typeof this.data.threadId == "undefined" || parseInt(this.data.threadId) <= 0)
	{
		return;
	}
	var DiscussionHTML = '';
	DiscussionHTML = '<div id="thread" class="discussthread" data-threadid='+this.data.threadId+'  data-showapprove='+this.data.discussions.showApprove+' >'+ 
						  	'<div class="alldiscuss container-fluid">'+
						  		'<div class="discuss-flex">'+
						  			'<div class="create-post container">'+
						  				'<span class="cardheader">Start Discussion</span>'+
						  				'<div>'+
											'<div class="post-query AskQuery '+ (typeof this.data.discussions.sharedPostId == "undefined" && this.data.discussions.postType !=1 && this.data.discussions.postType !=2 ? 'active' : '')+'">'+
											'<img src="img/query.png"/><span>Ask Doubts</span></div>'+
											'<div class="post-mcq pmcq '+(this.data.discussions.postType == 1 ? 'active' : '')+'">'+
											'<img src="img/mcq.png"/><span>Post MCQ</span></div>'+
											'<div class="post-shareinfo shareinfo '+(this.data.discussions.postType == 2 ? 'active' : '')+'">'+
												'<img src="img/shareinfo.png"/><span>Share Info</span>'+
											'</div>'+
										'</div>'+
									'</div>'+
									'<div class="post-list container">'+
										 '<div class="createall">'+
										 	'<div class="create-jsquery common-create Card '+(typeof this.data.discussions.sharedPostId == "undefined" && this.data.discussions.postType !=1 && this.data.discussions.postType !=2 ? '':'Hidden')+'"  id="askQuery">'+
										 		'<span class="discard-post"><img src="img/close-discardpost.png"/>DISCARD</span>'+
										 		'<p class="postheader">What would you like to ask?</p>'+
										 		'<div>'+
													'<input type="file" class="img-file" accept="image/png, image/jpeg" style="display:none;" />'+
													'<div class="select-image js-upload-img">'+
														'<span>'+
															'<span><img src="https://cdn.toprankers.net/images/add-image-2x-023d2826a265a.png" alt="Add Image"/></span>'+
															'<span>ADD IMAGE</span>'+
														'</span>'+
													'</div>'+
													'<div class="upload-progress"></div>'+
												'</div>'+
										 		'<textarea class="query-title js-inputkeyboard" type="text" placeholder="Enter Your post Title (optional)" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Enter Your post Title (optional)\'" name="lname"></textarea>'+
										 		'<div class="createpost-content">'+
										 			'<textarea class="query-description js-inputkeyboard" placeholder="Enter Your Question or Query here" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Enter Your Question or Query here\'"></textarea>'+
										 		'</div>'+
										 		'<div class="img-outercontainer">'+
											 		'<div class="img-container">'+
														'<span>'+
															'<img class="js-delete-img Hidden" src="https://cdn.toprankers.net/images/delete-image-2x-023d29ff58959.png" alt="delete image button"/>'+
														'</span>'+
														'<div class="image-preview" data-attachmentid="0"></div>'+
													'</div>'+
												'</div>'+
										 		'<div class="text-center"><span class="errorMsg usermsg" ></span></div>'+
										 		'<div><button class="btn btn-primary-alt queryPost" data-postid="0">Post Query</button></div>'+
										 	'</div>'+		
											'<div class="create-jsmcq common-create Card '+(this.data.discussions.postType == 1 ? '' : 'Hidden')+' " id="pMCQ" data-optcount="2">'+
											 	'<span class="discard-post"><img src="img/close-discardpost.png"/>DISCARD</span>'+
											 	'<p class="postheader">What would you like to ask?</p>'+
												'<div>'+
													'<input type="file" class="img-file" accept="image/png, image/jpeg" style="display:none;" />'+
													'<div class="select-image js-upload-img">'+
														'<span>'+
															'<span><img src="https://cdn.toprankers.net/images/add-image-2x-023d2826a265a.png" alt="Add Image"/></span>'+
															'<span>ADD IMAGE</span>'+
														'</span>'+
													'</div>'+
													'<div class="upload-progress"></div>'+
												'</div>'+
											 	'<textarea class="mcq-title js-inputkeyboard" type="text" name="lname" placeholder="Enter Your post Title (optional)" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Enter Your post Title (optional)\'"></textarea>'+
											 	'<div class="createpost-content">'+
											 		'<textarea class="mcq-question js-inputkeyboard" placeholder="Enter Your Question or Query here" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Enter Your Question or Query here\'"></textarea>'+
											 	'</div>'+
											 	'<div class="mcq-options">'+
											 		'<p>Add Options Here:</p>'+
											 		'<div class="option">'+
											 			'<label class="mcq-option-label "> A </label>'+
											 			'<div><textarea class="mcq-option" placeholder="Option A" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Option A\'"></textarea></div>'+
											 		'</div>'+
											 		'<div class="option">'+
											 			'<label class="mcq-option-label "> B </label>'+
											 			'<div><textarea class="mcq-option" placeholder="Option B" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Option B\'"></textarea></div>'+
											 		'</div>'+	
											 	'</div>'+
											 	'<div class="optionremove">'+
													'<img src="img/close-discardpost.png"/>'+
												'</div>'+
												'<div  class="AddOption">'+
													'<img src="img/addmoreoption.png" />'+
													'<span class="addoptions">ADD MORE OPTIONS</span>'+ 
												'</div>'+
												'<div class="select-correct-option" data-id="'+this.data.currthrd+'">'+
													'<span>Choose Correct Answer :</span>'+
													'<a data-select="0">A</a>'+
													'<a data-select="1">B</a>'+
												'</div>'+
												'<div class="img-outercontainer">'+
													'<div class="img-container">'+
														'<span>'+
															'<img class="js-delete-img Hidden" src="https://cdn.toprankers.net/images/delete-image-2x-023d29ff58959.png" alt="delete image button"/>'+
														'</span>'+
														'<div class="image-preview" data-attachmentid="0"></div>'+
													'</div>'+
												'</div>'+
												'<div class="text-center"><span class="errorMsg usermsg" ></span></div>'+
												'<div><button class="btn btn-primary-alt js-submit-mcq" data-postid="0">Post MCQ</button></div>'+
										    '</div>'+
											 '<div class="create-jsinfo common-create Card '+(this.data.discussions.postType == 2 ? '' : 'Hidden')+'" id="shareInfo">'+
												'<span class="discard-post"><img src="img/close-discardpost.png"/>	DISCARD</span>'+
												'<p class="postheader">What would you like to share?</p>'+
												'<div>'+
													'<input type="file" class="img-file" accept="image/png, image/jpeg" style="display:none;" />'+
													'<div class="select-image js-upload-img">'+
														'<span>'+
															'<span><img src="https://cdn.toprankers.net/images/add-image-2x-023d2826a265a.png" alt="Add Image"/></span>'+
															'<span>ADD IMAGE</span>'+
														'</span>'+
													'</div>'+
													'<div class="upload-progress"></div>'+
												'</div>'+
												'<textarea class="info-title js-inputkeyboard" type="text" name="lname" placeholder="Enter Your post Title (optional)" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Enter Your post Title (optional)\'"></textarea>'+
												'<div class="createpost-content">'+
													'<textarea class="info-description js-inputkeyboard" placeholder="Share Info here" onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Share Info here\'"></textarea>'+
												'</div>'+
												'<div class="img-outercontainer">'+
													'<div class="img-container">'+
														'<span>'+
															'<img class="js-delete-img Hidden" src="https://cdn.toprankers.net/images/delete-image-2x-023d29ff58959.png" alt="delete image button"/>'+
														'</span>'+
														'<div class="image-preview" data-attachmentid="0"></div>'+
													'</div>'+
												'</div>'+
												'<div class="text-center"><span class="errorMsg usermsg" ></span></div>'+
												'<div><button class="btn btn-primary-alt post-info" data-postid="0">Share Info</button></div>'+
											 '</div>'+
										 '</div>';
										 if( typeof this.data.discussions.postCount != "undefined")
										 {
										 	DiscussionHTML += '<div class="dropdown mobilecardhead hideInDiscussion">'+
										 							'<span>Ongoing Discussions</span>'+
										 							'<div class="postfilter_div">'+
										 							'<span class="filter-type-text">('+this.data.discussions.postTypeDisplay+')</span>'+
																	'<span class="glyphicon glyphicon-option-horizontal dropdown-toggle" data-toggle="dropdown" aria-expanded="false"></span>'+
																    '<ul class="dropdown-menu post-filter-menu">'+
																    '<li><p class="js-clear-filter '+(this.data.discussions.postType == -1 ? 'activeTab':'')+'"><img src="img/discussions.png"/>All Discussions</p></li>'+
																	'<li><p class="js-filter-post '+(this.data.discussions.postType == 0 ? 'activeTab':'')+'" data-posttype="query"><img src="img/query.png"/>Queries</p></li>'+
																	'<li><p class="js-filter-post '+(this.data.discussions.postType == 1 ? 'activeTab':'')+'" data-posttype="mcq"><img src="img/mcq.png"/>MCQ</p></li>'+
																	'<li><p class="js-filter-post '+(this.data.discussions.postType == 2 ? 'activeTab':'')+'" data-posttype="info"><img src="img/shareinfo.png"/>Shared Info</p></li>'+
																	'<li><p class="js-myposts '+(this.data.discussions.postType == 3 ? 'activeTab':'')+'" data-posttype="myposts"><img src="img/mypost.png"/>My Posts</p></li>'+
																    '</ul>'+
																    '</div>'+
															  '</div>';
											if(parseInt(this.data.discussions.postCount) > 0)
											{				  
												var index = [],pinIndex = [],pinIndexcount=0,indexcount=0,c=-1;  
												index =  tr$.reverseObjectIndex(this.data.discussions.posts);
												
												while( indexcount < index.length)
												{
													
													if(this.data.discussions.posts[parseInt(index[indexcount])].pinIndex == null)
													{
														pinIndex[pinIndexcount++] = (c--); 
													}
													else{
														pinIndex[pinIndexcount++] = this.data.discussions.posts[parseInt(index[indexcount])].pinIndex; 
													}
													indexcount++;	
												}
												for(var i=0 ; i< pinIndexcount-1;i++)
												{
													for(var j=i+1; j < pinIndexcount ; j++)
													{
														  if(parseInt(pinIndex[i]) < parseInt(pinIndex[j]))
															{
																var temp = pinIndex[i];
																pinIndex[i] = pinIndex[j];
																pinIndex[j] = temp;
																
																temp = index[i];
																index[i] = index[j];
																index[j] = temp;
															}
													}
												}
												for(var i = 0;i< index.length;i++)
												{
													key = index[i];
													var userID = 0;
													if (UrlMgmt.getObj().userData != null)
													{
														userID = UrlMgmt.getObj().userData.id;
													}
													
													if (typeof this.data.discussions.posts[key].postType != "undefined" && parseInt(this.data.discussions.posts[key].postType) == 0)
													{
														 DiscussionHTML += this.Postquery({post:this.data.discussions.posts[key],showApprove:this.data.discussions.showApprove,userId:userID});
														// type 0 Posts  cards_postquery {'post' : post, 'userId' : user.id, 'showApprove':data.discussions.showApprove}
													}
													else if (typeof this.data.discussions.posts[key].postType != "undefined" && parseInt(this.data.discussions.posts[key].postType) == 1)
													{
														 DiscussionHTML += this.Postmcq({post:this.data.discussions.posts[key],showApprove:this.data.discussions.showApprove,userId:userID});
														// type 1 Posts  cards_postmcq {'post' : post, 'userId' : user.id, 'showApprove':data.discussions.showApprove}
													}
													else if (typeof this.data.discussions.posts[key].postType != "undefined" && parseInt(this.data.discussions.posts[key].postType) == 2)
													{
														 DiscussionHTML += this.Postinfo({post:this.data.discussions.posts[key],showApprove:this.data.discussions.showApprove,userId:userID});
														// type 2 Posts cards_postinfo {'post' : post, 'userId' : user.id, 'showApprove':data.discussions.showApprove}
													}
														
												}
											}
											else
											{
												DiscussionHTML +='<div class="noposts">'+
																	'<div class="noposts_msg">No Discussions Yet</div>'+
																	'<div class="AddOption js-noposts">'+
																		'<img src="img/addmoreoption.png" alt="Add Option">'+
																		'<div class="addoptions">Start a Discussion</div> '+
																	'</div>'+
																'</div>';
												
											}
																
											//for loop for type of post.					
										 }
										 if(typeof this.data.discussions.postCount != "undefined" && this.data.discussions.postCount > 15)
										 {
										 	
											if(this.domId != "listsdiscussionController" && this.domId != "itemliveclassesController")
											{
											 DiscussionHTML += '<div class="more-posts text-center">';	
											 DiscussionHTML += '<a class="btn btn-primary js-loadmore">Read More</a>'; //{{data.baseUrl}}{{data.threadurlkey}}
											 DiscussionHTML += '</div>';
											}
															
										 }
										 if( (typeof this.data.discussions.postCount != "undefined" && this.data.discussions.postCount > 0) && (this.domId == "listsdiscussionController" || this.domId == "itemliveclassesController") ) // && (this.domId == "listsdiscussionController" || this.domId == "itemliveclassesController") this.data.viewId == "discussion" || this.data.viewId == "liveclassesitem"
										 {
										 	console.log(this.data);
										  var postCount = this.data.discussions.postCount;
										  var postsPerPage = (typeof this.data.postsPerPage == "undefined" ?15:this.data.postsPerPage);
										  var lastPage = Math.ceil(((postCount-1)/postsPerPage));
										  var currentPage = (typeof this.data.currentPage == "undefined")?1:parseInt(this.data.currentPage);
										  var mid = (currentPage >= lastPage-2) ? lastPage-2 : ((currentPage <= 3) ? 3 : currentPage);
											 if(lastPage > 1)
											 {
												DiscussionHTML +='<div class="text-center pagination_div">'+
																	'<span class="pagination">';
																		if(currentPage != 1)
																		{
																			DiscussionHTML += '<span class="prenext js-page" data-page="1"><img src="img/start-page.png"/></span>'+
																							  '<span class="prenext js-page" data-page="'+(currentPage-1)+'"><img src="img/prevpostlist.png"/></span>';
																		}
																		if(lastPage > 5)
																		{
																			for( var i=-2; i <=2;i++)
																			{
																				DiscussionHTML += '<span class="page js-page '+(mid + i == currentPage ? "current":"")+'" data-page="'+(mid+i)+'">'+(mid+i)+'</span>';
																			}
																		}
																		else
																		{
																			for(var i = 1; i <= lastPage;i++)
																			{
																				DiscussionHTML += '<span class="page js-page '+( i == currentPage ? "current":"")+'" data-page="'+i+'">'+i+'</span>';
																			}
																		}
																		if(currentPage != lastPage)
																		{
																			DiscussionHTML += '<span class="prenext js-page" data-page="'+(currentPage+1)+'"><img src="img/nextpostlist.png"/></span>'+
																							  '<span class="prenext js-page" data-page="'+lastPage+'"><img src="img/end-page.png"/></span>';
																		}
																	DiscussionHTML += '</span>'+
																	'<span class="pagetext">Showing '+currentPage+' of '+lastPage+' Pages</span>'+
																'</div>';
											 }
									 	 } 
										 DiscussionHTML += '</div>'+
																'<div class="discusfilter container">'+
																	'<div class="cardheader">View Discussions By</div>'+
																	'<div class="allfilter">'+
																		'<p class="js-clear-filter '+(this.data.discussions.postType == -1 ? 'activeTab':'')+'"><img src="img/discussions.png"/>All Discussions</p>'+
																		'<p class="js-filter-post '+(this.data.discussions.postType == 0 ? 'activeTab':'')+'" data-posttype="query"><img src="img/query.png"/>Queries</p>'+
																		'<p class="js-filter-post '+(this.data.discussions.postType == 1 ? 'activeTab':'')+'" data-posttype="mcq"><img src="img/mcq.png"/>MCQ</p>'+
																		'<p class="js-filter-post '+(this.data.discussions.postType == 2 ? 'activeTab':'')+'" data-posttype="info"><img src="img/shareinfo.png"/>Shared Info</p>'+
																		'<p class="js-myposts '+(this.data.discussions.postType == 3 ? 'activeTab':'')+'" data-posttype="myposts"><img src="img/mypost.png"/>My Posts</p>'+
																	'</div>'+
																'</div>'+
														'</div>'+
													'</div>';
										DiscussionHTML += '</div>';	
														
										$(this.completeDom).find(this.dom).html(DiscussionHTML);
										$(this.completeDom).find(this.dom).find('.post-questn.js-url_check').find('a').addClass('redirect-url');
										$(this.completeDom).find(this.dom).find('.redirect-url').unbind().bind('click', function(e){
											e.preventDefault();
											URLRedirection($(e.currentTarget).attr('href'));
										});
										this.BindEvents();
	
	
	
};
listsdiscussionController.prototype.Postquery = function(data)
{
	var currentTimestamp = new Date().getTime();
	var profileImage = remoteServer + '/attachment/profile-thumbnail/'+data.post.userId+'/'+currentTimestamp;
	var Postquery = '<div id="post-'+data.post.id+'" class="query-post Card" data-postid='+data.post.id+' data-commntlimit="0" data-remaincommnts='+data.post.commentCount+' data-cmtsloaded="0" data-ogimg = '+(data.post.seoMetaImageUrl!=null?"1":"0")+'>';
						if( data.showApprove == 1 )
						{
				        	Postquery +='<div class="admin_is_approved">';
							if(data.post.pinIndex != null)
							{
								Postquery += '<span class="glyphicon glyphicon-pushpin on-post">('+data.post.pinIndex+')</span>';
							}
							Postquery += '<span class="post-approve">'+
											'<label>Approved</label>'+
											'<input type="checkbox" '+(parseInt(data.post.isApproved)?"checked='true'":"")+'>'+
										'</span>'+
									'</div>';
						}
			Postquery +='<div class="post-detail">'+
							'<span class="userpic" style="background-image: url('+profileImage+');"></span>'+
							'<div>'+
							'<span class="username">'+data.post.createdBy+'</span>';
							if(data.post.adminpost == 1)
							{
							Postquery += '<span class="admin"><img src="img/adminpost.png" alt="Discussion Admin"></span>';
							}
							
							Postquery +='<p>'+
											'<span>'+data.post.displayType+'</span>'+
											'<span>'+data.post.displayDate+'</span>'+
										'</p>'+
									'</div>';	
							if(data.showApprove == 1 || data.userId == data.post.userId) // comparing with the logined user  adn the and user wh posted the post
							{
								Postquery += '<div class="btn-group moreactions">'+
									         '<a class="dropdown-toggle" data-toggle="dropdown">'+
									         '<span class="glyphicon glyphicon-option-vertical"></span>'+
									         '</a>'+
									         '<ul class="dropdown-menu">';
									         	 if(data.showApprove == 1)
									         	 {
										            Postquery += '<li><a class="js-pinpost"><span class="glyphicon glyphicon-pushpin"></span>'+(data.post.pinIndex != null ? "Change Pin("+data.post.pinIndex+")" : "Pin")+'</a></li>';
										         	if(data.post.pinIndex != null) 
													 {
													 	Postquery +='<li><a class="js-unpin"><span class="glyphicon glyphicon-pushpin"></span>Unpin</a></li>';
												     }
												}
												
													Postquery += '<li><a class="js-edit-query"><span class="glyphicon glyphicon-pencil"></span>Edit Query</a></li>'+
																 '<li><a class="js-delete-post"><span class="glyphicon glyphicon-trash"></span>Delete Query</a></li>';
												
												
									        Postquery += '</ul>'+
								        			'</div>';
						     }   
						Postquery +=    '</div>';
						if(typeof data.post.image != "undefined" && data.post.image != null)
						{
								Postquery += '<div class="post-img" data-attachmentid="'+data.post.image.id+'"><img src="'+data.post.image.url+'" alt="Post Attachments"/></div>';
						}
								Postquery += '<div class="post-title">'+data.post.title+'</div>'+
										'<div class="post-questn js-url_check">'+data.post.content.query+'</div>'+
										'<div class="post-statsaction container">'+
											'<div class="status">'+
												'<span><span class="upvotes-count">'+data.post.upvoteCount+'</span> Likes</span>'+
												'<span class="get-comments js-showcomments"> <span class="comments-count">'+data.post.commentCount+'</span> Comments </span>'+
											'</div>'+
											'<div class="actions">'+
												'<a class="post-upvote" data-postid="'+data.post.id+'" data-upvote="'+data.post.userUpvote+'">';
									if(data.post.userUpvote == 1)
									{ 
										Postquery += '<img src="img/liked.png"  alt="Post Upvoted"/>'+
													 '<img src="img/tolike.png" alt = "Post Upvote" style="display: none;"/>';
									}
									else
									{ 
										Postquery += '<img src="img/liked.png" style="display: none;"/>'+
													 '<img src="img/tolike.png"/>';
									} 
									Postquery += '<span class='+(data.post.userUpvote?"liked":"like")+'>LIKE'+(data.post.userUpvote?"D":"")+'</span></a>'+
												 '<a class="post-comment">'+
												 '<img src="img/comment.png"  alt="Post Comment" />'+
												 '<span>COMMENT</span>'+
												'</a>'+
												'<a class="post-share" data-postid="'+data.post.id+'">'+
													'<img src="img/discussionshare.png"  alt="Post Share"/>'+
													'<span>SHARE</span>'+
												'</a>'+
											'</div>'+
										'</div>'+
										'<div class="comment_div">'+
											'<div class="write-comment" id="writecomment-'+data.post.id+'">'+
												'<div>'+
												   '<textarea type="text" class="write-comment-text js-inputkeyboardcomment" placeholder="Write Comment...." onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Write Comment....\'"></textarea>'+
												   '<button type="button" class="btn btn-primary submit-comment" data-postid="'+data.post.id+'">Comment</button>'+
												'</div>'+       
											'</div>'+ 
											'<div class="show-comments">'+     	
											'</div>'+
											'<div class="view_more">'+
												'<button class="btn btn-primary-alt more_comments js-getcomments">Load More Comments</button>'+
											'</div>'+
										'</div>'+
									'</div>';
									
									return Postquery;
};
listsdiscussionController.prototype.Postmcq = function(data)
{
	var currentTimestamp = new Date().getTime();
	var profileImage = remoteServer + '/attachment/profile-thumbnail/'+data.post.userId+'/'+currentTimestamp;
	var Postmcq = '<div id="post-'+data.post.id+'" class="mcq-post Card" data-postid='+data.post.id+'  data-commntlimit="0" data-remaincommnts = '+data.post.commentCount+' data-cmtsloaded="0" data-ans='+data.post.content.answer+' data-ogimg = '+(data.post.seoMetaImageUrl!=null?"1":"0")+'>';
					if( data.showApprove == 1 )
						{
				        	Postmcq +='<div class="admin_is_approved">';
							if(data.post.pinIndex != null)
							{
								Postmcq += '<span class="glyphicon glyphicon-pushpin on-post">('+data.post.pinIndex+')</span>';
							}
							Postmcq += '<span class="post-approve">'+
											'<label>Approved</label>'+
											'<input type="checkbox" '+(parseInt(data.post.isApproved)?"checked='true'":"")+'>'+
										'</span>'+
									'</div>';
						}
			Postmcq +='<div class="post-detail">'+
						'<span class="userpic" style="background-image: url('+profileImage+');"></span>'+
						'<div>'+
							'<span class="username">'+data.post.createdBy+'</span>';
							if(data.post.adminpost == 1)
							{
							Postmcq += '<span class="admin"><img src="img/adminpost.png" alt="Discussion Admin"></span>';
							}
							Postmcq +='<p>'+
								'<span>'+data.post.displayType+'</span>'+
								'<span>'+data.post.displayDate+' </span>'+
							'</p>'+
						'</div>';
						// if(data.showApprove == 1)
						// {
							// if(data.post.pinIndex != null)
							// {	
								// Postmcq += '<span class="glyphicon glyphicon-pushpin">('+data.post.pinIndex+')</span>';
							// }
						// }
						if(data.showApprove == 1 || data.userId == data.post.userId)
						{
							Postmcq += '<div class="btn-group moreactions">'+
								         '<a class="dropdown-toggle" data-toggle="dropdown">'+
								         '<span class="glyphicon glyphicon-option-vertical"></span>'+
								         '</a>'+
								         '<ul class="dropdown-menu">';
								         	if(data.showApprove == 1)
								         	{
									            Postmcq += '<li><a class="js-pinpost"><span class="glyphicon glyphicon-pushpin"></span>'+(data.post.pinIndex != null ? "Change Pin("+data.post.pinIndex+")" : "Pin")+'</a></li>';
												         	if(data.post.pinIndex != null)
												         	{
																Postmcq += '<li><a class="js-unpin"><span class="glyphicon glyphicon-pushpin"></span>Unpin</a></li>';
															}
															
											}
											
											 Postmcq +=	'<li><a class="js-delete-post"><span class="glyphicon glyphicon-trash"></span>Delete MCQ</a></li>';
											
								         Postmcq +='</ul>'+
							      				  '</div>';
				       }
				       //melwin
					Postmcq += '</div>';
					if(typeof data.post.image != "undefined" && data.post.image != null)
					{
							Postmcq += '<div class="post-img" data-attachmentid="'+data.post.image.id+'"><img src="'+data.post.image.url+'" alt="Post Attachments"/></div>';
					}
								Postmcq += '<div class="post-title ">'+data.post.title+'</div>'+
								'<div class="mcq-description">'+
									'<div class="post-questn">'+data.post.content.question+'</div>';
							        for (key in data.post.content.options)
							        {
							        	var selectclass = "";
							        	var symbol = "";
							       		var hover = "hover";
							        	if(typeof data.post.userMcqAttempts != "undefined")
							        	{
							       			hover = "";
								        	if(key == data.post.userMcqAttempts.selectedOption && data.post.userMcqAttempts.selectedOption != data.post.content.answer)
									    	{
									    		selectclass = "wrong";
									    		symbol = "glyphicon glyphicon-remove"; 
									    	}
									    	else if(key == data.post.content.answer)
											{
												selectclass = "correct";
												symbol = "glyphicon glyphicon-ok";
								    		}
								    	}
							            Postmcq += '<div class="mcqOptions '+hover+' '+selectclass+'" data-option='+key+'>'+
								                   '<label class="mcq-option-label">'+(String.fromCharCode((parseInt(key)+65)))+'</label>'+
								                   '<div class="disablepointerevent">'+this.htmlEncode(data.post.content.options[key])+'</div>'+
								                   '<span class="'+symbol+'"></span>'+
								           		'</div>';
								   	}
								Postmcq += '</div>'+
											'<div class="post-statsaction container">'+
												'<div class="status">'+
													'<span><span class="upvotes-count">'+data.post.upvoteCount+'</span> Likes</span>'+
													'<span class="get-comments js-showcomments"><span class="comments-count">'+data.post.commentCount+'</span> Comments </span>'+
													'<span><span class="attempts-count">'+data.post.attemptCount+'</span> Attempts</span>'+
												'</div>'+	
												'<div class="actions">'+
													'<a class="post-upvote" data-postid="'+data.post.id+'" data-upvote="'+data.post.userUpvote+'">';
														if(data.post.userUpvote == 1)
														{
															Postmcq += '<img src="img/liked.png" alt="Post Upvoted"/>'+
																	   '<img src="img/tolike.png" alt="Post Upvote" style="display: none;"/>';
														}
														else
														{ 
															Postmcq += '<img src="img/liked.png" alt="Post Upvoted" style="display: none;"/>'+
																	   '<img src="img/tolike.png" alt="Post Upvote" />';
														} 
														Postmcq += '<span class='+(data.post.userUpvote?"liked":"like")+'>LIKE'+(data.post.userUpvote?"D":"")+'</span>'+
																	'</a>'+	
																	'<a class="post-comment">'+
																		'<img src="img/comment.png"  alt="Post Comment"/>'+
																		'<span>COMMENT</span>'+
																	'</a>'+
																	'<a class="post-share" data-postid="'+data.post.id+'">'+
																		'<img src="img/discussionshare.png"  alt="Post Share"/>'+
																		'<span>SHARE</span>'+
																	'</a>'+
																'</div>'+
															'</div>'+
																'<div class="comment_div">'+
																'<div class="write-comment" id="writecomment-'+data.post.id+'">'+
																	'<div>'+
																	   '<textarea type="text" class="write-comment-text js-inputkeyboardcomment" placeholder="Write Comment...." onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Write Comment....\'"></textarea>'+
																	    '<button type="button" class="btn btn-primary submit-comment" data-postid="'+data.post.id+'">Comment</button>'+
																	'</div>'+       
																'</div>'+
																'<div class="show-comments">'+     
																'</div>'+
																'<div class="view_more">'+
																	'<button class="btn btn-primary-alt more_comments js-getcomments">Load More Comments</button>'+
																'</div>'+
															'</div>'+
														'</div>';
														return Postmcq;
};
listsdiscussionController.prototype.Postinfo = function(data)
{
	var currentTimestamp = new Date().getTime();
	var profileImage = remoteServer + '/attachment/profile-thumbnail/'+data.post.userId+'/'+currentTimestamp;
	var Postinfo = '<div id="post-'+data.post.id+'" class="info-post Card" data-commntlimit="0" data-postid='+data.post.id+' data-remaincommnts = '+data.post.commentCount+' data-cmtsloaded="0" data-ogimg = '+(data.post.seoMetaImageUrl!=null?"1":"0")+'>';
						if( data.showApprove == 1 )
						{
				        	Postinfo +='<div class="admin_is_approved">';
							if(data.post.pinIndex != null)
							{
								Postinfo += '<span class="glyphicon glyphicon-pushpin on-post">('+data.post.pinIndex+')</span>';
							}
							Postinfo += '<span class="post-approve">'+
											'<label>Approved</label>'+
											'<input type="checkbox" '+(parseInt(data.post.isApproved)?"checked='true'":"")+'>'+
										'</span>'+
									'</div>';
						}
			 
				Postinfo +='<div class="post-detail">'+
							'<span class="userpic" style="background-image: url('+profileImage+');"></span>'+
							'<div>'+
								'<span class="username">'+data.post.createdBy+'</span>';
							if(data.post.adminpost == 1)
							{
							Postinfo += '<span class="admin"><img src="img/adminpost.png"  alt="Discussion Admin"/></span>';
							}
							Postinfo +='<p>'+
									'<span>'+data.post.displayType+'</span>'+
									'<span>'+data.post.displayDate+'</span>'+
								'</p>'+
							'</div>';
							if(data.showApprove == 1 || data.userId == data.post.userId)
							{
								Postinfo += '<div class="btn-group moreactions">'+
										         '<a class="dropdown-toggle" data-toggle="dropdown">'+
										         '<span class="glyphicon glyphicon-option-vertical"></span>'+
										         '</a>'+
										         '<ul class="dropdown-menu">';
										         	if(data.showApprove == 1)
										         	{		
												            Postinfo +='<li><a class="js-pinpost"><span class="glyphicon glyphicon-pushpin"></span>'+(data.post.pinIndex != null ? "Change Pin("+data.post.pinIndex+")" : "Pin")+'</a></li>';
															           if(data.post.pinIndex != null)
															           {
																		Postinfo += '<li><a class="js-unpin"><span class="glyphicon glyphicon-pushpin"></span>Unpin</a></li>';
																	   }
																					
													}
													
														Postinfo += '<li><a class="js-edit-info"><span class="glyphicon glyphicon-pencil"></span>Edit Info</a></li>'+
																	'<li><a class="js-delete-post"><span class="glyphicon glyphicon-trash"></span>Delete Info</a></li>';
													
													Postinfo += '</ul>'+
									       				'</div>';
							}
										         
					        
						Postinfo += '</div>';
						if(typeof data.post.image != "undefined" && data.post.image != null)
						{
								Postinfo += '<div class="post-img" data-attachmentid="'+data.post.image.id+'"><img src="'+data.post.image.url+'" alt="Post Attachments"/></div>';
						}
						Postinfo += '<div class="post-title">'+data.post.title+'</div>'+
						'<div class="post-questn js-url_check">'+data.post.content.info+'</div>'+
						'<div class ="post-statsaction container">'+
							'<div class="status">'+
								'<span> <span class="upvotes-count">'+data.post.upvoteCount+'</span> Likes</span>'+
								'<span class="get-comments js-showcomments"> <span class="comments-count">'+data.post.commentCount+'</span> Comments</span>'+
							'</div>'+
							'<div class="actions">'+
								'<a class="post-upvote" data-postid="'+data.post.id+'" data-upvote="'+data.post.userUpvote+'">';
									if(data.post.userUpvote == 1)
									{ 
											Postinfo += '<img src="img/liked.png" alt="Post Upvoted"/>'+
														'<img src="img/tolike.png"  alt="Post Upvote" style="display: none;"/>';
									}
									else
									{ 
											Postinfo += '<img src="img/liked.png" alt="Post Upvoted" style="display: none;"/>'+
														'<img src="img/tolike.png"  alt="Post Upvote"/>';
									} 
									Postinfo += '<span class='+(data.post.userUpvote?"liked":"like")+'>LIKE'+(data.post.userUpvote?"D":"")+'</span>'+
												'</a>'+	
												'<a class="post-comment">'+
													'<img src="img/comment.png" alt="Post Comment" />'+
													'<span>COMMENT</span>'+
												'</a>'+
												'<a class="post-share" data-postid="'+data.post.id+'">'+
													'<img src="img/discussionshare.png" alt="Post Share"/>'+
													'<span>SHARE</span>'+
												'</a>'+
											'</div>'+
										'</div>'+
										'<div class="comment_div">'+
											'<div class="write-comment" id="writecomment-'+data.post.id+'">'+
												'<div>'+
												   '<textarea type="text" class="write-comment-text js-inputkeyboardcomment" placeholder="Write Comment...." onfocus="this.placeholder = \'\'" onblur="this.placeholder = \'Write Comment....\'"></textarea>'+
												    '<button type="button" class="btn btn-primary submit-comment" data-postid="'+data.post.id+'">Comment</button>'+
												'</div>'+       
											'</div>'+
											'<div class="show-comments">'+     
											'</div>'+
											'<div class="view_more">'+
												'<button class="btn btn-primary-alt more_comments js-getcomments">Load More Comments</button>'+
											'</div>'+
										'</div>'+
									'</div>';
									return Postinfo;
};